unit fer418;


  interface

 {$R-}


 uses GraphicsForm, ferm118, fer318,
      QGraphics, SysUtils
      {quickdraw} {, events, Toolutils, packages, types, sioux, Paslibintf,
			memory, osutils, quickdrawtext};

 var  plotting, cplotting, threedim, marking, printchar, points, surplotting,
          savescreen: boolean;
      penstyle: longint;
			mychar: char;
			xorigin, yorigin, lastspot, contrast: integer;
			startexpr, prev_expr, currentchar, zilch, old_prev, old_start: nameptr;
			surplot: funcptr;  { for surface plotting }
			det1, det2: crossings;
			thelight: evector;
			sintheta, costheta, z_cosine, xscale, yscale, zscale: longreal;
			initial, final, increm, plotnum, cplotnum: quoly;          { for Funcplot }
			pplot, cplot: funcptr;  arrplot, arr2plot, arrpcopy: arrptr;   { for Funcplot }
			vplot, hplot, h2plot, hpcopy, vcop, ccop, vcop2, vplot2: varptr;
			tptr: textptr;  { for Funcplot }
			shadefactor: array[1..8] of longreal;

//wwh		  wrecord: WindowRecord;
//wwh			mywindow: WindowRef;
//wwh			windw: WindowPeek;
{wwh moved to GraphicsRoutines
			piccopy: BitMap;
			copyrect: Rect;}

	procedure attach_line(x,y,z,w: integer; a,b,c,d,e,f: longreal);
	
	procedure semi_change_view(ob: objptr; showit, change_angle: boolean);
	
	procedure copy_gr_ln(p1: graphptr; q1: lineptr; ob2: objptr);
		
	procedure copy_sides(ob1, ob2: objptr);
	
	procedure copy_gons(ob1, ob2: objptr);
	
	procedure cancel_obj_array(ob: objptr);
	
	procedure hide_line(var line: lineptr; q: quadptr; squarenum, width: integer);
	
	procedure show_g_list(g, fin: graphptr; stoppt: integer; undo: boolean);
	
	procedure show_line_list(ln: lineptr; undo: boolean);
	
	procedure show_lines(line: lineptr);
	
	procedure compute_hidden_lines(ob: objptr; showit: boolean);
	
	procedure show_one_unshaded(p: polygon_ptr);

	procedure show_unshaded_polys(p: polygon_ptr; undo: boolean); 
	
	procedure attach_symbols(q: varptr; s: arrptr);
	
	procedure preset_stuff(p: funcptr);
	
	procedure set_marking_globals;
	
	procedure setkeys(q: quadptr; size: integer; var width: integer);
	
	procedure sort_quads(q: quadptr; size: integer);
	
	function absval(var e: evector): longreal;
	
	procedure set_normal(gp: polygon_ptr; reverse: integer);
	
	function dotprod(var e: evector; var f: f_vector): longreal;
	
	function flength(var e: f_vector; dim: integer): longreal;
	
	procedure set_radius(this: polygon_ptr);
	
	procedure do_bias(ob: objptr; x,y,z: longreal);
	
	procedure enormalize(var normal: evector);
	
	procedure dist_sort_quads(q: quadptr; size: integer);
	
	procedure purge_hidden(ob: objptr; erasetoo: boolean);
	
	function find_spot(q: quadptr; start, stop: longint; key: integer): integer;
	
	procedure rotate_obj(ob: objptr; angle: longreal; erasetoo, showit: boolean; 
	                     ax: longint);
											 
	procedure reverse_obj(cur: polygon_ptr);
	
	procedure join_obj(ob: objptr; p: polygon_ptr);
	
	procedure trans_form(alpha: workptr; dim: longint; ob: objptr);
											 
	procedure trans_one(ob: objptr; erasetoo, showit: boolean; x: extarray);
	
	procedure zoom_most(ob: objptr; factor: longreal; showit: boolean);
	
	procedure single_cut(var ob: objptr; dim: integer; a: f_vector; length: longreal;
	                     testside: boolean; var killed: boolean; shouldsort: boolean);
												 
	function get_shading(s: polygon_ptr): longint;
	
	procedure sort_polygons(ob: objptr);
	
	procedure washobj(ob: objptr);
	
	procedure dump_points_lines(var outf: text; ob: objptr); {```}
	
	procedure dumpolyg(var outf: text; gp: polygon_ptr);  {```}
	
	procedure union_points(join, ob: objptr);  {```}
	
	procedure map_to_sphere(var xext, yext, x2: longreal; var xcor, ycor: integer);
	
	procedure My_PaintPoly(s: polygon_ptr);  { Jan 1998 }
	
												 
implementation	
	
  {***************************************************************}
	
	procedure newgroup(var p: grouptr);

    begin
      if group_garb = nil
         then new(p)
         else begin
                 p := group_garb;
                 group_garb := group_garb^.next
              end
		end;
						 
  {***************************************************************}
	
	procedure newfact(var p: factptr);
	
    begin
      if fact_garb = nil
         then new(p)
         else begin
                 p := fact_garb;
                 fact_garb := fact_garb^.next
              end;
			p^.fresh := true
		end;
						 
	{***************************************************************************}	

	procedure attach_line; {(x,y,z,w: integer; a,b,c,d,e,f: longreal)}
		 
		 begin
		    with curline^ do
				   begin
					    abscoord[1] := x;
							abscoord[2] := y;
							abscoord[3] := z;
							abscoord[4] := w;
							locoord[1] := a;
							locoord[2] := b;
							locoord[3] := c;
							locoord[4] := d;
							locoord[5] := e;
							locoord[6] := f;
							if wantcolor
			           then begin
				                 rred := theColor.red;  { Jan 1998 }
				                 ggreen := theColor.green;
				                 bblue := theColor.blue
			                end
					 end;
				penult := curline;
				newline(curline^.next);
				curline := curline^.next
		 end;

	{***********************************************************************}

	procedure compute_hidden_lines; {(ob: objptr; showit: boolean)}
	   var ln: lineptr;
		     s: integer;
		 begin
			  if noisy
				   then begin
					         writeln(userOutput, ' Computing hidden lines...');
				           flush(userOutput)
								end;
				setkeys(ob^.quads, ob^.init, s);
			  sort_quads(ob^.quads, ob^.init);
			  ln := ob^.line;
			  while ln <> nil do
					 begin
						  hide_line(ln, ob^.quads, ob^.init, s);
						  ln := ln^.next
					 end;
			  if showit
					 then show_lines(ob^.line)
							
		 end;
																
	{************************************************************************}
	
	 procedure semi_change_view; {(ob: objptr; showit, change_angle: boolean)}
	 
			var g: graphptr;
				  p: lineptr;
					i, j, stop: integer;
					xfact, yfact, zfact, xsine, ysine: longreal;
					erase: boolean;
			
	    {_______________________________________________________________________}

			procedure get_rs(x, y, z: longreal; var r, s: integer);
			 
					begin
						 r := round(yfact*y - xfact*x); 
						 s := - round(zfact*z - xsine*x - ysine*y)
					end;
					
			{_______________________________________________________________________}
				 
			begin
				 
				 if change_angle
				    then begin
										ob^.sintheta := sintheta;   
										ob^.z_cosine := z_cosine;
								 end
						else begin
						        ob^.xscale := xscale;
										ob^.yscale := yscale;
										ob^.zscale := zscale
								 end;
				 with ob^ do
				    begin
						   yfact := yscale*costheta;
							 xfact := xscale*costheta;
							 zfact := zscale*z_cosine;
							 xsine := xscale*sintheta;
							 ysine := yscale*sintheta
						end;
				 stop := graphsize;
				 erase := showit;
				 
				 { Compute new point coords. }
				 g := ob^.first;
				 while g <> nil do
						begin
							 if g = ob^.last
									then stop := ob^.final;
							 j := 1;
							 for i := 1 to stop do
								 begin
										if showit
										   then begin
											         SetPenShade(psWhite);
															 MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
															 if printchar
																	 then begin
																					 Move(-2,2);
																					 DrawChar(' ')
																				end
																	 else Line(0, 0);
											         RestorePenShade
											      end;
										get_rs(g^.locoord[j], g^.locoord[j+1], g^.locoord[j+2], g^.abscoord[2*i-1],
										       g^.abscoord[2*i]);
										if showit
										   then begin
											         MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
															 if wantcolor
										              then begin
													                with theColor do  { Jan 1998 }
																					 	 begin
																						    red := g^.colors[3*i-2];
																						    green := g^.colors[3*i-1];  
																						    blue := g^.colors[3*i]
																					   end;
																					RGBForeColor(theColor)
																			 end;
										           if printchar
																  then begin
																				  Move(-2,2);
																				  DrawChar(mychar)
																			 end
																  else Line(0, 0)
														end;
										j := j + 3
								 end;
							 g := g^.next
						end;

				{ Now the lines. }
				if ob^.quads <> nil
				   then begin
					         purge_hidden(ob, showit);
									 showit := false
					      end;
								
				 p := ob^.line;
				 while p <> nil do
						begin
							 j := 1;
							 if erase and p^.show
								  then begin
												  SetPenShade(psWhite);
												  MoveTo(p^.abscoord[1], p^.abscoord[2]);
												  LineTo(p^.abscoord[3], p^.abscoord[4]);
												  RestorePenShade
											 end;
							 for i := 1 to 2 do
								  begin
									   get_rs(p^.locoord[j], p^.locoord[j+1], p^.locoord[j+2], p^.abscoord[2*i-1],
										        p^.abscoord[2*i]);
										 if showit and p^.show
										    then if i = 1
																then MoveTo(p^.abscoord[1], p^.abscoord[2])
																else begin
																        if wantcolor
														               then begin
																	                with theColor do  { Jan 1998 }
																									 	 begin
																										    red := p^.rred;
																										    green := p^.ggreen;  
																										    blue := p^.bblue
																									   end;
																									RGBForeColor(theColor)
																							  end;
																        LineTo(p^.abscoord[3], p^.abscoord[4])
																     end;
										 j := j + 3
								  end;
							 p := p^.next
						end;
						
				 savescreen := true
				 				 
			end;
				
	{*****************************************************************************}

  procedure copy_gr_ln; {(p1: graphptr; q1: lineptr; ob2: objptr)}
	
	   var p2: graphptr;
				 q2: lineptr;
				 
		 begin
		 
				p2 := nil;
        if p1 <> nil
				   then begin
					         newgraph(ob2^.first);
									 p2 := ob2^.first;
									 p2^.abscoord := p1^.abscoord;
									 p2^.locoord := p1^.locoord;
									 p1 := p1^.next
								end
					 else ob2^.first := nil;
				while p1 <> nil do
				   begin
					    newgraph(p2^.next);
						  p2 := p2^.next;
						  p2^.abscoord := p1^.abscoord;
						  p2^.locoord := p1^.locoord;
						  p1 := p1^.next
					 end;
				if p2 <> nil
				   then begin
					         p2^.next := nil;
									 ob2^.last := p2
								end;
				
				q2 := nil;
        if q1 <> nil
				   then begin
					         newline(ob2^.line);
									 q2 := ob2^.line;
									 q2^.abscoord := q1^.abscoord;
									 q2^.locoord := q1^.locoord;
									 q2^.for_real := q1^.for_real;
									 q2^.show := q1^.show;
									 q1 := q1^.next
								end
					 else ob2^.line := nil;
				while q1 <> nil do
				   begin
					    newline(q2^.next);
						  q2 := q2^.next;
						  q2^.abscoord := q1^.abscoord;
						  q2^.locoord := q1^.locoord;
							q2^.for_real := q1^.for_real;
							q2^.show := q1^.show;
						  q1 := q1^.next
					 end;
				if q2 <> nil
				   then begin
					         q2^.next := nil;
									 ob2^.lasline := q2
								end
				
		 end;

  {************************************************************************}

   procedure copy_sides; {(ob1, ob2: objptr)}
	 
	    var q1, q2: quadptr;
				  l1, l2: lineptr;
				  s1, s2: sidesptr;
					i: integer;
			
			begin
			   
				 newquad(ob2^.quads);
				 q2 := ob2^.quads;
				 q1 := ob1^.quads;
				 for i := 1 to ob1^.init do
						begin
							 q2^.quad[i] := q1^.quad[i];
							 newsides(q2^.quad[i].q);
							 s2 := q2^.quad[i].q;
							 s1 := q1^.quad[i].q;
							 s2^.depth := s1^.depth;
							 
							 l1 := ob1^.line;
							 l2 := ob2^.line;
							 while s1^.left <> l1 do
									begin
										 l1 := l1^.next;
										 l2 := l2^.next
									end;
							 s2^.left := l2;
							 
							 l1 := ob1^.line;
							 l2 := ob2^.line;
							 while s1^.top <> l1 do
									begin
										 l1 := l1^.next;
										 l2 := l2^.next
									end;
							 s2^.top := l2;
							 
							 l1 := ob1^.line;
							 l2 := ob2^.line;
							 while s1^.right <> l1 do
									begin
										 l1 := l1^.next;
										 l2 := l2^.next
									end;
							 s2^.right := l2;
							 
							 l1 := ob1^.line;
							 l2 := ob2^.line;
							 while s1^.bottom <> l1 do
									begin
										 l1 := l1^.next;
										 l2 := l2^.next
									end;
							 s2^.bottom := l2;

							 if i > 1
							    then s2^.next := q2^.quad[i-1].q
						end
 
			end;
								
  {************************************************************************}

   procedure copy_gons; {(ob1, ob2: objptr)}
	 
	    var q1, q2: polygon_ptr;
				  s1, s2: coordptr;
			
			procedure dup_points;
			   var i: longint;
			   begin
		        q2^ := q1^;
						newpoint(q2^.cp);
						if s2 <> nil
						   then s2^.cp := q2^.cp;
						s2 := q2^.cp;
						s1 := q1^.cp;
						s2^ := s1^;
						for i := 2 to q1^.rank do
						   begin
							     newpoint(s2^.cp);
									 s2 := s2^.cp;
									 s1 := s1^.cp;
									 s2^ := s1^
							 end
				 end;
					
			begin
			
			   newgon(ob2^.gons);
				 q2 := ob2^.gons;
				 q1 := ob1^.gons;
				 s2 := nil;
				 dup_points;
				 q1^.link := q2;
				 q1 := q1^.gg;
				 while q1 <> nil do
				    begin
						   newgon(q2^.gg);
							 q2 := q2^.gg;
							 dup_points;
							 q1^.link := q2;
							 q1 := q1^.gg
						end;
			   q2^.gg := nil;
				 with ob2^ do
				    begin
						   lastgon := q2;
				       endvert := s2;
				       headvert := gons^.cp
						end;
				 if ob2^.solid
				    then begin
						        q2 := ob2^.gons;
										while q2 <> nil do
										   begin
													q2^.face := q2^.face^.link;
													q2 := q2^.gg
										   end
								 end
			
			end;
			
	{**************************************************************************}

	procedure cancel_obj_array; {(ob: objptr)}
											 
	   var i, j, size: integer;
		 
		 begin
		 					 
				for i := ob^.init to ob^.final do
				   begin
					     free_obj(obstash^[i]);
							 obstash^[i] := nil
					 end;
				size := ob^.final - ob^.init + 1;
				lastspot := lastspot - size;
				for i := ob^.init to lastspot do
				   obstash^[i] := obstash^[i+size];
				ob^.next := obj_garb;
				obj_garb := ob;
				i := ob^.init;
				
				for j := 0 to 150 do
				   begin
					    ob := objlist[j];
							while ob <> nil do
								 begin
										if ob^.obarray and (ob^.init > i)
											 then begin
															 ob^.init := ob^.init - size;
															 ob^.final := ob^.final - size
														end;
										ob := ob^.next
								 end
					 end
				
		 end;

  {************************************************************************}
	
	procedure show_g_list; {(g, fin: graphptr; stoppt: integer; undo: boolean)}
	
	   var i, stop: integer;
		 
		 begin
		 		 
		    if undo
				   then SetPenShade(psWhite);
				stop := graphsize;
				while g <> nil do
				   begin
					    if g = fin
							   then stop := stoppt; 
							for i := 1 to stop do
							   begin
										MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
										if wantcolor
										   then if not undo
										        then begin
										                with theColor do  { Jan 1998 }
																		 	 begin
																			    red := g^.colors[3*i-2];
																			    green := g^.colors[3*i-1];  
																			    blue := g^.colors[3*i]
																		   end;
																		RGBForeColor(theColor)
																 end;
										if printchar
											 then begin
															 Move(-2,2);
															 if undo
															    then DrawChar(' ')
																	else DrawChar(mychar)
														end
											 else Line(0, 0)
								 end;
					    g := g^.next
					 end;
				if undo
				   then RestorePenShade;
				savescreen := true
					 
		 end;
					 
  {*************************************************************************}
	
	procedure show_line_list; {(ln: lineptr; undo: boolean)}
	
	   begin
		 
		    if undo
				   then SetPenShade(psWhite);
				while ln <> nil do
				   begin
							if ln^.show
							   then begin
								         MoveTo(ln^.abscoord[1], ln^.abscoord[2]);
								         if wantcolor
												    then if not undo
												        then begin
												                with theColor do  { Jan 1998 }
																				 	 begin
																					    red := ln^.rred;
																					    green := ln^.ggreen;  
																					    blue := ln^.bblue
																				   end;
																				RGBForeColor(theColor)
																		 end;
							           LineTo(ln^.abscoord[3], ln^.abscoord[4])
											end;
							ln := ln^.next
					 end;
				if undo
				   then RestorePenShade;
				savescreen := true
					 
		 end;					 
					 
  {*************************************************************************}
	
  procedure show_one_unshaded; {(p: polygon_ptr)}

		 var i: longint;
		     cp: coordptr;

		 begin
		    cp := p^.cp;
			  MoveTo(cp^.a, cp^.b);
			  if wantcolor
					 then begin
	                with theColor do  { Jan 1998 }
									 	 begin
										    red := p^.rred;
										    green := p^.ggreen;  
										    blue := p^.bblue
									   end;
									RGBForeColor(theColor)
							  end;
			  for i := 2 to p^.rank do
					 begin
						  cp := cp^.cp;
						  LineTo(cp^.a, cp^.b)
					 end;
			  LineTo(p^.cp^.a, p^.cp^.b);
			  savescreen := true
		 end;
							 							 							 
	{************************************************************************}
	
	procedure show_unshaded_polys; {(p: polygon_ptr; undo: boolean)}  
	
     begin
		 
				 if undo
						then SetPenShade(psWhite);
				 while p <> nil do
				    begin
						   show_one_unshaded(p);
							 p := p^.gg
						end;
				 if undo
						then RestorePenShade
								
     end;

  {*************************************************************************}

	procedure attach_symbols; {(q: varptr; s: arrptr)}
	
	   var i: integer;
				 temp: varptr;
				 t: arrptr;
				
		 begin

		    while q <> nil do
						begin
							 i := q^.let.address;
							 temp := q^.next;
							 q^.next := sca_store[i];
							 sca_store[i] := q;
							 q := temp
						end;										
					
				while s <> nil do
					 begin
							i := s^.name.address;
							t := s^.next;
							s^.next := arr_store[i];
							arr_store[i] := s;
							s := t
					 end
						 
			end;
									 
	{***************************************************************************}
	
	procedure preset_stuff; {(p: funcptr)}
	
	   begin
		    lastf := lastf^.next;
				lastf^.f := p;
				statcount := statcount + 1;
				old_start := startexpr;
				old_prev := prev_expr;
				prev_expr := nil;
				startexpr := nil
		 end;
								
  {***************************************************************************}
	
	procedure set_marking_globals;
		 begin 
		    if sysgraph = nil
					 then newgraph(sysgraph);
				curgraph := sysgraph;
				grindex := 0;
				sysgraph^.abscoord[1] := impossibl;
				if sysline = nil
					 then newline(sysline);
				curline := sysline;
				sysline^.abscoord[1] := impossibl;
        { sysgon and curgon always nil }
				
				{ These are used only by sort polygons.  They must be set and maintained for 
				  all threeD objects with polygons. }
				xmin := 1.0e300;
				ymin := 1.0e300;
				zmin := 1.0e300;
				xmax := -1.0e300;
				ymax := -1.0e300;
				zmax := -1.0e300
		 end;
														
	{***************************************************************************}
	
	procedure setkeys; {(q: quadptr; size: integer; var width: integer)}

	   var i, max, min: integer;
		     p: lineptr;
				 s: sidesptr;
				 emin: longreal;
		 
		 begin
       
				width := -30000;
				for i := 1 to size do
				   begin
					    min := 30000;
				      max := -30000;
							s := q^.quad[i].q;
							p := s^.left;
					    if p^.abscoord[1] < min
							   then min := p^.abscoord[1];
							if p^.abscoord[3] < min
							   then min := p^.abscoord[3];
							if p^.abscoord[1] > max
							   then max := p^.abscoord[1];
							if p^.abscoord[3] > max
							   then max := p^.abscoord[3];
							emin := p^.locoord[1] + p^.locoord[2];
							if (p^.locoord[4] + p^.locoord[5] < emin)
								 then emin := p^.locoord[4] + p^.locoord[5]; 
								 
				      p := s^.right; 
							if p^.abscoord[1] < min
							   then min := p^.abscoord[1];
							if p^.abscoord[3] < min
							   then min := p^.abscoord[3];
							if p^.abscoord[1] > max
							   then max := p^.abscoord[1];
							if p^.abscoord[3] > max
							   then max := p^.abscoord[3];
								 
							q^.quad[i].left := min;
							q^.quad[i].right := max;
							if max - min > width
							   then width := max - min;
							
							if (p^.locoord[1] + p^.locoord[2] < emin)
								 then emin := p^.locoord[1] + p^.locoord[2];
							if (p^.locoord[4] + p^.locoord[5] < emin)
								 then emin := p^.locoord[4] + p^.locoord[5];
							s^.depth := emin
					 end
					 
     end;

	{***************************************************************************}

	procedure sort_quads; {(q: quadptr; size: integer)}
	
	   { Quicksort the array of quads given by q. }

     {____________________________________________________________________}
		 
		 procedure partition(var i,j,r: integer; var hit: boolean);
		 
		    var low, high, k: integer;
				    temp, store: quaddata;

				function f(i: integer): integer;
				   begin
					    f := q^.quad[i].left
					 end;
				
				begin
				
				   { find median of three }
					 k := (i+j) div 2;
					 if f(i) < f(k)
					    then if f(j) <= f(i)
							        then r := i
								      else if f(j) < f(k)
											        then r := j
															else r := k
							else if f(j) <= f(k)
							        then r := k
											else if f(j) >= f(i)
											        then r := i
															else r := j;

					 k := q^.quad[r].left;
					 store := q^.quad[r];
					 low := i - 1;
					 high := j + 1;
					 hit := false;
					 while low < high do
					    begin
							   repeat
								    low := low + 1
								 until (q^.quad[low].left > k) or (low = j);
								 repeat
								    high := high - 1
								 until (q^.quad[high].left <= k) or (high = i);
								 if low < high
								    then begin
										        temp := q^.quad[low];
														q^.quad[low] := q^.quad[high];
														q^.quad[high] := temp
												 end;
							end;
					 if r <= high
							then begin
											q^.quad[r] := q^.quad[high];
											q^.quad[high] := store;
											hit := true
									 end;
					 r := high
					 
				end;
				
		 {___________________________________________________________________}

     procedure quicksort(i,j: integer);
		 
		    var r, k, key: integer;
				    t: quaddata;
						hit: boolean;
				
				begin

           if j >= i + 2
					    then begin
							        partition(i,j,r, hit);
											if hit
											   then begin
												         k := r;
																 key := q^.quad[r].left;
																 while q^.quad[k].left = key do
																    begin
																		   k := k - 1;
																			 if k < i
																			    then break
																		end;
																 while q^.quad[r].left = key do
																    begin
																		   r := r + 1;
																			 if r > j
																			    then break
																		end;
																 quicksort(i, k);
																 quicksort(r, j)
															end
												 else begin
																 quicksort(i,r);
											           quicksort(r+1,j)
															end
									 end
							else if j = i + 1
							        then if q^.quad[i].left > q^.quad[j].left
											        then begin
															        t := q^.quad[i];
																			q^.quad[i] := q^.quad[j];
																			q^.quad[j] := t
																	 end

        end;
				
		 {__________________________________________________________________}

     begin
		 
		    quicksort(1, size)
				
		 end;

	{***************************************************************************}

	procedure dist_sort_quads; {(q: quadptr; size: integer)}
	
	   { Quicksort the array of quads given by q, using distance from observer,
		   estimated by sum of x and y coordinates. }

		 {____________________________________________________________________}

		 function f(i: integer): longreal;
				 begin
						with q^.quad[i].q^.left^ do
							 f := locoord[1] + locoord[2]
				 end;
				
     {____________________________________________________________________}
		 
		 procedure partition(var i,j,r: integer; var hit: boolean);
		 
		    var low, high, k: integer;
				    temp, store: quaddata;
						key: longreal;
				
				begin
				
				   { find median of three }
					 k := (i+j) div 2;
					 if f(i) < f(k)
					    then if f(j) <= f(i)
							        then r := i
								      else if f(j) < f(k)
											        then r := j
															else r := k
							else if f(j) <= f(k)
							        then r := k
											else if f(j) >= f(i)
											        then r := i
															else r := j;
					 
					 key := f(r);
					 store := q^.quad[r];
					 low := i - 1;
					 high := j + 1;
					 hit := false;
					 while low < high do
					    begin
							   repeat
								    low := low + 1
								 until (f(low) > key) or (low = j);
								 repeat
								    high := high - 1
								 until (f(high) <= key) or (high = i);
								 if low < high
								    then begin
										        temp := q^.quad[low];
														q^.quad[low] := q^.quad[high];
														q^.quad[high] := temp
												 end;
							end;
					 if r <= high
							then begin
											q^.quad[r] := q^.quad[high];
											q^.quad[high] := store;
											hit := true
									 end;
					 r := high
					 
				end;
				
		 {___________________________________________________________________}

     procedure quicksort(i,j: integer);
		 
		    var r, k: integer;
				    t: quaddata;
						hit: boolean;
						key: longreal;
				
				begin

           if j >= i + 2
					    then begin
							        partition(i,j,r, hit);
											if hit
											   then begin
												         k := r;
																 key := f(r);
																 while f(k) = key do
																    begin
																		   k := k - 1;
																			 if k < i
																			    then break
																		end;
																 while f(r) = key do
																    begin
																		   r := r + 1;
																			 if r > j
																			    then break
																		end;
																 quicksort(i, k);
																 quicksort(r, j)
															end
												 else begin  
																 quicksort(i,r);
											           quicksort(r+1,j)
															end
									 end
							else if j = i + 1
							        then if f(i) > f(j)
											        then begin
															        t := q^.quad[i];
																			q^.quad[i] := q^.quad[j];
																			q^.quad[j] := t
																	 end

        end;
				
		 {__________________________________________________________________}

     begin

		    quicksort(1, size)

		 end;

   {***********************************************************************}

	 function find_spot; {(q: quadptr; start, stop: longint; key: integer): integer}

	    { binary search. Return first index that we need look at. }

	    var mid: integer;

			begin

			   while stop >= start do
				    begin
						   mid := (start + stop) div 2;
				       if q^.quad[mid].left = key
				          then begin
									        while q^.quad[mid].left = key do
													   begin
														    mid := mid - 1;
																if mid = 0
																   then break
														 end;
													find_spot := mid + 1;
													exit
											 end
				       else if q^.quad[mid].left < key
				          then start := mid + 1
				       else stop := mid - 1
						end;
				 if stop = 0
				    then find_spot := 1
						else find_spot := stop
				 
			end;
					
	{***************************************************************************}
	
	procedure in_out_side(line: lineptr; q: sidesptr; var in1, in2: boolean);
	
	   { Assumes that all the little squares have oriented boundaries. }
	
	   var i: integer;
		 
		 function get_det(x, y, x0, y0, x1, y1: integer): integer;
		    { cross product of vectors, origin moved to x0, y0. }
		    var determ, p1, p2: longint;
				begin
				   p1 := x1-x0;
					 p2 := y-y0;
					 determ := p1*p2;  { necessary to prevent overflow! }
					 p1 := x-x0;
					 p2 := y1-y0;
					 determ := determ - p1*p2;
					 if determ > 0
					    then get_det := 1
					 else if determ < 0
					    then get_det := -1
					 else get_det := 0
				end;
		 
		 {_______________________________________________________________________}
		 
		 procedure set_dets(i,j,k: integer; p: lineptr);
		    var d: integer;
		    begin
				    d := get_det(line^.abscoord[j], line^.abscoord[j+1], p^.abscoord[1],
                         p^.abscoord[2], p^.abscoord[3], p^.abscoord[4]);
						if k = 1
						   then det1[i] := d
							 else det2[i] := d
				end;
		 
		 {_______________________________________________________________________}

		 begin

        set_dets(1, 1, 1, q^.left);
				set_dets(2, 1, 1, q^.top);
				set_dets(3, 1, 1, q^.right);
				set_dets(4, 1, 1, q^.bottom);
				in1 := (det1[1] <> 0);
				for i := 1 to 3 do
				   in1 := in1 and (det1[i] = det1[i+1]);

				set_dets(1, 3, 2, q^.left);
				set_dets(2, 3, 2, q^.top);
				set_dets(3, 3, 2, q^.right);
				set_dets(4, 3, 2, q^.bottom);
				in2 := (det2[1] <> 0);
				for i := 1 to 3 do
				   in2 := in2 and (det2[i] = det2[i+1])

     end;

	{***************************************************************************}

  procedure attach_subdivide(var line: lineptr; a,b,c,d: integer; var noattach: boolean);
	  
		 var q: lineptr;
				 
		 begin
        noattach := (a = c) and (b = d);
				if noattach
				   then exit;

			  line^.show := false;
				q := line^.next;
			  newline(line^.next);
				line^.next^.locoord := line^.locoord;
				line := line^.next;
			  with line^ do
				   begin
					    next := q;
							for_real := false;
							abscoord[1] := a;
							abscoord[2] := b;
							abscoord[3] := c;
							abscoord[4] := d
					 end
		 end; 
									 
	{***************************************************************************}

  procedure in_intersect(var line: lineptr; p: sidesptr; ind, other: integer; det: crossings;
	                       var done: boolean);
												 
		 { one endpoint of line is definitely inside p. Slight compromise. Assumes that the
		   quad p is convex, in that if more than one side satisfies the condition in the
			 main loop, the larger (or smaller; see get_t_v) t is chosen (as v). }
		 
		 var i: integer;
		     q: lineptr;
				 x, y: array[1..4] of longreal;
				 deter, t, v, initv: longreal;
		 
		 {__________________________________________________________________}
		 
		 procedure get_t_v;
		    var j: integer;
		    begin
				   case i of 
							1: q := p^.left;
							2: q := p^.top;
							3: q := p^.right;
							4: q := p^.bottom
					 end;
					 for j := 3 to 4 do
							begin
								 x[j] := q^.abscoord[2*j-5];
								 y[j] := q^.abscoord[2*j-4]
							end;
					 deter := (x[1]-x[2])*(y[4]-y[3]) - (x[4]-x[3])*(y[1]-y[2]);
					 t := (x[4]-x[2])*(y[4]-y[3]) - (x[4]-x[3])*(y[4]-y[2]);
					 t := t/deter;
					 if ind = 2
					    then if t > v
					            then v := t
											else
							else if t < v
					            then v := t
				end;				
		 {____________________________________________________________________}
		 
		 begin
			 
			  if other = 0
				   then exit;  { very degenerate case }
					 
				for i := 1 to 2 do
					 begin
						  x[i] := line^.abscoord[2*i-1];
						  y[i] := line^.abscoord[2*i]
					 end;
					 
			  i := 1;
				if ind = 2
				   then initv := -1
					 else initv := 2;
				v := initv;
				while i < 5 do
				   begin
					    if (det[i] <> other) and (det[i] <> 0) { line crosses that side of p, }
							   then get_t_v;                     { but may be a phantom cross. }
							i := i + 1                           { real cross has largest t. }
					 end;

				if v = initv
				   then done := true
					 else begin
									 if (v < 0.00001) or (v > 0.99999)
									    then done := true
									 { This line is now not to show.  Insert new line record to
									   be shown, but not for_real. }
									    else attach_subdivide(line, round(v*(x[1]-x[2]) + x[2]), round(v*(y[1]-y[2]) + 
									                          y[2]), line^.abscoord[2*ind-1], line^.abscoord[2*ind],
																						done)
								end
								
		 end;					    		 		 

  {***************************************************************************}
	
  procedure out_intersect(var line: lineptr; p: sidesptr; var done: boolean);
	
	   { done means that 'line' is hidden. }

	   var i, key: integer;
		     x, y, t: array[1..4] of longreal;
				 q: lineptr;
				 deter, u, deltax, deltay, max, min: longreal;
				 nothing: boolean;
		 
		 {______________________________________________________________________}
		 
		 procedure find_t;
		    { find point of intersection parameter t, the affine coordinate }
		    var j: integer;
		    begin
		       case i of 
							1: q := p^.left;
							2: q := p^.top;
							3: q := p^.right;
							4: q := p^.bottom
					 end;
					 for j := 3 to 4 do
							begin
								 x[j] := q^.abscoord[2*j-5];
								 y[j] := q^.abscoord[2*j-4]
							end;
					 { u = affine coord of intersection point relative to (x3,y3), (x4,y4), the
					   side of p. }
					 u := deltax*(y[4]-y[2]) - (x[4]-x[2])*deltay;
					 deter := deltax*(y[4]-y[3]) - (x[4]-x[3])*deltay;
					 u := u/deter;
					 if (u > -0.0000001) and (u < 1.0000001)  { they touch }
							then begin
							       t[i] := ((x[4]-x[2])*(y[4]-y[3]) - (x[4]-x[3])*(y[4]-y[2]))/deter;
										 nothing := false
									 end
				end;
		 
		 {________________________________________________________________________}
		 
		 begin
		 
		    for i := 1 to 2 do
					 begin
						  x[i] := line^.abscoord[2*i-1];
						  y[i] := line^.abscoord[2*i]
					 end;
				deltax := x[1] - x[2];
				deltay := y[1] - y[2];
				nothing := true;
			  for i := 1 to 4 do
		       begin
					    key := det1[i]*det2[i];
							t[i] := -1;  { initialization }
						  case key of
							   -1: { line straddles side i of p }
								     find_t;
							    0: if (det1[i] = 0) and (det2[i] = 0) { degenerate colinear }
									      then { nothing(!). sneaky. }
												else find_t;  { t[i] will be 0 or 1, if they touch at all }
									1: { nothing. no straddle. }
							end
					 end;
							
				if nothing
				   then exit;

				min := 2;
				max := -1;
				{ slight cop-out here in only considering max and min. }
				for i := 1 to 4 do
				   begin
					    if t[i] > max
							   then max := t[i];
							if (t[i] < min) and (t[i] > -1)
							   then min := t[i]
					 end;
					 
		    min := abs(min);
				max := abs(max);
				if min = max
				   then exit{(out_intersect)};
					 
				if (min = 0) and (max = 1)
				   then done := true
				else if min = 0
				   then attach_subdivide(line, line^.abscoord[1], line^.abscoord[2], 
					                       round(max*deltax + x[2]), round(max*deltay + y[2]), done) 
				else if max = 1
				   then attach_subdivide(line, round(min*deltax + x[2]), round(min*deltay + y[2]), 
					                       line^.abscoord[3], line^.abscoord[4], done) 
				else begin
				        q := line;
								attach_subdivide(line, round(min*deltax + x[2]), round(min*deltay + y[2]), 
					                       line^.abscoord[3], line^.abscoord[4], nothing);
								line := q;
								attach_subdivide(line, line^.abscoord[1], line^.abscoord[2], 
					                       round(max*deltax + x[2]), round(max*deltay + y[2]), done);
								if done and not nothing
								   then line := line^.next;
								done := done and nothing
				     end
						 
		 end;
		 
	{****************************************************************************}
	
  procedure hide_line; {var line: lineptr; q: quadptr; squarenum, width: integer}
	
	   var xcor, rxcor, temp, i: integer;
		     done, in1, in2: boolean;
				 p: sidesptr;
		 
		 {_________________________________________________________________________}

		 function infront(depth: longreal; line: lineptr): boolean;
		    { is the quad in front of the line?  }
				begin
				   if line^.locoord[1] + line^.locoord[2] < depth
						  then infront := true
						  else if line^.locoord[4] + line^.locoord[5] < depth
										  then infront := true
										  else infront := false
				end;
		 		 
		 {_____________________________________________________________________}
		 
     begin
		 
				xcor := line^.abscoord[1];
				rxcor := line^.abscoord[3];
				if xcor > rxcor
					 then begin
									 temp := xcor;
									 xcor := rxcor;
									 rxcor := temp
								end;
				i := find_spot(q, 1, squarenum, xcor - width);
				repeat
				   { Note: line may be changed by in_intersect and out_ }
					 p := q^.quad[i].q;
					 if q^.quad[i].right > xcor
							then if infront(p^.depth, line)
											then begin
															in_out_side(line, p, in1, in2); { sets det1 and det2 too }
															done := false;
															if in1 and in2
																 then done := true
															else if in1
																 then in_intersect(line, p, 2, det1[1], det2, done)
															else if in2
																 then in_intersect(line, p, 1, det2[1], det1, done)
															else out_intersect(line, p, done);
															if done 
																 then begin
																				 line^.show := false;
																				 break
																			end
													 end;
					 i := i + 1;
					 if i > squarenum 
							then break
				until q^.quad[i].left >= rxcor
				
		 end;
					 					 
	{**************************************************************************}
	
	procedure join_obj; {(ob: objptr; p: polygon_ptr)}
	
	   var g1, g2: polygon_ptr;
		     t, fp: gonptrptr;
				 u: coordptrptr;
		     bad, i, j: integer;
				 rank: longint;
				 cp, cp1, cp2, cp3, d1, d2, e1, e2: coordptr;
				 x1, y1, z1: longreal;
				 first, second, norm: evector;
		 
		 begin
		 
		    bad := 0;
				t := @ ob^.lastgon^.gg;
				u := @ ob^.endvert^.cp;
				g1 := ob^.gons;
				g2 := p;
				while g1 <> p do
				   begin
							if g1^.rank <> g2^.rank
							   then bad := bad + 1;
							if g1^.rank > g2^.rank
							   then rank := g2^.rank
								 else rank := g1^.rank;
							cp1 := g1^.cp;
							cp2 := g2^.cp;
							{ set up face links }
							g1^.face := g2;
							fp := @ g2^.face;
							for i := 1 to rank do
							   begin
								    newgon(t^);
							      if i = rank
										   then begin
											         { save current values }
															 d1 := cp1^.cp;
															 d2 := cp2^.cp;
															 e1 := cp1;
															 e2 := cp2;
															 { make point records into circular lists to simplify the
															   following }
															 cp1^.cp := g1^.cp;
															 cp2^.cp := g2^.cp;
															 { set lastgon in case this is the end }
															 ob^.lastgon := t^
											      end;
										fp^ := t^;
										fp := @ t^^.face;
										t^^.rank := 4;
							      newpoint(t^^.cp);
										cp := t^^.cp;
										u^ := cp;   { set coordptr link. }
										cp^ := cp1^;
										cp3 := cp;  
										with cp^ do
										   begin
											    x1 := x;
													y1 := y;
													z1 := z
											 end;
										cp1 := cp1^.cp;
										newpoint(cp^.cp);
										cp := cp^.cp;
										cp^ := cp1^;
										with cp^ do
										   begin
												  x1 := x1 + x;
												  y1 := y1 + y;
												  z1 := z1 + z
											 end;
										first[1] := cp3^.x - cp^.x;
									  first[2] := cp3^.y - cp^.y;
									  first[3] := cp3^.z - cp^.z;
										cp3 := cp;
										newpoint(cp^.cp);
										cp := cp^.cp;
										cp^ := cp2^.cp^;
										second[1] := cp^.x - cp3^.x;
									  second[2] := cp^.y - cp3^.y;
									  second[3] := cp^.z - cp3^.z;
										with cp^ do
										   begin
												  x1 := x1 + x;
												  y1 := y1 + y;
												  z1 := z1 + z
											 end;
										newpoint(cp^.cp);
										cp := cp^.cp;
										cp^ := cp2^;
										t^^.xcen := (x1 + cp^.x)/4.0;
										t^^.ycen := (y1 + cp^.y)/4.0;
										t^^.zcen := (z1 + cp^.z)/4.0;
										cp2 := cp2^.cp;
										{ find unit normal vector. 
									    take second X first for counterclockwise orientation. }
									  norm[1] := second[2]*first[3] - second[3]*first[2];
									  norm[2] := second[3]*first[1] - second[1]*first[3];
									  norm[3] := second[1]*first[2] - second[2]*first[1];
									  x1 := 0;
									  for j := 1 to 3 do
											 x1 := x1 + sqr(norm[j]);
									  x1 := sqrt(x1);
									  if x1 > 0
											 then for j := 1 to 3 do
														   norm[j] := norm[j]/x1;
										with t^^ do
										   begin
											    x := norm[1];  y := norm[2];  z := norm[3]
											 end;
										set_radius(t^);
										u := @ cp^.cp;
										t := @ t^^.gg
								 end;
							
					    { restore coord ptrs }
							e1^.cp := d1;
							e2^.cp := d2;
							
							{ finish face link }
							fp^ := g1;
							
							g1 := g1^.gg;
							g2 := g2^.gg
					 
					 end;
					 
				t^ := nil;
				ob^.endvert := cp;
							
				if bad > 0
				   then writeln(' Warning.  Mismatch found in objects being joined.')					 
		 		 
		 end;
	
	{**************************************************************************}
	
	procedure rotate_obj; {(ob: objptr; angle: longreal; erasetoo, showit: boolean; 
	                        ax: longint)}
	
	   var g: graphptr;
		     ln: lineptr;
				 sine, cosine, dum, dum2, sinth, zcosh, xscale, yscale, zscale,
				    xfact, yfact, zfact, xsine, ysine: longreal;
				 i, j, stop, r, s, fir, sec: integer;
				 
		 {______________________________________________________________________}
		 
		 procedure get_rs(x, y, z: longreal);
		    
		    begin
				   if ob^.threeD
							 then begin
											 r := round(yfact*y - xfact*x); 
						           s := - round(zfact*z - xsine*x - ysine*y)
										end
							 else begin
											 r := round(xscale*x);
											 s := - round(yscale*y);
										end
				end;
				
		 {______________________________________________________________________}
		 
		 begin
		    
				if ob = nil
				   then exit;
					 
				g := ob^.first;
				sinth := ob^.sintheta;
				zcosh := ob^.z_cosine;
				xscale := ob^.xscale;
			  yscale := ob^.yscale;
				zscale := ob^.zscale;
				yfact := yscale*costheta;
			  xfact := xscale*costheta;
			  zfact := zscale*zcosh;
			  xsine := xscale*sinth;
			  ysine := yscale*sinth;
				
				sine := sin(angle);
				cosine := cos(angle);
				stop := graphsize;
				case ax of
				   1: begin
					       fir := 1;
								 sec := 2
					    end;
					 2: begin
					       fir := 0;
								 sec := 2
					    end;
					 3: begin
					       fir := 0;
								 sec := 1
					    end
				end;
				
				while g <> nil do
				   begin
					    if g = ob^.last
							   then stop := ob^.final;
							j := 1;
							for i := 1 to stop do
							   begin
										if erasetoo
										   then begin
											         SetPenShade(psWhite);
											         MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
										           if printchar
																	 then begin	
																					 SetTextMode(3); //wwh mywindow^.txMode := 3;
																					 Move(-2,2);
																					 DrawChar(' ');
																					 SetTextMode(0) //wwh mywindow^.txMode := 0
																				end
																	 else Line(0, 0);
											         RestorePenShade
											      end;
										dum := g^.locoord[j+fir]*cosine - g^.locoord[j+sec]*sine;
										dum2 := g^.locoord[j+fir]*sine + g^.locoord[j+sec]*cosine;
								    g^.locoord[j+fir] := dum;
										g^.locoord[j+sec] := dum2;
										case ax of
										   1: get_rs(g^.locoord[j+ax-1], dum, dum2);
											 2: get_rs(dum, g^.locoord[j+ax-1], dum2);
											 3: get_rs(dum, dum2, g^.locoord[j+ax-1])
										end;
										if showit
										   then begin
											         MoveTo(r, s);
											         if wantcolor
										              then begin
													                with theColor do  { Jan 1998 }
																					 	 begin
																						    red := g^.colors[3*i-2];
																						    green := g^.colors[3*i-1];  
																						    blue := g^.colors[3*i]
																					   end;
																					RGBForeColor(theColor)
																			 end;
															 if printchar
																  then begin
																				 Move(-2,2);
																				 DrawChar(mychar)
																			 end
																  else Line(0, 0)
														end;
										g^.abscoord[2*i-1] := r;
										g^.abscoord[2*i] := s;
										j := j + 3
								 end;
					    g := g^.next
					 end;
					 
				if ob^.quads <> nil
				   then begin
									 showit := false;
									 purge_hidden(ob, erasetoo)
					      end;
					 
				fir := fir + 1;
				sec := sec + 1;
				ln := ob^.line;
				while ln <> nil do
				   begin
						  if erasetoo and ln^.show
							   then begin
								         SetPenShade(psWhite);
							           MoveTo(ln^.abscoord[1], ln^.abscoord[2]);
							           LineTo(ln^.abscoord[3], ln^.abscoord[4]);
							           RestorePenShade
											end;
							dum := ln^.locoord[fir]*cosine - ln^.locoord[sec]*sine;
							dum2 := ln^.locoord[fir]*sine + ln^.locoord[sec]*cosine;
							ln^.locoord[fir] := dum;
							ln^.locoord[sec] := dum2;
							case ax of
								 1: get_rs(ln^.locoord[ax], dum, dum2);
								 2: get_rs(dum, ln^.locoord[ax], dum2);
								 3: get_rs(dum, dum2, ln^.locoord[ax])
							end;
							if showit
							   then MoveTo(r, s);
							ln^.abscoord[1] := r;
							ln^.abscoord[2] := s;
							
							dum := ln^.locoord[fir+3]*cosine - ln^.locoord[sec+3]*sine;
							dum2 := ln^.locoord[fir+3]*sine + ln^.locoord[sec+3]*cosine;
							ln^.locoord[fir+3] := dum;
							ln^.locoord[sec+3] := dum2;
							case ax of
								 1: get_rs(ln^.locoord[ax+3], dum, dum2);
								 2: get_rs(dum, ln^.locoord[ax+3], dum2);
								 3: get_rs(dum, dum2, ln^.locoord[ax+3])
							end;
							if showit
							   then begin
							           if wantcolor
						                then begin
										                with theColor do  { Jan 1998 }
																		 	 begin
																			    red := ln^.rred;
																			    green := ln^.ggreen;  
																			    blue := ln^.bblue
																		   end;
																		RGBForeColor(theColor)
															   end;
							           LineTo(r, s)
							        end;
							ln^.abscoord[3] := r;
							ln^.abscoord[4] := s;
							ln := ln^.next
					 end;
				
				savescreen := true				 
		 
		 end; 
		
	 {************************************************************************}
	 
	 procedure trans_one; {(ob: objptr; erasetoo, showit: boolean; x: extarray)}
	 
			var g: graphptr;
					ln: lineptr;
					i, j, stop, k, r, s: integer;
					xfact, yfact, zfact, xsine, ysine: longreal;
										
			{______________________________________________________________________}
	 
			 procedure get_rs(x, y, z: longreal);
					begin
						 if ob^.threeD
								 then begin
												 r := round(yfact*y - xfact*x);
												 s := - round(z*zfact - xsine*x - ysine*y)
											end
								 else begin
												 r := round(ob^.xscale*x);
												 s := - round(ob^.yscale*y);
											end
					end;
					
			 {_____________________________________________________________________}
	 
			begin
					
					if ob = nil
						 then exit;
					
					with ob^ do
				    begin
						   yfact := yscale*costheta;
							 xfact := xscale*costheta;
							 zfact := zscale*z_cosine;
							 xsine := xscale*sintheta;
							 ysine := yscale*sintheta
						end;
					g := ob^.first;
					stop := graphsize;
					get_rs(x[0], x[1], x[2]);
					while g <> nil do
						 begin
								if g = ob^.last
									 then stop := ob^.final;
								j := 1;
								for i := 1 to stop do
									 begin
											if erasetoo
												 then begin
																 SetPenShade(psWhite);
																 MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
																 if printchar
																		 then begin
																						 Move(-2,2);
																						 DrawChar(' ')
																					end
																		 else Line(0, 0);
																 RestorePenShade
															end;
											for k := 0 to 2 do
												 g^.locoord[k+j] := g^.locoord[k+j] + x[k];
											g^.abscoord[2*i-1] := g^.abscoord[2*i-1] + r;
											g^.abscoord[2*i] := g^.abscoord[2*i] + s;
											if showit
												 then begin
																 MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
																 if wantcolor
											              then begin
														                with theColor do  { Jan 1998 }
																						 	 begin
																							    red := g^.colors[3*i-2];
																							    green := g^.colors[3*i-1];  
																							    blue := g^.colors[3*i]
																						   end;
																						RGBForeColor(theColor)
																				 end;
																 if printchar
																	  then begin
																					  Move(-2,2);
																					  DrawChar(mychar)
																				 end
																	  else Line(0, 0)
															end;
											j := j + 3
									 end;
								g := g^.next
						 end;
						 					
					ln := ob^.line;
					while ln <> nil do
						 begin
								if erasetoo and ln^.show
									 then begin
													 SetPenShade(psWhite);
													 MoveTo(ln^.abscoord[1], ln^.abscoord[2]);
													 LineTo(ln^.abscoord[3], ln^.abscoord[4]);
													 RestorePenShade
												end;
								with ln^ do
								   begin
									    for k := 1 to 3 do
												 locoord[k] := locoord[k] + x[k-1];
											abscoord[1] := r + abscoord[1];
											abscoord[2] := s + abscoord[2];
											if showit and show
												 then MoveTo(abscoord[1], abscoord[2]);
											
											for k := 0 to 2 do
												 locoord[k+4] := locoord[k+4] + x[k];
											abscoord[3] := r + abscoord[3];
											abscoord[4] := s + abscoord[4];
											if showit and show
									       then begin
									               if wantcolor
										                then begin
														                with theColor do  { Jan 1998 }
																						 	 begin
																							    red := rred;
																							    green := ggreen;  
																							    blue := bblue
																						   end;
																						RGBForeColor(theColor)
																			   end;
									               LineTo(abscoord[3], abscoord[4])
									            end;
									 end;
								ln := ln^.next
						 end;
						 
				 savescreen := true
						 
			end;
				
	 {**************************************************************************}

	 procedure show_lines; {(line: lineptr)}
			begin
				while line <> nil do
					 begin
							if line^.show
								 then begin
												 MoveTo(line^.abscoord[1], line^.abscoord[2]);
												 if wantcolor
						                then begin
										                with theColor do  { Jan 1998 }
																		 	 begin
																			    red := line^.rred;
																			    green := line^.ggreen;  
																			    blue := line^.bblue
																		   end;
																		RGBForeColor(theColor)
															   end;
												 LineTo(line^.abscoord[3], line^.abscoord[4])
											end;
							line := line^.next
					 end;
					 
				 savescreen := true
			end; 
				
  {**************************************************************************}
	
	procedure reverse_obj; {(cur: polygon_ptr)}	
	
	   { Reverse orientation.  Just change normal vector; do not change actual 
		   path in the vertices! }
		 
		 begin
		 
				while cur <> nil do
				   begin
					    with cur^ do
							   begin
								    x := -x;
										y := -y;
										z := -z
								 end;
					    cur := cur^.gg
					 end
		 
		 end;	
	
  {*************************************************************************}
	
	procedure purge_hidden; {(ob: objptr; erasetoo: boolean)}
	
	   { Assumes that something will survive. }
		 
		 var ln, t, p: lineptr;
		 
		 begin
				 
				 ln := ob^.line;
				 t := nil;
				 while ln <> nil do
						if ln^.for_real
								then begin
												ln^.show := true;
												t := ln;
												ln := ln^.next
										 end 
								else begin
												p := ln^.next;
												ln^.next := line_garb;
												line_garb := ln;
												if erasetoo and ln^.show
													 then begin
																	 SetPenShade(psWhite);
																	 MoveTo(ln^.abscoord[1], ln^.abscoord[2]);
																	 LineTo(ln^.abscoord[3], ln^.abscoord[4]);
																	 RestorePenShade
																end;
												if t = nil
													 then ob^.line := p
													 else t^.next := p;
												ln := p
										 end;
				 ob^.lasline := t;  { it just CAN'T be nil. }
				 
				 savescreen := true
										 
			end;
																								
	 {*************************************************************************}
 
	 procedure mindist(p1, p2: polygon_ptr; var x, y: coordptr);
	 
	    var min, d: longreal;
			    c1, c2: coordptr;
					i, j: longint;
		  
			procedure distance;
			   begin
				    with c1^ do
						   d := sqr(x-c2^.x) + sqr(y-c2^.y) + sqr(z-c2^.z)
				 end;
									
			begin
         min := 1e300;
				 c1 := p1^.cp;
				 for i := 1 to p1^.rank do
				    begin
						   c2 := p2^.cp;
							 for j := 1 to p2^.rank do
						      begin
							       distance;
									   if d < min
									      then begin
												        min := d;
																x := c1;
																y := c2
														 end;
										 c2 := c2^.cp
									end;
							 c1 := c1^.cp
						end
				 
      end;

	 {*************************************************************************}
	 
	 procedure crossprod(var first, second: evector; var ans: f_vector);
	 
	    begin
			
			   ans[1] := first[2]*second[3] - first[3]*second[2];
				 ans[2] := first[3]*second[1] - first[1]*second[3];
				 ans[3] := first[1]*second[2] - first[2]*second[1];
			
			end;

   {**************************************************************************}
	 
	 function f_absval(var e: f_vector): longreal;
			begin
				 f_absval := sqr(e[1]) + sqr(e[2]) + sqr(e[3])
			end;

	 {**************************************************************************}
	 
	 procedure set_normal; {(gp: polygon_ptr; reverse: integer)}
      
			var f, t, q, stash, qq: coordptr;
			    first, second: evector;
					norm: f_vector;
					i: integer;
					length: longreal;
      
			procedure getone;
			   begin
				    first[1] := f^.x - t^.x;
					  first[2] := f^.y - t^.y;
					  first[3] := f^.z - t^.z;
					  second[1] := q^.x - t^.x;
					  second[2] := q^.y - t^.y;
					  second[3] := q^.z - t^.z;
					  { counterclockwise produces up, right hand vector }
					  crossprod(second, first, norm);
					  length := sqrt(f_absval(norm))
				 end;			 
			 
			begin
			   if gp^.rank < 3
				    then begin
						        with gp^ do
										   begin
											    x := 0;  y := 0;  z := 0
											 end;
						        exit
						     end;
				 f := gp^.cp;
				 t := f^.cp;
				 q := t^.cp;
				 getone;
				 i := 1;
				 stash := nil;
				 if gp^.rank > 3
				    then while length < 1e-8 do
				            begin
						           i := i + 1;
											 if i > gp^.rank
											    then break;
											 if i = gp^.rank - 1
											    then begin
													        stash := q^.cp;
																	qq := q;
																	q^.cp := gp^.cp   { loop up }
															 end;
						           f := t;
											 t := q;
											 q := q^.cp;
											 getone
						        end;
						
				 if stash <> nil
				    then qq^.cp := stash;
				 if length > 0
				    then for i := 1 to 3 do
						        norm[i] := reverse*norm[i]/length;
										
				 with gp^ do
				    begin
						   x := norm[1];  y := norm[2];  z := norm[3]
						end
						
      end;

	 {**************************************************************************}
	 
	 procedure set_radius; {(this: polygon_ptr);}

	    var q: coordptr;
			    a, length: longreal;
					r: longint;
					norm: evector;
			
			begin
			
			   q := this^.cp;
				 length := 1.0e-300;
				 for r := 1 to this^.rank do
						begin
							 with this^ do
									begin
										 norm[1] := xcen;  norm[2] := ycen;  norm[3] := zcen
									end;
							 with q^ do
									begin
										 norm[1] := norm[1] - x;  
										 norm[2] := norm[2] - y; 
										 norm[3] := norm[3] - z
									end;
							 a := absval(norm);
							 if a > length
									then length := a;
							 q := q^.cp
						end;
				 this^.radius := sqrt(length)
				 
			end;
	 
   {**************************************************************************}
	 
	 function absval; {(var e: evector): longreal}
			begin
				 absval := sqr(e[1]) + sqr(e[2]) + sqr(e[3])
			end;

   {**************************************************************************}
	 
	 function dotprod; {(var e: evector; var f: f_vector): longreal}
			begin
				 dotprod := e[1]*f[1] + e[2]*f[2] + e[3]*f[3]
			end;

   {**************************************************************************}
	 
	 function flength; {(var e: f_vector; dim: integer): longreal;}
			{ dim >= 1 }
			var length: longreal;
			    i: integer;
			begin
				 length := sqr(e[1]);
				 for i := 2 to dim do
					  length := length + sqr(e[i]);
				 flength := sqrt(length)
			end;

   {**************************************************************************}
	 
	 procedure enormalize; {(var normal: evector)}
	    var length: longreal;
			    i: integer;
			begin
			   length := sqr(normal[1]);
				 for i := 2 to 3 do
					  length := length + sqr(normal[i]);
				 length := sqrt(length);
				 if length > 0
					  then for i := 1 to 3 do
									  normal[i] := normal[i]/length
		  end;
														 
   {*************************************************************************}
	 
	 procedure set_centroid(tp: polygon_ptr);
	    var i: integer;
			    sums: evector;
					cp: coordptr;
			begin
			   for i := 1 to 3 do 
				    sums[i] := 0;
				 cp := tp^.cp;
				 for i := 1 to tp^.rank do
						begin
							 with cp^ do
									begin
										 sums[1] := sums[1] + x;
										 sums[2] := sums[2] + y;
										 sums[3] := sums[3] + z
									end;
							 cp := cp^.cp
						end;
				 with tp^ do
						begin
							 xcen := sums[1]/rank;
							 ycen := sums[2]/rank;
							 zcen := sums[3]/rank
						end
			end;																				
																				
	 {***********************************************************************}

	 function determin(var a: twobytwo): longreal;
	 
	    begin
			   determin := a[1,1]*a[2,2] - a[1,2]*a[2,1]
			end;

   {***********************************************************************}

	 procedure do_bias; {(ob: objptr; x,y,z: longreal)}
	 
			begin			
			   with ob^ do
				    begin
						   bias[1] := x;  bias[2] := y;  bias[3] := z;
							 enormalize(bias)
						end;
				 sort_polygons(ob)
			end;

	 {***********************************************************************}
	 
	 procedure sort_polygons; {(ob: objptr);}
	 
	    { assume ob^.gons <> nil.  classification and merge. }
			
			var head: array[1..2] of polygon_ptr;
			    st: polygon_ptr;
					ref: evector;
					angle, length: longreal;
					i: integer;
					
			{_____________________________________________________________________}
			
			procedure passone;
			   var key: longreal;
				     cur, old: gonptrptr;
				 begin
				    { ob^.gons <> nil on entry }
						st := ob^.gons;
						with st^ do
							 dist := sqrt(sqr(ref[1]-xcen) + sqr(ref[2]-ycen) + sqr(ref[3]-zcen));
						head[1] := st;
						key := st^.dist;
						cur := @ st^.gg;
						old := @ head[2];
						st := st^.gg;
						while st <> nil do
						   with st^ do
								  begin
										 dist := sqrt(sqr(ref[1]-xcen) + sqr(ref[2]-ycen) + sqr(ref[3]-zcen));
										 if dist <= key
											  then cur^ := st
											  else begin
															  old^ := st;
															  old := cur
														 end;
										 cur := @ gg;
										 key := dist;
								     st := gg
							    end;
						old^ := nil
				 end;
				 
			{__________________________________________________________________}
			
			procedure classify;
			   var key: longreal;
				     cur, old: gonptrptr;
				 begin
						{ st points to list to classify; st is not nil }
						head[1] := st;
						key := st^.dist;
						cur := @ st^.gg;
						old := @ head[2];
						st := st^.gg;
						while st <> nil do
						   with st^ do
								  begin
										 if dist <= key
											  then cur^ := st
											  else begin
															  old^ := st;
															  old := cur
														 end;
										 cur := @ gg;
										 key := dist;
								     st := gg
							    end;
						old^ := nil
				 end;
				 
			{___________________________________________________________________}
			
			procedure merge;
			
			   var key: longreal;
				     cur: gonptrptr;
						 
				 {------------------------------------------------------------------}
				 
				 function case1(i: integer) : boolean;
				    { both head^.dist's <= the key, head[i] the larger, so take it. }
				    begin
						   cur^ := head[i];
							 key := head[i]^.dist;
						   cur := @ head[i]^.gg;
							 head[i] := head[i]^.gg;
							 if head[i] = nil
								  then begin
												  cur^ := head[3-i];
												  case1 := false
											 end
               else
                  case1 := true
						end;

				 {------------------------------------------------------------------}

				 function case2(i: integer) : boolean;
				    { take from head[i] as long as keys decrease. }
				    var local_key: longreal;
						begin
							 cur^ := head[i];
							 local_key := 1.0e300;
               case2 := true;
						   while head[1]^.dist <= local_key do
							    begin
									   local_key := head[i]^.dist;
										 cur := @ head[i]^.gg;
										 head[i] := head[i]^.gg;
										 if head[i] = nil
												then begin
																cur^ := head[3-i];
																case2 := false;
                                exit
														 end
									end;
							 key := 1.0e300
						end;

				 {-----------------------------------------------------------------}

				 begin  { of merge }

				    { neither head[1] nor head[2] is nil }
						cur := @ st;
						key := 1.0e300;  { infinity }

						while true do
						   { at start of loop, neither head[1] nor head[2] is nil }
							 if key >= head[1]^.dist
								  then if key >= head[2]^.dist
									        then if head[1]^.dist > head[2]^.dist
													        then begin
                                    if not case1(1) then exit
                                  end
																	else begin
                                    if not case1(2) then exit
                                  end
													else begin
                            if not case2(1) then exit
                          end
							 else if key >= head[2]^.dist
							    then begin
                    if not case2(2) then exit
                  end
									else if head[1]^.dist > head[2]^.dist
													then begin
                            if not case1(1) then exit
                          end
													else begin
                            if not case1(2) then exit
                          end

				 end;

			{___________________________________________________________________}

			begin  {of sort_polygons }

			   { compute ref, a large vector through the viewing angle. }
				 with ob^ do
				    length := 40*sqrt(sqr(xmin - xmax) + sqr(ymin - ymax) + sqr(zmin - zmax));

				 angle := ob^.sintheta/costheta;
				 { compute arcsin @@@}
				 if angle = 1
				    then angle := pii.float/2
				    else if angle = -1
				            then angle := -pii.float/2
				            else angle := arctan(angle/sqrt(1 - sqr(angle)));
				 ref[1] := length*Cos(angle)*costheta;
				 ref[2] := ref[1];
				 ref[3] := length*Sin(angle);
				
				 length := 3/4*length;
				 if ob^.solid
				    then for i := 1 to 3 do
						        ref[i] := ref[i] + length*ob^.bias[i];
						
				 { Now the actual sort }
				 head[2] := nil;
				 passone;  { a preliminary classify }				 
				 while head[2] <> nil do
				    begin
						   merge;
						   classify
						end;
										 		
				 ob^.gons := head[1];
				 st := head[1];
				 while st^.gg <> nil do
				    st := st^.gg;
						
				 ob^.lastgon := st
				 
			end;	 	 	 	 
	  
	 {*************************************************************************}

	 function num_intersects(cp: coordptr; gp: polygon_ptr): longint;

	    { Count the number of intersections of a test ray from cp^ through gp^.
			  The ray is constructed to go through one of the edges of gp^. }

			var c1: coordptr;
			    i: integer;
					hits: longint;
					fudge, det, u, t: longreal;
					p1, p2, sample: evector;
					sing_copy: boolean;
					coef, cons, alt: twobytwo;

			function singular: boolean;
			   var test: f_vector;
				     e1, e2: evector;
				     i: integer;
				 begin
			       for i := 1 to 3 do
						    e1[i] := p2[i] - p1[i];
						 with cp^ do
						    begin
								   e2[1] := x - sample[1];
									 e2[2] := y - sample[2];
									 e2[3] := z - sample[3]
								end;
						 crossprod(e1, e2, test);
						 sing_copy := (f_absval(test) < 1e-12);
						 singular := sing_copy
			   end;

			begin

				 { loop up gp }
				 c1 := gp^.cp;
				 for i := 2 to gp^.rank do
				    c1 := c1^.cp;
				 c1^.cp := gp^.cp;

				 { Create test ray from the given point (cp^) to approx the middle of
				   one of the edges of gp^. }
				 c1 := gp^.cp;
				 repeat
				    with c1^ do
							 begin
								  p1[1] := x; p1[2] := y; p1[3] := z;
								  p2[1] := cp^.x; p2[2] := cp^.y; p2[3] := cp^.z
							 end;
					  fudge := 1.776e-3 * random / 2 /halfblock;  {@@@}
						for i := 1 to 3 do
							 sample[i] := p1[i]*(0.5 - fudge) + p2[i]*(0.5 + fudge);
				    c1 := c1^.cp
				 until (not singular) or (c1 = gp^.cp);

				 if sing_copy
				    then begin
						        writeln(userOutput, ' *** Fermat error. Singlar polygons.');
										flush(userOutput);
										num_intersects := 0;
										exit
								 end;
						
				 { Assume that the test ray won't hit any vertex. }
				 hits := 1;  { by construction }
				 for i := 2 to gp^.rank do
				    begin
						   { Determine if test ray hits this edge. }
							 
							 { Use x and y coords.  This may fail, if the cut plane happens to
							   be on the x-y plane or y-z plane.  Then switch. }
							 with c1^ do
							    begin
									   coef[1,1] := x - cp^.x;    { note: this is c1^.cp }
										 coef[2,1] := y - cp^.y;
										 cons[1,1] := sample[1] - cp^.x;
										 cons[2,1] := sample[2] - cp^.y
									end;
				       with cp^ do
							    begin
									   coef[1,2] := sample[1] - x;
				             cons[1,2] := coef[1,2];
				             coef[2,2] := sample[2] - y;
									   cons[2,2] := coef[2,2]
									end;
							 det := determin(coef);
							 if abs(det) < 1e-4  
						      then begin
									        { Replace y coords with z. }
													with c1^ do
														 begin
															  coef[2,1] := z - cp^.z;
															  cons[2,1] := sample[3] - cp^.z
														 end;
									        with cp^ do
														 begin
															  coef[2,2] := sample[3] - z;
															  cons[2,2] := coef[2,2]
														 end;
													det := determin(coef);
                          if abs(det) < 1e-4  
															then begin
																			{ Replace x coords with y. }
																			with c1^ do
																				 begin
																						coef[1,1] := y - cp^.y;
																						cons[1,1] := sample[2] - cp^.y
																				 end;
																			with cp^ do
																				 begin
																						coef[1,2] := sample[2] - y;
																						cons[1,2] := coef[1,2]
																				 end;
																			det := determin(coef)
																	 end
									     end;
							 u := determin(cons)/det;

							 if (u > 0) and (u < 1)
							    then begin
									        { t must be < 1 to be a hit. }
													alt := coef;
													alt[1,2] := cons[1,1];
												  alt[2,2] := cons[2,1];
												  t := determin(alt)/det;
													if t < 1
													   then hits := hits + 1
                       end;
											 
							 c1 := c1^.cp
						end;
				 
			   num_intersects := hits
				 
			end;

	 {*************************************************************************}

	 function inside(p1, p2: polygon_ptr; var which: boolean): boolean;
			{ Is either of the polygons p1 and p2 inside the other? }
			begin
			   if odd(num_intersects(p1^.cp, p2))
				    then begin
						        inside := true;
										which := true
								 end
				 else if odd(num_intersects(p2^.cp, p1))
			           then begin
												 inside := true;
												 which := false
										  end
				 else inside := false
			
			end;

	 {*************************************************************************}

	 procedure splice(p1, p2: polygon_ptr; c1, c2: coordptr);
	 
	    { assume p2 is inside p1 }

			var cp: coordptr;
			    i: longint;
			
			begin
			
			   { loop up p2 }
				 cp := p2^.cp;
				 for i := 2 to p2^.rank do
				    cp := cp^.cp;
				 cp^.cp := p2^.cp;
				 
				 { splice }
				 cp := c1^.cp;
				 newpoint(c1^.cp);
				 c1^.cp^ := c2^;
				 newpoint(c2^.cp);
				 c2^.cp^ := c1^;
				 c2^.cp^.cp := cp;
				 
				 with p1^ do
				    begin
						   i := rank + p2^.rank + 2;
							 xcen := (rank*xcen + p2^.rank*p2^.xcen)/i;
							 ycen := (rank*ycen + p2^.rank*p2^.ycen)/i;
							 zcen := (rank*zcen + p2^.rank*p2^.zcen)/i;
				       rank := i
							 { old radius is still correct }
						end
				 
			   { p2^ can now be discarded }
					
			end; 
			
	{**************************************************************************}

	procedure dump_points_lines; {(var outf: text; ob: objptr)```}
	
	   var g: graphptr;
		     ln: lineptr;
				 stop, i, j: integer;
				 threed, lastone: boolean;
				 comma: char;

		 begin

				if ob = nil
				   then exit;
					 
				comma := ',';
				lastone := false;
				g := ob^.first;
				stop := graphsize;
				threed := ob^.threeD;
				write(outf, ' Points');
				if g <> nil
				   then writeln(outf, ' {');
				while g <> nil do
				   begin
					    if g = ob^.last
							   then begin
								         stop := ob^.final;
												 lastone := true
											end;
							j := 1;
							for i := 1 to stop do
							   begin
									  write(outf, chr(9), g^.locoord[j]:9:7, chr(9), g^.locoord[j+1]:9:7);
										if threed
										   then writeln(outf, chr(9), g^.locoord[j+2]:9:7)
											 else writeln(outf);
										write(outf, chr(9), g^.abscoord[2*i-1]:1, chr(9), g^.abscoord[2*i]:1);
										if wantcolor  { Feb 1998 }
										   then begin
							                 writeln(outf);
							                 write(outf, chr(9), '[ ');
							                 with g^ do  { Feb 1998 }
															 	  write(outf, colors[3*i-2]:1, chr(9), colors[3*i-1]:1, chr(9), 
															 	        colors[3*i]:1, ' ]')
													  end;
										if lastone
										   then if i = stop  { Feb 1998 }
											         then comma := ' ';
										writeln(outf, comma);
										j := j + 3
								 end;
					    g := g^.next
					 end;
					 
				if ob^.first <> nil
				   then write(outf, '        }'); 
				writeln(outf, ',');
				writeln(outf);
				write(outf, ' Lines');
				ln := ob^.line;
				if ln <> nil
				   then writeln(outf, ' {');
				comma := ',';
				while ln <> nil do
				   begin
							write(outf, chr(9), ln^.locoord[1]:9:7, chr(9), ln^.locoord[2]:9:7);
							if threed
								 then writeln(outf, chr(9), ln^.locoord[3]:9:7)
								 else writeln(outf);
							write(outf, chr(9), ln^.locoord[4]:9:7, chr(9), ln^.locoord[5]:9:7);
							if threed
								 then writeln(outf, chr(9), ln^.locoord[6]:9:7)
								 else writeln(outf);
							writeln(outf, chr(9), ln^.abscoord[1]:1, chr(9), ln^.abscoord[2]:1);
							write(outf, chr(9), ln^.abscoord[3]:1, chr(9), ln^.abscoord[4]:1);
							if wantcolor  { Feb 1998 }
							   then begin
				                 writeln(outf);
				                 write(outf, chr(9), '[ ');
				                 with ln^ do 
												 	  write(outf, rred:1, chr(9), ggreen:1, chr(9), bblue:1, ' ]')
										  end;
							ln := ln^.next;
							if ln = nil
							   then writeln(outf)
								 else writeln(outf, comma)
					 end;
				if ob^.line <> nil
				   then write(outf, '        }'); 
				writeln(outf, ',');
		 
		 end; 
		
	 {*************************************************************************}

	 procedure dumpolyg{var outf: text; gp: polygon_ptr}; { all new```}
	    var cp: coordptr;
					i: longint;
	    begin
	       with gp^ do
						writeln(outf, radius:9:7, chr(9), xcen:9:7, chr(9), ycen:9:7, chr(9), zcen:9:7,
						        chr(9), x:9:7, chr(9), y:9:7, chr(9), z:9:7);
				 if wantcolor  { Feb 1998 }
				    then begin
	                  write(outf, chr(9), '[ ');
	                  with gp^ do  
									 	   writeln(outf, rred:1, chr(9), ggreen:1, chr(9), bblue:1, ' ]')
							   end;
				 cp := gp^.cp;
				 writeln(outf, chr(9), '* ', gp^.rank:1);  { Feb 1998 }
				 for i := 1 to gp^.rank do
						begin
							 with cp^ do
									begin
									   writeln(outf, chr(9), x:9:7, chr(9), y:9:7, chr(9), z:9:7);
										 write(outf, chr(9), a:1, chr(9), b:1)
									end;
							 if i < gp^.rank
							    then writeln(outf);  {```}
							 cp := cp^.cp
						end
			end;									
									
	 {*************************************************************************}

	 procedure union_points; {(join, ob: objptr)}   {```}
	 
	    { Both join and ob have points. Put both point lists onto join's. }
	 
	    var i, j, newfinal: integer;
			    gp: graphptrptr;  
					
			begin
			
				 { Snip off the last node of join's list of point nodes -- i.e.,
					 join^.last. The 'next' ptr in the penultimate node of join (or  
					 maybe just join^.first) then points to the first node of ob's list. }
				 gp := @ join^.first;
				 while gp^ <> join^.last do
						gp := @ gp^^.next;
				 gp^ := ob^.first;
				 ob^.first := nil;  { probably not necessary }
				 { Now move all possible nodes from join^.last to ob^.last. }
				 newfinal := join^.final + ob^.final - graphsize;
				 if newfinal < 0
						then newfinal := 0;
				 j := ob^.final;
				 with ob^.last^ do
						for i := newfinal+1 to join^.final do
							 begin
									j := j + 1;
									abscoord[2*j-1] := join^.last^.abscoord[2*i-1];
									abscoord[2*j] := join^.last^.abscoord[2*i];
									locoord[3*j-2] := join^.last^.locoord[3*i-2];
									locoord[3*j-1] := join^.last^.locoord[3*i-1];
									locoord[3*j] := join^.last^.locoord[3*i]
							 end;
				 if newfinal = 0
						then begin
										join^.last^.next := graph_garb;
										graph_garb := join^.last;
										join^.last := ob^.last;
										join^.final := j
								 end
						else begin
										ob^.last^.next := join^.last;
										join^.final := newfinal
								 end;
				 ob^.last := nil  { probably not necessary }
				 
			end;
														
	 {**********************************************************************}
	 
	 procedure washobj; {(ob: objptr)}
	 
	    { Clean out duplicate vertices. }
			
			var gp, tail: polygon_ptr;
			    small: longreal;
					cp1, cp2, t: coordptr;
					e, f: evector;
					i, j, rank, cnt, tot, delcnt: longint;
					h: coordptrptr;
					delete: boolean;
			
			begin	
			
			   gp := ob^.gons;
				 tot := 0;
				 delcnt := 0;
				 delete := false;
				 while gp <> nil do
				    begin
						
						   small := sqr(gp^.radius/50);  { set heuristically }
							 cnt := 0;
							 cp1 := gp^.cp;
							 i := 2;
							 rank := gp^.rank;
							 while i <= rank do
							    begin
									   cp2 := cp1^.cp;
										 t := cp1;
										 with cp1^ do
										    begin
												   f[1] := x; f[2] := y; f[3] := z
												end;
										 j := i;
										 while j <= rank do
										    begin
												   with cp2^ do
													    begin
															   e[1] := x - f[1]; e[2] := y - f[2];
																 e[3] := z - f[3]
															end;
													 j := j + 1;
													 if absval(e) < small
													    then begin
															        t^.cp := cp2^.cp;
																			cp2^.cp := point_garb;
																			point_garb := cp2;
																			cp2 := t^.cp;
																			cnt := cnt + 1;
																			rank := rank - 1
																	 end
															else begin
															        t := cp2;
																			cp2 := cp2^.cp
																	 end
												end;
									   cp1 := cp1^.cp;
										 i := i + 1
									end;
									
							 if cnt > 0
							    then begin
									        tot := tot + cnt;
													gp^.rank := rank;
													if noisy
													   then writeln('   ', cnt:2, ' vertices deleted from a polygon; rank now ', rank:2);
													if rank < 3
													   then delete := true
													   else begin
														         set_centroid(gp);
																		 set_radius(gp);
																		 with gp^ do
																			  if (abs(x) < 1e-1) and (abs(y) < 1e-1) and (abs(z) < 1e-1)
																					 then set_normal(gp, 1) 
																  end
											 end;
							 
							 gp := gp^.gg
							 
						end;

				 gp := ob^.gons;
				 h := @ ob^.headvert;
				 tail := nil;
				 while gp <> nil do
						if gp^.rank < 3
							 then begin
											 if tail = nil
												  then ob^.gons := gp^.gg
												  else begin
																  tail^.gg := gp^.gg;
																  tail^.face := gp^.gg
															 end;
											 freegon(gp);
											 delcnt := delcnt + 1;
											 if tail = nil
												  then gp := ob^.gons
												  else gp := tail^.gg
									  end
							 else begin
											 cp1 := gp^.cp;
											 cp2 := cp1;
											 for i := 2 to gp^.rank do
													cp1 := cp1^.cp;
											 h^ := cp2;
											 h := @ cp1^.cp;
											 ob^.endvert := cp1;
											 if delete
											    then gp^.face := gp^.gg;
										   tail := gp;
											 gp := gp^.gg
										end;					 
				
				 if tail = nil
				    then writeln('*** Warning.  All polygons were degenerate and were discarded.')
						else begin
						        ob^.lastgon := tail;
										if delete
										   then tail^.face := ob^.gons
								 end;
								 
				 if noisy and (delcnt > 0)
				    then writeln(delcnt:2, ' polygons were deleted.  In addition,');
				 if noisy
				    then writeln(tot:2, ' vertices were deleted.')

			end;

	 {*************************************************************************}

	 function convex(tp: polygon_ptr): boolean;
	    var i, spot: longint;
			    max, value: longreal;
					cp: coordptr;
					this, next: evector;
					f: f_vector;
					known: boolean;
					current, standard: integer;

	    function signof(e: longreal): integer;
			   begin
				    if e > 1e-6             { a fudge }
						   then signof := 1
						else if e < -1e-6
						   then signof := -1
				    else signof := 0
				 end;

			begin

			   if tp^.rank < 3
				    then begin
						        convex := true;
										exit
								 end;
								 
				 { Find largest entry in normal vector. }
				 value := tp^.x;
				 max := abs(value);
				 spot := 1;
				 if abs(tp^.y) > max
				    then begin
						        spot := 2;
										value := tp^.y;
										max := abs(value)
								 end;
				 if abs(tp^.z) > max
				    then begin
						        spot := 3;
										value := tp^.z
								 end;
				 value := 1/value;
				 
				 { loop up }
				 cp := tp^.cp;
				 for i := 2 to tp^.rank do
				    cp := cp^.cp;
				 cp^.cp := tp^.cp;
				 				 
				 known := false;
				 cp := tp^.cp;
				 with cp^ do
				    begin
						   next[1] := cp^.x - x;
							 next[2] := cp^.y - y;
							 next[3] := cp^.z - z;
						end;
				 for i := 1 to tp^.rank do
				    begin
						   this := next;
							 cp := cp^.cp;
							 with cp^ do
									begin
										 next[1] := cp^.x - x;
										 next[2] := cp^.y - y;
										 next[3] := cp^.z - z;
									end;
			         crossprod(this, next, f);
							 current := signof(f[spot]*value);
							 if known
							    then if current <> 0
									        then if standard <> current
													        then begin
																	        convex := false;
																					exit
																			 end
																	else
													else
									else if current <> 0
									        then begin
													        standard := current;
																	known := true
															 end
			      end;

				 convex := true  { even if known is still false, a degenerate case }

			end;

	 {*************************************************************************}

	 procedure clean_degenerates(var tp, tail: polygon_ptr);
	 
	    {   tp^ is a polygon that is "really" two or more pieces joined by degenerate 
			  line segments.  tp^.gg is nil.  tp^ is scanned and pieces may be sliced 
				off and appended to the	gg pointer, with face also being linked.
				Each new piece is similarly	scanned. 
				  This procedure is called by divider when it cuts a non-convex polygon. }			
						
			var cur: polygon_ptr;
			    value: longreal;
					spot: integer;
			
			{____________________________________________________________________}
			
			function inside(c1, c2: coordptr): boolean;
			   { Two edges are colinear.  Determine if either is inside the
				   other.  }
				 var t, u: longreal;
				 begin
				    with c2^ do
						   case spot of
							    1: t := x - c1^.x;
									2: t := y - c1^.y;
									3: t := z - c1^.z;
							 end;
						t := t/value;
						with c2^ do
						   case spot of
							    1: u := cp^.x - c1^.x;
									2: u := cp^.y - c1^.y;
									3: u := cp^.z - c1^.z;
							 end;
						u := u/value;
						if (t <= 0) and (u <= 0)
						   then inside := false
							 else if (t >= 1) and (u >= 1)
											 then inside := false
											 else inside := true
				 end;
				 
			{____________________________________________________________________}
			
			procedure set_value_spot(c1: coordptr);
			   var max: longreal;
				     i: integer;
						 e: evector;
				 begin
				    with c1^ do
						   begin
							    e[1] := cp^.x - x;
									e[2] := cp^.y - y;
									e[3] := cp^.z - z
							 end;
						value := e[1];
					  max := abs(value);
					  spot := 1;
						for i := 2 to 3 do
						   if abs(e[i]) > max
							    then begin
									        value := e[i];
													max := abs(value);
													spot := i
											 end
				 end;

			{____________________________________________________________________}
			
			procedure set_all(tp: polygon_ptr);
			   begin
				    set_centroid(tp);
						set_radius(tp)
				 end;

			{____________________________________________________________________}

			procedure check_one(tp: polygon_ptr);

			   label 909;

				 var c1, c2, initial: coordptr;
			       found: boolean;
					   i: longint;
						 pg: polygon_ptr;

				 function get_next_c1 : boolean;
				    begin
               get_next_c1 := false;
						   repeat
									repeat
										c1 := c1^.cp;
									until c1^.bdy;
									if c1 = initial
										 then begin
										         exit;
													end;
									if c1^.cp^.bdy
										 then break
							 until false;
               get_next_c1 := true
						end;

				 begin
			       { loop up and find first boundary point, c1. }
						 c2 := tp^.cp;
						 found := false;
						 for i := 2 to tp^.rank do
								begin
									 if not found
											then if c2^.bdy
															then begin
																		 c1 := c2;
																		 found := true
																	 end;
									 c2 := c2^.cp
								end;

						 c2^.cp := tp^.cp;
						 if not found  { theoretically impossible - must exist and be paired }
								then begin
								        writeln(userOutput, '*** Fermat error.  No bdy points found.');
												flush(userOutput);
                        raise Exception.Create('*** Fermat error.  No bdy points found.');
										 end;

						 initial := c1;
						 if not c1^.cp^.bdy
								then begin
                  if not get_next_c1 then exit;
                end;
						 initial := c1;
						 set_value_spot(c1);
						 while true do
								begin
									 c2 := c1^.cp;
									 while true do
									    { Find all bdy edges below c1^ and check them for
											  inside/outside with c1^. }
									    begin
											   { get next candidate }
												 repeat
														repeat
															c2 := c2^.cp;
														until c2^.bdy;
														if c2 = initial 
															 then goto 909;  { get a new c1 }
														if c2^.cp^.bdy
															 then break
												 until false;
												 { check candidate against c1^ }
												 if inside(c1, c2)
														then begin  { split off, then continue }
														        pg := tp^.gg;
																		newgon(tp^.gg);
																		tp^.gg^.gg := pg;
																		pg := tp^.gg;
																		{ can't do face now }
																		pg^.cp := c1^.cp;
																		c1^.cp := c2^.cp;
																		c2^.cp := nil;
																		c2 := pg^.cp;
																		pg^.trash := true;
																		tp^.trash := true;
																		i := 0;
																		while c2 <> nil do
																		   begin
																			    c2 := c2^.cp;
																					i := i + 1
																			 end;
														        with tp^ do
																		   rank := rank - i;
																		with pg^ do
																		   begin
																			    rank := i;
																			    x := tp^.x;
																					y := tp^.y;
																					z := tp^.z
																			 end;
																		c2 := c1
																 end
									    end;
									 909:;
									 
									 if not get_next_c1 then exit;
									 set_value_spot(c1)
								end
			
			   end;
			
			{____________________________________________________________________}
			
			begin
			   
				 tail := tp;  { failsafe in case of early termination }

				 tp^.trash := false; { Will use trash to indicate that a polygon has lost
				                       some vertices. true = lost some.  Expect no conflict
															 with original use of trash in procedure solid. }
				 cur := tp;
				 while cur <> nil do
				    begin
						   check_one(cur);
							 if cur^.trash
							    then set_all(cur);
							 cur := cur^.gg
						end;
						
				 tail := nil;
				 cur := tp;
				 while cur <> nil do
				    if cur^.rank < 3
								then if tail = nil
												then begin
																tp := cur^.gg;
																freegon(cur);
																cur := tp
														 end
												else begin
																tail^.gg := cur^.gg;
																tail^.face := cur^.gg;
																freegon(cur);
																cur := tail^.gg
														 end
							 else begin
											 if tail <> nil
													then tail^.face := cur;
											 tail := cur;
											 cur := cur^.gg
										end;

				 if tail = nil
				    then tail := tp
						
			end;	 
	 
	 {**********************************************************************}
	 
	 procedure build_group(var gons, last: grouptr; facts: factptr; tp: polygon_ptr);
	 
	    var ft: factptr;
			
			{___________________________________________________________________}
			
			procedure attach_new_node;
			   begin
				    if gons = nil
						   then begin
							         newgroup(gons);
											 last := gons
										end
							 else begin
							         newgroup(last^.next);
											 last := last^.next
										end				 
				 end;

			{____________________________________________________________________}

			procedure set_sub(gp: grouptr);

			   var ft: factptr;
				     t: grouptr;

				 {------------------------------------------------------------------}

				 procedure attach_gp_node;
				    begin
						    if gp^.sub = nil
									 then begin
													 newgroup(gp^.sub);
													 t := gp^.sub
												end
									 else begin
													 newgroup(t^.next);
													 t := t^.next
												end
						end;

				 {------------------------------------------------------------------}

				 function unused_mate(ft: factptr): boolean;
				    var f: factptr;
						    this: polygon_ptr;
				    begin
						   f := facts;
							 this := ft^.sec;
							 while f <> nil do
							    begin
									   if f <> ft
										    then if f^.fresh and (this = f^.sec)
												        then begin
																        unused_mate := false;
																				exit
																		 end;
									   f := f^.next
									end;
						   unused_mate := true
						end;

				 {------------------------------------------------------------------}

				 begin

				    ft := facts;
						gp^.sub := nil;
						while ft <> nil do
						   begin
							    if ft^.first = gp^.gon
									   then if unused_mate(ft)
										         then begin
														         attach_gp_node;
																		 t^.gon := ft^.sec;
																		 ft^.fresh := false
																	end
														 else ft^.fresh := false;
									ft := ft^.next
							 end;
						if gp^.sub = nil
						   then exit;
						t^.next := nil;
						t := gp^.sub;
						while t <> nil do
						   begin
							    set_sub(t);
									t := t^.next
							 end
				 
				 end;

			{___________________________________________________________________}
				 
			begin { of build_group }
						   
				 gons := nil;
				 while tp <> nil do
				    begin
						   { Find next polygon of maximal status -- not inside anything else. }
							 while tp <> nil do
									begin
										 ft := facts;
										 while ft <> nil do
												begin
													 if ft^.sec = tp
															then break;
													 ft := ft^.next
												end;
										 if ft = nil
												then break;
										 tp := tp^.gg
									end;
							 
							 if tp = nil
									then break;
									
							 attach_new_node;
							 last^.gon := tp;
							 set_sub(last);
							 tp := tp^.gg
						end;
						
				 if gons = nil
				    then begin
									  writeln(userOutput, '*** Fermat error.  No maximal polygon.');
									  flush(userOutput)
							   end
					  else last^.next := nil;
					 
				 ft := facts;
				 while ft^.next <> nil do
				    ft := ft^.next;
				 ft^.next := fact_garb;
				 fact_garb := facts
			
			end;

	 {*************************************************************************}
	 
	 procedure trans_form; {(alpha: workptr; dim: longint; ob: objptr)}
	 
	    { No erasing or showing; just recompute coords. }
	 
	    var i, stop, j: longint;
				  g1: graphptr;
				  ln1: lineptr;
					gp: polygon_ptr;
					cp: coordptr;
					tst: evector;
					xfact, yfact, zfact, xsine, ysine: longreal;
					x_min, x_max, y_min, y_max, z_min, z_max: longreal;
					
	    {_______________________________________________________________________}

			procedure get_rs(x, y, z: longreal; var r, s: integer);  { bug, Jan 1998 }
					begin
						  if dim = 3
								 then begin
												 r := round(yfact*y - xfact*x); 
												 s := - round(zfact*z - xsine*x - ysine*y)
											end
								 else with ob^ do
												 begin
														r := round(xscale*x);
														s := - round(yscale*y);
												 end
					end;
			 					
			{_______________________________________________________________________}

			function sumup(i: longint): longreal;
			   var sum: longreal;
				     k, spot: longint;
				 begin
				    sum := alpha^[i]^.ncoef^.float * tst[1];
					  for k := 1 to dim - 1 do
							 begin
								  spot := i + dim * k;
								  sum := sum + alpha^[spot]^.ncoef^.float * tst[k+1];
							 end;
						sumup := sum
				 end;
									
			{______________________________________________________________________}
			
			begin
			
				 if ob = nil
				    then exit;
						
				 if dim = 3
				    then with ob^ do
								    begin
										   yfact := yscale*costheta;
											 xfact := xscale*costheta;
											 zfact := zscale*z_cosine;
											 xsine := xscale*sintheta;
											 ysine := yscale*sintheta
										end;
										
				 x_min := 1.0e300;
				 y_min := 1.0e300;
				 z_min := 1.0e300;
				 x_max := -1.0e300;
				 y_max := -1.0e300;
				 z_max := -1.0e300;
				 g1 := ob^.first;
				 stop := graphsize;
				 
				 j := 1;
				 while g1 <> nil do
						begin
								if g1 = ob^.last
									 then stop := ob^.final;
								while true do
									 begin
											for i := 1 to dim do
												 tst[i] := g1^.locoord[3*j - 3 + i];
											for i := 0 to dim - 1 do
												 g1^.locoord[3*j - 2 + i] := sumup(i);
											with g1^ do
											   get_rs(locoord[3*j - 2], locoord[3*j - 1], locoord[3*j],
											          abscoord[2*j - 1], abscoord[2*j]);
											j := j + 1;
											if j > stop
												 then begin
																 g1 := g1^.next;
																 j := 1;
																 break
															end
									 end
						 end; 
																					 
					if ob^.quads <> nil  { Remove segments that aren't for real. }
						 then purge_hidden(ob, false);
								
					ln1 := ob^.line;
					while ln1 <> nil do
						 begin 
						    for i := 1 to dim do
									 tst[i] := ln1^.locoord[i];
								for i := 0 to dim - 1 do
									 ln1^.locoord[i+1] := sumup(i);
								with ln1^ do
									 get_rs(locoord[1], locoord[2], locoord[3],
													abscoord[1], abscoord[2]);
							  for i := 1 to dim do
									 tst[i] := ln1^.locoord[i+3];
								for i := 0 to dim - 1 do
									 ln1^.locoord[i+4] := sumup(i);
								with ln1^ do
									 get_rs(locoord[4], locoord[5], locoord[6],
													abscoord[3], abscoord[4]);
								ln1 := ln1^.next
						 end;

				 if (ob^.quads <> nil)
				    then if not ob^.shaded
									  then begin
						                compute_hidden_lines(ob, false);
									          exit
								         end;
																
				 gp := ob^.gons;
				 while gp <> nil do
				    begin
						   cp := gp^.cp;
						   for j := 1 to gp^.rank do
							    begin
									   tst[1] := cp^.x;
										 tst[2] := cp^.y;
										 tst[3] := cp^.z;
										 for i := 0 to dim - 1 do
											  case i of
														0: cp^.x := sumup(i);
														1: cp^.y := sumup(i);
														2: cp^.z := sumup(i)
												end;
										 with cp^ do
									      get_rs(x, y, z, a, b);
									   cp := cp^.cp
									end;
							 set_normal(gp, 1);
							 set_centroid(gp);
							 set_radius(gp);
							 with gp^ do
									begin
									   if xcen + radius > x_max
										    then x_max := xcen + radius;
										 if ycen + radius > y_max
										    then y_max := ycen + radius;
									   if zcen + radius > z_max
												then z_max := zcen + radius;
									   if xcen - radius < x_min
												then x_min := xcen - radius;
									   if ycen - radius < y_min
												then y_min := ycen - radius;
										 if zcen - radius < z_min
												then z_min := zcen - radius
									end;
						   gp := gp^.gg
						end;

				 if ob^.threeD
				    then begin
						        tst := ob^.bias;
									  for i := 0 to dim - 1 do
											 ob^.bias[i+1] := sumup(i);
									  enormalize(ob^.bias)
								 end;
								 
				 if ob^.gons <> nil
				    then with ob^ do
										begin
										   xmin := x_min;
										   ymin := y_min;
											 zmin := z_min;
										   xmax := x_max;
											 ymax := y_max;
										   zmax := z_max
										end;									 
				 
				 if ob^.shaded and (ob^.gons <> nil)
				    then sort_polygons(ob)
			
			end;
	 
	 {*************************************************************************}
	 
	 procedure unwind_group(gons, last: grouptr; var hd: polygon_ptr);

      var gp, t, copy: grouptr;
			    c1, c2: coordptr;
			
			begin
			
			   copy := gons;
				 while gons <> nil do
				    begin
						   gp := gons^.sub;
							 while gp <> nil do
							    begin
											if gp^.sub <> nil
												 then begin
																 last^.next := gp^.sub;
																 while last^.next <> nil do
																		last := last^.next
															end;
											mindist(gons^.gon, gp^.gon, c1, c2);
									    splice(gons^.gon, gp^.gon, c1, c2);
											gp^.gon^.gg := gon_garb;
											gon_garb := gp^.gon;
											t := gp^.next;
											gp^.next := group_garb;
											group_garb := gp;
											gp := t
									end;
						   gons := gons^.next
						end;
						
				 gons := copy;
				 hd := gons^.gon;
				 while gons <> last do
				    begin
						   gons^.gon^.gg := gons^.next^.gon;
							 gons := gons^.next
						end;
				 last^.gon^.gg := nil;
				 last^.next := group_garb;
				 group_garb := copy
			
			end;

	 {*************************************************************************}
	 
	 procedure f_crossprod(var first: evector; var second, ans: f_vector);
	 
	    begin
			
			   ans[1] := first[2]*second[3] - first[3]*second[2];
				 ans[2] := first[3]*second[1] - first[1]*second[3];
				 ans[3] := first[1]*second[2] - first[2]*second[1];
			
			end;

	 {*************************************************************************}

	 procedure single_cut; {(var ob: objptr; dim: integer; a: f_vector; length: longreal; 
	                         testside: boolean; var killed: boolean; 
													 shouldsort: boolean)}
	
	    var stop, j2, j1, k: integer;
			    i: longint;
				  g1, g2: graphptr;
				  ln1, ln2: lineptr;
					eg1: edgeptr;
					tst: evector;
					cur: polygon_ptr;
					cp, cl, nxt: coordptr;
					h: coordptrptr;
					epsilon, xfact, yfact, zfact, xsine, ysine: longreal;
					dummy: boolean;
					
      {______________________________________________________________________}
			
			function on_right_side(shouldnt_be: boolean; a: f_vector; testside: boolean;
			                       var equals: boolean): boolean;

		     var i: integer;
				     localtest: boolean;
						 test: longreal;
		 
		     begin
				
				    test := 0;
					  for i := 1 to dim do
					     test := test + a[i]*tst[i];
					  localtest := (test < a[dim+1]);
					  equals := (test = a[dim+1]);
						if equals and shouldnt_be
							 then begin
											 writeln(userOutput, '*** Fermat error.  Point-on-plane type 1 degeneracy.');
											 flush(userOutput)
									  end;
					  on_right_side := (localtest = testside) or equals

				 end;

			{________________________________________________________________________}

			procedure get_rs(x, y, z: longreal; var r, s: integer);
				 begin
						 if ob^.threeD
								then begin
												r := round(yfact*y - xfact*x); 
						            s := - round(zfact*z - xsine*x - ysine*y)
										 end
								else with ob^ do
												begin
													 r := round(xscale*x);
													 s := - round(yscale*y);
												end
				 end;
					 
		 {_______________________________________________________________________}
		 
		 function cuts_through(var k: integer; solid: boolean; var allgood: boolean;
		                       a: f_vector; testside: boolean): boolean;
		 
		    { works for polygon edges. }
		    
				var pt1side, pt2side, pt1eqs, pt2eqs: boolean;
				    test1, test2, t: longreal;
						newpt: evector;
						i: integer;
		 
        begin
				 
				   test1 := 0;
					 for i := 1 to dim do
					    test1 := test1 + a[i]*eg1^.locoord[i];
					 pt1side := (test1 < a[dim+1]);
					 pt1eqs := (test1 = a[dim+1]);
					 if solid and pt1eqs
					    then begin
							        { a[dim+1] := a[dim+1]*(1 + 1.0e-9); }
	                    writeln(userOutput, '*** Fermat error.  Point-on-plane type 2 degeneracy.');
					            flush(userOutput);
											pt1eqs := false
									 end;
					 pt1side := (pt1side = testside) or pt1eqs;
					 test2 := 0;
					 for i := 1 to dim do
					    test2 := test2 + a[i]*eg1^.locoord[i+3];
					 pt2side := (test2 < a[dim+1]);
					 pt2eqs := (test2 = a[dim+1]);
					 if solid and pt2eqs
					    then begin
							       {  a[dim+1] := a[dim+1]*(1 + 1.234e-9); }
	                    writeln(userOutput, '*** Fermat error.  Point-on-plane type 3 degeneracy.');
					            flush(userOutput);
											pt2eqs := false
									 end;
					 pt2side := (pt2side = testside) or pt2eqs;
					 					 
					 if pt1side and pt2side
					    then begin
							        cuts_through := false;
											exit
									 end;
									 
					 allgood := false;
				   if pt1eqs or pt2eqs
					    then cuts_through := false
					 else if pt1side or pt2side  { on opposite sides }
					    then with eg1^ do
							        begin
												cuts_through := true;
												t := (a[dim+1] - test2)/(test1 - test2);
												newpt[3] := 0;
												for i := 1 to dim do
													 newpt[i] := (1-t)*locoord[i+3] + t*locoord[i];
												for i := 1 to 3 do
													 if pt1side
															then locoord[i+3] := newpt[i]
															else locoord[i] := newpt[i];
												if pt1side
													 then k := 2
													 else k := 0;
												get_rs(newpt[1], newpt[2], newpt[3], abscoord[k+1], abscoord[k+2])
										  end
					 else cuts_through := false
							
				end;
				
		 {_______________________________________________________________________}
		 
		 function line_hits_right_side: boolean;
		 
		    { works for ordinary lines }
		    
				var pt1side, pt2side, pt1eqs, pt2eqs: boolean;
				    test1, test2, t: longreal;
						newpt: evector;
						i, k: integer;
		 
        begin
				 
				   test1 := 0;
					 for i := 1 to dim do
					    test1 := test1 + a[i]*ln1^.locoord[i];
					 pt1side := (test1 < a[dim+1]);
					 pt1eqs := (test1 = a[dim+1]);
					 pt1side := (pt1side = testside) or pt1eqs;
					 test2 := 0;
					 for i := 1 to dim do
					    test2 := test2 + a[i]*ln1^.locoord[i+3];
					 pt2side := (test2 < a[dim+1]);
					 pt2eqs := (test2 = a[dim+1]);
					 pt2side := (pt2side = testside) or pt2eqs;
					 					 
				   if pt1side and pt2side
					    then line_hits_right_side := true
					 else if pt1eqs or pt2eqs
					    then line_hits_right_side := false
					 else if pt1side or pt2side  { on opposite sides }
					    then with ln1^ do
							        begin
												line_hits_right_side := true;
												t := (a[dim+1] - test2)/(test1 - test2);
												newpt[3] := 0;
												for i := 1 to dim do
													 newpt[i] := (1-t)*locoord[i+3] + t*locoord[i];
												for i := 1 to 3 do
													 if pt1side
															then locoord[i+3] := newpt[i]
															else locoord[i] := newpt[i];
												if pt1side
													 then k := 2
													 else k := 0;
												get_rs(newpt[1], newpt[2], newpt[3], abscoord[k+1], abscoord[k+2])
										  end
					 else line_hits_right_side := false
							
				end;
				
		{_______________________________________________________________________}
		
		procedure cut_polys(var obgon, tail: polygon_ptr; var a: f_vector; testside: boolean);
		
		   var cur: polygon_ptr;
			     cp, cl, nxt: coordptr;
					 found, lostsome, allgood: boolean;
					 i: longint;
			 
			 begin
			 
			    tail := nil;    { trails behind cur }
					cur := obgon;
					while cur <> nil do
						 begin
								cp := cur^.cp;
								
								{ Search for a point that is on the correct side (or on the cut plane). }
								found := false;
								for i := 1 to cur^.rank do
									 begin
											tst[1] := cp^.x;
											tst[2] := cp^.y;
											tst[3] := cp^.z;
											cp^.keep := on_right_side(false, a, testside, cp^.bdy);
											if not found and cp^.keep
												 then begin
																 cl := cp;  { cl marks this good node }
																 found := true
															end;
											if i < cur^.rank
												 then cp := cp^.cp
									 end;
									 
                if found  
									 then begin
													 tail := cur;
													 cur := cur^.gg;
													 
													 if tail^.rank = 1
															then continue;

                           cp^.cp := tail^.cp;  { make coord list circular }
													 cp := cl;
													 { first pass.  Compute all intersection points. }
													 allgood := true;
													 repeat
															nxt := cp^.cp;
															with eg1^ do
																 begin
																		abscoord[1] := cp^.a;
																		abscoord[2] := cp^.b;
																		abscoord[3] := nxt^.a;
																		abscoord[4] := nxt^.b;
																		locoord[1] := cp^.x;
																		locoord[2] := cp^.y;
																		locoord[3] := cp^.z;
																		locoord[4] := nxt^.x;
																		locoord[5] := nxt^.y;
																		locoord[6] := nxt^.z
																 end;
															if cuts_through(k, false, allgood, a, testside)
																 then begin   { insert new vertex on the cut plane }
																				 newpoint(cp^.cp);
																				 cp := cp^.cp;
																				 cp^.keep := true;
																				 cp^.bdy := true;
																				 cp^.cp := nxt;
																				 tail^.rank := tail^.rank + 1;
																				 with eg1^ do
																						begin
																							 cp^.a := abscoord[k+1];
																							 cp^.b := abscoord[k+2];
																							 cp^.x := locoord[3*k div 2 + 1];
																							 cp^.y := locoord[3*k div 2 + 2];
																							 cp^.z := locoord[3*k div 2 + 3]
																						end
																			end;
															cp := nxt
													 until cp = cl;
													 
													 if allgood
															then continue;
															
													 { Pass 2.  Remove all points on the bad side. }
													 cp := tail^.cp;
													 cl := nil;
													 lostsome := false;
													 for i := 1 to tail^.rank do
															if cp^.keep
																	then begin
																					cl := cp;
																					cp := cp^.cp
																			 end
																	else if cl = nil
																					then begin
																					        lostsome := true;
																									tail^.rank := tail^.rank - 1;
																									tail^.cp := cp^.cp;
																									cp^.cp := point_garb;
																									point_garb := cp;
																									cp := tail^.cp
																							 end
																					else begin
																					        lostsome := true;
																									tail^.rank := tail^.rank - 1;
																									cl^.cp := cp^.cp;
																									cp^.cp := point_garb;
																									point_garb := cp;
																									cp := cl^.cp
																							 end;
															
													if lostsome  { recompute centroid }
														 then begin
																		 set_centroid(tail);
																		 set_radius(tail)
																	end;
																				
												   { There seems to be no need to recompute xmin, xmax, etc. }
													 if tail^.rank < 3
															then with tail^ do
																			begin
																				 x := 0; y := 0; z := 0
																			end

												end
									 else begin  { discard this entire polygon }
													 cp^.cp := point_garb;
													 point_garb := cur^.cp;
													 if tail = nil  { it's the first polygon }
															then begin  
																			obgon := cur^.gg;
																			cur^.gg := gon_garb;
																			gon_garb := cur;
																			cur := obgon
																	 end
															else begin
																			tail^.gg := cur^.gg;
																			cur^.gg := gon_garb;
																			gon_garb := cur;
																			cur := tail^.gg
																	 end
												end
						 
						 end

				end;

		{_______________________________________________________________________}
		 		 		 				 
		procedure hollow;
		
		   var i: longint;
			 
			 begin
			 					
					if ob^.gons = nil
						 then eg1 := nil
						 else newedge(eg1);
					cut_polys(ob^.gons, ob^.lastgon, a, testside);
					
					{ set headvert and endvert }
					cur := ob^.gons;
					h := @ ob^.headvert;
					cp := nil;
					while cur <> nil do
						 begin
								cp := cur^.cp;
								h^ := cp;
								for i := 2 to cur^.rank do
									 cp := cp^.cp;
								h := @ cp^.cp;
								cur := cur^.gg
						 end;
					ob^.endvert := cp
			 
			 end;
			 
		{__________________________________________________________________________}
		 		 		 				 
		procedure divider(var tp, vp: polygon_ptr; av_radius: longreal);
		
		   { MUST HAVE tp^.gg = nil on entry. }
			 
			 var a1, c1: evector;
			     norm1, norm2: f_vector;
					 fv: fvptr;

			 {-----------------------------------------------------------------------}

			 procedure subdivide(var tp, vp: polygon_ptr; nm: fvptr; flag, convex: boolean);

					 { on input, tp points to a single polygon to be cut up.  At end, vp points
					   to the last gon in the chain.  nm^ is either norm1 or norm2; flag tells
						 which. }

					 var b1: evector;
							 tcopy, tail1, tail2: polygon_ptr;
							 s1, s2: coordptr;
							 i: longint;

					 begin

							with tp^ do
								 begin
										b1[1] := xcen; b1[2] := ycen; b1[3] := zcen
								 end;
							nm^[4] := dotprod(b1, nm^);

							{ Duplicate tp^ }
							newgon(tcopy);
							tcopy^ := tp^;
							newpoint(tcopy^.cp);
							s2 := tcopy^.cp;
							s1 := tp^.cp;
							s2^ := s1^;
							for i := 2 to tp^.rank do
								 begin
										newpoint(s2^.cp);
										s2 := s2^.cp;
										s1 := s1^.cp;
										s2^ := s1^
								 end;

							{ Cut tp^ with norm. }
							cut_polys(tp, tail1, nm^, false);
							if tp = nil  { SUPPOSED to be impossible }
							   then begin
								         tp := tcopy;
												 vp := tp;
												 tp^.rank := - tp^.rank;
												 exit
											end;

							if convex
							   then tail1 := tp
								 else clean_degenerates(tp, tail1);

							cut_polys(tcopy, tail2, nm^, true);
							if tcopy = nil  { SUPPOSED to be impossible }
							   then begin
								         vp := tail1;
												 tp^.rank := - tp^.rank;
												 exit
											end;
								
							if convex
							   then tail2 := tcopy
								 else clean_degenerates(tcopy, tail2);
							
							{ Link together }
							tail1^.gg := tcopy;
							tail1^.face := tcopy;
											
							{ Check each new polygon, subdividing if necessary. }
							if flag 
								 then nm := @ norm2
								 else nm := @ norm1;
							tail1 := tp^.gg;
							tp^.gg := nil;
							if tp^.radius <= 1.4*av_radius
							   then begin
												 vp := tp;
												 tp^.rank := - tp^.rank
										  end
									else subdivide(tp, vp, nm, not flag, convex);
							 vp^.gg := tail1;
							 vp^.face := tail1;
							 while tail1 <> nil do
									begin
										 tail2 := tail1^.gg;
										 tail1^.gg := nil;
										 if tail1^.radius <= 1.4*av_radius
											  then begin
															  vp := tail1;
															  tail1^.rank := - tail1^.rank
														 end
												else subdivide(tail1, vp, nm, not flag, convex);
										 vp^.gg := tail2;
										 vp^.face := tail2;
										 tail1 := tail2
									end
					 
					 end;
					 
			 {------------------------------------------------------------------------}

       begin
			 
			    { Select two appropriate orthogonal vectors.  Try standard k first.
					  Use these alternately to cut the polygon until it's small enough. }
					a1[1] := 0;  a1[2] := 0;  a1[3] := 1;
					with tp^ do
					   begin
						    c1[1] := x; c1[2] := y; c1[3] := z
						 end;
					crossprod(a1, c1, norm1);
					if f_absval(norm1) < 1e-1
					   then begin
						         a1[1] := 1;    
									   a1[3] := 0;
										 crossprod(a1, c1, norm1)
									end;
					f_crossprod(c1, norm1, norm2);
					{ fourth components set by subdivide. }
									
					fv := @ norm1;
					subdivide(tp, vp, fv, true, convex(tp))
			 
			 end;

		{_______________________________________________________________________}
		 		 		 				 
		procedure solid(myepsilon: longreal);
		
		   { The point is to compute the polygon created by the intersection of
			   the cut plane and the object.  Intriguingly, the intersection may be
				 not connected or not simply connected.  In that case, the boundary of
				 the intersection is a collection of circles (better, simple closed curves)
				 that may be nested, reminiscent of the nesting of parentheses in the 
				 parentheses language.}
			 
			 label 123;
			 
			 var i, thisrank, number_left: longint;
			     found, sometrash, addedsome, lostsome, allgood: boolean;
					 anchor, start, tp, newpolys: polygon_ptr;
					 hp: gonptrptr;
					 count, polycnt: integer;
					 sums: evector;
					 na: f_vector;
					 sign, sum_radii, av_radius: longreal;
					 newedges, tail, initial: edgeptr;
			 
			 {---------------------------------------------------------------------}
			 
			 function distance(k: integer): longreal;
			    var length: longreal;
					begin
					   k := 3*k;
						 with tail^ do
						    begin
								   length := sqr(cp^.x - locoord[k + 1]);
									 length := length + sqr(cp^.y - locoord[k + 2]);
									 distance := length + sqr(cp^.z - locoord[k + 3])
								end
					end;
					
			 {--------------------------------------------------------------------}
			 
			 procedure check_for_new;
			    begin
					   if count = 1
								then begin
												newedge(newedges);
												tail := newedges
										 end
								else if odd(count)  
												then begin
																newedge(tail^.next);
																tail := tail^.next
														 end
				  end;
			 
			 {---------------------------------------------------------------------}
 			 
			 procedure add_node;
			    { Changes cp, sums. Uses tail^, k }
					var j: integer;
			    begin
					   newpoint(cp^.cp);
						 cp := cp^.cp;
						 with tail^ do
								begin
									 cp^.a := abscoord[2*k+1];
									 cp^.b := abscoord[2*k+2];
									 cp^.x := locoord[3*k + 1];
									 cp^.y := locoord[3*k + 2];
									 cp^.z := locoord[3*k + 3]
								end;
						 with tail^ do
								for j := 1 to 3 do
									 sums[j] := sums[j] + locoord[3*k + j]
					end;
					
			 {---------------------------------------------------------------------}
 			 
			 procedure initialize;
			    { Changes cp, cl, tp^, sums. Uses newedges. }
			    var i, j: integer;
					begin
					   with tp^ do
								begin
									 x := na[1];  y := na[2];  z := na[3];
									 trash := false
								end;
						 for i := 1 to 3 do
								sums[i] := 0;
						 
						 { The first two points are read from newedges. }
						 newpoint(tp^.cp);
						 cp := tp^.cp;
						 cl := cp;
						 newpoint(cp^.cp);
						 { leave newedges^.fresh = true }
						 for j := 0 to 1 do
								begin
									 with newedges^ do
											begin
												 cp^.a := abscoord[2*j+1];
												 cp^.b := abscoord[2*j+2];
												 cp^.x := locoord[3*j + 1];
												 cp^.y := locoord[3*j + 2];
												 cp^.z := locoord[3*j + 3];
												 for i := 1 to 3 do
														sums[i] := sums[i] + locoord[3*j + i]
											end;
									 cp := cp^.cp
								end;
						 cp := cl^.cp
					end;															
															
			 {---------------------------------------------------------------------}
 			 
			 procedure attach_to_main(tp: polygon_ptr);
			    var d1, d2, vp: polygon_ptr;
			    begin
					   if shouldsort and (tp^.radius > 1.4*av_radius)
								then divider(tp, vp, av_radius)
								else begin
												vp := tp;
												tp^.rank := - tp^.rank  { now negative }
										 end;	
						 { Add new node(s) after anchor. This will be later in
							 the gg list than cur. }
						 d1 := anchor^.gg;
						 d2 := anchor^.face;
						 anchor^.gg := tp;
						 anchor^.face := tp;
						 vp^.gg := d1;
						 vp^.face := d2
					end;
										
			 {---------------------------------------------------------------------}
 			 
			 procedure group_and_attach(hd: polygon_ptr);
			    
					var tp, copy: polygon_ptr;
					    first: boolean;
							head, tail: factptr;
							gons, last: grouptr;  

					begin
					
					   head := nil;
						 copy := hd;
						 
						 tp := nil;
						 { Discard any polygon of rank 2 or less. }
						 while hd <> nil do
						    if hd^.rank < 3
									 then if tp = nil
													 then begin
																	 copy := hd^.gg;
																	 freegon(hd);
																	 hd := copy
																end
													 else begin
																	 tp^.gg := hd^.gg;
																	 freegon(hd);
																	 hd := tp^.gg
																end
									 else begin
									         tp := hd;
													 hd := hd^.gg
												end;
								
						 hd := copy;
						 while hd <> nil do
						    begin
								   tp := hd^.gg;
									 while tp <> nil do
									    begin
								         if inside(hd, tp, first)
												    then begin
														        if head = nil
																		   then begin
																			         newfact(head);
																							 tail := head
																						end
																			 else begin
																			         newfact(tail^.next);
																							 tail := tail^.next
																						end;
																		if first
																		   then with tail^ do
																			         begin
																							    first := tp;
																							    sec := hd
																							 end
																			 else with tail^ do
																			         begin
																							    first := hd;
																							    sec := tp
																							 end
														     end;
												 tp := tp^.gg
								      end;
									 hd := hd^.gg
								end;
						 
						 hd := copy;
						 if head <> nil
						    then begin
								        { Non-simply connected regions must be regrouped. }
												tail^.next := nil;
												build_group(gons, last, head, hd);
												unwind_group(gons, last, hd)
										 end;
						 
						 while hd <> nil do
						    begin
								   tp := hd^.gg;
									 hd^.gg := nil;
									 if hd^.rank < 3
                      then freegon(hd)
					            else attach_to_main(hd);
									 hd := tp
								end
								
					end;

			 {---------------------------------------------------------------------}
 			 
			 procedure finalize;
					begin
					   with tp^ do
								begin
									 rank := thisrank;
									 xcen := sums[1]/rank;  
									 ycen := sums[2]/rank; 
									 zcen := sums[3]/rank
								end;
						 set_radius(tp)
					end;
													 
			 {----------------------------------------------------------------------}
			 
			 begin  { of solid }

					addedsome := false;
					sum_radii := 0;
					polycnt := 0;
					cur := ob^.gons;
					if cur = nil
						 then eg1 := nil
						 else newedge(eg1);
						 
					{ Perturb the cut plane to 'eliminate' the possibility of polygon points being
					  on the plane.  Encourage misses in borderline cases. }
					av_radius := sqrt(f_absval(a) + sqr(a[4]));
					for i := 1 to 3 do
					   begin 
						    if a[i] > 0
								   then sign := -1
									 else sign := 1;
								if a[i] = 0
								   then a[i] := sign * av_radius * 1.23e-4 * random / halfblock / 2 {@@@}
									 else a[i] := a[i]*(1 + sign * av_radius * 1.23e-4 * random / halfblock / 2) {@@@}
						 end;
					if a[4] > 0
						 then sign := 1
						 else sign := -1;
					if a[4] = 0
						 then a[4] := sign * av_radius * 1.23e-4 * random / halfblock / 2
						 else a[4] := a[4]*(1 + sign * 1.23e-4 * random / halfblock / 2);
						 						 
					{ Find the unit normal to the cut plane. length is given. }
					for i := 1 to 3 do
					   na[i] := a[i]/length;
						 
					while cur <> nil do
						 begin
						 
								{ Analyze the polyhedron cur is part of.  Polyhedrons are represented
								  by a circular list of polygons via the face pointer. }
								if cur^.rank < 0  { have already seen this one. }
								   then begin
									         cur^.rank := - cur^.rank;  { now it's positive again }
													 cur := cur^.gg;
													 continue  { next polyhedron }
												end;

								anchor := nil;
								start := cur;
								sometrash := false;
								count := 0; { total number of new vertices of new face(s!) added }
								repeat
								    polycnt := polycnt + 1;
										sum_radii := sum_radii + cur^.radius;
										{ Look at every polygon in the polyhedron. }										
										cp := cur^.cp;
										found := false;
										{ Search for a point that is on the correct side (or on the cut plane). }
										for i := 1 to cur^.rank do
											 begin
													tst[1] := cp^.x;
												  tst[2] := cp^.y;
												  tst[3] := cp^.z;
												  cp^.keep := on_right_side(true, a, testside, cp^.bdy);  { don't care about cp^.bdy here }
												  if not found and cp^.keep
														 then begin
														         cl := cp;  { cl marks this good node }
																		 found := true
																	end;
													if i < cur^.rank
														 then cp := cp^.cp
											 end;
											 
										tp := cur;
										cur := cur^.face;
										if tp^.rank < 3
											 then found := false;  { so will be trashed below }
															
										if found  
											 then begin
															 tp^.trash := false;
															 anchor := tp;
															 		
															 cp^.cp := tp^.cp;  { make coord circular list }
															 cp := cl;
															 { first pass.  Compute all intersection points. }
															 allgood := true;
															 repeat
																	nxt := cp^.cp;
																	with eg1^ do
																		 begin
																				abscoord[1] := cp^.a;
																				abscoord[2] := cp^.b;
																				abscoord[3] := nxt^.a;
																				abscoord[4] := nxt^.b;
																				locoord[1] := cp^.x;
																				locoord[2] := cp^.y;
																				locoord[3] := cp^.z;
																				locoord[4] := nxt^.x;
																				locoord[5] := nxt^.y;
																				locoord[6] := nxt^.z
																		 end;
																	if cuts_through(k, true, allgood, a, testside)  
																		 then begin		{ This edge straddles the cut plane. } 
																		         count := count + 1;
																						 check_for_new;  { add new edge node if count odd }
																						 { Insert new vertex. }
																						 newpoint(cp^.cp);
																						 cp := cp^.cp;
																						 cp^.keep := true;  
																						 cp^.cp := nxt;
																						 tp^.rank := tp^.rank + 1;
																						 with eg1^ do
																								begin
																									 cp^.a := abscoord[k+1];
																									 cp^.b := abscoord[k+2];
																									 cp^.x := locoord[3*k div 2 + 1];
																									 cp^.y := locoord[3*k div 2 + 2];
																									 cp^.z := locoord[3*k div 2 + 3]
																								end;
																						 { Make record of the new edge of new polygon. }
																						 k := 1 - (count mod 2);
																						 with cp^ do
																						    with tail^ do
																								   begin
																								      abscoord[2*k+1] := a;
																										  abscoord[2*k+2] := b;
																										  locoord[3*k + 1] := x;
																										  locoord[3*k + 2] := y;
																										  locoord[3*k + 3] := z
																								   end
																					end;
																	cp := nxt
															 until cp = cl;
															 															 
															 if allgood  { may have been changed by cuts_through }
																	then begin
																	        tp^.rank := - tp^.rank;  { it's now negative }
								                          continue { next face }
																			 end;
																	
															 { Pass 2.  Remove all points on the bad side. }
															 cp := tp^.cp;
															 cl := nil;
															 lostsome := false;
															 for i := 1 to tp^.rank do
																	if cp^.keep
																			then begin
																							cl := cp;
																							cp := cp^.cp
																					 end
																			else if cl = nil
																							then begin
																											lostsome := true;
																											tp^.rank := tp^.rank - 1;
																											tp^.cp := cp^.cp;
																											cp^.cp := point_garb;
																											point_garb := cp;
																											cp := tp^.cp
																									 end
																							else begin
																											lostsome := true;
																											tp^.rank := tp^.rank - 1;
																											cl^.cp := cp^.cp;
																											cp^.cp := point_garb;
																											point_garb := cp;
																											cp := cl^.cp
																									 end;
																	
															  if lostsome
																   then begin
																	         set_centroid(tp);
																					 set_radius(tp)
																	      end;
																				
																{ There seems to be no need to recompute xmin, xmax, etc. }
																if tp^.rank < 3
																	then with tp^ do
																					begin
			                                       trash := true;
			                                       sometrash := true;
																						 x := 0; y := 0; z := 0
																					end
															 
														end
											 else  { mark for later discard of entire polygon }
														begin
														   tp^.trash := true;
															 sometrash := true  { there is some trash in this polyhedron }
														end;
														
									 tp^.rank := - tp^.rank;  { it's now negative }
									 
								until cur = start;
								
								av_radius := sum_radii/polycnt;
								
								if cur^.rank < 0  
								   then cur^.rank := - cur^.rank;
									 
								{ Reset the face pointers to delete the trashed ones from the
								  face lists.  Actual deletion later, at end. }
								if sometrash and (anchor <> nil)
								   then begin    { not all are trash }
									         tp := anchor^.face;
													 hp := @ anchor^.face;
													 while tp <> anchor do
													    begin
															   if tp^.trash
																    then hp^ := tp^.face
																		else hp := @ tp^.face;
															   tp := tp^.face
															end
									      end
									 { else either no trash or all are trash -- don't need to 
									   do anything };
											 
								{ Add the new polygon(s!) created by the cut if count > 0. Raw list
								  of edges from above must be turned into actual polygon(s). }
								if count > 0
								   then begin
									         addedsome := true;
													 tail^.next := newedges;  { make the list circular. }
													 newgon(tp);
													 newpolys := tp;
				                   if odd(count)
													    then begin
															        writeln(userOutput, '*** Fermat error.  Odd count degeneracy.');
					                            flush(userOutput)
																	 end;
													 initialize; { tp^ and first two coord nodes. }
													 
													 { The other coord nodes have to be searched for. Beware of 
													   roundoff error effects! }
													 initial := newedges;
													 thisrank := 2;
													 number_left := count div 2;
													 while thisrank < number_left do
													    begin
															   tail := newedges^.next;
																 repeat
																	  while tail <> newedges do
																			 begin
																				  if tail^.fresh
																					   then begin
																						         k := 0;
																										 while k < 2 do
																											  if distance(k) < myepsilon
																													 then goto 123
																													 else k := k + 1
																									end;
																				  tail := tail^.next
																			 end;
																		myepsilon := 1.2*myepsilon;
																		tail := tail^.next
																 until false;
																 
													       123:;
																 tail^.fresh := false;
																 if epsilon <> myepsilon
																		then begin  { need a "bridge" }
		                                        add_node;  { using the current k }
																					  thisrank := thisrank + 1;
																						if tail <> initial { looking ahead at next statement }
																						   then number_left := number_left + 1;
																						if myepsilon > 1e-3
																							 then begin
																											 writeln(userOutput, '*** Warning.  Object contains singular polygons.');
																											 flush(userOutput)
																										end;
																						myepsilon := epsilon
		                                     end;
									 
																 if tail = initial
																    then begin  { premature end -> disconnected poly }
																		        thisrank := thisrank - 1;  { discard extra node }
																						with cp^ do
																						   begin
																							    sums[1] := sums[1] - x;
																							    sums[2] := sums[2] - y;
																									sums[3] := sums[3] - z
																							 end;
																						cp^.cp := point_garb;
																						point_garb := cp;
																						finalize;
																		        { Begin new polygon. }
																						newgon(tp^.gg);
																						tp := tp^.gg;
																						repeat
																						   tail := tail^.next
																						until tail^.fresh;
																						newedges := tail;
																						initial := newedges;
																						initialize;
																						number_left := number_left - thisrank;
																						thisrank := 2
																		     end
																		else begin  { ordinary case }
																		        k := 1 - k;  { need other entry }
																            add_node;
																						thisrank := thisrank + 1;
																            newedges := tail
																				 end
															end;
																 
													 finalize;
													 tp^.gg := nil;
													 group_and_attach(newpolys);
													 
													 { Discard edge list. }
													 newedges := tail^.next;
													 tail^.next := edge_garb;
													 edge_garb := newedges
									 
									      end;
																
								cur := cur^.gg
								
						 end;
						 						 
					{ Set headvert, endvert, lastgon.  Discard trash. }
					cur := ob^.gons;
					hp := @ ob^.gons;
					h := @ ob^.headvert;
					while cur <> nil do
						 begin
								cp := cur^.cp;
								cl := cp;
								for i := 2 to cur^.rank do
									 cp := cp^.cp;
								if cur^.trash
								   then begin
									         cp^.cp := point_garb;
													 point_garb := cl;
													 hp^ := cur^.gg;
													 cur^.gg := gon_garb;
													 gon_garb := cur;
													 cur := hp^
									      end
									 else begin
									         h^ := cl;
													 h := @ cp^.cp;
													 hp := @ cur^.gg;
													 ob^.lastgon := cur;
													 ob^.endvert := cp;
													 cur := cur^.gg
												end
						 end;
						 
					if shouldsort and addedsome and ob^.shaded and (ob^.gons <> nil)
					   then sort_polygons(ob)
						 		 
			 end;

		{_________________________________________________________________________}

		begin { of single_cut }

			 killed := false;
			 if ob = nil
					then exit;
				
			 with ob^ do
					begin
						 yfact := yscale*costheta;
						 xfact := xscale*costheta;
						 zfact := zscale*z_cosine;
						 xsine := xscale*sintheta;
						 ysine := yscale*sintheta
					end;
			 g1 := ob^.first;
			 g2 := g1;
			 stop := graphsize;
			 j1 := 1;  j2 := 0;
			 while g1 <> nil do
					begin
							if g1 = ob^.last
								 then stop := ob^.final;
							while true do
								 begin
										for i := 1 to dim do
										   tst[i] := g1^.locoord[3*j1 - 3 + i];
										if on_right_side(false, a, testside, dummy)
											 then begin
															 j2 := j2 + 1;
															 if j2 > graphsize
																	then begin
																					j2 := 1;
																					g2 := g2^.next
																			 end;
															 g2^.abscoord[2*j2-1]:= g1^.abscoord[2*j1-1];
															 g2^.abscoord[2*j2]:= g1^.abscoord[2*j1];
															 g2^.locoord[3*j2-2]:= g1^.locoord[3*j1-2];
															 g2^.locoord[3*j2-1]:= g1^.locoord[3*j1-1];
															 g2^.locoord[3*j2]:= g1^.locoord[3*j1]
														end;
										j1 := j1 + 1;
										if j1 > stop
											 then begin
															 g1 := g1^.next;
															 j1 := 1;
															 break
														end
								 end
					 end;
				if g2 <> nil
					 then begin
									 ob^.final := j2;
									 if j2 = 0
											then begin
															g1 := ob^.first;
															ob^.first := nil
													 end
											else begin
															g1 := g2^.next;
															g2^.next := nil;
															ob^.last := g2
													 end;
									 if g1 <> nil
											then begin
															ob^.last^.next := graph_garb;
															graph_garb := g1
													 end
								end;
																				 
				{ Now the lines }
				ln1 := ob^.line;
				ln2 := nil;
				while ln1 <> nil do
					 begin
							if line_hits_right_side   
								 then begin
												 if ln2 = nil
														then ln2 := ob^.line
														else ln2 := ln2^.next;
												 ln2^ := ln1^
											end;
							ln1 := ln1^.next
					 end;
				if ob^.line <> nil
					 then if ln2 = nil
									 then begin
													 ob^.lasline^.next := line_garb;
													 line_garb := ob^.line;
													 ob^.line := nil
												end
									 else begin
													 ln1 := ln2^.next;
													 ln2^.next := nil;
													 if ln1 <> nil
															then begin
																			ob^.lasline^.next := line_garb;
																			line_garb := ln1
																	 end;
													 ob^.lasline := ln2
												end;
				
				{ Now the polygons.  This is quite complex.  Headvert and endvert will have
				  to be completely reset at end; they can't be set on the fly because if a 
					polygon is deleted, there is no way to know where its coord records are 
					in the headvert list -- recall that rotate (for example) jumbles up the
					initial coherence between the polygon list and the coord list. 
					   Also, two different versions for solid and non-solid. }
				
			  epsilon := 1.0e-8;  
				if ob^.solid
				   then solid(epsilon)
					 else hollow;
					 
				if eg1 <> nil
					 then begin
									 eg1^.next := edge_garb;
									 edge_garb := eg1
								end;									
					 
				if (ob^.line = nil) and (ob^.first = nil) and (ob^.gons = nil)
					 then killed := true
				
		end;
				
	 {************************************************************************}
	 
	 procedure zoom_most; {(ob: objptr; factor: longreal; showit: boolean)}
	 
			var g: graphptr;
					ln: lineptr;
					i, j, stop, k: integer;
					xfact, yfact, zfact, xsine, ysine: longreal;
										
			{____________________________________________________________________}
	 
			 procedure get_rs(x, y, z: longreal; var r, s: integer);
					begin
						  if ob^.threeD
								 then begin
												 r := round(yfact*y - xfact*x); 
												 s := - round(zfact*z - xsine*x - ysine*y)
											end
								 else with ob^ do
												 begin
														r := round(xscale*x);
														s := - round(yscale*y);
												 end
					end;
					
			 {____________________________________________________________________}
	 
			begin
					
					g := ob^.first;
					stop := graphsize;
					
					with ob^ do
				    begin
						   yfact := yscale*costheta;
							 xfact := xscale*costheta;
							 zfact := zscale*z_cosine;
							 xsine := xscale*sintheta;
							 ysine := yscale*sintheta
						end;
						
				  while g <> nil do
						 begin
								if g = ob^.last
									 then stop := ob^.final;
								j := 1;
								for i := 1 to stop do
									 begin
										  for k := 0 to 2 do
												 g^.locoord[k+j] := g^.locoord[k+j]*factor;
											with g^ do
											   get_rs(locoord[j], locoord[1+j], locoord[2+j], abscoord[2*i-1], abscoord[2*i]);
											if showit
												 then begin
																 MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
																 if wantcolor
											              then begin
														                with theColor do  { Jan 1998 }
																						 	 begin
																							    red := g^.colors[3*i-2];
																							    green := g^.colors[3*i-1];  
																							    blue := g^.colors[3*i]
																						   end;
																						RGBForeColor(theColor)
																				 end;
																 if printchar
																	  then begin
																					  Move(-2,2);
																					  DrawChar(mychar)
																				 end
																	  else Line(0, 0)
															end;
											j := j + 3
									 end;
								g := g^.next
						 end;
						 					
					ln := ob^.line;
					while ln <> nil do
						 begin
								for k := 1 to 3 do 
									 ln^.locoord[k] := ln^.locoord[k]*factor;
								with ln^ do
									 get_rs(locoord[1], locoord[2], locoord[3], abscoord[1], abscoord[2]);
								if showit and ln^.show
									 then MoveTo(ln^.abscoord[1], ln^.abscoord[2]);
								
								for k := 0 to 2 do
									 ln^.locoord[k+4] := ln^.locoord[k+4]*factor;
								with ln^ do
									 get_rs(locoord[4], locoord[5], locoord[6], abscoord[3], abscoord[4]);
								if showit and ln^.show
									 then begin
									         if wantcolor
							                then begin
											                with theColor do  { Jan 1998 }
																			 	 begin
																				    red := ln^.rred;
																				    green := ln^.ggreen;  
																				    blue := ln^.bblue
																			   end;
																			RGBForeColor(theColor)
																   end;
									         LineTo(ln^.abscoord[3], ln^.abscoord[4])
									      end;
								ln := ln^.next
						 end;
						 
				 savescreen := true
						 
			end;
				
  {*************************************************************************}

	function get_shading; {(s: polygon_ptr): longint}
	   var i: longint;
		     dot: longreal;
	   begin
		    { dot product with standard illumination source }
				dot := s^.x*thelight[1] + s^.y*thelight[2] + s^.z*thelight[3];
				{ compute illumination factor }
				i := 1;
				while dot < shadefactor[i] do
				   Inc(i);
				get_shading := i
		 end;
		 
	 {************************************************************************}
	 
	 procedure map_to_sphere;{(var xext, yext, x2: longreal; var xcor, ycor: integer)}
	 
	    { map (xext, yext) to Riemann sphere of radius x2. Pass back three space coords 
			  and the two integer pixel coordinates. }
				
			var sqrs, z2, y2: longreal;
			
			begin
			
			   x2 := 2*x2;
				 z2 := sqr(x2);
				 y2 := sqr(xext) + sqr(yext);
				 sqrs := y2 + z2;
				 x2 := x2*y2/sqrs;  { new z coordinate }
				 sqrs := z2/sqrs;
				 xext := xext*sqrs;
				 yext := yext*sqrs;
				 sqrs := xscale*xext;
				 y2 := yscale*yext;
				 xcor := round((y2 - sqrs)*costheta);
			 	 ycor := - round(zscale*x2*z_cosine - (sqrs + y2)*sintheta)
						
			end;
			
   {******************************************************************************}
   
   procedure My_PaintPoly;  {s: polygon_ptr}  { Jan 1998 }
      var xx: Cardinal;
          dot, factor: longreal;
      begin
      
        dot := s^.x*thelight[1] + s^.y*thelight[2] + s^.z*thelight[3];
        factor := paint_c_1*dot + paint_c_2;  { linear map from [-1,1] -> [1/10, 1] }
        with theColor do  
				 	  begin
					     xx := red;
					     dot := xx;
					     xx := trunc(dot*factor);
					     red := xx;
					     xx := green;
					     dot := xx;
					     xx := trunc(dot*factor);
					     green := xx;
					     xx := blue;
					     dot := xx;
					     xx := trunc(dot*factor);
					     blue := xx
				    end;
				    
				 RGBForeColor(theColor);
         PaintPoly(thequad)
         
      end;
			
																																															
 end.