unit fer218;


interface

  uses SyncObjs;

     procedure InitializeFermat(inEvent : TEvent);
     procedure RunFermat;

implementation
  {$R-}

  uses  ferm118, fer318, fer418, GraphicsForm,
        Types,sysutils, math;


	type shortstring = string[1];
			 bigstring = string[255];
			 longrealptr = ^longreal;
			 test_array = array[0..6] of integer; { for polygcd }


	var input_file_name, output_file_name, blankone: bigstring;
	    prompt: string[10];
	    continset: set of char;
			continuation, siouxcont: char;
			endarr, first_available, semicount, detcutoff, levelcount, matrix_eval, sizeval,
			   buffsize, limit_char_arrays (*wwh , i*), heapsize, heapdelta, siouxcols, siouxrows: longint;
			dispcutoff, tripval, promptsize: integer;
      timerflag, time_to_quit, errorpush, laurent, want_sparse, need_message,
			   need_to_set_char_poly, doing_sys_func, watch_for_func, uglyprint, saveonclose,
			   plottingerror, load_startup_now, real_quit: boolean;
		  last_good_one: condexptr;
			last_attached: nameptr;
			last_comm: comptr;
			sys_arr_facts: arr_descr;
			leftover, saveleft: shortstring;
			blank, semicolon, zero, multsign, plussign, quotsign, sqrtsign, expsign, factsign,
			  comma, minussign, esign, concatsign, logsign, arctansign, quotesign, empty, diag_sign,
				current_func, bulletsign, arr_arrsign, sys_func_tok, sys_func_token: tokentipe;
		  nilpol, pseudo_polynames: polypt;  { nilpol is always nil, pseudo_polynames is
			                                     nil unless there is actually need for poly-
																					 mod-out, when it is polynames. }


			sys_func: formptr;

			base_3_list: test_array;

      inputEvent : TEvent;

//wwh			OSerror		: OSErr;
//wwh			theWorld	: SysEnvRec;  { Jan 1998 }


//wwh FUNCTION cosh(x: double): double; {C;}  { Dec 1997 }
//wwh FUNCTION sinh(x: double): double; {C;}
//wwh FUNCTION atanh(x: double): double; {C;}

{*************************************************************************}

function hash(x: nametype; prime: integer): integer;

  var i, val: integer;
	
	begin
	
	   val := 0;
	   for i:=1 to length(x) do
		    val := ( 123*val + ord(x[i]) ) mod prime;
			
		 hash := val
		 
	end;
	
{*************************************************************************}

procedure reset_pseudo_poly;

   var q: polypt;
	 
	 begin
	  
		  q := polynames;
			while q <> nil do
			   begin
				    if q^.p <> nil
						   then break;
						q := q^.next
				 end;
			if q = nil
			   then pseudo_polynames := nil
				 else pseudo_polynames := polynames
				 
	 end;

{**************************************************************************}

procedure out_err_mess(x: longint);

  begin
	  if x = 17
		   then writeln(userOutput, 'After &, legal symbols are: v,f,F,r,R,d,D,');
    writeln(userOutput, erp^[x]) 
  end;

{***********************************************************************}

procedure simple_remove_args(f: funcptr);  {@@@ all these 'simple' procedures}

  var q, t: varptr;
      p: paramptr;
			i: integer;
			
	{--------------------------------------------------------------}

  procedure remove_array(x: tokentipe);

    var p, t: arrptr;
		    i: integer;

    begin
       if x.address = -1
		      then i := hash(x.name, 151)
				  else i := x.address;
			 
		   p := arr_store[i];
				
       while p^.name.name <> x.name do
          begin
						 t := p;
						 p := p^.next;
						 if (p = nil)
								then begin
												out_err_mess(30);
												exit {(remove_array)}
										 end
          end;
      if p^.time > 0
			   then begin
				         writeln(userOutput, '*** Warning. On function termination, found an array with the same name as an ');
								 writeln(userOutput, '       array parameter, namely: ', p^.name.name);
								 out_err_mess(30);
								 exit {(remove_array)}
							end;
							
			{ Take care of sparse/normal with father. Careful!! Sneaky!! }
			p^.father^.spar := p^.spar;
				         					 
			if p = arr_store[i]
         then arr_store[i] := arr_store[i]^.next
         else t^.next := p^.next;
				
			p^.next := arr_garb;
      arr_garb := p
	 end;
		
  {---------------------------------------------------------------}

  begin
	
    p := f^.pars;
    while p <> nil do
       begin
			    i := p^.let.address;
					q := sca_store[i];
					while q^.let.name <> p^.let.name do
						 begin
								t := q;
								q := q^.next;
						 end;
					if q = sca_store[i]
						 then sca_store[i] := sca_store[i]^.next
						 else t^.next := q^.next;	 
					if q^.val^.numb
						 then if q^.val^.ncoef^.size = -1742
										 then begin
														 remove_array(p^.let);
														 q^.val^.ncoef^.size := 0
												  end;
					q^.next := var_garb;
					var_garb := q;  
					
					if p^.result
					   then begin
						         free_quoly(q^.qp^);
										 q^.qp^ := q^.val
									end
						 else free_quoly(q^.val);						
          p := p^.next
						
       end
       
  end;

{***************************************************************************}

procedure simple_epilog(p: funcptr);

   begin
	    statcount := statcount - 1;
			lastf := lastf^.prev;
			prev_expr := old_prev;
			startexpr := old_start;
			exit_flag := false;
			simple_remove_args(p)
	 end;
	
{****************************************************************************}

procedure manage(shouldpush, printit: boolean; x: longint);

   var u: statptr;
	     i, real_count: longint;
	 
	 begin
	 
			finish := nil;
			leave_flag := false;
			exit_flag := false;
			cycle_flag := false;
			cancelflag := false;
			matrix_eval := 0;
			syst_dump := false;
			reset_pseudo_poly; 

			{ Manage the status information.}
			
			if (statcount > 0) and printit
				 then writeln(userOutput, '*** The most recent function evaluations were:');
			if statcount < statsize
				 then real_count := statcount
				 else real_count := statsize;
			u := lastf;
			if (x = 0) or ( (x > 0) and not shouldpush )
				 then for i := 1 to real_count do
								 begin
										if printit
										   then writeln(userOutput,  lastf^.f^.name.name);
										simple_remove_args(lastf^.f);
										lastf := lastf^.prev
								 end
					else for i := 1 to real_count do
								 begin
										if printit
										   then writeln(userOutput,  u^.f^.name.name);
										u := u^.prev
								 end;
			if (x = 0) or ( (x > 0) and not shouldpush )
		     then statcount := 0
									
	 end;
								 
{***********************************************************************}
		
procedure duplicate(q: varptr; s: arrptr; var r: varptr; var newarr: arrptr;
                    v: varptr; var vcop: varptr);

	 { Duplicate the q and s lists for funcplot. r <> q. newarr <> s. }
	 
	 var t: varptr;
			 u: arrptr;
	 
	 begin
			r := nil;
			while q <> nil do
				 begin
						if var_garb = nil
							 then new(t)
						else begin
										t := var_garb;
										var_garb := var_garb^.next
								 end;											
						t^.let := q^.let;
						t^.val := nil;
						quoly_assign(q^.val, t^.val);
						t^.qp := q^.qp;
						t^.next := r;
						r := t;
						if q = v
						   then vcop := t;
						q := q^.next
					end;
			
			newarr := nil;
			while s <> nil do
				 begin
						if arr_garb = nil
							 then new(u)
						else begin
										u := arr_garb;
										arr_garb := arr_garb^.next
								 end;											
						u^ := s^;
						u^.next := newarr;
						newarr := u;
						s := s^.next
					end
	 end;
		 
{***********************************************************************}

procedure init_quoly_node(var p: quoly);

  begin

		 newimag(p^.ncoef);
		 p^.ncoef^.size := 0;
		 p^.ncoef^.imag := nil
   
  end;
	
{**************************************************************************}

procedure add(var num1, num2, num3: number);

  begin
	
		num3.float := num1.float + num2.float;
									 
		if complex
		   then begin
							  if (num1.imag = nil) and (num2.imag = nil)
									 then imag_free(num3)
								else if num1.imag = nil
												then imag_assign(num2, num3)
								else if num2.imag = nil
												then imag_assign(num1, num3)
								else begin
												if num3.imag = nil
													 then begin
																	 newimag(num3.imag);
																	 num3.imag^.imag := nil
																end;
												num3.imag^.float := num1.imag^.float + num2.imag^.float;
												if num3.imag^.float = 0
													 then imag_free(num3)
										end
			      end

  end;
		
 {*************************************************************************}

 procedure simple_quoly_add(n, m: quoly; var p: quoly);
 
    { n and m are numbers @@@}
    
    var q: quoly;
				 
    begin
		
			 if realflag
			    then begin
					        if p = nil
									   then begin
										         newquoly(p);
														 p^.numb := true;
														 init_quoly_node(p)
													end;
								  p^.ncoef^.float := n^.ncoef^.float + m^.ncoef^.float;
									exit {(simple_quoly_add)}
							 end;
							 
			 newquoly(q);
		   q^.numb := true;
       newimag(q^.ncoef);
			 q^.ncoef^.imag := nil;
       add(n^.ncoef^, m^.ncoef^, q^.ncoef^);
			 free_quoly(p);
       p := q
					
	 end;
	 
{***************************************************************************}

procedure attach_data(x,y: integer; a,b,c: longreal);

   var i: integer;
	 
	 begin
	    Inc(grindex);
			if grindex > graphsize
			   then begin
				         newgraph(curgraph^.next);
								 curgraph := curgraph^.next;
								 grindex := 1
							end;
			i := 2*grindex - 1;
			with curgraph^ do
			   begin
			      abscoord[i] := x;
			      abscoord[i+1] := y;
			      i := 3*grindex - 2;
			      locoord[i] := a;
			      locoord[i+1] := b;
			      locoord[i+2] := c;
		      if wantcolor
			         then begin
			                 colors[i] := theColor.red;  { Jan 1998 }
			                 colors[i+1] := theColor.green;
			                 colors[i+2] := theColor.blue
			              end
			   end
	 end;
				
{***************************************************************************}

procedure simple_plotfunc;

   var xext, yext, x0, y0: longreal;
	     xcor, ycor, xcor0, ycor0: integer;
			 first, oldrealflag: boolean;

   begin

			first := true;
			repeat
			   xext := quoly_convert_to_ext(vplot^.val);
				 quoly_set(0, plotnum);
				 if xext > final^.ncoef^.float
				    then break;  { fail safe; can occur if the function being plotted has an
						               error for all (or final!) vplot values.  Then the block of
													 code after 9988 would call this forever. fixed Oct 1993 }
         oldrealflag := realflag;
			{	 eval_form(inf, pplot^.rht, plotnum);@@@}
				 if plotnum = nil
				    then quoly_set(0, plotnum);
				 realflag := oldrealflag;
				 exit_flag := false;
				 cycle_flag := false;
				 leave_flag := false;
				 if not plotnum^.numb
				    then begin
				             writeln(userOutput, '*** Error. Functions being plotted must return number values.');
				             break
				         end;
				 yext := quoly_convert_to_ext(plotnum);
				 xcor := round(xscale*xext);
				 ycor := - round(yscale*yext);
				 if first
				    then begin
						        MoveTo(xcor, ycor);
										xcor0 := xcor;   x0 := xext;
										ycor0 := ycor;   y0 := yext
								 end;
				 if points
				    then MoveTo(xcor, ycor)
						else LineTo(xcor, ycor);
				 if points
				    then if printchar
									  then begin
													  Move(-2,2);
													  DrawChar(mychar)
												 end
									  else Line(0, 0);
				 if marking
				    then if points
						        then attach_data(xcor, ycor, xext, yext, 0)
										else if not first
										        then begin
										                attach_line(xcor0,ycor0,xcor,ycor,x0,y0,0,xext,yext,0);
																		xcor0 := xcor; ycor0 := ycor;
																		x0 := xext; y0 := yext
																 end;
			   simple_quoly_add(vplot^.val, increm, vplot^.val);
				 first := false
			until vplot^.val^.ncoef^.float > final^.ncoef^.float;

			plotting := false;

			savescreen := true

	 end;

{***************************************************************************}

procedure cancel_dups(h: varptr; a: arrptr);

   var v: varptr;
	     y: arrptr;

	 begin
	 
	    while h <> nil do
			   begin
				    v := h^.next;
						h^.next := var_garb;
						var_garb := h;
						free_quoly(h^.val);
						h := v
				 end;
				 
			while a <> nil do
			   begin
				    y := a^.next;
						a^.next := arr_garb;
						arr_garb := a;
						a := y
				 end
				 
	 end;	
	
{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure pseudo_main;   {@@@ a BIG procedure! }


  procedure error(x: longint;  bad: tokentipe); forward;
		
 {***********************************************************************}
 
 procedure fermat_error(mess: bigstring; push: boolean);{ there are two of these. Other
                                                          is in fer320 }

    begin
			 write(userOutput, '*** Fermat error. ');
			 writeln(userOutput, mess);
			 flush(userOutput);
			 if push
			    then error(-1, blank)
		end;

 {************************************************************************}

  procedure check_cmd_keys;  { Changed Mar 1997 }
  begin
    if inputEvent.WaitFor(0) = wrSignaled then
      begin
        if alertKey = PanicKey then
          error(0, blank)
        else if alertKey = NewCommandLevel then
          error(-1, blank)
      end
  end;

  {*************************************************************************}

	procedure array_seek(x: tokentipe; var q: arrptr);
  			
	   var i: integer;
		
		 begin
		
		    if x.address = -1
			     then i := hash(x.name, 151)
				   else i := x.address;
				 
			  q := arr_store[i];
        while q <> nil do
           if q^.name.name = x.name
              then break
              else q := q^.next;
				if q = nil
           then error(28, x)
		
	   end;				
				
  {*************************************************************************}
	
	procedure free_colm(var t: colm_ptr);
	
	   var s: colm_ptr;
		 
		 begin
		 
		    free_quoly(t^.val);
				s := t^.next;
				t^.next := col_garb;
				col_garb := t;
				t := s		 
		 
		 end;
	
	{**************************************************************************}
	
	procedure new_worknode(var p: longint; x: tokentipe);

    begin
		
		  if first_available > worksize
			  then error(88, x)
      else if workhead[first_available] = nil
        then begin
				        new(workhead[first_available]);
								Inc(first_available);
						 end
      else Inc(first_available);
					 
			p := first_available - 1;
			if (p < 1) or (p > worksize)
				   then begin
					         writeln(userOutput, '*** Fermat error. first available = ', p:1);
									 flush(userOutput)
							  end
						 
    end;
		
  {**************************************************************************}
	
  procedure free_work; 

    begin
		
		   first_available := first_available - 1
				 
	  end;

 {**************************************************************************}

 procedure expre(var inf: text; var qp: quolyptr; var n: quoly; 
                 var aux: colm_ptrptr; var colpos: longint; var flag: nameptr);  forward;

 {**************************************************************************}

  procedure half_expre(var inf: text; var n: quoly; var flag: nameptr); forward;  
                       {Nov 1997}
  
  {**************************************************************************}
  
  procedure old_expre(var inf: text; var n: quoly; var flag: nameptr); forward;  {Nov 1997}

 {***************************************************************************}

  procedure arr_parse(x: char; var inf: text; var n: quoly; var flag: nameptr);
	                    forward;

  {***********************************************************************}
	
  procedure do_prompts;
	
	   begin

		    if levelcount > 1
					 then write(userOutput, levelcount : 1);
				if promptsize > 0
					 then write(userOutput, prompt);
				leftover := ''
								
		 end;
		 
	{****************************************************************************}

  procedure scanner(var inf: text; var tok: tokentipe; var flag: nameptr);

	  var t: char;

		{__________________________________________________________________}

		procedure getchar;

		   begin

          repeat
					  t := ' ';
            if eof(inf)
						   then t := ';';
						while ((t in throwaways) and not (eof(inf) or eoln(inf)) )
						   do read(inf, t);
						if eoln(inf) and (t in throwaways)
               then if tt_flag
									      then t := ';'
										    else readln(inf); { changed Oct 1997 }

					  if (t = continuation) { and eoln(inf) }
						   then begin
							         readln(inf);
											 semicount := 0;
											 t := ' '
										end
          until not (t in throwaways)

			 end;

		{__________________________________________________________________}

		procedure getchar2;  { Nov 1997.  New scanning! }

		   begin

					  t := ' ';
            if eof(inf)
						   then t := ';';
            if ((t in throwaways) and not (eof(inf) or eoln(inf)) )
						   then read(inf, t);
						if eoln(inf) and (t in throwaways)
               then if tt_flag
									      then t := ';'
										    else readln(inf); { changed Oct 1997 }

					  if (t = continuation) { and eoln(inf) }
						   then begin
							         readln(inf);
											 semicount := 0;
											 t := ' '
										end

					  { can end with t = ' ' }

			 end;

		{____________________________________________________________________}

    begin

  	  if command_int
			   then check_cmd_keys;

      if flag = nil
        then begin
								 tok.name := '';
								 tok.address := -1;
				         if (leftover = '') or (leftover = ' ')  { Nov 1997 }
								    then getchar
										else t := leftover[1];

	               if ((t>='a') and (t<='z')) or ((t>='A') and (t<='Z'))
								    then begin
									          repeat
													     tok.name := concat(tok.name, t);
									             getchar2;  { Nov 1997 }
															 if length(tok.name) = namelength
															    then break;
													  until ((t < 'a') or (t > 'z')) and ((t < 'A') or (t > 'Z')) and
								                  ((t < '0') or (t > '9')) and (t <> '_');  { Dec 1997 }
													  leftover := t
											   end
									  else begin
													  tok.name := t;
													  leftover := ''
												 end;
								 if finish = nil
								    then begin
										        start^.let.name := tok.name;
														if t = ' '  { Jan 1998 }
														   then start^.let.name := concat(start^.let.name, ' ');
														finish := start
												 end
										else begin
										        finish := finish^.next;
														finish^.let.name := tok.name;
														if t = ' '  { Jan 1998 }
														   then finish^.let.name := concat(finish^.let.name, ' ');
														if finish = start
														   then start := start^.next
												 end
						  end

        else begin
                flag := flag^.next;
								tok := flag^.let;
								currentchar := flag^.next
             end

    end;

	{****************************************************************************}

  procedure spec_scanner(var inf: text; var tok: tokentipe; var flag: nameptr; var
	                       end_ln_seen: boolean);

		{ end_ln_seen is set during every call. }

	  var t: char;

		{__________________________________________________________________}

		procedure getchar;

		   begin

          repeat
					  t := ' ';
						while ((t in throwaways) and not (eof(inf) or eoln(inf)) )
						   do read(inf, t);
						if eoln(inf) and (t = ' ')
               then if tt_flag
									      then t := ';'
										    else begin
												        readln(inf); { changed Oct 1997 }
																end_ln_seen := true
														 end;

					  if (t = continuation) { and eoln(inf)}
						   then begin
							         readln(inf);
											 end_ln_seen := true;
											 semicount := 0;
											 t := ' '
										end;
          until not (t in throwaways)

			 end;

		{____________________________________________________________________}

    begin

  	  if command_int
			   then check_cmd_keys;

			end_ln_seen := false;

      if flag = nil
        then begin
								 tok.name := '';
								 tok.address := -1;
				         if leftover = ''
								    then getchar
										else t := leftover[1];

	               if ((t>='a') and (t<='z')) or ((t>='A') and (t<='Z'))
								    then begin
									          repeat
													     tok.name := concat(tok.name, t);
									             getchar;
															 if length(tok.name) = namelength then break;
													  until ((t<'a') or (t>'z')) and ((t<'A') or (t>'Z')) and
								                  ((t<'0') or (t>'9')) and (t <> '_');  { Dec 1997 }
													  leftover := t
											   end
									  else begin
													  tok.name := t;
													  leftover := ''
												 end;
								 if finish = nil
								    then begin
										        start^.let.name := tok.name;
														if t = ' '  { Jan 1998 }
														   then start^.let.name := concat(start^.let.name, ' ');
														finish := start
												 end
										else begin
										        finish := finish^.next;
														finish^.let.name := tok.name;
														if t = ' '  { Jan 1998 }
														   then finish^.let.name := concat(finish^.let.name, ' ');
														if finish = start
														   then start := start^.next
												 end
						 end
										 
        else begin
								flag := flag^.next;
								tok := flag^.let;
								currentchar := flag^.next
						 end
    end;

	
  {****************************************************************************}

  procedure dumbscanner (var inf: text;  var tok: tokentipe; var flag: nameptr;
	                       var endline: boolean);
	
	  var t: char;
	
    begin  { just take the next character. }
		
      if flag = nil
        then
				  begin
            if eoln(inf)
               then begin
							         readln(inf);
											 endline := true;
											 t := chr(13)
										end
               else begin
							         read(inf, t);
											 endline := false
										end;
											 
					  if t = continuation
						   then begin
							         readln(inf);
											 t := ' '
										end;
						
						tok.name := t;
						tok.address := -1;
						if finish = nil
								then begin
												start^.let.name := tok.name;
												finish := start
										 end
								else begin
												finish := finish^.next;
												finish^.let.name := tok.name;
												if finish = start
													 then start := start^.next
										 end
					end
					
        else begin
								flag := flag^.next;
								tok := flag^.let;
								endline := false
						 end
					
    end;	
			
	{****************************************************************************}
  
	procedure remove_args(f: funcptr; cant_call_error: boolean);  forward;

  {****************************************************************************}

  procedure quoly_display(var outf: text; outf_is_tty, flag, linend: boolean;
                         p: quoly; var mylength: longint; endchar: tokentipe;
												 q: polypt; extra_space, leadoff, char_flag: boolean); forward;
												 
	{****************************************************************************}

  function parse(var inf: text; var n: quoly; var flag: nameptr) : integer; forward;

  {****************************************************************************}
	
  procedure newname(var p: nameptr);

    begin
		
      if name_garb = nil
        then new(p)
        else begin
                p := name_garb;
                name_garb := name_garb^.next;
             end;
			 p^.compiled := false;
			 p^.space := false   { Dec 1997 }
					
    end;
		
  {***************************************************************************}
	
	procedure save_input_stream(var p: nameptr); 
	
	  { Used by error when pushing new command level to ensure that all of the 
		  input stream of the old level will be read when control is returned to
			the old level. Also used by &p }
	
	   var s: nameptr;
		     t: tokentipe;
				 count: integer;
				 old_command_int: boolean; 
		 
		 begin
		 
		   newname(p);  { need a dummy node because of changes to scanner in Dec 1991 }
			 s := p;
			 count := 0;
			 old_command_int := command_int;
			 command_int := false;

			 if not eoln(userInput)
				  then begin				 
								  repeat		 
										 scanner(userInput, t, zilch);
										 newname(s^.next);
										 s := s^.next;
										 s^.let := t;
										 Inc(count)
								  until (t.name = ';') and (func_def_count = 0);				 
								  s^.next := nil
							 end;
				
			  command_int := old_command_int;
				if count <= 1 then p := nil
				 
		end;
			
   {****************************************************************************}
	
   procedure listchars_com(var outf: text; p: nameptr; var ind: longint);
      { Nov 1997 }
      var thisname: nametype;
      begin
         while p <> nil do
            begin
	             thisname := p^.let.name;
	             if (thisname = chr(10)) or (thisname = chr(13))
	                then writeln(outf)
					        else begin
					                write(outf, thisname);
					                ind := ind + length(thisname)
					             end;
	             p := p^.next
            end
      end;
			
  {****************************************************************************}
	
   procedure listchars(var outf: text; p: nameptr; var ind: longint; var afterspace: boolean);
   
      { Nov 1997. removed ok and unused argument 'x'.  Made lots of fancy
         changes for spacing. }

      var q: nameptr;
          assignmt, colon, opert, notpurge: boolean;
          thisname: nametype;
          count: integer;

      begin
      
        colon := false;
        afterspace := false;  { Dec 1997 }
        count := 0;
        if p <> nil
           then notpurge := (p^.let.name <> '@');
        while p <> nil do
           begin
	            q := p^.next;
	            thisname := p^.let.name;
	            if q <> nil
	               then begin
	                       if thisname = '['  { keep track when inside array index }
	                          then Inc(count)
	                          else if thisname = ']'
	                                  then count := count - 1;
	                       if count < 0
	                          then count := 0;
	                       assignmt := (thisname = ':') and (q^.let.name = '=');
	                       if count = 0
	                          then begin
	                                  opert := not colon and ((thisname = '+') or (thisname = '-'));
						                        if not opert and notpurge
						                           then opert := thisname[1] in cond_set
						                     end
						                else opert := false;
						             if (assignmt or opert) and not afterspace
	                          then write(outf, ' ');   
	                       write(outf, thisname);
	                       afterspace := p^.space;   { Dec 1997 }
	                       if afterspace
	                          then begin
	                                  write(outf, ' ');  { Dec 1997 }
	                                  Inc(ind)
	                               end;
	                       if (count = 0) and (thisname = ',')  { cut down Dec 1997 }
	                          then write(outf, ' ');
	                       if assignmt
	                          then begin  { Nov 1997. all new }
	                                  write(outf, '= ');
	                                  q := q^.next;
	                                  ind := ind + 4;
	                                  colon := false
	                               end
	                       else if opert
	                          then begin
	                                  if not afterspace
						                           then begin
						                                   write(outf, ' ');  { Dec 1997 }
						                                   afterspace := true;
						                                   Inc(ind)
						                                end;
	                                  ind := ind + 2;
	                                  colon := false
	                               end
	                          else begin
	                                  ind := ind + length(thisname);
	                                  colon := (thisname = ':')
	                               end
	                    end;
	            p := q
           end
           
      end;
			
	{************************************************************************}

   procedure listform(var outf: text; outf_is_tty: boolean; p: formptr; 
	                    ind: longint); forward;
			
	{***************************************************************************}

   procedure listrht(var outf: text; outf_is_tty: boolean; p: condexptr; comm: comptr; 
                     ind: longint);

      var i: longint;
          pn: nameptr;  { Nov 1997. All new procedure, more complex. }
          space: boolean;  { Dec 1997 }

      begin
        i := 0;
				while comm <> nil do
				   begin
					    write(outf, '{');
					    listchars_com(outf, comm^.q, i);  { Nov 1997 }
							if outf_is_tty or uglyprint 
								 then writeln(outf, '  ', continuation)
								 else writeln(outf, ' ');
							write(outf, ' ': ind);
							comm := comm^.next
					 end;
				
				i := 0;
        if p^.cond = nil
          then listchars(outf, p^.expr, i, space)  { Dec 1997 }
          else begin
					        pn := p^.cond;   { Nov 1997 }
					        if p^.aloop
									   then if pn^.let.name = ':'  { signal for for-loop }
									           then begin
									                   write(outf, 'for ');   { Nov 1997 }
									                   pn := pn^.next
									                end
														 else write(outf, 'while ')
										 else write(outf, 'if ');
									{ write(outf, '( ');  removed Nov 1997 }
									listchars(outf, pn, i, space);
									if not space
									   then write(outf, ' ');  { Dec 1997 }
									if p^.aloop
									   then write(outf, 'do')  { Dec 1997 }
										 else write(outf, 'then');
									if outf_is_tty or uglyprint
									   then writeln(outf, ' ', continuation)
									   else writeln(outf, ' ');
									write(outf, ' ': ind + 3);
									listform(outf, outf_is_tty, p^.form1, ind + 3);
									if outf_is_tty or uglyprint  {@@@}
										 then writeln(outf, ' ', continuation)
										 else writeln(outf);
									if p^.aloop
									   then write(outf, ' ': ind, 'od')
									else if p^.form2 = nil
										 then write(outf, ' ': ind, 'fi')
									else begin
												  write(outf, ' ': ind, 'else');
												  if outf_is_tty or uglyprint  {@@@}
										         then writeln(outf, ' ', continuation)
										         else writeln(outf);
										      write(outf, ' ': ind + 3);
												  listform(outf, outf_is_tty, p^.form2, ind + 3);
												  if outf_is_tty or uglyprint  {@@@}
										         then writeln(outf, ' ', continuation)
										         else writeln(outf);
										      write(outf, ' ': ind, 'fi')
											 end
								end
      end;
			
  {***************************************************************************}
	
	procedure epilog(p: funcptr);
	
	   begin
		    statcount := statcount - 1;
				lastf := lastf^.prev;
				prev_expr := old_prev;
				startexpr := old_start;
				exit_flag := false;
				remove_args(p, false)
		 end;
	
 {***************************************************************************}

  procedure arrdisplay(var outf: text; outf_is_tty, pretty: boolean;
                       x: tokentipe; q: arrptr; location, rows, cols, 
											 firstrow, firstcol, total_rows, desired: longint; charprint, 
											 from_store, extras: boolean; stash: workptr); forward;
											 
  {*************************************************************************}
	
	procedure warning( x: longint; bad: nametype);
	
	   begin
		   
			   writeln(userOutput);
				 writeln(userOutput, ' *** Warning.');
				 case x of
				     19: writeln(userOutput, ' *** Undefined variable: ', bad, '.  will use 0'); 
             22: writeln(userOutput, ' *** Trying to divide by 0, in variable: ', bad, '.  will set quotient to 0');
						 else begin
						             writeln(userOutput, ' *** Can''t do ', bad);
												 out_err_mess(x)
										 end
				 end;
				 
				 writeln(userOutput)
		 end;
		 
	{*************************************************************************}
	
	function hash2(x: nametype; prime: integer): integer;
	
	  { Find spot to insert x into symbol table of objects. }
		
		var i, val, stop: integer;
		    errname: tokentipe;
		
		begin
		
		   val := 0;
		   for i := 1 to length(x) do
			    val := ( 123*val + ord(x[i]) ) mod prime;
				
			 if objlist[val] = nil
			    then hash2 := val
			    else if objlist[val]^.name = x
					        then hash2 := val
									else begin
									        stop := (val + 40) mod prime;
													repeat
													   Inc(val);
														 if val = prime
														    then val := 0;
														 if val = stop
														    then begin
																        errname.name := x;
																				error(280, errname);
																				break
																		 end
													until (objlist[val] = nil) or (objlist[val]^.name = x);
											    hash2 := val
											 end
			 
		end;
		
  {****************************************************************************}
 
  procedure insert_object(objname: tokentipe; its_array, quit: boolean; i: integer; 
	                        var ob: objptr);
	
		 begin
		 
		    newobj(ob);
				ob^.name := objname.name;
				if sysgraph^.abscoord[1] = impossibl
					 then ob^.first := nil
					 else begin
									 ob^.first := sysgraph;
									 sysgraph := nil;
									 ob^.last := curgraph;
									 ob^.final := grindex;
									 curgraph^.next := nil
								end;
				if sysline^.abscoord[1] = impossibl
					 then ob^.line := nil
					 else begin
									 ob^.line := sysline;
									 sysline := nil;
									 penult^.next := nil;
									 ob^.lasline := penult;
									 curline^.next := line_garb;
									 line_garb := curline
								end;
				ob^.gons := sysgon;  { nil or not }
				if sysgon <> nil
				   then begin
									 ob^.headvert := sysgon^.cp;
									 sysgon := nil;
									 curgon^.gg := nil;
									 ob^.lastgon := curgon;
									 curgon := nil;
									 ob^.endvert := sysendvert
								end;
				
				ob^.threeD := threedim;
				ob^.obarray := false;
				ob^.shaded := false;
				ob^.solid := false;
				ob^.quads := nil;
				ob^.sintheta := sintheta;
				ob^.z_cosine := z_cosine;
				ob^.xscale := xscale;
				ob^.yscale := yscale;
				ob^.zscale := zscale;
				if threedim 
				   then begin
					         ob^.xmin := xmin;
								   ob^.xmax := xmax;
									 ob^.ymin := ymin;
								   ob^.ymax := ymax;
									 ob^.zmin := zmin;
								   ob^.zmax := zmax
								end;
				
				if quit
				   then exit {(insert_object)};
					 
				if its_array
					 then begin
					         obstash^[i] := ob; { old obstash[i] already freed }
									 ob^.next := nil   { essential for object parameters }
								end
					 else begin
									 i := hash2(objname.name, 151);
									 ob^.next := objlist[i];
									 objlist[i] := ob
								end
						
		 end;
								
  {***************************************************************************}
 
  procedure error;  {  (x: longint;  bad: tokentipe); }

	{ report errors or push new command level.  Pushing is very tricky - the
	  resetting of globals is subtle.  So is the timing: the three global arrays
		mytime, breaktime, and timeoff are used. }

    var i, old_func_def_count: longint;
				newnum: quoly;
				oldtok: tokentipe;
				old_tt_flag, old_done_load, old_complex, shouldpush, old_doing_sys, old_command_int,
				    old_real_flag, firstpass: boolean;
				myzilch: nameptr;
				message: bigstring;

    begin

			if plotting and (x > 0)
			   then
         begin
           plotting := false;
          raise EInvalidArgument.Create('if plotting and (x > 0)');  { exit(pseudo_main)};  {@@@}
         end;

			myzilch := nil;
			want_sparse := false;

			shouldpush :=  errorpush and ( (statcount > 0) or (levelcount > 1) );
			reset_pseudo_poly;

      if extra_line
				 then writeln(userOutput);
			if bad.name = ''
			   then bad.name := ';';
      if x > 0 { standard error }
			   then if (levelcount = 1) or ( (x <> 19) and (x <> 22) )
				          then begin
                          writeln(userOutput, '*** Inappropriate symbol: ', bad.name);
                          out_err_mess(x);
													if x = 139
													   then begin
														         writeln(userOutput, 'that you have just deleted.  Any reference to this parameter ');
																		 writeln(userOutput,  bad.name, ' may crash Fermat. There may be other such dangling array parameters.')
																	end
						           end
									else begin
									        warning(x, bad.name);
													finish := nil;
												  exit {(error)}
											 end
			else if x=0
				 then writeln(userOutput, '*** Panic stop.')
			else writeln(userOutput, '*** New command level.');

			if x = 132
			   then begin
				         writeln(userOutput, 'Here is the last line read:');
								 listrht(userOutput, true, last_good_one, last_comm, 4);
								 writeln(userOutput);
								 writeln(userOutput, '*** Definition of ', current_func.name, ' cancelled.')
							end;
			if (x = 103) or (x = 38) or ((x = 129) and (func_def_count > 0))
			   then begin
				         writeln(userOutput, 'Here is the last line successfully read:');
								 i := 0;
								 listchars(userOutput, last_attached, i, firstpass); { firstpass not mnemonic }
								 writeln(userOutput);
								 writeln(userOutput, '*** Definition of ', current_func.name, ' cancelled.')
							end;
							
			if (x > 0) and not tt_flag  { were reading from a file }
			   then begin
				         writeln(userOutput, '*** Error occurred right before this:');
								 readln(inpuf, message);
								 writeln(userOutput, message);
								 readln(inpuf, message);
								 writeln(userOutput, message);
								 readln(inpuf, message);
								 writeln(userOutput, message);
							end;

			if (x > 0) and tt_flag and (finish <> nil)
			   then begin
				         writeln(userOutput, '*** Error occurred at this point:');
								 s2 := start;
								 while true do
								    begin  
										   write(userOutput,  s2^.let.name);
											 if s2 = finish
											    then break
													else s2 := s2^.next
										end;
								 if statcount > 0
                    then writeln(userOutput)
							end;
								 
			{ Manage the status information and reset globals. }
			manage(shouldpush, true, x);

      if (startexpr <> nil) or (prev_expr <> nil) 
			    then writeln(userOutput, '*** Function was interrupted at:');
			i := 0;
			while prev_expr <> nil do
			    begin
					   if prev_expr^.let.name<>'' 
						    then write(userOutput, prev_expr^.let.name)
							  else write(userOutput, ';');
						 i := i + length(prev_expr^.let.name);
						 if i > 68
						    then begin
								        writeln(userOutput);
												i := 0
										 end;
						 prev_expr := prev_expr^.next;
						 if prev_expr = nil then writeln(userOutput);
					end;			
			while (startexpr<>nil) and (startexpr<>currentchar) do
			    begin
					   if startexpr^.let.name<>'' then write(userOutput, startexpr^.let.name);
						 startexpr := startexpr^.next
					end;
			if extra_line 
	       then writeln(userOutput);
			startexpr := nil;
			prev_expr := nil;
      currentchar := nil;
			
			old_tt_flag := tt_flag;
			old_complex := complex;
			old_done_load := done_load;
			old_func_def_count := func_def_count;
			
      tt_flag := true;
      func_def_count := 0;
			
      if (x = 0) or ( (x > 0) and not shouldpush )
			   then begin
				         statcount := 0;
								 if (dupptr <> nil) and (duparr^.name.name = 'dup')  
								    then for i := 0 to duparr^.stop do
										        free_quoly(dupptr^[i]);
								 dupptr := nil;  
								 duparr^.name.name := '  '
							end;
				 
			old_doing_sys := doing_sys_func;
			old_real_flag := realflag;
			doing_sys_func := false;
			realflag := false;
			newnum := nil;
			oldtok := token;
			if x >= 0
			   then begin
				         surplotting := false;
			           cplotting := false;
								 plotting := false { fixed Oct 1993 }
							end;

      if (x < 0) or ( (x > 0) and shouldpush )
			   then begin
				        Inc(levelcount);
								if levelcount > 9
								   then begin
									         writeln(userOutput, '*** Highest command level is 9.');
													 error(0, token)
												end;
												
								breaktime[time_level] := Time;
								Inc(time_level);
								time_off[time_level] := 0;
								
								old_command_int := command_int;
								command_int := false;  {@@@}
								firstpass := true;
								
								if x < 0   { will later pick it up again at this point. }
								         { too dangerous to try if x>0. }
								   then save_input_stream(myzilch);
								writeln(userOutput);
								write(userOutput, levelcount : 1);
								if promptsize > 0
								   then write(userOutput, prompt);
								flush(userOutput);  { added May 1997 }
								readln(userInput);
								leftover := '';
								if savescreen  { Jan 1998 } 
							     then begin
							            RestoreScreenFromCopy;
							            savescreen := false
							          end;
      
                { interpretive loop }
                while true do
                   begin
		                  scanner(userInput, token, zilch);
											if firstpass
                         then begin
                                 command_int := old_command_int;  {@@@}
                                 firstpass := false
                              end;
											mytime[time_level] := Time;	
	                    case token.name[1] of  {spar}
												 '!', ';':
                              if parse(userInput, newnum, zilch) <> 0 then exit;
												 '', '[', '': arr_parse(token.name[1], userInput, newnum, zilch);
												 'A': if (token.name = 'Adjoint') or (token.name = 'Altmult')
												         or (token.name = 'Altpower')
												         then arr_parse('A', userInput, newnum, zilch)
																 else old_expre(userInput, newnum, zilch);
												 else if parse(userInput, newnum, zilch) <> 0 then exit
												        { Nov 1997 expre(userInput, newnum, zilch) }
										  end;
										  zilch := nil;
											mytime[time_level] := Time - mytime[time_level] -
											                      time_off[time_level];
											time_off[time_level] := 0;
                      if newnum = nil 
											   then quoly_set(0, newnum);
											if savescreen  { May 1997 } 
										     then begin
										            RestoreScreenFromCopy;
										            savescreen := false
										          end;
											if (token.name <> ';') and (token.name <> '') and (token.name <> '@')
			                   and (token.name <> ':')
												 then error(129, token);
											finish := nil;				              
										  if time_to_quit 
										      then begin
													        time_to_quit := false;
																	levelcount := levelcount - 1;
																	time_level := time_level - 1;   
																	time_off[time_level] := time_off[time_level] +
																	          Time - breaktime[time_level];
																	writeln(userOutput, '*** Resuming earlier command level');
																	flush(userOutput);
																	free_quoly(newnum);
																	token := oldtok;
			                            tt_flag := old_tt_flag;
																	complex := old_complex;
		                            	done_load := old_done_load;
				                  				func_def_count := old_func_def_count;
																	doing_sys_func := old_doing_sys;
			                            realflag := old_real_flag;
																	zilch := myzilch;
													        break
															 end;
										 if token.name <> ':'
										    then begin
												        if syst_dump and noisy
																	 then arrdisplay(userOutput, true, false, syst^.name, syst, 0, syst^.rows,
																									 (syst^.stop + 1) div syst^.rows, addresser,
																									 addresser, syst^.rows, 4, false, false, true, stash);
															  if extra_line
																	 then writeln(userOutput);  
															  if noisy then flush(userOutput);
															  dummy := 0;
															  if (token.name <> '@') and noisy
																	 then quoly_display(userOutput, true, true, true, newnum, dummy, semicolon, 
																										  polynames, false, true, false);
															  if (polynames = nil) and noisy and extra_line
																	 then writeln(userOutput)
														 end
												else if extra_line
															  then writeln(userOutput);
										 syst_dump := false;
										 if timerflag
						            then begin
												         writeln(userOutput, ' Elapsed time: ', mytime[time_level]/60.0: 11:3);
																 if extra_line
																    then writeln(userOutput)
														 end;
										 flush(userOutput);
										 free_quoly(prevnum);
						         prevnum := newnum;
						         newnum := nil;
				             write(userOutput, levelcount : 1);
					           if promptsize > 0
											  then write(userOutput, prompt);
//wwh										 Showcursor(TRUE);
										 readln(userInput)

                  end;
              end
          else begin
					        levelcount := 1;
									time_level := 1; {~~~~}
									time_off[1] := 0;
									flush(userOutput);
									first_available := 1;
                  writeln(userOutput);   {@@@}
									token.name := '';  {~~~~ these two lines?}
									token.address := -1;
									raise Exception.Create('error'); {exit (pseudo_main)}  { main interpretive loop }
							 end
							 
    end;
		
	{************************************************************************}

   procedure listform{ var outf text; outf_is_tty: boolean; p: formptr; ind: longint };
		
      begin
        while p <> nil do
          begin
            listrht(outf, outf_is_tty, p^.cptr, p^.comms, ind);
            p := p^.next;
            if p <> nil
              then begin
								     	if outf_is_tty 
								     	   then writeln(outf, '; ', continuation)  {@@@}
								     	else if uglyprint 
									       then write(outf, '; ', continuation, chr(13))
										     else writeln(outf, '; ');
                      write(outf, ' ': ind)
                   end
          end
      end;
			
 {*************************************************************************}

 procedure poly_display(var outf: text; outf_is_tty, flag: boolean;
                        p: ferm118.poly; var mylength: longint; endchar:tokentipe;
												q: polypt; extra_space, maybe_just_number: boolean); forward;

 {*************************************************************************}
 
 procedure polylist(var outt: text; saveflag: boolean);
 
    { saveflag = write to saved file; else write to userOutput. }
 
    var p: polypt;
	      i, j, k, size: integer;  { k, Oct 2000 }
		    pound: string[7];
	
		begin
		
			 if saveflag then writeln(outt);
			 size := 0;
			 p := polynames;
			 if saveflag
					then pound := ' &(J = '
					else pound := ' ';  { Oct 2000 }
			 while p <> nil do
					begin
						 Inc(size);
						 p := p^.next
					end;
					
			 k := 0;  { k counts # written on a line, for moving up to new line. irrelevant if saveflag. }
			 for i := 1 to size do
					begin
						 p := polynames;
						 for j := 1 to size - i do
								p := p^.next;
						 if (k > 0) and (p^.p <> nil)  { Oct 2000 }
								then begin
								        writeln(outt);
								        k := 0
								     end;
						 write(outt, pound, p^.let.name);
						 if saveflag
						    then write(outt, ');')
								else write(outt, ';');
						 k := k + 1;  { Oct 2000 }
						 if p^.p <> nil
								then begin
												if saveflag
													 then write(outt, ' &(P = ')
													 else write(outt, '  subject to ');
												write(outt, p^.let.name:1, '^', p^.expon:1, ' = ');
												dummy := 0;
												poly_display(outt, not saveflag, false, p^.p, dummy, semicolon,
																		 polynames, false, true);
												if saveflag
													 then write(outt, ');')
													 else write(outt, '.')
										 end;
						 if (p^.p <> nil) or saveflag or (k = 12)  { Oct 2000 }
						    then begin
						            writeln(outt);
						            k := 0
						         end
					end;
					
			 if saveflag or (k > 0)  { Oct 2000 }
			    then writeln(outt)
				
		end;
   
	{*************************************************************************}

  procedure find_good_spot(var dup: workarray; i, m, num_cols: longint; 
	                         var newi, j: longint);

     label 88;
		 
		 var j2, k, spot, maybe, maybe_num: longint;
			
		 {_________________________________________________________________}
		 
		 procedure return_ans(num: longint);		 
		    begin
				   newi := 1 + num mod m;      { unnormalized form of row index }
				   j := 1 + num div m;         { unnormalized form of col index }
				end;
				
		 {__________________________________________________________________}
				    
     begin
        
        k := m * (i - 1) - 1; { k is always (number of elements before this column) - 1. }
				spot := i + k;  
				maybe := -1;      { spot, maybe, maybe_num are normalized indices in dup }
				maybe_num := -1;
				for j2 := 1 to num_cols do
				   begin
							while spot <= m + k do
								 if quoly_iszero(dup[spot])    { want spot with smallest sized poly }
										then Inc(spot)
								 else if dup[spot]^.numb
												 then begin
																 with dup[spot]^.ncoef^ do
																    if (float = 1) and (imag = nil)
																		    then goto 88
																 else if maybe_num = -1
																				 then maybe_num := spot
																 else if better_number(dup[maybe_num]^.ncoef^, dup[spot]^.ncoef^)
																				 then maybe_num := spot;
																 Inc(spot)
															end
								 else begin
												 if maybe = -1  
														then maybe := spot
														else if quoly_mass(dup[spot]) < quoly_mass(dup[maybe])
																		then maybe := spot;
												 Inc(spot)
											end;
							if j2 = 1
							   then if (maybe = -1) and (maybe_num = -1) and (m > 1) { column is all 0 }
								         then begin
												         spot := -1; { so that below call to return_ans works }
																 break
															end;
						  spot := spot + i - 1;
							k := k + m;
					 end;
									 					
        88: 
				
				if k = m*(num_cols + i - 1) - 1 { above loops ran to conclusion }
           then if maybe_num > -1
					         then return_ans(maybe_num)
								   else if maybe > -1
					                 then return_ans(maybe)
                           else newi := 0  { possible only if m=1 and matrix = 0} 									         
           else return_ans(spot)  { left loop early }
					 
     end;			

  {*************************************************************************}
 
  procedure zline(var inf: text; var n: quoly; var flag: nameptr); forward;
	
  {***************************************************************************}
	
	procedure get_ob(var obp: objptrptr; nameobj: tokentipe; nonil: boolean);
	
		 { Search main symbol table. If nonil, object of name 'nameobj' must already exist. }
		 
		 var i, stop, val: integer;
		 
		 begin
		 
		    val := 0;
		    for i := 1 to length(nameobj.name) do
			     val := ( 123*val + ord(nameobj.name[i]) ) mod 151;
				
			  stop := (val + 40) mod 151;
				while true do
			     begin
					    if objlist[val] = nil
						     then val := (val + 1) mod 151
						     else if objlist[val]^.name = nameobj.name
								         then break
												 else val := (val + 1) mod 151;
						  if val = stop
								 then begin
								         if nonil
					                  then error(227, nameobj)
									          else obp := nil;
												 exit {(get_ob)}
											end
					 end;
											 
				obp := @ objlist[val]
					 
		 end;					 
					 
	{*************************************************************************}

  function getindex(var inf: text; var n: quoly; var flag: nameptr; key: tokentipe): integer;
	
	   { key is name of an object array that must be existing already. The array index
		   is evaluated here and checked for in-bounds.  But key[index] may or may not
			 already exist. }
		 		 
		 var obp: objptrptr;
		     i: integer;
				 
		 begin
		 
		     scanner(inf, token, flag);
				 old_expre(inf, n, flag);
				 if token.name <> ']'
						then error(24, token);
				 scanner(inf, token, flag);
				 
				 i := quoly_convert_to_int(n);
				 get_ob(obp, key, true);
				 if not obp^^.obarray
						then error(231, key);
				 if (i < 1) or (i > obp^^.final - obp^^.init + 1)
						then error(27, key);
				 getindex := obp^^.init + i - 1
				 
		 end;
													 													 
   {******************************************************************************}					 

   procedure use_obj_param(var inf: text; var n: quoly; var flag: nameptr; var obp: objptrptr;
	                         var objname: tokentipe; nonil: boolean);
									 
	    { its_array means that [...] was after the parameter name. }
			
			var j: longint;
			    i: integer;
					parname: tokentipe;
					q: varptr;
					
			begin
			
			   parname.name := concat('', objname.name);
				 i := hash(parname.name, 151);
				 q := sca_store[i];
				 while q <> nil do
						if q^.let.name = parname.name
							 then break
							 else q := q^.next;
				 if q = nil
						then error(278, parname);
				 obp := q^.obj;
				 objname.name := obp^^.name;  { the 'real' name }
				 if token.name <> '['
						then exit {(use_obj_param)};
						
				 scanner(inf, token, flag);
				 old_expre(inf, n, flag);
				 if token.name <> ']'
						then error(24, token);
				 scanner(inf, token, flag);
				 j := quoly_convert_to_int(n);
				 if not obp^^.obarray
						then error(231, parname);
				 if (j < 1) or (j > obp^^.final - obp^^.init + 1)
						then error(27, parname);
				 i := obp^^.init + j - 1;
				 obp := @ obstash^[i];
         if nonil and (obp^ = nil)
						then error(232, parname)									 				 
						
			end;
																						
	{****************************************************************************}
 
  procedure set_object(var inf: text; var n: quoly; var  flag: nameptr);
 
     { Lines, points, and polygons since Mark will be grouped as an object and
		   assigned the name to be read here.  Complicated by object parameters.
			 Setobj(x) will create a new object with the name associated with x.
			 Setobj(x[i]) will actually 
			 change z[i], where z is the name associated with x. This is more reasonable. }
			 
		 var its_array, its_param: boolean;
		     objname: tokentipe; 
				 i: integer;
				 ob: objptr;
				 obp: objptrptr;
				 
		 begin
		
				if not marking
				   then error(226, token);
				if (sysline^.abscoord[1] = impossibl) and (sysgraph^.abscoord[1] = impossibl) and (sysgon = nil)
					 then error(226, token);
				scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				scanner(inf, objname, flag);
				its_param := (objname.name = '');
				if its_param
				   then scanner(inf, objname, flag);
				if (objname.name[1] < 'a') or (objname.name[1] > 'z')
					 then error(225, objname);
				scanner(inf, token, flag);
				if its_param
				   then begin
					         use_obj_param(inf, n, flag, obp, objname, false);
									 if token.name <> ')'
										  then error(1, token);
									 if obp^^.obarray 
									    then error(279, objname);
									 ob := obp^;
									 obp^ := ob^.next;
									 free_obj(ob);
									 i := 0;  { not necessary but leave it. }
									 insert_object(objname, false, true, i, ob);  { i is dummy }
									 ob^.next := obp^;
									 obp^ := ob
								end								 
		       else begin
					         its_array := false;
									 if token.name <> ')'
										  then if token.name <> '['
														  then error(1, token)
														  else begin
																		  i := getindex(inf, n, flag, objname);
																		  if token.name <> ')'
																				 then error(1, token);
																		  its_array := true
																	 end;
									 if its_array
				              then free_obj(obstash^[i]);
				           insert_object(objname, its_array, false, i, ob)
								end;
																				
				marking := false;
				scanner(inf, token, flag);
				quoly_set(0, n)
				
		 end;
		 
  {******************************************************************************}					 

  procedure actual_getob(var inf: text; var n: quoly; var flag: nameptr; var obp: objptrptr;
	                       var objname: tokentipe; nonil: boolean);
												 
		 {  If nonil is false, its ok not to find any object.  This means that 
		   in some cases obp is nil, in others that obp^ is nil.  Careful!.
			 objname can't be token upon call.  pass back obp.  pass back objname, but only for 
		   error messages, I think. }
	
	   var i: integer;
				 objparam: boolean;
				 		 
		 begin
		 
		    scanner(inf, objname, flag);
				objparam := (objname.name = '');
				if objparam
				   then scanner(inf, objname, flag);
				if (objname.name[1] < 'a') or (objname.name[1] > 'z')
					 then error(225, objname);
				scanner(inf, token, flag);
				if objparam
				   then use_obj_param(inf, n, flag, obp, objname, nonil)
				else if token.name = '['
				   then begin
					         i := getindex(inf, n, flag, objname);
									 obp := @ obstash^[i];
									 if nonil and (obp^ = nil)
									    then error(232, objname)
								end
				else get_ob(obp, objname, nonil)
					 
		 end;
					 
	{******************************************************************************}					 

  procedure get_object(var inf: text; var n: quoly; var flag: nameptr; var ob: objptr;
	                     var objname: tokentipe);
											 
		 var obp: objptrptr;
		 
		 begin
		 
		    scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				actual_getob(inf, n, flag, obp, objname, true);
				ob := obp^
					 
		 end;
									 
	{****************************************************************************}							
								
	procedure copy_object(var inf: text; var n: quoly; var flag: nameptr);
											 
	   { Note carefully what happens in commands like Copy(z, x) where
		   x is an obj array or an entry in an obj array! }
			 
		 var ob1, ob2: objptr;
		     obp: objptrptr;
				 nameobj: tokentipe;
				 i: integer;
				 its_array, its_param: boolean;
				 
		 begin
		 
		    get_object(inf, n, flag, ob1, nameobj);
				if ob1^.obarray
				   then error(236, token);
				if token.name <> ','
					 then error(202, token);
				scanner(inf, nameobj, flag);
				its_param := (nameobj.name = '');
				if its_param
				   then scanner(inf, nameobj, flag);
				if (nameobj.name[1] < 'a') or (nameobj.name[1] > 'z')
					 then error(225, nameobj);
				scanner(inf, token, flag);
				if its_param
				   then begin
					         use_obj_param(inf, n, flag, obp, nameobj, false);
									 if token.name <> ')'
										  then error(1, token);
									 if obp^^.obarray
									    then error(279, nameobj);
									 ob2 := obp^;
									 obp^ := ob2^.next;
									 free_obj(ob2)
								end								 
		       else begin
					         its_array := false;
									 if token.name <> ')'
										  then if token.name <> '['
														  then error(1, token)
														  else begin
																		  i := getindex(inf, n, flag, nameobj);
																		  if token.name <> ')'
																				 then error(1, token);
																		  its_array := true
																	 end
								end;
								
				newobj(ob2);
				ob2^ := ob1^;
				with ob2^ do
				   begin
					    name := nameobj.name;
							obarray := false
					 end;
													 
				copy_gr_ln(ob1^.first, ob1^.line, ob2);
				
				if ob1^.quads <> nil
				   then copy_sides(ob1, ob2);
					 
				if ob1^.gons <> nil
				   then copy_gons(ob1, ob2);
				
				if its_param
				   then begin
					         ob2^.next := obp^;
									 obp^ := ob2
					      end
				else if its_array
				   then begin
					         free_obj(obstash^[i]);
									 obstash^[i] := ob2;
									 ob2^.next := nil
								end
					 else begin
					         i := hash2(ob2^.name, 151);
									 ob2^.next := objlist[i];
									 objlist[i] := ob2
								end;
					 
				scanner(inf, token, flag);
				quoly_set(0, n)
				
		 end;
									 
	{****************************************************************************}							
								
	procedure gettheRGB(var inf: text; var n: quoly; var flag: nameptr; 
	                    var rred, ggreen, bblue: integer);  { Jan 1998 }
	   begin
	      scanner(inf, token, flag);
				old_expre(inf, n, flag);
			  if token.name <> ','
				   then error(202, token);
				rred := quoly_convert_to_int(n);
			  scanner(inf, token, flag);
				old_expre(inf, n, flag);
			  if token.name <> ','
				   then error(202, token);
				ggreen := quoly_convert_to_int(n);
				scanner(inf, token, flag);
				old_expre(inf, n, flag);
			  if token.name <> ')'
				   then error(1, token);
				bblue := quoly_convert_to_int(n)
	   end;
	   
	{****************************************************************************}
	
	procedure color_object(var inf: text; var n: quoly; var flag: nameptr; incr: boolean);
											 
	   { Jan 1998 }
			 
		 var ob1: objptr;
				 nameobj: tokentipe;
				 i, rred, ggreen, bblue: integer;
				 gg: graphptr;
				 lp: lineptr;
				 gp: polygon_ptr;
				 
		 begin
		 
		    get_object(inf, n, flag, ob1, nameobj);
				if ob1^.obarray
				   then error(276, token);
				if token.name <> ','
					 then error(202, token);
				gettheRGB(inf, n, flag, rred, ggreen, bblue);
				gg := ob1^.first;
				if incr
				   then while gg <> nil do
								   begin
								      for i := 1 to graphsize do
								         begin
								            gg^.colors[3*i-2] := gg^.colors[3*i-2] + rred;
								            gg^.colors[3*i-1] := gg^.colors[3*i-1] + ggreen;
								            gg^.colors[3*i] := gg^.colors[3*i] + bblue;
								         end;
								      gg := gg^.next
								   end
				   else while gg <> nil do
								   begin
								      for i := 1 to graphsize do
								         begin
								            gg^.colors[3*i-2] := rred;
								            gg^.colors[3*i-1] := ggreen;
								            gg^.colors[3*i] := bblue;
								         end;
								      gg := gg^.next
								   end;
				   
				lp := ob1^.line;
				if incr
				   then while lp <> nil do
								   begin
								      lp^.rred := lp^.rred + rred;
								      lp^.ggreen := lp^.ggreen + ggreen;
								      lp^.bblue := lp^.bblue + bblue;
								      lp := lp^.next
								   end
				   else while lp <> nil do
								   begin
								      lp^.rred := rred;
								      lp^.ggreen := ggreen;
								      lp^.bblue := bblue;
								      lp := lp^.next
								   end;
				   
				gp := ob1^.gons;
				if incr
				   then while gp <> nil do
								   begin
								      gp^.rred := gp^.rred + rred;
								      gp^.ggreen := gp^.ggreen + ggreen;
								      gp^.bblue := gp^.bblue + bblue;
								      gp := gp^.gg
								   end
				   else while gp <> nil do
								   begin
								      gp^.rred := rred;
								      gp^.ggreen := ggreen;
								      gp^.bblue := bblue;
								      gp := gp^.gg
								   end;
				
				scanner(inf, token, flag);
				quoly_set(0, n)
				
		 end;
									 
  {***************************************************************************}
	
  procedure arr_fact(var inf: text; var n: quoly; var arr: workarray;
                     var arr_facts: arr_descr; var arr_free: boolean; 
										 var rows: longint; var flag: nameptr; var spar: sparseptr); forward;

	{******************************************************************************}
	
	procedure free_arr(var ar: workarray; var arf: arr_descr);

    var  i: longint;

    begin
       for i := 0 to arf[1]-1 do
				  free_quoly(ar[i]);
       arf[1] := 0
    end;

	 
  {***************************************************************************}
  procedure define_polygon(s: polygon_ptr; showit: boolean);   { Jan 1998 }
     var i: longint;
		     c: coordptr;
		 begin

		    c := s^.cp;
				thequad := OpenPoly;
				if wantcolor and showit
           then begin
	                with theColor do  { Jan 1998 }
									 	 begin
										    red := s^.rred;
										    green := s^.ggreen;
										    blue := s^.bblue
									   end;
									RGBForeColor(theColor)
							  end;
				MoveTo(c^.a, c^.b);
			  for i := 2 to s^.rank do
			     begin
					    c := c^.cp;
						  LineTo(c^.a, c^.b)
					 end;
			  c := s^.cp;
			  LineTo(c^.a, c^.b);
				ClosePoly;
				savescreen := true
		 end;

  {***************************************************************************}

	procedure shadepoly(s: polygon_ptr; showit: boolean);
		 begin
				define_polygon(s, showit);
				if wantcolor and showit and wantsolid { Jan 1998 }
           then begin
                   My_PaintPoly(s);
                   KillPoly(thequad);
                   exit {(shadepoly)}
                end;
				if showit
				   then FillPoly(thequad, thepatt[get_shading(s)])
					 else ErasePoly(thequad);
{wwh unneeded with Delphi
				if showit
				   then FramePoly(thequad)
					 else begin
					         SetPenShade(psWhite);
									 FramePoly(thequad);
									 RestorePenShade
					      end; }
			  KillPoly(thequad)
		 end;

  {***************************************************************************}

  procedure solidify(var inf: text; var n: quoly; var flag: nameptr);
     
		 var nameobj: tokentipe;
		     x: longreal;
				 solid: boolean;
				 ob: objptr;
				 cur: polygon_ptr;
				 hp: gonptrptr;
		 
		 begin
		    
				get_object(inf, n, flag, ob, nameobj);
				if token.name = ','
					 then begin
									 scanner(inf, token, flag);
									 old_expre(inf, n, flag);
									 x := quoly_convert_to_ext(n);
									 if x = 1
											then solid := true
											else if x = 0
															then solid := false
															else error(270, token)
								end
					 else solid := true;
				if token.name <> ')'
				   then error(1, token);
				scanner(inf, token, flag);
				quoly_set(0, n);
				if (ob^.quads <> nil) or (ob^.first <> nil) or (ob^.line <> nil) or (ob^.gons = nil)
				   then error(318, token);  {```}
        if ob^.obarray
				   then error(276, token);  {```}
				if solid = ob^.solid
				   then exit {(solidify)};
				ob^.solid := solid;
				if not solid
				   then exit {(solidify)};
				
				cur := ob^.gons^.gg;
				hp := @ ob^.gons^.face;
				while cur <> nil do
				   begin
					    hp^ := cur;
							hp := @ cur^.face;
							cur := cur^.gg
					 end;
				hp^ := ob^.gons
				   
     end;

  {****************************************************************************}

  procedure cut_object(var inf: text; var n: quoly; var flag: nameptr; carve: boolean);
											 
	   var ob, knife: objptr;
		     obp: objptrptr;
		     nameobj, nameknife: tokentipe;
				 i, dim: integer;
				 arr: workptr;
		     arr_facts: arr_descr;
				 arr_free, testside, killed, allkilled: boolean;
				 r: longint;
				 a: f_vector;
				 b: evector;
				 test, length: longreal;
				 spar: sparseptr;
				 
		 {__________________________________________________________________________}
		 
		 procedure remove_it;
		    var obp: objptrptr;
				begin
						get_ob(obp, nameobj, true);
						ob := obp^;
						obp^ := ob^.next;
						free_obj(ob)
				end;
								
		 {__________________________________________________________________________}

	   procedure carve_it(ob, knife: objptr; b: evector);
	   
				var i: integer;
						fv: f_vector;
						cen: evector;
						gp: polygon_ptr;
//wwh						mykeys: KeyMap;  { May 1997 }
				
				procedure moveup(var tp: polygon_ptr; num: integer);
				   { tp not nil on input. }
					 var i: integer;
					 begin
					    for i := 1 to num do
							   begin
								    tp := tp^.gg;
										if tp = nil
										   then break
								 end
					 end;
					 
			  begin				 
					 
					 for i := 0 to 39 do
					    begin
							   gp := knife^.gons;
								 moveup(gp, i);
								 while gp <> nil do
										begin
											 if gp^.rank < 3
													then error(275, nameknife);
											 with gp^ do
													begin
														 fv[1] := x;
														 fv[2] := y;
														 fv[3] := z;
														 cen[1] := xcen;
														 cen[2] := ycen;
														 cen[3] := zcen
													end;
											 fv[4] := dotprod(cen, fv);
											 test := dotprod(b, fv);
											 if test = fv[4]
													then error(274, nameknife);
											 testside := (test < fv[4]);
											 test := flength(fv, 3);
											 if test = 0
													then error(269, nameknife);
											 single_cut(ob, 3, fv, test, testside, killed, false);
											 if killed
													then begin
																	remove_it;
																	exit {(carve_it)}
															 end;
(*											 if command_int
												  then begin
												          GetKeys(mykeys);
												          if mykeys[55]  { cmd }
														         then begin
														                 if ob^.shaded and (ob^.gons <> nil)
																						    then sort_polygons(ob);
																						 if mykeys[56]  { shift }
					                                      then error(0, blank)
																		            else error(-1, blank)
																					end
															 end;
*)
											 moveup(gp, 40)
										end
							end;
					 
					 if ob^.shaded and (ob^.gons <> nil)
					    then sort_polygons(ob)
							
				end;
				
     {_____________________________________________________________________________}

     begin
		 
		    get_object(inf, n, flag, ob, nameobj);
				if token.name <> ','
					 then error(202, token);
				if ob^.quads <> nil
				   then error(242, token);
				spar := nil;
				if carve
				   then begin
					         actual_getob(inf, n, flag, obp, nameknife, true);
									 knife := obp^;
									 if not (ob^.threeD and knife^.threeD)
									    then error(271, token);
									 if knife^.obarray
									    then error(272, nameknife);
									 if (knife^.quads <> nil) or (knife^.first <> nil) or (knife^.line <> nil)
										  or (knife^.gons = nil)
											then error(272, nameknife);
									 if (ob^.sintheta <> knife^.sintheta) or (ob^.z_cosine <> knife^.z_cosine)
											or (ob^.xscale <> knife^.xscale) or (ob^.yscale <> knife^.yscale)
											or (ob^.zscale <> knife^.zscale)
											then error(273, token);	
									 dim := 3
								end;
		    new_worknode(r, token);
			  arr := workhead[r];
        if not carve
				   then begin
					          arr_facts[1] := 0;
										scanner(inf, token, flag);
										arr_fact(inf, n, arr^, arr_facts, arr_free, r, flag, spar);
										if spar <> nil
										   then error(288, token);
										if ob^.threeD
											 then if not (arr_facts[1] = 4)
															 then error(223, token)
															 else 
											 else if not (arr_facts[1] = 3)
															 then error(223, token);
										if ob^.threeD
											 then dim := 3
											 else dim := 2;
										a[4] := 0;
										for i := 0 to dim do
											 a[i+1] := quoly_convert_to_ext(arr^[i]);
										if arr_free 
											 then free_arr(arr^, arr_facts);
										length := flength(a, dim);
										if length = 0
											 then error(269, token)
								end;

				arr_facts[1] := 0;
				if token.name <> ','
				   then error(202, token);
				scanner(inf, token, flag);
				arr_fact(inf, n, arr^, arr_facts, arr_free, r, flag, spar);
				if spar <> nil
					 then error(288, token);
				if threedim
				   then if not (arr_facts[1] = 3)
					         then error(223, token)
									 else 
					 else if not (arr_facts[1] = 2)
					         then error(223, token);
				if token.name <> ')'
					 then error(1, token);
				b[3] := 0;
				for i := 0 to dim-1 do
				   b[i+1] := quoly_convert_to_ext(arr^[i]);
				if arr_free 
					 then free_arr(arr^, arr_facts);
				free_work;
				scanner(inf, token, flag);
				quoly_set(0, n);
				
				if carve
				   then begin
					         carve_it(ob, knife, b);
									 exit {(cut_object)}
								end;
				
				test := 0;
			  for i := 1 to dim do
					 test := test + a[i]*b[i];
				if test = a[dim+1]
				   then error(235, token);
				testside := (test < a[dim+1]);
							
				allkilled := true;
				if ob^.obarray
				   then for i := ob^.init to ob^.final do
					         begin
									    single_cut(obstash^[i], dim, a, length, testside, killed, true);
											if killed
											   then begin
												         obstash^[i]^.next := obj_garb;
				                         obj_garb := obstash^[i];
																 obstash^[i] := nil
															end
												 else allkilled := false;
											if command_int 
												 then check_cmd_keys
									 end
					 else single_cut(ob, dim, a, length, testside, killed, true);
				
				if ob^.obarray
				   then if allkilled
					         then cancel_obj_array(ob)
									 else
					 else if killed
									 then remove_it
									 else if ob^.solid
													 then begin
																	 for i := 1 to 3 do
																			a[i] := a[i]/length;
																	 if not testside
																			then for i := 1 to 3 do
																							 a[i] := - a[i];
																	 with ob^ do
																			for i := 1 to 3 do
																					bias[i] := bias[i] + a[i];
																	 enormalize(ob^.bias)
																end
		 
		 end;
		 
  {**************************************************************************}

  procedure del_object(var inf: text; var n: quoly; var flag: nameptr);
											 
	   var obp: objptrptr;
		     ob: objptr;
		     nameobj: tokentipe;
		 
		 begin
		 
		    scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				actual_getob(inf, n, flag, obp, nameobj, false);
			  if token.name <> ')'
					 then error(1, token);
				scanner(inf, token, flag);
				quoly_set(0, n);
				
				if obp = nil
				   then exit {(del_object)};
				ob := obp^;
				if ob = nil
				   then exit {(del_object)};
				obp^ := ob^.next;
				
				if ob^.obarray
				   then cancel_obj_array(ob)
				   else free_obj(ob)
				
		 end;
									 
	 {*************************************************************************}
 
	 procedure union(var inf: text; var n: quoly; var flag: nameptr; its_join: boolean);
	 
	    { Unite two objects.  Must have only points and polygons and agree in viewing 
			  angle and scaling.  Complicated by object arrays. }
				
			var obp: array[1..3] of objptrptr;
					obname: array[1..3] of tokentipe;
					join, ob: objptr;
					dumm: objptrptr;
					p: polygon_ptr;
					i: integer;
					duplicate: boolean;
			
			{______________________________________________________________________}
			
			procedure check_them(i: integer);
			   begin
				    if obp[i]^^.obarray 
				       then error(276, obname[i]);  {```}
						if obp[i]^^.quads <> nil  {```}
						   then error(265, obname[i]);
						if its_join   {```}
						   then if (obp[i]^^.line <> nil) or (obp[i]^^.first <> nil)
						           then error(281, obname[i]);
						if i = 2
						   then if (obp[1]^^.sintheta <> obp[2]^^.sintheta) or (obp[1]^^.z_cosine <> obp[2]^^.z_cosine)
							         or (obp[1]^^.xscale <> obp[2]^^.xscale) or (obp[1]^^.yscale <> obp[2]^^.yscale)
											 or (obp[1]^^.zscale <> obp[2]^^.zscale) or (obp[1]^^.threeD <> obp[2]^^.threeD)
				               then error(266, token)				 
				 end;
				 
			{______________________________________________________________________}
			
			function minmum(x, y: longreal): longreal;
			   begin
				    if x < y
						   then minmum := x
							 else minmum := y
				 end;
			
			{______________________________________________________________________}
			
			function maxmum(x, y: longreal): longreal;
			   begin
				    if x > y
						   then maxmum := x
							 else maxmum := y
				 end;
			
			{______________________________________________________________________}
			
			procedure message;
			   begin
					  if flag = nil
							 then begin
											writeln(userOutput, '*** Warning. Possible creation of dangling pointer.');
											flush(userOutput)
									  end
				 end;
																												
			{______________________________________________________________________}
			
			procedure freeob_3(i: integer);
			   begin
					  ob := obp[3]^;
					  obp[3]^ := ob^.next;
					  free_obj(ob);
					  ob := obp[i]^;
					  message;  
					  obp[3] := nil
				 end;
														
			{______________________________________________________________________}
			
			procedure freeob(i: integer);
			   begin
				    obp[i]^ := ob^.next;
						ob^.next := obj_garb;
						obj_garb := ob
				 end;
										
			{_____________________________________________________________________}
				 
			begin
			
			   scanner(inf, token, flag);
				 if token.name <> '('
					  then error(177, token);
				 actual_getob(inf, n, flag, obp[1], obname[1], true);
			   if token.name <> ','
					  then error(202, token);
				 actual_getob(inf, n, flag, obp[2], obname[2], true);
			   if token.name <> ','
					  then error(202, token);
				 actual_getob(inf, n, flag, obp[3], obname[3], false);
				 { obp[3] can be nil, but only if statement was Union(,,s) where no object
				   named s exists.  obp[3]^ can be nil if it was Union(,,s[i]) }
			   if token.name <> ')'
					  then error(1, token);
					 
				 scanner(inf, token, flag);
				 quoly_set(0, n);
				 				 
				 { check for duplicates and compatability }
				 if obp[1]^ = obp[2]^
				    then error(267, obname[1]);
				 for i := 1 to 2 do
				    check_them(i);
				 if (obp[3] <> nil) and (obp[3]^ <> nil) and obp[3]^^.obarray
				    then error(276, obname[3]);  {```}
				 duplicate := false;
				 if (obp[3] <> nil) and (obp[3]^ <> nil)
				    then if (obp[1]^ = obp[3]^) or (obp[2]^ = obp[3]^)
						        then duplicate := true;
				 { Note:  looks like obp[1]^ = obp[3]^ is possible only if 
				   obp[1] = obp[3]. will assume this. }
				 if its_join and (obp[1]^^.shaded or obp[2]^^.shaded) and (flag = nil)
				    then begin
						        writeln(userOutput, ' Warning.  At least one of the objects is shaded.  Join');
										writeln(userOutput, '    usually produces garbage in that case.');
										flush(userOutput)
								 end;
				 				 
				 { union/join together under "obp[1]^" }
				 newobj(join);
				 join^ := obp[1]^^;
				 ob := obp[2]^;
				 with join^ do
				    begin
						   name := obname[3].name;
							 obarray := false;
							 shaded := false;
							 solid := its_join or (solid and ob^.solid);  {``` remove last = nil}
							 xmin := minmum(xmin, ob^.xmin);
							 xmax := maxmum(xmax, ob^.xmax);
							 ymin := minmum(ymin, ob^.ymin);
							 ymax := maxmum(ymax, ob^.ymax);
							 zmin := minmum(zmin, ob^.zmin);
							 zmax := maxmum(zmax, ob^.zmax);
							 if line = nil
							    then line := ob^.line
									else lasline^.next := ob^.line;
							 if ob^.line <> nil
							    then lasline := ob^.lasline;
							 if ob^.gons = nil
							    then { nothing }
							 else if gons = nil
							    then begin
									        gons := ob^.gons;
													lastgon := ob^.lastgon;
												  headvert := ob^.headvert;
													endvert := ob^.endvert
											 end
							 else begin
							         lastgon^.gg := ob^.gons;
							         lastgon := ob^.lastgon;
							         endvert^.cp := ob^.headvert;
							         endvert := ob^.endvert
										end
						end;
						
				 { Take care of points for Union. ```}
				 if ob^.first = nil
				    then { nothing; takes care of Join also. }
					  else if join^.first = nil
										then begin
														join^.first := ob^.first;
														join^.last := ob^.last;
														join^.final := ob^.final
												 end
									  else union_points(join, ob);
				 				 
				 with join^ do
				    if its_join
							 then for i := 1 to 3 do
											 bias[i] := 0
							 else begin
							         for i := 1 to 3 do
										      bias[i] := bias[i] + ob^.bias[i];
											 enormalize(bias)
										end;
												
				 p := ob^.gons;
				 
				 { free old nodes. This is subtle!  Problems when obp[i] is a "neighbor"  
				   of obp[j]. But that's very unlikely with revised symbol table objlist. }
				 ob := obp[1]^;
				 if @ ob^.next = obp[2]
					  then begin  { Put obp[2] earlier in list than obp[1] }
									  dumm := obp[2];
									  obp[2] := obp[1];
									  obp[1] := dumm;
									  ob := obp[1]^
								 end;
				 if duplicate
				    then begin
						        freeob(1);
						        ob := obp[2]^;
										if @ ob^.next = obp[1] 
										   then begin
											         message;
															 if obp[1] = obp[3]
															    then obp[3] := nil
														end;
										freeob(2)
						     end
						else begin
						        if @ ob^.next = obp[3]
										   then freeob_3(1);
										freeob(1);
										ob := obp[2]^;
										if @ ob^.next = obp[1]
										   then message;
										if @ ob^.next = obp[3]
										   then freeob_3(2);
								    freeob(2)
								 end;
								 
				 if not duplicate and (obp[3] <> nil) and (obp[3]^ <> nil)
				    then begin
						        ob := obp[3]^;
										if @ ob^.next = obp[1]
										   then message;
										if @ ob^.next = obp[2]
										   then message;
										obp[3]^ := ob^.next;
										free_obj(ob)
								 end;
				 
				 { put it in the symbol table }
				 if obp[3] = nil
				    then begin
						        i := hash2(join^.name, 151);
									  join^.next := objlist[i];
										objlist[i] := join
								 end
						else begin
						        join^.next := obp[3]^;
										obp[3]^ := join
								 end;
						
				 if its_join
				    then join_obj(join, p)  { finish the join operation }  
						
			end;	 	 
	 
	{****************************************************************************}
	
	procedure window(var inf: text; var n: quoly; var flag: nameptr);

     var x: evector;
				 i: integer;
				 w: longreal;
		 
		 begin
		   
			  scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				w := 0;
				for i := 1 to 3 do
				   begin
							scanner(inf, token, flag);
							old_expre(inf, n, flag);
							x[i] := quoly_convert_to_ext(n);
							w := w + sqr(x[i]);
							if (i = 2) and not threedim
							   then begin
								         x[3] := 0;
												 break
											end;
							if i < 3
							   then if token.name <> ','
								         then error(202, token);
					 end;
				if token.name <> ')'
					 then error(1, token);
				scanner(inf, token, flag);
				
				w := sqrt(w);
				if w > 0
				   then for i:= 1 to 3 do
					         x[i] := x[i]/w;
				thelight := x
		 
		 end;

  {***************************************************************************}

	procedure shadequad(s: sidesptr; needbottom, erase: boolean);
		 var i: integer;
				 side1, side2, normal: evector;
				 length: longreal;
		 begin
				if needbottom
				   then s^.bottom := penult;
				thequad := OpenPoly;
					 MoveTo(s^.left^.abscoord[1], s^.left^.abscoord[2]);
					 LineTo(s^.top^.abscoord[1], s^.top^.abscoord[2]);
					 LineTo(s^.right^.abscoord[1], s^.right^.abscoord[2]);
					 LineTo(s^.bottom^.abscoord[1], s^.bottom^.abscoord[2]);
				ClosePoly;

				if not erase
				   then begin
					        { compute vectors on 2 sides of quad.  careful of orientations! }
									for i := 1 to 3 do
										 side1[i] := s^.left^.locoord[i+3] - s^.left^.locoord[i];
									for i := 1 to 3 do
										 side2[i] := s^.bottom^.locoord[i] - s^.bottom^.locoord[i+3];

									{ take cross product of side vectors to make unit normal }
									normal[1] := side1[2]*side2[3] - side1[3]*side2[2];
									normal[2] := side1[3]*side2[1] - side1[1]*side2[3];
									normal[3] := side1[1]*side2[2] - side1[2]*side2[1];

									enormalize(normal);

									{ dot with standard illumination source }
									length := 0;
									for i := 1 to 3 do
										 length := length + normal[i]*thelight[i];

									{ compute illumination factor and shade it }
									i := 1;
									while length < shadefactor[i] do
										 Inc(i)
							 end;

				if erase
				   then ErasePoly(thequad)
					 else begin
					         FillPoly(thequad, thepatt[i]);
{wwh unneeded with Delphi
				           FramePoly(thequad) }
								end;
				KillPoly(thequad);

				savescreen := true
		 end;

	 {************************************************************************}

	 procedure zoom_one(ob: objptr; factor: longreal; showit: boolean);

			var cp: coordptr;
			    gp: polygon_ptr;
					k: integer;
					xfact, yfact, zfact, xsine, ysine: longreal;

			 {____________________________________________________________________}
	 
			 procedure get_rs(x, y, z: longreal; var r, s: integer);
					begin
						  if ob^.threeD
								 then begin
												 r := round(yfact*y - xfact*x); 
												 s := - round(zfact*z - xsine*x - ysine*y)
											end
								 else with ob^ do
												 begin
														r := round(xscale*x);
														s := - round(yscale*y);
												 end
					end;
					
			 {____________________________________________________________________}
	 
			begin
					
				 if ob = nil
					  then exit {(zoom_one)};
				 zoom_most(ob, factor, showit);
				 
				 if (ob^.quads <> nil) and ob^.shaded  { if not shaded, nothing is needed! }
					  then begin
									  purge_hidden(ob, false);
									  dist_sort_quads(ob^.quads, ob^.init);
									  for k := 1 to ob^.init do
										   shadequad(ob^.quads^.quad[k].q, false, false);
									  compute_hidden_lines(ob, true)
								 end;								
							
				 if ob^.gons = nil
					  then exit {(zoom_one)};
						
				 with ob^ do
				    begin
						   yfact := yscale*costheta;
							 xfact := xscale*costheta;
							 zfact := zscale*z_cosine;
							 xsine := xscale*sintheta;
							 ysine := yscale*sintheta
						end;
				 cp := ob^.headvert;
				 ob^.endvert^.cp := nil;
				 while cp <> nil do
					  begin
							 with cp^ do
								  begin
										 x := factor*x;
										 y := factor*y;
										 z := factor*z;
										 get_rs(x, y, z, a, b)
								  end;
							 cp := cp^.cp
					  end;
						 
				if ob^.threeD
				   then with ob^ do
									 begin
											xmin := xmin*factor;
											xmax := xmax*factor;
											ymin := ymin*factor;
											ymax := ymax*factor;
											zmin := zmin*factor;
											zmax := zmax*factor
									 end;
					 
				gp := ob^.gons;
				while gp <> nil do
				   begin
					    with gp^ do
							   begin
								    xcen := xcen*factor;
										ycen := ycen*factor;
										zcen := zcen*factor;
										radius := radius*factor
								 end;
							if showit
								 then if ob^.shaded
												 then shadepoly(gp, true)
												 else show_one_unshaded(gp);
							gp := gp^.gg
					 end
																														 
		 end;
		 
	{****************************************************************************}
	
	procedure do_trans_one(ob: objptr; erasetoo, showit: boolean; var ex: extarray);
  
	   var gp: polygon_ptr;
				 cp: coordptr;
				 k, r, s: integer;
		 
		 {_______________________________________________________________________}
	 
			procedure get_rs(x, y, z: longreal);
					begin
						 if ob^.threeD
								 then begin
												 r := round((ob^.yscale*y - ob^.xscale*x)*costheta);
												 s := - round(ob^.zscale*z*ob^.z_cosine - (ob^.xscale*x + ob^.yscale*y)*ob^.sintheta)
											end
								 else begin
												 r := round(ob^.xscale*x);
												 s := - round(ob^.yscale*y);
											end
					end;
					
		 {________________________________________________________________________} 
					
		 begin
		 
				if (ob^.quads <> nil) and ob^.shaded and erasetoo
					 then for k := 1 to ob^.init do
									 shadequad(ob^.quads^.quad[k].q, false, true);
																			
				trans_one(ob, erasetoo, showit, ex);  { does all but polygon and quad parts }
				get_rs(ex[0], ex[1], ex[2]);
								
				if (ob^.quads <> nil) and ob^.shaded  { if not shaded, nothing is needed! }
					 then begin
									 purge_hidden(ob, false);
									 if showit
											then begin
															dist_sort_quads(ob^.quads, ob^.init);
															for k := 1 to ob^.init do
																 shadequad(ob^.quads^.quad[k].q, false, false);
															compute_hidden_lines(ob, true)
													 end;
									 exit {(do_trans_one)}
								end;
												
				if erasetoo
				   then begin
					         gp := ob^.gons;
									 SetPenShade(psWhite);
									 while gp <> nil do
											 begin
													define_polygon(gp, false);
													if ob^.shaded
													   then ErasePoly(thequad)
                          else                 //wwh
  													FramePoly(thequad);
													KillPoly(thequad);
													gp := gp^.gg
											 end;
									 RestorePenShade
								end;

				gp := ob^.gons;
				if gp <> nil
				   then with ob^ do
					         begin
									    xmin := xmin + ex[0];
									    xmax := xmax + ex[0];
											ymin := ymin + ex[1];
									    ymax := ymax + ex[1];
											zmin := zmin + ex[2];
									    zmax := zmax + ex[2];
									 end;
				while gp <> nil do
				   begin
							with gp^ do
								 begin
										xcen := xcen + ex[0];
										ycen := ycen + ex[1];
										zcen := zcen + ex[2]
								 end;
							cp := gp^.cp;
							for k := 1 to gp^.rank do
							   begin
								    with cp^ do
										   begin
											    x := x + ex[0];
													y := y + ex[1];
													z := z + ex[2];
													a := a + r;
													b := b + s
											 end;
										cp := cp^.cp
								 end;
							if showit
							   then begin
								         define_polygon(gp, true);
												 if ob^.shaded
												    then if wantcolor and wantsolid { Jan 1998 }
												           then My_PaintPoly(gp)
												           else FillPoly(thequad, thepatt[get_shading(gp)])
                         else   //wwh
  												 FramePoly(thequad);
												 KillPoly(thequad)
								      end;
							gp := gp^.gg
					 end

    end;

	{****************************************************************************}
	
	procedure translate(var inf: text; var n: quoly; var flag: nameptr; erasetoo: boolean);
	
	   var ob: objptr;
				 x: extarray;
				 i: integer;
				 nameobj: tokentipe;
				 		 
		 begin
		 
				get_object(inf, n, flag, ob, nameobj);
				for i := 0 to 2 do
				   begin
					    if token.name <> ','
								 then error(202, token);
							scanner(inf, token, flag);
							old_expre(inf, n, flag);
							x[i] := quoly_convert_to_ext(n);
							if (i=1) and not ob^.threeD
							   then begin
								         x[2] := 0;
												 break
											end
					 end;
				if token.name <> ')'
					 then error(1, token);
				
				if ob^.obarray
				   then for i := ob^.init to ob^.final do
									 begin
									    do_trans_one(obstash^[i], false, false, x);
											if command_int
												 then check_cmd_keys
									 end
					 else do_trans_one(ob, erasetoo, true, x);

				scanner(inf, token, flag);
				quoly_set(0, n)
				
		 end;
						 
  {*************************************************************************}

	procedure arrayarg(x: tokentipe; var n: quoly; var newar: arrptr; var inf: text; 
										 var flag: nameptr; var its_array_arg: boolean); forward;
										 
  {*************************************************************************}
	
	procedure get_qp_n(var qp: quolyptr; var inf: text; var flag: nameptr; 
										 var n: quoly; mytok: tokentipe);  forward;
										 
  {*************************************************************************}
	
	procedure newnode(var p: numptr);

    begin
		
      if numhead = nil
         then new(p)
         else begin
                 p := numhead;
                 numhead := numhead^.next;
              end
						 
		end;
		
	{*************************************************************************}

  procedure obj_param(var obp: objptrptr; var inf: text; var flag: nameptr; var n: quoly);
	
	   var objname: tokentipe;
		 
		 begin
		 
		    actual_getob(inf, n, flag, obp, objname, true);
				quoly_set(0, n)
		 
		 end;
	
	{*************************************************************************}
	
	procedure spec_setargs(p: paramptr; var flag: nameptr; var n: quoly;
	                       var val: quol_array; var inf: text; var v: varp_array; 
												 var loc: loc_array);
		
	 { This procedure allows for local variables: once ')' is seen in
		 the argument list, all remaining formal parameters are set to 0 -
		 i.e., they become local variables .  Same thing if there is no	argument list. 
		    v is nilled upon entry. 
				
		 Used only by surface plotting. }

		var q, temp: varptr;
				s: arrptr;
				qp: quolyptr;
				obp: objptrptr;
				np: numptr;
				its_array_arg, thisone, turnon: boolean;
				i, j: integer;
												
		begin 

			thisone := false;
			turnon := false;
			i := 1;
			j := 1;
			s := nil;
			temp := nil;
			scanner(inf, token, flag);
			if token.name <> '(' { programmer has passed no arguments. Thats ok-
											       all params are local vars.}
				 then begin
								 if token.name <> ')'
										then error(222, token);
								 turnon := true
							end;
					
			{ Create linked list of arguments, pointed to by temp.  
				WHEN ALL FINISHED attach these to the store array. }
			while p <> nil do
				 begin
						if its_a_polyname(p^.let.name)
							 then error(125, p^.let);
						thisone := turnon and (i < 3);
						its_array_arg := false;   { could be changed by arrayarg }
						if p^.result
							 then get_qp_n(qp, inf, flag, n, p^.let)
						else if p^.isobject
							 then obj_param(obp, inf, flag, n)
						else if token.name <> ')'
										 then begin
														 scanner(inf, token, flag);
														 if token.name = '['
																then arrayarg(p^.let, n, s, inf, flag, its_array_arg)
														 else if token.name = '' 
																		 then begin
																						 if i > 2
																								then error(216, token);
																						 free_quoly(n);
																						 n := val[i];
																						 val[i] := nil;
																						 thisone := true;
																						 scanner(inf, token, flag);
																					end
														 else old_expre(inf, n, flag)
													end
										 else if thisone
														 then begin
																		 free_quoly(n);
																		 n := val[i];
																		 val[i] := nil
																	end
														 else quoly_set(0, n);
						if var_garb = nil
							 then new(q)
							 else begin
											 q := var_garb;
											 var_garb := var_garb^.next
										end;											
						q^.let := p^.let;
						if thisone
							 then begin
											 v[i] := q;
											 Inc(i)
										end
							 else begin
							         if j > 15
											    then error(249, token);
											 loc[j] := q;
											 Inc(j)
							      end;
						if p^.result
							 then q^.qp := qp
							 else if p^.isobject
											 then q^.obj := obp;
						if its_array_arg
								 then n^.ncoef^.size := -1742  { universal flag }
								 else if n^.numb
												 then n^.ncoef^.size := 0;
						q^.val := n;
						
						{ assign p^.qp for eventual compilation. Need to be careful
								about array args. }
						if its_array_arg and (s^.spar <> nil)
						   then error(288, token);  { Is this really necessary? Jan 30 1993 }
				    if its_array_arg
							 then if p^.arry { was array arg last time too }
											 then begin
															 np := numptr(p^.qp);
															 np^.value := s^.start - addresser;
															 np^.next^.value := s^.rows
														end
											 else begin
															 newnode(np);
															 np^.value := s^.start - addresser;
															 newnode(np^.next);
															 np^.next^.value := s^.rows;
															 p^.arry := true;
															 p^.qp := quolyptr(np)
														end
							 else if p^.arry
											 then begin
															 np := numptr(p^.qp);
															 np^.next^.next := numhead;
															 numhead := np;
															 p^.arry := false;
															 p^.qp := @ q^.val
														end
											 else p^.qp := @ q^.val;
						q^.next := temp;
						if its_array_arg          
							 then p^.sparse := (s^.spar <> nil);  { Is this really necessary? Jan 30 1993 }
						temp := q;
						p := p^.next;
						n := nil;
						if (token.name <> ',') and (token.name <> ')') and (p <> nil)
							 then error(14, token);
				 end;
				
			if token.name <> ')'
				 then error(15, token);
				 
			{ attach to symbol table. }
			attach_symbols(q, s);
			
		  if not turnon
			   then scanner(inf, token, flag)
				
		end;

	{***************************************************************************}

	procedure eval_form(var inf: text; q: formptr; var n: quoly); forward;

  {*******************************************************************}

  procedure sub(var n1, n2, n3: number);

    begin
		
			 n3.float := n1.float - n2.float;
						
			 if complex
			    then if (n1.imag = nil) and (n2.imag = nil)
									then imag_free(n3)
									else if n1.imag = nil
													then begin
																	 if n3.imag = nil
																			then newimag(n3.imag);
																	 n3.imag^.float := -n2.imag^.float
															 end
									else if n2.imag = nil
													then imag_assign(n1, n3)
									else begin
													if n3.imag = nil
														 then begin
																		 newimag(n3.imag);
																		 n3.imag^.imag := nil
																	end;
													n3.imag^.float := n1.imag^.float - n2.imag^.float;
													if n3.imag^.float = 0
														 then imag_free(n3)
											 end

		end;
		
  {**********************************************************************}

  procedure mult(var n1, n2, n3: number);
	
	 { On entry, n3 could be nilled out, or might be n1, or might be something else. }

		var	n4, n5, n6: longreal;

    begin
		
  	  if command_int 
			   then check_cmd_keys;
     
      n4 := n1.float * n2.float;
				 
			if complex
			   then if (n1.imag = nil) and (n2.imag = nil)
				    then begin
						        imag_free(n3); 
										n3.float := n4
								 end
					  else if n2.imag = nil
						        then begin
										         n3.float := n2.float * n1.imag^.float;
														 if n3.float = 0
														    then imag_free(n3)  
																else slide_over(n3);
														 n3.float := n4										 
												 end
						else if n1.imag = nil
						        then begin
										         n3.float := n2.imag^.float * n1.float;
														 if n3.float = 0
														    then imag_free(n3)
																else slide_over(n3);
														 n3.float := n4	
												 end
						else begin
						        n5 := (n1.float + n1.imag^.float) * (n2.float + n2.imag^.float);
										n6 := n1.imag^.float * n2.imag^.float;
										
										{ create imaginary part of answer }
										n5 := n5 - n4 - n6;
										
										{ create real part of answer }
										n3.float := n4 - n6;
										
										if n5 = 0
										   then imag_free(n3)
											 else begin
										           if n3.imag = nil
															    then newimag(n3.imag);
										           n3.imag^.float := n5
														end
                 end
								 
				else begin
				        n3.float := n4;
								n3.imag := nil  { not sure this is necessary. Oct 1994 }
						 end
						 
    end; 

  {**********************************************************************}

  procedure quot(var n1, n2, n3: number);
	
	  var n4, n5, n6, n7: longreal;

	 { Revised Oct 22, 1994. Now n2 could be n3, n1 could be n2, n1 could be n3.
	   This procedure is very delicate!  Careful of changing ANYTHING! }

    begin

			if complex
			   then if n2.imag = nil
								 then begin  
												 if n2.float = 0
														then error(22, token);
												 if n1.imag <> nil  { n1 can't be n2 }
														then begin
																		if n3.imag = nil
																			 then newimag(n3.imag);
																		n3.imag^.float := n1.imag^.float / n2.float
																 end;
												 n3.float := n1.float / n2.float
											end
								 else begin
												 n5 := -n2.imag^.float;  { Note minus }
												 n4 := sqr(n5) + sqr(n2.float);
												 if n1.imag = nil
														then if n1.float = 0
														        then begin
																		        imag_free(n3);
																						n3.float := 0
																				 end
																		else begin
														                if n3.imag = nil
																							 then newimag(n3.imag);
														                n3.imag^.float := n1.float*n5/n4;
																						n3.float := n1.float*n2.float/n4
																         end
														else begin
														        n6 := n1.imag^.float * n5;
																		n5 := (n1.float + n1.imag^.float) * (n2.float + n5);
																		n7 := n1.float * n2.float;

																		{ create imaginary part of answer }
																		n5 := (n5 - n7 - n6)/n4;
																		
																		{ create real part of answer }
																		n3.float := (n7 - n6)/n4;
																		
																		if n5 = 0
																			 then imag_free(n3)
																			 else begin
																							 if n3.imag = nil
																									then newimag(n3.imag);
																							 n3.imag^.float := n5
																						end
																 end
											end
													
				else begin
				        if n2.float = 0
								   then
                      Raise EZeroDivide.Create('Division by zero in quot');
							  n3.float := n1.float / n2.float
						 end
						
		end;
								
  {**************************************************************************}

  procedure poly_add(n, m: ferm118.poly; var p: ferm118.poly); 
 
    var q, t, r, s: ferm118.poly;
		    first: boolean;
				
	 {________________________________________________________________}
				
		procedure append_one(var x: ferm118.poly);

       begin			 
					
					if x^.numb
					   then if ferm118.iszero(x^.ncoef^)
						         then begin
										         x := nil;
														 exit {(append_one)}
													end;
					s := x^.next;
					x^.next := nil;
					poly_assign(x, r);
					x^.next := s;
					if first 
						 then begin
									   q := r;
										 first := false
									end
					   else t^.next := r;
					t := r;
					x := s
					
			 end;

    {_____________________________________________________________}
		
		procedure add_numb(var x,y: ferm118.poly);
		
		   { x is a number, y is not. Both have exponent 0. }
		
		   var r: ferm118.poly;
			 
			 begin
			 
					if first
						 then begin
										 newpoly(q);
										 first := false;
									   t := q
									end
					else begin
									newpoly(t^.next);
								  t := t^.next
							 end;
					t^.numb := false;
					t^.exp := y^.exp;
					t^.pcoef := nil;
					r := x^.next;
					if laurent
					   then x^.next := nil;
					poly_add(x, y^.pcoef, t^.pcoef);
					if laurent
					   then x^.next := r;
					x := r;
					y := y^.next
					
			 end;
			 
		{___________________________________________________________________}
		
		procedure expand;
		
		   { Add poly node on top of r and reset r to this node. }
		
		   begin
			    
					if r^.numb and (r^.next = nil) and (n^.exp = 0)
					   then { do nothing }
						 else begin
			               newpoly(s);
					           s^.numb := false;
					           s^.exp := n^.exp;
					           s^.pcoef := r;
					           s^.next := nil;
					           r := s
									end
					
			 end;
			 
		{__________________________________________________________________}
		
		procedure do_numbs;
		
		   begin
			 
					if first
					   then begin
						         newpoly(q);  { don't turn first off yet }
									   t := q;
									end
						 else begin
						         newpoly(t^.next);
										 s := t;  { may need this later }
					           t := t^.next;
									end;
					t^.exp := 0;
	        t^.numb := true;
					newimag(t^.ncoef);
					t^.ncoef^.imag := nil;
					add(n^.ncoef^, m^.ncoef^, t^.ncoef^);
					if ferm118.iszero(t^.ncoef^)
						 then begin    
						         t^.next := nil;
						         free_poly(t); 
										 if first
										    then q := nil
												else t := s
									end					 
					   else first := false;
					n := n^.next;
					m := m^.next
								
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on(x: ferm118.poly);
		
		   begin
			    
					if x^.numb
	           then if ferm118.iszero(x^.ncoef^)
						         then exit {(tack_on)};
					if first
					   then poly_assign(x, q)
					   else poly_assign(x, t^.next)
					
			 end;
			 
		{___________________________________________________________________}
						          
    begin  { of poly_add }

        q := nil;		
		    if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
					         newpoly(q);
									 q^.next := nil;
									 q^.numb := true;
									 q^.exp := 0;
					         newimag(q^.ncoef);
									 q^.ncoef^.imag := nil;
								   add(n^.ncoef^, m^.ncoef^, q^.ncoef^)
								end
				else begin
				        first := true;
								t := nil;
				        repeat
								   r := nil;
								   if n^.exp > m^.exp
									    then append_one(n)
									 else if m^.exp > n^.exp
									    then append_one(m)
									 else if n^.numb and m^.numb
									    then do_numbs
									 else if n^.numb
									    then add_numb(n, m)
									 else if m^.numb
									    then add_numb(m, n)
									 else begin
													 poly_add(n^.pcoef, m^.pcoef, r);
													 if poly_iszero(r)
													    then free_poly(r)
													    else if first
															        then begin
																			        expand;
																			        q := r;
																							t := q;
																							first := false
																					 end
																	 else begin
																	         expand;
																	         t^.next := r;
																					 t := r
																				end;
															
													 n := n^.next;
													 m := m^.next 
									      end
								until (n=nil) or (m=nil);
								
								if t <> nil
								   then t^.next := nil;
								if n <> nil
								   then tack_on(n)
								else if m <> nil
								   then tack_on(m);
								if q = nil
								   then poly_set(0, q)
					end;
					
			 free_poly(p);
			 p := q

		end;
		
{**************************************************************************}

 procedure better_poly_add(n, m: ferm118.poly; var p: ferm118.poly);

   { Gobble up n to save reallocation of space. m must not be touched. 
	   Nodes not used will be put on a garbage list and freed at the end.  
		 p always points to n or m, or is initially nil  Therefore, never need to free
		 p at end before changing it to answer. } 
 
    var q, t, r, s, garb, tail: ferm118.poly;
		    first: boolean;
				
	 {________________________________________________________________}
				
		procedure take_one_m; { duplicate one node }

       begin
			 
					if m^.numb
					   then if ferm118.iszero(m^.ncoef^)
						         then begin
										         m := nil;
														 exit {(take_one_m)}
													end;
				  s := m^.next;
					m^.next := nil;
					r := nil;
					poly_assign(m, r);
					m^.next := s;
					if first 
						 then begin
									   q := r;
										 first := false
									end
					else t^.next := r;
					t := r;
					m := s
					
			 end;
	 {________________________________________________________________}
				
		procedure take_one_n;  { just gobble up }

       begin
			 					
					if n^.numb
					   then if ferm118.iszero(n^.ncoef^)  { entire poly n MUST be 0 }
						         then begin
										         free_poly(n);
														 exit {(take_one_n)}
													end;
					if first 
						 then begin
									   q := n;
										 first := false
									end
					   else t^.next := n;
					t := n;
					n := n^.next
					
			 end;

    {_____________________________________________________________}
		
		procedure add_numb_m_n;
		
		  { m is a number and n isn't, but has exponent 0. Gobble up n. }
		
		   var r: ferm118.poly;
			 
			 begin
			 
					if first
						 then begin
						         first := false;
										 q := n
									end
					   else t^.next := n;
					t := n;
					r := m^.next;
					if laurent
					   then m^.next := nil;
					better_poly_add(n^.pcoef, m, n^.pcoef);
					if laurent
					   then m^.next := r;
					m := r;
					n := n^.next
					
			 end;
			 
    {_____________________________________________________________}
		
		procedure add_numb_n_m;  { n is a number, m isn't. }
		
		   var s: ferm118.poly;
		
		   begin
			 
					if first
						 then begin
										 newpoly(q);
										 first := false;
									   t := q
									end
					else begin
									newpoly(t^.next);
								  t := t^.next
							 end;
					t^.numb := false;
					t^.exp := 0;
					t^.pcoef := nil;
					s := n^.next;  { only add the number node of n! }
					n^.next := nil;
					better_poly_add(n, m^.pcoef, t^.pcoef);
					n := s;
					m := m^.next
					
			 end;
		{__________________________________________________________________}
		
		procedure do_numbs;
		
		   begin
			 
					if first
					   then q := n
						 else begin
						         t^.next := n;
										 s := t;  { may need this later }					           
									end;
					t := n;
			    add(n^.ncoef^, m^.ncoef^, n^.ncoef^); 
					if ferm118.iszero(n^.ncoef^) 
						 then begin    
						         { put n on garbage list }
						         free_imag(n^.ncoef);
										 if tail = nil
					              then garb := n
						            else tail^.next := n;
										 tail := n;
										 if first
										    then begin
												        q := nil;
																t := nil
														 end
												else t := s
									end
						 else first := false;
									
					n := n^.next;
					m := m^.next
								
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on_n;
		
		   begin
			    
					if n^.numb
					   then if ferm118.iszero(n^.ncoef^)
						     then begin
								         free_imag(n^.ncoef);
										     if tail = nil
					                  then garb := n
						                else tail^.next := n;
										     tail := n;
												 exit {(tack_on_n)}
											end;
					if first
					   then q := n
					   else t^.next := n
					
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on_m;
		
		   begin
			    
					if m^.numb
					   then if ferm118.iszero(m^.ncoef^)
						         then exit {(tack_on_m)};
					if first
					   then poly_assign(m, q)
					   else poly_assign(m, t^.next)
					
			 end;
			 
		{___________________________________________________________________}
						          
    begin

				tail := nil;
				if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
									 add(n^.ncoef^, m^.ncoef^, n^.ncoef^); 
									 q := n
								end
				else begin				  		  
				        first := true;
								t := nil;
								q := nil;
				        repeat
								   if n^.exp > m^.exp
									    then take_one_n
									 else if m^.exp > n^.exp
									    then take_one_m
									 else if n^.numb and m^.numb
									    then do_numbs
									 else if n^.numb
									    then add_numb_n_m
									 else if m^.numb
									    then add_numb_m_n
									 else begin
													 better_poly_add(n^.pcoef, m^.pcoef, n^.pcoef);
													 
													 r := n^.pcoef;
													 if poly_iszero(n^.pcoef)
													    then begin  
															        if tail = nil
					                               then garb := r
						                             else tail^.next := r;
																			tail := r;
                                      free_imag(r^.ncoef);                                      
																			r^.next := n;																			
																			tail := n																																					
																	 end
													    else begin
															        if r^.numb and (r^.next = nil) and (n^.exp = 0) { special case! }
																			   then begin
																				         if tail = nil
					                                          then garb := n
						                                        else tail^.next := n;
																								 tail := n;
																								 r^.next := n^.next;
																								 n := r
																							end;
																			if first
															           then begin
																			           q := n;
																							   first := false
																					    end
																	       else t^.next := n;
																		  t := n
																	 end;
																	 																												
													 n := n^.next;
													 m := m^.next 
									      end
								until (n=nil) or (m=nil);
								
								if t <> nil
								   then t^.next := nil;
								if n <> nil
								   then tack_on_n
								else if m <> nil
								   then tack_on_m;
								if q = nil
								   then poly_set(0, q);
					end;
					
			 if tail <> nil
			    then begin
					        tail^.next := polygarb;
	                polygarb := garb
							 end;
								
			 p := q

		end;
				
{**************************************************************************}

 procedure best_poly_add(n, m: ferm118.poly; var p: ferm118.poly);

   { Gobble up m and n to save reallocation of space. Nodes not used will be put 
	   on a garbage list and freed at the end.  p is assumed to be equal to, or part of,
		 n or m. Therefore p is not freed here at the end. m is undefined at end. } 
 
    var q, t, r, s, garb, tail: ferm118.poly;
		    first: boolean;
				
	 {________________________________________________________________}
				
		procedure take_one(var x: ferm118.poly);

       begin
			 
					if x^.numb
					   then if ferm118.iszero(x^.ncoef^)  { x MUST be the poly 0 }
						         then begin
										         free_poly(x);
														 exit {(take_one)}
													end;
					if first 
						 then begin
									   q := x;
										 first := false
									end
					   else t^.next := x;
					t := x;
					x := x^.next
					
			 end;

    {_____________________________________________________________}
		
		procedure add_numb(var x, y: ferm118.poly);
		
		  { x is a number and y isn't, but has exponent 0. Gobble up y.  x and y^.pcoef
			  are freed and/or gobbled by recursive call. }
				
				var s: ferm118.poly;
		
		   begin
			 
					if first
						 then begin
						         first := false;
										 q := y
									end
					   else t^.next := y;
					t := y;
					s := x^.next;  { add only the number node of x! }
					x^.next := nil; 
					best_poly_add(x, y^.pcoef, y^.pcoef);
					
					x := s;
					y := y^.next
					
			 end;
			 
		{__________________________________________________________________}
		
		procedure do_numbs;
		
		   begin
			 
					if first
					   then q := n  { do not turn off first yet }
						 else begin
						         t^.next := n;
										 s := t;  { may need this later }					           
									end;
					t := n;
			    add(n^.ncoef^, m^.ncoef^, n^.ncoef^);
					
					{ put m on garbage list. }
					free_imag(m^.ncoef);
					if tail = nil
					   then garb := m
						 else tail^.next := m;
					tail := m;
					m := m^.next;
					if ferm118.iszero(n^.ncoef^)
						 then begin    
						         free_imag(n^.ncoef);
						         tail^.next := n;
										 tail := n; 
										 if first
										    then begin
												        q := nil;
																t := nil
														 end
												else t := s
									end
						 else first := false;
					n := n^.next
								
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on(x: ferm118.poly);
		
		   begin
			    
					if x^.numb
					   then if ferm118.iszero(x^.ncoef^)
						     then begin
								         free_imag(x^.ncoef);
										     if tail = nil
					                  then garb := x
						                else tail^.next := x;
										     tail := x;
												 exit {(tack_on)}
											end;
					if first
					   then q := x
					   else t^.next := x
					
			 end;
			 
		{___________________________________________________________________}
						          
    begin

				if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
									 add(n^.ncoef^, m^.ncoef^, n^.ncoef^); 
									 q := n;
									 free_imag(m^.ncoef);
									 garb := m;
									 tail := m
								end
				else begin
				  		  tail := nil;
				        first := true;
								t := nil;  
								q := nil;
				        repeat
								   if n^.exp > m^.exp
									    then take_one(n)
									 else if m^.exp > n^.exp
									    then take_one(m)
									 else if n^.numb and m^.numb
									    then do_numbs
									 else if n^.numb
									    then add_numb(n, m)
									 else if m^.numb
									    then add_numb(m, n)
									 else begin
													 best_poly_add(n^.pcoef, m^.pcoef, n^.pcoef);
													 
													 { put m^ on garbage list. (m^ is not a number.) }
					                 if tail = nil
					                    then garb := m
						                  else tail^.next := m;
													 tail := m;
													 
													 m := m^.next;
													 
													 r := n^.pcoef;
													 if poly_iszero(r)
													    then begin  															        
																			tail^.next := r;
																			free_imag(r^.ncoef);
																			r^.next := n;
																			tail := n
																	 end
													    else begin
															        if r^.numb and (r^.next = nil) and (n^.exp = 0) { special case! }
																			   then begin
																				         tail^.next := n;
																								 tail := n;
																								 r^.next := n^.next;
																								 n := r
																							end;
																			if first
															           then begin
																			           q := n;
																							   first := false
																					    end
																	       else t^.next := n;
																		  t := n
																	 end;
															
													 n := n^.next
													 
									      end
								until (n=nil) or (m=nil);
								
								if t <> nil
								   then t^.next := nil;
								if n <> nil
								   then tack_on(n)
								else if m <> nil
								   then tack_on(m);
								if q = nil
								   then poly_set(0, q);
					end;
					
			 if tail <> nil
			    then begin
					        tail^.next := polygarb;
	                polygarb := garb
							 end;
								
			 p := q

		end;
		
 {*************************************************************************}
		
 procedure no_denom(r: ferm118.poly; s: quoly; var q: quoly; flag: integer); forward;
    			 
 {*****************************************************************************}

 procedure poly_sub(n, m: ferm118.poly; var p: ferm118.poly);
 
    var q, t, r, s: ferm118.poly;
		    first: boolean;
				
	 {________________________________________________________________}
				
		procedure take_one(var x: ferm118.poly; flag: boolean);

       begin
			 
					if x^.numb
					   then if ferm118.iszero(x^.ncoef^)
						         then begin
										         x := nil;
														 exit {(take_one)}
													end;
					s := x^.next;
					x^.next := nil;
					if flag 
					   then poly_makeneg(x, r)
						 else poly_assign(x, r);
					x^.next := s;
					if first 
						 then begin
									   q := r;
										 first := false
									end
					else t^.next := r;
					t := r;
					x := x^.next
					
			 end;

    {_____________________________________________________________}
		
		procedure add_numb(var x,y: ferm118.poly; flag: boolean);
		
		   var r: ferm118.poly;
			 
			 begin
			 
					if first
						 then begin
										 newpoly(q);
										 first := false;
									   t := q
									end
					else begin
									newpoly(t^.next);
								  t := t^.next
							 end;
					t^.numb := false;
					t^.exp := y^.exp;
					t^.pcoef := nil;
					r := x^.next;
					if laurent
					   then x^.next := nil;
					if flag
					   then poly_sub(y^.pcoef, x, t^.pcoef)
						 else poly_sub(x, y^.pcoef, t^.pcoef);
					if laurent
					   then x^.next := r;
					x := r;
					y := y^.next
					
			 end;
			 
		{___________________________________________________________________}
		
		procedure expand;
		
		   begin
			    
					if r^.numb and (r^.next = nil) and (n^.exp = 0)
					   then { do nothing }
						 else begin
			               newpoly(s);
					           s^.numb := false;
					           s^.exp := n^.exp;
					           s^.pcoef := r;
					           s^.next := nil;
					           r := s
									end
					
			 end;
			 
		{__________________________________________________________________}
		
		procedure do_numbs;
		
		   begin
			 
					if first
					   then begin
						         newpoly(q);  { do not turn off first yet. }
									   t := q;
									end
						 else begin
						         newpoly(t^.next);
										 s := t;  { may need this later }
					           t := t^.next;
									end;
					t^.exp := 0;
	        t^.numb := true;
					newimag(t^.ncoef);
					t^.ncoef^.imag := nil;
					sub(n^.ncoef^, m^.ncoef^, t^.ncoef^);
					if ferm118.iszero(t^.ncoef^) 
						 then begin    
						         t^.next := nil;
						         free_poly(t); 
										 if first
										    then q := nil
												else t := s
									end					 
					   else first := false;
					n := n^.next;
					m := m^.next
								
			 end;
			 
		{___________________________________________________________________}
		
		procedure tack_on(x: ferm118.poly; flag: boolean);
		
		   begin
			    
					if x^.numb
	           then if ferm118.iszero(x^.ncoef^)
						         then exit {(tack_on)};
					if first
					   then if flag
						         then poly_makeneg(x, q)
										 else poly_assign(x, q)
					   else if flag
						         then poly_makeneg(x, t^.next)
										 else poly_assign(x, t^.next)
					
			 end;
			 
		{___________________________________________________________________}
						          
    begin
		
		    q := nil;
		    if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
					         newpoly(q);
									 q^.next := nil;
									 q^.numb := true;
									 q^.exp := 0;
					         newimag(q^.ncoef);
									 q^.ncoef^.imag := nil;
									 sub(n^.ncoef^, m^.ncoef^, q^.ncoef^)
								end
				else begin
				        first := true;
								t := nil;
				        repeat
								   r := nil;
								   if n^.exp > m^.exp
									    then take_one(n, false)
									 else if m^.exp > n^.exp
									    then take_one(m, true)
									 else if n^.numb and m^.numb
									    then do_numbs
									 else if n^.numb
									    then add_numb(n, m, false)
									 else if m^.numb
									    then add_numb(m, n, true)
									 else begin
													 poly_sub(n^.pcoef, m^.pcoef, r);
													 if poly_iszero(r)
													    then free_poly(r)
													    else if first
															        then begin
																			        expand;
																			        q := r;
																							t := q;
																							first := false
																					 end
																	 else begin
																	         expand;
																	         t^.next := r;
																					 t := r
																				end;
													 n := n^.next;
													 m := m^.next
									      end
								until (n=nil) or (m=nil);
								
								if t <> nil
								   then t^.next := nil;
								if n <> nil
								   then tack_on(n, false)
								else if m <> nil
								   then tack_on(m, true);
								if q = nil
								   then poly_set(0, q)
					end;
					
			 free_poly(p);
			 p := q

		end;
		
{*****************************************************************************}

 procedure better_poly_sub(n, m: ferm118.poly; var p: ferm118.poly);

   { Gobble up n to save reallocation of space. m must not be touched. 
	   Nodes not used will be put on a garbage list and freed at the end.  
		 p always points to n or m, or is initially nil  Therefore, never need to free
		 p at end before changing it to answer. } 
 
    var q, t, r, s, garb, tail: ferm118.poly;
		    first: boolean;
				
	 {________________________________________________________________}
				
		procedure take_one_m; { duplicate one node }

       begin
			 
					if m^.numb
					   then if ferm118.iszero(m^.ncoef^)
						         then begin
										         m := nil;
														 exit {(take_one_m)}
													end;
					s := m^.next;
					m^.next := nil;
					r := nil;
					poly_makeneg(m, r);
					m^.next := s;
					if first 
						 then begin
									   q := r;
										 first := false
									end
					else t^.next := r;
					t := r;
					m := s
					
			 end;
	 {________________________________________________________________}
				
		procedure take_one_n;  { just gobble up }

       begin
			 					
					if n^.numb
					   then if ferm118.iszero(n^.ncoef^)
						         then begin
										         free_poly(n);
														 exit {(take_one_n)}
													end;
					if first 
						 then begin
									   q := n;
										 first := false
									end
					   else t^.next := n;
					t := n;
					n := n^.next
					
			 end;

    {_____________________________________________________________}
		
		procedure add_numb_m_n;
		
		  { m is a number and n isn't, but has exponent 0. Gobble up n. }
		
		   var r: ferm118.poly;
			 
			 begin
			 
					if first
						 then begin
						         first := false;
										 q := n
									end
					   else t^.next := n;
					t := n;
					r := m^.next;
					if laurent
					   then m^.next := nil;
					better_poly_sub(n^.pcoef, m, n^.pcoef);
					if laurent
					   then m^.next := r;
					n := n^.next;
					m := r
					
			 end;
			 
    {_____________________________________________________________}
		
		procedure add_numb_n_m;  { n is a number, m isn't. }
		
		   var s: ferm118.poly;
		
		   begin
			 
					if first
						 then begin
										 newpoly(q);
										 first := false;
									   t := q
									end
					else begin
									newpoly(t^.next);
								  t := t^.next
							 end;
					t^.numb := false;
					t^.exp := 0;
					t^.pcoef := nil;
					s := n^.next;
					n^.next := nil;
					better_poly_sub(n, m^.pcoef, t^.pcoef);
					n := s;
					m := m^.next
					
			 end;
		{__________________________________________________________________}
		
		procedure do_numbs;
		
		   begin
			 
					if first
					   then q := n
						 else begin
						         t^.next := n;
										 s := t;  { may need this later }					           
									end;
					t := n;
			    sub(n^.ncoef^, m^.ncoef^, n^.ncoef^);
					
					if ferm118.iszero(n^.ncoef^) 
						 then begin    
						         { put n on garbage list }
						         free_imag(n^.ncoef);
										 if tail = nil
					              then garb := n
						            else tail^.next := n;
										 tail := n;
										 if first
										    then begin
												        q := nil;
																t := nil
														 end
												else t := s
									end
						 else first := false;
									
					n := n^.next;
					m := m^.next
								
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on_n;
		
		   begin
			    
					if n^.numb
					   then if ferm118.iszero(n^.ncoef^)
						     then begin
								         free_imag(n^.ncoef);
										     if tail = nil
					                  then garb := n
						                else tail^.next := n;
										     tail := n;
												 exit {(tack_on_n)}
											end;
					if first
					   then q := n
					   else t^.next := n
						 
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on_m;
		
		   begin
			    
					if m^.numb
					   then if ferm118.iszero(m^.ncoef^)
						         then exit {(tack_on_m)};
					if first
					   then poly_makeneg(m, q)
					   else poly_makeneg(m, t^.next)
					
			 end;
			 
		{___________________________________________________________________}
						          
    begin

				tail := nil;
				if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
									 sub(n^.ncoef^, m^.ncoef^, n^.ncoef^);
									 q := n
								end
				else begin				  		  
				        first := true;
								t := nil;
								q := nil;
				        repeat
								   if n^.exp > m^.exp
									    then take_one_n
									 else if m^.exp > n^.exp
									    then take_one_m
									 else if n^.numb and m^.numb
									    then do_numbs
									 else if n^.numb
									    then add_numb_n_m
									 else if m^.numb
									    then add_numb_m_n
									 else begin
													 better_poly_sub(n^.pcoef, m^.pcoef, n^.pcoef);
													 
													 r := n^.pcoef;
													 if poly_iszero(n^.pcoef)
													    then begin  
															        if tail = nil
					                               then garb := r
						                             else tail^.next := r;
																			tail := r;
                                      free_imag(r^.ncoef);                                      
																			r^.next := n;																			
																			tail := n
																	 end
													    else begin
															        if r^.numb and (r^.next = nil) and (n^.exp = 0)  { special case! }
																			   then begin
																				         if tail = nil
					                                          then garb := n
						                                        else tail^.next := n;
																								 tail := n;
																								 r^.next := n^.next;
																								 n := r
																							end;
																			if first
															           then begin
																			           q := n;
																							   first := false
																					    end
																	       else t^.next := n;
																		  t := n
																	 end;
																	 																												
													 n := n^.next;
													 m := m^.next 
									      end
								until (n=nil) or (m=nil);
								
								if t <> nil
								   then t^.next := nil;
								if n <> nil
								   then tack_on_n
								else if m <> nil
								   then tack_on_m;
								if q = nil
								   then poly_set(0, q);
					end;
					
			 if tail <> nil
			    then begin
					        tail^.next := polygarb;
	                polygarb := garb
							 end;
								
			 p := q

		end;
				
{*****************************************************************************}

 procedure best_poly_sub(n, m: ferm118.poly; var p: ferm118.poly);

   { Gobble up m and n to save reallocation of space. Nodes not used will be put 
	   on a garbage list and freed at the end.  p is assumed to be equal to, or part of,
		 n or m. Therefore p is not freed here at the end. } 
 
    var q, t, r, s, garb, tail: ferm118.poly;
		    first: boolean;
				
	 {________________________________________________________________}
				
		procedure take_one(var x: ferm118.poly; flag: boolean);

       begin
			 
					if x^.numb
					   then if ferm118.iszero(x^.ncoef^)
						         then begin
										         free_poly(x);
														 exit {(take_one)}
													end;
				 if first 
						 then begin
									   q := x;
										 first := false
									end
					   else t^.next := x;
					t := x;
					x := x^.next;
					if flag
					   then begin
						         t^.next := nil;
										 poly_inplace(t)
									end					
					
			 end;

    {_____________________________________________________________}
		
		procedure add_numb(var x, y: ferm118.poly; flag: boolean);
		
		  { x is a number and y isn't, but has exponent 0. Gobble up y.  x and y^.pcoef
			  are freed and/or gobbled by recursive call. flag means we want to take y - x. }
				
			 var s: ferm118.poly;
		
		   begin
			 
					if first
						 then begin
						         first := false;
										 q := y
									end
					   else t^.next := y;
					t := y;
					s := x^.next;
					x^.next := nil;
					if flag
					   then best_poly_sub(y^.pcoef, x, y^.pcoef)
						 else best_poly_sub(x, y^.pcoef, y^.pcoef);
					
					x := s;
					y := y^.next
					
			 end;
			 
		{__________________________________________________________________}
		
		procedure do_numbs;
		
		   begin
			 
					if first
					   then q := n  { no need to turn off first }
						 else begin
						         t^.next := n;
										 s := t;  { may need this later }					           
									end;
					t := n;
			    sub(n^.ncoef^, m^.ncoef^, n^.ncoef^);
					
					{ put m on garbage list }
					free_imag(m^.ncoef);
					if tail = nil
					   then garb := m
						 else tail^.next := m;
					tail := m;
					m := m^.next;
					if ferm118.iszero(n^.ncoef^)
						 then begin    
						         free_imag(n^.ncoef);
						         tail^.next := n;
										 tail := n; 
										 if first
										    then begin
												        q := nil;
																t := nil
														 end
												else t := s
									end
						 else first := false;
					n := n^.next
													
			 end;
			 
		{__________________________________________________________________}	 
							
		procedure tack_on(x: ferm118.poly; flag: boolean);
		
		   begin
			    
					if x^.numb
					   then if ferm118.iszero(x^.ncoef^)
						     then begin
								         free_imag(x^.ncoef);
										     if tail = nil
					                  then garb := x
						                else tail^.next := x;
										     tail := x;
												 exit {(tack_on)}
											end;
			    
					if first
					   then q := x
					   else t^.next := x;
					if flag
					   then poly_inplace(x)
					
			 end;
			 
		{___________________________________________________________________}
						          
    begin

				if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
									 sub(n^.ncoef^, m^.ncoef^, n^.ncoef^);
									 q := n;
									 free_imag(m^.ncoef);
									 garb := m;
									 tail := m
								end
				else begin
				  		  tail := nil;
				        first := true;
								t := nil;  
								q := nil;
				        repeat
								   if n^.exp > m^.exp
									    then take_one(n, false)
									 else if m^.exp > n^.exp
									    then take_one(m, true)
									 else if n^.numb and m^.numb
									    then do_numbs
									 else if n^.numb
									    then add_numb(n, m, false)
									 else if m^.numb
									    then add_numb(m, n, true)
									 else begin
													 best_poly_sub(n^.pcoef, m^.pcoef, n^.pcoef);
													 
													 { put m^ on garbage list. (m^ is not a number.) }
					                 if tail = nil
					                    then garb := m
						                  else tail^.next := m;
													 tail := m;
													 
													 m := m^.next;
													 
													 r := n^.pcoef;
													 if poly_iszero(n^.pcoef)
													    then begin  															        
																			tail^.next := r;
																			free_imag(r^.ncoef);
																			r^.next := n;
																			tail := n
																	 end
													    else begin
															        if r^.numb and (r^.next = nil) and (n^.exp = 0)  { special case! }
																			   then begin
																				         tail^.next := n;
																								 tail := n;
																								 r^.next := n^.next;
																								 n := r
																							end;
																			if first
															           then begin
																			           q := n;
																							   first := false
																					    end
																	       else t^.next := n;
																		  t := n
																	 end;
															
													 n := n^.next
													 
									      end
								until (n=nil) or (m=nil);
								
								if t <> nil
								   then t^.next := nil;
								if n <> nil
								   then tack_on(n, false)
								else if m <> nil
								   then tack_on(m, true);
								if q = nil
								   then poly_set(0, q);
					end;
					
			 if tail <> nil
			    then begin
					        tail^.next := polygarb;
	                polygarb := garb
							 end;
								
			 p := q

		end;
		
	{***************************************************************************}

  procedure insert(x: tokentipe; num: quoly; var q: varptr);
	
	  { November 1, 1994:  no longer duplicate num^, just put it in the symbol table. 
		  BUT NOTE that num's argument is not changed. That's the caller's problem. 
			On exit q^.val := num. }
		
		var i: integer;

    begin

			if x.address = -1
			   then i := hash(x.name, 151)
				 else i := x.address;
				 
			q := sca_store[i];
      while q <> nil do
         if q^.let.name = x.name
            then break
            else q := q^.next;
					
      if q <> nil
         then begin
				         free_quoly(q^.val);
								 q^.val := num
							end
         else begin
								 q := sca_store[i];
								 if var_garb = nil
									  then new(sca_store[i])
									  else begin
													  sca_store[i] := var_garb;
													  var_garb := var_garb^.next
												 end;
								 with sca_store[i]^ do
								    begin
										   let := x;
											 val := num;
											 next := q
										end;
								 q := sca_store[i]
							end

    end;
		 
	{***************************************************************************}

  procedure iinsert(x: tokentipe; num: longreal; var q: varptr);
	
	  var i: integer;

    begin

      if x.address = -1
			   then i := hash(x.name, 151)
				 else i := x.address;
				 
			q := sca_store[i];
      while q <> nil do
         if q^.let.name = x.name
            then break
            else q := q^.next;
					
      if q <> nil
        then if q^.val^.numb
				        then q^.val^.ncoef^.float := num
								else quoly_set_ext(num, q^.val)
        else begin
								q := sca_store[i];
								if var_garb = nil
									 then new(sca_store[i])
									 else begin
													 sca_store[i] := var_garb;
													 var_garb := var_garb^.next
												end;
								sca_store[i]^.let := x;
								sca_store[i]^.val := nil;
								quoly_set_ext(num, sca_store[i]^.val);
								sca_store[i]^.next := q;
								q := sca_store[i]
						 end

    end;
		 
 {**************************************************************************}
		
	procedure scalar_by_poly(x, y: ferm118.poly; var q: ferm118.poly);
		
		 { x points to a non-zero number node; y may not be a number, but may become one.
			 q can't be x or y. q must be nil. Multiply the node x by all of y. }
			 
		 var first, ok: boolean;
				 t,s: ferm118.poly;
				 n: number;
	
		 begin
				
				first := true;
				n.imag := nil;
				while y <> nil do
					 begin
							ok := true;
							if y^.numb
								 then mult(x^.ncoef^, y^.ncoef^, n)
							else begin
											s := nil;
											scalar_by_poly(x, y^.pcoef, s)
									 end;
							if ok 
								 then begin								
												 if first
														then begin
																		newpoly(q);
																		first := false;
																		t := q
																 end
												 else begin
																 newpoly(t^.next);
																 t := t^.next
															end;
												 t^.exp := y^.exp;
												 t^.numb := y^.numb;
												 if y^.numb
														then begin
																		newimag(t^.ncoef);
																		t^.ncoef^ := n
																 end
												 else t^.pcoef := s									 
											end;
								 
							y := y^.next
					 end;
					 
				if q = nil
					 then poly_set(0, q)
					 else t^.next := nil
											
		 end;
			 
	{****************************************************************************}
	
	procedure poly_mult(n, m: ferm118.poly; var p: ferm118.poly; pol: polypt); forward;

  {****************************************************************************}
		
	procedure simple_standard(n, m: ferm118.poly; size1, size2: longint; var q: ferm118.poly);
	
	   { neither n nor m is a (polynomial) number, but the node might be. }
	
		 var size, i: longint;
				 t: ferm118.poly;
	
		{_________________________________________________________________}
		
		procedure node_by_poly(x, y: ferm118.poly; var q: ferm118.poly);
		
		   { x is a single node, not a number; y is not a number (at first). }
			 
			 var first, ok: boolean;
			     t,s: ferm118.poly;
		
		   begin
			    
					first := true;
					q := nil;  { no need to free it first }
			    while y <> nil do
					   begin
						    ok := true;
								s := nil;
								if y^.numb
								   then scalar_by_poly(y, x^.pcoef, s)
								   else poly_mult(x^.pcoef, y^.pcoef, s, nilpol);
								if ok 
								   then begin								
													 if first
															then begin
																			newpoly(q);
																			first := false;
																			t := q
																	 end
															else begin
																			newpoly(t^.next);
																			t := t^.next
																	 end;
													 t^.exp := x^.exp + y^.exp;
													 t^.numb := (t^.exp = 0) and s^.numb and (s^.next = nil);
													            { possible in modularmode 
                                        and with negative exponents. }
													 if t^.numb
													    then begin
															        t^.ncoef := s^.ncoef;
																			s^.next := polygarb;
																			polygarb := s
																	 end
													 else t^.pcoef := s									 
									      end
									 else free_poly(s);
									 
								y := y^.next
						 end;
						 
					if q = nil
					   then poly_set(0, q)
						 else t^.next := nil
												
			 end;
			 
		{_________________________________________________________________}
		
		 begin
		 
				 if size1 > size2 
						 then begin
										 size := size2;
										 t := n;
										 n := m;
										 m := t
									end
						 else size := size1;
					if n^.numb
						 then scalar_by_poly(n,m, q)
						 else node_by_poly(n,m, q);
					for i:= 1 to size - 1 do
						 begin
								n := n^.next;
								t := nil;
								if n^.numb
									 then scalar_by_poly(n,m, t)
									 else node_by_poly(n,m, t);
								best_poly_add(q, t, q)
						 end
						 
		 end;
			 
  {****************************************************************************}
		
	procedure mod_standard(n, m: ferm118.poly; size1, size2: longint; var q: ferm118.poly; r: polypt);
	
	  { neither n nor m is a (polynomial) number, but the node might be. }
	
		 var size, i: longint;
				 t: ferm118.poly;
	
		{_________________________________________________________________}
		
		procedure node_by_poly(x, y: ferm118.poly; var q: ferm118.poly);
		
		   { x is a single node, not a number; y is not a number (at first). }
			 
			 label 987;
			 
			 var first, ok, number, happened: boolean;
			     t, s, alt: ferm118.poly;
					 expo: longint;
		
		   begin
			    
					first := true;
					happened := false;
					q := nil;  { no need to free it first }
					alt := nil;
					
			    while y <> nil do
					   begin
						 
						    ok := true;
								s := nil;
								if y^.numb
								   then scalar_by_poly(y, x^.pcoef, s)
								   else poly_mult(x^.pcoef, y^.pcoef, s, r^.next);
								if r^.next <> nil
									 then if r^.next^.p <> nil
													 then ok := not poly_iszero(s);
								if ok 
								   then begin																					 
													 expo := x^.exp + y^.exp;
													 if (r^.p <> nil) and (expo >= r^.expon)
														  then begin
																		  expo := expo - r^.expon;
																		  poly_mult(s, r^.p, s, nilpol);
																		  if poly_iszero(s)
																				 then begin  { same as ok = false }
																								 free_poly(s);
																								 goto 987
																							end;																		  
																			happened := true
																	 end;
													 number := (expo = 0) and s^.numb and (s^.next = nil);
																			
													 if first
															then begin
																			newpoly(q);
																			first := false;
																			t := q
																	 end
													 else if happened and (expo > t^.exp)
													      then begin
																        t^.next := nil;
																				newpoly(alt);
																				t := alt;
																				happened := false
																     end
													 else begin
																	 newpoly(t^.next);
																	 t := t^.next
																end;
																
													 t^.numb := number;
													 t^.exp := expo;
													 if number
													    then begin
															        t^.ncoef := s^.ncoef;
																			s^.next := polygarb;
																			polygarb := s
																	 end
													 else t^.pcoef := s
															
									      end
									 else free_poly(s);
									 
								987:;
								y := y^.next
								
						 end;
						 
					if q = nil
					   then poly_set(0, q)
					else if alt <> nil
					        then begin
									        t^.next := q;
													q := alt
											 end
					else t^.next := nil
												
			 end;
			 
		{_________________________________________________________________}
		
		 begin
		 
				 if size1 > size2 
						 then begin
										 size := size2;
										 t := n;
										 n := m;
										 m := t
									end
						 else size := size1;
					if n^.numb
						 then scalar_by_poly(n,m, q)
						 else node_by_poly(n,m, q);
					for i:= 1 to size - 1 do
						 begin
								n := n^.next;
								t := nil;
								if n^.numb
									 then scalar_by_poly(n,m, t)
									 else node_by_poly(n,m, t);
								best_poly_add(q, t, q)
						 end
						 
		 end;
			 
	{*************************************************************************}
	
	procedure fold_poly(var p, num: ferm118.poly; expon: longint); forward;

  {***************************************************************************}
	
	procedure poly_mult; {(n, m: ferm118.poly; var p: ferm118.poly; pol: polypt)}
 
    var q, t, r, s, x1, x2, x3, u1, u2, v1, v2, w, y, z, prev: ferm118.poly;
		    i, size1, size2, expon: longint;	
				different: boolean;
			   			 
    begin
		
		    q := nil;
		    if n^.numb and m^.numb and (n^.next = nil) and (m^.next = nil)
				   then begin
					         newpoly(q);
									 q^.next := nil;
									 q^.numb := true;
									 q^.exp := 0;
					         newimag(q^.ncoef);
									 q^.ncoef^.imag := nil;
									 mult(n^.ncoef^, m^.ncoef^, q^.ncoef^)
								end
				else if n^.numb and (n^.next = nil)
				        then if ferm118.iszero(n^.ncoef^)
					              then poly_set(0, q)
										    else scalar_by_poly(n,m, q)
				else if m^.numb and (m^.next = nil)
				        then if ferm118.iszero(m^.ncoef^)
					              then poly_set(0, q)
										    else scalar_by_poly(m,n, q)
				else begin
				        size1 := poly_length(n);
								size2 := poly_length(m);
								if command_int 
									 then check_cmd_keys;
								if (size1 < cutoff) or (size2 < cutoff)
								   then if pol = nil
									         then simple_standard(n, m, size1, size2, q)
													 else mod_standard(n, m, size1, size2, q, pol)
								else begin
								        { first compute expon, the exponent to be subtracted from
												  each node. expon is always > 0. }
												different := n <> m;
												q := n;
								        for i := 1 to size1 div 2 - 1 do
												   q := q^.next;
												if n = m
												   then if laurent
													         then expon := n^.exp - q^.next^.exp
																	 else expon := q^.exp
												else begin
												       t := m;
												       for i := 1 to size2 div 2 - 1 do
												          t := t^.next;
												       if laurent  { can no longer assume that q^.exp is about half of n^.exp. }
															    then begin
																	        expon := n^.exp - q^.next^.exp;
																					i := m^.exp - t^.next^.exp;
																					if i < expon
																					   then expon := i
																	     end																	
																	else if q^.exp < t^.exp
												                  then expon := q^.exp
													                else expon := t^.exp
														 end;
												
												{ Now subtract expon from each node. Complicated by an exponent
												  becoming 0; in laurent this can happen at any time.
													Split with r.  Use v1 and v2 to mark 0 exp node.
													Beware of case where the split is right after a 0 exp node 
													that became a number. }
												q := n;
												u1 := nil;
												u2 := nil;
												q^.exp := q^.exp - expon;
												if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil)
												   then begin   { because this node is now a number! }
													         u2 := n;
																	 n := n^.pcoef;
																	 n^.next := u2^.next;
																	 if not different
																	    then m := n
																end;
												for i := 1 to size1 div 2 - 1 do
												   begin
													    if u2 = nil  { unused yet }
															   then u1 := q;
															q := q^.next;
													    q^.exp := q^.exp - expon;
												      if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil)
																 then begin   { because this node is now a number! }
																				 u2 := q;
																				 q := q^.pcoef;
																				 u1^.next := q;
																				 q^.next := u2^.next
																			end
													 end;
													 
												r := q^.next;
												q^.next := nil;
												if different
												   then begin
													        { Split m. Delicate! Beware of case where the split
																	  is right after a 0 exp node that became a number. }
												          t := m;
												          v1 := nil;
																	v2 := nil;
																	t^.exp := t^.exp - expon;
																	if (t^.exp = 0) and t^.pcoef^.numb and (t^.pcoef^.next = nil)
																		 then begin   { because this node is now a number! }
																						 v2 := m;
																						 m := m^.pcoef;
																						 m^.next := v2^.next
																					end;
																  for i := 1 to size2 div 2 - 1 do
												             begin
																		    if v2 = nil  { unused yet }
																					 then v1 := t;
																				t := t^.next;
																				t^.exp := t^.exp - expon;
																				if (t^.exp = 0) and t^.pcoef^.numb and (t^.pcoef^.next = nil)
																					 then begin   { because this node is now a number! }
																									 v2 := t;
																									 t := t^.pcoef;
																									 v1^.next := t;
																									 t^.next := v2^.next
																								end						      
													           end;
												          s := t^.next;
												          t^.next := nil
															  end
													 else s := r;
													 
												x1 := nil;  x2 := nil;  x3 := nil;
												poly_add(n,r, x1);
											  poly_add(m,s, x2);
												poly_mult(x1, x2, x1, pol);
												poly_mult(n,m, x2, pol);
												poly_mult(r,s, x3, pol);
												w := nil;
												better_poly_sub(x1, x2, w);
												better_poly_sub(w, x3, w);												
												
												{ Add expon to all exponents.  Be very careful to change
												  numbers to non-numbers and visa versa!  Tricky! }
											  prev := nil;
												z := w;
												if not poly_iszero(w)
												   then while z <> nil do
																	 begin
																	    if z^.numb
																			   then begin  { pad }
																				         newpoly(y);
																								 if prev = nil
																								    then w := y
																										else prev^.next := y;
																								 y^.next := z^.next;
																								 z^.next := nil;
																								 y^.numb := false;
																								 y^.exp := expon;
																								 y^.pcoef := z;
																								 z := y
																							end
																		     else z^.exp := z^.exp + expon;
																			if (z^.exp = 0) and z^.pcoef^.numb and (z^.pcoef^.next = nil)
																			   then begin { z is a number }
																				         x1 := z^.pcoef;
																								 z^.numb := true;
																								 z^.ncoef := x1^.ncoef;
																								 x1^.next := polygarb;
																								 polygarb := x1
																							end;	 
																			prev := z;
																		  z := z^.next
																	 end;
																	 
												if pol <> nil
												   then if pol^.p <> nil
													         then fold_poly(w, pol^.p, pol^.expon); 
												best_poly_add(w, x3, w);
													 
												z := x2;
												prev := nil;
												if not poly_iszero(x2)
												   then while z <> nil do
																	 begin
																	    if z^.numb
																			   then begin  { pad }
																				         newpoly(y);
																								 if prev = nil
																								    then x2 := y
																										else prev^.next := y;
																								 y^.next := z^.next;
																								 z^.next := nil;
																								 y^.numb := false;
																								 y^.exp := 2*expon;
																								 y^.pcoef := z;
																								 z := y
																							end
																		     else z^.exp := z^.exp + 2*expon;
																			if (z^.exp = 0) and z^.pcoef^.numb and (z^.pcoef^.next = nil)
																			   then begin { z is a number }
																				         x1 := z^.pcoef;
																								 z^.numb := true;
																								 z^.ncoef := x1^.ncoef;
																								 x1^.next := polygarb;
																								 polygarb := x1
																							end;	 
																			prev := z;
																		  z := z^.next
																	 end;
							
												if pol <> nil
												   then if pol^.p <> nil
													         then fold_poly(x2, pol^.p, pol^.expon);
												best_poly_add(w, x2, w);
													 
												{ answer is now w. }
												
												{ restore n and m. }
												if u2 <> nil
												   then if u1 = nil
													         then begin
																	         n^.next := nil;
																					 n := u2
																				end
																	 else begin
																	         u1^.next^.next := nil;
																					 u1^.next := u2
																				end;
												q := n;
												q^.exp := q^.exp + expon;
												for i := 1 to size1 div 2 - 1 do
												   begin
													    q := q^.next;
													    q^.exp := q^.exp + expon												      
													 end;
												q^.next := r;
												if different
												   then begin
													         if v2 <> nil
																		 then if v1 = nil
																						 then begin
																										 m^.next := nil;
																										 m := v2
																									end
																						 else begin
																										 v1^.next^.next := nil;
																										 v1^.next := v2
																									end;
													         q := m;
												           q^.exp := q^.exp + expon;
												           for i := 1 to size2 div 2 - 1 do
												              begin
													               q := q^.next;
													               q^.exp := q^.exp + expon												      
													            end;
												           q^.next := s
																end;
												
												q := w
										 end
												
						 end;

			 free_poly(p);
			 p := q

		end;
		
	{**************************************************************************}

	 procedure root_unity(var inf: text; var n: quoly; var flag: nameptr);
	 
	    var m: quoly;
			    y2, z2: longreal;
					im: imptr;
			
			begin
				 scanner(inf, token, flag);
				 if token.name <> '('
						then error(177, token);
				 scanner(inf, token, flag);
				 old_expre(inf, n, flag);
				 if token.name <> ','
						then error(202, token);
				 scanner(inf, token, flag); 
				 m := nil;
				 old_expre(inf, m, flag);
				 if not (n^.numb and m^.numb)
					  then error(253, token);
				 if token.name <> ')'
					  then error(1, token);
				 scanner(inf, token, flag);
				 if not complex
					  then error(85, token);
				 im := n^.ncoef;
				 y2 := im^.float;
				 if y2 < 1
					  then error(86, token);
				 z2 := 2*pii.float*m^.ncoef^.float/y2;
				 y2 := sin(z2);
				 im^.float := cos(z2);
				 if abs(y2) < 1.0e-15
					  then y2 := 0;
				 if abs(im^.float) < 1.0e-15
					  then im^.float := 0;
				 if y2 = 0
					  then if im^.imag <> nil
									  then imag_free(im^)
									  else
					  else begin
									  if im^.imag = nil
											 then newimag(im^.imag);
									  im^.imag^.float := y2
								 end;
				 free_quoly(m)
			end;
						 
 {****************************************************************************}

 procedure poly_quot(n, m: ferm118.poly; var p: ferm118.poly);
 
    { m is assumed to be a genuine number, even in laurent, but it doesn't really
		  matter so long as this node is a number. All invocations of this procedure 
			check this. }
 
    var q,t : ferm118.poly;
 
    begin
		
		    q := nil;
				if n^.numb and (n^.next = nil) 
				   then begin
					         newpoly(q);
									 q^.numb := true;
									 q^.exp := 0;
									 q^.next := nil;
					         newimag(q^.ncoef);
									 q^.ncoef^.imag := nil;
									 quot(n^.ncoef^, m^.ncoef^, q^.ncoef^);
								   free_poly(p);
									 p := q
								end
		    else begin
								 t := nil;
								 while n <> nil do
										begin
											 if t = nil
													then begin
																	newpoly(q);
																	t := q
															 end
													else begin
																	newpoly(t^.next);
																	t := t^.next
															 end;
											 t^.numb := n^.numb;
											 t^.exp := n^.exp;
											 if t^.numb
													then begin
																	newimag(t^.ncoef);
																	t^.ncoef^.imag := nil;
																	quot(n^.ncoef^, m^.ncoef^, t^.ncoef^)
															 end
													else begin
																	t^.pcoef := nil;
																	poly_quot(n^.pcoef, m, t^.pcoef)
															 end;
											 n := n^.next
										end;
								 t^.next := nil;
								 free_poly(p);
								 p := q
						 end
					
		end;
		
 {**************************************************************************}
 
 procedure basic_poly_divide(n, m: ferm118.poly; var q, r: ferm118.poly);
 
    { Field case, highest level polys. Compute quotient and remainder. 
		  Ordinary scalar arithmetic will be called on coefficients - they must be numbers.
			Assume m is not a number, so m^.exp >= 1.  q <> r. 			
			  Possible improvement: instead of calling free_poly so often in main loop, keep
			a local garbage list. }
			
		var first: boolean;
        head, tail, coef, lead, rest: ferm118.poly;
			
		begin
		
		   if m^.exp > n^.exp
			    then begin					        
									poly_assign(n, r);
			            poly_set(0, q);
									exit {(basic_poly_divide)}
							 end;
			 lead := m^.pcoef;
			 rest := m^.next;
			 if rest <> nil
			    then poly_inplace(rest);  { clever way to avoid subtracting later. }
			 			 
			 first := true;
			 while m^.exp <= n^.exp do
			    begin  { n will never be a number }
					   if first
						    then begin
								        newpoly(head);
												tail := head    { don't turn off first yet }
										 end
								else begin
								        newpoly(tail^.next);
												tail := tail^.next
										 end;
						 tail^.exp := n^.exp - m^.exp;
						 tail^.numb := (tail^.exp = 0);
						 coef := nil;
						 poly_quot(n^.pcoef, lead, coef);
						 if tail^.numb
						    then begin
								        tail^.ncoef := coef^.ncoef;
												coef^.next := polygarb;
												polygarb := coef
										 end
								else tail^.pcoef := coef;
						
						 if (rest = nil) or first
						    then n := n^.next
								else begin
								        { free this node before moving on! }
												coef := n^.next;
												n^.next := nil;
												free_poly(n);
												n := coef
										 end;
										 
						 if rest = nil  { monomial m }
						    then if n = nil
								        then break
												else { nothing }
						 else begin
						         coef := nil;
										 tail^.next := nil;
						         poly_mult(tail, rest, coef, nilpol);
										 if n <> nil
										    then if first
												        then better_poly_add(coef, n, coef)
																else best_poly_add(coef, n, coef);
										 n := coef
									end;
						 if first 
						    then first := false
					end;
			 
			 if rest <> nil
			    then poly_inplace(rest);  { put it back }
					
			 if n = nil
			    then poly_set(0, r)
					else if rest = nil
					        then poly_assign(n, r)
									else begin
									        free_poly(r);
													r := n
											 end;
											 
			 tail^.next := nil;
			 free_poly(q);
			 q := head
		
		end;
																		 						
 {***********************************************************************}
 
 procedure add_pad(var r: ferm118.poly; h: integer);
 
   var s,t: ferm118.poly;
	      i: integer;
	
	 begin
	
	   for i := 1 to h do
				begin
					 if i = 1
							then begin
											newpoly(s);
											t := s
									 end
							else begin
											newpoly(t^.pcoef);
											t := t^.pcoef
									 end;
					 t^.exp := 0;
					 t^.next := nil;
					 t^.numb := false
				end;
	   t^.pcoef := r;
	   r := s
				
	 end;
	
 {**************************************************************************}
 
 procedure poly_divide(n, m: ferm118.poly; var q: ferm118.poly);
 
		{ Don't call if m is a number. Assumes that m divides evenly into n. But this 
		  might not happen in finite precision. }
		
		var head, tail, lead, rest, coef: ferm118.poly;
		    height: integer;
				first: boolean;
		
		begin
		
		   if (number_polys = 1) or ( height_is_1(m) and height_is_1(n) )
			    then begin
					        head := nil;
									basic_poly_divide(n,m, q, head);
									if not head^.numb 
										 then writeln(userOutput, '*** Fermat warning. head not number ');
									free_poly(head)
							 end
			 else if m^.exp > n^.exp
			    then poly_set(0, q)
			 else if (m^.exp = 0) and (n^.exp = 0)
			    then begin
					        findHeight(n, m, height);
									poly_divide(n, m, q);
									if not q^.numb
									   then add_pad(q, height)
							 end
			 else if m^.exp = 0
			    then begin
					        m := m^.pcoef;
									tail := nil;
									while n <> nil do  { term by term division of coefs. }
									   begin
										    if tail = nil
												   then begin
													         newpoly(head);
																	 tail := head
																end
													 else begin
													         newpoly(tail^.next);
																	 tail := tail^.next
																end;
												tail^.exp := n^.exp;
												tail^.pcoef := nil;
												poly_divide(n^.pcoef, m, tail^.pcoef);
												tail^.numb := (tail^.exp = 0) and tail^.pcoef^.numb;
												if tail^.numb
												   then begin
													         rest := tail^.pcoef;
													         tail^.ncoef := rest^.ncoef;
																	 rest^.next := polygarb;
																	 polygarb := rest
																end;
												n := n^.next
										 end;
									tail^.next := nil;
									free_poly(q);
									q := head
							 end
			 else begin  { m^.exp > 0, n^.exp > 0, n^.exp >= m^.exp }
			         lead := m^.pcoef;
			         rest := m^.next;
			         if rest <> nil
			            then poly_inplace(rest);
			 			 
			         first := true;
			         while m^.exp <= n^.exp do
			            begin  { n will never be a number }
					           if first
						            then begin
								                newpoly(head);
												        tail := head    { don't turn off first yet }
										         end
								        else begin
								                newpoly(tail^.next);
												        tail := tail^.next
										         end;
						         tail^.exp := n^.exp - m^.exp;
						         coef := nil;
						         if lead^.numb
										    then poly_quot(n^.pcoef, lead, coef)
												else poly_divide(n^.pcoef, lead, coef);
										 tail^.numb := (tail^.exp = 0) and coef^.numb;
						         if tail^.numb
						            then begin
								                tail^.ncoef := coef^.ncoef;
												        coef^.next := polygarb;
												        polygarb := coef
										         end
								        else tail^.pcoef := coef;
						
						         if (rest = nil) or first
						            then n := n^.next
								        else begin
								                { free this node before moving on! }
												        coef := n^.next;
												        n^.next := nil;
												        free_poly(n);
												        n := coef
										         end;
										 
						        if rest = nil  { monomial m }
						           then if n = nil
								               then break
												       else { nothing }
						        else begin
						                coef := nil;
										        tail^.next := nil;
						                poly_mult(tail, rest, coef, nilpol);
										        if n <> nil
										           then if first
												               then better_poly_add(coef, n, coef)
																       else best_poly_add(coef, n, coef);
										        n := coef
									       end;
						        if first 
						           then first := false
					       end;
			 
			        if rest <> nil
			           then poly_inplace(rest);  { put it back }
			 											 
			        if n <> nil
							   then begin
								         if not n^.numb
												    then begin
														        writeln(userOutput, '*** Fermat warning. poly divide failure');
																		flush(userOutput);
																 end;
												 free_poly(n)
											end;
											
							tail^.next := nil;
			        free_poly(q);
			        q := head
					
				   end
		
		end;
		
 {*************************************************************************}
 
 procedure poly_div_no_q(n, m: ferm118.poly; var r: ferm118.poly);
 
    { Field case, highest level polys. Compute remainder only. 
		  Ordinary scalar arithmetic will be called on coefficients - they must be numbers.
			Assume m is not a number, so m^.exp >= 1.   			
			  Possible improvement: instead of calling free_poly so often in main loop, keep
			a local garbage list. }
			
		var first: boolean;
		    quotient, coef, lead, rest: ferm118.poly;
			
		begin
		
		   if m^.exp > n^.exp
			    then begin					        
									poly_assign(n, r);
									exit {(poly_div_no_q)}
							 end;
							 
			 lead := m^.pcoef;
			 rest := m^.next;
			 if rest <> nil
			    then poly_inplace(rest);  { clever way to avoid subtracting later. }

			 first := true;
			 newpoly(quotient);
			 quotient^.next := nil;
			 
			 while m^.exp <= n^.exp do
			    begin  { n will never be a number }					   
						 if rest <> nil
						    then begin
								        quotient^.exp := n^.exp - m^.exp;
						            quotient^.numb := (quotient^.exp = 0);
						            coef := nil;
						            poly_quot(n^.pcoef, lead, coef);
						            if quotient^.numb
						               then begin
								                   quotient^.ncoef := coef^.ncoef;
												           coef^.next := polygarb;
												           polygarb := coef
										            end
								           else quotient^.pcoef := coef
										 end;

						 if (rest = nil) or first
						    then n := n^.next
								else begin
								        { free this node before moving on! }
												coef := n^.next;
												n^.next := nil;
												free_poly(n);
												n := coef
										 end;

						 if rest = nil  { monomial m }
						    then if n = nil
								        then break
												else { nothing }
						 else begin
						         coef := nil;	
						         poly_mult(quotient, rest, coef, nilpol);
										 if n <> nil
										    then if first
												        then better_poly_add(coef, n, coef)
																else best_poly_add(coef, n, coef);
										 n := coef;
										 if quotient^.numb
			                  then free_imag(quotient^.ncoef)
			                  else free_poly(quotient^.pcoef);
									end;

						 if first 
						    then first := false
					end;
			 
			 if rest <> nil
			    then poly_inplace(rest);  { put it back }
			 
			 if n = nil
			    then poly_set(0, r)
					else if rest = nil
					        then poly_assign(n, r)
									else begin
									        free_poly(r);
													r := n
											 end;
											 
			 quotient^.next := polygarb;
			 polygarb := quotient
		
		end;
																		 						
	{****************************************************************************}
	
	procedure eliminate_bads(var p, exps: ferm118.poly; factor: longint);
	
	  { Lowest 'bad' exponents in p (or former p) of each poly var are given by exps. 
		  Add through to clear all 'bad' exponents, or to return former 'bad' 
			exponents.  factor = -1 means clear bads; factor = 1 means return 
			previously cleared bads, or adjust this poly using bads constructed from another
			poly. 'bad' means either negative, or a least exponent not 0.}
							
		 var t, q, s: ferm118.poly;
				 needto: boolean;
				 copy: longint;
				 
		 {------------------------------------------------------------}
		 
		 procedure pad_one(var p: ferm118.poly; val: longint);			 
				begin					   
					 newpoly(p);
					 p^.numb := false;
					 p^.exp := val;
					 p^.next := s;
					 p^.pcoef := q;
					 q := p						 
				end;
				
		 {-----------------------------------------------------------}
		 
		 procedure remove_q;
				begin  { q should now be a number }
					 if t = nil
							then p := q^.pcoef
							else t^.next := q^.pcoef;
					 q^.pcoef^.next := q^.next;
					 q^.next := polygarb;
					 polygarb := q;
					 q := q^.pcoef
				end;
				
		 {-----------------------------------------------------------}
		 
		 begin 
	 
				q := p;
				needto := (exps^.exp <> 0);
				if needto
					 then copy := factor*exps^.exp;
				t := nil;  { trailer behind q }
				
				while q <> nil do
					 begin
							 if exps^.next <> nil  { take care of lower polys first }
							    then if q^.numb
									        then begin
													        s := q^.next;
																	q^.next := nil;
																	eliminate_bads(q, exps^.next, factor);
																	{ q can't be a number now. }
																	if t = nil  { means p = q }
																     then pad_one(p, 0)
																     else pad_one(t^.next, 0)
															 end
													else eliminate_bads(q^.pcoef, exps^.next, factor);
													
							 if needto  { do this level }
								  then if q^.numb
												  then begin
												          s := q^.next;
																  q^.next := nil;
																  if t = nil  { means p = q }
																     then pad_one(p, copy)
																     else pad_one(t^.next, copy)
															 end
												  else q^.exp := q^.exp + copy;
												 
								if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil)
									 then remove_q;
															
							 t := q;
							 q := q^.next
						end
					 
		 end;
			 
 {*************************************************************************}
 
 procedure clear_bads(var p, exps, tail: ferm118.poly; value: longint);
 
    { Find lowest 'bad' exponents in p of each ferm118.poly var. Then add through to 
		  clear all 'bad' exponents. Return list of exponents found via
			exps and tail. If no 'bad's were found, exps is nil, tail undefined. }
 
    var s, last: ferm118.poly;
		    q: polypt;
		
		{____________________________________________________________________}
	
	  procedure find_negs(p, exps: ferm118.poly);
		
		   { Search for smallest negative exponents. If a variable is not present in
			   a node, can just move on. }
								
			 begin 
		 
				  repeat 
					   if not p^.numb
						    then if (not p^.pcoef^.numb) or (p^.pcoef^.next <> nil)
								        then find_negs(p^.pcoef, exps^.next);
						 if p^.next = nil
						    then break
								else p := p^.next
					until false;
					
					if p^.exp < exps^.exp
					   then exps^.exp := p^.exp
						 
			 end;
			 
		{____________________________________________________________________}
	
	  procedure find_bads(p, exps: ferm118.poly);
		
		   { Search EVERY node for lowest exponent of ALL variables at level of exps on 
			   down. If a variable is not present in a node, the implicit exp of 0 counts. }
								
			 var s: ferm118.poly;
			 
			 begin 
		 
				  repeat 
					   if p^.numb
						    then begin
								        s := exps;
												while s <> nil do
													 begin
														  if s^.exp > 0
															   then s^.exp := 0;
														  s := s^.next
													 end
										 end
						    else find_bads(p^.pcoef, exps^.next);
								
						 if p^.next = nil
						    then break
								else p := p^.next
					until false;
					
					if p^.exp < exps^.exp
					   then exps^.exp := p^.exp
						 
			 end;
			 
		{_________________________________________________________________}
		
		begin { of clear_bads }
		
		   { Create list of smallest exponents for each poly var.  Start by 
			   initializing list to value. }
			 newpoly(exps);
			 tail := exps;
			 tail^.exp := value;
			 q := polynames^.next;
			 while q <> nil do
			    begin
					   newpoly(tail^.next);
						 tail := tail^.next;
						 tail^.exp := value;
						 q := q^.next
					end;
			 tail^.next := nil;
			 
			 if value = 0
			    then find_negs(p, exps)
					else find_bads(p, exps);
			 
			 { identify deepest 'bad' with 'last'; then cut off list at that point. }
			 s := exps;
			 last := nil;
			 while s <> nil do
			    begin
					   if (s^.exp <> 0) and (s^.exp <> value)   
					      then last := s;
						 s := s^.next
					end;
			 if (last <> nil) and (last <> tail)
			    then begin
					        tail^.next := polygarb;
									polygarb := last^.next;
									last^.next := nil;
									tail := last
							 end;
			 
			 { If necessary, go through p making all exponents 'good'. }
			 if last = nil 
			    then begin
					        tail^.next := polygarb;
									polygarb := exps;
									exps := nil
							 end
					else eliminate_bads(p, exps, -1)
		   			 			 						
		end;
											 
 {***************************************************************************}
 
 procedure check_quoly(var q: quoly; q_odd: boolean); forward;
 
 {**************************************************************************} 
 
 procedure Lpoly_divide(var n, m, q: ferm118.poly; notsame: boolean);
   
	  { m is a standard poly.  n is probably (possibly?) a laurent poly.  Clean up n, 
		  then divide, then put n back, then adjust q.  No errors can interfere with 
			n being put back. 'notsame' means q and n are different. }

    var exps, tail: ferm118.poly;
		
		begin
		
		   if laurent
			    then begin
					        clear_bads(n, exps, tail, 0);
									poly_divide(n,m, q);
									if exps <> nil
									   then begin
										         if notsame
														    then eliminate_bads(n, exps, 1);
														 eliminate_bads(q, exps, 1);
														 tail^.next := polygarb;
														 polygarb := exps
													end									
					     end
					else poly_divide(n,m, q)
		
		end;

  {***************************************************************************}
 
  procedure compute_power(var n: ferm118.poly; expont: longint; pol: polypt);  forward;
 
  {**************************************************************************}
 
  procedure polygcd(u, v: ferm118.poly; var r: ferm118.poly); forward;

	{***************************************************************************}
	
	procedure differentiate(var n: quoly; height: integer; degree: longint); forward;
	
  {***************************************************************************}
 
  procedure poly_diff(var n: ferm118.poly; degree: longint); forward;
 
	{***************************************************************************}
	
	procedure general_poly_diff(var p: ferm118.poly; degree: longint; height: integer);  forward; 
	
	{***************************************************************************}
	
	procedure quoly_differen_once(var q: quoly; height: integer);  
	
	   { laurents ok.  q^.denom has no negative exponents. Differentiate once with 
		   respect to 'height' level poly var.  }
		 
		 var uprime, vprime, com: ferm118.poly;
	
	   begin
		 
		    if q^.numb 
				   then quoly_set(0, q)
				else if q^.denom = nil
								 then begin
												 general_poly_diff(q^.numer, 1, height);
												 if q^.numer^.numb and (q^.numer^.next = nil)
														then polynum_to_quoly(q)
											end
							else if (q^.denom^.exp = 0) and (height = 1)
								 then begin
												 poly_diff(q^.numer, 1);
												 check_quoly(q, false)  
											end
							else begin
											 uprime := nil;
											 poly_assign(q^.numer, uprime);
											 general_poly_diff(uprime, 1, height);
											 poly_mult(q^.denom, uprime, uprime, pseudo_polynames);
											 vprime := nil;
											 com := nil;
											 poly_assign(q^.denom, vprime);
											 general_poly_diff(vprime, 1, height);
											 polygcd(q^.denom, vprime, com); 
											 poly_mult(q^.numer, vprime, q^.numer, pseudo_polynames);
											 free_poly(vprime);
											 if com^.numb
											    then vprime := q^.denom
													else poly_divide(q^.denom, com, vprime);
															 
											 poly_mult(q^.denom, vprime, q^.denom, pseudo_polynames);
											 { if com^.numb, vprime now undefined. }
											 
											 best_poly_sub(uprime, q^.numer, q^.numer);
											 if not com^.numb
											    then begin
													        poly_divide(q^.numer, com, q^.numer);
																	free_poly(vprime)
													     end;
											 free_poly(com);  
											 
											 if poly_iszero(q^.denom)
													then begin
													        error(22, quotsign);
																	quoly_set(1, q)
															 end;
											 check_quoly(q, false)  
										end	
						 
		 end;
		 
 {****************************************************************************}
 
 procedure pseudo_div(n, m: ferm118.poly; var q, r: ferm118.poly; want_rem: boolean);
 
    { Integral domain case. Pseudo division, a'la Knuth p. 407. General polys at
		  the same level.  Assume m^.exp >= 1. q can't be r.  n, m not changed. 
			If want_rem, r is nil on entry. }
			
		var head, ncopy, coef, lead, rest, quot, dum: ferm118.poly;
		    pass: longint;
			
		begin
		
		   if m^.exp > n^.exp
			    then begin					        
									poly_set(0, q);
									if want_rem
									   then poly_assign(n, r);
									exit {(pseudo_div)}
							 end;
							 
			 ncopy := nil;
			 poly_assign(n, ncopy);
			 n := ncopy;
			 lead := m^.pcoef;
			 rest := m^.next;
			 if rest <> nil
			    then poly_inplace(rest);  { clever way to avoid subtracting later. }			 			 
			 if lead^.numb
			    then head := lead
					else begin
					        newpoly(head);
			            head^.next := nil;
			            head^.numb := false;
			            head^.exp := 0;
									head^.pcoef := lead
							 end;
			 quot := nil;
			 pass := n^.exp - m^.exp + 1;  

			 while m^.exp <= n^.exp do
			    begin  { n will never be a number upon entering this loop. }
						 { break off first node. }
						 coef := n;
						 n := n^.next;
						 coef^.exp := coef^.exp - m^.exp;
						 coef^.numb := (coef^.exp = 0) and (coef^.pcoef^.numb);
						 if coef^.numb
						    then begin
								        dum := coef^.pcoef;
												coef^.ncoef := dum^.ncoef;
												dum^.next := polygarb;
												polygarb := dum
										 end;
						 coef^.next := nil;						 			
             
						 if n <> nil
						    then poly_mult(n, head, n, nilpol);
						 if quot <> nil
						    then begin
								        poly_mult(quot, head, quot, nilpol);
												lastnode(quot)^.next := coef
										 end
								else quot := coef;

						 pass := pass - 1;
						 if rest = nil  { monomial m }
						    then if n = nil
								        then break
												else { nothing }
						    else begin								        
												dum := nil;
								        poly_mult(coef, rest, dum, nilpol);
												if n = nil
												   then n := dum
													 else best_poly_add(n, dum, n)
										 end
										 
					end;

			 if rest <> nil
			    then poly_inplace(rest);  { put it back }			 
							 
			 if pass > 0  { make (8) on p. 407 Knuth true. Might not be because 
									               main loop ended 'early'. }
				  then if pass > 1
								  then begin
												  coef := nil;
													poly_assign(head, coef);
													compute_power(coef, pass, nilpol)
											 end
									else coef := head;
													
			 if want_rem
			    then if n = nil
									then poly_set(0, r)
									else begin
													if pass > 0  { make (8) on p. 407 Knuth true. Might not be because 
																				 main loop ended 'early'. }
														 then poly_mult(n, coef, n, nilpol);
													r := n
											 end
					 else free_poly(n);
			 
			 if pass > 0
			    then poly_mult(quot, coef, quot, nilpol);
			 free_poly(q);
			 q := quot;
							 
			 if pass > 1
			    then free_poly(coef);
			 if not head^.numb
			    then begin
					        head^.next := polygarb;
									polygarb := head
							 end
							 
		end;
																		 						
 {**************************************************************************}
 
 procedure pseudo_div_no_q(n, m: ferm118.poly; var r: ferm118.poly);
 
    { Integral domain case. Pseudo division, a'la Knuth p. 407. General polys.  
		  Compute remainder only. Assume m^.exp >= 1. polys at same level. }
			
		var head, ncopy, coef, lead, rest: ferm118.poly;
		    pass: longint;
			
		begin
		
		   if m^.exp > n^.exp
			    then begin					        
									poly_assign(n, r);
									exit {(pseudo_div_no_q)}
							 end;
			 ncopy := nil;
			 poly_assign(n, ncopy);
			 n := ncopy;
			 lead := m^.pcoef;
			 rest := m^.next;
			 if rest <> nil
			    then poly_inplace(rest);  { clever way to avoid subtracting later. }			 			 
			 if lead^.numb
			    then head := lead
					else begin
					        newpoly(head);
			            head^.next := nil;
			            head^.numb := false;
			            head^.exp := 0;
									head^.pcoef := lead
							 end;
			 pass := n^.exp - m^.exp + 1;

			 while m^.exp <= n^.exp do
			    begin  { n will never be a number upon entering this loop}
						 { break off first node. }
						 coef := n;
						 n := n^.next;
						 coef^.exp := coef^.exp - m^.exp;
						 coef^.numb := (coef^.exp = 0) and (coef^.pcoef^.numb);
						 if coef^.numb
						    then begin
								        coef^.next := polygarb;
												polygarb := coef;
												coef := coef^.pcoef
										 end
								else coef^.next := nil;
						 if n <> nil
						    then poly_mult(n, head, n, nilpol);

						 pass := pass - 1;
						 if rest = nil  { monomial m }
						    then begin
								        free_poly(coef);
												if n = nil
								           then break
										 end
						    else begin
								        poly_mult(coef, rest, coef, nilpol);
												if n = nil
												   then n := coef
													 else best_poly_add(n, coef, n)
										 end
					end;

			 if rest <> nil
			    then poly_inplace(rest);  { put it back }			 
							 
			 if n = nil
			    then poly_set(0, r)
					else begin
					        if pass > 0  { make (8) on p. 407 Knuth true. Might not be because 
									               main loop ended 'early'. }
									   then begin										         
														 if pass > 1
														    then begin
																        coef := nil;
																        poly_assign(head, coef);
														            compute_power(coef, pass, nilpol)
																		 end
																else coef := head;
														 poly_mult(n, coef, n, nilpol);
														 if pass > 1
														    then free_poly(coef)
													end;
									free_poly(r);
									r := n
							 end;
							 
			 if not head^.numb
			    then begin
					        head^.next := polygarb;
									polygarb := head
							 end
							 
		end;
																		 						
 {*************************************************************************}
 
 procedure content(q: ferm118.poly; var r: ferm118.poly);
 
    { Compute the content of the poly q.  If q is a number return 1.  If q has only
		  one node, return that coefficient.  An unpadded poly is returned (i.e., highest 
			pad is not there, if logically it should be.  This is convenient for polygcd.)
			Does not always return a poly with normalized numerical coefficients. 
			Called only by polygcd.  Not checked for laurent. }
 
		begin
		
		   if lastnode(q)^.numb
			    then poly_set(1, r)
			 else begin
			         poly_assign(q^.pcoef, r);
							 q := q^.next;
			         while q <> nil do
							    begin
									   polygcd(r, q^.pcoef, r);
										 if r^.numb
										    then break
												else q := q^.next
									end
						end
						
    end;

 {*************************************************************************}
 
 procedure monic_poly(q: ferm118.poly);
 
    { make a monic poly. }
 
    var p: ferm118.poly;
		    n: number;
		
		procedure divide_thru(u: ferm118.poly);
		   begin
			    while u <> nil do
					   begin
						    if u^.numb
					         then quot(u^.ncoef^, n, u^.ncoef^)
	                 else divide_thru(u^.pcoef);
							  u := u^.next
						 end
			 end;
			 
	  begin
	
	     p := leading_coef(q);
			 n.float := p^.ncoef^.float;
			 n.imag := p^.ncoef^.imag;
					
	     divide_thru(q)
		  
	  end;
 
 {*************************************************************************}
	
 procedure total_poly_modout(var p: ferm118.poly); forward;
		
 {*************************************************************************}
 
 procedure normal_form(q: quoly);
 
    { q is not a number. q^.numer <> 0. q^.denom <> nil and is not a number. Put into 
		  canonical form. Don't convert to number. }
 
    var exps, tail: ferm118.poly;
	
	  begin 

	     { Note:  leading_coef(q^.denom) might not be a genuine number
				 in laurent.  That's ok. }
			 poly_quot(q^.numer, leading_coef(q^.denom), q^.numer);
			 monic_poly(q^.denom);
			 
			 if laurent
			    then begin	
					        clear_bads(q^.denom, exps, tail, two_to_31);
									if exps <> nil
									   then begin
										         eliminate_bads(q^.numer, exps, -1);
														 tail^.next := polygarb;
														 polygarb := exps;
														 if pseudo_polynames <> nil  
								                then total_poly_modout(q^.numer);  { can't become 0 }																																						 
														 if q^.denom^.numb
								                then begin
													              poly_quot(q^.numer, q^.denom, q^.numer);
													              free_poly(q^.denom)
											               end
													end
							 end
					 						
		end;
											 
  {***********************************************************************}
	
	procedure basic_poly_gcd(n,m: ferm118.poly; var p: ferm118.poly); 
	 
    { Warning. n exor m zero produces either 1 or the other as output.  As of
		  August 15, this is ok. Both zero produces 0 as output. n and m numbers,
			non zero, produces answer 1.  In rational mode, 
			non-number gcd's have integer coefs, positive leading coef, and have content 1.}
			 
    var r {wwh , ncopy, mcopy}: ferm118.poly;
		    count: longint;
				
		{----------------------------------------------------------}
		
		procedure basic_loop;
		
		  begin

				while not m^.numb do
			    { if m becomes 0, answer is n. if m is <> 0 number, answer is 1.
					   must free stuff as go along and also at end. }
			    begin
					   r := nil;
					   poly_div_no_q(n, m, r);
						 Inc(count);
						 if count > 2
								then free_poly(n);
						 n := m;
						 m := r;
						 if not m^.numb  { originally: and (count >= 2) }
						    then monic_poly(m)	
				  end
					
			end;
			
		{---------------------------------------------------------------}
		
		begin 
		
		   if n^.exp < m^.exp
			    then begin
					        r := n;
									n := m;
									m := r
							 end;
	 
			 { now m^.exp <= n^.exp }
			 count := 0;
//wwh			 ncopy := nil;
//wwh			 mcopy := nil;

       basic_loop;

			 if poly_iszero(m)  { ought to check instead that |m| is less than epsilon }
			    then { answer is n }
					     if count > 1
					        then begin
									        free_poly(p);
													p := n
											 end
									else poly_assign(n, p)
			    else { answer is 1; free n if possible/necessary }
					     begin
							    poly_set(1, p);
									if count > 1
									   then free_poly(n)
							 end;
			 if count > 0
					then free_poly(m);
			 if not p^.numb
			    then monic_poly(p)
							 
		end;
		
	{**************************************************************************}
	
	function minn(a, b: longint): longint;
			begin
				 if a < b
						then minn := a
						else minn := b
			end;
					 
	{***************************************************************************}
	
	function quick_depth_below(p: ferm118.poly): integer;
		 
		 { no laurents. if field_depth > 0, p is not at field_depth, but next level might
		   be.  This procedure computes 'level' for polygcd.  
			    p is never a number.  p has no 0-exponent head nodes. }
			 
		 var d: integer;
		 
		 begin
		 
				d := 0;
				while p <> nil do
					 begin
							if not p^.numb
								 then if p^.pcoef^.numb  { we use here that there are no laurents. }
												 then begin
																 if d = 0
																	  then d := 1
															end
												 else d := maxx(d, 1 + quick_depth_below(p^.pcoef));
							p := p^.next
					 end;
				quick_depth_below := d
				
		 end;
			 
 {**************************************************************************}
 
 procedure actual_eval_poly(var n, n2: ferm118.poly; target, source: longint); forward;
 
 {**************************************************************************}
 
 procedure polygcd; {(u, v: ferm118.poly; var r: ferm118.poly);}
 
    { neither is 0.  r could
		  be u, or u could be part or r!!  Careful!!  Maybe u could be v; haven't 
			checked carefully. }
		
		var height, i, level, base: integer;
		    delta, uexp, vexp: longint;
		    s, t, d, g, h, newh, ucopy, vcopy, utail, vtail, comm: ferm118.poly;
			  is_a_mon: boolean;
				local_list: test_array;
				
		{_______________________________________________________________________}
		
		procedure finish; 
		   begin
			    if not d^.numb
						 then add_pad(d, 1);
					poly_mult(r, d, r, nilpol);
					if comm <> nil
					   then poly_mult(r, comm, r, nilpol); 
					free_poly(d);
					free_poly(comm);
					if not r^.numb
						 then monic_poly(r);
					{exit(polygcd)}
			 end;
			 
		{_______________________________________________________________________}
		
		procedure check_uv; 
		   begin
			    if (ucopy = nil) and (uexp > 0)
					   then restore_exps(u, utail, uexp);
					if (vcopy = nil) and (vexp > 0)
					   then restore_exps(v, vtail, vexp);
					if ucopy <> nil  
					   then free_poly(u);
					if vcopy <> nil  
					   then free_poly(v)
			 end;
				
		{_______________________________________________________________________}
		
		procedure monomial(u, v: ferm118.poly; e: longint);  {!!}     
		   { u is a monomial in the top level variable. (Lower levels could be quite
			   complex.)  We know that gcd(u,v) has content 1. Note that if the lower
				 levels are all below field depth, content = 1 is automatic or vacuous.
				    So, gcd(u,v) is simply v^k; just need to find k.
						DANGER:  Remember r could be u or v (the local vars here).
						This is an extremely delicate procedure. }
		   var f: longint;
			 begin
					e := lastnode(v)^.exp + e;  { Do these first! }
					f := u^.exp;
					check_uv;  { might change u.  v might be r! }
					if e = 0
						 then poly_set(1, r)
						 else begin
										 if f < e
												then e := f;
										 base_poly(r, 1);
										 r^.exp := e
									end;
					finish
			 end;

		{______________________________________________________________________}

		procedure fast_divide(s, d: ferm118.poly);

		   { Assume that s^.exp > 0 on entry. }

			 var t: ferm118.poly;
		
		   begin
			 
			    while s <> nil do
						 begin
								poly_divide(s^.pcoef, d, s^.pcoef);
								if (s^.exp = 0) and s^.pcoef^.numb
									 then begin
													 t^.next := s^.pcoef;  { t can't be nil or undefined }
													 s^.next := polygarb;
													 polygarb := s;
													 s := s^.pcoef
												end;
								t := s;
								s := s^.next
						 end
						 
			 end;
			 
		{________________________________________________________________________}																	
																				
		function fast_test(i: integer): boolean;
		
		   { true means that gcd(n, m) involves at worst only lower levels poly vars. 
				 		u and v are not necessarily of content 1, but gcd(u, v) has content 1. 
				 Reduce to height 1 (ideally) poly by poly eval at an essentially random 
				 number, i.  This process is a homomorphism, as long as you don't have 
				 poly mod out!  If field_depth > 0, we will accomodate by not going below 
				 field_depth level, via the global vars 'level' and 'its_bottom'.
				     Any non-trivial factor of u and v must show up as a nontrivial
				 factor of the reduced polys, so long as the degrees do not decrease. }
				 
		   var j: integer;
					 
			 function F(i, n, j, b, level: integer): integer;
			    { Originally, this function simply returned i, so that every poly var
					  would be evaluated at i.  That isn't good enough.  The present version
						is quite complex.  The final case is the jth digit of: n written to the 
						base b.  j = 0 means last digit. !!}
					var k, x: integer;
					begin
					   if level = 2
						    then F := i
						 else if j > 1
						    then F := i div 2
						 else if i > 6   { i is 7 - 10 }
						    then F := i - 4
								else begin   { j is either 0 or 1 }
								        x := 1;
											  for k := 1 to j do
													 x := x*b;
											  n := n div x;
											  F := n mod b
										 end
					end;
			 			 			 
			 begin

					poly_assign(u, g);
				  poly_assign(v, h);
					for j := level downto 2 do
						 begin
						    poly_set(F(i, local_list[i], j-2, base, level), t);
								actual_eval_poly(g, t, LongInt(j), halfblock)  {@@@}
						 end;
					if g^.exp < u^.exp
					   then begin
						         fast_test := false;
										 exit {(fast_test)}
									end;

					for j := level downto 2 do
						 begin
						    poly_set(F(i, local_list[i], j-2, base, level), t);
								actual_eval_poly(h, t, LongInt(j), halfblock)  {@@@}
						 end;
					if h^.exp < v^.exp
					   then begin
						         fast_test := false;
										 exit {(fast_test)}
									end;
				  free_poly(t);
					basic_poly_gcd(g, h, t); { Don't use r here! Sneaky! }
				  fast_test := t^.numb

			 end;
											 
		{_________________________________________________________________________}

		begin

			 if u^.numb or v^.numb
					then begin
					        poly_set(1, r);
									exit {(polygcd)}
							 end;	
					
			 if number_polys = 1
			    then basic_poly_gcd(u, v, r)
			 else if (u^.exp = 0) and (v^.exp = 0)
			    then begin
							    height := 0;
								  repeat 
										 u := u^.pcoef;
										 v := v^.pcoef; 
										 Inc(height)
									until (u^.exp > 0) or (v^.exp > 0);
									polygcd(u, v, r);
									if not r^.numb
									   then add_pad(r, height)																			 																				 																					
							 end		
			 else if (u^.exp = 0) or (v^.exp = 0)
			    then begin
					        if u^.exp = 0
									   then begin
										         s := u;
														 u := v;
														 v := s
													end;
									s := nil;
									content(u, s);  
									v := v^.pcoef;
									polygcd(s, v, r);  
									free_poly(s);
									if not r^.numb
									   then add_pad(r, 1)
					     end
		{	 else if u = v never happen? ~~~
			    then poly_assign(v, r)  }
			 else if height_is_1(u) and height_is_1(v) 
			    then basic_poly_gcd(u, v, r) { rearrange position of call }
			 else begin  { algorithm C, p. 410, Knuth II. similar notation used here. }

			         { u^.exp and v^.exp are both positive. }
							 t := nil;											 
							 ucopy := nil;
							 vcopy := nil;
							 comm := nil;  
							 utail := nil;
							 vtail := nil;
							 
							 { Check for easy factor out of highest power.  Can't touch a 
							   monomial, though. }
							 if u^.next = nil
							    then uexp := 0  
									else uexp := lastnode(u)^.exp;
							 if v^.next = nil
							    then vexp := 0  
									else vexp := lastnode(v)^.exp;
							 if uexp > 0
							    then sub_expons(u, utail, uexp);
							 if vexp > 0
								  then sub_expons(v, vtail, vexp);
							 if (uexp > 0) and (vexp > 0)
							    then begin
									        base_poly(comm, 1);
													comm^.exp := minn(uexp, vexp)
											 end;
											 
							 { u^.exp must be >= v^.exp. after swap, r could be v. }
							 if u^.exp < v^.exp
			            then begin
					                s := u;
									        u := v;
									        v := s;
													s := utail;
									        utail := vtail;
									        vtail := s;
													delta := uexp;
													uexp := vexp;
													vexp := delta
							         end;
							 s := nil;
							 
							 content(u, s);
							 content(v, t);
							 
							 d := nil;
							 polygcd(s, t, d); 
							 
							 is_a_mon := (u^.next = nil) or (v^.next = nil);
							 
							 if not s^.numb and not is_a_mon 
							    then begin
									        if ucopy = nil
													   then begin
														         poly_assign(u, ucopy);
																		 if uexp > 0
						                            then restore_exps(u, utail, uexp);
													           u := ucopy
																	end;
													fast_divide(u, s);
													ucopy := u
											 end;
							 if not t^.numb and not is_a_mon
							    then begin
									        if vcopy = nil
													   then begin
														         poly_assign(v, vcopy);
																		 if vexp > 0
						                            then restore_exps(v, vtail, vexp);
													           v := vcopy
																	end;
													fast_divide(v, t);
													vcopy := v
											 end;
											 
							 free_poly(s);
							 free_poly(t);
							 
							 { Check for some easy cases: (1) one argument a monomial. (2) fast test
							   for gcd = 1. }
							 if u^.next = nil
							    then begin
                    monomial(u, v, vexp);
                    exit
                  end
									else if v^.next = nil
									        then begin
                            monomial(v, u, uexp);  { exits if either is monomial }
                            exit
                          end;
							 
							 { Neither u nor v is monomial. }
							 { Check for equality now. }
							 if essentially_equal(u, v)
							    then begin
									        poly_assign(u, t);							 
							 					  check_uv;
													free_poly(r);
													r := t;
													finish;
                          exit
											 end;
											 
							 g := nil;
							 h := nil;
							 { s, t nil }
							 
							 if poly_length(u) + poly_length(v) > 10  
							    then height := 10
									else if node_total(u) + node_total(v) > 14
													then height := 8
													else height := 4;
													
							 base := 3;
							 local_list := base_3_list;
									
							 level := quick_depth_below(u);
							 i := quick_depth_below(v);
							 if i > level
							    then level := i;
							 if level = 2 
							    then height := minn(6, height);
																	
							 if level >= 2
							    then for i := 0 to height do
													if fast_test(i)
														 then begin
																		 free_poly(g);
																		 free_poly(h);  
																		 check_uv;
																		 free_poly(r);  { not before! }
																		 r := t;  { beware other versions of Fermat here }
																		 finish;
                                     exit
																	end;
							 
							 { Now back to general method. }
							 if ucopy = nil  
							    then if uexp > 0
												  then begin
																  poly_assign(u, ucopy);
																  restore_exps(u, utail, uexp);
																  u := ucopy
															 end;
							 if vcopy = nil  
							    then if vexp > 0
												  then begin
																  poly_assign(v, vcopy);
																  restore_exps(v, vtail, vexp);
																  v := vcopy
															 end;
															 
							 poly_set(1, h);
							 poly_set(1, g);
							 
							 height := 0;
							 newh := nil;
							 while true do
							    begin
									   { v is never a number at start of this loop. }
									   s := nil;
									   delta := u^.exp - v^.exp;
										 pseudo_div_no_q(u, v, s);
										 if poly_iszero(s)
										    then break
										 else if s^.exp = 0
												     then begin
														         if height = 0
																		    then v := vcopy;
																		 poly_set(1, v);
																		 break
																	end;
										 case height of
										    0: if ucopy <> nil
												      then free_poly(u);
												1: if vcopy <> nil
												      then free_poly(u);
												else free_poly(u)
										 end;
												
										 u := v;
										 v := s;

										 { set newh = h^delta }
										 if delta = 0
										    then poly_set(1, newh)
												else poly_assign(h, newh);
										 if delta > 1
										    then compute_power(newh, delta, nilpol);
										 { compute new v and new g }
										 poly_mult(g, newh, g, nilpol);
										 	 
										 if g^.numb
										    then poly_quot(v, g, v)
												else poly_divide(v, g, v);
												
										 poly_assign(u^.pcoef, g);
										 if not g^.numb
										    then add_pad(g, 1);
										 {set t = g^delta }
										 if delta = 0
										    then poly_set(1, t)
												else poly_assign(g, t);
										 if delta > 1
										    then compute_power(t, delta, nilpol);
										 poly_mult(t, h, t, nilpol);
										 if newh^.numb
										    then poly_quot(t, newh, h)
												else poly_divide(t, newh, h);

  									 Inc(height)
										 
									end;
									
							 if (height = 0) and (not v^.numb) and (vcopy = nil)
							    then poly_assign(v, r)
									else begin
									        free_poly(r);
													r := v
											 end;
											 
							 if height > 1
									then free_poly(u)
							 else if height = 0
							    then free_poly(ucopy)
							 else if height = 1
							    then free_poly(vcopy);  { which equals u if vcopy <> nil }
									
							 free_poly(h);
							 free_poly(newh);
							 free_poly(s);
							 free_poly(g);
							 
							 { cleanse r if necessary }
							 if not r^.numb
							    then begin
									        content(r, t);
													if not t^.numb
													   then fast_divide(r, t)
											 end;
											 
								free_poly(t);
								finish;
                exit
									 
						end
						
		end;
		
 {**************************************************************************}
 
 procedure Lpolygcd(var u, v, r: ferm118.poly; v_odd: boolean);
 
    { Can't have r = u or r = v. }
 
    var expsu, expsv, tailu, tailv: ferm118.poly;
 
    begin
		
		   if laurent 
			    then begin
					        clear_bads(u, expsu, tailu, 0);								
									if v_odd
									   then clear_bads(v, expsv, tailv, 0)
										 else expsv := nil;
									polygcd(u,v, r);									
									if expsu <> nil
									   then begin  { put negative exps back }
										         eliminate_bads(u, expsu, 1);
														 tailu^.next := polygarb;
														 polygarb := expsu
													end;
									if expsv <> nil
									   then begin  { put negative exps back }
										         eliminate_bads(v, expsv, 1);
														 tailv^.next := polygarb;
														 polygarb := expsv
													end
					     end
					else polygcd(u,v, r)
		
		end;

 {**************************************************************************}
 
 procedure Lpolygcd2(var u, v, r: ferm118.poly);
 
    { used for one case when r = u. no need to reassemble u or v. }
 
    var expsu, expsv, tailu, tailv: ferm118.poly;
 
    begin
		
		   if laurent 
			    then begin
					        clear_bads(u, expsu, tailu, 0);
									clear_bads(v, expsv, tailv, 0);
									polygcd(u,v, r);									
									if expsu <> nil
									   then begin
														 tailu^.next := polygarb;
														 polygarb := expsu
													end;
									if expsv <> nil
									   then begin
														 tailv^.next := polygarb;
														 polygarb := expsv
													end
					     end
					else polygcd(u,v, r)
		
		end;

 {**************************************************************************}

 procedure general_quoly_add(n, m: quoly; var q: quoly; add: boolean);
    
		{ Neither n nor m is a number.  Both have denoms.  q must be an existing quoly
		  that is not a number. q might be n. Method of P. Henrici. }
 
    var com, dup, n1, n2: ferm118.poly;
		
		begin  
		
			 com := nil;
			 dup := nil;
			 n1 := nil;
			 n2 := nil;
			 polygcd(n^.denom, m^.denom, com);
			 if com^.numb
			    then begin
									n2 := m^.denom;
									poly_mult(m^.numer, n^.denom, n1, pseudo_polynames);
							 end
					else begin
					        poly_divide(n^.denom, com, n1);
			            poly_divide(m^.denom, com, n2);
									poly_mult(m^.numer, n1, n1, pseudo_polynames)
							 end;							 
			 poly_mult(n^.numer, n2, dup, pseudo_polynames);

			 free_poly(q^.numer);
			 if add
			    then best_poly_add(dup, n1, q^.numer)
					else best_poly_sub(dup, n1, q^.numer);
					
			 if poly_iszero(q^.numer)
					then begin
					        free_poly(q^.denom);
									polynum_to_quoly(q)
							 end
			 else begin
							 poly_mult(n^.denom, n2, q^.denom, pseudo_polynames);
							 dup := nil;							 
							 Lpolygcd(q^.numer, com, dup, false);
							 			
							 if not dup^.numb
									then begin
													Lpoly_divide(q^.numer, dup, q^.numer, false);
											    poly_divide(q^.denom, dup, q^.denom)
											 end;
							 if q^.denom^.numb
								  then if poly_iszero(q^.denom)
					                then error(210, token)
											 else begin
															 poly_quot(q^.numer, q^.denom, q^.numer);
															 free_poly(q^.denom);
															 if q^.numer^.numb and (q^.numer^.next = nil)
																  then polynum_to_quoly(q)
													  end;
							 free_poly(dup)
						end;
			 if not com^.numb
			    then free_poly(n2);
			 free_poly(com)
						
		end;
		 
 {*************************************************************************}

 procedure quoly_add(n, m: quoly; var p: quoly);
 
    var q: quoly;
		    dup: ferm118.poly;
				 
    begin
		
			 if realflag
			    then begin
					        if p = nil
									   then begin
										         newquoly(p);
														 p^.numb := true;
														 init_quoly_node(p)
													end;
								  p^.ncoef^.float := n^.ncoef^.float + m^.ncoef^.float;
									exit {(quoly_add)}
							 end;
							 
			 newquoly(q);
		   if n^.numb and m^.numb
				  then begin					        
									q^.numb := true;
					        newimag(q^.ncoef);
									q^.ncoef^.imag := nil;
		              add(n^.ncoef^, m^.ncoef^, q^.ncoef^);
									free_quoly(p);
			            p := q;
									exit {(quoly_add)}
							 end;
			
			 if command_int 
			    then check_cmd_keys;
													
			 q^.numb := false;
			 q^.numer := nil;
			 q^.denom := nil;
			 if n^.numb
			    then begin
					        dup := nil;									
					        quoly_to_poly(n, dup);
									if m^.denom = nil
					           then poly_add(dup, m^.numer, q^.numer)									        
									   else no_denom(dup, m, q, 0);
								  free_poly(dup)
							 end
			 else if m^.numb
					then begin
					        dup := nil;
					        quoly_to_poly(m, dup);
									if n^.denom = nil
					           then poly_add(dup, n^.numer, q^.numer)									        
									   else no_denom(dup, n, q, 0);
								  free_poly(dup)
							 end
			 else if (n^.denom = nil) and (m^.denom = nil)
			         then begin
											 poly_add(n^.numer, m^.numer, q^.numer);
											 if q^.numer^.numb and (q^.numer^.next = nil)
											    then polynum_to_quoly(q)
										end
			 else if n^.denom = nil
			         then no_denom(n^.numer, m, q, 0)
			 else if m^.denom = nil
			         then no_denom(m^.numer, n, q, 0)
			 else general_quoly_add(n, m, q, true);
			 									
			 free_quoly(p);
			 p := q
			 
		end;
		
 {**************************************************************************}

 procedure better_quoly_add(n, m: quoly; var p: quoly);
 
    { m is read only. gobble up n. n <> m. p could be n. p <> m. }
 
    var dup: ferm118.poly;
 
    begin
		
		   if realflag
			    then begin
					        if p <> n
										 then begin
										         if p <> nil
														    then free_quoly(p);
														 p := n
													end;
									p^.ncoef^.float := n^.ncoef^.float + m^.ncoef^.float;
									exit {(better_quoly_add)}
							 end;
							 
			 if command_int 
			    then check_cmd_keys;
													
			 if p = n
			    then p := nil
					else free_quoly(p);
					
			 if n^.numb and m^.numb
				  then begin					        
		              add(n^.ncoef^, m^.ncoef^, n^.ncoef^);
									p := n
							 end
			 else if n^.numb
			    then begin
					        newquoly(p);
									p^.numb := false;
									p^.denom := nil;
									p^.numer := nil;
					        dup := nil;                      
					        quoly_consume(n, dup);
									if m^.denom = nil
									   then better_poly_add(dup, m^.numer, p^.numer)  
									   else begin
										         no_denom(dup, m, p, 0);
														 free_poly(dup)
													end
							 end
			 else if m^.numb
					then begin
									newpoly(dup);
									dup^.exp := 0;
									dup^.next := nil;
									dup^.numb := true;
									dup^.ncoef := m^.ncoef;
					        if n^.denom = nil
									   then better_poly_add(n^.numer, dup, n^.numer)
										 else no_denom(dup, n, n, 0);
									p := n;
									dup^.next := polygarb;
									polygarb := dup
							 end				
			 else if (n^.denom = nil) and (m^.denom = nil)
			         then begin
									     better_poly_add(n^.numer, m^.numer, n^.numer);
											 if n^.numer^.numb and (n^.numer^.next = nil)
											    then polynum_to_quoly(n);
											 p := n
										end
			 else if n^.denom = nil
			         then begin
							         no_denom(n^.numer, m, n, 0);
											 p := n
										end
			 else if m^.denom = nil
			         then begin
							         no_denom(m^.numer, n, n, 0);
											 p := n
										end											 
			 else begin
			         newquoly(p);
							 p^.numb := false;
							 p^.numer := nil;
							 p^.denom := nil;
			         general_quoly_add(n, m, p, true);
							 free_quoly(n)
						end
			 																 
		end;
		
 {**************************************************************************}

 procedure best_quoly_add(var n: quoly; m: quoly);
 
    { Add and put answer in n. n <> m. See documentation under best_poly_add. }
 
    var dup: ferm118.poly;
		    p: imptr;
 
    begin
		
		   if realflag
			    then begin
					        n^.ncoef^.float := n^.ncoef^.float + m^.ncoef^.float;
									p := m^.ncoef;
			            p^.imag := imhead;
			            imhead := p;
									m^.next := quolygarb; 
									quolygarb := m;
									exit {(best_quoly_add)}
							 end;
							 
			 if command_int 
			    then check_cmd_keys;
								 
			 if n^.numb and m^.numb
				  then begin					        
		              add(n^.ncoef^, m^.ncoef^, n^.ncoef^);
									p := m^.ncoef;
			            if p^.imag = nil
										 then p^.imag := imhead
										 else p^.imag^.imag := imhead;
								  imhead := p;
									m^.next := quolygarb; 
									quolygarb := m
							 end
			 else if n^.numb
			    then begin
					        dup := nil;            
					        quoly_consume(n, dup);
									newquoly(n);
									n^.numb := false;
						      n^.denom := nil;
									n^.numer := nil;
									if m^.denom = nil
									   then begin
										         best_poly_add(m^.numer, dup, n^.numer);
														 m^.next := quolygarb; 
									           quolygarb := m;
									           if n^.numer^.numb and (n^.numer^.next = nil)
									              then polynum_to_quoly(n)
												  end
										 else begin
										         no_denom(dup, m, n, 0);
														 free_poly(dup);
														 free_quoly(m)
													end																					
							 end
			 else if m^.numb
					then begin
					        dup := nil;                      
					        quoly_consume(m, dup);
									if n^.denom = nil
									   then better_poly_add(n^.numer, dup, n^.numer)
										 else no_denom(dup, n, n, 0);
									free_poly(dup)
							 end				
				else if (n^.denom = nil) and (m^.denom = nil)
			         then begin
									     better_poly_add(n^.numer, m^.numer, n^.numer);
											 free_poly(m^.numer);
											 m^.next := quolygarb; 
									     quolygarb := m;
											 if n^.numer^.numb and (n^.numer^.next = nil)
											    then polynum_to_quoly(n)
										end
			 else if n^.denom = nil
			         then begin
							         no_denom(n^.numer, m, n, 0);
											 free_quoly(m)
										end
			 else if m^.denom = nil
			         then begin
							         no_denom(m^.numer, n, n, 0);
											 free_quoly(m)
										end											 
			 else begin
			         general_quoly_add(n, m, n, true);
							 free_quoly(m)
						end
			 																 
		end;
		
  {**************************************************************************}

  procedure quoly_sub(n, m: quoly; var p: quoly);
 
    var q: quoly;
		    dup: ferm118.poly;
 
    begin
		
			 if realflag
			    then begin
					        if p = nil
									   then begin
										         newquoly(p);
														 p^.numb := true;
														 init_quoly_node(p)
													end;
									p^.ncoef^.float := n^.ncoef^.float - m^.ncoef^.float;
									exit {(quoly_sub)}
							 end;

			 if command_int 
			    then check_cmd_keys;
													
			 newquoly(q);
		   if n^.numb and m^.numb
				  then begin					        
									q^.numb := true;
					        newimag(q^.ncoef);
									q^.ncoef^.imag := nil;
		              sub(n^.ncoef^, m^.ncoef^, q^.ncoef^);
									free_quoly(p);
			            p := q;
									exit {(quoly_sub)}
							 end;
			
			 q^.numb := false;
			 q^.numer := nil;
			 q^.denom := nil;
			 if n^.numb
			    then begin
					        dup := nil;									
					        quoly_to_poly(n, dup);
									if m^.denom = nil
					           then poly_sub(dup, m^.numer, q^.numer)									        
									   else no_denom(dup, m, q, 1);
								  free_poly(dup)
							 end
			 else if m^.numb
					then begin
					        dup := nil;
					        quoly_to_poly(m, dup);
									if n^.denom = nil
					           then poly_sub(n^.numer, dup, q^.numer)									        
									   else no_denom(dup, n, q, -1);
								  free_poly(dup)
							 end
			 else if (n^.denom = nil) and (m^.denom = nil)
			         then begin
											 poly_sub(n^.numer, m^.numer, q^.numer);
											 if q^.numer^.numb and (q^.numer^.next = nil)
											    then polynum_to_quoly(q)
										end
			 else if n^.denom = nil
			         then no_denom(n^.numer, m, q, 1)
			 else if m^.denom = nil
			         then no_denom(m^.numer, n, q, -1)
			 else general_quoly_add(n, m, q, false);
			 									
			 free_quoly(p);
			 p := q
			 
		end;
		
  {**************************************************************************}

  procedure better_quoly_sub(n, m: quoly; var p: quoly);
 
    var dup: ferm118.poly;
 
    begin
		
		   if realflag
			    then begin
					        if p <> n
										 then begin
										         if p <> nil
														    then free_quoly(p);
														 p := n
													end;
								  p^.ncoef^.float := n^.ncoef^.float - m^.ncoef^.float;
									exit {(better_quoly_sub)}
							 end;
							 
			 if command_int 
			    then check_cmd_keys;
													
			 if p = n
			    then p := nil
					else free_quoly(p);
			 if n^.numb and m^.numb
				  then begin					        
		              sub(n^.ncoef^, m^.ncoef^, n^.ncoef^);
									p := n
							 end
			 else if n^.numb
			    then begin
					        newquoly(p);
									p^.numb := false;
									p^.denom := nil;
									p^.numer := nil;
					        dup := nil;                      
					        quoly_consume(n, dup);
									if m^.denom = nil
									   then better_poly_sub(dup, m^.numer, p^.numer)  { result dup can't be number }
									   else begin
										         no_denom(dup, m, p, 1);
														 free_poly(dup)
													end
							 end
			 else if m^.numb
					then begin
									newpoly(dup);
									dup^.exp := 0;
									dup^.next := nil;
									dup^.numb := true;
									dup^.ncoef := m^.ncoef;
					        if n^.denom = nil
									   then better_poly_sub(n^.numer, dup, n^.numer)
										 else no_denom(dup, n, n, -1);
									p := n;
									dup^.next := polygarb;
									polygarb := dup
							 end				
			 else if (n^.denom = nil) and (m^.denom = nil)
			         then begin
									     better_poly_sub(n^.numer, m^.numer, n^.numer);
											 if n^.numer^.numb and (n^.numer^.next = nil)
											    then polynum_to_quoly(n);
											 p := n
										end
			 else if n^.denom = nil
			         then begin
							         no_denom(n^.numer, m, n, 1);
											 p := n
										end
			 else if m^.denom = nil
			         then begin
							         no_denom(m^.numer, n, n, -1);
											 p := n
										end											 
			 else begin
			         newquoly(p);
							 p^.numb := false;
							 p^.numer := nil;
							 p^.denom := nil;
			         general_quoly_add(n, m, p, false);
							 free_quoly(n)
						end
			 																 
		end;
		
  {**************************************************************************}

  procedure best_quoly_sub(var n: quoly; m: quoly);
 
    { Add and put answer in n. n <> m. See documentation under best_poly_add. }
 
    var dup: ferm118.poly;
		    p: imptr;
 
    begin
		
		   if realflag
			    then begin
					        n^.ncoef^.float := n^.ncoef^.float - m^.ncoef^.float;
									p := m^.ncoef;
			            p^.imag := imhead;
			            imhead := p;
									m^.next := quolygarb; 
									quolygarb := m;
									exit {(best_quoly_sub)}
							 end;
							 
			 if command_int 
			    then check_cmd_keys;
								 
			 if n^.numb and m^.numb
				  then begin					        
		              sub(n^.ncoef^, m^.ncoef^, n^.ncoef^);
									p := m^.ncoef;
			            if p^.imag = nil
										 then p^.imag := imhead
										 else p^.imag^.imag := imhead;
			            imhead := p;
									m^.next := quolygarb; 
									quolygarb := m
							 end
			 else if n^.numb
			    then begin
					        dup := nil;            
					        quoly_consume(n, dup);
									newquoly(n);
									n^.numb := false;
						      n^.denom := nil;
									n^.numer := nil;
									if m^.denom = nil
									   then begin
										         better_poly_sub(dup, m^.numer, n^.numer);
														 free_poly(m^.numer);
														 m^.next := quolygarb; 
									           quolygarb := m;
									           if n^.numer^.numb and (n^.numer^.next = nil)
									              then polynum_to_quoly(n)
												  end
										 else begin
										         no_denom(dup, m, n, 1);
														 free_poly(dup);
														 free_quoly(m)
													end																					
							 end
			 else if m^.numb
					then begin
					        dup := nil;                      
					        quoly_consume(m, dup);
									if n^.denom = nil
									   then better_poly_sub(n^.numer, dup, n^.numer)
										 else no_denom(dup, n, n, -1);
									free_poly(dup)
							 end				
				else if (n^.denom = nil) and (m^.denom = nil)
			         then begin
									     better_poly_sub(n^.numer, m^.numer, n^.numer);
											 free_poly(m^.numer); 
											 m^.next := quolygarb; 
									     quolygarb := m;
											 if n^.numer^.numb and (n^.numer^.next = nil)
											    then polynum_to_quoly(n)
										end
			 else if n^.denom = nil
			         then begin
							         no_denom(n^.numer, m, n, 1);
											 free_quoly(m)
										end
			 else if m^.denom = nil
			         then begin
							         no_denom(m^.numer, n, n, -1);
											 free_quoly(m)
										end											 
			 else begin
			         general_quoly_add(n, m, n, false);
							 free_quoly(m)
						end
			 																 
		end;
		
 {*************************************************************************}
		
 procedure no_denom; {(r: ferm118.poly; s: quoly; var q: quoly; flag: integer)}
    
		{ q might be s. if so, gobble up storage of s^.numer and s^.denom. 
		  r might be q^.numer. flag allows for subtraction, either way. }
		
		var com: ferm118.poly;
		
		begin			 
		   com := nil;
			 poly_mult(r, s^.denom, com, pseudo_polynames);
			 if q = s
			    then if flag = 0
					        then best_poly_add(com, s^.numer, q^.numer)
									else best_poly_sub(com, s^.numer, q^.numer)
					else begin
					        free_poly(q^.numer);
									if flag = 0
					           then better_poly_add(com, s^.numer, q^.numer)
									   else better_poly_sub(com, s^.numer, q^.numer)
							 end;
			 if q <> s
			    then poly_assign(s^.denom, q^.denom);
			 if flag = -1
			    then quoly_inplace(q)
		end;
		
 {***************************************************************************}
	
 procedure gen_quoly_mult(n, m: quoly; var q: quoly);
 
    { Assume q exists and is a nilled out non-number. q might be left as a non-number
		  with nilled denom and number numer. In modular mode, q^.numer could be 0
			and q^.denom <> nil. This procedure is called by quoly_quot, in
			which m has flipped numers and denoms.}
 
    var com1, com2, n1, d1, n2, d2: ferm118.poly;
 
    begin
		
			 com1 := nil;
			 com2 := nil;
			 Lpolygcd(n^.numer, m^.denom, com1, false);
			 if com1^.numb
			    then begin
					        n1 := n^.numer;
									d2 := m^.denom
							 end
					else begin
					        n1 := nil;
									d2 := nil;
					        Lpoly_divide(n^.numer, com1, n1, true);
									poly_divide(m^.denom, com1, d2)
						   end;
			 Lpolygcd(m^.numer, n^.denom, com2, false);
			 if com2^.numb
			    then begin
					        n2 := m^.numer;
									d1 := n^.denom
							 end
					else begin
					        n2 := nil;
									d1 := nil;
					        Lpoly_divide(m^.numer, com2, n2, true);
									poly_divide(n^.denom, com2, d1)
						   end;
			 poly_mult(n1, n2, q^.numer, pseudo_polynames);
			 poly_mult(d1, d2, q^.denom, pseudo_polynames);
			 
			 if q^.denom^.numb and (q^.denom^.next = nil)
					then if poly_iszero(q^.denom)
					        then error(210, token)
							 else begin
											poly_quot(q^.numer, q^.denom, q^.numer);
											free_poly(q^.denom)
									 end;
			 if not com1^.numb
			    then begin
					        free_poly(n1);
									free_poly(d2)
							 end;
			 if not com2^.numb
			    then begin
					        free_poly(n2);
									free_poly(d1)
							 end;
			 free_poly(com1);
			 free_poly(com2)
			 
		end;					 
 
 {***************************************************************************}
	
 procedure quoly_mult(n, m: quoly; var p: quoly);
 
    var q: quoly;
		    dup, com: ferm118.poly;
 
    begin
		   
       newquoly(q);
		   if n^.numb and m^.numb
				  then begin					        
									q^.numb := true;
					        newimag(q^.ncoef);
									q^.ncoef^.imag := nil;
		              mult(n^.ncoef^, m^.ncoef^, q^.ncoef^);
									free_quoly(p);
			            p := q;
									exit {(quoly_mult)};
							 end;
							 
			 if command_int 
			    then check_cmd_keys;
									
			 q^.numb := false;
			 q^.numer := nil;
			 q^.denom := nil;
			 if n^.numb
			    then begin
					        dup := nil;																		
					        quoly_to_poly(n, dup);
									poly_mult(dup, m^.numer, q^.numer, pseudo_polynames);
									if m^.denom <> nil
									   then poly_assign(m^.denom, q^.denom);
									free_poly(dup);
							 end
			 else if m^.numb
					then begin
					        dup := nil;
					        quoly_to_poly(m, dup);
									poly_mult(n^.numer, dup, q^.numer, pseudo_polynames);
									if n^.denom <> nil
									   then poly_assign(n^.denom, q^.denom);
									free_poly(dup);
							 end				
			 else if (n^.denom = nil) and (m^.denom = nil)
			         then poly_mult(n^.numer, m^.numer, q^.numer, pseudo_polynames)
			 else if n^.denom = nil
			         then begin
							         com := nil;
							         Lpolygcd(n^.numer, m^.denom, com, false);
											 if com^.numb
											    then begin
													        poly_mult(n^.numer, m^.numer, q^.numer, pseudo_polynames);
																	poly_assign(m^.denom, q^.denom)
															 end
													else begin
													        Lpoly_divide(n^.numer, com, q^.numer, true);
																	poly_divide(m^.denom, com, q^.denom);
																	poly_mult(q^.numer, m^.numer, q^.numer, pseudo_polynames);
																	if q^.denom^.numb
								                     then begin
													                   poly_quot(q^.numer, q^.denom, q^.numer);
													                   free_poly(q^.denom)
											                    end
															 end;
											 free_poly(com)
										end
			 else if m^.denom = nil
			         then begin
							         com := nil;
							         Lpolygcd(m^.numer, n^.denom, com, false);
											 if com^.numb
											    then begin
													        poly_mult(m^.numer, n^.numer, q^.numer, pseudo_polynames);
																	poly_assign(n^.denom, q^.denom)
															 end
													else begin
													        Lpoly_divide(m^.numer, com, q^.numer, true);
																	poly_divide(n^.denom, com, q^.denom);
																	poly_mult(q^.numer, n^.numer, q^.numer, pseudo_polynames);
																	if q^.denom^.numb
								                     then begin
													                   poly_quot(q^.numer, q^.denom, q^.numer);
													                   free_poly(q^.denom)
											                    end
															 end;
											 free_poly(com)
										end
       else gen_quoly_mult(n, m, q);
			         			 
			 if q^.numer^.numb and (q^.numer^.next = nil)
					then if poly_iszero(q^.numer)
					        then quoly_set(0, q)
									else if q^.denom = nil
									        then polynum_to_quoly(q);
									
			 free_quoly(p);
			 p := q
			 
		end;
		
 {***************************************************************************}
	
 procedure quoly_quot(n, m: quoly; var p: quoly);
 
    var q, recip: quoly;
		    com: ferm118.poly;
 
    begin
		   
       newquoly(q);
		   if n^.numb and m^.numb
				  then begin					        
									q^.numb := true;
					        newimag(q^.ncoef);
									q^.ncoef^.imag := nil;
		              quot(n^.ncoef^, m^.ncoef^, q^.ncoef^);
									free_quoly(p);
			            p := q;
									exit {(quoly_quot)}
							 end;
							 
			 if command_int 
			    then check_cmd_keys;
													
			 q^.numb := false;
			 q^.numer := nil;
			 q^.denom := nil;
			 if m^.numb
					then begin
					        com := nil;									
					        quoly_to_poly(m, com);
									poly_quot(n^.numer, com, q^.numer);
									if n^.denom <> nil
									   then poly_assign(n^.denom, q^.denom);
									free_poly(com);
							 end
			 else if n^.numb
			    then begin
					        com := nil;									
					        quoly_to_poly(n, com);
									if m^.denom = nil
									   then begin
										         poly_assign(com, q^.numer);
														 poly_assign(m^.numer, q^.denom)
													end
										 else begin
										         poly_mult(com, m^.denom, q^.numer, pseudo_polynames);
														 poly_assign(m^.numer, q^.denom);
														 if q^.denom^.numb and (q^.denom^.next = nil)
								                then begin
													              poly_quot(q^.numer, q^.denom, q^.numer);
													              free_poly(q^.denom)
											               end
													end;
									free_poly(com)
							 end
			 				
				else if (n^.denom = nil) and (m^.denom = nil)
			         then begin	
											 com := nil;
											 Lpolygcd(n^.numer, m^.numer, com, true);
											 if com^.numb
											    then begin
													        poly_assign(n^.numer, q^.numer);
																	poly_assign(m^.numer, q^.denom)
															 end
											 else begin
															 Lpoly_divide(n^.numer, com, q^.numer, true);
															 Lpoly_divide(m^.numer, com, q^.denom, true);
															 if q^.denom^.numb and (q^.denom^.next = nil)
																	then begin
																					poly_quot(q^.numer, q^.denom, q^.numer);
																					free_poly(q^.denom)
																			 end
														end;
											 free_poly(com)											 
										end
			 else if n^.denom = nil
			         then begin
							         com := nil;
							         Lpolygcd(n^.numer, m^.numer, com, true);
											 if com^.numb
											    then begin
													        poly_mult(n^.numer, m^.denom, q^.numer, pseudo_polynames);
																	poly_assign(m^.numer, q^.denom)
															 end
													else begin
													        Lpoly_divide(n^.numer, com, q^.numer, true);
																	Lpoly_divide(m^.numer, com, q^.denom, true);
																	poly_mult(q^.numer, m^.denom, q^.numer, pseudo_polynames)
															 end;
											 if q^.denom^.numb and (q^.denom^.next = nil)
								          then begin
													        poly_quot(q^.numer, q^.denom, q^.numer);
													        free_poly(q^.denom)
											         end;
											 free_poly(com)
										end
			 else if m^.denom = nil
			         then begin
							         com := nil;
							         Lpolygcd(n^.numer, m^.numer, com, true);
											 if com^.numb
											    then begin
													        poly_mult(m^.numer, n^.denom, q^.denom, pseudo_polynames);
																	poly_assign(n^.numer, q^.numer)
															 end
													else begin
													        Lpoly_divide(n^.numer, com, q^.numer, true);
																	Lpoly_divide(m^.numer, com, q^.denom, true);
																	poly_mult(q^.denom, n^.denom, q^.denom, pseudo_polynames)
															 end;
											 if q^.denom^.numb and (q^.denom^.next = nil)
								          then begin
													        poly_quot(q^.numer, q^.denom, q^.numer);
													        free_poly(q^.denom)
											         end;
											 free_poly(com)
										end
       else begin
			         newquoly(recip);
							 recip^.numb := false;
							 if laurent 
							    then begin
									        recip^.numer := nil;
													recip^.denom := nil;
													poly_assign(m^.denom, recip^.numer);
													poly_assign(m^.numer, recip^.denom);
													if recip^.denom^.numb and (recip^.denom^.next = nil)
														 then begin
																		 poly_quot(recip^.numer, recip^.denom, recip^.numer);
																		 free_poly(recip^.denom)
																	end
														 else normal_form(recip);
													quoly_mult(n, recip, q);
													free_quoly(recip);
													free_quoly(p);
			                    p := q;
									        exit {(quoly_quot)}
											 end
									else begin
													 recip^.numer := m^.denom;
													 recip^.denom := m^.numer;
													 gen_quoly_mult(n, recip, q);
													 recip^.next := quolygarb;
							             quolygarb := recip
											 end
						end;
									 
			 if q^.numer^.numb and (q^.numer^.next = nil)
					then if poly_iszero(q^.numer)
					        then quoly_set(0, q)
									else if q^.denom = nil
									        then polynum_to_quoly(q);
									
			 if not q^.numb
			    then if q^.denom <> nil
					        then normal_form(q);
											 
			 free_quoly(p);
			 p := q
			 
		end;
		
 {****************************************************************************}						 
 
 procedure two_times_poly(s: ferm118.poly);
 
   { ONLY POLY SQUARE CALLS THIS. }
 
    begin
		
		   while s <> nil do
			    begin
					   if s^.numb
						    then add(s^.ncoef^, s^.ncoef^, s^.ncoef^)
						    else two_times_poly(s^.pcoef);
						 s := s^.next
					end
			
		end;
		
 {*************************************************************************}
 
 procedure check_quoly; {(var q: quoly; q_odd: boolean);}
 
    { q^.denom <> nil.  q^.numer <> 0. q^.denom may be a number, but can't be 0.
		  may end with q^.numer^.numb. q_odd means q^denom might have negative exps. 
			Beware other versions of Fermat!  This one is simpler here. }
 
    var com: ferm118.poly;
		
		begin
		
		   if not q^.denom^.numb or (q^.denom^.next <> nil)
					then begin
							    com := nil;
								  Lpolygcd(q^.numer, q^.denom, com, q_odd);
									if not com^.numb
										 then begin
														 Lpoly_divide(q^.numer, com, q^.numer, false);
													   if q_odd
														    then Lpoly_divide(q^.denom, com, q^.denom, false)
																else poly_divide(q^.denom, com, q^.denom)
													end;
									free_poly(com)
							 end;
				if q^.denom^.numb and (q^.denom^.next = nil)
					 then begin
									 poly_quot(q^.numer, q^.denom, q^.numer);
									 free_poly(q^.denom)
						    end
					 else normal_form(q)
								
		end;
		
 {*************************************************************************}
 
 procedure quoly_imag_free(var q: quoly; err_flag: boolean);
 
    begin
		
		   if q^.numb
			    then imag_free(q^.ncoef^)
			 else begin
			         poly_imag_free(q^.numer);
							 if q^.denom <> nil
							    then begin 
									        poly_imag_free(q^.denom);
													if poly_iszero(q^.denom)
													   then if err_flag
														         then error(188, token)
																		 else begin
																		         writeln(userOutput, ' Warning. A quoly denominator became 0 and was set to 1.');
																						 flush(userOutput);
																						 poly_set(1, q^.denom)
																					end;
													if poly_iszero(q^.numer)
													   then begin
														         quoly_set(0, q);
																		 exit {(quoly_imag_free)}
																	end;
													check_quoly(q, false) 
											 end; 
							 if q^.numer^.numb and (q^.numer^.next = nil) and (q^.denom = nil)
							    then polynum_to_quoly(q)
						end
						
		end;
						
 {*************************************************************************}
 
 procedure quoly_imag_part(var q: quoly);
 
    begin
		
		   if q^.numb
			    then imag_part(q^.ncoef^)
			 else begin
			         poly_imag_part(q^.numer);
							 if q^.denom <> nil
							    then begin 
									        poly_imag_part(q^.denom);
													if poly_iszero(q^.denom)
													   then error(188, token);
													if poly_iszero(q^.numer)
													   then begin
														         quoly_set(0, q);
																		 exit {(quoly_imag_part)}
																	end;
													check_quoly(q, false)  
											 end; 
							 if q^.numer^.numb and (q^.numer^.next = nil) and (q^.denom = nil)
							    then polynum_to_quoly(q)
						end
						
		end;
						
 {*************************************************************************}
 
 procedure quoly_conjugate(var q: quoly);
 
    { easy because conjugation is an automorphism. }
 
    begin
		
		   if q^.numb
			    then conjugate(q^.ncoef^, q^.ncoef^)
			 else begin
			         poly_conjugate(q^.numer);
							 if q^.denom <> nil
							    then poly_conjugate(q^.denom)							 
						end
						
		end;
						
 {***************************************************************************}
 
 procedure quoly_great_int(var q: quoly);
		
		begin
		
	{	   if down
			    then SetRound(Downward)
					else SetRound(ToNearest);@@@}
			 if q^.numb
			    then complex_great_int(q^.ncoef^, q^.ncoef^)
			 else begin
			         poly_great_int(q^.numer);
							 if q^.denom <> nil
							    then begin 
									        poly_great_int(q^.denom);
													if poly_iszero(q^.denom)
													   then error(187, token);
													if poly_iszero(q^.numer)
													   then begin
														         quoly_set(0, q);
																		 exit {(quoly_great_int)}
																	end;
													check_quoly(q, false)  
											 end; 
							 if q^.numer^.numb and (q^.numer^.next = nil) and (q^.denom = nil)
							    then polynum_to_quoly(q)
						end
						
		end;
						
 {*********************************************************************}

 procedure inumber_power(var n: longreal; e: longint);
 
    var m: longreal;
		    i, last: integer;
		    negflag: boolean;
        powerOf2: longint;

    begin									 				

				if (n = 0) and (e <= 0)
				   then error(22, token);
					 
			  negflag := (e < 0);
				if negflag 
				   then begin
					         e := -e;
									 if n = 0
					            then error(22, token)
								end;
					 
				if e and 1 <> 0
					 then m := n
					 else m := 1;
					 
				last := 0;
        powerOf2 := 1 shl 30;
				for i := 30 downto 0 do
        begin
					 if e and powerOf2 <> 0
							 then begin
												last := i;
												break
										end;
           powerOf2 := powerOf2 shr 1;
        end;

				powerOf2 := 2;
				for i := 1 to last do
					 begin
							 n := n * n;
							 if e and powerOf2 <> 0
									then m := n * m;
               powerOf2 := powerOf2 shl 1;
					 end;
					 
				n := m;
				if negflag
				   then n := 1/n
			
	  end;
						 
 {*********************************************************************}

 procedure number_power(var n: number; expont: longint);
 
    var m: number;
		    i,last: integer;
        powerOf2 : longint;
  
    begin									 				

				m.imag := nil;
				if expont and 1 <> 0
					 then complex_assign(n, m)
					 else m.float := 1;

				powerOf2 := 1 shl 30;
				for i := 30 downto 0 do
        begin
					 if expont and powerOf2 <> 0
							 then begin
												last := i;
												break
										end;
           powerOf2 := powerOf2 shr 1
        end;

				powerOf2 := 2;
				for i := 1 to last do
					 begin
							 mult(n, n, n);
							 if expont and powerOf2 <> 0
									then mult(n, m, m);
               powerOf2 := powerOf2 shl 1
					 end;
					 
				imag_free(n);
				n := m
			
	  end;
						 
 {*********************************************************************}

 procedure compute_power; {(var n: ferm118.poly; expont: longint; pol: polypt)}  
 
    { expont must be positive. n gets changed.}
 
    var i, last: longint;
				m: ferm118.poly;
				powerOf2 : longint;
    {__________________________________________________________________}	
		
		function bysquaring(m: ferm118.poly): boolean;
		
		  { true means ferm118.poly is essentially all of lowest level. }
		
		   var length: longint;
			     maybe_not: boolean;
					 q: ferm118.poly;
			 
			 begin
			 
			    if (polynames = nil) or (polynames^.next = nil)
					   then begin
						         bysquaring := true;
										 exit {(bysquaring)}
									end;
					maybe_not := false;
					q := m;
				  length := 0;
				  while q <> nil do
				     begin
					      if not q^.numb
							     then if not q^.pcoef^.numb or (q^.pcoef^.next <> nil)
								         then maybe_not := true;
							  q := q^.next;
							  Inc(length);
								if maybe_not and (length > 1)
								   then begin
									         bysquaring := false;
													 exit {(bysquaring)}
												end
					   end;
				  if maybe_not
				     then bysquaring := bysquaring(m^.pcoef)
						 else bysquaring := true
						 
			 end;
			 
			 {__________________________________________________________________}

		begin
		
				{ Determine most efficient way to multiply -- depends on poly coeffs. }
				m := nil;
				if not bysquaring(n)
				   then begin
					         poly_assign(n, m);
									 for i := 2 to expont do
											poly_mult(m, n, m, pol)
								end
								
				else begin									 				
								if expont and 1 <> 0
									 then poly_assign(n, m)
									 else poly_set(1, m);

								powerOf2 := 1 shl 30;
								for i := 30 downto 0 do
                begin
									 if expont and powerOf2 <> 0
											 then begin
																last := i;
																break
														end;
                   powerOf2 := powerOf2 shr 1;
                end;

								powerOf2 := 2;
								for i := 1 to last do
									 begin
											 if n^.numb and (n^.next = nil)
													then mult(n^.ncoef^, n^.ncoef^, n^.ncoef^)
													else poly_mult(n, n, n, pol);
											 if expont and powerOf2 <> 0
													then poly_mult(m, n, m, pol);
                       powerOf2 := powerOf2 shl 1;
									 end									 
						 end;
					 
				free_poly(n);
				n := m
			
		end;

  {***************************************************************************}
	
	procedure quoly_compute_power(var q: quoly; expont: longint);
	
	   begin
		  
			  if expont <= 0
				   then begin
					         writeln(userOutput, ' *** Fermat error.  negative exponent');
									 flush(userOutput)
								end;
								
				if q^.numb
				   then number_power(q^.ncoef^, expont)
				else begin
				        compute_power(q^.numer, expont, pseudo_polynames);
								if q^.denom <> nil
								   then begin
									         compute_power(q^.denom, expont, pseudo_polynames);
													 if q^.denom^.numb 
								              then begin
													            poly_quot(q^.numer, q^.denom, q^.numer);
													            free_poly(q^.denom)
																	 end													
											  end;
								if q^.numer^.numb and (q^.numer^.next = nil) and (q^.denom = nil)
									 then polynum_to_quoly(q)
						 end
						 
		 end;
		 
 {******************************************************************************}
 
 procedure get_quoly_ptr(q: arrptr; r,c: longint; colflag: boolean; var qp: quolyptr;
                         var x: tokentipe; its_syst: boolean);
	
	  { In sparse array, qp might be nil but qp^ is not.  In ordinary array, qp
		  can't be nil but qp^ might be. <<<< 
			
			 Nov 1997:  Beware!  qp might be nil at end, if we have a sparse array 
		   with no entry present, i.e., 0.  Caller must check. 
			 Jan 1998:  also, qp^ might be nil; uninitialized ordinary array. 
			 
			 This is now called array_quoly_ptr in QFermat }
			
		var t: colm_ptr;
		    sp: sparseptr;
				i: longint;
		
		begin
		
      r := r - addresser;
			c := c - addresser;
			if (r < 0) or (c < 0)
         then error(27, x);
				
			if colflag and (r > q^.rows - 1)
			   then error(27, x);
      if q^.spar = nil
				 then begin
								 c := q^.start + r + c * q^.rows;
								 if (c < q^.start) or (c > q^.stop)
										then error(27, x);
								 if its_syst
								    then qp := @ stash^[c]
										else qp := @ arp[c shr 10]^[c and tenmask]
							end
				 else begin
								 if colflag
								    then c := c + 1  {@@@ remove +1}
										else begin
										        c := 1 + r div q^.rows;
								            r := r mod q^.rows  {@@@ remove +1}
								         end;
								 if c > q^.size div q^.rows
								    then error(27, x);
								 sp := q^.spar;  
				         for i := 1 to r div sparsesize do
								    sp := sp^.next;
				         t := sp^.indx[1 + r mod sparsesize];
								 while t <> nil do
										if t^.coord >= c  {@@@ added > }
											 then break
											 else t := t^.next;
								 if t = nil
										then qp := nil
										else if t^.coord > c  { not sure this is possible? }
										        then qp := nil
										        else qp := @ t^.val
							end
							
		 end;
							
	{****************************************************************************}

	function spar_retrieve(sp: sparseptr; r, c: longint): quoly;
	
	   { sp is changed. }
		 
		 var s: colm_ptr;
		     i: longint;
		 
		 begin
		 
		    for i := 1 to (r - 1) div sparsesize do {```}
					 sp := sp^.next;
			  s := sp^.indx[1 + (r - 1) mod sparsesize];
				while s <> nil do
				   if s^.coord = c
					    then begin
							        spar_retrieve := s^.val;
											exit {(spar_retrieve)}
									 end
							else if s^.coord < c
							        then s := s^.next
								      else break;
				
		    spar_retrieve := quol_num_0
		 
		 end;
	
	{****************************************************************************}

  procedure lookup(x: tokentipe;  r, c: longint; var q: arrptr; var qp: quolyptr;
	                 colflag: boolean); forward;
	
	{****************************************************************************}
	
  function rand_integer: longint;
 	
//wwh	   var rand_int: longint;
		 
		 begin
		    
//wwh				rand_int := abs(random();
//wwh				rand_integer := RandomRange(BSL(rand_int, 16) + abs(random)   {@@@}
 				rand_integer := RandomRange(0, 2147483647)   {@@@}

		end;

  {**********************************************************************}

	procedure randomize(again: boolean; var n: quoly);

	   var next: longint;
		     m: number;
		 
		 begin
		 
		    next := rand_integer;
				m.float := next;
				m.imag := nil;
				if again
					 then begin
//wwh				           next := abs(next * Tickcount) mod block;
									 next := abs(next * longint(Trunc(2147483647.0*Frac(Time)))) mod block;
								   m.float := next
								end;
				quot(m, rand_denom_n, m);
				scalar_to_quoly(m, n)
								
		end;
		
  {****************************************************************************}
	
	procedure quoly_abs(q: quoly; flag: boolean); forward;
	
	{***************************************************************************}
	
	procedure sparse_great_abs(var spar: sparseptr; rows: longint; free, abs: boolean);
	
	   { Similar enough. }
	
	   var spar2: sparseptr;  {``` delete i}
				 
		 {------------------------------------------------------------------------}
		 
		 procedure basic;
		    var i, k: longint;
				    u: colm_ptrptr;
						sp: sparseptr;
				begin
				   sp := spar;  {```}
				   for k := 0 to (rows - 1) div sparsesize do
					    begin
							   for i := 1 + k*sparsesize to (k+1)*sparsesize do
								    if i > rows 
								       then break
								    else begin
														u := @ sp^.indx[i-k*sparsesize];
														while u^ <> nil do
															 if abs
																	then begin
																					quoly_abs(u^^.val, true);
																					u := @ u^^.next
																			 end
																	else begin
																					quoly_great_int(u^^.val);
																					if quoly_iszero(u^^.val)
																						 then free_colm(u^)
																						 else u := @ u^^.next
																			 end
												 end;
					       sp := sp^.next
							end
				end;
				
		 {------------------------------------------------------------------------}
		 
		 begin
		 
		    if free
		       then basic
					 else begin
									 copy_sparse(spar, spar2, rows, false);
									 spar := spar2;
									 basic
								end
		 
		 end;
	
	{******************************************************************************}
	
	procedure quoly_mod_or_div(n, m: quoly; var p: quoly; which: char); forward;
	
	{*******************************************************************************}
	
	procedure sparse_mod_or_div(var spar: sparseptr; n2: quoly; row: longint; 
	                            free: boolean; which: char);
	
	   var i, k: longint;
		     spar2, sp, sp2: sparseptr;
				 u: colm_ptrptr;
				 t: colm_ptr;
				 n: quoly;
		 
		 begin
		 
		    if free
				   then begin
					         sp := spar;  {```}
									 for k := 0 to (row - 1) div sparsesize do
										  begin
												 for i := 1 + k*sparsesize to (k+1)*sparsesize do
													  if i > row 
															 then break
													  else begin
																		u := @ spar^.indx[i-k*sparsesize];
																		while u^ <> nil do
																			 begin
																					quoly_mod_or_div(u^^.val, n2, u^^.val, which);
																					if quoly_iszero(u^^.val)
																						 then free_colm(u^)
																						 else u := @ u^^.next
																			 end
																 end;
												 sp := sp^.next
											end
							  end
				   else begin
					         n := nil;
									 sp := spar;  {```}
									 for k := 0 to (row - 1) div sparsesize do
										  begin
												 if k = 0
												    then begin
														        newsparse(spar2);
																		sp2 := spar2
																 end
														else begin
														        newsparse(sp2^.next);
																		sp2 := sp2^.next
														     end;
									       for i := 1 + k*sparsesize to (k+1)*sparsesize do
													  if i > row 
															 then break
													  else begin
																		t := sp^.indx[i-k*sparsesize];
																		u := @ sp2^.indx[i-k*sparsesize];
																		while t <> nil do
																			 begin
																					quoly_mod_or_div(t^.val, n2, n, which);
																					if quoly_iszero(n)
																						 then free_quoly(n)
																						 else begin
																										 newcolm(u^);
																										 u^^.coord := t^.coord;
																										 u^^.val := n;
																										 n := nil;
																										 u := @ u^^.next
																									end;
																					t := t^.next
																			 end;
																		u^ := nil
																 end;
													sp := sp^.next
										  end;
											
									 spar := spar2
							  end
				
     end;
	
	{******************************************************************************}
	
	procedure mult_cons_sparse(var spar: sparseptr; n2: quoly; free: boolean; row: longint);
	
	   var i, k: longint;
		     spar2, sp, sp2: sparseptr;
				 u: colm_ptrptr;
				 t: colm_ptr;
				 n: quoly;
		 
		 begin
		 
		    sp := spar;  {```}
				if free
				   then if realflag
					         then for k := 0 to (row - 1) div sparsesize do
													begin
														 for i := 1 + k*sparsesize to (k+1)*sparsesize do
																if i > row 
																	 then break
																else begin
																				u := @ sp^.indx[i-k*sparsesize];
																				while u^ <> nil do
																					 begin
																							u^^.val^.ncoef^.float := n2^.ncoef^.float * u^^.val^.ncoef^.float;
																							if u^^.val^.ncoef^.float = 0
																								 then free_colm(u^)
																								 else u := @ u^^.next
																					 end
																		 end;
														 sp := sp^.next
												  end

									 else for k := 0 to (row - 1) div sparsesize do
													begin
														 for i := 1 + k*sparsesize to (k+1)*sparsesize do
																if i > row 
																	 then break
																else begin
																				u := @ sp^.indx[i-k*sparsesize];
																				while u^ <> nil do
																					 begin
																							quoly_mult(u^^.val, n2, u^^.val);
																							if quoly_iszero(u^^.val)
																								 then free_colm(u^)
																								 else u := @ u^^.next
																					 end
																		 end;
														 sp := sp^.next
												  end
				   else begin
					         n := nil;
									 for k := 0 to (row - 1) div sparsesize do
											begin
												 if k = 0
												    then begin
														        newsparse(spar2);
																		sp2 := spar2
																 end
														else begin
														        newsparse(sp2^.next);
																		sp2 := sp2^.next
														     end;
												 for i := 1 + k*sparsesize to (k+1)*sparsesize do
														if i > row 
															 then break
														else begin
																		t := sp^.indx[i-k*sparsesize];
																		u := @ sp2^.indx[i-k*sparsesize];
																		while t <> nil do
																			 begin
																					quoly_mult(t^.val, n2, n);
																					if quoly_iszero(n)
																						 then free_quoly(n)
																						 else begin
																										 newcolm(u^);
																										 u^^.coord := t^.coord;
																										 u^^.val := n;
																										 n := nil;
																										 u := @ u^^.next
																									end;
																					t := t^.next
																			 end;
																		u^ := nil
																 end;
												sp := sp^.next	 
										 end;	
										 
									spar := spar2
							 end
		 
		 end;
	
	{***************************************************************************}
	
	procedure flip_sparse(var spar, spar2: sparseptr; row, col: longint); forward;
	
	{***************************************************************************}
	
	procedure trans_sparse(var spar: sparseptr; row, col: longint); forward;
	
	{***************************************************************************}
	
	procedure mult_sparses(var spar, spar2: sparseptr; var arrf: arr_descr; rows2, cols2:
	                       longint; arr_free: boolean);
	
	   { answer back in spar. If spar = spar2, BOTH will be freed at end if arr_free. }
		 
		 var i, j, k, rows1, j2: longint;
		     extsum, n2: longreal;
		     s, t: colm_ptr;
				 ans, flip2, sp, sp2, an2: sparseptr;
				 sum, prod: quoly;
				 u: colm_ptrptr;
		 
		 begin
		   
			  flip_sparse(spar2, flip2, rows2, cols2);
				rows1 := arrf[2];
				sp := spar;
				if realflag
				   then for k := 0 to (rows1 - 1) div sparsesize do {```}
									 begin
										  if k = 0
												 then begin
																 newsparse(ans);
																 an2 := ans
														  end
												 else begin
																 newsparse(an2^.next);
																 an2 := an2^.next
														  end;
											for i := 1 + k*sparsesize to (k+1)*sparsesize do
												 if i > rows1 
													  then break
												 else begin
																u := @ an2^.indx[i-k*sparsesize];
																sp2 := flip2;
																j2 := 1;
																for j := 1 to cols2 do
																	 begin
																		 t := sp^.indx[i-k*sparsesize];
																		 s := sp2^.indx[j2];
																		 if j2 = sparsesize  { move up for next time }
																		    then begin
																				        sp2 := sp2^.next;
																								j2 := 1
																				     end
																				else Inc(j2);
																		 extsum := 0;
																		 while (t <> nil) and (s <> nil) do
																				if t^.coord < s^.coord
																					 then t := t^.next
																				else if s^.coord < t^.coord
																					 then s := s^.next
																				else begin
																								n2 := t^.val^.ncoef^.float * s^.val^.ncoef^.float;
																								t := t^.next;
																								s := s^.next;
																								extsum := n2 + extsum
																						 end;
																		 if extsum <> 0
																				then begin
																								newcolm(u^);
																								u^^.coord := j;
																								u^^.val := nil;
																								quoly_set_ext(extsum, u^^.val);
																								u := @ u^^.next
																						 end
																	 end;
																u^ := nil
														  end;
															
											sp := sp^.next
											
									 end
									 
					 else for k := 0 to (rows1 - 1) div sparsesize do
									 begin
										  if k = 0
												 then begin
																 newsparse(ans);
																 an2 := ans
														  end
												 else begin
																 newsparse(an2^.next);
																 an2 := an2^.next
														  end;
											for i := 1 + k*sparsesize to (k+1)*sparsesize do
												 if i > rows1 
													  then break
												 else begin
																u := @ an2^.indx[i-k*sparsesize];
																sp2 := flip2;
																j2 := 1;
																for j := 1 to cols2 do
																	 begin
																		 t := sp^.indx[i-k*sparsesize];
																		 s := sp2^.indx[j2];
																		 if j2 = sparsesize  { move up for next time }
																		    then begin
																				        sp2 := sp2^.next;
																								j2 := 1
																				     end
																				else Inc(j2);
																		 sum := nil;
																		 while (t <> nil) and (s <> nil) do
																				if t^.coord < s^.coord
																					 then t := t^.next
																				else if s^.coord < t^.coord
																					 then s := s^.next
																				else begin
																								prod := nil;
																								quoly_mult(t^.val, s^.val, prod);
																								t := t^.next;
																								s := s^.next;
																								if quoly_iszero(prod)
																									 then free_quoly(prod)
																									 else if sum = nil
																													 then sum := prod
																													 else best_quoly_add(sum, prod)
																						 end;
																		 if sum <> nil
																				then if quoly_iszero(sum)
																								then free_quoly(sum)
																								else begin
																												newcolm(u^);
																												u^^.coord := j;
																												u^^.val := sum;
																												u := @ u^^.next
																										 end
																	 end;
																u^ := nil
														  end;
															
											sp := sp^.next
											
									 end;
					 
				free_sparse_frame(flip2, cols2);
				arrf[1] := rows1 * cols2;
        if arr_free
				   then free_sparse(spar, rows1, true);
				spar := ans
				
		 end;
	
	{***************************************************************************}
	
	procedure mult_sparse_norm(var spar: sparseptr; arr2, arr: workptr; spar_free: 
	                           boolean; rows1, rows2, cols2: longint; var arrf: arr_descr);
	
	   { arr is empty or irrelevant; answer goes there. arr2 is read-only.  If spar_free, 
		   then free spar at end. }
		 
		 var i, j, spot2, spot3, k2, k: longint;
		     t: colm_ptr;
				 n2: longreal;
				 n3: quoly;
				 sp: sparseptr;
		 
		 begin
		 
		    sp := spar;  {```}
				if realflag
				   then for k := 0 to (rows1 - 1) div sparsesize do
									 begin
										  for i := 1 + k*sparsesize to (k+1)*sparsesize do
												 if i > rows1 
													  then break
												 else for j := 0 to cols2 - 1 do
																 begin
																		spot3 := i + rows1 * j - 1;
																		arr^[spot3] := nil;
																		quoly_set(0, arr^[spot3]);
																		t := sp^.indx[i-k*sparsesize];
																		k2 := rows2 * j - 1;
																		while t <> nil do
																			 begin
																					spot2 := t^.coord + k2;
																					n2 := arr2^[spot2]^.ncoef^.float * t^.val^.ncoef^.float;
																					with arr^[spot3]^.ncoef^ do
																					   float := float + n2;
																					t := t^.next
																			 end
																 end;
										  sp := sp^.next
									 end
													 
					 else for k := 0 to (rows1 - 1) div sparsesize do
									 begin
										  for i := 1 + k*sparsesize to (k+1)*sparsesize do
												 if i > rows1 
													  then break
												 else for j := 0 to cols2 - 1 do
																begin
																		spot3 := i + rows1 * j - 1;
																		arr^[spot3] := nil;
																		quoly_set(0, arr^[spot3]);
																		t := sp^.indx[i-k*sparsesize];
																		k2 := rows2 * j - 1;
																		while t <> nil do
																			 begin
																					spot2 := t^.coord + k2;
																					n3 := nil;
																					quoly_mult(t^.val, arr2^[spot2], n3);
																					best_quoly_add(arr^[spot3], n3);
																					t := t^.next
																			 end
																end;
										  sp := sp^.next
									 end;
		    
		    if spar_free 
			     then free_sparse(spar, rows1, true);
        arrf[1] := rows1 * cols2;
        arrf[2] := rows1
		 
		 end;
	
	{***************************************************************************}
	
	procedure mult_norm_sparse(var arr, arr2: workarray; var spar: sparseptr; 
	                           rows1, rows2, cols2: longint);
	
	   { arr2 is empty; answer goes there.  arr is read-only.  }
		 
		 var i, j, spot2, spot3, k, j2: longint;
		     t: colm_ptr;
				 n2: longreal;
				 n3: quoly;
				 flip, sp2: sparseptr;
		 
		 begin
		 
		    flip_sparse(spar, flip, rows2, cols2);
				if realflag
				   then for i := 1 to rows1 do  {```}
					         begin
									    sp2 := flip;
											j2 := 1;
											for j := 1 to cols2 do
											   begin
													 spot3 := i + rows1 * (j - 1) - 1;
													 arr2[spot3] := nil;
													 quoly_set(0, arr2[spot3]);
													 t := sp2^.indx[j2];
													 if j2 = sparsesize  { move up for next time }
															then begin
															        sp2 := sp2^.next;
																			j2 := 1
																	 end
															else Inc(j2);
													 k := i - rows1 - 1;
													 while t <> nil do
															begin
																 spot2 := k + rows1 * t^.coord;
																 n2 := arr[spot2]^.ncoef^.float * t^.val^.ncoef^.float;
																 with arr2[spot3]^.ncoef^ do
																		float := float + n2;
																 t := t^.next
															end
												 end
								   end
					 
					 else for i := 1 to rows1 do
									 begin
									    sp2 := flip;
											j2 := 1;
											for j := 1 to cols2 do
												begin
													 spot3 := i + rows1 * (j - 1) - 1;
													 arr2[spot3] := nil;
													 quoly_set(0, arr2[spot3]);
													 t := sp2^.indx[j2];
													 if j2 = sparsesize  { move up for next time }
															then begin
															        sp2 := sp2^.next;
																			j2 := 1
																	 end
															else Inc(j2);
													 k := i - rows1 - 1;
													 while t <> nil do
															begin
																 spot2 := k + rows1 * t^.coord;
																 n3 := nil;
																 quoly_mult(arr[spot2], t^.val, n3);
																 best_quoly_add(arr2[spot3], n3);
																 t := t^.next
															end
												end
									 end;
		    
		    free_sparse_frame(flip, cols2)
		 
		 end;
	
	{**************************************************************************}			 

  procedure evaluate(var inf: text; name: tokentipe; var n: quoly; 
                     var flag: nameptr);  forward;

	{***************************************************************************}

	procedure right_side(var q: formptr; stop: nametype; var inf: text;
	                     var flag: nameptr; var once_more: boolean; 
											 var realtok: tokentipe);  forward;

	{**************************************************************************}

	procedure spec_right_side(var q: formptr; var inf: text; var flag: nameptr; 
	                          endflag: nametype); forward;

	{**************************************************************************}			 

  procedure call_sys_func(var inf: text; var n: quoly; var flag: nameptr);
	
	   var p, copy: nameptr;
		     oldtok: tokentipe;
	
	   begin
		 
				 current_func := sys_func_tok;
				 Inc(func_def_count);
				 last_good_one := nil;
				 last_attached := nil;
				 last_comm := nil;
				 spec_right_side(sys_func, inf, flag, ';');
				 if eof(inf) and (token.name <> ';')
						then error(103, token); 
				 { once_more and realtok are set by attach, basically because a decimal constant 
					 was found in the funcdef }
				 func_def_count := func_def_count - 1;
				 oldtok := token;
				 { Now actually evaluate. }
				 p := startexpr;
				 copy := prev_expr;
				 quoly_set(0, n);
				 prev_expr := nil;
				 startexpr := nil;
				 eval_form(inf, sys_func, n);
				 if n = nil
					  then quoly_set(0, n);
				 realflag := false;
				 token := oldtok;
				 prev_expr := copy;
				 startexpr := p;
				 exit_flag := false;
				 cycle_flag := false;
				 leave_flag := false
				 
			end;
																
  {**************************************************************************}

  procedure retrieve(var x: tokentipe; var qp: quolyptr; var n: quoly; var inf: text; 
                     var flag: nameptr);
                     
     { qp added Nov 1997. n is nil on entry, and usually on exit. return answer in qp, 
       and don't make new storage unless sysfunc or odd final case below.  qp might be
       nil at end, if the name in x was not found.  Caller must deal with that. }

     var q: varptr;
		     i: integer;

     begin

				if x.address = -1
					 then i := hash(x.name, 151)
					 else i := x.address;
					 
				q := sca_store[i];
				while q <> nil do
					 if q^.let.name = x.name
							then break
							else q := q^.next;
			
				if q = nil
					 then begin
								   if (x.name = 'for') or (x.name = 'if') or (x.name = 'while')
							         then if flag = nil
											         then begin
																			 sys_func_token := token;
																			 token := x;
																			 doing_sys_func := true;
																			 call_sys_func(inf, n, flag);
																			 qp := @ n;
																			 exit {(retrieve)}
																		end
															 else error(251, x)
									     else qp := nil;
								   exit {(retrieve)}
							  end
					 else qp := @ q^.val;
									
				if qp^^.numb  { check for array - scalar param error }
					 then if q^.val^.ncoef^.size = -1742 
									 then begin
													 quoly_set(0, n);
													 qp := @ n;
													 writeln(userOutput, 'Warning. ', x.name, ' is an array parameter used as a scalar.');
													 writeln(userOutput, '  Value 0 used for ', x.name, '.'); flush(userOutput)
												end
					
     end;

  {**************************************************************************}

  procedure iretrieve(var x: tokentipe; var qp: quolyptr);

    {Nov 1997, big change.  Now can have q nil, i.e., no such var. }

     var q: varptr;
		     i: integer;

     begin

				if x.address = -1
					 then i := hash(x.name, 151)
					 else i := x.address;

				q := sca_store[i];
				while q <> nil do
					 if q^.let.name = x.name
							then break
							else q := q^.next;

				if q = nil
					 then qp := nil
				   else if q^.val^.numb
									 then qp := @ q^.val
									 else error(253, x)

     end;

  {*********************************************************************************}
	
  procedure arretrieve(var inf: text; x: tokentipe; var flag: nameptr;
	                     var qp: quolyptr);  forward;  { Nov 1997 }

  {**************************************************************************}

  procedure new_arretrieve(var inf: text; x: tokentipe; var flag: nameptr;  
	                         var qp: quolyptr; var t: colm_ptrptr; var colpos: longint); 
	                         forward;  { Nov 1997 }

  {****************************************************************************}
	
	procedure quoly_reciprocal(var n: quoly);
	
	   var m: number;
		     temp: ferm118.poly;
	
	   begin
		 
		    m.imag := nil;
				if n^.numb
				   then begin 
					         quot(number_1, n^.ncoef^, m);
									 scalar_to_quoly(m, n)
								end
				else if n^.denom = nil
				        then begin
								        n^.denom := n^.numer;
												n^.numer := nil;
												poly_set(1, n^.numer);
												normal_form(n)
										 end
				else begin
				        temp := n^.numer;
								n^.numer := n^.denom;
								n^.denom := temp;
								if n^.denom^.numb and (n^.denom^.next = nil)
								   then begin
									         poly_quot(n^.numer, n^.denom, n^.numer);
													 free_poly(n^.denom)
												end
									 else normal_form(n)
						 end
					 
		 end;
		 
	{******************************************************************}
	
  procedure special_free(var x: snumber);

    begin
      if x.size > 0 { used by readin during floatmode }
         then begin
                 x.size := 0;  
                 x.tail^.next := numhead;
                 numhead := x.head;
              end; 
    end;
		
 {**************************************************************************}

  procedure cline(var inf: text; var n: quoly; var flag: nameptr);
	
	   var x1, x2, y1, y2: integer;
				 x,a,b,c, xext, yext: longreal;
						
		 begin
						    
				scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				scanner(inf, token, flag);
				old_expre(inf, n, flag);
				quoly_convert_to_comp(n, xext, yext);
				if token.name <> ','
					 then error(202, token);
				scanner(inf, token, flag);
				if threedim
					 then begin
									 old_expre(inf, n, flag);
									 x := quoly_convert_to_ext(n);
									 if token.name <> ','
											then error(202, token);
									 scanner(inf, token, flag);
									 x1 := round((yscale*yext - xscale*xext)*costheta);
									 y1 := - round(zscale*x*z_cosine - (xscale*xext + yscale*yext)*sintheta);
									 c := x
								end
					 else begin
									 x1 := round(xscale*xext);
									 y1 := - round(yscale*yext);
									 c := 0
								end;
				
				MoveTo(x1, y1);
				a := xext; b := yext;
				old_expre(inf, n, flag);
				quoly_convert_to_comp(n, xext, yext);
				if threedim
					 then begin
									 if token.name <> ','
											then error(202, token);
									 scanner(inf, token, flag);
									 old_expre(inf, n, flag);
									 x := quoly_convert_to_ext(n);
									 x2 := round((yscale*yext - xscale*xext)*costheta);
									 y2 := - round(zscale*x*z_cosine - (xscale*xext + yscale*yext)*sintheta)
								end
					 else begin
									 x2 := round(xscale*xext);
									 y2 := - round(yscale*yext);
									 x := 0
								end;
								
				if token.name <> ')'
					 then error(1, token);				
				LineTo(x2, y2);
				if marking
					 then attach_line(x1,y1,x2,y2,a,b,c,xext,yext,x);														 
				scanner(inf, token, flag);
				quoly_set(0, n);
				
				savescreen := true
				
		 end;
						 						 
  {*************************************************************************}
	
	procedure shade_all(p: polygon_ptr; undo: boolean);
	
		 begin
		    while p <> nil do
					 begin
							shadepoly(p, not undo);
							p := p^.gg
					 end
		 end;
									 
	{**************************************************************************}		 

	procedure change_one_view(ob: objptr; showit, change_angle: boolean);
	 
	   var k: integer;
				 xfact, yfact, zfact, xsine, ysine: longreal;
				 cp: coordptr;
				 gp: polygon_ptr;
					
			{_______________________________________________________________________}

			procedure get_rs(x, y, z: longreal; var r, s: integer);
			 
					begin
						 r := round(yfact*y - xfact*x); 
						 s := - round(zfact*z - xsine*x - ysine*y)
					end;
					
			{_______________________________________________________________________}
			
			begin
		 
		    if ob = nil
					 then exit {(change_one_view)};
						
				if change_angle and not ob^.threeD
				   then begin
						       writeln(userOutput, ' Warning.  Object is not three dimensional. No change.');
									 exit {(change_one_view)}
								end;

	      if showit and (ob^.quads <> nil) and ob^.shaded
					 then for k := 1 to ob^.init do
									 shadequad(ob^.quads^.quad[k].q, false, true);

				semi_change_view(ob, showit, change_angle);
				
				if (ob^.quads <> nil)
				   then begin
					         if ob^.shaded 
									    then if showit
													    then begin
															        dist_sort_quads(ob^.quads, ob^.init);
																			for k := 1 to ob^.init do
																				 shadequad(ob^.quads^.quad[k].q, false, false);
													            compute_hidden_lines(ob, true)
																	 end
													    else
										  else compute_hidden_lines(ob, showit);
									 exit {(change_one_view)}
								end; 
				
				with ob^ do
				    begin
						   yfact := yscale*costheta;
							 xfact := xscale*costheta;
							 zfact := zscale*z_cosine;
							 xsine := xscale*sintheta;
							 ysine := yscale*sintheta
						end;
				 
				if showit
				   then begin
					         gp := ob^.gons;
									 SetPenShade(psWhite);
									 while gp <> nil do
											 begin
													define_polygon(gp, false);
													if ob^.shaded
													   then ErasePoly(thequad)
                          else  //wwh
    													FramePoly(thequad);
													KillPoly(thequad);
													gp := gp^.gg
											 end;
									 RestorePenShade
								end;
											
				gp := ob^.gons;
				while gp <> nil do
				   begin
							cp := gp^.cp;
							for k := 1 to gp^.rank do
							   begin
							      with cp^ do
										   get_rs(x, y, z, a, b);
										cp := cp^.cp
								 end;
							gp := gp^.gg
					 end;
					 
				if ob^.shaded and (ob^.gons <> nil)
				   then sort_polygons(ob);
					 
				if showit
					 then if ob^.shaded
				           then shade_all(ob^.gons, false)
					         else show_unshaded_polys(ob^.gons, false)
	 
	   end;
	 
	{*************************************************************************}
	
	procedure show_object(ob: objptr; undo: boolean);
	
		 var p: polygon_ptr;
				 i: longint;
		 
		 begin
		    
				if ob = nil
				   then exit {(show_object)};
					 
				show_g_list(ob^.first, ob^.last, ob^.final, undo);
				
				if ob^.shaded and (ob^.quads <> nil)
				   then if undo
									 then for i := 1 to ob^.init do
														shadequad(ob^.quads^.quad[i].q, false, true)
									 else begin
									          { quads are in hidden-line order;  bad }
														purge_hidden(ob, false);
														dist_sort_quads(ob^.quads, ob^.init);
														for i := 1 to ob^.init do
															 shadequad(ob^.quads^.quad[i].q, false, false);
														compute_hidden_lines(ob, true);
														exit {(show_object)}
												end;     
				
				show_line_list(ob^.line, undo);

        p := ob^.gons;
				if p = nil
				   then exit {(show_object)};
				if ob^.shaded
				   then shade_all(p, undo)
					 else show_unshaded_polys(p, undo)					 
								
		 end;
		
	{***************************************************************************}
	
	procedure shade_object(ob: objptr);
	
		 var p: polygon_ptr;
		 
		 begin
		    
				if ob = nil
				   then exit {(shade_object)};
					 
				if (ob^.gons = nil) or not ob^.threeD
				   then error(263, token);
					 
				show_g_list(ob^.first, ob^.last, ob^.final, true);
				
				show_line_list(ob^.line, true);
 
				if not ob^.shaded 
				   then begin
					         sort_polygons(ob);
					         ob^.shaded := true
					      end;
				
				p := ob^.gons;  { don't assign until after above sort is finished! }
				shade_all(p, false)
		 
		 end;
		
	{**************************************************************************}
	
	procedure one_rotate_obj(ob: objptr; angle: longreal; erasetoo, showit: boolean; 
	                         ax: longint);
	
	   var gp: polygon_ptr;
		     cp: coordptr;
				 sine, cosine, xscale, yscale, zscale, dum, fmaxcor, xfact, yfact, zfact, xsine,
				     ysine, fmincor, smaxcor, smincor: longreal;
				 i, j: integer;
				 fir, sec, dfir, dsec: longrealptr;
				 
		 {____________________________________________________________________}
		 
		 procedure get_rs;
		    
		    begin
				   if ob^.threeD
							 then begin
											 cp^.a := round(yfact*cp^.y - xfact*cp^.x);
											 cp^.b := - round(cp^.z*zfact - xsine*cp^.x - ysine*cp^.y)
										end
							 else begin
											 cp^.a := round(xscale*cp^.x);
											 cp^.b := - round(yscale*cp^.y);
										end
				end;
				
		 {______________________________________________________________________}
		 		    
			procedure set_ptrs;
			   begin
					 case ax of
						  1: begin
									 fir := @ cp^.y;
									 sec := @ cp^.z
								 end;
						  2: begin
									 fir := @ cp^.x;
									 sec := @ cp^.z
								 end;
						  3: begin
									 fir := @ cp^.x;
									 sec := @ cp^.y
								 end
					 end	
				end;
				
		 {______________________________________________________________________}
		 
		 begin
		    
				if ob = nil
				   then exit {(one_rotate_obj)};
				
	      with ob^ do
				    begin
						   yfact := yscale*costheta;
							 xfact := xscale*costheta;
							 zfact := zscale*z_cosine;
							 xsine := xscale*sintheta;
							 ysine := yscale*sintheta
						end;
						
				if erasetoo and (ob^.quads <> nil) and ob^.shaded
					 then for i := 1 to ob^.init do
									 shadequad(ob^.quads^.quad[i].q, false, true);

				rotate_obj(ob, angle, erasetoo, showit, ax);

				if (ob^.quads <> nil)
				   then begin
					         if ob^.shaded
									    then if showit
													    then begin
															        dist_sort_quads(ob^.quads, ob^.init);
																			for i := 1 to ob^.init do
																				 shadequad(ob^.quads^.quad[i].q, false, false);
													            compute_hidden_lines(ob, true)
																	 end
													    else
										  else compute_hidden_lines(ob, showit);
									 exit {(one_rotate_obj)}
								end;

	      if erasetoo
				   then begin
					         gp := ob^.gons;
									 SetPenShade(psWhite);
									 while gp <> nil do
											 begin
													define_polygon(gp, false);
													if ob^.shaded
													   then ErasePoly(thequad)
                          else  //wwh
  													  FramePoly(thequad);
													KillPoly(thequad);
													gp := gp^.gg
											 end;
									 RestorePenShade
								end;

				xscale := ob^.xscale;
			  yscale := ob^.yscale;
				zscale := ob^.zscale;
				sine := sin(angle);
				cosine := cos(angle);

				case ax of
				   1: begin
								i := 2;
								j := 3
							end;
					 2: begin
								i := 1;
								j := 3
							end;
					 3: begin
								i := 1;
								j := 2
							end
				end;
				with ob^ do
				   begin
					    dum := bias[i]*cosine - bias[j]*sine;
							bias[j] := bias[i]*sine + bias[j]*cosine;
							bias[i] := dum
					 end;

				fmaxcor := -1.0e200;
				fmincor := 1.0e200;
				smaxcor := -1.0e200;
				smincor := 1.0e200;

				gp := ob^.gons;
				while gp <> nil do
				   begin
							{ change normal vector }
							case ax of
								1: begin
										 fir := @ gp^.y;
										 sec := @ gp^.z
									 end;
								2: begin
										 fir := @ gp^.x;
										 sec := @ gp^.z
									 end;
								3: begin
										 fir := @ gp^.x;
										 sec := @ gp^.y
									 end
						  end;
							dum := fir^*cosine - sec^*sine;
							sec^ := fir^*sine + sec^*cosine;
							fir^ := dum;

							{ change centroid }
							case ax of
								1: begin
										 dfir := @ gp^.ycen;
										 dsec := @ gp^.zcen
									 end;
								2: begin
										 dfir := @ gp^.xcen;
										 dsec := @ gp^.zcen
									 end;
								3: begin
										 dfir := @ gp^.xcen;
										 dsec := @ gp^.ycen
									 end
						  end;
							dum := dfir^*cosine - dsec^*sine;
							dsec^ := dfir^*sine + dsec^*cosine;
							dfir^ := dum;
							
							{ change all vertices }
							cp := gp^.cp;
							for i := 1 to gp^.rank do
							   begin
								    set_ptrs;
										dum := fir^*cosine - sec^*sine;
										sec^ := fir^*sine + sec^*cosine;
										fir^ := dum;
										if dum > fmaxcor
										   then fmaxcor := dum;
										if dum < fmincor
										   then fmincor := dum;
										if sec^ > smaxcor
										   then smaxcor := sec^;
										if sec^ < smincor
										   then smincor := sec^;
										get_rs;
										cp := cp^.cp
								 end;
							
							gp := gp^.gg
					 end;
					 
				if ob^.gons <> nil
				   then with ob^ do
					         case ax of
											1: begin
													 ymin := fmincor;
													 ymax := fmaxcor;
													 zmin := smincor;
													 zmax := smaxcor;
												 end;
											2: begin
													 xmin := fmincor;
													 xmax := fmaxcor;
													 zmin := smincor;
													 zmax := smaxcor;
												 end;
											3: begin
													 xmin := fmincor;
													 xmax := fmaxcor;
													 ymin := smincor;
													 ymax := smaxcor;
												 end;
									 end;
									 
				if ob^.shaded and (ob^.gons <> nil)
				   then sort_polygons(ob);
					 
				gp := ob^.gons;  { must be set after the above sort!! }
				if gp = nil
				   then exit {(one_rotate_obj)};
				if ob^.shaded
				   then shade_all(gp, false)
					 else show_unshaded_polys(gp, false)
	
	   end;
	
	{**************************************************************************}
	
	procedure run_movie(ob: objptr; delay: longint);
	
	   var g1, g2: graphptr;
		     ln1, ln2: lineptr;
				 p: polygon_ptr;
				 i, j, start, stop1, stop2: integer;
				 time: longint;
		 
		 {_______________________________________________________________________}
		 
		 procedure finish_node(g: graphptr; stop, j: integer; undo: boolean);
		 
		    var i: integer;

				begin
					 if undo
				      then SetPenShade(psWhite);
					 for i := j to stop do
					    begin
							   MoveTo(g^.abscoord[2*i-1], g^.abscoord[2*i]);
								 if wantcolor
								    then if not undo
								         then begin
								                 with theColor do  { Jan 1998 }
																 	  begin
																	     red := g^.colors[3*i-2];
																	     green := g^.colors[3*i-1];
																	     blue := g^.colors[3*i]
																    end;
																 RGBForeColor(theColor)
														  end;
								 if printchar
									  then begin
													 Move(-2,2);
													 if undo
															then DrawChar(' ')
															else DrawChar(mychar)
												 end
									  else Line(0, 0)
							end;
					 if undo
				      then RestorePenShade

				end;

		 {________________________________________________________________________}

		 begin
		    start := ob^.init;
				show_object(obstash^[start], false);
				
				for i := start to ob^.final - 1 do
				   { Erase first and display next, element by element. }
				   begin
					 
					    if (obstash^[i] = nil) or (obstash^[i+1] = nil)
							   then continue;
							g1 := obstash^[i]^.first;
							g2 := obstash^[i+1]^.first;
							stop1 := graphsize;
							stop2 := graphsize;
				      while (g1 <> nil) and (g2 <> nil) do
							   begin
								    if g1 = obstash^[i]^.last
							         then stop1 := obstash^[i]^.final;
										if g2 = obstash^[i+1]^.last
							         then stop2 := obstash^[i+1]^.final;
										j := 1;
										while (j <= stop1) and (j <= stop2) do
										   begin
											    SetPenShade(psWhite);
													MoveTo(g1^.abscoord[2*j-1], g1^.abscoord[2*j]);
													if printchar
														 then begin
																		 Move(-2,2);
																		 DrawChar(' ')
																	end
														 else Line(0, 0);
													RestorePenShade;
													MoveTo(g2^.abscoord[2*j-1], g2^.abscoord[2*j]);
													if wantcolor
													   then begin
										                 with theColor do  { Jan 1998 }
																		 	 begin
																			    red := g2^.colors[3*i-2];
																			    green := g2^.colors[3*i-1];  
																			    blue := g2^.colors[3*i]
																		   end;
																		 RGBForeColor(theColor)
																  end;
													if printchar
														 then begin
																		 Move(-2,2);
																		 DrawChar(mychar)
																	end
														 else Line(0, 0);
													Inc(j)
											 end;
										if j <= stop1
										   then finish_node(g1, stop1, j, true);
										if j <= stop2
										   then finish_node(g2, stop2, j, false);	 
				            g1 := g1^.next;
										g2 := g2^.next
								 end;
						  if g1 <> nil
							   then show_g_list(g1, obstash^[i]^.last, obstash^[i]^.final, true);
							if g2 <> nil
							   then show_g_list(g2, obstash^[i+1]^.last, obstash^[i+1]^.final, false);
								 
				      if command_int 
								 then check_cmd_keys;
												 
							{ Now the lines }
							ln1 := obstash^[i]^.line;
							ln2 := obstash^[i+1]^.line;
							while (ln1 <> nil) and (ln2 <> nil) do
								 begin
										while not ln1^.show do
										   begin
											    ln1 := ln1^.next;
													if ln1 = nil
													   then break
											 end;
										while not ln2^.show do
										   begin
											    ln2 := ln2^.next;
													if ln2 = nil
													   then break
											 end;	 
											    
										if ln1 <> nil
										   then begin
											         SetPenShade(psWhite);
															 MoveTo(ln1^.abscoord[1], ln1^.abscoord[2]);
															 LineTo(ln1^.abscoord[3], ln1^.abscoord[4]);
															 RestorePenShade;
															 ln1 := ln1^.next
														end;
										if ln2 <> nil
										   then begin
											         MoveTo(ln2^.abscoord[1], ln2^.abscoord[2]);
											         if wantcolor
															    then begin
													                with theColor do  { Jan 1998 }
																					 	 begin
																						    red := ln2^.rred;
																						    green := ln2^.ggreen;  
																						    blue := ln2^.bblue
																					   end;
																					RGBForeColor(theColor)
																			 end;
									             LineTo(ln2^.abscoord[3], ln2^.abscoord[4]);
															 ln2 := ln2^.next
														end
								 end;
							if ln1 <> nil
							   then show_line_list(ln1, true);
							if ln2 <> nil
							   then show_line_list(ln2, false);
								 
							{ now the polygons }
							p := obstash^[i]^.gons;
							if p <> nil
							   then begin
								         if obstash^[i]^.shaded
													  then shade_all(p, true)
													  else show_unshaded_polys(p, true);
												
												 p := obstash^[i+1]^.gons;
												 if obstash^[i+1]^.shaded
													  then shade_all(p, false)
													  else show_unshaded_polys(p, false)
											end;
							
{wwh							if delay > 0
								 then begin
								         time := TickCount + delay;
												 while TickCount < time do
												    begin
														end
											end }

				   end;

				savescreen := true

		 end;
	
  {***************************************************************************}

  procedure readin(var inf: text;  var n: snumber; var flag: nameptr; 
	                 var outcount: longint); 

    var num, i, size, toomuch, count: longint;
        x: char;
				x2: tokentipe;
        h, p, s: numptr;
        more: boolean;

    begin
      p := nil;
      more := true;
      size := 0;
      count := 1;
			x := token.name[1];
      while more do
        begin
          Inc(size);
          newnode(s);
          if size = 1
             then h := s
             else p^.next := s;
          p := s;
          num := ord(x) - 48;
          for i := 1 to psuedo_logblock - 1 do         
            begin
              scanner(inf, x2, flag);
							x := x2.name[1];
              Inc(count);
              if (x >= '0') and (x <= '9')
                then num := 10 * num + ord(x) - 48
                else break
            end;
        
          p^.value := num;
          if (x >= '0') and (x <= '9')
            then begin
                    scanner(inf, x2, flag);
								    x := x2.name[1];
                    Inc(count)
                 end;

          more := (x >= '0') and (x <= '9');

          if (size = 1) and (num = 0) and more
            then
              begin { user is being funny }
                size := 0;
                p^.next := numhead;
                numhead := p;
                p := nil
              end;

        end;
      count := count - 1;
      p^.next := nil;
      outcount := count;
      { if x = ' '
         then scanner(inf, token, flag)  weird archaic garbage discovered, Nov 1997
         else }
				 
			token := x2;
				
      special_free(n);
      n.head := h;
      n.tail := p;
      n.size := size;

      toomuch := count mod psuedo_logblock;
      if count < 0
        then if toomuch > 0
                then toomuch := toomuch - psuedo_logblock;
								
      if (toomuch > 0) and (size > 1)
           then
               begin
							     count := 2;
								   num := 1;
									 for i:=1 to psuedo_logblock - toomuch do
									    num := 10*num;
									 s := n.head;
									 for i := 1 to size - count do
									    s := s^.next;
									 p := s^.next;
									 while p <> s do
									    begin
									        p^.value := p^.value + (s^.value mod num)*(psuedo_block div num);
									        s^.value := s^.value div num;
								        	p := s;
													s := n.head;
													Inc(count);
									        for i := 1 to size - count do
									            s := s^.next;
											end;
											
									 if p^.value = 0
									    then begin
											        n.size := n.size - 1;
															n.head := p^.next;
															p^.next := numhead;
													    numhead := p
													 end
									 
               end
							 								
    end;
		
  {***************************************************************************}
	
	procedure new_readin(var inf: text; var n: number; var flag: nameptr; var count: longint);
	
	   var n2: snumber;
		     p: numptr;
				 i: integer;
		 
		 begin
		 
				n2.size := 0;
				readin(inf, n2, flag, count);
				p := n2.head;
				n.float := 0;
				for i := 1 to n2.size do
						begin
								n.float := psuedo_block * n.float + p^.value;
								p := p^.next
						end;
				
				special_free(n2)
					 
		end;
			
	{**************************************************************************}
	
	procedure check_for_monic_poly(erno: longint; num: quoly; var n: integer; var 
	                               expon: longint; var p, t: ferm118.poly);  
	
	   begin		 
		     if num^.numb
						then error(erno, token);
				 if num^.denom <> nil
						then error(196, token);
				 p := num^.numer;
				 n := 1;
				 t := nil;
				 while p^.exp = 0 do
						begin
							 Inc(n);
							 t := p;    { trailer }
							 p := p^.pcoef
						end;
				 expon := p^.exp;
				 if expon < 0
						then error(294, token);
				 if not poly_eq_1(p^.pcoef)
						then error(32, token)
		 end;
														
	{*****************************************************************************}
	
	function check_and_convert(var n2: number): longint;
	
		 var n3: longreal;
		 
		 begin
		 
		    if n2.imag <> nil
						then begin
								    writeln(userOutput, ' Warning. Expected real integer exponent.'); 
								    writeln(userOutput, '  Will use real part.');
										imag_free(n2)
								 end;
				n3 := trunc(n2.float);
				if n2.float <> n3
					 then writeln(userOutput, ' Warning. Exponent has been truncated to integer.');
				   
				check_and_convert := round(n3);
				
				if abs(n3) >= two_to_28
					 then begin
					         error(36, token);
									 check_and_convert := block
								end
				
		 end;
		 
  {**************************************************************************}
	
	procedure raise_to_power(var n: quoly; var n2: number);
	
	   var expont: longint;
	
		 begin
		 
				expont := check_and_convert(n2);
				
				if expont > 0
					 then quoly_compute_power(n, expont)
					 else if expont < 0
									 then begin
										       quoly_compute_power(n, -expont);
													 quoly_reciprocal(n)
												end
									 else quoly_set(1, n)
		
		end;
		
	{************************************************************************}
	
	procedure obtain_expression(var inf:text; var flag, p: nameptr; brace: nametype); 
	
	   var t: nameptr;
		     first: boolean;
				 count: integer;
				 mate: char;
		 
		 begin
		     count := 1;
				 first := true;
				 if brace[1] = '['
				    then mate := ']'
						else mate := ')';
				 while count > 0 do
				    begin
						   if first
							    then newname(p)         
									else newname(t^.next);
							 if first
							    then t := p
									else t := t^.next;
							 first := false;
							 t^.let := token;
							 if t^.let.name = brace
							    then Inc(count)
							 else if (t^.let.name[1] = mate)
									then count := count - 1
							 else if (t^.let.name = ';') or (t^.let.name = '')
							    then error(312, semicolon);
							 if count > 0
							    then scanner(inf, token, flag)
						end;
						
				 t^.next := nil
				 
		 end;
		 
	{****************************************************************************}
	
	procedure obtain_sum(var inf:text; var flag, p: nameptr);
	
	   var t: nameptr;
		     first, done: boolean;
		 
		 begin
		 
		     { token =  at beginning }
				 if flag = nil
				    then begin
						        scanner(inf, token, flag);
				            if token.name <> '<'
					             then error(144, token);
										first := true;
									  done := false;
										while not done do
				               begin
						              if first
							               then newname(p)   
									           else newname(t^.next);
							            if first
							               then t := p
									           else t := t^.next;
							            first := false;
							            t^.let := token;
							            if t^.let.name = '>'
							               then begin
														         scanner(inf, token, flag);
																		 done := (token.name = '[') or (token.name = '('); 
																		 if not done and (token.name <> '<')
																		    then error(145, token)
																	end
							            else if (t^.let.name = ';') or (t^.let.name = '')
							               then error(81, semicolon)
							            else scanner(inf, token, flag)
						           end;
									  newname(t^.next);
									  t := t^.next;
									  t^.let := token;
									  scanner(inf, token, flag);
									  obtain_expression(inf, flag, t^.next, t^.let.name)
						     end
					 else p := flag^.next			 
				 
		 end;
		 
  {**************************************************************************}

   procedure iexpre(var n: longreal; var flag: nameptr); forward;

	{****************************************************************************}
	
	 procedure old_iexpre(var n: longreal; var flag: nameptr); forward;
	
	{****************************************************************************}
	
   procedure set_up_for_loop(var inf: text; var p: nameptr;
  	                         var r: varptr; var init, stop, increm: longint);

			{ token is now irrelevant on entry. Nov 1997 }
			
			var oldtok: tokentipe;
					q: quoly;
					n: longreal;

			procedure obtain_int(var num: longint;  bad: longint);
				begin
					scanner(inf, token, p);
					if realflag
					   then begin
						         old_iexpre(n, p);
										 num := round(n)
									end
						 else begin
						         old_expre(inf, q, p);
										 if not q^.numb
											  then begin
															  free_quoly(q);
															  error(bad, token)
														 end;
										 num := round(q^.ncoef^.float)
									end
				end;

			begin
			
				q := nil; 
				scanner(inf, oldtok, p);                                
				if (oldtok.name[1] < 'a') or (oldtok.name[1] > 'z')
					 then error(51, oldtok);
				scanner(inf, token, p);
				if (token.name <> 'from') and (token.name <> '=')   { Nov 1997 }
					 then error(48, token);
					
				obtain_int(init, 50);
				if (token.name <> ' to') and (token.name <> ',')
					 then error(49, token); 
				if realflag
				   then iinsert(oldtok, n, r)
					 else insert(oldtok, q, r);
				
				q := nil;  {~~~~ very necessary. changes in insert, Nov 1, 1994 }
				obtain_int(stop, 52);
				if (token.name = ' by') or (token.name = ',')
					 then obtain_int(increm, 53)
					 else increm := 1;
				free_quoly(q)
				
			end;
				
  {***************************************************************************}

   procedure adjust(r: varptr; i: longint);
	 
			begin
				if abs(i) >= block
					 then error(47, r^.let);
				r^.val^.ncoef^.float := i
			end;

	{***************************************************************************}
	
	procedure surface_plot(var n: quoly; var inf: text; var flag: nameptr; initx, finalx,
	                       inity, finaly, incr: longreal; graphname: tokentipe; itsarray,
												 shadeit: boolean; ind: integer);  forward;
												 
  {***************************************************************************}
			 
	procedure sum_mult_up(sign: nametype; var inf: text; var n: quoly; var p: nameptr;
	                      parse_only: boolean; var sum: longreal; var mate: char);
	
	  var t: nameptr;
		    i, stop, increm, negflag: longint;
				r: varptr;
				s: quoly;
				im: imptr;
				fp: formptr;
				recur: boolean;
				num: longreal;
	
	  begin
		 
			 { scanner(inf, token, p);  Nov 1997 }
			 set_up_for_loop(inf, p, r, i, stop, increm);
			 if increm < 0
				  then begin
								  i := -i;  stop := -stop;  increm := -increm;
									negflag := -1
							 end
				  else negflag := 1;
			 if token.name <> '>' 
			    then error(78, token);
			 
			 scanner(inf, token, p);
			 t := p;
			 recur := (token.name = '<');
			 if not recur and (token.name <> '[') and (token.name <> '(')
				  then error(145, token);
			 
			 if not recur
			    then if token.name = '['  { user's choice }
			            then mate := ']'
					        else mate := ')';
			 if sign = ''
			    then if realflag
					           then sum := 0
										 else quoly_set(0, n)
					else if realflag
					           then sum := 1
										 else quoly_set(1, n);
			 
			 if (i > stop) or parse_only
			    then begin  { must parse all the rest, but can't actually execute. }
					        s := nil;
								  if recur
										 then sum_mult_up(sign, inf, s, p, true, sum, mate)
										 else begin
														 scanner(inf, token, p);
														 spec_right_side(fp, inf, p, mate);
														 free_form(fp);
														 if eof(inf) and (token.name[1] <> mate)
															  then error(103, token)
												  end;
								  free_quoly(s);
									exit {(sum_mult_up)}
							 end;
					        
       im := r^.val^.ncoef;
			 while i <= stop do
					begin
					   p := t;
						 s := nil;
						 if recur
						    then sum_mult_up(sign, inf, s, p, false, num, mate)
								else begin
								        scanner(inf, token, p);
						 						if realflag
												   then old_iexpre(num, p)
													 else old_expre(inf, s, p)  { Nov 1997 }
										 end;
						 if sign = ''
						    then if realflag
								        then sum := sum + num
												else best_quoly_add(n, s)
								else if realflag
								        then sum := sum * num
												else begin
																quoly_mult(n, s, n);
																free_quoly(s)
														 end;
             i := i + increm;
             if abs(i) >= block
					      then error(47, r^.let);
				     im^.float := negflag*i
          end
			
	 end;
		
  {******************************************************************}	
	 
	 function find_built_in(start, stop: longint; key: nametype): longint;
	 
	    { binary search }
	 
	    var mid: longint;
			
			begin
			
			   while stop >= start do
				    begin
						   mid := (start + stop) div 2;
				       if builtin[mid,1] = key
				          then begin
									        find_built_in := mid;
													exit {(find_built_in)}
											 end
				       else if builtin[mid,1] < key
				          then start := mid + 1
				       else stop := mid - 1
						end;
				 find_built_in := -1
				 
			end;
					
  {**************************************************************************}
	
	procedure sparse_switch(index, j, k: longint; q: arrptr); forward;

  {***************************************************************************}

	procedure tot_eval_poly(q: ferm118.poly; arg: quoly; var n: quoly; level, skip: integer);
	
	   { original doc: q is not a number. arg is a linked list of quolys that are numbers. q is
		   read-only; answer is returned in n. 
			 
			 June 1997:  TOTALLY CHANGED.  Returns a quoly.  Arguments in arg can be quolies. 
			   Fixed BUGS.  Now works with laurent too.  q can be any poly.  n is nil on entry.
				 On final recursive call, arg might be nil on entry. 
				 
			 Aug 1997:  arg no longer must have an argument for every poly var.  It can 
				 have less, so the recursion simply stops, when arg = nil. If level = 0, arg
				 can't be nil. 
				    'level' is obvious, except it is one less than the level as we sink into the poly
				 q. 'skip' means to ignore 'arg' for 'skip' levels, using base_quoly instead.}
	
	   var nextexp, size, i: longint;
		     n2, pow, thisarg: quoly;
	
	   begin
		 
		    if q^.numb 
				   then poly_to_quoly(q, n)
					 
				else if (arg = nil)  { implies level > 0 }
				   then begin
					          p_q_assign(q, n);
										if not n^.numb
										   then add_pad(n^.numer, level)
								end
					 
				else begin
				
				        pow := nil;
								size := poly_length(q);
								
								 if skip = 0
								   then tot_eval_poly(q^.pcoef, arg^.next, n, level+1, skip)
									 else tot_eval_poly(q^.pcoef, arg, n, level+1, skip - 1);
								
								if skip = 0 
								   then thisarg := arg
									 else begin
									         thisarg := nil;
													 base_quoly(thisarg, level+1)
												end;
											 
								for i := 2 to size do  { Horner's method }
										begin
											 nextexp := q^.exp - q^.next^.exp;
											 if nextexp > 1
													then begin
																	quoly_assign(thisarg, pow);
																	quoly_compute_power(pow, nextexp);
																	quoly_mult(n, pow, n)
															 end
													else quoly_mult(n, thisarg, n);
											 q := q^.next;
											 n2 := nil;
											 if q^.numb
													then poly_to_quoly(q, n2)
											 else if skip = 0
													then tot_eval_poly(q^.pcoef, arg^.next, n2, level+1, skip)
													else tot_eval_poly(q^.pcoef, arg, n2, level+1, skip - 1);
											 best_quoly_add(n, n2)
										end;
										
								if abs(q^.exp) > 1
										then begin
														quoly_assign(thisarg, pow);
														quoly_compute_power(pow, abs(q^.exp));
														if q^.exp > 0
															 then quoly_mult(n, pow, n)
															 else quoly_quot(n, pow, n)
												 end
								else if q^.exp = 1
												then quoly_mult(n, thisarg, n)
								{ else if q^.exp = 0 do nothing }
								else if q^.exp = -1
												then quoly_quot(n, thisarg, n);
												
								free_quoly(pow);
								if skip > 0 
								   then free_quoly(thisarg)
								
						 end
										
		 end;
	         
	{***************************************************************************}

	procedure total_eval(var inf: text; var n, n2: quoly; var flag: nameptr;
	                     should_free: boolean; target: longint);
	
	   { target added Aug 1997.  Can now evaluate on just a contiguous range of vars,
		   like x(:q4 = s4, s3, s2, s1).  target-1 tells how many to skip, and to terminate 
			 can simply stop the list, as in the example. }
		 
		 var p,t: quoly;
				 num, num2: quoly;
		     count: longint;
		
	   {____________________________________________________________________}
		 
		 procedure free_n2s;		 
		    begin
				   n2 := p;
					 p := p^.next;  { leave one n2 }
				   while p <> nil do
					    begin
							   t := p^.next;
								 free_quoly(p);
								 p := t
							end
				end;				
		 {____________________________________________________________________}
		 
	   begin
		 		    				
				{ Upon entry the first time, token = ',' and n2 is the first of the arguments. 
				  The first time, n2^.next = nil.  There are later calls when the whole thing
					is called from array parsing.  If n2^.next 
				  is nil, we need to read all the others, ending with p pointing to a 
					linked list of them. If n2^.next is not nil, the reading was done earlier. }
					
				p := n2;
				if n2^.next = nil
				   then begin
					         t := n2;
									 count := 1;
				           while token.name = ',' do
											begin
												 scanner(inf, token, flag);
												 n2 := nil;
												 old_expre(inf, n2, flag);  { June 1997; no more check for number }
												 t^.next := n2;
												 t := n2;
												 Inc(count)
										  end;
									 t^.next := nil;
									 n2 := p;
									 if token.name <> ')'
										  then error(1, token);
									 if count > number_polys  { changed Aug 1997 }
										  then error(193, token)
								end;
				
				if n^.numb
				   then begin
					         if should_free
									    then free_n2s;
									 exit {(total_eval)}
								end;
												
				num := nil; 
				tot_eval_poly(n^.numer, p, num, 0, target-1);
				free_poly(n^.numer);
				
				if n^.denom <> nil
				   then begin
					         num2 := nil;  
				           tot_eval_poly(n^.denom, p, num2, 0, target-1);
									 quoly_quot(num, num2, num);
									 free_quoly(num2); 
									 free_poly(n^.denom)
								end;
				
				n^.next := quolygarb;
	      quolygarb := n;
				n := num;
		    if should_free 
				   then free_n2s
				
		 end;
	
  {***************************************************************************}

  procedure fact(var inf: text; var qp: quolyptr; var n: quoly; var aux: colm_ptrptr;
                 var colpos: longint; var flag: nameptr);  forward;   { Nov 1997 }
	
  {***************************************************************************}

  procedure old_fact(var inf: text; var n: quoly; var flag: nameptr); 
    { Nov 1997 }
     var qp: quolyptr;
         aux: colm_ptrptr;
         colpos: longint;
     begin
         fact(inf, qp, n, aux, colpos, flag);
         if qp = nil
            then quoly_set(0, n)
            else if n = nil
                    then quoly_assign(qp^, n)
     
     end;
	
  {******************************************************************************}
	
	procedure get_evalquoly(var inf: text; var n, n2: quoly; var target: longint;
	                        var flag: nameptr; should_free: boolean);
	
	   { In the quoly n, replace a poly variable (to be read, whose depth is 'target') 
		   with the quantity n2 (if nil, to be read and evaluated here, whose depth is 
			 'source').   Return answer in n. Slightly inefficient in possible recomputation 
			 of powers of n2. 
			 August7, 1990: looks like n2 is always nil. will assume so. 
			 August 9: no, not when called from downdate vars, or by array parsing routines.
			 August 14: n2 must be poly, not quoly. 
			 
			 Nov 1997:  It's now p(x=q).}
	
	   var source: longint;
		     n3, exps, tail: ferm118.poly;
				 
		 {_________________________________________________________________________}
		 
		 procedure get_polys;
		  
		   { sets target and n2. rewritten Nov 1997 }
		   
		    var n: quoly;  { bug of July 1996 }
		        targ: longint;
		        
		    procedure check_and_finish(doscan: boolean);
		       { have just seen a ferm118.poly var }
		       begin
		          if doscan
		             then scanner(inf, token, flag);  { Nov 1997 }
		          if token.name = '='
		             then begin
		                     scanner(inf, token, flag);
		                     old_expre(inf, n2, flag);
		                     target := targ
		                  end
		             else begin
		                     base_quoly(n2, targ);
		                     half_expre(inf, n2, flag);
		                     target := 1
		                  end
		       end;
		    		    
		    begin
				
				   if is_poly_name(token.name, targ)
				      then check_and_finish(true)
				   else if (token.name = '') or (token.name = 'Var')  {~~~}
					    then begin
							        scanner(inf, token, flag);
											n := nil;  { local n }
											old_fact(inf, n, flag);  { changed July 1996 }
											if not n^.numb
											   then error(253, token);
											targ := quoly_convert_to_int(n);
											free_quoly(n);
											if (targ <= 0) or (targ > number_polys)  { bug, Jan 1997 }
											   then error(316, token);
											check_and_finish(false) 
									 end
							else begin
							        old_expre(inf, n2, flag);
							        target := 1
							     end
								 
			  end;
				
		 {_____________________________________________________________________}
		 
		 function needto(p: ferm118.poly; depth: longint): boolean;
		 
		    { Is there a negative exponent in 'p' at depth 'depth'? }
		 
		    var test: boolean;
		 
		    begin
				   
					 if depth = 1
					    then while p <> nil do
										  if p^.exp < 0
												 then begin
																 needto := true;
																 exit {(needto)}
															end
												 else p := p^.next
												 
							else while p <> nil do
							        begin
											   if p^.numb
												    then test := false
														else test := needto(p^.pcoef, depth - 1);
												 if test
													  then begin
																	  needto := true;
																	  exit {(needto)}
																 end
														else p := p^.next
											end;
											
					 needto := false	        
							
				end;
				
		 {_______________________________________________________________________}
				 
	   begin
		 
		    { The nodes of input n can be changed or destroyed. n is also output. 
				  Possible space losing problem if error occurs during a call to this from
					arr_fact. }
		 					 
				{ target = 1 means highest level poly var, or number }
				if n2 = nil
				   then if token.name = '('
									 then begin
													 scanner(inf, token, flag);
													 get_polys;  { sets n2 and target. Nov 1997 }
													 n2^.next := nil;  { necessary for total_eval, and future calls to 
																							 get_evalquoly, if any }
													 if token.name = ','
															then begin   { changed lots of this, June 1997, for totaleval }
															        total_eval(inf, n, n2, flag, should_free, target);
																			if token.name <> ')'
															           then error(150, token);									 
													            scanner(inf, token, flag);
																			exit {(get_evalquoly)}
																	 end;
													 if token.name <> ')'
															then error(150, token);									 
													 scanner(inf, token, flag)
											  end
									 else begin
													 target := 1;
													 old_fact(inf, n2, flag);
													 n2^.next := nil
											  end
					 else if n2^.next <> nil
					         then begin
									         total_eval(inf, n, n2, flag, should_free, 1);
													 exit {(get_evalquoly)}
												end;
								 
				{ n2 must be 'poly'. }
				if not n2^.numb
					 then if n2^.denom <> nil
									 then begin
									         free_quoly(n);
													 free_quoly(n2);
													 error(186, token)
												end;
												
				if n^.numb
				   then exit {(get_evalquoly)};

				n3 := nil;
				if n2^.numb
				   then quoly_to_poly(n2, n3)
					 else n3 := n2^.numer;
					 
				source := poly_depth(n3); 				
				
				if laurent
				   then if needto(n^.numer, target)
									 then begin
									         { Remove all negative exponents from n -- for
													   calls to actual_eval_poly. }
													 clear_bads(n^.numer, exps, tail, 0);
													 if n^.denom = nil
														  then poly_set(1, n^.denom);
													 eliminate_bads(n^.denom, exps, -1);
													 tail^.next := polygarb;
													 polygarb := exps
											  end;								
				
				actual_eval_poly(n^.numer, n3, target, source);
				
			  if n^.denom <> nil
					 then begin
									 actual_eval_poly(n^.denom, n3, target, source);
									 if n^.denom^.numb and (n^.denom^.next = nil)
										  then begin
														  poly_quot(n^.numer, n^.denom, n^.numer);
														  free_poly(n^.denom)
													 end
										  else if poly_iszero(n^.numer)
													 then begin
																	 quoly_set(0, n);
																	 if n3^.numb and (n3^.next = nil)
																			then free_poly(n3);
																	 exit {(get_evalquoly)}
																end
													 else normal_form(n)
							  end;
								 
			  if n^.numer^.numb and (n^.numer^.next = nil) and (n^.denom = nil)
					 then polynum_to_quoly(n);
					 
				if n3^.numb and (n3^.next = nil)
				   then free_poly(n3)
								
     end;
		 
  {***************************************************************************}
 
  procedure quoly_at_matrix(var inf: text; nq: quoly; var arr: workarray; var 
                           arr_facts: arr_descr; var arr_free: boolean; var rows:
										       longint; var flag: nameptr; var spar: sparseptr); forward;
													 
	{**************************************************************************}
	
	procedure left_side(var inf: text; var q: arrptr; var rows, cols, start, total_rows, 
	                    firstrow, firstcol, target_rows: longint; var oldtok: tokentipe; 
											var flag: nameptr; systok: boolean); forward;
										
  {**************************************************************************}

  procedure insertarr(let: tokentipe;  r, c: longint);
	
	  { r, c, independent of addresser  -- they are numbers. }

    var p: arrptr;
			  i: integer;

    begin
      if (r < 1) or (c < 1)
         then error(27, let);
      if (endarr + r * c) > last_arr_spot
         then error(26, let);
      if (r * c > arr_limit)
         then error(43, let);
      if arr_garb = nil
         then new(p)
         else begin
                 p := arr_garb;
                 arr_garb := arr_garb^.next
              end;						 
      p^.name := let;
			p^.size := r * c;
      p^.start := endarr + 1;
      p^.stop := endarr + r * c;
      p^.rows := r;
			p^.spar := nil;
			p^.time := array_time;
			Inc(array_time);
			
			if let.address = -1
			   then i := hash(let.name, 151)
				 else i := let.address;
				 
      p^.next := arr_store[i];
      arr_store[i] := p;
			
			while p^.stop > (numblocks+1)*arr_block_size - 1  do
			    { allocate more array blocks to accomodate new array }
					begin
						 numblocks := numblocks + 1;
						 new(arp[numblocks]);
						 for i := 0 to arr_block_size - 1 do
                arp[numblocks]^[i] := nil
          end;
						 
      endarr := p^.stop
			
    end;

  {***************************************************************************}
	
	procedure normalize(var n: quoly; q: arrptr; want: boolarray; var alpha, beta, 
	                    alphinv, betinv: workarray); forward;
											
  {***************************************************************************}
	
	procedure red_row_ech(var n: quoly; q: arrptr; want: boolarray; var alpha, 
	                      alphinv: workarray); forward;  { Oct 2000 }
	                         
	{*****************************************************************************}
	 
	procedure fill_sparse(q: arrptr);
	 
	   { quolies from standard format are freed if 0, moved to new format otherwise.
		   All storage in arp is left nilled out. 
			    On entry, only first block of q^.spar has been created. }
			 
		 var j, k, cols, rows, start, locat, i, stop: longint;
		     first: boolean;
				 qp: quolyptr;
				 t: colm_ptr;
				 sp: sparseptr;
				 
		 begin
			
			  rows := q^.rows;
				cols := q^.size div rows;
				start := q^.start - 1;
				sp := q^.spar;
				stop := (rows - 1) div sparsesize;
				for i := 0 to stop do {```}
					 begin
							for j := 1 + i*sparsesize to (i+1)*sparsesize do
								 if j > rows
								    then break
								    else begin
														sp^.indx[j-i*sparsesize] := nil;
														first := true;
														for k := 0 to cols - 1 do
															 begin
																	locat := start + j + k*rows;
																	qp := @ arp[locat shr 10]^[locat and tenmask];
																	if qp^ <> nil
																		 then if quoly_iszero(qp^)
																						 then free_quoly(qp^)
																						 else begin
																										 if first
																												then begin
																																newcolm(sp^.indx[j-i*sparsesize]);
																																t := sp^.indx[j-i*sparsesize];
																																first := false
																														 end
																												else begin
																																newcolm(t^.next);
																																t := t^.next
																														 end;
																										 t^.coord := k+1;
																										 t^.val := qp^;
																										 qp^ := nil
																									end
															 end;
														if not first
															 then t^.next := nil
													end;
								 
					 if i < stop
					    then newsparse(sp^.next);
					 sp := sp^.next
				end
		 
		 end;

  {***************************************************************************}

  procedure make_sparse(var inf: text; var n: quoly; var flag: nameptr);
	
	   { Create new copies of all nonzero stuff in the array, to be looked up here.
		   Delete all the standard format values. }
	
	   var i: integer;
		     q: arrptr;
				 paren: boolean;
		 
		 begin
		    
				scanner(inf, token, flag);
				paren := (token.name = '(');
				if paren
				   then scanner(inf, token, flag);
				if token.name <> '['
				   then error(178, token);
				scanner(inf, token, flag);
				if token.name = ''
				   then error(176, token);  {```}					 
				if token.address = -1
					 then i := hash(token.name, 151)
					 else i := token.address;

			  q := arr_store[i];
			  while q <> nil do
					 if q^.name.name = token.name
						  then break
						  else q := q^.next;
			  if q = nil
					 then error(28, token);
				scanner(inf, token, flag);
				if token.name <> ']'
				   then error(24, token);
				if paren
				   then begin
					         scanner(inf, token, flag);
									 if token.name <> ')'
									    then error(1, token)
								end;
				scanner(inf, token, flag);
				quoly_set(0, n);
								
				if q^.spar = nil
				   then newsparse(q^.spar)
					 else exit {(make_sparse)};
					 
        fill_sparse(q)
				
		 end;
																					 
  {********************************************************************}
	
	procedure gcd_one_num(var n, m: quoly; second: boolean); 
	
	   { n is a number, m isn't.  If second, return answer in m, else n. other can be
		   changed - it's expendable - but must be freed properly. The one that isn't
			 changed may become an illegal number, so the caller must free it soon. }
		 
		 {-------------------------------------------------------------------}
		 
		 procedure gcd_num_poly(var n: quoly; p: ferm118.poly);
		 
		    { n is a number. Can't let n = 0 because of call to gcdnum in rational mode. 
				  Find gcd of n with all coefficients in p. Return answer in n. }
		 
		    var dum: quoly;
		 
		    begin
				
				   newquoly(dum);
					 dum^.numb := true;
					 while p <> nil do
					    begin
							   if quoly_eq_1(n)
								    then break;
								 if p^.numb
								    then begin
										        dum^.ncoef := p^.ncoef;
														gcdnum(n, dum)
												 end
								 else if p^.pcoef^.numb and (p^.pcoef^.next = nil)
												 then begin
																 dum^.ncoef := p^.pcoef^.ncoef;
																 gcdnum(n, dum)
														  end
								 else gcd_num_poly(n, p^.pcoef);
								 
								 p := p^.next
							end;
							
					 dum^.next := quolygarb;
					 quolygarb := dum
												 
				end;
				
		 {-------------------------------------------------------------------}

     begin
		 
		    if m^.denom <> nil
				   then error(203, token);
				
				if quoly_iszero(n)
				   then if second
					         then { nothing }
									 else begin
									         free_quoly(n);
													 n := m;
													 m := nil
												end
				else begin
				        gcd_num_poly(n, m^.numer);
								if second
									 then begin
													 free_quoly(m);
													 m := n;
													 n := nil
												end
					   end
				
		 end;

  {***************************************************************************}

  procedure mat_invert(var ar, outar: workarray;  ar_free, oar_free: boolean; m: longint; 
	                     var n: quoly; invert, equal: boolean; var spar: sparseptr); forward;
											 
  {****************************************************************************}
  
  procedure row_reduce(var arr: workarray; factor: quoly; rows, k, q: longint);
  
     { k and q are reduced coords. arr is rows X rows. }
  
     var i, j: longint;
	     p: quoly;
	 
	   begin
	 
	     i := q;		
		   while i < rows*rows do
		      begin
		         j := i + k - q;
			       p := nil;
			       quoly_mult(arr[i], factor, p);
			       best_quoly_sub(arr[j], p);
			       i := i + rows
		      end
		   
     end;
	 
  {****************************************************************************}
  
  procedure divide_row(var arr: workarray; factor: quoly; rows, q: longint);
  
     { q is reduced coord. arr is rows X rows.  divide qth row by factor. Oct 2000 }
  
	   begin
	 
	      while q < sqr(rows) do
		       begin
		          quoly_quot(arr[q], factor, arr[q]);
			        q := q + rows
		       end
		   
     end;
	 
   {****************************************************************************}
  
   procedure col_reduce(var arr: workarray; factor: quoly; rows, k, q: longint);
  
     var i: longint;
	       p: quoly;
	 
	   begin
	 
	     q := q*rows;
			 k := k*rows;
		   for i := 0 to rows - 1 do
		      begin
			       p := nil;
			       quoly_mult(arr[q+i], factor, p);
			       best_quoly_sub(arr[k+i], p);
		      end
	 
	   end;
			  
  {****************************************************************************}
  
  procedure mult_col(var arr: workarray; factor: quoly; rows, q: longint);
  
     { q is reduced coord. arr is rows X rows.  mult qth col by factor. Oct 2000 }
  
	   var i: longint;
	   
	   begin
	 
	      q := q*rows;
	      for i := 1 to rows do
		       begin
		          quoly_mult(arr[q], factor, arr[q]);
			        q := q + 1
		       end
		   
     end;
	 
  {****************************************************************************}
	
	procedure colreduce(var n: quoly; q: arrptr; want: boolarray; var alpha, 
	                    beta, alphinv, betinv: workarray); 
											
		 { q is not sparse }
		 
		 var rows, cols, min, i, j, k, locat, spot, start, other: longint;
		     factor, prod: quoly;
				 iszer: boolean;
				 qp: quolyptr;
		 
		 begin
		 
		    rows := q^.rows;
				cols := q^.size div rows;
				if rows < cols
				   then min := rows
					 else min := cols;
			  if want[1]
				   then identi(alpha, rows, false);
			  if want[2]
					 then identi(beta, cols, false);
			  if want[3]
					 then identi(alphinv, rows, false);
			  if want[4]
					 then identi(betinv, cols, false);
					 
				factor := nil;				
				for i := 0 to min-1 do
				   begin
					    findbest(q^.start, q^.stop, rows, i, j, k);
							if j = -1 
							   then begin
								         min := i;
												 break;
											end;
							if i <> k
							   then switchrow_col(Switchcol_, i, k, q^.start+i, rows, rows - i, cols - i);
		          if i <> j
							   then switchrow_col(Switchrow_, i, j, q^.start+i*rows, rows, rows - i, cols - i);
							
							if (i <> j) and want[1]
								 then swap_rows(factor, alpha, false, true, i, j, rows);
							if (i <> k) and want[2]
								 then swap_cols(beta, i, k, cols);
							if (i <> j) and want[3]
				         then swap_cols(alphinv, i, j, rows);
			        if (i <> k) and want[4]
			           then swap_rows(factor, betinv, false, true, i, k, cols);								
																			 
						  { col reduce }							
							start := q^.start + i*rows + i;  { address of diagonal spot }
							k := start + rows;  { marks start of each column in the submatrix left }
							other := i + 1;  { marks col number for alpha, beta, etc. }
							while k <= q^.stop do
							   begin
								    qp := @ arp[k shr 10]^[k and tenmask];
										iszer := quoly_iszero(qp^);
										if not iszer
										   then begin  { kill rest of column }
											         quoly_quot(qp^, arp[start shr 10]^
															            [start and tenmask], factor);															 
															 locat := start + 1;
															 spot := k + 1;
															 while locat < start + rows - i do
																  begin
																		 prod := nil;
																		 quoly_mult(factor, arp[locat shr 10]^[locat and tenmask], prod);
																		 best_quoly_sub(arp[spot shr 10]^[spot and tenmask],
																									  prod);
																		 Inc(locat);
																		 Inc(spot)
																  end;
															 if want[2]
															    then col_reduce(beta, factor, cols, other, i);
															 if want[4]
																  then begin
																				  quoly_inplace(factor);
																			    row_reduce(betinv, factor, cols, i, other)
																		   end;
														end;
										Inc(other);
								    if not iszer
										   then quoly_set(0, qp^);
										k := k + rows
								 end
								     
					 end;
					 
				free_quoly(factor);
				quoly_set(min, n)
							   
		 end;
		 
  {****************************************************************************}
	
	procedure setargs(p: paramptr; var flag: nameptr; var mytoken: tokentipe;
										var n, val: quoly; var inf: text; var v, r, vcop: varptr; 
										var newarr: arrptr); forward;
										
	{****************************************************************************}									
										
	function func_retrieve(name: tokentipe): funcptr;  forward;
	
	{***************************************************************************}
	
	procedure plotfunc(var inf: text);
	   var xext, yext, x0, y0: longreal;
		     xcor, ycor, xcor0, ycor0: integer;
				 first, oldrealflag: boolean;
         evalOk : boolean;
	   begin
				first := true;
				repeat
				   xext := quoly_convert_to_ext(vplot^.val);
					 quoly_set(0, plotnum);
					 if xext > final^.ncoef^.float
					    then break;  { fail safe; can occur if the function being plotted has an
							               error for all (or final!) vplot values.  Then the block of
														 code after 9988 would call this forever. fixed Oct 1993 }
           oldrealflag := realflag;
           try
             eval_form(inf, pplot^.rht, plotnum);
  					 if plotnum = nil
	  				    then quoly_set(0, plotnum);
  					 if not plotnum^.numb
	  				    then error(219, token);
		  			 yext := quoly_convert_to_ext(plotnum);
			  		 xcor := round(xscale*xext);
				  	 ycor := - round(yscale*yext);
             evalOk := true;
           except evalOk := false
           end;

           if evalOk then
           begin
		  			 realflag := oldrealflag;
			  		 exit_flag := false;
				  	 cycle_flag := false;
					   leave_flag := false;
					   if first
					      then begin
							        MoveTo(xcor, ycor);
											xcor0 := xcor;   x0 := xext;
											ycor0 := ycor;   y0 := yext
								     end;
  					 if points
	  				    then MoveTo(xcor, ycor)
			  				else LineTo(xcor, ycor);
		  			 if points
				  	    then if printchar
										  then begin
														  Move(-2,2);
														  DrawChar(mychar)
													 end
										  else Line(0, 0);
					   if marking
					      then if points
							        then attach_data(xcor, ycor, xext, yext, 0)
											else if not first
											        then begin
											                attach_line(xcor0,ycor0,xcor,ycor,x0,y0,0,xext,yext,0);
																			xcor0 := xcor; ycor0 := ycor;
																			x0 := xext; y0 := yext
																	 end;
				  	 first := false;
           end
           else
             first := true;
				   better_quoly_add(vplot^.val, increm, vplot^.val);
					 if command_int
			        then check_cmd_keys
				until vplot^.val^.ncoef^.float > final^.ncoef^.float;
				plotting := false;

				savescreen := true

		 end;

	{***************************************************************************}

	procedure get_params(var inf: text; var n: quoly; var flag: nameptr);

	   var mytoken: tokentipe;
		 		 x: integer;

		 begin

		    if plotting or cplotting or surplotting
					 then error(220, token);
				scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				scanner(inf, token, flag);												
				old_expre(inf, n, flag);
				x := quoly_convert_to_int(n);
				points := (x = 0);  { global, used by plotfunc. }
        if token.name <> ','
				   then error(202, token);
				scanner(inf, token, flag);
				
				old_expre(inf, initial, flag);
				if not initial^.numb
					 then error(215, token);
				if token.name <> ','
					 then error(202, token);
				scanner(inf, token, flag);
				old_expre(inf, final, flag);
				if not final^.numb
					 then error(215, token);
				if token.name <> ','
					 then error(202, token);
				scanner(inf, token, flag);
				old_expre(inf, increm, flag);
				if not increm^.numb
					 then error(215, token);
				if increm^.ncoef^.float <= 0
				   then error(240, token);
				if token.name <> ','
					 then error(202, token);
				scanner(inf, token, flag);
				if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
					 then pplot := func_retrieve(token)
					 else error(217, token);
				vplot := nil;
				if pplot^.pars = nil
					 then error(221, token);
								
				setargs(pplot^.pars, flag, mytoken, n, initial, inf, vplot, hplot, 
						    vcop, arrplot);
								
				preset_stuff(pplot);
				if vplot = nil
					 then error(218, token);
				token := mytoken;

				{ initial is now nil. 
						hplot and arrplot point to duplicates of arguments that have just
					been set on the environment stack.  vplot points to the record on the env. 
					stack that contains the variable that will be incremented, by 
					plotfunc.  vcop points to the corresponding record in the copy list
					of hplot.  }
					
		 end;

	{***************************************************************************}
	
	procedure funcplot(var inf: text; var n: quoly; var flag: nameptr);

		 begin

				get_params(inf, n, flag);

				if token.name <> ')'
					 then error(1, token);
				if vplot = nil
					 then error(218, token);
				scanner(inf, token, flag);
				quoly_set(0, n);
				plotting := true;
				tptr := @ inf;

				plotfunc(inf);
				epilog(pplot);
				cancel_dups(hplot, arrplot)

		 end;

	{***************************************************************************}
	
	procedure cfuncplot(var inf: text; var n: quoly; var flag: nameptr; index: longint);
	                    forward;
	
 {***************************************************************************}
	
 	procedure fill_display_polyg(arr: workptr; length: longint; reverse: integer); {```}
	
	   var r, size: longint;
				 x, y, z, x0, y0, z0, a, b, c: longreal;
				 x1, y1, x2, y2: integer;
				 this: polygon_ptr;
				 q: coordptr;
		 
		 begin
		 
		    if not arr^[0]^.numb
				   then error(224, token);
				if not arr^[1]^.numb
				   then error(224, token);
				x0 := arr^[0]^.ncoef^.float;
				y0 := arr^[1]^.ncoef^.float;
				r := 2;  { don't move this! }
				if threedim
				   then begin
					         if not arr^[r]^.numb
				              then error(224, token);
					         z0 := arr^[r]^.ncoef^.float;
									 x1 := round((yscale*y0 - xscale*x0)*costheta);
									 y1 := - round(zscale*z0*z_cosine - (xscale*x0 + yscale*y0)*sintheta);
								   r := 3
								end
					 else begin
					         x1 := round(xscale*x0);
									 y1 := - round(yscale*y0);
									 z0 := 0
							  end;

				MoveTo(x1, y1);
				
				if marking
				   then begin
					         newgon(this);
					         if wantcolor
						          then with this^ do
						                  begin
								                 rred := theColor.red;  { Jan 1998 }
								                 ggreen := theColor.green;
								                 bblue := theColor.blue
						                  end;
									 newpoint(this^.cp);
									 q := this^.cp;
									 q^.a := x1;
									 q^.b := y1;
									 q^.x := x0; q^.y := y0;  q^.z := z0
								end;

				size := 1;
				a := x0;  b := y0;  c := z0;  { will hold sum of all coords }
				while r < length do
				   begin
					    if not arr^[r]^.numb
				         then error(224, token);
					    x := arr^[r]^.ncoef^.float;
							if not arr^[r+1]^.numb
				         then error(224, token);
				      y := arr^[r+1]^.ncoef^.float;
							r := r + 2;
							if threedim
							   then begin
								         if not arr^[r]^.numb
				                    then error(224, token);
					               z := arr^[r]^.ncoef^.float;
												 Inc(r);
												 x2 := round((yscale*y - xscale*x)*costheta);
												 y2 := - round(zscale*z*z_cosine - (xscale*x + yscale*y)*sintheta)
											end
				         else begin
								         x2 := round(xscale*x);
												 y2 := - round(yscale*y);
												 z := 0
											end;
							LineTo(x2, y2);
							Inc(size);
							if marking
							   then begin
								         newpoint(q^.cp);
												 q := q^.cp;
												 q^.a := x2;
									       q^.b := y2;
									       q^.x := x; q^.y := y;  q^.z := z;
												 a := a + x; b := b + y; c := c + z
											end
					 end;
					 
				if threedim
				   then begin
					         x2 := round((yscale*y0 - xscale*x0)*costheta);
									 y2 := - round(zscale*z0*z_cosine - (xscale*x0 + yscale*y0)*sintheta)
								end
					 else begin
					         x2 := round(xscale*x0);
									 y2 := - round(yscale*y0)
								end;
			   LineTo(x2, y2);
				 
				 if marking
					  then this^.rank := size;
					 
				 if marking
				    then if curgon = nil
									 then begin
													 sysgon := this;
													 curgon := sysgon;
													 sysendvert := q
												end
									 else begin
									         curgon^.gg := this;
													 curgon := this;
													 sysendvert^.cp := this^.cp;
													 sysendvert := q
												end;
				 if marking and threedim 
				    then begin  { compute unit normal, centroid and radius of polygon, 
					               and max and min of coords. }
					         set_normal(this, reverse);
									 with this^ do
									    begin
											   xcen := a/size;  ycen := b/size;  zcen := c/size;
												 { Slight compromise.  Use centroid in determining xmax, xmin,
												   etc. }
												 if xcen < xmin
														then xmin := xcen;
												 if xcen > xmax
														then xmax := xcen;
												 if ycen < ymin
														then ymin := ycen;
												 if ycen > ymax
														then ymax := ycen;
												 if zcen < zmin
														then zmin := zcen;
												 if zcen > zmax
														then zmax := zcen
											end;
											
									 set_radius(this)
									 
					       end;
					       
			 savescreen := true
								
		 end;
 
 {***************************************************************************}
 
 procedure polygn(var inf: text; var n: quoly; var flag: nameptr);
	
	   var arr: workptr;
		     arr_facts: arr_descr;
				 r: longint;
				 arr_free, parenth_form: boolean;
				 reverse: integer;
				 spar: sparseptr;
				
		 begin

				new_worknode(r, token);
				spar := nil;
			  arr := workhead[r];
        arr_facts[1] := 0;
				scanner(inf, token, flag);
				parenth_form := (token.name = '(');
				if parenth_form
				   then scanner(inf, token, flag);					         
				arr_fact(inf, n, arr^, arr_facts, arr_free, r, flag, spar);
				if spar <> nil
				   then error(288, token);
				if (arr_facts[1] < 2) 
           then error(223, token);
				if threedim
				   then if not (arr_facts[1] mod 3 = 0)
					         then error(223, token)
									 else 
					 else if odd(arr_facts[1])
					         then error(223, token);
				if parenth_form
				   then begin
					         if token.name <> ','
									    then error(202, token);
									 scanner(inf, token, flag);
									 old_expre(inf, n, flag);
									 if token.name <> ')'
									    then error(1, token);
									 scanner(inf, token, flag);
									 reverse := quoly_convert_to_int(n);
									 if (reverse <> 1) and (reverse <> -1)
									    then error(264, token)
								end
					 else reverse := 1;

        fill_display_polyg(arr, arr_facts[1], reverse);
				
				if arr_free 
					 then free_arr(arr^, arr_facts);
				free_work;
				quoly_set(0, n)
											
		 end;
								
  {**************************************************************************}

  procedure objarray(var inf: text; var n: quoly; var flag: nameptr);
 
     var ob: objptr;
		     i: integer;
				 obname: tokentipe;
				
		 begin
		
				scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				scanner(inf, obname, flag);
				if (obname.name[1] < 'a') or (obname.name[1] > 'z')
					 then error(225, obname);
				scanner(inf, token, flag);
				if token.name <> '['
					 then error(178, token);
				scanner(inf, token, flag);
				old_expre(inf, n, flag);
				i := quoly_convert_to_int(n);
				if token.name <> ']'
					 then error(24, token);
				scanner(inf, token, flag);
				if token.name <> ')'
					 then error(1, token);
				if lastspot + i > 1000
				   then error(26, obname);
				if i < 1
				   then error(27, obname);
					 
				newobj(ob);
				ob^.name := obname.name;
				ob^.threeD := threedim;
				ob^.obarray := true;
				ob^.quads := nil;
				ob^.solid := false;
				ob^.gons := nil;
				ob^.init := lastspot + 1;
				lastspot := lastspot + i;
				ob^.final := lastspot;
				i := hash2(ob^.name, 151);
				ob^.next := objlist[i];
				objlist[i] := ob;
				if obstash = nil
				   then begin
					         new(obstash);
				           for i := 1 to 1000 do
									    obstash^[i] := nil
								end;
				
				scanner(inf, token, flag);
				quoly_set(0, n)
				
		 end;
						 						 
  {****************************************************************************}
	
	procedure sparse_chpoly(spar: sparseptr; rows: longint; var n: quoly); forward;
	
  {****************************************************************************}
	
	procedure total_reset_view(change_angle: boolean);
	
	   var ob: objptr;
		     i, j: integer;
		 											
		 begin
		 
		    for j := 0 to 150 do
				   begin
					    ob := objlist[j];
							while ob <> nil do
								 begin
										if ob^.threeD
											 then if ob^.obarray
															 then for i := ob^.init to ob^.final do
																			 change_one_view(obstash^[i], false, change_angle)
															 else change_one_view(ob, false, change_angle);
										ob := ob^.next
								 end
					 end;
(*				if threedim
					 then begin
									 SetOrigin(0, 0);
									 EraseRect(my_rect);
									 MoveTo(xorigin, 0);
									 Line(0, yorigin);
									 MoveTo(xorigin, yorigin);
									 Line(2*round(yorigin*costheta), 2*round(yorigin*sintheta));
									 MoveTo(xorigin, yorigin);
									 Line(2*round(-yorigin*costheta), 2*round(yorigin*sintheta));
									 SetOrigin(-xorigin, -yorigin)
								end;
 *)								
				savescreen := true
					 
		 end;

	{**********************************************************************}  

  procedure factorial(var n: number);

     var i, j, value: longint;
		     x: longreal;
				 		 
		 begin
		 
				 n.float := round(n.float);
				 if n.float > factlimit
						then error(94, factsign);
				 i := 21;
				 value := round(n.float);
				 
				 while value < factnum[i] do
					  begin
							 i := i - 1;
							 if i = 0 then break
					  end;
					  
				 if complex
				    then imag_free(n);	 
				 x := facts[i];
				 for j := factnum[i] + 1 to value do
						x := x * j;
						
				 n.float := x
				
		end;
		 
	{***************************************************************************}
	 
	 procedure from_table(n, r: longint; var m: quoly);
			var k: longint;
			begin
				 k := n div 3;      { assume n <= 150 }
				 if odd(k) 
						then k := (k-1)*(n-1) div 4
						else k := k*(n-4) div 4;
				 free_quoly(m);
				 newquoly(m);
				 m^.numb := true;
				 newimag(m^.ncoef);
	       m^.ncoef^.float := binom^[r+k];
		     m^.ncoef^.imag := nil
			end;
				
	{****************************************************************************}
	 
	 procedure trivial(n, r: longint; var m: quoly);
			begin
				 if r = 1
						then quoly_set(n, m)
						else quoly_set(n*(n-1) div 2, m)  
			end;
				
	{****************************************************************************}
  		
  procedure float_binom(n, r: longint; var m: quoly);
	
		 var s, n2, r2, i: longint;
		     x: longreal;
		 		 
		 procedure standard;
		    var dum, trash: number;
				begin
					 if n > factlimit
					    then error(62, token);
					 if r = 1
					    then begin
							        quoly_set(n, m);
											exit {(float_binom)}
									 end
							else if (r=2) and (n <= halfblock)
							     then begin
									         quoly_set(n*(n-1) div 2, m);
													 exit {(float_binom)}
									      end;
					 trash.imag := nil;
					 trash.size := 0;
					 dum.imag := nil;
					 dum.size := 0;
					 dum.float := n;
					 factorial(dum);
					 trash.float := r;
					 factorial(trash);
					 dum.float := dum.float / trash.float;
					 trash.float := n-r;  {@@@ num2longreals}
					 factorial(trash);
					 dum.float := dum.float / trash.float;
					 scalar_to_quoly(dum, m)
				end;
				
		 {______________________________________________________________________}
				
		 begin
		 
		    if r > n div 2
				   then r := n - r;
				if (r <= 0) or (n <= 2)
				   then begin
					         if (n = 2) and (r = 1)
										  then quoly_set(2, m)
										  else quoly_set(1, m);
									 exit {(float_binom)}
								end;
								
				{ now n > 2 }
				if n <= 152
				   then if n mod 3 = 0
									 then from_table(n, r, m)
									 else begin  { assume n <= 152 }
													 n2 := 3*(n div 3);
													 s := n - n2;
													 r2 := r - s;
													 if r2 <= 0
															then trivial(n, r, m)
															else begin
																			from_table(n2, r2, m);  
																			for i := 1 to s do
																				 begin
																						x := n2 + i;
																						m^.ncoef^.float := x * m^.ncoef^.float;
																						x := r2 + i;
																						m^.ncoef^.float := m^.ncoef^.float / x
																				 end
																	 end
												end
				 else if n <= 500  { and n > 152 }
				         then begin
								         s := n - r;
												 n2 := 150;
												 r2 := n2 - s;
												 if r2 < 3
												    then standard
											      else begin
														        from_table(n2, r2, m);  
																		while n2 + 3 <= n do
																			 begin
																					n2 := n2 + 3;
																					x := (n2)*(n2-1)*(n2-2);
																					m^.ncoef^.float := x * m^.ncoef^.float;
																					r2 := r2 + 3;
																					x := (r2)*(r2-1)*(r2-2);
																					m^.ncoef^.float := m^.ncoef^.float / x
																			 end;
																		Inc(n2);
																		for i := n2 to n do
																			 begin
																					x := i;
																					m^.ncoef^.float := x * m^.ncoef^.float;
																					x := i - s;
																					m^.ncoef^.float := m^.ncoef^.float / x
																			 end
																 end
											end
				 else standard
		    
		 end;
		 
 {*****************************************************************************}
	
  procedure arr_expre(var inf: text; var n: quoly; var arr: workarray;
											var arr_facts: arr_descr; var arr_free: boolean; 
											var rows: longint; var flag: nameptr; var spar: sparseptr;
											callterm: boolean); forward;  { Nov 1997 }
											
  {****************************************************************************}

  procedure quoly_mod_and_quot(var n, m: quoly); forward;

	{****************************************************************************}
	
	procedure compute_char_poly(n, i: longint; var q: quoly); forward;
		
	{****************************************************************************}
	
	procedure set_quotient(m: quoly; var inf: text; var flag: nameptr); forward;
	
	{**************************************************************************}
	
	procedure call_content(var n: quoly); forward;
	
	{****************************************************************************}
	 
	procedure quoly_leading_coef(var n: quoly); forward;
	
	{****************************************************************************}
	 
	procedure raise_quoly(var n: quoly; k: longint); forward;
	
	{**************************************************************************}
	 
	procedure lower_quoly(var n: quoly; k: longint); forward; 
	
	{************************************************************************}
	 
	procedure dumpobj(var outf: text; ob: objptr);  forward;
	    									
	{***************************************************************************}
	
	procedure create_array(var inf: text; var n: quoly; var flag: nameptr); forward;
	
  {************************************************************************}

  procedure change_coef(var inf: text; var n: quoly; var flag: nameptr); forward;

	{***************************************************************************}
	
	procedure namechange(var inf: text; var n: quoly; var flag: nameptr);  forward;
	
	{***************************************************************************}
	
	procedure funcdef(var inf: text; var flag: nameptr); forward;
	
	{****************************************************************************}
	 
	procedure get_color(var inf: text; var n: quoly; var flag: nameptr);
	   { Jan 1998 }
	   var rred, ggreen, bblue: integer;
	   begin
	      scanner(inf, token, flag);
			  if token.name <> '('
					 then error(177, token);
				gettheRGB(inf, n, flag, rred, ggreen, bblue);
	      with theColor do
				 	 begin
					    red := rred;   green := ggreen;  blue := bblue
				   end;
				RGBForeColor(theColor)
	   end;

	{****************************************************************************}

	procedure builtin_func(var inf: text; var n: quoly; var flag: nameptr; index: longint);

	   var q, q2: arrptr;
		     rows, cols, start, total_rows, firstrow, firstcol, target_rows,
				    i, j, k: longint;
				 oldtok: array[1..4] of tokentipe;
				 wantmod, oldm1: boolean;
				 alpha: workptr;
				 beta: array[1..4] of workptr;
				 errorname: tokentipe;
				 arr_facts: arr_descr;
				 m, tr, ci, power, dum, cp, denomm: quoly;
				 want: boolarray;
				 xcor, ycor, height, x3: integer;
				 xext, yext, zext, x2, y2, z2: longreal;
				 ob: objptr;
				 obp: objptrptr;
				 spar: sparseptr;
         bounds : TRect;

		 {________________________________________________________________________}

		 procedure read_command;
        var oldtok: tokentipe;
		    begin
				   scanner(inf, token, flag);
					 if token.name <> '('
							then error(177, token);
					 scanner(inf, token, flag);
					 if token.name <> '['
							then error(178, token);
					 left_side(inf, q, rows, cols, start, total_rows, firstrow, firstcol,
								     target_rows, oldtok, flag, false);
					 if q = nil
							then error(28, oldtok);
				end;

		 {______________________________________________________________________}

		 procedure read_with_comma;
		    begin
				   scanner(inf, token, flag);
					 if token.name <> '('
						  then error(177, token);
					 scanner(inf, token, flag);
					 old_expre(inf, n, flag);
					 if token.name <> ','
						  then error(202, token);
					 scanner(inf, token, flag)
				end;

		 {______________________________________________________________________}

		 procedure standard_read;

		    begin
					 scanner(inf, token, flag);
					 if token.name <> '('
							then error(177, token);
					 scanner(inf, token, flag);
					 old_expre(inf, n, flag);
					 if token.name <> ')'
							then error(1, token);
					 scanner(inf, token, flag)
				end;

		 {__________________________________________________________________________}

	   procedure finish;
		    begin
					 free_work;
					 command_int := oldm1
				end;

		 {__________________________________________________________________________}

		 function average_size: longreal;
		    { all are numbers }
		    var i: longint;
				    sum: longreal;
						q: quoly;
		    begin
				   sum := 0;
					 q := nil;
				   for i:= 0 to rows*rows - 1 do
					    begin
							   quoly_assign(alpha^[i], q);
								 quoly_abs(q, true);
								 sum := sum + q^.ncoef^.float
							end;
					 average_size := sum/rows/rows;
					 free_quoly(q)
				end;

     {__________________________________________________________________________}

		 function allnumbs: boolean;
		    var i: longint;
		    begin
				   allnumbs := false;
				   for i:= 0 to rows*rows - 1 do
					    if not alpha^[i]^.numb
							   then exit {(allnumbs)};
					 allnumbs := true
				end;

		 {__________________________________________________________________________}

	   procedure get_exts;

		    begin
						scanner(inf, token, flag);
						old_expre(inf, n, flag);
						xext := quoly_convert_to_ext(n);
						if token.name <> ','
							 then error(202, token);
						scanner(inf, token, flag);
						old_expre(inf, n, flag);
						yext := quoly_convert_to_ext(n)
				end;

		 {_________________________________________________________________________}

		 procedure get_ints;

		    begin
				   scanner(inf, token, flag);
					 if token.name <> '('
							then error(177, token);
					 scanner(inf, token, flag);
					 old_expre(inf, n, flag);
					 xcor := quoly_convert_to_int(n);
					 if token.name <> ','
							then error(202, token);
					 scanner(inf, token, flag);
					 old_expre(inf, n, flag);
					 ycor := quoly_convert_to_int(n)
				end;

		 {__________________________________________________________________________}

	   procedure getfour;

		    var x1, x2, y1, y2: integer;
				    a,b: longreal;

		    begin
  				  get_exts;
						if token.name <> ','
							 then error(202, token);
						x1 := round(xscale*xext);
						y1 := - round(yscale*yext);
						MoveTo(x1, y1);
						a := xext; b := yext;
						get_exts;
						if token.name <> ')'
							 then error(1, token);
						x2 := round(xscale*xext);
						y2 := - round(yscale*yext);
						LineTo(x2, y2);
						if marking
						   then attach_line(x1,y1,x2,y2,a,b,0,xext,yext,0)
				end;

		{__________________________________________________________________________}

	   procedure getsix;

		    var x1, x2, y1, y2: integer;
				    x,a,b,c: longreal;

				begin
  				  get_exts;
						if token.name <> ','
							 then error(202, token);
						scanner(inf, token, flag);
						old_expre(inf, n, flag);
						x := quoly_convert_to_ext(n);
						if token.name <> ','
							 then error(202, token);
						x1 := round((yscale*yext - xscale*xext)*costheta);
						y1 := - round(zscale*x*z_cosine - (xscale*xext + yscale*yext)*sintheta);
						MoveTo(x1, y1);
						a := xext; b := yext; c := x;
						get_exts;
						if token.name <> ','
							 then error(202, token);
						scanner(inf, token, flag);
						old_expre(inf, n, flag);
						x := quoly_convert_to_ext(n);
						if token.name <> ')'
							 then error(1, token);
						x2 := round((yscale*yext - xscale*xext)*costheta);
						y2 := - round(zscale*x*z_cosine - (xscale*xext + yscale*yext)*sintheta);
						LineTo(x2, y2);
						if marking
						   then attach_line(x1,y1,x2,y2,a,b,c,xext,yext,x)
				end;

		 {_______________________________________________________________________}

		 procedure get_next_n;

		    begin
				   if token.name <> ','
						  then error(202, token);
					 scanner(inf, token, flag);
					 old_expre(inf, n, flag);
					 if not n^.numb
						  then error(215, token)
				end;

		 {_______________________________________________________________________}

		 begin

				case index of
				  Numb_:
					    begin
							   standard_read;
					       if n^.numb
								    then quoly_set(1, n)
										else quoly_set(0, n)
					    end;

					Return_: 
					   begin
						    standard_read;
						    if flag = nil
								   then writeln(userOutput, ' *** Warning. ''Return'' ignored.')
								   else exit_flag := true
						 end;	 				

					Arccos_, Arcsin_, Arctanh_, Cosh_, Sinh_:
					    begin
							   scanner(inf, token, flag);
					       if token.name <> '('
							      then error(177, token);
								 scanner(inf, token, flag);
								 old_expre(inf, n, flag);
								 if token.name <> ')'
							      then error(1, token);
								 if not n^.numb
								    then error(115, token);
								 x2 := n^.ncoef^.float;  {@@@}
								 if (index = Arccos_) or (index = Arcsin_)  {@@@}
								    then if abs(x2) > 1
										        then error(237, token);
								 case index of
								    Arccos_: if x2 = 0
														    then n^.ncoef^.float := pii.float/2
														 else begin
														         y2 := abs(x2);
														         n^.ncoef^.float := arctan(sqrt(1 - sqr(y2))/y2);
														         if x2 < 0
														            then n^.ncoef^.float := pii.float - n^.ncoef^.float
														      end;
										Arcsin_: if x2 = 1
														    then n^.ncoef^.float := pii.float/2
														 else if x2 = -1
														    then n^.ncoef^.float := -pii.float/2
														 else n^.ncoef^.float := arctan(x2/sqrt(1 - sqr(x2)));
										Arctanh_: n^.ncoef^.float := ArcTanh(n^.ncoef^.float);
									  Cosh_: n^.ncoef^.float := cosh(n^.ncoef^.float);
									  Sinh_: n^.ncoef^.float := sinh(n^.ncoef^.float)  { Dec 1997 }
								 end;
								 if n^.ncoef^.imag <> nil
								    then imag_free(n^.ncoef^);
								 scanner(inf, token, flag)
							end;
							
					True_:
					   begin
						    scanner(inf, token, flag);
								quoly_set(1, n)
						 end;
					
					False_:
					   begin
						    scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					Array_:
					   create_array(inf, n, flag);  { Nov 1997 }
					   
					Line_:
					   begin
						    scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
							  if threedim
								   then getsix
									 else getfour;
						    scanner(inf, token, flag);
								quoly_set(0, n);
								savescreen := true
						 end;
						 
					CLine_:
					    cline(inf, n, flag);
							
					ZLine_:
					    zline(inf, n, flag);
							
					Objarray_:
					    objarray(inf, n, flag);
							
					Sumup_:
					    arr_parse('S', inf, n, flag);
							
					Switchcol_, Switchrow_: 
					    begin
					       read_command;
								 if start = -1  { wasn't subarray }
								    then begin
										       start := q^.start;
													 target_rows := total_rows
												 end
										else if q^.spar <> nil
										        then error(291, token);
								 if (index = Switchrow_) and (target_rows <> total_rows)
								    then error(180, token);
								 if (index = Switchcol_) and (total_rows*cols <> q^.size)
								    then error(181, token);
								 if token.name <> ','
								    then error(70, token);
								 scanner(inf, token, flag);
								 old_expre(inf, n, flag);
								 j := quoly_convert_to_int(n) - addresser;
								 if token.name <> ','
								    then error(70, token);
								 scanner(inf, token, flag);
								 old_expre(inf, n, flag);
								 k := quoly_convert_to_int(n) - addresser;
								 if token.name <> ')'
								    then error(70, token);
								 scanner(inf, token, flag);
								 if (j < 0) or (k < 0) 
										then error(179, token);
								 if (index = Switchrow_) and ( (j >= total_rows) or (k >= total_rows) )
								    then error(179, token);
								 if (index = Switchcol_) and ( (j >= cols) or (k >= cols) )
								    then error(179, token);
								 if j <> k
								    then if q^.spar = nil
														then switchrow_col(index, j, k, start, total_rows, target_rows, cols)
														else sparse_switch(index, j + addresser, k + addresser, q);
								 quoly_set(0, n)
							end;
							
					Rcoef_:
					    change_coef(inf, n, flag);   { Nov 1997 }
					    
					Rname_:
					    namechange(inf, n, flag);    { Nov 1997 }

					Iszero_:
					    begin
							   errorname.name := 'iszero';
								 new_worknode(i, errorname);																		 
			           alpha := workhead[i];
								 scanner(inf, token, flag);
								 spar := nil;
								 arr_fact(inf, n, alpha^, arr_facts, wantmod, rows, flag, spar);
			           if arr_facts[1] = 0
								    then error(184, errorname);
								 j := 1;
								 for i := 0 to arr_facts[1] - 1 do
								    if not quoly_iszero(alpha^[i])
										   then begin
											         j := 0;
															 break
														end;
								 if wantmod
								    then free_arr(alpha^, arr_facts);								 
								 free_work;
								 quoly_set(j, n)
							end;
														
					Root1_:  {```}
					   root_unity(inf, n, flag);
					
					GCD_:
					   begin
						    read_with_comma; 
								m := nil;
								old_expre(inf, m, flag);
								if token.name <> ')'
							     then error(1, token);
								scanner(inf, token, flag);
								if n^.numb and m^.numb
								   then gcdnum(n, m)
								else if n^.numb
								   then gcd_one_num(n, m, false)
								else if m^.numb
								   then gcd_one_num(m, n, true)
								else if (n^.denom <> nil) or (m^.denom <> nil)
								   then error(203, token)
								else begin
								        Lpolygcd2(n^.numer, m^.numer, n^.numer);
												if n^.numer^.numb and (n^.numer^.next = nil)
							             then polynum_to_quoly(n)								
								     end;
								free_quoly(m)
						 end;
							
					Level_:  
					   begin
						    standard_read;
								if n^.numb
								   then quoly_set(0, n)
									 else quoly_set(poly_level(n^.numer), n)
						 end;
					
				  Numer_, Denom_:
					   begin
						    standard_read;
								if index = Denom_  
								   then if n^.numb
													 then quoly_set(1, n)
												else if n^.denom = nil
													 then quoly_set(1, n)
												else begin
																free_poly(n^.numer);
																n^.numer := n^.denom;
																n^.denom := nil
														 end
								else if n^.numb
								        then { nothing }
										 else if n^.denom = nil
										    then { nothing }
										 else begin
										         free_poly(n^.denom);
								             if n^.numer^.numb and (n^.numer^.next = nil)
											          then polynum_to_quoly(n)
													end
						 end;
					
          Func_, Function_:  { Nov 1997 }
					    begin
					       scanner(inf, token, flag);
					       if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
                    then funcdef(inf, flag)
										else error(11, token);
                 quoly_set(0, n)
              end;
							
					Numcon_:
					    begin
							   standard_read;
							   if quoly_iszero(n)   
								    then 
								    else quoly_set(1, n)
							end;
							
					Content_:
					    begin
							   standard_read;
							   call_content(n)
							end;
							
				  Sparse_:
					    make_sparse(inf, n, flag);
							
					RemQuot_:
					    begin
							   read_with_comma; 
								 m := nil;
								 old_expre(inf, m, flag);
								 if token.name <> ','
							      then error(202, token);
								 scanner(inf, token, flag);
								 quoly_mod_and_quot(n, m);
								 set_quotient(m, inf, flag);  { will use up m }
								 scanner(inf, token, flag)
							end;
							
				 Cfunc_, Pfunc_:
					   begin
						    scanner(inf, token, flag);
					      writeln(userOutput, 'not implemented');
								quoly_set(1, n)
						 end;
						 
					Lcoef_:  
					    begin
							   standard_read;
							   if not n^.numb
								    then quoly_leading_coef(n)
							end;
							
				  Height_:  
					    begin
							   standard_read;
							   if n^.numb
								    then quoly_set(0, n)
										else quoly_set(poly_height(n^.numer), n)
							end;
							
					Raise_, Lower_:
					    begin
							   scanner(inf, token, flag);
								 if token.name <> '('
										then error(177, token);
								 scanner(inf, token, flag);
								 old_expre(inf, n, flag);
								 if token.name = ','
								    then begin
										        scanner(inf, token, flag);
													  m := nil;
														old_expre(inf, m, flag);
														if not m^.numb
														   then error(253, token);
														k := quoly_convert_to_int(m);
														free_quoly(m)
										     end
										else k := 1;
								 if token.name <> ')'
										then error(1, token);
								 scanner(inf, token, flag);
							   if not n^.numb and (k <> 0)
								    then if index = Lower_
										        then lower_quoly(n, k)  { k is longint }
														else raise_quoly(n, k)
							end;
							
					 CPlot_:
					   begin
						    scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
								scanner(inf, token, flag);
						    old_expre(inf, n, flag);
								quoly_convert_to_comp(n, xext, yext);
								if token.name <> ')'
							     then if threedim
									         then if token.name <> ','
													         then error(202, token)
																	 else begin
																	         scanner(inf, token, flag);
																					 old_expre(inf, n, flag);
																					 z2 := quoly_convert_to_ext(n);
																					 if token.name <> ')'
							                                then error(1, token)
																				end
													 else error(1, token)
										else if threedim
										        then z2 := 0;
						    x2 := xscale*xext;
								y2 := yscale*yext;
								if threedim
								   then begin
									         xcor := round((y2 - x2)*costheta);
													 ycor := - round(zscale*z2*z_cosine - (x2 + y2)*sintheta)
												end
									 else begin
									         xcor := round(x2);
													 ycor := - round(y2)
												end;
(*								MoveTo(xcor, ycor);
								if marking
								   then attach_data(xcor, ycor, xext, yext, z2);
								if printchar
									 then begin
									         Move(-2,2);
													 DrawChar(mychar)
												end
									 else Line(0, 0);   *)
								scanner(inf, token, flag);
								quoly_set(0, n);
								savescreen := true
						 end;
						 
					ZPlot_:
					   begin
						    if not threedim
								   then error(130, token);
								scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
								scanner(inf, token, flag);
						    old_expre(inf, n, flag);
								quoly_convert_to_comp(n, xext, yext);
								if token.name = ')'
							     then x2 := 1  { x2 = the radius of the Riemann sphere }
									 else if token.name <> ','
													 then error(202, token)
													 else begin
																	 scanner(inf, token, flag);
																	 old_expre(inf, n, flag);
																	 x2 := quoly_convert_to_ext(n);
																	 if x2 <= 0
																	    then error(191, token);
																	 if token.name <> ')'
																			then error(1, token)
																end;
						    map_to_sphere(xext, yext, x2, xcor, ycor);
								{ x2 is now the z coord }
(*								MoveTo(xcor, ycor);
								if marking
								   then attach_data(xcor, ycor, xext, yext, x2);
								if printchar
									 then begin
									         Move(-2,2);
													 DrawChar(mychar)
												end
									 else Line(0, 0);     *)
								scanner(inf, token, flag);
								quoly_set(0, n);
								savescreen := true
						 end;
					
					Mark_:
					   begin
						    if marking
								   then writeln(userOutput, ' Warning. Already marking.')
									 else begin
									          marking := true;
				                    set_marking_globals;
														if flag = nil
														   then writeln(userOutput, ' Begin marking.')
												end;
								scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					Unmark_:
					   begin
						    if marking
								   then begin
									         curgraph^.next := graph_garb;
													 graph_garb := sysgraph;
													 curline^.next := line_garb;
													 line_garb := sysline;
													 sysline := nil;
													 sysgraph := nil;
													 if curgon <> nil
													    then begin
															        curgon^.gg := gon_garb;
																		  gon_garb := sysgon;
																		  sysendvert^.cp := point_garb;
																		  point_garb := sysendvert;
																			sysendvert := nil;
																			sysgon := nil;
																			curgon := nil
																	 end;
													 marking := false;
									         writeln(userOutput, ' Marking cancelled.')
									      end
									 else writeln(userOutput, ' Warning. Wasn''t marking.');
						    scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
				  Erase_:
					    begin
							   scanner(inf, token, flag);
								 if token.name = '('       { change bottom boundary of my_rect }
										then begin
										        scanner(inf, token, flag);
													  old_expre(inf, n, flag);
													  xcor := quoly_convert_to_int(n);
														if token.name <> ')'
														   then error(1, token);
														scanner(inf, token, flag);
														my_rect.bottom := xcor
												 end
								    else quoly_set(0, n);
								 SetOrigin(0,0);
								 EraseRect(my_rect);
								 SetOrigin(-xorigin, -yorigin);
								 savescreen := true
							end;
							
					Penstyle_:
					   begin
						    read_with_comma;
								k := quoly_convert_to_int(n);
								if (k >= 0) and (k <= 4)
								    then penpatt := k
										else error(228, token);
								RestorePenShade;
								old_expre(inf, n, flag);
								j := quoly_convert_to_int(n);
								if (j >= 0) and (j <= 4)
								    then penstyle := j
										else error(230, token);
								if j = 4
								   then begin
									         if token.name <> ','
							                then error(202, token);
													 scanner(inf, token, flag);	 
								           old_expre(inf, n, flag);
								           i := quoly_convert_to_int(n)
												end;
								if token.name <> ')'
							     then error(1, token);
								printchar := false;
								SetPenWidth(1);
							  case j of
								   0: { nothing };
									 1: SetPenWidth(2);
									 2: begin
									       printchar := true;
												 mychar := 'x'
											end;
									 3: begin
									       printchar := true;
												 mychar := 'o'
											end;
									 4: begin
									       printchar := true;
												 mychar := char(i)
											end
								end;
						    scanner(inf, token, flag)
						 end;

					Plot_:
					   begin
						    scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
								get_exts;
								if token.name <> ')'
							     then if threedim
									         then if token.name <> ','
													         then error(202, token)
																	 else begin
																	         scanner(inf, token, flag);
																					 old_expre(inf, n, flag);
																					 x2 := quoly_convert_to_ext(n);
																					 if token.name <> ')'
							                                then error(1, token)
																				end
													 else error(1, token)
										else if threedim
										        then x2 := 0;
														
						    scanner(inf, token, flag);
						    if threedim
								   then begin
									         xcor := round((yscale*yext - xscale*xext)*costheta);
													 ycor := - round(zscale*x2*z_cosine - (xscale*xext + yscale*yext)*sintheta)
												end
									 else begin
									         xcor := round(xscale*xext);
													 ycor := - round(yscale*yext)
												end;
								MoveTo(xcor, ycor);
								if marking
								   then attach_data(xcor, ycor, xext, yext, x2);
								if printchar
									 then begin
									         Move(-2,2);
													 DrawChar(mychar)
												end
									 else Line(0, 0);
								quoly_set(0, n);
							savescreen := true
						 end;
						 
					Rint_:
					   begin
						    standard_read;
								quoly_great_int(n)
						 end;						 
						 
					Polygon_:
					   polygn(inf, n, flag);
						 
					Solid_:
					   solidify(inf, n, flag);

					Rect_:
					   begin
						    scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
							  get_exts;
								if token.name <> ','
							     then error(202, token);
								xcor := round(xscale*xext);
								ycor := - round(yscale*yext);
						    MoveTo(xcor, ycor);
								x2 := xext;  y2 := yext;
								get_exts;
								if token.name <> ')'
							     then error(1, token);

								x3 := round(xscale*x2);
								height := - round(yscale*yext);
								LineTo(x3, height);
								if marking
								   then attach_line(xcor, ycor, x3, height, x2, y2, 0, x2, yext, 0);
								xcor := round(xscale*xext);
								ycor := - round(yscale*yext);
								LineTo(xcor, ycor);
								if marking
								   then attach_line(x3, height, xcor, ycor, x2, yext, 0, xext, yext, 0);
								x3 := round(xscale*xext);
								height := - round(yscale*y2);
								LineTo(x3, height);
								if marking
								   then attach_line(xcor, ycor, x3, height, xext, yext, 0, xext, y2, 0);
								xcor := round(xscale*x2);
								ycor := - round(yscale*y2);
								LineTo(xcor, ycor);
								if marking
								   then attach_line(x3, height, xcor, ycor, xext, y2, 0, x2, y2, 0);
								scanner(inf, token, flag);
								quoly_set(0, n);
								savescreen := true
						 end;
						 
					Copy_:
					   copy_object(inf, n, flag);

					OColor_, OIColor_:
					   color_object(inf, n, flag, index = OIColor_);  { Jan 1998 }
					   
					Carve_, Cut_:
					   cut_object(inf, n, flag, (index = Carve_));
						 
					Contrast_:
					   begin
						    standard_read;
								k := quoly_convert_to_int(n);
								if (k >= 0) and (k <= 3)
								   then contrast := k
									 else error(268, token);
								thepatt := patts[k]
						 end;
						 
					Reverse_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
								if token.name <> ')'
							     then error(1, token);
								if ob^.obarray
								   then for i := ob^.init to ob^.final do
												   begin
													    reverse_obj(obstash^[i]^.gons);
															if command_int 
																 then check_cmd_keys;
													 end
									 else begin
									         reverse_obj(ob^.gons);
													 if ob^.shaded
													    then shade_all(ob^.gons, false)
												end;
						    scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					ERotate_, Rotate_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
								if token.name <> ','
							     then error(202, token);
								scanner(inf, token, flag);
								old_expre(inf, n, flag);
								x2 := quoly_convert_to_ext(n);
								if token.name <> ','
							     then error(202, token);
								scanner(inf, token, flag);
								old_expre(inf, n, flag);
								k := quoly_convert_to_int(n);
								if (k < 1) or (k > 3)
								   then error(229, token);
								if token.name <> ')'
							     then error(1, token);
								wantmod := (index = ERotate_);
								if ob^.obarray
								   then for i := ob^.init to ob^.final do
												   begin
													    one_rotate_obj(obstash^[i], x2, false, false, k);
															if command_int 
																 then check_cmd_keys
													 end
									 else one_rotate_obj(ob, x2, wantmod, true, k);
						    scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					SColor_:  { Jan 1998 }
					   begin
					      get_color(inf, n, flag);
					      scanner(inf, token, flag);
					      quoly_set(0, n)
					   end;
					   
					Redraw_:   { May 1997 }
					   begin
					      redraw_screen;
					      scanner(inf, token, flag);
					      quoly_set(0, n)
					   end;
					
					Animate_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
								if token.name <> ')'
							     then if token.name <> ','
							             then error(202, token)
													 else begin
													         scanner(inf, token, flag);
								                   old_expre(inf, n, flag);
								                   k := quoly_convert_to_int(n);
						                       if token.name <> ')'
							                        then error(1, token)
																end
									 else k := 0;
						    if not ob^.obarray
								   then error(233, token);
								run_movie(ob, k);
								scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					Trans_, Etrans_:
					   begin
						    wantmod := (index = Etrans_);
						    translate(inf, n, flag, wantmod)
					   end;
					
					Union_, Join_:					   
             union(inf, n, flag, (index = Join_));
					
					Window_:
					   window(inf, n, flag);
															
					Setaxes_:
					   begin
						    get_ints;
								if token.name = ','
								   then begin
									         scanner(inf, token, flag);
													 old_expre(inf, n, flag);
													 height := quoly_convert_to_int(n)
												end
									 else height := 0; //wwhqd.ScreenBits.bounds.bottom;
								if token.name <> ')'
							     then error(1, token);
						    scanner(inf, token, flag);
								SetOrigin(0, 0);
						    MoveTo(xcor, 0);
								Line(0, height);
								MoveTo(0, ycor);
                GetScreenBounds(bounds);
								Line(bounds.right, 0);
								xorigin := xcor;
								yorigin := ycor;
								SetOrigin(-xorigin, -yorigin);
								threedim := false;
								quoly_set(0, n)
						 end;
									
					Setobj_:
					   set_object(inf, n, flag);					
					
					Delete_:
					   del_object(inf, n, flag);
					
					Setscale_:
					   begin
						    scanner(inf, token, flag);
							  if token.name <> '('
									 then error(177, token);
							  get_exts;
								if threedim
									 then if token.name <> ','
													 then error(202, token)
													 else begin
																	 scanner(inf, token, flag);
																	 old_expre(inf, n, flag);
																	 zext := quoly_convert_to_ext(n)
																end
									 else zext := zscale;
								if token.name = ','
								   then begin
									         actual_getob(inf, n, flag, obp, oldtok[1], true);
													 ob := obp^;
													 wantmod := false;
													 x2 := xscale;
													 y2 := yscale;
													 z2 := zscale
									      end
									 else wantmod := true;
												
								if token.name <> ')'
									 then error(1, token);
						    
						    xscale := xext;
								yscale := yext;
								zscale := zext;
								if wantmod
								   then total_reset_view(false)
									 else begin
									         if ob^.obarray
													    then for i := ob^.init to ob^.final do
												              change_one_view(obstash^[i], false, false)
															else change_one_view(ob, true, false);
													 xscale := x2;
													 yscale := y2;
													 zscale := z2;
													 if command_int 
														  then check_cmd_keys
												end;
								
								scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					Setthree_:
					   begin
						    get_ints;
								if token.name <> ')'
							     then error(1, token);
								SetOrigin(0, 0);
						    EraseRect(my_rect);
								MoveTo(xcor, 0);
								Line(0, ycor);
								xorigin := xcor;
								yorigin := ycor;
								MoveTo(xorigin, yorigin);
							  Line(2*round(yorigin*costheta), 2*round(yorigin*sintheta));
							  MoveTo(xorigin, yorigin);
							  Line(2*round(-yorigin*costheta), 2*round(yorigin*sintheta));
								SetOrigin(-xorigin, -yorigin);
								threedim := true;
								scanner(inf, token, flag);
								quoly_set(0, n);
								savescreen := true
						 end;
						 
					Deriv_: 
					   begin 
							  read_with_comma;  { gets n, token }
								m := nil;
								old_expre(inf, m, flag);
								{ will use 'dum' below; kind of dangerous. dum points into m. }
								newquoly(dum);
								check_for_monic_poly(296, m, height, k, dum^.numer, dum^.denom);
								if dum^.numer^.next <> nil
								   then error(296, token);
								dum^.next := quolygarb;
	              quolygarb := dum;
	              dum := nil;
								free_quoly(m);
								if token.name <> ','
									 then error(202, token);
								if k <> 1
								   then error(296, token);
								scanner(inf, token, flag);
								old_expre(inf, dum, flag);
								if not dum^.numb
								   then error(253, token);
								k := quoly_convert_to_int(dum);
								free_quoly(dum);
								if k < 0
								   then error(317, token);
								if token.name = ')'
								   then scanner(inf, token, flag)
									 else error(1, token);
							  if k > 0
								   then differentiate(n, height, k)
						 end;
							
				  Shade_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
								if token.name <> ')'
							     then error(1, token);
								if ob^.obarray
								   then error(261, token);
								shade_object(ob);
						    scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					Show_, Hide_, Wash_, ODump_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
								if token.name <> ')'
							     then error(1, token);
								if ob^.obarray
								   then error(234, token);
								if index = ODump_
								   then dumpobj(outpuf, ob)
								else if index = Wash_
								   then washobj(ob)
								else show_object(ob, (index = Hide_));
						    scanner(inf, token, flag);
								quoly_set(0, n)
						 end;
						 
					Trace_:
					   arr_parse('T', inf, n, flag);
						 
					Funcplot_:
					   funcplot(inf, n, flag);
						 
					CFuncplot_, ZSphere_:
					   cfuncplot(inf, n, flag, index);
						 
					Det__:  { Apr 1998 }
					    arr_parse('L', inf, n, flag);
					   
					Minpoly_:
					   error(302, token);
						 
					Zoom_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
								if token.name <> ','
							     then error(202, token);
								scanner(inf, token, flag);
								old_expre(inf, n, flag);
								x2 := quoly_convert_to_ext(n);
								if x2 = 0
								   then error(262, token);
								if token.name <> ')'
							     then error(1, token);
						    scanner(inf, token, flag);
						    if ob^.obarray
									 then for i := ob^.init to ob^.final do
													 zoom_one(obstash^[i], x2, false)
									 else zoom_one(ob, x2, true)
						 end;
						 
					View_:
					   begin
						    scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
								scanner(inf, token, flag);	 
								old_expre(inf, n, flag);
								xext := quoly_convert_to_ext(n);
								if (xext < -pii.float/2) or (xext > pii.float/2)
								   then error(238, token);
								if token.name <> ')'
							     then if token.name <> ','
													 then error(202, token)
													 else begin
																	 actual_getob(inf, n, flag, obp, oldtok[1], true);
																	 ob := obp^;
																	 if token.name <> ')'
																			then error(1, token);
																	 wantmod := false;
																	 y2 := sintheta;
																	 z2 := z_cosine
																end
									 else wantmod := true;
													
								sintheta := sin(xext)*costheta;
								z_cosine := cos(xext);
								if wantmod
								   then total_reset_view(true)
									 else begin
									         if ob^.obarray
													    then for i := ob^.init to ob^.final do
												              begin
																			    change_one_view(obstash^[i], false, true);
																					if command_int 
																						 then check_cmd_keys
																	    end
															else change_one_view(ob, true, true);
													 sintheta := y2;
													 z_cosine := z2
												end;
						    
								scanner(inf, token, flag);
						    quoly_set(0, n)
						 end;						 
						 
				  Transform_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
						    if token.name <> ','
							     then error(202, token);
						    new_worknode(i, errorname);																		 
			          alpha := workhead[i];
								scanner(inf, token, flag);
								spar := nil;
								arr_expre(inf, n, alpha^, arr_facts, wantmod, rows, flag, spar, true);
								if spar <> nil
								   then error(288, token);
								if token.name <> ')'
							     then error(1, token);
								scanner(inf, token, flag);
								quoly_set(0, n);
			          if arr_facts[1] = 0
								   then error(282, errorname);
								if ob^.threeD
								   then k := 3
									 else k := 2;
								if (arr_facts[1] <> sqr(k)) or (arr_facts[2] <> k)
								   then error(283, token);
								for i := 0 to arr_facts[1] - 1 do
								   if not alpha^[i]^.numb
									    then error(284, token);
								if ob^.obarray
									 then for i := ob^.init to ob^.final do
													 trans_form(alpha, k, obstash^[i])
									 else trans_form(alpha, k, ob);
                if wantmod
								   then free_arr(alpha^, arr_facts);								 
								free_work						    
						 end;
										
					Warp_:
					   begin
						    get_object(inf, n, flag, ob, errorname);
						    if token.name <> ','
							     then error(202, token);
								get_exts;
								get_next_n;
								zext := quoly_convert_to_ext(n);
								if token.name <> ')'
							     then error(1, token);
						    scanner(inf, token, flag);
								quoly_set(0, n);
								if ob^.obarray
								   then error(276, errorname);
								do_bias(ob, xext, yext, zext)
						 end;
						 
					Surface_, Threeplot_:
					   begin
								if index = Surface_
								   then begin
									        if marking or not threedim
														 then error(239, token);
													if surplotting or plotting or cplotting
														 then error(220, token)
												end;
								scanner(inf, token, flag);
								if token.name <> '('
									 then error(177, token);
								if index = Surface_
								   then begin
									         scanner(inf, oldtok[1], flag);
													 if (oldtok[1].name[1] < 'a') or (oldtok[1].name[1] > 'z')
														  then error(225, oldtok[1]);
													 scanner(inf, token, flag);
													 if token.name = '['
														  then begin
																		  x3 := getindex(inf, n, flag, oldtok[1]);
																		  free_obj(obstash^[x3]);
																		  wantmod := true
																	 end
														  else wantmod := false
												end
									 else token.name := ',';
									 
								{ shaded object (Surface) or polygons (Threeplot) }
							  get_next_n;
							  want[1] := (quoly_convert_to_int(n) = 1);  {```}
								if want[1] and (index = Threeplot_)
								   then if not marking
									         then error(319, token);
								
						    get_next_n;
							  xext := quoly_convert_to_ext(n);
								get_next_n;
								x2 := quoly_convert_to_ext(n);
								get_next_n;
								yext := quoly_convert_to_ext(n);
								get_next_n;
								y2 := quoly_convert_to_ext(n);
								get_next_n;
								z2 := quoly_convert_to_ext(n);
								if z2 <= 0
								   then error(240, token);
								if token.name <> ','
									 then error(202, token);
								scanner(inf, token, flag);	 
								if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
									 then surplot := func_retrieve(token)
									 else error(217, token);
								if index = Surface_
								   then surplotting := true;
							  surface_plot(n, inf, flag, xext, x2, yext, y2, z2, oldtok[1], wantmod, want[1], x3);
								if index = Surface_
								   then surplotting := false;
								if token.name <> ')'
								   then error(1, token);
								scanner(inf, token, flag);	 
								quoly_set(0, n)
						 end;
						 
					Colreduce_, Normalize_, Redrowech_:  { Oct 2000 }
					   begin
						    if index = Intnormal_
								   then error(183, token);
						    read_command; { sets q, rows, cols, start }
								if start <> -1
								   then error(182, token);
								case index of
									 Normalize_: errorname.name := 'Normalize';
								   Colreduce_: errorname.name := 'Colreduce';
									 Redrowech_: errorname.name := 'Redrowech'   { Oct 2000 }
								end;
								if q^.spar <> nil
								   then error(289, errorname);
								for i := 1 to 4 do
									 want[i] := false;
								for i := 1 to 4 do
									 if token.name = ')'
								      then break
											else begin
															if token.name <> ','
																 then error(70, token);
															if (index = Redrowech_) and (i >= 3)
															   then error(330, token);  { Oct 2000 }
															scanner(inf, token, flag);
															if token.name <> ','
																 then begin
																         if token.name <> '['
																				    then error(178, token);
																				 left_side(inf, q2, j, k, start, total_rows, firstrow, firstcol, 
																									 target_rows, oldtok[i], flag, false);
																									  { only want oldtok[i] }
																				 if start <> -1
																					  then error(182, token);
																				 want[i] := true
																			end
													 end;
								if token.name <> ')'
								   then error(1, token);
								scanner(inf, token, flag);								

								for i := 1 to 4 do
								   if want[i]
											 then begin
															 new_worknode(j, errorname);																		 
															 beta[i] := workhead[j]
														end;
								
								case index of
								   Normalize_: normalize(n, q, want, beta[1]^, beta[2]^, beta[3]^, beta[4]^);
								   Colreduce_: colreduce(n, q, want, beta[1]^, beta[2]^, beta[3]^, beta[4]^);
								   Redrowech_: red_row_ech(n, q, want, beta[1]^, beta[2]^);  { Oct 2000 }
								end;
								
								for i := 1 to 4 do
								   if want[i]
											 then begin
											         if index = Redrowech_ { Oct 2000 }
															    then j := rows
															 else if odd(i)
															         then j := rows
																	     else j := cols;
															 insertarr(oldtok[i], j, j);
															 if oldtok[i].address = -1
																	then k := hash(oldtok[i].name, 151)
																	else k := oldtok[i].address;
															 q2 := arr_store[k];
															 fillup(j, j, q2^.start, beta[i]^);
															 free_work
														end
						 end;
					
					Chpoly_:
					   begin
						    if polynames = nil
								   then error(299, token);
						    read_command; { sets q, rows, cols }
								if start <> -1
								   then error(182, token);
								if rows <> cols
								   then error(211, token);
								if token.name <> ')'
								   then error(1, token);
								errorname.name := 'Chpoly';
								scanner(inf, token, flag);
								
								if q^.spar <> nil
								   then begin
									         sparse_chpoly(q^.spar, rows, n);
									         exit {(builtin_func)}
												end;
												
								new_worknode(i, errorname);																		 
								alpha := workhead[i]; 
								oldm1 := command_int;
								command_int := false;
								
								{ 'copy' matrix to alpha }
								k := q^.start;
								for i := 0 to sqr(rows) - 1 do
									 begin
										  check_and_assign(k, alpha^[i]);
											Inc(k)
									 end; 
							 
								m := nil;
								spar := nil;
								
								if not ( allnumbs and (rows >= 4) and (rows <= full_charpol + 2) )
								   then begin  { ordinary way }
									         base_quoly(m, 1);
													 quoly_set(1, n);
													 for i := 0 to rows - 1 do
													    begin  { make new storage in case of error in mat_invert }
														     dum := alpha^[i*(rows+1)];
																 alpha^[i*(rows+1)] := nil;
																 quoly_sub(dum, m, alpha^[i*(rows+1)])
															end;
													 mat_invert(alpha^, alpha^, true, true, rows, n, false, true, spar);
													 free_quoly(m);
													 for i := 0 to rows - 1 do
													    free_quoly(alpha^[i*(rows+1)]);
													 finish;
													 exit {(builtin_func)}
								        end;
												
								{ find trace }
								tr := nil;
								k := q^.start;
								quoly_assign(arp[k shr 10]^[k and tenmask], tr);
								k := k + rows + 1;
								while k <= q^.stop do
									 begin
											better_quoly_add(tr, arp[k shr 10]^[k and tenmask], tr);
											k := k + rows + 1
									 end;
									 
								{ find determinant, call it m. }
								quoly_set(1, m);
								mat_invert(alpha^, alpha^, false, false, rows, m, false, true, spar);
								
								ci := nil;
								cp := nil;
								power := nil;
								denomm := nil;
								ycor := rows;
								quoly_set(0, n);
								
								xext := 3*average_size;   { hueristics here }
								yext := xext/(2*rows-6);
								for i := 1 to rows - 2 do
								   cc[i] := yext + xext*(2*i+1-rows)/(rows-3);
								
								{ Compute (:i=1,rows-2)[ C(i)*pol[rows-3,i] ] }
								for i := 1 to rows - 2 do
									 begin
											{ compute c[i]. Start by subtracting denom[i] from diag. }
											quoly_set_ext(cc[i], denomm);
											for j := 0 to rows - 1 do
												 better_quoly_sub(alpha^[j*(rows+1)], denomm, alpha^[j*(rows+1)]);
											quoly_set(1, ci);
											mat_invert(alpha^, alpha^, false, false, rows, ci, false, true, spar);
											better_quoly_sub(ci, m, ci);
											quoly_assign(denomm, power);
											quoly_compute_power(power, rows - 1);
											dum := nil;
											quoly_sub(denomm, tr, dum);
											quoly_mult(dum, power, dum);
											if odd(rows)
												 then quoly_inplace(dum);
											better_quoly_sub(ci, dum, ci);
											quoly_quot(ci, denomm, ci);
											
											{ cumulative sum in n }
											xcor := i;
											compute_char_poly(rows-2, i, cp);
											quoly_mult(ci, cp, dum);
											best_quoly_add(n, dum);
											if (flag = nil) and (ycor > 29) 
											   then begin
												         write(userOutput, xcor:0, ' ');
																 if (xcor mod 27 = 0) or (xcor = ycor - 2)
																    then writeln(userOutput);
																 flush(userOutput)
															end;
											
											{ put matrix back. }
											for j := 0 to rows - 1 do
												 better_quoly_add(alpha^[j*(rows+1)], denomm, alpha^[j*(rows+1)]);
									end;

							 dum := nil; 
							 base_quoly(dum, 1);
							 base_quoly(power, 1);
							 quoly_compute_power(power, rows - 1);
							 best_quoly_sub(dum, tr);
							 quoly_mult(dum, power, dum);
							 if odd(rows)
									then quoly_inplace(dum);
							 base_quoly(power, 1);
							 quoly_mult(n, power, n);
							 best_quoly_add(n, dum);
							 best_quoly_add(n, m);
							 
							 free_quoly(power);
							 free_quoly(denomm);
							 free_quoly(ci);
							 free_quoly(cp);
							 finish
				
						end;
						 
					else begin
					             writeln(userOutput, 'not yet');
											 exit {(pseudo_main)}
										end
							
				end
								 
		 end;
		 
  {**************************************************************************}

  procedure lookup; { (x: tokentipe;  r, c: longint; var q: arrptr; var qp: quolyptr;
	                     colflag: boolean)}

    { Set qp to point to the right quoly.  If array is sparse and the spot r, c
		  is zero, set qp to nil. 
			Jan 1998, qp might be nil at end, or qp^ might be nil. }
			
	  {spar. many changes here; almost all new procedure }

    begin
		
       array_seek(x, q);
			 get_quoly_ptr(q, r, c, colflag, qp, x, false)
			 
    end;

	{**************************************************************************}

  procedure sum_arr(var arr: workarray; m: longint;  var n: quoly);

     var i: longint;
		     extsum: longreal;

     begin
        quoly_set(0, n);
        if realflag
				   then begin
					         extsum := 0;
									 for i := 0 to m-1 do
			                extsum := extsum + arr[i]^.ncoef^.float;
									 n^.ncoef^.float := extsum
								end
					 else for i := 0 to m-1 do
			             better_quoly_add(n, arr[i],n)
     end;

  {*************************************************************************}

   procedure init_poly_node(var p: ferm118.poly);

    begin
	
			 newimag(p^.ncoef);
			 p^.ncoef^.size := 0;
			 p^.ncoef^.imag := nil
	   
	  end;
	
  {**************************************************************************}

  procedure sparse_create(let: tokentipe;  r, c: longint);  {``` new name}
	
	   var p: arrptr;
			   i: integer;

     begin
		    
				if (r < 1) or (c < 1)
           then error(27, let);
				if arr_garb = nil
					 then new(p)
					 else begin
									 p := arr_garb;
									 arr_garb := arr_garb^.next
								end;						 
				with p^ do
				   begin
					    name := let;
							start := 0;
							stop := -1;
							size := r*c;
							rows := r;
							time := array_time
					 end;
				Inc(array_time);
				
				if let.address = -1
					 then i := hash(let.name, 151)
					 else i := let.address;
					 
				p^.next := arr_store[i];
				arr_store[i] := p;
				
				sparse_init(p^.spar, r)		
		    
		 end;	
	
	{**************************************************************************}
	
	procedure actual_eval_poly; {(var n, n2: ferm118.poly; target, source: longint)}
	
	   { n needs to have no negative exponents at depth 'target', where the substitution
		   will be made.  n2 can be laurent poly. }
	
		 {_______________________________________________________________________}
		 
		 procedure highest_level(var q: ferm118.poly; n2: ferm118.poly; level: integer; pol: polypt);
		 
		    { The poly q will be evaluated at n2 with Horner's method.  q will
				  be freed (at the end) and reset to the desired value, computed with sum. 
					n2 is read only.  q cannot be a number upon entry.  q^.exp could be 0 
					when called by case_2.  q's first node is gobbled up into sum in an odd
					fashion.  can't have negative exponents in q at this level, but in laurent 
					you could have negatives below. }
		 
		    var sum, n2pow, t, qcopy, lowest: ferm118.poly;
				    num, i, nextexp: longint;
						
				procedure pad(p: ferm118.poly);
				   var i: integer;
					 begin
					    for i := 1 to level do
							   begin
		                 newpoly(t);
										 if i = 1
										    then lowest := t;
									   t^.exp := 0;
									   t^.numb := false;
									   t^.next := nil;
									   t^.pcoef := p;
									   p := t
								 end
					 end;
					 
				begin
				
					 sum := q^.pcoef;  { guaranteed since q is not a number. }
					 num := poly_length(q);
					 qcopy := q;
				   t := nil;
					 n2pow := nil;
					 
				   if (not sum^.numb) or (sum^.next <> nil)
				      then begin  { must pad with dummy node(s) for depth }
					           pad(sum);
										 sum := t;
									   t := nil 
								   end;

				   for i := 1 to num-1 do  { Horner's method }
				      begin
					       nextexp := q^.exp - q^.next^.exp;
							   if nextexp > 1
							       then begin				
							               poly_assign(n2, n2pow);
								             compute_power(n2pow, nextexp, pol);
									  			   poly_mult(n2pow, sum, sum, pol)
											    end
								    else poly_mult(n2, sum, sum, pol);
							   q := q^.next;
							   if q^.numb
							      then better_poly_add(sum, q, sum)
							   else if q^.pcoef^.numb and (q^.pcoef^.next = nil)
							      then better_poly_add(sum, q^.pcoef, sum)
							   else begin   { must pad with dummy node for depth }
							           if t = nil  { will be first time }
											      then pad(q^.pcoef) { sets t }
									          else lowest^.pcoef := q^.pcoef; { reuse pad created first time. }																		 
											   better_poly_add(sum, t, sum)
								      end
					    end;

				   if q^.exp > 1
							then begin
								      poly_assign(n2, n2pow);
								      compute_power(n2pow, q^.exp, pol);
											poly_mult(n2pow, sum, sum, pol)
									 end
							else if q^.exp = 1
									    then poly_mult(n2, sum, sum, pol);
								      { else if q^.exp = 0 do nothing }
									 
					 if t <> nil
				      then for i := 1 to level do
							        begin
				                 t^.next := polygarb;
								         polygarb := t;
												 t := t^.pcoef
								      end;
									 
					 free_poly(qcopy^.next);  { first node of qcopy had its coef used by sum }
					 qcopy^.next := polygarb;
					 polygarb := qcopy;
					 free_poly(n2pow);
					 q := sum
					 
			  end;
				
		 {________________________________________________________________}
				
		 procedure remove(var p,q,t: ferm118.poly);
		 
		    { p is the output head.  q is this node.  t is the tail of previously created 
				  output. This node is being killed. }
					
	      begin
	         if t = nil
		          then begin
			                p := q^.next;
					            q^.next := nil;
					            free_poly(q);
					            q := p
				           end
						  else begin
										  t^.next := q^.next;
										  q^.next := nil;
										  free_poly(q);
										  q := t^.next
									 end
        end;
				
		 {_________________________________________________________________}
				
		  procedure case_one(var p: ferm118.poly; target: integer; n2: ferm118.poly; pol: polypt);
			
			  { p is changed to answer. n2's depth is at least that of p.
				  n2 is read only.  Apply highest_level to coefficients in turn. Recur.}
		 
		    var t, q, r: ferm118.poly;
		 
        begin
				
	        if target = 1
					   then begin
						         if p^.exp > 0
						            then highest_level(p, n2, 1, pol);
										 exit {(case_one)}
									end;
					t := nil;
					q := p;
					if not n2^.numb
					   then n2 := n2^.pcoef; { prepare for recursion }
	        while q <> nil do
	           begin
		            if q^.numb { finished if not laurent, else nothing to do }
			             then begin
									         t := q;
													 q := q^.next
												end
			          else if q^.pcoef^.numb and (q^.pcoef^.next = nil) { nothing to do }
								   then begin
						               t := q;
								           q := q^.next
						            end
			          else begin
								        case_one(q^.pcoef, target - 1, n2, pol^.next);
			                  if poly_iszero(q^.pcoef)
				                   then remove(p, q, t)
												else if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil) 
						               then begin  { subtle! }
													         if t = nil
																	    then p := q^.pcoef
																			else t^.next := q^.pcoef;
																	 r := q^.next;
																	 q^.next := polygarb;
																	 polygarb := q;
																	 q := q^.pcoef;
																	 q^.next := r;
																	 t := q;
																	 q := r
																end
												else begin
						                    t := q;
								                q := q^.next
						                 end
										 end
		        end;
	       if p = nil
	          then poly_set(0, p)
		  				   
			 end;
				
		 {________________________________________________________________}
		 
		 procedure highest_case2(var q: ferm118.poly; target: longint; n2: ferm118.poly; leveldown: integer;
		                         pol: polypt);
		    
				{ The source poly n2 is at q's level or above; 'leveldown' tells how far above. 
				  The target poly var is lower (or perhaps at) q's level. If at q's level, 
					call highest_level to perform Horner's method. Otherwise call this procedure 
					recursively on each node's pcoef, multiply the result by the node with 
					coefficient 1 attached, and add up all such, using 'sum'.  Free all of q 
					and set q equal to sum.  q is not a number upon entry. }
		 
		    var sum, r, t: ferm118.poly;
						
				procedure pad_and_set;
				   { Attach 'leveldown' poly nodes of degree 0 on top of q.  Move up q to 
					   q^.next.  r points to augmented poly. }
				   var i: integer;
					     s: ferm118.poly;
				   begin
					    r := q;
							q := q^.next;
							r^.next := nil;
							for i := 1 to leveldown do
							   begin
								    newpoly(s);
	                  s^.next := nil;
	                  s^.exp := 0;
	                  s^.numb := false;
										s^.pcoef := r;
										r := s
								 end
					 end;
							   
				begin
				
				   if target = 1
					    then highest_level(q, n2, leveldown + 1, pol)
							
					 else begin
					    
							     sum := nil;
									 poly_set(0, sum);
									 while q <> nil do
									    begin
											   if q^.numb { finished, unless laurent }
			                      then begin
														        r := q^.next;
																		q^.next := nil;
														        best_poly_add(sum, q, sum);
																		q := r
																 end
			                   else if q^.pcoef^.numb and (q^.pcoef^.next = nil) { no recursive call }
								            then begin
						                        pad_and_set;  { sets r }
								                    best_poly_add(sum, r, sum)
						                     end
			                   else begin
												         highest_case2(q^.pcoef, target - 1, n2, leveldown + 1, pol);
			                           if poly_iszero(q^.pcoef)
				                            then begin
																		        r := q;
																						q := q^.next;
																						r^.next := nil;
																						free_poly(r)
																				 end
												         else if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil) 
						                            then begin
																	              r := q^.next;
																								q^.next := polygarb;
																	              polygarb := q;
																	              q := q^.pcoef;
																								best_poly_add(sum, q, sum);																																															
																								q := r
																             end
												        else begin
						                            t := q^.pcoef;
																				q^.pcoef := nil;
																				if q^.exp <> 0
																				   then begin  { mult the pcoef by this node. }
																					         poly_set(1, q^.pcoef);
																				           pad_and_set;  { sets r }
																				           poly_mult(r, t, r, pol);
																				           free_poly(t)
																								end
																					 else begin  { just add the pcoef. }
																					         r := q^.next;
																									 q^.next := polygarb;
																									 polygarb := q;
																									 q := r;
																									 r := t
																								end;
																				best_poly_add(sum, r, sum)
						                         end
														 end
										 end;
										 
							   q := sum
								 
		          end
				
				end;
				
		 {___________________________________________________________________}
		 
		 procedure case_two(var p: ferm118.poly; target, source: longint; n2: ferm118.poly; pol: polypt);
		 
		    { n2 is not a number. p is not a number. }
		 
		    var q, t, r: ferm118.poly;
		 
		    begin

				   if source = 1
					    then begin
						          highest_case2(p, target, n2, 0, pol);
										  exit {(case_two)}
									 end;
					 t := nil;
					 q := p;
	         while q <> nil do
	            if q^.numb { finished, unless laurent }
								 then begin
												 t := q;
												 q := q^.next
											end
							else if q^.pcoef^.numb and (q^.pcoef^.next = nil) { nothing to do }
								 then begin
												 t := q;
												 q := q^.next
											end
							else begin
											case_two(q^.pcoef, target - 1, source - 1, n2^.pcoef, pol^.next);
											if poly_iszero(q^.pcoef)
												 then remove(p, q, t)
											else if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil) 
												 then begin
																 if t = nil
																		then p := q^.pcoef
																		else t^.next := q^.pcoef;
																 r := q^.next;
																 q^.next := polygarb;
																 polygarb := q;
																 q := q^.pcoef;
																 q^.next := r;
																 t := q;
																 q := r
															end
											else begin
															t := q;
															q := q^.next
													 end
									 end;
									 
	        if p = nil
	           then poly_set(0, p)
		  				   
				end;
				
		 {_________________________________________________________________}

	   begin { actual_eval_poly }

				if target <= source  { guaranteed if n2 is number or target = 1 }
				   then case_one(n, target, n2, polynames)   { the easier case }
					 else case_two(n, target, source, n2, polynames)
								
		 end;
		 
  {*************************************************************************}
 
  procedure sparse_display(var outf: text; p: arrptr; istty: boolean);
	
	   var i, k, leng, pream: longint;
		     t: colm_ptr;
				 notfirst, its_syst: boolean;
				 lead: string[10];
				 sp: sparseptr;
		 
		 begin
		 
		    if istty
				   then lead := prompt
					 else lead := '';
				its_syst := istty and (p^.name.name = '');
				if its_syst  {```}
				   then write(outf, '[')
					 else write(outf, lead, '[', p^.name.name, '] := [ ');  { Nov 1997 }
				if its_syst {```}
				   then leng := 1
					 else leng := 8 + length(p^.name.name) + length(lead);
				pream := leng;
				notfirst := false;
				sp := p^.spar;  {```}
				for k := 0 to (p^.rows - 1) div sparsesize do
					 begin
							for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > p^.rows 
								    then break
								 else if sp^.indx[i-k*sparsesize] <> nil
										then begin
														if notfirst
															 then begin
																			 if istty
																					then write(outf, ' ', continuation);
																			 writeln(outf);
																			 write(outf, ' ':pream);
																			 leng := pream
																		end
															 else notfirst := true;
														write(outf, '[', i:2);
														leng := leng + 3;
														t := sp^.indx[i-k*sparsesize];
														while t <> nil do 
															 begin
																	write(outf, ', [', t^.coord:2, ', ');
																	leng := leng + 7;
																	quoly_display(outf, true, false, true, t^.val, leng, empty, 
																								polynames, false, false, false);
																	write(outf, ']');
																	Inc(leng);
																	t := t^.next;
																	if (leng > 150) and (t <> nil)
																		 then begin
																						 if istty
																								then write(outf, ' ', continuation);
																						 writeln(outf);
																						 write(outf, ' ': pream + 3);
																						 leng := pream + 3
																					end
															 end;
														write(outf, ' ]');
														check_cmd_keys
												 end;
							sp := sp^.next
					 end;
									 
			  write(outf, ' ]');
				if not istty
					 then write(outf, ';');
				writeln(outf);
				writeln(outf)
																			 
		 end;

	{*****************************************************************************}

  procedure display(var outf: text; outf_is_tty: boolean; var a: number;
	                  var mylength: longint; extra_space: boolean);

    var key: longint;
        done : boolean;

    procedure testneg;
		   begin
			    if a.float < 0
						 then begin
										 write(outf, '-');
										 if extra_space then write(outf, ' ');
										 Inc(mylength)
									end
			 end;

    begin

       done := False;
			 if abs(a.float) <= two_to_28 then
  			 if a.float = trunc(a.float)
					then begin
									if (a.float = 0) or (a.float = -0)
										 then key := 1
										 else key := 1 + trunc(0.00001+log10e*ln(abs(a.float)));
									testneg;
									write(outf, abs(round(a.float)) : key);
									mylength := mylength + key;
                  done := true
							 end;
       if not done then
         if outf_is_tty
									then begin
													if (a.float = 0) or (a.float = -0)
														 then write(outf, ' ':2, 0.0: 1:0, ' ':disp_size)
													else if (abs(a.float) <= two_to_28) and (abs(a.float) > 1/two_to_28)
														 then begin
														         testneg;
														         key := 1 + trunc(0.00001+log10e*ln(abs(a.float)));
																		 write(outf, abs(a.float): disp_size :disp_size-key)
																	end
													else begin
													        testneg;
													        write(outf, abs(a.float): disp_size+7);  { May 1997 }
													        mylength := mylength + 4  { estimate, May 1997 }
													     end;
													mylength := mylength + disp_size
											 end
									else begin
													testneg;
													write(outf, abs(a.float): 23);  { May 1997 }
													mylength := mylength + 18  { May 1997 }
											 end

    end;

  {***************************************************************************}

  procedure complex_display(var outf: text; outf_is_tty, flag: boolean;
                                var a: number; var mylength: longint; 
										            extra_space: boolean); 
																
		 var should_indent, flipped, its_minus1: boolean;
				 pad: string;
				 p: imptr;
																
	   begin
		 
		    if (a.imag = nil) or ferm118.iszero(a)
				   then display(outf, outf_is_tty, a, mylength, extra_space)
				else begin
				         
								 if imagzero(a)
								    then begin
										        display(outf, outf_is_tty, a, mylength, extra_space);
														exit {(complex_display)}
												 end;
								 
								 should_indent := true;
								 flipped := false;
								 a.imag^.imag := nil;
								 pad := '';
								 p := a.imag;
								 a.imag := nil;
								 if not ferm118.iszero(a)
								    then begin
										        display(outf, outf_is_tty, a, mylength, extra_space);
														should_indent := false
												 end;
								 a.imag := p;
								 if not should_indent 
								    then if mylength >= dispcutoff
                            then begin
														        if outf_is_tty or uglyprint
										                   then if uglyprint
																								then write(outf, continuation)
																								else write(outf, ' ', continuation);
														        writeln(outf);
																		mylength := 0
																 end;
								 if not should_indent 
								    then if 0 > a.imag^.float
										        then begin
										               flipped := true;
														       a.imag^.float := - a.imag^.float;
														       write(outf, ' - ')
												         end
														else write(outf, ' + ');
								 if not should_indent
								    then mylength := mylength + 3;
								 if mylength >= dispcutoff
                    then begin
										         if outf_is_tty or uglyprint
										            then if uglyprint
																				then write(outf, continuation)
																				else write(outf, ' ', continuation);
										         writeln(outf);
                             mylength := 0;
														 should_indent := true
												 end;
								 if not equal_to_pm1(a.imag^, its_minus1)
								    then display(outf, outf_is_tty, a.imag^, mylength,  
										             should_indent and extra_space)
										else if its_minus1
										         then if flag
														          then pad := '       -'
																			else pad := '-'
												 else if should_indent
												     then if flag
																			then pad := '        '
																			else pad := ' '
														 else pad := '';
								 if should_indent and extra_space
								    then pad := concat(pad, ' ');
								 write(outf, pad, '');
								 mylength := mylength + length(pad) + 1;
														 
								 if flipped
								    then a.imag^.float := -a.imag^.float
														 
						end						
						
		 end;
								 								 
 {******************************************************************************}
	
  procedure poly_display { (var outf: text; outf_is_tty, flag: boolean;
                            p: ferm118.poly; var mylength: longint; endchar:tokentipe;
												    q: polypt; extra_space, maybe_just_number: boolean)} ;
												 
		 var t: ferm118.poly;
		     its_minus1, needtimes: boolean;
				 
		 {______________________________________________________________________}
		 
		 function zero_real_part(t: ferm118.poly): boolean;
				begin
					  zero_real_part := (t^.ncoef^.float = 0)
				end;					    
		 
     {______________________________________________________________________}
		 
		 procedure blank_space;               {<<<<}
		    begin
		       if not uglyprint
					    then begin
							        write(outf, ' ');
							        Inc(mylength)
							     end
		    end;
		 {______________________________________________________________________}
		 
		 procedure plus_sign;                 {<<<<}
		    begin
		       if uglyprint
					    then write(outf, '+')
							else write(outf, '+ ')
		    end;
     {______________________________________________________________________}
		 
		 procedure handle_number(p: ferm118.poly);
		 
		    begin
				   if p^.ncoef^.float > 0
						  then plus_sign
						  else if pos_imag_part(p)
										  then write(outf, '+ ')
										  else extra_space := true
				end;
																				 																				 
		 {_____________________________________________________________________}
		 
		 function need_to(p: ferm118.poly; flag: boolean): boolean;
		 
		    var t: ferm118.poly;
		 
		    begin
				
					 if p^.numb
					    then if p^.ncoef^.float > 0
											then need_to := true
											else if pos_imag_part(p)
															then need_to := true
															else need_to := false
					 else begin
					         t := p^.pcoef;
									 need_to := false;
									 if p^.exp = 0
									    then need_to := flag and need_to(t, true)
											else if not t^.numb or (t^.next <> nil)
															then need_to := true
															else if complex
																			then if t^.ncoef^.imag <> nil
																						 then begin
																										 t^.ncoef^.imag^.imag := nil;
																										 if not ferm118.iszero(t^.ncoef^.imag^)
																												then if not zero_real_part(t)
																																then need_to := true
																									end
							 end
				end;

     {_____________________________________________________________________}
				 
		 procedure print_if_need(p: ferm118.poly; x: char);
		 
		    begin
				  if need_to(p, false)
					   then begin
									   write(outf, x);
									   Inc(mylength);
									   if x = '(' then extra_space := false
								  end
				end;
				
		 {_______________________________________________________________________}
												 
		 begin { of poly_display }
		 
		    if p^.numb and (p^.next = nil) and maybe_just_number
				   then complex_display(outf, outf_is_tty, flag, p^.ncoef^, 
								                mylength, false)
				else
				while p<>nil do
				   begin
					    needtimes := true;
							if p^.numb
				         then complex_display(outf, outf_is_tty, false, p^.ncoef^, 
								                      mylength, extra_space)
								 else begin
								         t := p^.pcoef;  
												 print_if_need(p, '(');
												 if t^.numb and (t^.next = nil)
												    then if equal_to_pm1(t^.ncoef^, its_minus1)
														        then if its_minus1
																		        then begin
																						        write(outf, '-');
																										needtimes := false;
																										if extra_space
																										   then blank_space
																								 end
																						else needtimes := false
																		else poly_display(outf, outf_is_tty, false, t, mylength, 
								                                      endchar, q^.next, extra_space, false)
													  else poly_display(outf, outf_is_tty, false, t, mylength, 
								                                      endchar, q^.next, extra_space, false);
												 print_if_need(p, ')')
											end;
							
							extra_space := false;
							if p^.exp <> 0
							   then begin 
								         if uglyprint and needtimes
												    then write(outf, '*');
												 write(outf, q^.let.name);
												 mylength := mylength + length(q^.let.name)
											end;
							if (p^.exp > 1) or (p^.exp < 0)
							   then begin
								         write(outf, '^', p^.exp:1);
												 if p^.exp < 0
												    then Inc(mylength);
												 mylength := mylength + trunc(0.00001+log10e*ln(abs(p^.exp)))+2
											end;
							p := p^.next;
							if (mylength >= dispcutoff + 4) and (p <> nil)
                 then begin
								         check_cmd_keys;
												 if outf_is_tty and (not uglyprint)          {<<<<<}
										        then write(outf, ' ', continuation);
										     writeln(outf);
                         mylength := 0
											end
							   else if p <> nil 
								         then blank_space;
							if p<>nil
							   then mylength := mylength + 2;
							if p<>nil 
							   then if p^.numb
								         then handle_number(p)
												 else if p^.pcoef^.numb and (p^.pcoef^.next = nil)
												         then if p^.pcoef^.ncoef^.float > 0
												                 then plus_sign
																         else if zero_real_part(p^.pcoef)
																				        then if pos_imag_part(p^.pcoef)
																							          then plus_sign
																								        else extra_space := true
																							  else if imagzero(p^.pcoef^.ncoef^)
																							          then extra_space := true
																											  else plus_sign
												         else if p^.exp <> 0
																         then plus_sign
																				 else if (pos_leading_coef(p) or need_to(p^.pcoef, true))
																				         then plus_sign
																								 else extra_space := true
					 end
		 
		 end;
								 
 {*****************************************************************************}

  procedure quoly_display; { var outf: text; outf_is_tty, flag, linend: boolean;
                             p: quoly; var mylength: longint; endchar: tokentipe;
												     q: polypt; extra_space, leadoff, char_flag: boolean }  
												 
		 var need_paren, flag2: boolean;
												 		 
		 procedure dumpit(x: char; front, back: boolean);  
		    begin
				   if front and not uglyprint
				      then write(outf, ' ');
					 write(outf, x);
				   if back and not uglyprint
				      then write(outf, ' ')
				end;
				
		 begin
		 
		    if p^.numb
				   then if char_flag
					         then write(outf, chr(convert_to_int(p^.ncoef^)))
									 else complex_display(outf, outf_is_tty, flag, p^.ncoef^, 
								                        mylength, false)
				else begin
				        need_paren := (p^.denom <> nil) and not poly_small(p^.numer);
								need_paren := need_paren or (not outf_is_tty);
								if outf_is_tty and leadoff and (promptsize > 0)
								   then write(userOutput, ' ': promptsize);
								if need_paren
									 then dumpit('(', false, true);
								flag2 := flag and (p^.denom = nil);
								poly_display(outf, outf_is_tty, flag2, p^.numer, mylength, endchar,
								             q, extra_space, true);
								if need_paren
									 then dumpit(')', true, false);
								if p^.denom <> nil
								   then begin
									         dumpit('/', true, true);
													 need_paren := not poly_small(p^.denom); 
													 if need_paren
													    then dumpit('(', false, true);
													 poly_display(outf, outf_is_tty, false, p^.denom, mylength, 
													              endchar, q, extra_space, true);
													 if need_paren
													    then dumpit(')', true, false)
											  end
						 end;
																
				if flag 
           then if outf_is_tty
                   then writeln(outf)
                   else writeln(outf, endchar.name)
		    else if outf_is_tty
		         then  
					   else if linend             {spar}
						         then begin
														 writeln(outf, endchar.name);
														 mylength := 4
													end;
        if flag and (polynames <> nil)
				   then if extra_line
					         then writeln(userOutput)
					 
		end;
					 												 												 
	{**************************************************************************}
	
	procedure call_content; {(var n: quoly)} 
	   
		 { laurents ok } 
		 
		 var p, exps, tail: ferm118.poly;
		     pt: polypt;
				 h: integer;
				 
		 begin
		 
		    if n^.numb
					 then quoly_set(1, n)
					 else if n^.denom <> nil
									 then error(196, token)
					 else begin
										pt := polynames;
										p := n^.numer;
										n^.numer := nil;
										if laurent
											 then clear_bads(p, exps, tail, 0)
											 else exps := nil;	
										h := 1;
										while p^.exp = 0 do 
											 begin
													p := p^.pcoef;
													h := h + 1;
													pt := pt^.next
											 end;
										content(p, n^.numer);  {~~~ new arg to content }
										if n^.numer^.numb
											 then polynum_to_quoly(n)
											 else add_pad(n^.numer, h);
										free_poly(p);
										if exps <> nil
											 then begin  
															 tail^.next := polygarb;
															 polygarb := exps
														end
								end
												
		 end;
		 
	{**************************************************************************}
	
	procedure quoly_leading_coef; {(var n: quoly)}
	
	   { n is not a number } 
		 
		 var pp: polyptrr;
		     q: ferm118.poly;
		 
		 begin
		 
		    pp := @ n^.numer;
				while not pp^^.numb do
				   pp := @ pp^^.pcoef;
					 
				q := pp^;
				pp^ := nil;
				free_poly(n^.numer);
				if n^.denom <> nil
				   then free_poly(n^.denom);
				n^.numb := true;
	      n^.ncoef := q^.ncoef;
	      q^.next := polygarb;
	      polygarb := q
		 
		 end;
		
	{**************************************************************************}
	
	procedure raise_quoly; {(var n: quoly; k: longint)}
	
	   { laurent ok. n is not a number. k <> 0. n is authenic. ~~~~ beware poly mod out }
		 
		 procedure raise_poly(var q: ferm118.poly);
		    var pt: polyptrr;
		        i: longint;
						p: ferm118.poly;
				begin
				   if q^.numb and (q^.next = nil)
					    then exit {(raise_quoly)};
					 pt := @ q;
					 for i := 1 to k do
						  if not pt^^.numb and (pt^^.exp = 0) and (pt^^.next = nil)
								 then pt := @ pt^^.pcoef
								 else error(313, token);
					 p := pt^;
					 pt^ := nil;
					 free_poly(q);
					 q := p
				end;
		 		 
		 begin
		 
		    if k < 0
				   then error(311, token);
				raise_poly(n^.numer);
				if n^.denom <> nil
				   then raise_poly(n^.denom)
				
		 end;
	
	{**************************************************************************}
	
	procedure lower_quoly; {(var n: quoly; k: longint)}
	
	   { laurent ok. n is not a number. k <> 0. n is authenic. ~~~ beware poly mod out }
		 
		 begin
		 
		    if k < 0
				   then error(311, token);
				if depth_below(n^.numer) + k > number_polys 
				   then error(315, token);
				if n^.denom <> nil
				   then if depth_below(n^.denom) + k > number_polys 
				           then error(315, token);
				if not (n^.numer^.numb and (n^.numer^.next = nil))
				   then add_pad(n^.numer, k);
				if n^.denom <> nil
				   then add_pad(n^.denom, k)
				
		 end;
	
  {**************************************************************************}
	
	procedure sparse_switch; {(index, j, k: longint; q: arrptr)}
	
	   { k <> j }
		 
		 var t: colm_ptr;
		     i, n: longint;
				 u, kp: colm_ptrptr;
				 found_k: boolean;
				 p: quoly;
				 sp1, sp2: sparseptr;
		 
		 begin
		 
		    if index = Switchrow_
				   then begin
					         sp1 := q^.spar;  {```}
									 sp2 := sp1;
									 for i := 2 to 1 + (j - 1) div sparsesize do
				              sp1 := sp1^.next;
					         for i := 2 to 1 + (k - 1) div sparsesize do
				              sp2 := sp2^.next;
					         u := @ sp1^.indx[1 + (j - 1) mod sparsesize];
									 kp := @ sp2^.indx[1 + (k - 1) mod sparsesize];
									 t := u^;
									 u^ := kp^;
									 kp^ := t
					      end
					 else begin
					         if k > j
									    then begin
											        i := j;
															j := k;
															k := i
													 end;
													 
									 { k is strictly less than j }
									 sp1 := q^.spar;  {```}
									 for n := 0 to (q^.rows - 1) div sparsesize do
											begin
												 for i := 1 + n*sparsesize to (n+1)*sparsesize do
														if i > q^.rows 
																then break
														 else begin
																		 u := @ sp1^.indx[i-n*sparsesize];
																		 while u^ <> nil do
																				if u^^.coord < k 
																					 then u := @ u^^.next
																					 else break;
																		 if u^ = nil
																				then continue;
																				
																		 kp := u;  { kp^^coord is first one >= k }
																		 found_k := (kp^^.coord = k);
																		 if found_k
																				then u := @ u^^.next;
																		 while u^ <> nil do
																				if u^^.coord < j 
																					 then u := @ u^^.next
																					 else break;
																		 if (u^ = nil) or (u^^.coord > j)  { j is absent }
																				then if found_k
																								then begin
																												t := kp^;
																												if u <> @ t^.next { sneaky! }
																													 then begin
																																	 kp^ := t^.next;
																																	 t^.next := u^;
																																	 u^ := t
																																end;
																												t^.coord := j
																										 end
																								else { nothing -- both absent }
																				else if found_k  { both present }
																								then begin
																												p := kp^^.val;
																												kp^^.val := u^^.val;
																												u^^.val := p
																										 end
																								else begin  { j is present, k isn't }
																												t := u^;
																												if u <> kp 
																													 then begin
																																	 u^ := t^.next;
																																	 t^.next := kp^;
																																	 kp^ := t
																																end;
																												t^.coord := k
																										 end
															   end;
																 
												 sp1 := sp1^.next
													
							        end
					 
					      end
								
		 end;
		
  {**************************************************************************}
	
	procedure mod_and_div(var n, n2, n4, n3: number);
	
		 { n3, n4, empty but initialized upon entry.  n3 is div; n4 is remainder. }
	
	   var n6: number;

		 begin
		 
				if complex
           then begin
										quot(n, n2, n3);
										complex_great_int(n3, n3);
										{ n3 is the div }
										n6.size := 0;   
										n6.imag := nil; 
										mult(n2, n3, n6);
										sub(n, n6, n4);
										{ n4 is the remainder }
										if pos_mod and (n2.imag = nil) and (n2.float > 0)
											 then begin
															if n4.float < 0
																 then n4.float := n4.float + n2.float;
															if (n4.imag <> nil) and (n4.imag^.float < 0) 
																 then n4.imag^.float := n4.imag^.float + n2.float
														end;
										imag_free(n6)
								end
										 
						else begin
										if n2.float = 0
											 then begin
															 error(22, token);
															 complex_set(0, n3);
															 complex_set(0, n4);
															 exit {(mod_and_div)}
														end;
										n3.float := round(n.float/n2.float);
										n4.float := n.float - n3.float*n2.float;
										if pos_mod and (n4.float < 0) and (n2.float > 0)
											 then n4.float := n4.float + n2.float;  { n4 is the remainder }
										{ n3 is the div }
								 end
                
			end;

	{****************************************************************************}
	 
	function anynegs(p: ferm118.poly): boolean;
	 
		{ Is there a negative exponent in p? }
 
		var test: boolean;
 
		begin
			 
			 while p <> nil do
					begin
						 if p^.exp < 0
								then test := true
						    else if p^.numb
						            then test := false
						            else test := anynegs(p^.pcoef);
						 if test
								then begin
												anynegs := true;
												exit {(anynegs)}
										 end
								else p := p^.next
					end;										
			 anynegs := false	        
					
		end;
				
  {************************************************************************}

  procedure dump(var outf: text; outf_is_tty, flag: boolean);
	
    var dummy: longint;
		    i: integer;
				p: varptr;
				do_data: boolean;
				
    begin
		
		  do_data := (not outf_is_tty) or noisy;
			for i := 0 to 150 do
			   begin
				    p := sca_store[i];
            while p <> nil do
               begin
							    write(outf, ' ', p^.let.name);  
									if do_data
									   then write(outf, ' := ');  { Nov 1997 }
									dummy := 0;
                  if is_array_param(p^.val)
						         then writeln(outf, ' array parameter.')
						         else if do_data
										         then begin
																		 if not p^.val^.numb
																				then write(outf, '&_n ');
																		 quoly_display(outf, outf_is_tty, flag, true, p^.val, dummy, semicolon, 
																									polynames, false, true, false);
																		 if not p^.val^.numb
																				then writeln(outf)
																	end
														 else writeln(outf);
                  p := p^.next
               end
				 end
				
    end;

  {**************************************************************************}

  procedure poly_mod_and_div(n, m: ferm118.poly; var r, qt: ferm118.poly);
	
    { r = remainder, qt = quotient. both always nil on entry.  }
		
		var q1, q2, t1, s1, t2, s2: ferm118.poly;
				
		{________________________________________________________________________}
		
		procedure gen_case(n, m: ferm118.poly; var r, qt: ferm118.poly);  
		
		   { r and qt nil on entry.  neither n nor m is a number.  Very delicate 
			   because of the m^.exp = 0 case.  Revised June 1994. }
			 
		   var height: integer;
					 pr, pqt: polyptrr;  
					 r2, qt2: ferm118.poly;
		   begin
					height := 0;
					if (n^.exp = 0) and (m^.exp = 0)
						 then repeat 
										 n := n^.pcoef;
										 m := m^.pcoef;
										 height := height + 1
								  until (n^.exp > 0) or (m^.exp > 0);
									
					if n^.exp = 0   
						 then begin
								     poly_assign(n, r);
									   poly_set(0, qt)
									end
												
					else if m^.exp = 0  { can't be a number }
					    then begin
						          poly_assign(n, r);
											pr := @ r;
											{ We need another list of the same nodes as r^ to build up qt.
											  qt^ ends up being a kind of pseudo-polynomial, with 
												undefined pcoef's.  Danger!  Don't try to free such a thing! }
											n := r;
											pqt := @ qt;
										  while n <> nil do
											   begin
												    newpoly(pqt^);
														pqt^^.exp := n^.exp;
														pqt^^.numb := n^.numb;
														n := n^.next;
														pqt := @ pqt^^.next
												 end;
											pqt^ := nil;
											pqt := @ qt;
											r2 := nil;
											qt2 := nil;

											while pr^ <> nil do
											   { at start, pr and pqt always point to corresponding nodes
												   whose contents are next to be examined.  Warning again:
													 Don't try to free_poly(pqt^) or any part of that list!  
													 Directly set polygarb to free individual nodes. }
										     if pr^^.numb
														then begin
																		pr := @ pr^^.next;  { pr^ must now be nil }
																		pqt^^.next := polygarb;
																		polygarb := pqt^;
																		pqt^ := nil
																 end
														else begin
																		poly_mod_and_div(pr^^.pcoef, m^.pcoef, r2, qt2);
																		free_poly(pr^^.pcoef);
																		if poly_iszero(r2)
																			 then begin
																							 free_poly(r2);
																							 r2 := pr^;
																							 pr^ := r2^.next;
																							 r2^.next := nil;
																							 free_poly(r2)
																						end
																			 else begin
																							 if r2^.numb and (pr^^.exp = 0)
																							    then begin
																									        free_poly(pr^);
																									        pr^ := r2
																									     end
																									else pr^^.pcoef := r2;
																							 r2 := nil;
																							 pr := @ pr^^.next
																						end;
																		if poly_iszero(qt2)
																			 then begin
																							 free_poly(qt2);
																							 qt2 := pqt^;
																							 pqt^ := qt2^.next;
																							 qt2^.next := polygarb;
																							 polygarb := qt2
																						end
																			 else begin
																							 if qt2^.numb and (pqt^^.exp = 0)
																							    then begin
																									        pqt^^.next := polygarb;
																													polygarb := pqt^;
																									        pqt^ := qt2
																									     end
																									else pqt^^.pcoef := qt2;
																							 pqt := @ pqt^^.next
																						end;
																		qt2 := nil
																 end;

										  if r = nil
										     then poly_set(0, r);												 
											if qt = nil
										     then poly_set(0, qt)
						       end
												
					else if (number_polys = 1) or ( height_is_1(n) and height_is_1(m)) 
						 then basic_poly_divide(n, m, qt, r)  { only works for fields }
						 else pseudo_div(n, m, qt, r, true); 
						 
					if (height > 0) and not r^.numb
						 then add_pad(r, height);	
					if (height > 0) and not qt^.numb
						 then add_pad(qt, height)
			 end;
			 
		{________________________________________________________________________}
 
    begin
		
		    q1 := nil;
				q2 := nil;
				if m^.numb and n^.numb and (m^.next = nil) and (n^.next = nil)
				   then begin
					         newpoly(q1);
									 q1^.numb := true;
									 q1^.exp := 0;
									 q1^.next := nil;
					         init_poly_node(q1);
									 newpoly(q2);
									 q2^.numb := true;
									 q2^.exp := 0;
									 q2^.next := nil;
					         init_poly_node(q2);
									 mod_and_div(n^.ncoef^, m^.ncoef^, q1^.ncoef^, q2^.ncoef^);
								   r := q1;
									 qt := q2
								end
		    else if m^.numb and (m^.next = nil)
				   then begin
					         t1 := nil;
									 s1 := nil;
									 t2 := nil;
									 s2 := nil;
									 { At the end of each pass through this loop, si and ti are equal and
									   point to the last node actually attached to the output lists qi. 
										 During the loop, a new node is tentatively attached to ti. }
					         while n <> nil do
									    begin
					               if t1 = nil
									          then begin
											              newpoly(q1);
															      t1 := q1
													       end
											      else begin
											              newpoly(t1^.next);
															      t1 := t1^.next
													       end;
												 if t2 = nil
									          then begin
											              newpoly(q2);
															      t2 := q2
													       end
											      else begin
											              newpoly(t2^.next);
															      t2 := t2^.next
													       end;
									       t1^.numb := n^.numb;
									       t1^.exp := n^.exp;
												 t2^.numb := n^.numb;
									       t2^.exp := n^.exp;
					               if n^.numb
									          then begin
											              init_poly_node(t1);
																		init_poly_node(t2);
									                  mod_and_div(n^.ncoef^,  m^.ncoef^, t1^.ncoef^, t2^.ncoef^);
																		if node_iszero(t1)
																		   then begin  { move back one node }
																			         t1^.next := nil;
																			         free_poly(t1);
																							 t1 := s1
																						end
																			 else s1 := t1;
																		if node_iszero(t2)
																		   then begin  { move back one node }
																			         t2^.next := nil;
																			         free_poly(t2);
																							 t2 := s2
																						end
																			 else s2 := t2
											           end
											      else begin
											              t1^.pcoef := nil;
																		t2^.pcoef := nil;
															      poly_mod_and_div(n^.pcoef, m, t1^.pcoef, t2^.pcoef);
																		if poly_iszero(t1^.pcoef)
																		   then begin  { move back one node }
																			         t1^.next := nil;
																			         free_poly(t1);
																							 t1 := s1
																						end
																			 else s1 := t1;
																		if poly_iszero(t2^.pcoef)
																		   then begin  { move back one node }
																			         t2^.next := nil;
																			         free_poly(t2);
																							 t2 := s2
																						end
																			 else s2 := t2
													       end;
									       n := n^.next
								      end;
									 if t1 <> nil
									    then begin
											        t1^.next := nil;
									            r := q1
													 end
											else poly_set(0, r);
									 if t2 <> nil
									    then begin
											        t2^.next := nil;
									            qt := q2
													 end
											else poly_set(0, qt)
								end
				else if n^.numb and (n^.next = nil)
				        then begin
								        poly_assign(n, r);
									      poly_set(0, qt)
										 end
				else if laurent 
				        then if anynegs(n) or anynegs(m)
								        then error(205, token)
												else gen_case(n, m, r, qt)									    
				else gen_case(n, m, r, qt)	
					
    end;
		
	{*************************************************************************}

  procedure quoly_mod_and_quot; {(var n, m: quoly)}
	
	   { just look at numers. }
	
	   var q1, q2: quoly;
		     m2: ferm118.poly;
	
	   begin
		 
		    newquoly(q1);
				newquoly(q2);
				
				if m^.numb and n^.numb
				   then begin
									 q1^.numb := true;
									 q2^.numb := true;
					         init_quoly_node(q1);
									 init_quoly_node(q2);
									 mod_and_div(n^.ncoef^, m^.ncoef^, q1^.ncoef^, q2^.ncoef^);
								   free_quoly(n);
									 n := q1;
									 free_quoly(m);
									 m := q2;
									 exit {(quoly_mod_and_quot)}
								end;
											
				q1^.numer := nil;
				q1^.denom := nil;
				q1^.numb := false;
				q2^ := q1^;
				if m^.numb
				   then begin
									 m2 := nil;
									 quoly_to_poly(m, m2);
									 poly_mod_and_div(n^.numer, m2, q1^.numer, q2^.numer);
								   free_poly(m2)						 									 
								end
				else if n^.numb
				   then begin
									 m2 := nil;
									 quoly_to_poly(n, m2);
									 poly_mod_and_div(m2, m^.numer, q1^.numer, q2^.numer);
								   free_poly(m2)
								end
				else poly_mod_and_div(n^.numer, m^.numer, q1^.numer, q2^.numer);
				
				if q1^.numer^.numb and (q1^.numer^.next = nil)
					 then polynum_to_quoly(q1);
				if q2^.numer^.numb and (q2^.numer^.next = nil)
					 then polynum_to_quoly(q2);
				free_quoly(n);
				free_quoly(m);
				n := q1;
				m := q2
				
		end;
					         
	{***************************************************************************}
	
	procedure cfuncplot; {(var inf: text; var n: quoly; var flag: nameptr; index: longint)}
	
	   var mytoken: tokentipe;
		     xext0, yext0, x2, y2, xext1, yext1, z0, z1, rad: longreal;
				 xcor0, ycor0, xcor1, ycor1: integer;
				 riemann, oldrealflag: boolean;
		 
		 procedure sphere(flag: boolean);
		    var r, d, n: longreal;
				begin
				   r := 4*sqr(rad);
					 n := sqr(x2) + sqr(y2);
					 d := n + r;
					 if flag
					    then xext1 := x2*r/d
							else xext0 := x2*r/d;
					 if flag
					    then yext1 := y2*r/d
							else yext0 := y2*r/d;
					 if flag
					    then z1 := 2*rad*n/d
							else z0 := 2*rad*n/d
				end;
		 
		 begin
		 					
				get_params(inf, n, flag);	
				if token.name <> ','
					 then error(202, token);
				scanner(inf, token, flag);
				if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
					 then cplot := func_retrieve(token)
					 else error(217, token);	 
					 
				{ get first value of path function. }
				quoly_set(0, plotnum);
			  oldrealflag := realflag;
				eval_form(inf, pplot^.rht, plotnum);
				if plotnum = nil
					 then quoly_set(0, plotnum);
				realflag := oldrealflag;
				exit_flag := false;
			  cycle_flag := false;
			  leave_flag := false;
				epilog(pplot);
			  if not plotnum^.numb
					 then error(219, token);
				if threedim
				   then quoly_convert_to_comp(plotnum, xext0, yext0);
				
				{ get first value of complex function to be plotted. }
				vplot2 := nil;
				if cplot^.pars = nil
					 then error(221, token);
				setargs(cplot^.pars, flag, mytoken, n, plotnum, inf, vplot2, h2plot, 
								ccop, arr2plot);   
				{ plotnum is now nil. }
				preset_stuff(cplot);
				if vplot2 = nil
					 then error(218, token);
				
				quoly_set(0, cplotnum);
			  oldrealflag := realflag;
				eval_form(inf, cplot^.rht, cplotnum);
				if cplotnum = nil
					 then quoly_set(0, cplotnum);
				realflag := oldrealflag;
				exit_flag := false;
			  cycle_flag := false;
			  leave_flag := false;
				epilog(cplot);
			  if not cplotnum^.numb
					 then error(219, token);
				
				token := mytoken;
				if index = ZSphere_
				   then begin
					         if not threedim
									    then error(130, token);
									 if token.name <> ','
										  then error(202, token);
									 scanner(inf, token, flag);
									 old_expre(inf, n, flag);
									 rad := quoly_convert_to_ext(n);
									 riemann := true
								end
					 else riemann := false;
				if token.name <> ')'
					 then error(1, token);
				scanner(inf, token, flag);
				
				{ plot it. }
				cplotting := true;
				if threedim
				   then begin
					         quoly_convert_to_comp(cplotnum, x2, y2);
									 if riemann
									    then sphere(false)
											else z0 := sqrt(sqr(x2) + sqr(y2));
									 xcor0 := round((yscale*yext0 - xscale*xext0)*costheta);
									 ycor0 := - round(zscale*z0*z_cosine - (xscale*xext0 + yscale*yext0)*sintheta)
					      end
					 else begin
					         quoly_convert_to_comp(cplotnum, xext0, yext0);
									 xcor0 := round(xscale*xext0);
									 ycor0 := - round(yscale*yext0)
								end;
				MoveTo(xcor0, ycor0);
				if marking and points  { set by get_params }
					 then attach_data(xcor0, ycor0, xext0, yext0, z0);
				if points
				   then if printchar
									 then begin
													 Move(-2,2);
													 DrawChar(mychar)
												end
									 else Line(0, 0);

			  add(vcop^.val^.ncoef^, increm^.ncoef^,  vcop^.val^.ncoef^);
				 
				while vcop^.val^.ncoef^.float <= final^.ncoef^.float do
				   begin
					    duplicate(hplot, arrplot, hpcopy, arrpcopy, vcop, vcop2);
              attach_symbols(hpcopy, arrpcopy);
							preset_stuff(pplot);
							quoly_set(0, plotnum);
							oldrealflag := realflag;
							eval_form(inf, pplot^.rht, plotnum);
							if plotnum = nil
					       then quoly_set(0, plotnum);
							realflag := oldrealflag;
							exit_flag := false;
					    cycle_flag := false;
					    leave_flag := false;
							epilog(pplot);
							if not plotnum^.numb
								 then error(219, token);
							if threedim
				         then quoly_convert_to_comp(plotnum, xext1, yext1);
					 
							free_quoly(ccop^.val);
							ccop^.val := plotnum;
							plotnum := nil;
							duplicate(h2plot, arr2plot, hpcopy, arrpcopy, ccop, vcop2);
              attach_symbols(hpcopy, arrpcopy);	 
							preset_stuff(cplot);
							quoly_set(0, cplotnum);
							oldrealflag := realflag;
							eval_form(inf, cplot^.rht, cplotnum);
							if cplotnum = nil
					       then quoly_set(0, cplotnum);
							realflag := oldrealflag;
							exit_flag := false;
						  cycle_flag := false;
						  leave_flag := false;
							epilog(cplot);
							if not cplotnum^.numb
								 then error(219, token);
								 
							if threedim
								 then begin
												 quoly_convert_to_comp(cplotnum, x2, y2);
												 if riemann
									          then sphere(true)
											      else z1 := sqrt(sqr(x2) + sqr(y2));
												 xcor1 := round((yscale*yext1 - xscale*xext1)*costheta);
									       ycor1 := - round(zscale*z1*z_cosine - (xscale*xext1 + yscale*yext1)*sintheta)
											end
								 else begin
												 quoly_convert_to_comp(cplotnum, xext1, yext1);
												 xcor1 := round(xscale*xext1);
									       ycor1 := - round(yscale*yext1)
											end;
							if points
								 then MoveTo(xcor1, ycor1)
								 else LineTo(xcor1, ycor1);
							if marking
				         then if points
								         then attach_data(xcor1, ycor1, xext1, yext1, z1)
												 else begin
												         attach_line(xcor0,ycor0,xcor1,ycor1,xext0,yext0,z0,xext1,yext1,z1);
																 xcor0 := xcor1; ycor0 := ycor1;
																 xext0 := xext1; yext0 := yext1;
																 z0 := z1
															end;
					    if points
							   then if printchar
												 then begin
																 Move(-2,2);
																 DrawChar(mychar)
															end
												 else Line(0, 0);

							add(vcop^.val^.ncoef^, increm^.ncoef^, vcop^.val^.ncoef^);

							if command_int
								 then check_cmd_keys

					 end;
							
				cancel_dups(hplot, arrplot);
				cancel_dups(h2plot, arr2plot);
				cplotting := false;
				quoly_set(0, n);
				
				savescreen := true

		 end;

	{***************************************************************************}
	
	procedure surface_plot; {(var n: quoly; var inf: text; var flag: nameptr; initx, finalx,
	                          inity, finaly, incr: longreal; graphname: tokentipe; itsarray,
												    shadeit: boolean; ind: integer)}
												 
		 { If not surplotting and shadeit, user desires Threeplot to produce polygons. }
		 
		 var val: quol_array;
		     ob: objptr;
		     v: varp_array;
				 loc: loc_array;
				 loc_vals: loc_val_array;
				 param: paramptr;
				 plotnum: quoly;
				 q: quadptr;
				 x, y: floatptr;
				 endrow, endcol,      { mark when on last row and column }
				   orientation, sqr_orient: boolean; { so that each squares flows correctly, a'la homology }
				 squarenum, i, estnum, row, col, numcols, width, maxwidth, size_locs: integer;
				 mytoken: tokentipe;
				 arr: workptr; {```}
				 line: lineptr;
				 dum: longint;
				 markit, wantpolygons, oldrealflag: boolean;
				 xext, yext, zext, zd, zr, oldy, zfactor, xfact1, xfact2, yfact1, 
				     yfact2: longreal;
				 xcor, ycor, dxcor, dycor, rxcor, rycor: integer;
				     { d and r stand for down and right, on the grid. }
		 
		 {_________________________________________________________________________}

		 procedure callerror(n: longint);
		    var i: integer;
				begin
				   if surplotting
					    then for i := 1 to squarenum do
											if q^.quad[i].q <> nil
												 then begin
																 q^.quad[i].q^.next := sides_garb;
																 sides_garb := q^.quad[i].q
															end;
						 
					 if surplotting
					    then begin
							        q^.next := quad_garb;
					            quad_garb := q
									 end;
					 error(n, token)
				end;

		 {________________________________________________________________________}
					 
		 procedure get_rs(x, y, z: longreal; var r, s: integer);
				begin
					 r := round(yfact1*y - xfact1*x);
					 s := - round(zfactor*z - (xfact2*x + yfact2*y))
				end;
				
		 {_________________________________________________________________________}

		 procedure update_sides(vertical: boolean);
		 
				begin           
					 if vertical
					    then if endrow
							        then q^.quad[squarenum].q^.right := penult
							        else begin
											        if q^.quad[squarenum].q = nil
																 then begin
																         newsides(q^.quad[squarenum].q);
																				 if squarenum > 1  { set next for free_obj }
																				    then q^.quad[squarenum].q^.next :=
																						     q^.quad[squarenum-1].q
														          end;
															q^.quad[squarenum].q^.left := penult;
															if col > 1
																 then q^.quad[squarenum-1].q^.right := penult
													 end
							else if endcol
							        then if shadeit
											        then shadequad(q^.quad[squarenum-numcols].q, true, false)
															else q^.quad[squarenum-numcols].q^.bottom := penult
											else begin
											        q^.quad[squarenum].q^.top := penult;
															if (row > 1)
																 then if shadeit
																         then shadequad(q^.quad[squarenum-numcols].q, true, false)
																				 else q^.quad[squarenum-numcols].q^.bottom := penult
													 end		   
		    end;
				
		{_________________________________________________________________________}
					
     begin

				{ Set up parameters for evaluation of the function. }
				squarenum := 0;
				size_locs := 0;
				param := surplot^.pars;
				if (param = nil) or (param^.next = nil)
					 then callerror(221);
				plotnum := nil;
				v[1] := nil;  v[2] := nil;
				loc := all_nil;
				loc_vals := all_val_nil;
				val[1] := nil; val[2] := nil;
				quoly_set_ext(initx, val[1]);
				quoly_set_ext(inity, val[2]);
				spec_setargs(param, flag, n, val, inf, v, loc);
				preset_stuff(surplot);
				for i := 1 to 15 do
				   if loc[i] <> nil
					    then begin
							        quoly_assign(loc[i]^.val, loc_vals[i]);
											size_locs := i
									 end;
				mytoken := token;
				if (v[1] = nil) or (v[2] = nil)
					 then callerror(218);
				if surplotting
				   then begin
					         newquad(q);
									 estnum := 2 + round(((finalx-initx)/incr + 1)*((finaly-inity)/incr + 1));
									 if (estnum < 0) or (estnum > maxquad)
										  then estnum := maxquad;
									 for i := 1 to estnum do
										  q^.quad[i].q := nil
								end;
				row := 1;
				col := 0;
				maxwidth := 0;
				numcols := -1;
				endcol := false;
				orientation := true;
				sqr_orient := true;
				
				wantpolygons := shadeit and not surplotting;
				{ if wantpolygons, marking must already be on. ```}
				if wantpolygons
				   then begin
					         new_worknode(dum, token);
			             arr := workhead[dum];
									 for i := 0 to 11 do
									    begin
											   arr^[i] := nil;
												 quoly_set(1, arr^[i])
											end
					      end;
								
				markit := (not wantpolygons) and (surplotting or marking); {```}
				zfactor := zscale*z_cosine;
				xfact1 := xscale*costheta;
				yfact1 := yscale*costheta;
				xfact2 := xscale*sintheta;
				yfact2 := yscale*sintheta;
				{ following set to 0 in case wantpolygons. }
				xcor := 0;
				dxcor := 0;
				rxcor := 0;
				ycor := 0;
				rycor := 0;
					 
				{ Plot the lines and create the object.  The lines are attached so that the
				  boundary of each little square forms an oriented cycle. }
				if surplotting
				   then set_marking_globals;
				x := @ v[1]^.val^.ncoef^.float;
				y := @ v[2]^.val^.ncoef^.float;
				repeat
				   { Locate the ground point for this row, upper left corner, of this square. }
					 quoly_set(0, plotnum);
					 oldrealflag := realflag;
					 eval_form(inf, surplot^.rht, plotnum);
					 if plotnum = nil
					    then quoly_set(0, plotnum);
					 realflag := oldrealflag;
					 exit_flag := false;
					 cycle_flag := false;
					 leave_flag := false;
					 if not plotnum^.numb
							then callerror(219);
					 zext := plotnum^.ncoef^.float;
					 xext := x^;
					 yext := y^;
					 if wantpolygons  {```}
					    then begin
							        arr^[0]^.ncoef^.float := xext;
							        arr^[1]^.ncoef^.float := yext;
											arr^[2]^.ncoef^.float := zext
							     end
							else get_rs(xext, yext, zext, xcor, ycor);
					 endrow := false;
					 
					 { finish this row. }
					 repeat    
							 if not endrow 
							    then begin 
									        Inc(squarenum);
													if (squarenum > maxquad) and surplotting
													   then callerror(241);
							            Inc(col)
											 end;

							 { Move to lower left. }
							 oldy := y^;
							 y^ := y^ + incr;
							 if (y^ > finaly) and not endcol
							    then y^ := finaly;
							 if not endcol
							    then begin
									       quoly_set(0, plotnum);
												 for i := 1 to size_locs do
													  quoly_assign(loc_vals[i], loc[i]^.val);
												 oldrealflag := realflag;
												 eval_form(inf, surplot^.rht, plotnum);
												 if plotnum = nil
					                  then quoly_set(0, plotnum);
												 realflag := oldrealflag;
												 exit_flag := false;
												 cycle_flag := false;
												 leave_flag := false;
												 if not plotnum^.numb
														then callerror(219);
												 zd := plotnum^.ncoef^.float;
												 if wantpolygons  {```}
														then begin
																		if x^ <> initx
																		   then begin
																			         arr^[6]^.ncoef^.float := x^;
																		           arr^[7]^.ncoef^.float := y^;
																		           arr^[8]^.ncoef^.float := zd;
																			         { store this poly. }
																							 fill_display_polyg(arr, 12, -1);
																							 { get ready for next. }
																							 arr^[0]^.ncoef^.float := arr^[9]^.ncoef^.float;
																		           arr^[1]^.ncoef^.float := arr^[10]^.ncoef^.float;
																		           arr^[2]^.ncoef^.float := arr^[11]^.ncoef^.float
																			      end;
																		arr^[3]^.ncoef^.float := x^;
																		arr^[4]^.ncoef^.float := y^;
																		arr^[5]^.ncoef^.float := zd
																 end
														else get_rs(x^, y^, zd, dxcor, dycor);
												 width := abs(xcor - dxcor);
												 if markit
												    then if sqr_orient
												            then attach_line(dxcor,dycor,xcor,ycor,x^,y^,zd,xext,yext,zext)
														        else attach_line(xcor,ycor,dxcor,dycor,xext,yext,zext,x^,y^,zd);
												 if surplotting
												    then update_sides(true)
														else if not wantpolygons
														        then begin
																						MoveTo(xcor, ycor);
																						LineTo(dxcor, dycor)
																				 end
											 end
									 else width := 0;
							 
							 { Move to upper right. }
							 x^ := x^ + incr;
							 if (x^ > finalx) and not endrow
							    then x^ := finalx;
							 if not endrow
							    then begin
									         y^ := oldy;
													 quoly_set(0, plotnum);
													 for i := 1 to size_locs do
													    quoly_assign(loc_vals[i], loc[i]^.val);
													 oldrealflag := realflag;
													 eval_form(inf, surplot^.rht, plotnum);
													 if plotnum = nil
					                    then quoly_set(0, plotnum);
													 realflag := oldrealflag;
													 exit_flag := false;
													 cycle_flag := false;
													 leave_flag := false;
													 if not plotnum^.numb
															then callerror(219);
													 zr := plotnum^.ncoef^.float;
													 if wantpolygons  {```}
														  then begin
																		  arr^[9]^.ncoef^.float := x^;
																		  arr^[10]^.ncoef^.float := y^;
																		  arr^[11]^.ncoef^.float := zr
																   end
														  else get_rs(x^, y^, zr, rxcor, rycor);
													 if markit
													    then if sqr_orient
													            then attach_line(xcor,ycor,rxcor,rycor,xext,yext,zext,x^,y^,zr)
															        else attach_line(rxcor,rycor,xcor,ycor,x^,y^,zr,xext,yext,zext);
													 if surplotting
													    then update_sides(false)
															else if not wantpolygons
															        then begin
																							MoveTo(xcor, ycor);
																							LineTo(rxcor, rycor)
																					 end;
													 width := width + abs(xcor - rxcor);
													 if width > maxwidth
													    then maxwidth := width;
													 
												   { Move on to next square. }
													 xcor := rxcor;  ycor := rycor;
													 xext := x^; yext := y^; zext := zr
											 end;
							 endrow := (x^ = finalx);
							 sqr_orient := not sqr_orient
					 until x^ > finalx;
					 
					 { Move on to next line. }
					 x^ := initx;
					 if numcols = -1
					    then numcols := col;
					 col := 0;
					 Inc(row);
					 orientation := not orientation;
					 sqr_orient := orientation;
					 endcol := (y^ = finaly);
					 if command_int 
			        then check_cmd_keys;
					 for i := 1 to size_locs do
							quoly_assign(loc_vals[i], loc[i]^.val)
				until y^ > finaly;
				
		    epilog(surplot);
				for i := 1 to size_locs do
					 free_quoly(loc_vals[i]);
				
				token := mytoken;
				if wantpolygons
				   then begin
					         for i := 0 to 11 do
									    free_quoly(arr^[i]);
									 free_work
					      end;
				if surplotting
				   then begin
					         insert_object(graphname, itsarray, false, ind, ob);
									 ob^.quads := q
								end
					 else exit {(surface_plot)};
					 
				squarenum := squarenum - numcols;
				ob^.init := squarenum;
				ob^.shaded := shadeit;
				
				if flag = nil
				   then begin
					         writeln(userOutput, ' Computing hidden lines...');
									 flush(userOutput)
								end;
				setkeys(q, squarenum, width);
				sort_quads(q, squarenum);
				
				line := ob^.line;
				while line <> nil do
				   begin
					    hide_line(line, q, squarenum, maxwidth);
							line := line^.next;
							if command_int 
								 then check_cmd_keys
					 end;
				
	      show_lines(ob^.line)
					 
	   end;
	
 {**************************************************************************}

 procedure expon_form(var inf: text; var n: number; var flag: nameptr; count: longint);

    { n is real }
		
		var n2: quoly;
		    n3, n4: number;
        exponent: longint;
				oldtok: tokentipe;

    begin
		  oldtok := token;
			n3.size := 0;  
			n3.imag := nil; 
      scanner(inf, token, flag);
			if (token.name = '+') and (oldtok.name = 'e')
			   then scanner(inf, token, flag);
      if (token.name <> '-') and ((token.name[1] < '0') or (token.name[1] > '9'))
         then if oldtok.name = 'e'
				         then error(35, token)
							   else error(68, token);
      n2 := nil;
      if oldtok.name = 'e'
			   then begin
				        old_fact(inf, n2, flag);
								if not n2^.numb
								   then begin
									         free_quoly(n2);
													 error(115, esign)
												end
								   else quoly_to_scalar(n2, n3);
								free_quoly(n2);
								if n3.imag <> nil
								   then error(35, esign);
				        if abs(n3.float) >= 4932
									 then error(36, token);
			          exponent := round(n3.float);
                n3.float := exp(log_of_10*abs(count - exponent));  {@@@}
		          	if count <= exponent
			             then n.float := n.float * n3.float
				           else n.float := n.float / n3.float
							end
				 else begin  { oldtok.name = '.' }
				        if (token.name = '-')
								   then error(68, token);
								n4.size := 0;  
			          n4.imag := nil; 
				        new_readin(inf, n4, flag, count);
								n3.float := exp(log_of_10*count); {@@@}
								n4.float := n4.float / n3.float;
								n.float := n.float + n4.float;
								if token.name = 'e'
								   then expon_form(inf, n, flag, 0)
						  end
			
    end;

  {***************************************************************************}
	
	 procedure get_arr_arr(var inf: text; var n: quoly; var flag: nameptr; var m: longint);
	
			begin
		     scanner(inf, token, flag);
				 if token.name <> '['
						then error(244, token);
				 scanner(inf, token, flag);
				 old_expre(inf, n, flag);
				 if token.name <> ']'
						then error(245, token);
				 if not n^.numb
						then error(246, token);
				 m := quoly_convert_to_int(n) - addresser;
				 if (m < 0) or (m > arrstashsize-1)
						then error(248, token)
			end;
															 
  {*************************************************************************}
	
	procedure complex_abs(var n: number; flag: boolean);
	
	  begin
		
			if n.imag = nil
				 then if flag
								 then n.float := abs(n.float)
								 else n.float := sqr(n.float)
				 else begin
								 n.float := sqr(n.float) + sqr(n.imag^.float);
								 if flag 
								    then n.float := sqrt(n.float);
								 n.imag^.imag := imhead;
								 imhead := n.imag;
								 n.imag := nil
							end
							
		 end;
																	 																	 
  {****************************************************************************}
	
	procedure poly_abs(p:ferm118.poly; flag: boolean);
 
    begin
	   
			 while p <> nil do
					begin
						 if p^.numb
								then complex_abs(p^.ncoef^, flag)
								else poly_abs(p^.pcoef, flag);
						 p := p^.next
					end
		  
	  end;
	
  {*****************************************************************************}

  procedure quoly_abs; {(q:quoly; flag: boolean)}
	
    begin
		
		   if q^.numb
			    then complex_abs(q^.ncoef^, flag)
			 else begin
			         poly_abs(q^.numer, flag);
							 if q^.denom <> nil
							    then begin 
									        poly_abs(q^.denom, flag);													
													check_quoly(q, false)  
											 end; 
							 if q^.numer^.numb and (q^.numer^.next = nil) and (q^.denom = nil)
							    then polynum_to_quoly(q)
						end
						
		end;
						
 {*************************************************************************}
 
  procedure poly_readin(var inf: text; var p: ferm118.poly; var flag: nameptr;
	                      var depth: longint);
												
		 {   Pass back depth = poly_depth of poly p.  This is the depth of the first
		   poly var encountered. prev_depth = depth of last poly var encountered as
			 the process of attaching goes on.
			   If p is not nil upon entry, it and depth describe the first coefficient,
			 already determinded elsewhere.
			   No zeros allowed anywhere!  }
	   
		 var this_depth, expon, this_exp, prev_depth: longint;
		     m: number;
				 q,t,r: ferm118.poly;
				 qq: quoly;
				 same_t_q, need_var: boolean;
				 
		 {_______________________________________________________________}
				 
		 procedure free_stuff(n: longint);
		 
		    begin
				
				   free_quoly(qq);
					 free_poly(p);
					 if q <> nil
					    then begin
							        t^.next := nil;
											free_poly(q)
									 end;
					 error(n, token)
					 
				end;
				
		{__________________________________________________________________}
		 
		 procedure stripoff(var p: ferm118.poly; n: longint);		 
		    var i: integer;				
				begin				
				   for i := 1 to n do
					    begin
								 p^.next := polygarb;
								 polygarb := p;
								 p := p^.pcoef
							end							
			  end;
				
		 {__________________________________________________________________}
		 
		 procedure get_fact(var p: ferm118.poly);
		 
		    begin				
				   old_fact(inf, qq, flag);
					 free_poly(p);
					 quoly_to_poly(qq, p)					 
				end;
																						
		 {__________________________________________________________________}
		 
		 function get_constant(var p: ferm118.poly) : boolean;
		 
		    { Read in a constant, including possibilty of complex constants.
				  minor space loss: p and r are not freed after some errors here. 
				  Check is set when a  b is read.}
		 
		    var r: ferm118.poly;
		 
		    {----------------------------------------------------------------}
		 
		    function get_one_cons(var p: ferm118.poly) : boolean;

				   { readin digits to form constant. }
					 
					 var dumm: longint;
				
				   begin
					    get_one_cons := true;
					    new_readin(inf, m, flag, dumm);
              if (token.name = 'e') or (token.name = '.')
                 then expon_form(inf, m, flag, dumm);
					    scalar_to_poly(m, p);
					    if poly_iszero(p)
							   then if q = nil
								         then begin
                          get_one_cons := false;
                          exit {(poly_readin)}
                         end
												 else free_stuff(163);
					    m.size := 0;  m.imag := nil;
					    if token.name = '/'
							   then free_stuff(164);
							if poly_iszero(p)
							   then free_stuff(163);
								
					 end;
					 
				{-----------------------------------------------------------------}
		   
			  begin { of get_constant }
					 get_constant := true;
					 r := nil;
           if (token.name[1] >= '0') and (token.name[1] <= '9')
              then begin
                if not get_one_cons(p)
                  then begin
                    get_constant := false;
                    exit {poly_readin}
                  end
                end
					    else if token.name = ''
							        then get_fact(p);
					 if token.name = ''
							then if complex
											then begin
															get_fact(r);
															poly_mult(p, r, p, nilpol);
															free_poly(r)
													 end
											else free_stuff(167)
					 							
				end;
				
		 {____________________________________________________________________}
												 												
		 procedure first_node(var q: ferm118.poly);
		 
		    var i: longint;
				
				begin
				
				  if poly_depth(p) <= this_depth
						 then free_stuff(159);
					base_poly(q, this_depth);
					r := q;
					for i := 1 to this_depth - 1 do
						 r := r^.pcoef;
					r^.exp := this_exp;
					free_poly(r^.pcoef);
					if not p^.numb
						 then stripoff(p, this_depth);
					r^.pcoef := p;
					t := r
					 
				end;
				
		 {______________________________________________________________________}
		 
		 procedure attach_to_poly;
		 
		    { Attach poly p as coefficient to var 'this_depth' with exponent
				  'this_exp'.  expon = latest exponent seen. prev_depth = latest depth seen.
					Note well: p's storage is absorbed into the poly q being built up! }
					
				var r: ferm118.poly;
		 
		    {----------------------------------------------------------------}
				
				procedure standard_attach;
				
				   var i: longint;
					 
					 begin
					 
							newpoly(t^.next);
							t := t^.next;
							t^.numb := false;
							if this_depth = prev_depth
								 then begin
												 t^.exp := this_exp;																 
												 if not p^.numb
														then stripoff(p, this_depth);
												 t^.pcoef := p
											end
								 else begin
												 t^.exp := 0;
												 t^.next := nil;
												 t^.pcoef := nil;
												 base_poly(t^.pcoef, this_depth - prev_depth);
												 r := t;
												 for i := 1 to this_depth - prev_depth do
														r := r^.pcoef;
												 r^.exp := this_exp;
												 free_poly(r^.pcoef);
												 if not p^.numb
														then stripoff(p, this_depth);
												 r^.pcoef := p;
												 t := r
											end

				   end;
					 
				{------------------------------------------------------------------}
																
				begin
				
					 if q = nil  { first node }
							then if this_depth = halfblock { p must be number }
											then begin
															q := p;
															t := q;
															depth := halfblock
									         end
										  else begin { a poly var was given }
											        first_node(q);
															depth := this_depth
									         end
						  else if this_depth = halfblock { p must be number }
											then if t^.numb
											        then begin
															        t^.next := nil;
																			if poly_iszero(t)
																			   then free_stuff(163);
																			same_t_q := (q = t);
																			best_poly_add(t, p, t);
																			if same_t_q
																			   then q := t;
																			p := nil; 
																			if poly_iszero(t)
																			   then free_stuff(163)
															     end
															else begin
																			t^.next := p;
																			t := p 
																	 end
							else begin
											if poly_depth(p) <= this_depth
												 then free_stuff(159);
                      if node_iszero(t)
												 then free_stuff(163);
                      standard_attach
									 end;
									 
					 expon := this_exp;
					 prev_depth := this_depth
															
		    end;
				
		 {______________________________________________________________________}
		 
		 function leading_exp(p: ferm118.poly): longint;
			  begin
					 while (p^.exp = 0) and not p^.numb do
						  p := p^.pcoef;
					 leading_exp := p^.exp
			  end;

		 {______________________________________________________________________}

		 procedure finish_laurent;

		    var q2: ferm118.poly;
						next_depth: longint;

				begin

					t^.next := nil;
					q2 := nil;
					first_node(q2);
					p := nil;
					if (token.name = '+') or (token.name = '-')
					   then begin
						         if token.name = '+'
										    then scanner(inf, token, flag);
										 poly_readin(inf, p, flag, next_depth);
										 if next_depth > this_depth
											  then free_stuff(159)
										 else if (next_depth < this_depth) and (leading_exp(p) >= 0)
														 then free_stuff(159)
										 else if next_depth = this_depth
														 then if leading_exp(p) >= this_exp
																		 then free_stuff(159)
								  end;
					best_poly_add(q, q2, q);
					if this_depth < depth
					   then depth := this_depth;
					if p <> nil
					   then begin
						         best_poly_add(p, q, p);
										 if next_depth < depth
					              then depth := next_depth
									end
						 else p := q;
					{wwh exit(poly_readin)}

			  end;

	  {___________________________________________________________________}

		 function get_var_and_expon(mustbe: boolean) : boolean;

			  { Figure out this_depth and this_exp, to describe this term. }

				procedure getit;
					 begin
							new_readin(inf, m, flag, this_exp);
							this_exp := convert_to_int(m);
							imag_free(m);
							if this_exp = 0
								 then free_stuff(204)
					 end;

				begin
           get_var_and_expon := false;
					 if (token.name[1] >= 'a') and (token.name[1] <= 'z')
							then if is_poly_name(token.name, this_depth)
											then begin
															scanner(inf, token, flag);
															if token.name = '^'
																 then begin
																				 scanner(inf, token, flag);
																				 if (token.name[1] >= '0') and (token.name[1] <= '9')
																						then getit
																				 else if (token.name = '-') 
																								 then if laurent
																												 then begin
																																 scanner(inf, token, flag);
																																 if (token.name[1] >= '0') and (token.name[1] <= '9')
																																		then getit
																																		else free_stuff(162);
																																 this_exp := - this_exp
																															end
																												 else free_stuff(165)
																				 else free_stuff(162)
																			end
																 else this_exp := 1
													 end
											else free_stuff(160)
							else if mustbe
											then free_stuff(161)
											else begin
															 this_exp := 0;
															 if this_depth = -1  { was not set yet }
																	then this_depth := halfblock;  { 'infinity' }
															 if (expon = 0) and (q <> nil)  
																						 { Two numbers in a row is ok. 
																							 Don't do following error checks }
																	then exit {(get_var_and_expon)}
													 end;
													 
					 if q = nil { first node }
							then { no error }
							else if this_depth < prev_depth
											then if this_exp < 0
															then begin
                                finish_laurent;
                                get_var_and_expon := true;
                              end
															else free_stuff(159)
											else if (this_depth = prev_depth) and (this_exp >= expon)
															then free_stuff(159)
											else if (expon < 0) and (this_depth > prev_depth) 
															then free_stuff(159)
															
				end;
				
     {____________________________________________________________________}
				 
		 procedure read_parenth;
		 
		    begin		 
						scanner(inf, token, flag);
						poly_readin(inf, p, flag, this_depth);  { don't really use this_depth here }
						if poly_iszero(p)
							 then free_stuff(163);
						if token.name <> ')'
							 then free_stuff(1)
							 else scanner(inf, token, flag)							 
			  end;
												 
		 {____________________________________________________________________}
				 
		 function get_the_coef(var need: boolean) : boolean;    

		    { need means must have poly var following this coeff. }

		    begin
           get_the_coef := true;
					 case token.name[1] of

					    '(': begin
							        read_parenth;
											need := false
									 end;
							'': begin
							        get_fact(p);
											if poly_iszero(p)
											   then free_stuff(163);
											need := false 
									 end;
							'': begin
							        if not get_constant(p)
                        then begin
                          get_the_coef := false;
                          exit
                        end;
											if poly_iszero(p)
											   then free_stuff(163);
											need := false
									 end;
							'-': begin
							        scanner(inf, token, flag);
							        get_the_coef(need);
											poly_inplace(p)
									 end;
							else 
							   begin
							      if (token.name[1] >= '0') and (token.name[1] <= '9')
                       then begin
                               if not get_constant(p)
                                then begin
                                  get_the_coef := false;
                                  exit
                                end;
															 need := false
													  end
									     else begin
									             poly_set(1, p);
															 need := true
												    end
								 end
					 end;

							
				end;
				
		 {_______________________________________________________________________}
		 
	   begin  { of poly_readin }
		 				
				q := nil;  { used to build up answer. t points to end node of answer.}
				r := nil;
				qq := nil;  { a quoly }
				m.size := 0;  m.imag := nil;

				repeat
					    
					{ For each term, get the coefficient p. Get the poly var and exponent,
						this_depth and this_exp.  If no error, attach them to previous node. 
						expon and prev_depth describe the last node attached, except on very
						first entry to this loop. }
					 				
					 this_depth := -1;  { I'm not sure we need this anymore. 2/91 }
					 
					 if p = nil  { almost always true }
					    then if get_the_coef(need_var) then exit
							else begin  { p and depth are the first coef. }
							        if poly_iszero(p)
							           then free_stuff(163);
											need_var := true;
											this_depth := depth
									 end;
					 if get_var_and_expon(need_var) then exit;
					 attach_to_poly;
					 
					 p := nil;
					 if token.name = '+'
					    then scanner(inf, token, flag)
					 else if token.name = '-'
					    then { nothing }
					 else break

				until false;
				
				p := q;
				t^.next := nil;
				free_quoly(qq)
																		
		 end;
		 
	{******************************************************************************}
	
	procedure quoly_readin(var inf: text; var p: quoly; var flag: nameptr; 
	                       var depth: longint);
												 
		 var parenth: boolean;
		     dumm: longint;
												 
		 begin
		 
		    free_quoly(p);
				newquoly(p);
				p^.numb := false;
				p^.numer := nil;
				p^.denom := nil;
				
				{ Opening parenthesis means either parens enclose numerator of quoly, or
				  a poly happens to start with parens, like (u+1)w. }
				parenth := (token.name = '(');
				if parenth
				   then scanner(inf, token, flag);
				poly_readin(inf, p^.numer, flag, depth);
 				if parenth
				   then begin
					         if token.name <> ')'
									    then error(1, token);
									 scanner(inf, token, flag);
									 if is_poly_name(token.name, dumm)  { continue. p^.numer and depth 
									                                      are now input. }
									    then poly_readin(inf, p^.numer, flag, depth);
								end;
				if token.name = '/'
				   then begin
					         if poly_iszero(p^.numer)
									    then error(164, quotsign);
					         scanner(inf, token, flag);
									 parenth := (token.name = '(');
				           if parenth
				              then scanner(inf, token, flag);
									 poly_readin(inf, p^.denom, flag, depth);
									 if parenth
				              then begin
					                    if token.name <> ')'
									               then begin
																         free_quoly(p);
																				 error(1, token)
																			end;
									            scanner(inf, token, flag);
															if is_poly_name(token.name, dumm)  
									               then poly_readin(inf, p^.denom, flag, depth);
								           end;
									 total_poly_modout(p^.numer);
									 total_poly_modout(p^.denom);
									 if poly_iszero(p^.denom)
									    then error(22, quotsign);
									 if poly_iszero(p^.numer)
									    then begin
											        quoly_set(0, p);
															exit {(quoly_readin)}
													 end;
									 check_quoly(p, true);  { true ok. 11/94 }
								end
					 else total_poly_modout(p^.numer);
					 
				if p^.numer^.numb and (p^.numer^.next = nil) and (p^.denom = nil)
					 then polynum_to_quoly(p)
									 
		 end;
		 
  {*********************************************************************
	
  COMMENT NOW
	
	procedure trig(x: nametype;  var n, n2, n3: number);

    var w: longreal;

    begin    of trig 
		
      case x[1] of
				'`','"': begin
										n3.float := cos(n.float);  don't interchange these!
										n2.float := sin(n.float);
										if (n2.float * n3.float <> 0)
											 then begin
															w := abs(n3.float/n2.float);
															if w > 1e18
																 then n2.float := 0
															   else if w < 1e-18
																      then n3.float := 0
														end
								 end;
				'%': n2.float := tan(n.float)
			end
						
	  end;
							
  *************************************************************************}
	
	procedure complex_log(var n, n2: number);
	
	  { assumes n and n2 are distinct. }
		
	   var n3: longreal;
				 remove: boolean;
		 
		 begin
		 
				if ferm118.iszero(n) 
					 then error(91, logsign);
				if (n.imag = nil) and (n.float < 0)
				   then begin
					         n2.float := ln(-n.float);
									 if n2.imag = nil
									    then newimag(n2.imag);
									 n2.imag^.float := pii.float;
									 exit {(complex_log)}
								end;
				
				complex_assign(n, n2);
			  complex_abs(n2, false);
				n2.float := ln(n2.float)/2;
				
				{ set n3 equal to -n.imag }
				if n.imag = nil
				   then begin
									 setimag(0, n);  { Danger: an illegal imag part. Must remove before
									                   an error can occur. }
									 n3 := 0;
									 remove := true
								end 
					 else begin
					         n3 := -n.imag^.float;
									 remove := false
								end;
				
				{ Compute n3 = the argument of the log of n.  Use arctan directly if the 
				  complex number n has argument between /4 and -/4, otherwise flip accordingly. }
				if (n.float >= n.imag^.float) and (n.float >= n3)  { illegal imag treated here. n <> 0. }
					 then n3 := arctan(n.imag^.float / n.float)
				else if (n.float <= n.imag^.float) and (n.float <= n3)  { illegal imag treated here. n <> 0. }
					 then if n.imag^.float > 0
									 then n3 := arctan(n.imag^.float / n.float) + pii.float 
									 else n3 := arctan(n.imag^.float / n.float) - pii.float
				else begin
							  n3 := arctan(n.float / n.imag^.float);
							  if n.imag^.float < 0
									 then n3 := -pii.float/2 - n3
									 else n3 := pii.float/2 - n3
						 end;				
					 
				if remove
				   then imag_free(n);  { Remove the illegal imag part. quick!!}
									 
				if n3 = 0  { n3.imag = nil at this point }
					 then imag_free(n2)
					 else begin
									 if n2.imag = nil
									    then newimag(n2.imag);
									 n2.imag^.float := n3
							  end
				
		end;

	{************************************************************************}

  procedure complex_expon(var n: number);

    var n2, n3: longreal;
		 
    begin
		 
			n.float := exp(n.float);
			if n.imag <> nil
				 then begin
							   n2 := sin(n.imag^.float);
							   n3 := cos(n.imag^.float);  {@@@}
								 if n2 = 0  
								    then imag_free(n)
										else n.imag^.float := n2 * n.float;
								 n.float := n3 * n.float
							end
			
	 end;
	 
	{**************************************************************************}
	
	procedure get_exponent(var inf: text; var flag: nameptr; var m2: number);
	
	   { m2^.imag never touched. }
	
	   var n2: quoly;
		 
		 begin
		 		    
				scanner(inf, token, flag);
				n2 := nil;
				old_fact(inf, n2, flag);
				if not n2^.numb
					 then begin
									 free_quoly(n2);
									 error(116, expsign)
								end;
				m2.float := n2^.ncoef^.float;
				free_quoly(n2)
				
		 end;
		 
 {**************************************************************************}	
 
 procedure get_coef(n: ferm118.poly; var ans: ferm118.poly; var inf: text; var flag: nameptr);
 
    { n is input and ans is output. Sink into the poly n recursively. Changed Dec 1994
		  to cooperate with quoly_get_coef not wasting time copying storage.  
			   token.name is ',' on entry unless user wanted leading coefficient.
				 ans must be nil on entry. 
				 n may become nil along the way. Must keep going to read all the coefficients
			the user has given. 
			   Read the comments on get_quoly.
				 Very delicate! ```}
 
    var n2: ferm118.poly;
		    q: quoly;
				expont: longint;
	
		procedure pad;	   
			 begin
				  newpoly(n2);
				  n2^.exp := 0;
				  n2^.numb := false;
				  n2^.next := nil;
				  n2^.pcoef := ans;
				  ans := n2
			 end;
	
	  begin
	
       if token.name = ','
					then begin
					        { read next desired exponent }
								  scanner(inf, token, flag);
								  q := nil;
								  old_expre(inf, q, flag);
								  if q^.numb
										 then expont := quoly_convert_to_int(q)
										 else begin
														 free_quoly(q);
														 error(155, token)
												  end;
								  if expont = neg_two_to_31
										 then error(156, token);
								  free_quoly(q)
					     end
					else { only possible if user wanted leading coefficient. }
					     expont := n^.exp;
			 									
			 { search for expont in the poly n }
			 while n <> nil do
					if n^.exp > expont
						 then n := n^.next
						 else break;
			 
			 if n = nil
					then { nothing }
			    else if n^.exp < expont
							    then n := nil;  { signal end of sinking }
						
			 if token.name = ','
					then if n = nil
					        then get_coef(n, ans, inf, flag)  { ans must become 0 }
							    else if n^.numb
													then begin
													        { sneaky!  Beware Laurents! }
																	n2 := n^.next;
																	n^.next := nil;
																	get_coef(n, ans, inf, flag);
																	{ ans must be genuine number }
																	n^.next := n2
															 end
											    else begin
													        get_coef(n^.pcoef, ans, inf, flag);
													        if not ans^.numb or (ans^.next <> nil)
					                           then pad
															 end
					else if n = nil
					        then poly_set(0, ans)
									else if n^.numb
									        then begin
													        { sneaky!  Beware Laurents! }
																	newpoly(ans);
																	with ans^ do
																	   begin
																		    exp := 0;
																				numb := true;
																				next := nil;
																		    newimag(ncoef);
																				ncoef^.imag := nil;
																				ncoef^.size := 0  { necessary? }
																		 end;
																	complex_assign(n^.ncoef^, ans^.ncoef^)
															 end
													else begin
																	poly_assign(n^.pcoef, ans);
			                            if not ans^.numb or (ans^.next <> nil)
					                           then pad
															 end
			  
	  end;

 {****************************************************************************}

 procedure quoly_get_coef(var inf: text; var n: quoly; var flag: nameptr);
 
    { n is initially read only!  Somebody else is pointing to n^.  Changed 
		  December 1994. 
			   Read the comments on get_quoly.  ```}
		
		var p2, p3: ferm118.poly;

    begin
	
	    p3 := nil;
			if n^.numb
				 then begin
								 newpoly(p2);
								 p2^.next := nil;
								 p2^.exp := 0;
								 p2^.numb := true;
								 p2^.ncoef := n^.ncoef;
								 get_coef(p2, p3, inf, flag);
								 p2^.next := polygarb;
								 polygarb := p2;
								 poly_consume(p3, n)
							end
				 else begin
								 get_coef(n^.numer, p3, inf, flag);
								 newquoly(n);
								 if p3^.numb and (p3^.next = nil)
									  then begin
													  n^.numb := true;
													  n^.ncoef := p3^.ncoef;
														p3^.next := polygarb;
								            polygarb := p3
												 end
									  else begin
													  n^.denom := nil;
													  n^.numb := false;
													  n^.numer := p3
												 end
						  end
			
     end;
		  		   
  {**************************************************************************}
	
  procedure ifact(var lp: floatptr; var n: longreal; var flag: nameptr); forward;  
                  { Nov 1997 }
	
  {*********************************************************************}

  procedure ievalcoords(var r, c: longint; var flag: nameptr; var c_is_there: boolean);

    var x: longreal;
		
		begin
		
			old_iexpre(x, flag);
			r := round(x);
      c := addresser;
      if token.name = ','
        then begin
								flag := flag^.next;         
								token := flag^.let;
								old_iexpre(x, flag);
								c := round(x);
							  c_is_there := true
						 end
				else c_is_there := false;
      if (token.name <> ']')
         then error(61, token)
				
    end;
		
 {*************************************************************************}

  procedure evalcoords(var inf: text; var r, c: longint; var flag: nameptr; 
	                     ending, separator: char; var c_is_there: boolean);

    var p: quoly;
	
    begin
		
	    p := nil;
			if (token.name = separator) and (separator = '')
			   then r := addresser
      else begin
			        old_expre(inf, p, flag); { Nov 1997 }
							if not p^.numb
				         then begin
								         free_quoly(p);
								         error(118, token)
					            end;
			        r := convert_to_int(p^.ncoef^);
							free_quoly(p)
					 end;
      c := addresser;
			c_is_there := false;
      if token.name = separator
        then
          begin
            scanner(inf, token, flag);
            if (separator = '') and ( (token.name = ',') or (token.name = ']') ) 
						   then c := -1  { subarray will set second row coord. to number of rows }
							 else begin
							         old_expre(inf, p, flag); { Nov 1997 }
											 if not p^.numb
											    then begin
													         free_quoly(p);
																	 error(118, token)
															 end;
											 c := convert_to_int(p^.ncoef^);
											 free_quoly(p);
						           c_is_there := true
                   end
					end;
      if (token.name <> ending) and (token.name <> ']')
        then error(61, token)
				
    end;
		
 {******************************************************************************}
 
 procedure new_array_quoly_ptr(q: arrptr; var r,c: longint; colflag: boolean; var qp: quolyptr;
                               var x: tokentipe; var aux: colm_ptrptr);
	
	  {   Nov 1997:  New version of array_quoly_ptr to accomodate new grammar.  Output
	    aux is for the sparse case, in which case it is never nil. (For ordinary array, aux = nil). 
	    aux^ might be nil, but that doesn't matter.  Some caller may use aux to attach a new 
	    node to the array at spot (r,c). 
	      Dec 1997:  changed r,c to var params -- it's c that counts. }
			
		var sp: sparseptr;
				i: longint;
				t: colm_ptrptr;
		
		begin
		
      r := r - addresser;
			c := c - addresser;
			if (r < 0) or (c < 0)
         then error(27, x);
				
			if colflag and (r > q^.rows - 1)
			   then error(27, x);
      if q^.spar = nil { ordinary array; don't need new stuff for new grammar }
				 then begin
								 c := q^.start + r + c * q^.rows;
								 if (c < q^.start) or (c > q^.stop)
										then error(27, x);
								 qp := @ arp[c shr 10]^[c and tenmask];
								 { qp <> nil but qp^ might be }
								 aux := nil
							end
				 else begin
								 if colflag
								    then Inc(c)
										else begin
										        c := 1 + r div q^.rows;
								            r := r mod q^.rows  
								         end;
								 if c > q^.size div q^.rows
								    then error(27, x);
								 sp := q^.spar;  
				         for i := 1 to r div sparsesize do
								    sp := sp^.next;
				         t := @ sp^.indx[1 + r mod sparsesize];
				         aux := t;
								 while t^ <> nil do
										if t^^.coord >= c  
											 then break
											 else t := @ t^^.next;
								 if t^ = nil
										then qp := nil
										else if t^^.coord > c
										        then qp := nil
										        else qp := @ t^^.val
								 { aux <> nil. aux^ might be nil. qp might be nil. }
							end

		 end;
							
	{***********************************************************************}

  procedure spec_arretrieve(var inf: text; var flag: nameptr; q: arrptr; var qp: 
                            quolyptr; var t: colm_ptrptr; var colpos: longint);

    { only used for .  changed Nov 1997 }  
		
		var r, c: longint;
			  colflag: boolean;  { is a second coordinate present? }
				
    begin
		
      scanner(inf, token, flag);
      evalcoords(inf, r, c, flag, ']', ',', colflag);
      scanner(inf, token, flag);
			
      new_array_quoly_ptr(q, r, c, colflag, qp, arr_arrsign, t);  { sets t, c, and qp }
      colpos := c;  { Dec 1997 }
      if qp <> nil  { qp = nil means sparse array, entry not there; i.e. it's 0 }
			   then if qp^ = nil
							   then begin
											   writeln(userOutput, 'Warning. Uninitialized array element in .');
											   writeln(userOutput, '  Will assign 0.');
											   quoly_set(0, qp^)
										  end
										  
    end;

	{**************************************************************************}

	procedure basic_form(var q: condexptr; var comm: comptr; endflag: nametype;
	                     var inf: text; var flag: nameptr; var once_more: boolean;
											 var realtok: tokentipe);
											 
		{ Nov 1997.  endflag can now be 'elfi*' to accomodate new function syntax. }

		var lastcom: comptr;
				first_mate, second_mate: nametype;  { Nov 1997 }
				its_a_loop, forloop: boolean;
		
		{__________________________________________________________________}
				
		procedure comment(var lastcom: comptr);
			
			 var lastq: nameptr;
					 eolnseen: boolean;
		
			 begin

					lastq := nil;
					if lastcom = nil
						 then begin
										 new(comm);  {@@@}
										 lastcom := comm  { com is parameter to basic_form. }
									end
						 else begin
										 new(lastcom^.next);  {@@@}
										 lastcom := lastcom^.next
									end;
					dumbscanner(inf, token, flag, eolnseen);
					while token.name <> '}' do
						 begin
								if lastq = nil
									 then begin
													 newname(lastcom^.q);  {@@@}
													 lastq := lastcom^.q
												end
									 else begin
													 newname(lastq^.next);  {@@@}
													 lastq := lastq^.next
												end;
								lastq^.let := token;
								if eolnseen
									 then writeln(userOutput, ' Warning. End of line encountered inside a comment.');
								dumbscanner(inf, token, flag, eolnseen)
						 end;
						 
					if lastq <> nil
						 then lastq^.next := nil
						 else lastcom^.q := nil;
						 
					scanner(inf, token, flag)

			 end;
				 
		{____________________________________________________________________}

		procedure attach(var q: nameptr; endflag: nametype);

			var last: nameptr;
					count, func_count: longint;
					in_func, maybe_in_func, ok, last_one, literal, maybe_more,
						 digit_seen, in_comment: boolean;

			{_________________________________________________________}

			procedure insertval(var front, tail, flag: nameptr);

					var endline: boolean;
	
					begin { Nov 1997. simplified at last }
					
						if not maybe_more
							 then newname(front);
						literal := not ( literal = (token.name = ''''));
						if not maybe_more
							 then begin
											 tail := front;
											 if forloop
											    then if token.name = 'to'
															    then token.name := ' to'
															 else if token.name = 'by'
															    then token.name := ' by';  { Dec 1997, delete 'from' }
											 if (token.name[1] >= 'a') and (token.name[1] <= 'z')
													then token.address := hash(token.name, 151)
											 else if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
													then token.address := hash(token.name, 71);
											 tail^.let := token
									 end;
						if literal or in_comment
							 then begin
											 dumbscanner(inf, token, flag, endline);
											 if endline
													then writeln(userOutput, ' Warning. End of line encountered inside a literal.')
										end
							 else begin
							         if leftover = ' '
							            then tail^.space := true;  { Dec 1997 }
							         scanner(inf, token, flag)
							      end
	
					end;

			{______________________________________________________________________}

			function funcstart: boolean;   { Nov 1997 }
			   begin
			      funcstart := (token.name = 'Function') or (token.name = 'Func')
			   end;
			   
			{______________________________________________________________________}
			
			function mate(x: tokentipe; flag: nametype): boolean;
         { flag could be 'elfi*', Nov 1997 }
				 begin
						if flag = '.'
							 then mate := (x.name = 'Function') or (x.name = 'Func') { Nov 1997 }
						else if flag = ')'
										then mate := (x.name = '(')
						else if flag = '>'
										then mate := (x.name = '<')
						else if flag = ']'
										then mate := (x.name = '[')
						else if flag = 'od'
										then mate := (x.name = 'do')						
						else if (flag = 'elfi*') or (flag = 'fi')
						        then mate := (x.name = 'if')
						else mate := false
				 end;

			{_________________________________________________________________}
							
			function found_endflag: boolean;   { Nov 1997 }
			   begin
			      if token.name = endflag
			         then found_endflag := true
			      else if endflag = 'elfi*'
			         then found_endflag := (token.name = 'fi') or 
			                               ((token.name = 'else') and (count = 1))
			      else found_endflag := false
			   end;
			   
			{_________________________________________________________________}
			
			procedure store_char(x: char);  { Nov 1997 }
				 begin
						newname(last^.next);
						last := last^.next;
						last^.let.name := x;
						last^.let.address := -1
				 end;
				 
			{__________________________________________________________________}
				 
			begin { of attach }
									{ The first unmated endflag marks the end.  So does the
										first semicolon not in an enclosed function def. }
									{ Modified so that decimal constants can be in function
										definitions. use maybe_more and digit_seen }
				count := 1; { count the matings }
				newname(q);
				last := q;
				last^.next := nil;
				func_count := 0; { count levels of internal function nestings }
				ok := true;
				literal := false;  { used by insertval }
				maybe_more := false;
				in_comment := false;  { needed in case a function defines a function 
																which has a comment }
				maybe_in_func := false;
				if mate(token, endflag)
					then Inc(count);
				last_one := (endflag = '.') and funcstart;  { Nov 1997 }
				
				if forloop  { Nov 1997. new way to mark for-loops, at start of condition only }
				   then store_char(':');
				
			 { 'Count' counts the number of endflags seen, adjusted for pairings with
					'mate'.  'func_count' counts the number of function definitions 
					seen and 'in'. }
				digit_seen := (token.name[1] >= '0') and (token.name[1] <= '9');
				maybe_in_func := funcstart;  { Nov 1997 }
				while (count > 0) and ok do
					 begin 
							 insertval(last^.next, last, flag);
							 { insertval calls scanner, changes last, allocates new nodes. }
							 if (token.name = '{') and not literal
									then in_comment := true;
							 if (token.name = '}') and in_comment
									then in_comment := false;
							 if (not literal) and (not in_comment)
											then begin
														 if maybe_more
																then if (token.name[1] < '0') or (token.name[1] > '9')
																				then begin
																								{ Do what you should have before
																									for the period. }
																								func_count := func_count - 1;
																								count := count - 1;
																								if func_count < 0 then break;
																								store_char('.')
																						 end
																				else store_char('.');
														 maybe_more := false;
														 if found_endflag  { Nov 1997 }
																then if digit_seen and (endflag = '.')
																			  then maybe_more := true
																			  else count := count - 1
																else if mate(token, endflag)
																			  then Inc(count);
														 digit_seen := (token.name[1] >= '0') and (token.name[1] <= '9');
														 if last_one and ((token.name[1] < 'A') or (token.name[1] > 'Z')) 
																then count := count - 1;
														 last_one := (endflag = '.') and funcstart;  { Nov 1997 }
														 in_func := maybe_in_func and (token.name[1] >= 'A') and (token.name[1] <= 'Z');
														 maybe_in_func := funcstart;  { Nov 1997 }
														 if in_func
																then func_count := func_count + 1;
														 if (token.name = '.') and not maybe_more and (endflag = '.')
																then func_count := func_count - 1;
														 if (token.name = ';') and (func_count < 1)
																then ok := false
													end
											else digit_seen := false;
							if eof(inf) and (func_count > 0)
								 then ok := false
					 end;
					
				if lastcom <> nil
					 then lastcom^.next := nil;
				if maybe_more
					 then begin
									 realtok := token;
									 token.name := '.';
									 once_more := false
								end;
				newname(last^.next);
				last := last^.next;
					
				last^.let.name := '';
				last^.next := nil;
				q := q^.next;
				if q = nil
					then error(8, token)
					else last_attached := q
					
			end;   { of attach }
			
		{____________________________________________________________________}

		function reserved(name: nametype; var first_mate: nametype; 
											var its_a_loop: boolean): boolean;
		
			 begin					
					reserved := true;
					forloop := (name = 'for');   { Nov 1997 }
					its_a_loop := true;
					if name = 'if'
						 then begin
										 first_mate := 'then';
										 its_a_loop := false
									end
					else if name = 'while'
									then first_mate := 'do'
					else if name = 'for'
									then first_mate := 'do'
					else reserved := false					
			 end;
			 
		{____________________________________________________________________}
		
		begin { of basic_form }
		
			{ A basic form is a loop, if-statement, or expression. A loop or if-statement
				is a condition with one or two right_sides enclosed in brackets. 
				
				Attach is called to actually attach the sequence of characters. }

			newcond(q); 
			lastcom := nil;
			
			while token.name = '{' do
				 comment(lastcom);
				 
			if reserved(token.name, first_mate, its_a_loop) { sets forloop too }
				then begin
								if doing_sys_func
								   then begin
									         token := sys_func_token;
													 doing_sys_func := false
												end
									 else scanner(inf, token, flag);
							  attach(q^.cond, first_mate);    { Nov 1997. ')' }
							  q^.aloop := its_a_loop;
								scanner(inf, token, flag);
							  if first_mate = 'do'
							     then second_mate := 'od'
							     else second_mate := 'elfi*';
								right_side(q^.form1, second_mate, inf, flag, once_more, realtok);
								if token.name = 'else'
									 then begin
									         if first_mate = 'then'
													    then scanner(inf, token, flag)
													    else error(214, token);
													 second_mate := 'fi';
													 right_side(q^.form2, second_mate, inf, flag, once_more, realtok)
												 end
										else q^.form2 := nil;
							   scanner(inf, token, flag);
								 q^.expr := nil;
							end
				else begin
								q^.aloop := false;
								q^.cond := nil;
								q^.form1 := nil;
								q^.form2 := nil;
								attach(q^.expr, endflag)
						 end

		end;

	{*************************************************************************}

	procedure right_side { var q: formptr; stop: nametype; var inf: text; 
	                       var flag: nameptr; var realtok: tokentipe };
	
		{ A right_side is a sequence of basic forms separated by semicolons }

		var last: formptr;
				first: boolean;

		function time_to_quit: boolean;  { Nov 1997 }
		   begin
		      if token.name = stop
		         then time_to_quit := true
		      else if stop = 'elfi*'
		         then time_to_quit := (token.name = 'else') or (token.name = 'fi')
		      else time_to_quit := false
		   end;
		   
		begin
		
			first := true;
			q := nil;
			semicount := 0;  { used for not falling into infinite loop if no  }
			last := nil;
			while true do  { was token.name <> stop, Nov 1997 }
				 begin
						if first
							then begin
											newform(q);  {~~~}
											q^.comms := nil;
											last := q;
											first := false
									 end
							else begin
											newform(last^.next); 
											last^.next^.comms := nil;
											last := last^.next
									 end;
						basic_form(last^.cptr, last^.comms, stop, inf, flag, once_more, realtok);
						if (token.name = ';') and tt_flag
							 then Inc(semicount)
							 else semicount := 0;
						if semicount = 1
							 then begin
											last_good_one := last^.cptr;
											last_comm := last^.comms
										end;
						if semicount = 10
							 then error(132, token);
						if time_to_quit   { Nov 1997 }
							 then break
							 else if token.name = ';'
											 then if eof(inf)
															 then break
															 else scanner(inf, token, flag)
											 else if token.name = '{'
											         then error(171, token)
															 else error(38, token)
				 end;
			if last <> nil then last^.next := nil
			
		end;

	{****************************************************************************}

	procedure spec_right_side { var q: formptr; var inf: text; var flag: nameptr };
	
		var last: formptr;
		    dummy: boolean;
				oltok: tokentipe;

		begin
			semicount := 0;  { used for not falling into infinite loop if no  }
			last := nil;
			newform(q);
			q^.comms := nil;
			last := q;
			basic_form(last^.cptr, last^.comms, endflag, inf, flag, dummy, oltok);
			if (token.name = ';') and tt_flag
				 then Inc(semicount)
				 else semicount := 0;
			if semicount = 1
				 then begin
								 last_good_one := last^.cptr;
								 last_comm := last^.comms
							end;
			if semicount = 10
				 then error(132, token);
			if last <> nil then last^.next := nil
		end;

	{***************************************************************************}

  procedure fast_mat_mult(var arr, arr2, z: workarray; rows1, rows2, cols2: longint); 
													
	   { page 481, Knuth vol 2.  Same basic notation here. x = arr, y = arr2, n = rows2. 
		   z assumed nil or irrelevant on input. arr could be arr2. ~~~~}
		 
		 var i, j, k, spot1, spot2, spot3, halfn, arr_spot: longint;
		     bhead, pr, a, c: quoly;
				 bp: quolyptr;
				 nodd: boolean;
		 
		 begin
		 
		    halfn := rows2 div 2;
				
				{ First, compute the list of b_k's. }
				bp := @ bhead;
				for k := 1 to cols2 do
				   begin
					    bp^ := nil;
							quoly_set(0, bp^);
							spot1 := (k-1)*rows2;
							for j := 1 to halfn do
							   begin
							      pr := nil;
										quoly_mult(arr2[spot1], arr2[spot1+1], pr);
										spot1 := spot1 + 2;
										best_quoly_add(bp^, pr)
								 end;
					    bp := @ bp^^.next
					 end;
				bp^ := nil;
				 
				{ Now the main loop. }
				nodd := odd(rows2);
				a := nil;
				c := nil;
				arr_spot := (rows2-1)*rows1;
				for i := 0 to rows1 - 1 do
				   begin
					    { Compute a = a_i }
							quoly_set(0, a);
							spot1 := rows1 + i;
							for j := 1 to halfn do
							   begin
							      pr := nil;
										quoly_mult(arr[spot1], arr[spot1 - rows1], pr);
										spot1 := spot1 + 2*rows1;
										best_quoly_add(a, pr)
								 end;
							
							bp := @ bhead;
							spot3 := i;
							for k := 1 to cols2 do
							   begin
								    z[spot3] := nil;
										quoly_set(0, z[spot3]);
										spot1 := rows1 + i;
										spot2 := (k-1)*rows2;
										for j := 1 to halfn do
										   begin
											    pr := nil;
													quoly_add(arr[spot1], arr2[spot2], pr);
													quoly_add(arr[spot1-rows1], arr2[spot2+1], c);
													quoly_mult(pr, c, pr);
													best_quoly_add(z[spot3], pr);
													spot1 := spot1 + 2*rows1;
													spot2 := spot2 +2
											 end;
										better_quoly_sub(z[spot3], a, z[spot3]);
										better_quoly_sub(z[spot3], bp^, z[spot3]);
										bp := @ bp^^.next;
										if nodd
										   then begin
											         quoly_mult(arr[arr_spot], arr2[k*rows2 - 1], c);
											         best_quoly_add(z[spot3], c);
															 c := nil
											      end;
										spot3 := spot3 + rows1
								 end;
							Inc(arr_spot)
					 end;
					 
				free_quoly(a);
				free_quoly(c);
				while bhead <> nil do
				   begin
					    a := bhead^.next;
							free_quoly(bhead);
							bhead := a
					 end
		 
		 end;
									 
	{***************************************************************************}

  procedure matrix_mult(var arr, arr2: workarray; var arrf, arr2f: arr_descr; 
	                      arr_free: boolean; var spar, spar2: sparseptr);
									 
		{ Note that this procedure does not change arr_free, although logically arr_free
		  is true after it finishes. Taken care of by the caller. 
		    If spar and spar2 are not nil, arr might be undefined. @@@}

    var i, j, k, cols2, spot1, spot2, spot3, rows1, rows2: longint;
        prod, arpt, arpt2: workptr;
        n2: quoly;
				allreal: boolean;
				sum: longreal;

    procedure check_numbs(var ar: workarray; row, col: longint);  
		   var i: longint;
			 begin
		      for i := 0 to row*col - 1 do
						 if ar[i]^.numb 
								then begin
								        if ar[i]^.ncoef^.imag <> nil
								           then begin
												           allreal := false;
												           break
												        end
										 end
								else begin
												allreal := false;
												break
										 end		
		   end;
				
   begin
		
      rows1 := arrf[2];
      rows2 := arr2f[2];
      cols2 := arr2f[1] div rows2;
			
			if (spar = nil) or (spar2 = nil)
			   then if rows1 * cols2 > arr_limit
			           then error(43, token);
																
			if (spar <> nil) or (spar2 <> nil)
			   then begin
				          if (spar <> nil) and (spar2 <> nil)
										 then mult_sparses(spar, spar2, arrf, rows2, cols2, arr_free)
									else if spar <> nil
										 then begin
										         arpt := @ arr;
														 arpt2 := @ arr2;
														 mult_sparse_norm(spar, arpt2, arpt, arr_free, rows1, rows2, cols2, arrf);
														 spar := nil
													end
									else if spar2 <> nil
										 then begin
										         mult_norm_sparse(arr, arr2, spar2, rows1, rows2, cols2);
														 if arr_free 
			                          then free_arr(arr, arrf);
														 arrf[1] := rows1 * cols2;
                             { Note: arr2 and arr point to same storage at end. }
														 for i := 0 to arrf[1] - 1 do
                                arr[i] :=  arr2[i]
													end;
								  exit {(matrix_mult)}
							end;
					
			new_worknode(i, token);																		 
			prod := workhead[i];
					
      allreal := true;
			if not realflag
			   then begin
			           check_numbs(arr, rows1, rows2);
								 if allreal
								    then check_numbs(arr2, rows2, cols2)
							end;
							
			if allreal
			   then for i := 0 to rows1 - 1 do
								 for j := 0 to cols2 - 1 do
										begin
												spot3 := i + rows1 * j;
												sum := 0;
												spot1 := i;
												spot2 := rows2 * j;
												for k := 1 to rows2 do
													 begin
															sum := sum + arr[spot1]^.ncoef^.float * arr2[spot2]^.ncoef^.float;
															spot1 := spot1 + rows1;
															Inc(spot2)
													 end;
												prod^[spot3] := nil;
												quoly_set_ext(sum, prod^[spot3])
										end
				 
				 else for i := 0 to rows1-1 do
								 for j := 0 to cols2-1 do
										begin
												spot3 := i + rows1 * j;
												prod^[spot3] := nil;
												quoly_set(0, prod^[spot3]);
												spot1 := i;
												spot2 := rows2 * j;
												for k := 1 to rows2 do
													 begin
															n2 := nil;
															quoly_mult(arr[spot1], arr2[spot2], n2);
															best_quoly_add(prod^[spot3], n2);
															spot1 := spot1 + rows1;
															Inc(spot2)
													 end;
										end;
      if arr_free 
			   then free_arr(arr, arrf);
      arrf[1] := rows1 * cols2;
      arrf[2] := rows1;
      for i := 0 to arrf[1] - 1 do
         arr[i] := prod^[i];
			free_work
			 
    end;
		
 {*****************************************************************************}
 
 procedure alt_mat_power(var arr: workarray; var arr_facts: arr_descr; 
                         var arr_free: boolean; expont: longint);
												
	  { take matrix arr to the expont power. return answer in arr. arr_free is true
		  at end, unless perhaps expont = 1.
			  Use fast_mat_mult. ~~~~~ changed to right-to-left Aug 1995. 
			  Copied from fer220 Apr 1996. }
										 
    var i, j, k, rows: longint;
		    arr2_free: boolean;
				dumm: quoly;
				prod, arr2: workptr;
				sp: sparseptr;
		powerOf2 : longint;
		
		begin
		
			 sp := nil;
		 	 if expont < 0
			    then begin
					        mat_invert(arr, arr, arr_free, arr_free, arr_facts[2], dumm, true, true, sp);
									arr_free := true;
									expont := -expont
							 end;
					
		   if expont = 1
					then exit {(alt_mat_power)}
			    else if expont = 0 
									then begin  { return identity matrix. }
													identi(arr, arr_facts[2], arr_free);
													arr_free := true;
													exit {(alt_mat_power)}
											 end;
															 
			 new_worknode(i, token);		{@@@}																 
			 arr2 := workhead[i];
			 for i := 0 to arr_facts[1] - 1 do
					arr2^[i] := arr[i];
			 arr2_free := false;			
					 
			 { now expont >= 2 }
			 rows := arr_facts[2];
			 powerOf2 := 1 shl 30;
			 for i := 30 downto 0 do  { find highest-order 1 in expont }
			 begin
					if expont and powerOf2 <> 0
					   then begin
							       k := i;
									   break
							    end;																powerOf2 := powerOf2 shr 1
			end;
										
			 new_worknode(i, token);																		 
			 prod := workhead[i];
			
			 { k must be at least 1. answer will be built up in arr2. }
			 powerOf2 := 1 shl (k-1);
			 for j := k-1 downto 0 do
				  begin
					   { prod is irrelevant at each start of this loop. }
						 fast_mat_mult(arr2^, arr2^, prod^, rows, rows, rows);
						 if arr2_free
						    then for i := 0 to arr_facts[1] - 1 do
								        free_quoly(arr2^[i]);
						 for i := 0 to arr_facts[1] - 1 do
								arr2^[i] := prod^[i];
						 arr2_free := true;
						 if expont and powerOf2 <> 0
							  then matrix_mult(arr2^, arr, arr_facts, arr_facts, arr2_free, sp, sp);
						powerOf2 := powerOf2 shr 1;
				  end;

			 free_work;
			 for i := 0 to arr_facts[1] - 1 do
					begin
						 if arr_free
						    then free_quoly(arr[i]);
						 arr[i] := arr2^[i]
					end;
			 free_work;  {@@@}
			 arr_free := true
					
	  end;
												
  {*************************************************************************}
 
  procedure zline; {(var inf: text; var n: quoly; var flag: nameptr)}
	
	   var xcor, ycor, xcor2, ycor2: integer;
				 z2, xext, yext, xext2, yext2, z: longreal;
		 
		 begin
		 
		    if not threedim
					 then error(130, token);
				scanner(inf, token, flag);
				if token.name <> '('
					 then error(177, token);
				scanner(inf, token, flag);
				old_expre(inf, n, flag);
				quoly_convert_to_comp(n, xext, yext);
				if token.name <> ','
					 then error(202, token);
				scanner(inf, token, flag);
			  old_expre(inf, n, flag);
			  quoly_convert_to_comp(n, xext2, yext2);
				if token.name = ')'
					 then z2 := 1  { z2 = the radius of the Riemann sphere }
					 else if token.name <> ','
									 then error(202, token)
									 else begin
													 scanner(inf, token, flag);
													 old_expre(inf, n, flag);
													 z2 := quoly_convert_to_ext(n);
													 if z2 <= 0
															then error(191, token);
													 if token.name <> ')'
															then error(1, token)
												end;
				z := z2;
				map_to_sphere(xext, yext, z, xcor, ycor);
				MoveTo(xcor, ycor);
				map_to_sphere(xext2, yext2, z2, xcor2, ycor2);
				LineTo(xcor2, ycor2);
				if marking
					 then attach_line(xcor,ycor, xcor2,ycor2, xext,yext,z, xext2,yext2,z2);	
				scanner(inf, token, flag);
				quoly_set(0, n);
				savescreen := true
						 
		 end;
	
  {****************************************************************************}	

  function fastestlookup(x: tokentipe; var q: arrptr): longint; 

    { Many callers need fastestlookup to return q^.start, even for sparse's that have
		  genuine arp storage as well. <<<<}
			
		begin
		
      if x.address = -1
			   then x.address := hash(x.name, 151);
				 
			q := arr_store[x.address];
      while q <> nil do
         if q^.name.name = x.name
            then break
            else q := q^.next;
    
      if q = nil
         then fastestlookup := -1
         else fastestlookup := q^.start
				
    end;

  {****************************************************************************}

  function fasterlookup(x: tokentipe; var q: arrptr; var inf: text; var flag: nameptr): longint; 

    { Many callers need fasterlookup to return q^.start, even for sparse's that have
		  genuine arp storage as well. <<<<}
			
		var m: longint;
		    n: quoly;
		
		begin
		
      if x.name = ''
			   then begin
				         n := nil;
								 get_arr_arr(inf, n, flag, m);
								 free_quoly(n);
								 q := arrstash[m];
								 if q = nil
									  then begin
										        error(247, token);
														fasterlookup := -1
												 end
									  else fasterlookup := q^.start
							end
			else if x.name = ''
			   then begin
				         q := syst;
								 fasterlookup := 0
				      end
			else fasterlookup := fastestlookup(x, q)
				
    end;

	{**************************************************************************}	

  procedure get_quoly(var n: quoly; var inf: text; var flag: nameptr);
	
	   { Return n as a pointer to existing storage -- do not duplicate the storage. 
		   n must be nil or irrelevant on input. 
			   It is very dangerous to do this, to have n pointing to some other storage.
			 Especially beware that n may be the system's main quoly, num. 
			 Beware any procedure that uses this one, especially if that procedure could
			 have an error! 
			 
			  Nov 1997:  Beware indeed!  n can be nil - sparse array.  Caller beware! }
	
	   var qp: quolyptr;
		     p: nameptr;
				 qa: arrptr;
				 q: varptr;
				 row, count: longint;
				 np: numptr;
				 sensitive, its_syst: boolean;
				 oldtok: tokentipe;
		 
		 begin
		 
		    if (flag <> nil) and flag^.compiled
			    then case flag^.tipe of
									one: begin
													n := flag^.qp^;
													flag := flag^.next;
													token := flag^.let
											 end;
									two: begin
													n := flag^.qp^;
													flag := flag^.next^.next;
													flag := flag^.next^.next;
													token := flag^.let
											 end;
									three: begin
														p := flag;
														flag := flag^.next^.next;
														token := flag^.let;
														ievalcoords(row, count, flag, sensitive);
														flag := flag^.next;
														token := flag^.let;
														np := numptr(p^.qp);
														row := np^.value + row - addresser; { changed Oct 1993 }
														if sensitive
															 then row := row + (count - addresser) * np^.next^.value;
														qp := @ arp[row shr 10]^[row and tenmask];
														n := qp^
												 end
							 end							
							 
			else begin
			
							if token.name = ''
								 then its_syst := true
								 else if (polynames <> nil) and its_a_polyname(token.name)
												 then error(125, token)
												 else its_syst := false;
												 
							oldtok := token;
							if token.name <> ''
							   then scanner(inf, token, flag);
							if (token.name = '[') or (token.name = '')
								 then begin
												 if fasterlookup(oldtok, qa, inf, flag) = -1
												    then error(28, oldtok);
												 if oldtok.name = ''
							              then begin
														        scanner(inf, token, flag);
																		if token.name <> '['
						                           then error(244, token)
																 end;
												 scanner(inf, token, flag);
												 evalcoords(inf, row, count, flag, ']', ',', sensitive);
												 get_quoly_ptr(qa, row, count, sensitive, qp, oldtok, its_syst);
												 if qp = nil
												    then n := nil
												    else n := qp^;  { Nov 1997 }
														{ might be nil either way; Jan 1998 }
												 scanner(inf, token, flag)
											end
								 else if its_syst
								         then n := prevnum
								 else begin
												 { Lookup oldtok in symbol table. }
												 if oldtok.address = -1
														then row := hash(oldtok.name, 151)
														else row := oldtok.address;
												 q := sca_store[row];
												 while q <> nil do
														if q^.let.name = oldtok.name
															 then break
															 else q := q^.next;
												 if q = nil
														then error(19, oldtok)
														else n := q^.val
											end
												 											
						end
					 
		 end;
								
	{****************************************************************************}

  function codegree(q: ferm118.poly; level: longint): longint;
	
	   { q <> nil. smallest exponent in q at level.  level is >= 1 and <= number_polys.
		   laurents definitely ok.  Don't change q^. ```}
		 
		 var ans, c: longint;
		 
		 begin
		 
		    if level = 1
					 then begin
						       while q^.next <> nil do
										  q := q^.next;
									 codegree := q^.exp
								end
					 else begin
					         ans := two_to_31;
									 while q <> nil do
									    begin
												 if q^.numb
														then if 0 < ans
																		then ans := 0
																		else
														else begin
														        c := codegree(q^.pcoef, level - 1);
														        if c < ans 
																		   then ans := c
																 end;
												 q := q^.next
									    end;
									 codegree := ans
								end
		 
		 end;

	{**************************************************************************}	

  procedure generalized_degree(var n: quoly; level: longint; lowest: boolean);
	
	   { on input level is >= 1 and <= number_polys. works for laurents. 
		   sneakier than it first seems. }
		 
		 var ans: longint;
		 
		 procedure search(q: ferm118.poly; lev: longint);
				begin
					 if lev = 1
					    then if q^.exp > ans
							        then ans := q^.exp
											else
							else while q <> nil do
										  begin
												 if q^.numb
													  then if 0 > ans
																		then ans := 0
																		else
														else search(q^.pcoef, lev - 1);
												 q := q^.next
										  end
				end;
		 		 
		 begin
		 
		    if n^.numb
					 then quoly_set(0, n)
				   else if lowest
					         then quoly_set(codegree(n^.numer, level), n)
									 else begin
													 ans := neg_two_to_31;
													 search(n^.numer, level);
													 quoly_set(ans, n)
												end

		 end;

	{**********************************************************************}

	procedure fact; { var inf: text; var qp: quolyptr; var n: quoly;
	                  var aux: colm_ptrptr; var colpos: longint; var flag: nameptr }

	  {   Big changes, Nov 1997.  Now returns qp, n, aux, and colpos.

	    Basic idea: qp^ is the value being returned.  If n = nil, qp is pointing to
	    storage in some system-wide data structure.  If n <> nil, qp^ = n.

	    qp might be nil, but only when a sparse array is accessed with no entry --
	    i.e., the entry "is 0." In that case (aux, colpos) then points to the place where
	    a value should be inserted if this is part of an assignment statement.
	    n = nil also.

	    More about aux and colpos: aux points to the entry in the array indx which is
	    the row where this array ref belongs, and colpos is its coordinate.  Note that at
	    first glance it seems that all we need is a colm_ptrptr to point to the previous
	    colm_ptr in the sparse array row list where the entry will later be placed. For example,
	    if it is x[3,4] that is not present, let aux point to the colm_ptr in the previous
	    node in row 3.  BUT by the time we need it, that node may no longer be there!!
	    Sneaky!  Hence the much safer method of passing back both aux and colpos.

	    aux is not nil for ALL sparse array refs.  It is usually nil otherwise.  When aux
	    <> nil, the caller cannot use qp -- can't take the chance that qp has been changed
	    in the mean time.  n = nil also then.

	    If qp <> nil (usually true), then qp^ is the value being returned. If n = nil
	    then qp is pointing to storage in one of the system data structures.  If
	    n <> nil then new storage for n was created here, and qp points to n.

	    The caller must first check if qp = nil.  If so, aux and colpos may be of use.
	    If qp <> nil, the caller may want to check if n = nil.

	    aux is usually nil (and colpos is undefined) unless it's a sparse reference, so then
	    n = nil too.  If n <> nil, caller will not care about aux.  If n = nil,
	    aux and colpos are valid. }

    var oldtok: tokentipe;
        n2: quoly;  { if you use it, beware of others who use it. }
				m, m2, m3: number;
				row, count, expont: longint;
				negative, sensitive: boolean;
				q: arrptr;
				p, copy: nameptr;
				pol: polypt;
				np: numptr;
				dumm: longreal;
				spar: sparseptr;
				vp: varptr; { Nov 1997 }
				mate: char;
				im: imptr;

    begin
		
		  if n <> nil
			   then free_quoly(n);   { Nov 1997 }
			   
			aux := nil;  { default }
			
			if (flag <> nil) and flag^.compiled
			    then case flag^.tipe of
									one: begin
													qp := flag^.qp;   { Nov 1997 }
													flag := flag^.next;
													token := flag^.let
											 end;
									two: begin
													qp := flag^.qp;   { Nov 1997 }
													flag := flag^.next^.next;
													repeat
													   flag := flag^.next
													until flag^.let.name = ']';
												  flag := flag^.next;
													token := flag^.let
											 end;
									three: begin
														p := flag;
														flag := flag^.next^.next;
														token := flag^.let;
														ievalcoords(row, count, flag, sensitive);
														flag := flag^.next;
														token := flag^.let;
														np := numptr(p^.qp);
														row := np^.value + row - addresser; { changed Oct 1993 }
														if sensitive
															 then row := row + (count - addresser) * np^.next^.value;
														qp := @ arp[row shr 10]^[row and tenmask]
												 end
							 end							
							 
			else begin
			
						m.size := 0;  m.imag := nil;
						m2.size := 0;   m2.imag := nil; 
						if (token.name[1] >= 'a') and (token.name[1] <= 'z')
							 then if (polynames <> nil) and its_a_polyname(token.name)
											then begin
															is_poly_name2(token.name, count, pol);
															if (pol^.p <> nil) and (pol^.expon = 1)
																 then p_q_assign(pol^.p, n)
																 else base_quoly(n, count);
														  qp := @ n;   { Nov 1997 }
															scanner(inf, token, flag)
													 end
								else begin
												oldtok := token;
												scanner(inf, token, flag);  { Nov 1997; all new }
												if token.name = '['
													 then begin
													         new_arretrieve(inf, oldtok, flag, qp, aux, colpos);
													         if qp = nil  { sparse array and entry isn't there; i.e. 0 }
													            then if token.name = ':'
													                 then  {aux, colpos are set, leave n nil for assignment}
													                 else begin
													                         quoly_set(0, n);
													                         qp := @ n
													                      end
													            { else nothing }
													      end
													 else begin
													         retrieve(oldtok, qp, n, inf, flag);
													         if qp = nil { var not defined }
													            then if token.name = ':' { assignment, new form. Nov 1997 }
													                    then begin   { also includes no-print command }
													                            quoly_set(0, n);
													                            insert(oldtok, n, vp);
													                            qp := @ vp^.val;
													                            n := nil
													                         end
													                    else error(19, oldtok)
													           { else n probably is nil }
													      end
										 end
										 
						else if token.name = '('
										then begin
													 scanner(inf, token, flag);
													 old_expre(inf, n, flag);
													 if token.name <> ')'
															then error(1, token)
															else scanner(inf, token, flag);
													 qp := @ n
												end
						else if (token.name[1] >= '0') and (token.name[1] <= '9')
										then begin
														new_readin(inf, m, flag, count);
														if (token.name = 'e') or (token.name = '.')
															 then expon_form(inf, m, flag, count);
														scalar_to_quoly(m, n);
														qp := @ n
												 end
						else if token.name = '.'  { Oct 2000. can now have constants like .32 }
										then begin        { but not inside function defs. }
														m.float := 0;
														expon_form(inf, m, flag, count);
														scalar_to_quoly(m, n);
														qp := @ n
												 end
						else if token.name = '-'
										then begin
													 scanner(inf, token, flag);
													 fact(inf, qp, n, aux, colpos, flag);
													 if qp = nil
															then quoly_set(0, n)
															else if n = nil
																			then quoly_makeneg(qp^, n)
																			else quoly_inplace(n);
													 qp := @ n
												end
								
						else if token.name = '' 
										 then begin
														 scanner(inf, token, flag);
														 fact(inf, qp, n, aux, colpos, flag);
														 if qp = nil
																then error(316, token)
																else if not qp^^.numb
																				then error(253, token);
														 row := convert_to_int(qp^^.ncoef^);
														 free_quoly(n); { added July 1996 }
														 if (row <= 0) or (row > number_polys)
																then error(316, token);
														 base_quoly(n, row);
														 qp := @ n
													end
						 
						 else if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
										then begin
														count := find_built_in(0, numbuiltins, token.name);
														if count = -1
															 then evaluate(inf, token, n,  flag)
														else if builtin[count, 2] <> ''
															 then begin
																			 token.name := builtin[count, 2];
																			 fact(inf, qp, n, aux, colpos, flag)
																		end
														else builtin_func(inf, n, flag, count);
														qp := @ n
												 end
						else if token.name = '^'
									then begin
													scanner(inf, token, flag);
													fact(inf, qp, n, aux, colpos, flag);
													if qp = nil
														 then quoly_set(0, n)
														 else if n = nil
																		 then quoly_assign(qp^, n);
													if not n^.numb
														 then begin
																		 free_quoly(n);
																		 error(115, expsign)
																	end;
													im := n^.ncoef;
													if im^.imag = nil
														 then im^.float := exp(im^.float)
														 else begin
																		 quoly_to_scalar(n, m);
																		 complex_expon(m);
																		 scalar_to_quoly(m, n)
																	end;
													qp := @ n
											 end
						else if token.name = '$'
										then begin
														scanner(inf, token, flag);
														fact(inf, qp, n, aux, colpos, flag);
														if qp = nil
															 then quoly_set(0, n)
															 else if n = nil
																			 then quoly_assign(qp^, n);
														quoly_great_int(n);
														qp := @ n
												 end
						else if token.name = '_'
										then begin
														scanner(inf, token, flag);
														fact(inf, qp, n, aux, colpos, flag);
														if qp = nil
												       then quoly_set(0, n)
												       else if n = nil
																			 then quoly_assign(qp^, n);
														if not n^.numb
															 then begin
																			 free_quoly(n);
																			 error(115, logsign)
																		end;
														im := n^.ncoef;
														if not complex
															 then if im^.float <= 0
																			 then error(34, logsign)
																			 else im^.float := ln(im^.float)
															 else begin
																			 quoly_to_scalar(n, m);
																			 complex_log(m, m2);
																			 scalar_to_quoly(m2, n);
																			 imag_free(m);  
																			 m.size := 0
																		end;
													 qp := @ n
												end
						else if token.name = '|'
										then begin
														scanner(inf, token, flag);
														fact(inf, qp, n, aux, colpos, flag);
														if token.name <> 'or' then error(63, token);
														if qp = nil
															 then quoly_set(0, n)
															 else if n = nil
																			 then quoly_assign(qp^, n);
														quoly_abs(n, true);
														qp := @ n;
														scanner(inf, token, flag)															
												 end
						else if token.name = ''
										then begin
														scanner(inf, token, flag);
														fact(inf, qp, n, aux, colpos, flag);
														if qp = nil
												       then quoly_set(0, n)
												       else if n = nil
																			 then quoly_assign(qp^, n);
														if not n^.numb
															 then begin
																			 free_quoly(n);
																			 error(115, sqrtsign)
																		end;
														im := n^.ncoef;
														if not complex
															 then if im^.float < 0   
																			 then error(37, sqrtsign)
																			 else im^.float := sqrt(im^.float)
														else begin
																		quoly_to_scalar(n, m);
																		m3.imag := nil;
																		m2.float := m.float;
																		if imagzero(m)
																			 then sensitive := false
																			 else sensitive := not (m.float = 0);
																		if m.imag <> nil
																			 then negative := (0 > m.imag^.float)
																			 else negative := false;
																		complex_abs(m, true);
																		m3.float := (m2.float + m.float) / 2;
																		if m3.float < 0
																			 then m3.float := 0;
																		m.float := sqrt(m3.float);
																		m3.float := m3.float - m2.float;
																		newimag(m.imag);
																		m.imag^.imag := nil;
																		if m3.float < 0
																			 then m3.float := 0;
																		m.imag^.float := sqrt(m3.float);
																		if negative
																			 then m.float := - m.float;
																		if sensitive 
																			 then begin
																							 quoly_to_scalar(n, m2);
																							 quot(m2, m, m2);
																							 add(m, m2, m);
																							 quot(m, number_2, m);
																							 imag_free(m2)
																						end;
																		if m.imag^.float = 0
																			 then imag_free(m);
																		scalar_to_quoly(m, n)	 
																 end;
														qp := @ n	 
												 end
																	 
						else if token.name = ''
										 then begin
														 get_arr_arr(inf, n, flag, count);
														 free_quoly(n);  { Nov 1997. all new below. }
														 if arrstash[count] = nil
																then error(247, token);
														 scanner(inf, token, flag);
														 if token.name <> '['
																then error(244, token);
														 spec_arretrieve(inf, flag, arrstash[count], qp, aux, colpos);
														 if qp = nil  { sparse array and entry isn't there; i.e. 0 }
																then if token.name = ':'
																				then  { aux, colpos are set, leave n nil for assignment}
																				else begin
																								quoly_set(0, n);
																								qp := @ n
																						 end
													end
													
						else if (token.name = '`') or (token.name = '"') or (token.name = '%')
									 then begin
													 oldtok := token;
													 scanner(inf, token, flag);
													 fact(inf, qp, n, aux, colpos, flag);
													 if qp = nil
												       then quoly_set(0, n)
												       else if n = nil
																			 then quoly_assign(qp^, n);
													 if not n^.numb
														 then begin
																		 free_quoly(n);
																		 error(115, oldtok)
																	end;
													 im := n^.ncoef;
													 if im^.imag = nil
															then case oldtok.name[1] of
																			'"': im^.float := cos(im^.float);
																			'`': im^.float := sin(im^.float);
																			'%': im^.float := sin(im^.float)/cos(im^.float) {@@@}
																	 end
															else begin
																			quoly_to_scalar(n, m);
																			m3.imag := nil;
																			m2.float := 0;
																			setimag(1, m2); 
																			mult(m, m2, m);
																			complex_expon(m);
																			complex_assign(m, m3);
																			quot(number_1, m3, m3);
																			case oldtok.name[1] of
																				'"': begin
																							 add(m, m3, m);
																							 quot(m, number_2, m)
																						 end;
																				'`': begin
																							 sub(m, m3, m);
																							 setimag(2, m2);
																							 quot(m, m2, m);
																						 end;
																				'%': begin
																							 add(m, m3, m2);
																							 sub(m, m3, m3);
																							 if m.imag = nil
																									then begin
																													newimag(m.imag);
																													m.imag^.imag := nil
																											 end;
																							 m.imag^.float := -m3.imag^.float;  { may be illegal imag! }
																							 if m3.imag = nil
																									then m.float := 0
																									else m.float := m3.imag^.float;
																							 quot(m, m2, m);
																						 end
																			end;
																			imag_free(m2); 
																			imag_free(m3);
																			if m.imag <> nil
																				 then if (m.imag^.float = 0)
																								 then imag_free(m);
																			scalar_to_quoly(m, n)
																	 end;
													 qp := @ n
												end
														
					 else if token.name = ''  { arctangent }
									 then begin
													 scanner(inf, token, flag);
													 fact(inf, qp, n, aux, colpos, flag);
													 if qp = nil
												       then quoly_set(0, n)
												       else if n = nil
																			 then quoly_assign(qp^, n);
													 if not n^.numb
														  then begin
																		  free_quoly(n);
																		  error(115, arctansign)
																	 end;
													 im := n^.ncoef;
													 if im^.imag <> nil
															then begin
																			writeln(userOutput, ' Warning.  Argument to arctangent truncated to real.');
																			imag_free(im^)
																	 end;
													 im^.float := arctan(im^.float);
													 qp := @ n
												end
										
					  else if token.name = ''
									 then if complex
												then begin
																scanner(inf, token, flag);
																m.float := 0;
																setimag(1, m);
																scalar_to_quoly(m, n);
																qp := @ n
														 end
												else begin
																write(userOutput, ' Warning:   encountered and ignored.');
																writeln(userOutput, ' 0 returned.');
																scanner(inf, token, flag);
																quoly_set(0, n);
																qp := @ n
														 end
														 
						 else if token.name = ''
										then begin
														m.float := pii.float;
														scalar_to_quoly(m, n);
														qp := @ n;
														scanner(inf, token, flag)
												 end
																	 
						else if token.name = ''
										then begin
														scanner(inf, token, flag);
														if token.name <> '('
															 then error(177, token);
														scanner(inf, token, flag);
														old_expre(inf, n, flag);
														if token.name <> ','
															 then error(202, token);
														row := quoly_convert_to_int(n);
														scanner(inf, token, flag);
														old_expre(inf, n, flag);
														if token.name <> ')'
															 then error(1, token);
														scanner(inf, token, flag);
														count := quoly_convert_to_int(n);
														if (count < 0) or (count > row)
															 then quoly_set(0, n)
															 else float_binom(row, count, n);
														qp := @ n
												 end
												 
						 else if token.name = ''
										 then begin
														 scanner(inf, token, flag);
														 sensitive := (token.name = '');
														 if sensitive
																then scanner(inf, token, flag);
														 randomize(sensitive, n);
														 qp := @ n
													end
						 else if token.name = '&_n'  { Sep 2002 }
										 then begin
														 scanner(inf, token, flag);
														 quoly_readin(inf, n, flag, count);
														 qp := @ n
													end
						 else if token.name = chr(21)
										 then begin
														 if sys_func = nil
																then error(243, token);
														 if flag <> nil
																then error(251, token);
														 p := startexpr;
														 copy := prev_expr;
														 quoly_set(0, n);
														 prev_expr := nil;
														 startexpr := nil;
														 eval_form(inf, sys_func, n);
														 if n = nil
					                      then quoly_set(0, n);
														 realflag := false;
														 prev_expr := copy;
														 startexpr := p;
														 exit_flag := false;
														 cycle_flag := false;
														 leave_flag := false;
														 scanner(inf, token, flag);
														 qp := @ n
													end
													
						else if (token.name = '') or (token.name = '')
											 then begin
															 oldtok := token;
															 obtain_sum(inf, flag, p);
															 copy := p;
															 token := p^.let;
															 if token.name <> '<'
																	then error(144, token);
															 sum_mult_up(oldtok.name, inf, n, p, false, dumm, mate);  
															 if flag = nil
																	then freename(copy)  { copy not changed }
																	else flag := p;
															 if token.name[1] <> mate
																	then error(312, token);
															 scanner(inf, token, flag);
															 qp := @ n
														end
														
							 else if token.name = ''''
										 then begin
														dumbscanner(inf, token, flag, sensitive);
														{ sensitive is a dummy here }
														m.float := ord(token.name[1]);
														dumbscanner(inf, token, flag, sensitive);
														if token.name <> ''''
															 then error(109, token);
														scalar_to_quoly(m, n);
														qp := @ n;
														scanner(inf, token, flag)
													end
						 
						 else if token.name = '' { determinant }
										 then begin
										         arr_parse('', inf, n, flag);
														 qp := @ n
													end
						 else if token.name = ''  { number of columns }
										 then begin
														scanner(inf, token, flag);
														if token.name <> '['
															 then error(96, token);
														scanner(inf, token, flag);
														count := fasterlookup(token, q, inf, flag);  {spar}
														if count = -1
															 then error(28, token);
														scanner(inf, token, flag);
														if token.name <> ']'
															 then error(97, token);
														m.float := q^.size div q^.rows;
														scalar_to_quoly(m, n);
														scanner(inf, token, flag);
														qp := @ n
													end
														
						 else if (token.name = '') or (token.name = '') 
											 then begin
															negative := (token.name = '');
															scanner(inf, token, flag);
															if token.name = '['
																 then begin
																				 if negative
																						then error(314, token); 
																				 scanner(inf, token, flag);
																				 count := fasterlookup(token, q, inf, flag); {spar}
																				 if count = -1
																						then error(28, token);
																				 scanner(inf, token, flag);
																				 if token.name <> ']'
																						then error(99, token);
																				 quoly_set(q^.size, n);
																				 scanner(inf, token, flag)
																			end
															else if token.name = '('
																	 then begin
																					 scanner(inf, token, flag);
																					 old_expre(inf, n, flag);
																					 if token.name = ')'
																							then if n^.numb
																											then quoly_set(0, n)
																											else if negative
																															then quoly_set(codegree(n^.numer, 1), n)
																															else quoly_set(n^.numer^.exp, n)  {~~~ Note change }
																							else begin
																											if token.name <> ','
																												 then error(202, token);
																											scanner(inf, token, flag);
																											n2 := nil;
																											old_expre(inf, n2, flag);
																											if token.name <> ')'
																												 then error(1, token);
																											if not n2^.numb
																												 then error(253, token);
																											expont := quoly_convert_to_int(n2); { really a level }
																											free_quoly(n2);
																											if (expont <= 0) or (expont > number_polys)
																												then error(311, token);
																											generalized_degree(n, expont, negative)
																									 end;
																					 scanner(inf, token, flag)
																				end
															else begin
																			get_quoly(n2, inf, flag); {``` n2 is just a pointer! }
																			if n2 = nil  { Jan 1998, can happen! }
																         then quoly_set(0, n)
																      else if n2^.numb
																				 then quoly_set(0, n)
																				 else if negative
																								 then quoly_set(codegree(n2^.numer, 1), n)
																								 else quoly_set(n2^.numer^.exp, n)  {~~~ Note change }
																	 end;
															qp := @ n
													 end  
															
						else if token.name = ''
									 then begin
									         scanner(inf, token, flag);  { bug of Dec 1997 }
													 fact(inf, qp, n, aux, colpos, flag);
													 if qp = nil
														  then quoly_set(0, n)
														  else if n = nil
																		  then quoly_assign(qp^, n);
													 if complex
														  then quoly_conjugate(n)
														  else writeln(userOutput, ' Warning:  encountered and ignored.');
													 qp := @ n
												end
						 else if token.name = ''
									 then begin
									         scanner(inf, token, flag);  { bug of Dec 1997 }
													 fact(inf, qp, n, aux, colpos, flag);
													 if qp = nil
														  then quoly_set(0, n)
														  else if n = nil
																		  then quoly_assign(qp^, n);
													 if complex
														  then quoly_imag_free(n, true)
														  else writeln(userOutput, ' Warning: Real part encountered and ignored.');
													 qp := @ n
												end
																		 
						 else if token.name = ''
									 then begin
									         scanner(inf, token, flag);  { bug of Dec 1997 }
													 fact(inf, qp, n, aux, colpos, flag);
													 if qp = nil
														  then quoly_set(0, n)
														  else if n = nil
																		  then quoly_assign(qp^, n);
													 if complex
														  then quoly_imag_part(n)
														  else writeln(userOutput, ' Warning: Imaginary part encountered and ignored.');
													 qp := @ n
												end
															
						 else if token.name = ''  { coefficient }
										 then begin
															 scanner(inf, token, flag);
															 if token.name <> '('
																	then error(154, token);
															 scanner(inf, token, flag);	
															 { Don't use n below!  Danger! }
															 get_quoly(n2, inf, flag);  
															 if n2 = nil  { Jan 1998,  can happen! }
																  then quoly_set(0, n2);
															 quoly_get_coef(inf, n2, flag);
															 if token.name <> ')'
																	then error(1, token);
															 free_quoly(n);
															 n := n2;
															 qp := @ n;
															 scanner(inf, token, flag)
														end
																										 
						else if token.name = ''  { leading term }
										then begin
														scanner(inf, token, flag);
														fact(inf, qp, n, aux, colpos, flag);														
														if qp = nil
															 then quoly_set(0, n)
															 else if qp^^.numb
																	 then if n = nil
															             then quoly_assign(qp^, n)
															             else { nothing }
																	 else begin
																					 if n = nil
															                then quoly_assign(qp^, n);
																					 if n^.denom <> nil
																							then error(186, token);
																					 free_poly(n^.numer^.next);
																					 if n^.numer^.numb 
																							then polynum_to_quoly(n);
																				end;
														qp := @ n
												 end
												 
						else if token.name = ''
											then begin
															scanner(inf, token, flag);
															if token.name = '['
																 then begin
																				 if syst^.stop = -1
																						then error(175, token);
																				 scanner(inf, token, flag);
																				 if realflag
																						then ievalcoords(row, count, flag, sensitive)
																						else evalcoords(inf, row, count, flag, ']', ',', sensitive);
																				 get_quoly_ptr(syst, row, count, sensitive, qp, token, true);
																				 if qp = nil
																						then quoly_set(0, n)
																						else begin
																										if qp^ = nil
																											 then begin
																															 writeln(userOutput, 'Warning. uninitialized array element in [].');
																															 writeln(userOutput, '  Will use 0.');
																															 quoly_set(0, qp^)
																														end;
																										quoly_assign(qp^, n)
																								 end;
																				 scanner(inf, token, flag)
																			end
																 else quoly_assign(prevnum, n);
															qp := @ n
													 end
												 
						else  case token.name[1] of
				 {	':', Nov 1997 } '@', '&', '!', '?': begin
																									 parse(inf, n, flag);
																									 if n = nil
																											then quoly_set(0,n);
																									 qp := @ n
																								end;
			
											else error(2, token)
									end
									
					end;
					
			if token.name = '^'
				 then begin
								 m.size := 0;  m.imag := nil;
								 m2.size := 0;  m2.imag := nil;
								 get_exponent(inf, flag, m2);
								 if qp = nil
										then quoly_set(0, n)
										else if n = nil
														then quoly_assign(qp^, n);
								 if not complex
										 then if m2.float = trunc(m2.float)
														 then raise_to_power(n, m2)
														 else begin
																		if n^.numb
																			 then quoly_to_scalar(n, m)
																			 else begin
																							free_quoly(n);
																							error(117, expsign)
																						end;
																		if m.float <= 0
																			 then error(34, logsign)
																			 else m.float := ln(m.float);
																		mult(m, m2, m);
																		m.float := exp(m.float);
																		scalar_to_quoly(m, n)
																	end
													
										 else raise_to_power(n, m2);
								 imag_free(m2);
								 qp := @ n
							end
			else if token.name = '!'
				 then begin
								 m.size := 0;  m.imag := nil;
								 if qp = nil
										then quoly_set(0, n)
										else if n = nil
														then quoly_assign(qp^, n);
								 if n^.numb
										then quoly_to_scalar(n, m)
										else begin
														free_quoly(n);
														error(115, factsign)
												 end;
								 scanner(inf, token, flag);
								 factorial(m);
								 scalar_to_quoly(m, n);
								 qp := @ n
							end
		
			else if token.name = ''
				 then begin
								 scanner(inf, token, flag);
								 if token.name = '['
										then if matrix_eval > 0  { Somebody is signalling. }
														then begin  { Return to arr_fact, which just called fact. }
																		matrix_eval := matrix_eval - 1;
																		exit {(fact)}
																 end
												 else begin  { must call quoly_at_matrix here, with stash }
																 spar := nil;
																 expont := syst^.rows;
																 new_worknode(count, bulletsign);																		 
															{	 spare := workhead[count];  FAILS!!  ???? }
																 { need spare because of maybe x[] }
																 if qp = nil  { Nov 1997 }
																		then begin
																						quoly_set(0, n);
																						qp := @ n
																				 end;
																 quoly_at_matrix(inf, qp^, workhead[count]^, sys_arr_facts,
																								 sensitive, syst^.rows, flag, spar);
																 if syst_dump
																		then if flag = nil
																						then writeln(userOutput, 'Warning. System array was changed before it could be displayed.')
																						else 
																		else syst_dump := true;
																 if syst^.spar = nil
																		then for row := 0 to syst^.stop do
																						free_quoly(stash^[row])
																		else free_sparse(syst^.spar, expont, true);	
																 syst^.stop := sys_arr_facts[1] - 1;
																 if spar <> nil
																		then if sensitive
																						then syst^.spar := spar
																						else copy_sparse(spar, syst^.spar, syst^.rows, false)
																		else if sensitive
																						then for row := 0 to syst^.stop do
																										stash^[row] := workhead[count]^[row]
																						else for row := 0 to syst^.stop do
																										quoly_assign(workhead[count]^[row], stash^[row]);
																 quoly_set(0, n);
																 qp := @ n;
																 free_work
															end																		 
										else begin
														n2 := nil; { flag to get_evalquoly }
														if qp = nil
															 then quoly_set(0, n)
															 else if n = nil
																			 then quoly_assign(qp^, n);
														get_evalquoly(inf, n, n2, count, flag, true);
														free_quoly(n2);
														qp := @ n
												 end
							end;
						 
			 while token.name = '' do
					begin
						 if qp = nil
								then quoly_set(0, n)
							  else if n = nil
								        then quoly_assign(qp^, n);  { Nov 1997 }
						 quoly_differen_once(n, 1);
						 qp := @ n;
						 scanner(inf, token, flag)
				  end
										 
    end;

  {*********************************************************************}
	
	procedure mod_or_div(var n, n2, n3: number; which: char);
	
		 { in infinit prec, must assume n2 is real. Caution: n3 and n may be the same! }
	
	   var x: longreal;
		     n6: number;

		 begin
		 
				if complex
				   then begin
									quot(n, n2, n3);
									complex_great_int(n3, n3);
									{ n3 is the div }
									if which = '|'
									   then begin
										         n6.size := 0;   
														 n6.imag := nil; 
														 mult(n2, n3, n6);
														 sub(n, n6, n3);
														 { n3 is the remainder }
														 if pos_mod and (n2.imag = nil) and (n2.float > 0)
															  then begin
																			  if n3.float < 0
																				   then n3.float := n3.float + n2.float;
																			  if (n3.imag <> nil) and (n3.imag^.float < 0) 
																				   then n3.imag^.float := n3.imag^.float + n2.float;
																		 end;
														 imag_free(n6)
													end
								end
					 else begin
					         if n2.float = 0
											 then begin
															 error(22, token);
															 complex_set(0, n3);
															 exit {(mod_or_div)}
														end;
									 x := round(n.float/n2.float); {@@@}
									 if which = '|'
										  then begin
														  n3.float := n.float - x*n2.float;
														  if pos_mod and (n3.float < 0) and (n2.float > 0)
																 then n3.float := n3.float + n2.float
													 end
										  else n3.float := x
								end
											
			end;

  {**************************************************************************}

  procedure poly_mod_or_div(n, m: ferm118.poly; var p: ferm118.poly; which: char);
	
    var q, t, s: ferm118.poly;
				
		{ p always nil on entry }
		
		procedure gen_case(n, m: ferm118.poly; var p: ferm118.poly);  
		   var height: integer;
			     p2: ferm118.poly;
					 pr: polyptrr;  
		   begin
					height := 0;
					p2 := nil;
					if (n^.exp = 0) and (m^.exp = 0)
						 then begin
										 repeat 
												n := n^.pcoef;
												m := m^.pcoef;
												Inc(height)
										 until (n^.exp > 0) or (m^.exp > 0)									         																			 																				 																					
									end;
									
					if n^.exp = 0   
						 then if which = '|'
								     then poly_assign(n, p)
									   else poly_set(0, p)
										 
					else if m^.exp = 0  { can't be a number }
					    then begin
						          poly_assign(n, p);
										  pr := @ p;
										  while pr^ <> nil do
										     if pr^^.numb
														then if which = '|'
																		then pr := @ pr^^.next
																		else free_poly(pr^)
														else begin
																		poly_mod_or_div(pr^^.pcoef, m^.pcoef, p2, which);
																		free_poly(pr^^.pcoef);
																		if poly_iszero(p2)
																			 then begin
																							 free_poly(p2);
																							 p2 := pr^;
																							 pr^ := p2^.next;
																							 p2^.next := nil;
																							 free_poly(p2)
																						end
																			 else begin
																							 if p2^.numb and (pr^^.exp = 0)
																							    then begin
																									        free_poly(pr^);
																													pr^ := p2
																									     end
																							     else pr^^.pcoef := p2;
																							 p2 := nil;
																							 pr := @ pr^^.next
																						end
																 end;
										  if p = nil
										     then poly_set(0, p)
						       end
												
					else if (number_polys = 1) or ( height_is_1(n) and height_is_1(m) )
						 then begin
										 basic_poly_divide(n, m, p, q);
										 if which = '|'
												then begin
																free_poly(p);
																p := q
														 end
												else free_poly(q)
									end
						 else if which = '|'
										 then pseudo_div_no_q(n, m, p)
										 else pseudo_div(n, m, p, p, false);
					if (height > 0) and not p^.numb
						 then add_pad(p, height)					
			 end;
			 
		{________________________________________________________________________}
 
    begin
		
		    q := nil;
				if m^.numb and n^.numb and (m^.next = nil) and (n^.next = nil)
				   then begin
					         newpoly(q);
									 q^.numb := true;
									 q^.exp := 0;
									 q^.next := nil;
					         newimag(q^.ncoef);
									 q^.ncoef^.imag := nil;
									 mod_or_div(n^.ncoef^, m^.ncoef^, q^.ncoef^, which);
								   free_poly(p);
									 p := q
								end
		    else if m^.numb and (m^.next = nil)
				   then begin
					         t := nil;
									 s := nil;
									 { At the end of each pass through this loop, s and t are equal and
									   point to the last node actually attached to the output list q. 
										 During the loop, a new node is tentatively attached to t. }
					         while n <> nil do
									    begin
					               if t = nil
									          then begin
											              newpoly(q);
															      t := q
													       end
											      else begin
											              newpoly(t^.next);
															      t := t^.next
													       end;
									       t^.numb := n^.numb;
									       t^.exp := n^.exp;
					               if t^.numb
									          then begin
											              init_poly_node(t);
									                  mod_or_div(n^.ncoef^,  m^.ncoef^, t^.ncoef^, which);
																		if node_iszero(t)
																		   then begin  { move back one node }
																			         t^.next := nil;
																			         free_poly(t);
																							 t := s
																						end
																			 else s := t
											           end
											      else begin
											              t^.pcoef := nil;
															      poly_mod_or_div(n^.pcoef, m, t^.pcoef, which);
																		if poly_iszero(t^.pcoef)
																		   then begin  { move back one node }
																			         t^.next := nil;
																			         free_poly(t);
																							 t := s
																						end
																			 else s := t
													       end;
									       n := n^.next
								      end;
									 if t <> nil
									    then begin
											        t^.next := nil;
									            free_poly(p);
									            p := q
													 end
											else poly_set(0, p)
								end
				else if n^.numb and (n^.next = nil)
				        then if which = '|'
								        then poly_assign(n, p)
									      else poly_set(0, p)
				else if laurent 
				        then if anynegs(n) or anynegs(m)
								        then error(205, token)
												else gen_case(n, m, p)									    
				else gen_case(n, m, p)	
					
    end;
		
	{***************************************************************************}

  procedure quoly_mod_or_div(n, m: quoly; var p: quoly; which: char);
	
	   { just look at numers. }
	
	   var q: quoly;
		     m2: ferm118.poly;
	
	   begin
		 
		    newquoly(q);
				
				if m^.numb and n^.numb
				   then begin
									 q^.numb := true;
					         newimag(q^.ncoef);
									 q^.ncoef^.imag := nil;
									 mod_or_div(n^.ncoef^, m^.ncoef^, q^.ncoef^, which);
								   free_quoly(p);
									 p := q;
									 exit {(quoly_mod_or_div)}
								end;
												
				q^.numer := nil;
				q^.denom := nil;
				q^.numb := false;
				if m^.numb
				   then begin
									 m2 := nil;
									 quoly_to_poly(m, m2);
									 poly_mod_or_div(n^.numer, m2, q^.numer, which);
								   free_poly(m2)						 									 
								end
				else if n^.numb
				   then begin
									 m2 := nil;
									 quoly_to_poly(n, m2);
									 poly_mod_or_div(m2, m^.numer, q^.numer, which);
								   free_poly(m2)
								end
				else poly_mod_or_div(n^.numer, m^.numer, q^.numer, which);
				
				if q^.numer^.numb and (q^.numer^.next = nil)
					 then polynum_to_quoly(q);
				free_quoly(p);
				p := q
				
		end;
					         
	{**************************************************************************}
	
  procedure term(var inf: text; var qp: quolyptr; var n: quoly; 
                 var aux: colm_ptrptr; var colpos: longint; var flag: nameptr);
                 
    { Nov 1997. all new. }

    var n2: quoly;
        key: char;
				qp2: quolyptr;
				
    begin

      fact(inf, qp, n, aux, colpos, flag);
			
			n2 := nil;
			key := token.name[1];
      while (key in big_term_set) or ((key >= 'a') and (key <= 'z')) 
						or ((key >= 'A') and (key <= 'Z')) do
        
				case key of 
				    '*', '\', '|', '/' :
				       begin
							   scanner(inf, token, flag);
							   if qp = nil
			              then begin
			                      quoly_set(0, n);
			                      qp := @ n
			                   end;
                 fact(inf, qp2, n2, aux, colpos, flag);
                 if qp2 = nil
                    then begin
                            quoly_set(0, n2);
                            qp2 := @ n2
                         end;
                 if key = '*'
                    then quoly_mult(qp^, qp2^, n)
                    else if key = '/'
                            then quoly_quot(qp^, qp2^, n)
                            else quoly_mod_or_div(qp^, qp2^, n, key);
                 if n2 <> nil
                    then free_quoly(n2);
                 qp := @ n;
								 key := token.name[1]
               end;
						else begin
												 if qp = nil
							              then begin
							                      quoly_set(0, n);
							                      qp := @ n
							                   end;
			                   fact(inf, qp2, n2, aux, colpos, flag);
												 if qp2 = nil
				                    then begin
				                            quoly_set(0, n2);
				                            qp2 := @ n2
				                         end;
                         quoly_mult(qp^, qp2^, n);
												 if n2 <> nil
												    then free_quoly(n2);
												 qp := @ n;
												 key := token.name[1];
											end
				end
							 
    end;

	{**************************************************************************}
	
  procedure old_term(var inf: text; var n: quoly; var flag: nameptr);

    var n2: quoly;
        key: char;
				
    begin

      old_fact(inf, n, flag);
      			
			n2 := nil;
			key := token.name[1];

      while (key in big_term_set) or ((key >= 'a') and (key <= 'z')) or  
						((key >= 'A') and (key <= 'Z')) do
        
				case key of
				    '*', '\', '|', '/' :
				       begin
							   scanner(inf, token, flag);
                 old_fact(inf, n2, flag);
                 if key = '*'
                    then quoly_mult(n, n2, n)
                    else if key = '/'
                            then quoly_quot(n, n2, n)
                            else quoly_mod_or_div(n, n2, n, key);
                 free_quoly(n2);
								 key := token.name[1]
               end;
						else begin
												 old_fact(inf, n2, flag);
												 quoly_mult(n, n2, n);
												 free_quoly(n2);
												 key := token.name[1]
											end
				end
							 
    end;

  {**************************************************************************}

  procedure old_expre; { (var inf: text; var n: quoly; var flag: nameptr) } 
  
    { Nov 1997.  Check all invocations of expre and replace most with this. }

    var n2: quoly;
        oldtoken: tokentipe;

    begin

      old_term(inf, n, flag);	
      
      while (token.name = '+') or (token.name = '-') do
				 begin				
						oldtoken := token;
						scanner(inf, token, flag);
						n2 := nil;
						old_term(inf, n2, flag);
						if oldtoken.name = '+'
							 then best_quoly_add(n, n2)
							 else best_quoly_sub(n, n2)        
				 end
				
    end;
		
  {**************************************************************************}

  procedure expre; { var inf: text; var qp: quolyptr; var n: quoly; 
                     var aux: colm_ptrptr; var colpos: longint; var flag: nameptr } 

    { massive changes Nov 1997. assignment and increment statements now handled here. }
    
    var n2: quoly;
        plus, needto: boolean; 
        incval: longreal;

    {---------------------------------------------------------------------}

    procedure get_incr_needto(var incr: longreal; var need: boolean; var n: quoly);
		
		   { need true means we later have to create and set n. 
			   If integerflag, we never touch n.  Notice incr could be 0. 
			   integerflag stuff changed, Nov 1997.  n (if set here) is the increment. }
			 
			 var key: char;
			     minus: boolean;
			     lp: floatptr;   { Nov 1997 }
					 
		   begin
			    
					minus := (token.name = '-');
					scanner(inf, token, flag);
					key := token.name[1];
					need := true; 
					if ((key >= 'a') and (key <= 'z')) or ((key >= '0') and (key <= '9'))
						 or (key = '(')
						 then if realflag
										 then begin
										         ifact(lp, incr, flag);
										         if lp = nil
										            then error(77, token);
										         incr := lp^
										      end
										 else begin
														old_fact(inf, n, flag);
														if not n^.numb
															 then error(253, token);
														if complex
														   then if n^.ncoef^.imag <> nil
															         then error(250, token);  { Dec 1997 }
														need := false;  { because we just got n }
														incr := n^.ncoef^.float;
													end
						 else incr := 1;
					if minus
						 then incr := -incr
			 
			 end;
			 
		{--------------------------------------------------------------------}
		
		procedure increment(qp: quolyptr; var n: quoly; needto: boolean; var incr: longreal); 
		   
			 { incr already set. If needto, we don't actually have n yet.  
			   It's now ok to increment a poly (July 1995), even a laurent. 
			   Nov 1997: changed incr to var parameter, to allow output. }
			 
			 var im: imptr;
					 val: longreal;
       
			 {...............................................................}
			 
			 procedure add_to_im;  { sets val to new value of the (numerical) variable. }
			    begin
					   with im^ do
								 begin
										 float := float + incr;  
										 val := float
								 end
					end;
					
			 {..................................................................}
			 
			 procedure do_poly(var n: ferm118.poly);
			    { n is not a number (only), so incrementing it cannot make it 0.
			      Nov 1997: changed so that incr = 0 is allowed.  This was an inconsistency,
			      in that val is supposed to be the new value of the numerical part of the
			      variable.  This procedure sets val. }
					var s: polyptrr;
					    t: ferm118.poly;
					begin
						 s := @ n;
						 while s^^.exp > 0 do
							  begin
									 s := @ s^^.next;
									 if s^ = nil
										  then break
							  end;
						 if s^ = nil
							  then begin
											  if incr <> 0
											     then poly_set_ext(incr, s^);
											  val := incr
										 end
						 else if s^^.exp < 0
										 then begin
														 if incr <> 0
														    then begin
														            t := s^;
														            s^ := nil;
														            poly_set_ext(incr, s^);
														            s^^.next := t
														         end;
														 val := incr
												  end
						 else if s^^.numb
										 then begin
														 im := s^^.ncoef;
														 add_to_im; { sets val }
														 if node_iszero(s^)
															  then begin
																			  t := s^^.next;
																			  s^^.next := nil;
																			  free_poly(s^);
																			  s^ := t
																		 end
												  end
						 else do_poly(s^^.pcoef)  { it can't become 0 }
			    end;
			 
			 {.................................................................}
			 
			 begin
			 
			    if qp^^.numb
					   then begin
						         im := qp^^.ncoef;
										 add_to_im;
								  end
						 else if qp^^.denom <> nil 
						         then error(196, token)  { change below, drop an 'else', Nov 1997 }
						 else do_poly(qp^^.numer);
					if needto  { Nov 1997 }
						 then quoly_set_ext(val, n)
						 else n^.ncoef^.float := val;
				  incr := val { Nov 1997 }		 
			 end;
			 
    {---------------------------------------------------------------------}
    
    begin

      term(inf, qp, n, aux, colpos, flag);	
      
      if token.name = ':' { Nov 1997. assignment statement, or final ':' for no-print }
         then begin
                 scanner(inf, token, flag);
                 incval := 1;
                 if token.name = '='
                    then begin
                            if n <> nil
                               then error(327, token);
                            scanner(inf, token, flag);
                            old_expre(inf, n, flag);
                            if qp = nil
														   then sparse_zero_set(aux, colpos, qp);
														free_quoly(qp^);
														qp^ := n;
														if n^.numb
														   then begin
														           n^.ncoef^.size := 0;  { sneaky }
														           incval := n^.ncoef^.float
										                end;
										           { else incval = 1 }
										        n := nil;
										        if flag = nil
										           then quoly_assign(qp^, n)
										           else quoly_set(0, n)
                         end
                 else if (token.name = '+') or (token.name = '-')
										then begin
										        if n <> nil
                               then error(327, token);
                            get_incr_needto(incval, needto, n);
														if qp = nil
														   then sparse_zero_set(aux, colpos, qp);
														increment(qp, n, needto, incval)
														{ n is the new value of the numerical part of the variable. }
												 end
								 else if (token.name = ';') and (flag = nil)
										then begin
										        quoly_set(0, n);
														token.name := ':'  { the no-display signal }
												 end
								    else error(328, token);
								 if (aux <> nil) and (incval = 0)
										then purge_sparse(aux, colpos);
								 qp := @ n;
								 exit {(expre)}
							end;                    
      
      while (token.name = '+') or (token.name = '-') do
				 begin				
						plus := (token.name = '+');
						scanner(inf, token, flag);
						if n = nil
						   then if qp = nil
                       then quoly_set(0, n)
                       else quoly_assign(qp^, n);
			      n2 := nil;
						term(inf, qp, n2, aux, colpos, flag);
						if qp = nil
						   then begin
						           quoly_set(0, n2);
						           qp := @ n2
						        end;
						if plus
							 then if n2 = nil
							         then better_quoly_add(n, qp^, n)
							         else best_quoly_add(n, n2) 
							 else if n2 = nil
							         then better_quoly_sub(n, qp^, n) 
							         else best_quoly_sub(n, n2);
					  qp := @ n        
				 end
				
    end;
	
  {******************************************************************************}
  
  procedure half_fact(var inf: text; var n: quoly; var flag: nameptr);
  
     { Nov 1997.  part of the grammar revision. n is a poly var equiv on input. }
     
     var n2: quoly;
				 m, m2: number;
				 dumm: longint;
     
     begin
     
  			m.size := 0;  m.imag := nil;
				m2.size := 0;  m2.imag := nil;
  			if token.name = '^'
					 then begin
									 get_exponent(inf, flag, m2);
									 if not complex
										  then if m2.float = trunc(m2.float)
														  then raise_to_power(n, m2)
														  else begin
																			if n^.numb
																				 then quoly_to_scalar(n, m)
																				 else begin
																								free_quoly(n);
																								error(117, expsign)
																							end;
																			if m.float <= 0
																				 then error(34, logsign)
																				 else m.float := ln(m.float);
																			mult(m, m2, m);
																			m.float := exp(m.float);
																			scalar_to_quoly(m, n)
																	 end
										  else raise_to_power(n, m2);
								  imag_free(m2);
							 end
				else if token.name = '!'
					 then begin
									 if n^.numb
											then quoly_to_scalar(n, m)
											else begin
															free_quoly(n);
															error(115, factsign)
													 end;
									 scanner(inf, token, flag);
									 factorial(m);
									 scalar_to_quoly(m, n);
								end
				else if token.name = ''
					 then begin
									 scanner(inf, token, flag);
									 n2 := nil; { flag to get_evalquoly }
									 get_evalquoly(inf, n, n2, dumm, flag, true);
									 free_quoly(n2)
								end;
						 
			 while token.name = '' do
					begin
					   quoly_differen_once(n, 1);
						 scanner(inf, token, flag)
				  end

     end;
     
  {******************************************************************************}
  
  procedure half_term(var inf: text; var n: quoly; var flag: nameptr);
  
     { Nov 1997.  part of the grammar revision.  }
     
     var n2: quoly;
				 key: char;
				 
		 begin
		 
		    n2 := nil;
		    key := token.name[1];
		    
		    while (key in big_term_set) or ((key >= 'a') and (key <= 'z')) or   
						((key >= 'A') and (key <= 'Z')) do
        
					case key of 
					    '*', '\', '|', '/' :
					       begin
								   scanner(inf, token, flag);
								   old_fact(inf, n2, flag);
	                 if key = '*'
	                    then quoly_mult(n, n2, n)
	                    else if key = '/'
	                            then quoly_quot(n, n2, n)
	                            else quoly_mod_or_div(n, n2, n, key);
	                 if n2 <> nil
	                    then free_quoly(n2);
									 key := token.name[1]
	               end;
							else begin
													 old_fact(inf, n2, flag);
													 quoly_mult(n, n2, n);
													 if n2 <> nil
													    then free_quoly(n2);
													 key := token.name[1]
												end
					end
				
		 end;

  {******************************************************************************}
  
  procedure half_expre; {var inf: text; var n: quoly; var flag: nameptr; targ: longint}
  
     { Nov 1997,  new grammar. n is already partially defined. }
     
     var n2: quoly;
         oldtoken: tokentipe;
     
     begin
        
        case token.name[1] of
           '^', '', '!', '': half_fact(inf, n, flag);
           else { nothing }
        end;
        
        half_term(inf, n, flag);
			  
			  while (token.name = '+') or (token.name = '-') do
				   begin				
							oldtoken := token;
							scanner(inf, token, flag);
							n2 := nil;
							old_term(inf, n2, flag);
							if oldtoken.name = '+'
								 then best_quoly_add(n, n2)
								 else best_quoly_sub(n, n2)        
				   end
     
     end;                 
  
	{***************************************************************************}	
	
	procedure iarretrieve(x: tokentipe; var qp: quolyptr; var flag: nameptr; var 
	                      sparse: boolean); forward;  { Nov 1997 }
													
  {***************************************************************************}
	
  procedure ibinom(var n: longreal; var flag: nameptr);
	
	   var n2: longreal;
		     m: quoly;
		 
		 begin
		 
		    old_iexpre(n2, flag);
				if (n2 < 0) or (n2 > n)
				   then n := 0
					 else begin
					          m := nil;
										float_binom(round(n), round(n2), m);
										n := m^.ncoef^.float;
										free_quoly(m)
								end
		 
		 end;
	
  {***************************************************************************}
	
  procedure ifact; {var lp: floatptr; var n: longreal; var flag: nameptr}
	  
	  { Changed Nov 1997.  np <> nil and points to the value, unless it's an
	    assignment to a sparse array element.  In that case, np = nil and flag 
	    is reset so that iexpre can reparse it.  np might point to n or it 
	    might point to a storage longint, shouldn't matter to the caller,
	    who will not directly use n in any event. }
			
	  var m: number;
		    q: quoly;
				colflag, negative: boolean;
		    row, count, colpos: longint;
				oldtok: tokentipe;
				np: numptr;
				qp: quolyptr;
				p, copy: nameptr;
				mate: char;
				x: longreal;
				aux: colm_ptrptr;  { Nov 1997 }
				vp: varptr;        { Nov 1997 } 
	
	  begin
		 
		  if flag^.compiled
			    then case flag^.tipe of
					        one: begin
									        lp := @ flag^.qp^^.ncoef^.float;
													flag := flag^.next;
													token := flag^.let
											 end;
									two: begin
													lp := @ flag^.qp^^.ncoef^.float;
													flag := flag^.next^.next;
													repeat
													   flag := flag^.next
													until flag^.let.name = ']';
												  flag := flag^.next;
													token := flag^.let
											 end;
									three: begin
									          p := flag;
														flag := flag^.next^.next;
		                        token := flag^.let;
														ievalcoords(row, count, flag, colflag);
														flag := flag^.next;
													  token := flag^.let;
														np := numptr(p^.qp);
														row := np^.value + row - addresser; { changed Oct 1993 }
														if colflag
														   then row := row + (count - addresser) * np^.next^.value;
														lp := @ arp[row shr 10]^[row and tenmask]^.ncoef^.float
									       end
							 end
			 else if (token.name[1] >= 'a') and (token.name[1] <= 'z')
							 then begin
											 oldtok := token;
											 copy := flag;
											 flag := flag^.next;
											 token := flag^.let;
											 if token.name = '['   { Nov 1997, all new }
													then begin
													        iarretrieve(oldtok, qp, flag, negative);
													        if negative and (token.name = ':')  { sparse assign }
													           then begin
													                   lp := nil;{ set up for iexpre to reparse }
													                   flag := copy { note: we don't reset token }
													                end
													           else if qp = nil  { sparse array, in an expression }
																	           then begin
																	                   n := 0;
																	                   lp := @ n
																	                end
																	           else lp := @ qp^^.ncoef^.float
															 end
													else begin
													        iretrieve(oldtok, qp);  { Nov 1997 }
													        if qp = nil { var not defined }
													           then if token.name = ':' { assignment, new form. Nov 1997 }
													                   then begin   
													                           q := nil;
													                           quoly_set(0, q);
													                           insert(oldtok, q, vp);
													                           q := nil;
													                           qp := @ vp^.val
													                        end
													                   else error(19, oldtok);
													        lp := @ qp^^.ncoef^.float
													     end 
										end
       else if (token.name[1] >= '0') and (token.name[1] <= '9')
							 then begin
							         m.size := 0;  m.imag := nil;
											 new_readin(userInput, m, flag, count);
											 if (token.name = 'e') or (token.name = '.')
												  then expon_form(userInput, m, flag, count);
											 n := m.float;
											 lp := @ n;
									  end
			 else if token.name = '('
							 then begin
											 flag := flag^.next;
											 token := flag^.let;     
											 old_iexpre(n, flag);  { Nov 1997 }
											 lp := @ n;
											 if token.name <> ')'
												  then error(1, token)
												  else begin
						                      flag := flag^.next;      
																	token := flag^.let
															 end
										end
        
       else if token.name = '-'
							 then begin
											 flag := flag^.next;       
									     token := flag^.let;
											 ifact(lp, n, flag);
											 if lp = nil
											    then error(77, token);
											 n := - lp^;
											 lp := @ n 
									  end
			 else if token.name = ''
							 then begin
							         flag := flag^.next;       
									     token := flag^.let;
											 n := pii.float;
											 lp := @ n 
							      end
			 
			 else if token.name = '|'
								then begin
												flag := flag^.next;    
						            token := flag^.let;
												ifact(lp, n, flag);
												if lp = nil
											     then error(77, token);
												if token.name <> '|' then error(63, token);
												n := abs(lp^);
												lp := @ n;
												flag := flag^.next;       
						            token := flag^.let														
										 end
			 
			 else if token.name = '^'
						  then begin
										  flag := flag^.next;                
											token := flag^.let;
											ifact(lp, n, flag);
											if lp = nil
											   then error(77, token);
											n := exp(lp^);
											lp := @ n 
								   end
			 else if token.name = '_'
							then begin
											flag := flag^.next;                
											token := flag^.let;
											ifact(lp, n, flag);
											if lp = nil
											   then error(77, token);
											if lp^ <= 0
											   then error(34, logsign);
											n := ln(lp^);
											lp := @ n 
									end
			 else if token.name = ''
							then begin
											flag := flag^.next;                
											token := flag^.let;
											ifact(lp, n, flag);
											if lp = nil
											   then error(77, token);
											if lp^ < 0
											   then error(37, sqrtsign);
											n := sqrt(lp^);
											lp := @ n 
									 end
			 
			 else if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
							then begin
											count := find_built_in(0, numbuiltins, token.name);
											q := nil;
											if count = -1
												 then evaluate(userInput, token, q,  flag)
											else if builtin[count, 2] <> ''
														 then begin
																		 token.name := builtin[count, 2];
																		 fact(userInput, qp, q, aux, colpos, flag)
																	end
											else builtin_func(userInput, q, flag, count);
											if q = nil { not sure this is possible }
											   then n := 0
												 else begin
												         if not q^.numb
												            then error(253, token);
																 n := q^.ncoef^.float;
																 free_quoly(q)
															end;
											lp := @ n
									 end
			 
			 else if (token.name = '`') or (token.name = '"') or (token.name = '%')
							 then begin
											 oldtok := token;
											 flag := flag^.next;                
											 token := flag^.let;
											 ifact(lp, n, flag);
											 if lp = nil
											    then error(77, token);
											 case oldtok.name[1] of 
													'`': n := sin(lp^);
													'"': n := cos(lp^);
													'%': n := sin(lp^)/cos(lp^)
											 end;
											 lp := @ n
										end
											
		   else if (token.name = '') or (token.name = '')
							 then begin
											 oldtok := token;
											 obtain_sum(userInput, flag, p);
											 copy := p;
											 token := p^.let;
											 if token.name <> '<'
													then error(144, token);
											 q := nil;  { q will not be touched }
											 sum_mult_up(oldtok.name, userInput, q, p, false, n, mate);  
											 if flag = nil
													then freename(copy)  { copy not changed }
													else flag := p;
											 if token.name[1] <> mate
													then error(312, token); 
											 lp := @ n;
											 flag := flag^.next;        
											 token := flag^.let
										end
										
			 else if token.name = ''
							 then begin
											 q := nil;
											 copy := flag;
											 oldtok := token;
											 get_arr_arr(userInput, q, flag, count);
											 if arrstash[count] = nil
													then error(247, token);
											 flag := flag^.next;                
											 token := flag^.let;
											 if token.name <> '['
													then error(244, token);
											 spec_arretrieve(userInput, flag, arrstash[count], qp, aux, colpos);
											 if (aux <> nil) and (token.name = ':')  { sparse assign }
							            then begin
							                    lp := nil;{ set up for iexpre to reparse }
							                    flag := copy
							                 end
							            else if qp = nil  { all this new, Nov 1997 }
											            then begin
											                    n := 0;
											                    lp := @ n
											                 end
											            else lp := @ qp^^.ncoef^.float;
											 free_quoly(q)
										end
										
			 else if token.name = '$'
							 then begin
											 flag := flag^.next;                
											 token := flag^.let;
											 ifact(lp, n, flag);
											 if lp = nil
											    then error(77, token);
											 n := trunc(lp^);
											 lp := @ n
									  end
										
			 else if token.name = ''  { arctangent }
							 then begin
											 flag := flag^.next;                
											 token := flag^.let;
											 ifact(lp, n, flag);
											 if lp = nil
											    then error(77, token);
											 n := arctan(lp^);
											 lp := @ n
										end
									
			 else if token.name = ''
						  then begin
										  flag := flag^.next;                
											token := flag^.let;
											if token.name <> '('
											   then error(177, token);
											flag := flag^.next;                
											token := flag^.let;
											old_iexpre(n, flag);
											if token.name <> ','
											   then error(202, token);
											flag := flag^.next;                
											token := flag^.let;
											ibinom(n, flag);
											lp := @ n;
											if token.name <> ')'
											   then error(1, token);
											flag := flag^.next;                
											token := flag^.let
								   end
			 
			 else if token.name = '' { determinant }
							 then begin                                 
							         q := nil;
											 arr_parse('', userInput, q, flag);
											 if q = nil  { not sure this is possible }
											    then n := 0
													else begin
													        n := q^.ncoef^.float;
																  free_quoly(q)
															 end;
											 lp := @ n
										end
										
	     else if token.name = ''
								then begin
												flag := flag^.next;    
						            token := flag^.let;
												if token.name = '['
												   then begin
													         if syst^.stop = -1
																		  then error(175, token);
																	 flag := flag^.next;    
						                       token := flag^.let;
																	 ievalcoords(row, count, flag, colflag);
																	 get_quoly_ptr(syst, row, count, colflag, qp, token, true);
																	 if qp = nil
																		  then n := 0
																		  else begin
																						  if qp^ = nil
																								 then begin
																												 writeln(userOutput, 'Warning. uninitialized array element in [].');
																												 writeln(userOutput, '  Will use 0.');
																												 quoly_set(0, qp^)
																										  end;
																						  n := qp^^.ncoef^.float
																					 end;
																	 flag := flag^.next;    
						                       token := flag^.let
													      end
													 else n := prevnum^.ncoef^.float;
												lp := @ n
										 end
										 
			 else case token.name[1] of
							{':',} '@', '&', '!', '?', '', '':
								    begin
											 q := nil;
											 parse(userInput, q, flag);     
											 if q = nil  { definitely is possible }
											    then n := 0
													else begin
													        if not q^.numb
													           then error(253, token);
																  n := q^.ncoef^.float;
																  free_quoly(q)
															 end;
											 lp := @ n
										end;
								else error(252, token)
						end;
						
			 if token.name = '^'
					 then begin
									 flag := flag^.next;
				           token := flag^.let;
									 n := lp^;
				           ifact(lp, x, flag);
									 if lp = nil
											then error(77, token);
									 x := lp^;
									 if x = trunc(x)
									    then inumber_power(n, round(x))	
											else begin
											        if n <= 0
																 then error(34, expsign);
															n := exp(x*ln(n))
											     end;
									 lp := @ n	
								end
			 else if token.name = '!'
							 then begin
											 m.size := 0;   m.imag := nil;
											 m.float := n;
											 factorial(m);
											 n := m.float;
											 lp := @ n;
											 flag := flag^.next;       
						           token := flag^.let
										end
			 
		end;
												 
	{**************************************************************************}
	
  procedure iterm(var lp: floatptr; var n: longreal; var flag: nameptr);

    { Nov 1997, big changes }
    
    var n2, x: longreal;
        key: char;
				
    begin

      ifact(lp, n, flag);
			
			key := token.name[1];
      while key in term_set do
			    begin
			       { lp can't be nil. }
						 flag := flag^.next;        
						 token := flag^.let;
						 n := lp^;
						 ifact(lp, n2, flag);
						 if lp = nil
						    then error(77, token);  
						 n2 := lp^;
						 if key = '*'
								then n := n * n2
								else if n2 = 0
												then error(22, token)
												else if key = '/'
																then n := n / n2
																else begin
																        x := trunc(n/n2);
																				if key = '|'
																				   then begin
																					         n := n - x*n2;
																									 if pos_mod and (n < 0)
															                        then n := n + n2
																						    end
																					 else n := x
																		 end;
						 key := token.name[1];
						 lp := @ n
					end
							 
    end;

  {**************************************************************************}

  procedure old_iexpre; {(var n: longreal; var flag: nameptr);}
  
    { Nov 1997 }

    var n2: longreal;
        plus: boolean;
        lp: floatptr;

    begin

      iterm(lp, n, flag);
      if lp = nil
         then error(129, token)
         else n := lp^;
      	
      while (token.name[1] = '+') or (token.name[1] = '-') do
				 begin				
						plus := (token.name[1] = '+');
						flag := flag^.next;                
						token := flag^.let;
						iterm(lp, n2, flag);
						if lp = nil
               then error(129, token)
               else n2 := lp^;
						if plus
							 then n := n + n2
							 else n := n - n2      
				 end
				
    end;
		
  {**************************************************************************}

  procedure iexpre; {(var n: longreal; var flag: nameptr)} 
  
    { massive changes, Nov 1997, to accomodate new Maple-like syntax }

    var r, c : longint;
		    n2: longreal;
        lp: floatptr;
        plus, colflag: boolean;
        q: arrptr;

    {---------------------------------------------------------------------}

    procedure get_incr(var incr: longreal);
		
		   { Notice incr could be 0. 
			   integerflag stuff changed, Nov 1997. }
			 
			 var key: char;
			     minus: boolean;
			     lp2: floatptr;  { Nov 1997 }
					 
		   begin
			    
					minus := (token.name = '-');
					flag := flag^.next;        
					token := flag^.let;
					key := token.name[1];
					if ((key >= 'a') and (key <= 'z')) or ((key >= '0') and (key <= '9'))
						 or (key = '(')
						 then begin
						         ifact(lp2, incr, flag);
						         if lp2 = nil
						            then error(68, token);
						         incr := lp2^
						      end
						 else incr := 1;
					if minus
						 then incr := -incr
			 
			 end;
			 
    {---------------------------------------------------------------------}

    procedure reparse_sparse;
    
       var oldtok: tokentipe;
           
       begin
          oldtok := token;
          flag := flag^.next;     
					token := flag^.let;
					if token.name <> '['
					   then fermat_error('reparse sparse failure, 1 ', true);
					flag := flag^.next;   
			    token := flag^.let;
		      ievalcoords(r, c, flag, colflag);
					flag := flag^.next;                  
					token := flag^.let;
		      array_seek(oldtok, q);
		      { q can't be nil }
		      if q = nil
		         then fermat_error('reparse sparse failure, 2 ', true);
		      if q^.spar = nil
		         then fermat_error('reparse sparse failure, 3 ', true);
		      if token.name <> ':'
		         then fermat_error('reparse sparse failure, 4 ', true)
		      
       end;
       
    {---------------------------------------------------------------------}
       
    begin

      iterm(lp, n, flag);

      if token.name = ':' { Nov 1997. assignment statement }
         then begin
                 if lp = nil
                    then begin
                            token := flag^.let; { flag was reset by ifact, but not token }
                            reparse_sparse { sets q, r, c, colflag; lp still nil }
                         end;
                 flag := flag^.next;
						     token := flag^.let;
                 if token.name = '='
                    then begin
                            flag := flag^.next;
						                token := flag^.let;
                            old_iexpre(n, flag);
                            if lp = nil
                               then isparse_insert(r, c, n, q, colflag, true)
                               else lp^ := n
                         end
                 else if (token.name = '+') or (token.name = '-')
										then begin
										        get_incr(n);
														if lp = nil
                               then isparse_insert(r, c, n, q, colflag, false)
                               else lp^ := lp^ + n
												 end
								 else error(328, token); { Note, the no-display signal ':' is not allowed }
								 n := 0;
								 exit {(iexpre)}
							end;

      while (token.name[1] = '+') or (token.name[1] = '-') do
				 begin				
						plus := (token.name[1] = '+');
						flag := flag^.next;
						token := flag^.let;
						{ lp can't be nil }
						n := lp^;
						iterm(lp, n2, flag);
						if lp = nil
						   then error(77, token);  { Nov 1997 }
						n2 := lp^;
						if plus
							 then n := n + n2
							 else n := n - n2;
						lp := @ n
				 end

    end;

  {****************************************************************************}
	
	procedure iarretrieve; { x: tokentipe; var qp: quolyptr; var flag: nameptr; var
	                         sparse: boolean }

    { big changes, Nov 1997 }
    
    var r, c: longint;
        q: arrptr;         { arrptr for array named x }
			  colflag: boolean;  { is a second coordinate present? }

    begin
      flag := flag^.next;       
			token := flag^.let;
      ievalcoords(r, c, flag, colflag);
			flag := flag^.next;                  
			token := flag^.let;
      lookup(x, r, c, q, qp, colflag);   
			{ q can't be nil }
			sparse := (q^.spar <> nil);
			if qp = nil  { sparse array, no entry }
			   then exit {(iarretrieve)};
			if qp^ = nil
         then quoly_set(0, qp^)  { Jan 1998; new grammar }
			   else if not qp^^.numb
			           then error(253, x)
    end;

  {***************************************************************************}	
	
	procedure set_quotient; {(m: quoly; var inf: text; var flag: nameptr)}   
	 
	   { m is used or freed. }
		 
		 var oldtok: tokentipe;
		     qp, qp2: quolyptr;
				 q: varptr;
				 q2: arrptr;
				 np: numptr;
				 colflag: boolean;
				 rows, cols, location: longint;
			
		 begin
			
				oldtok := token;
				if (flag <> nil) and flag^.compiled
					 then begin
									 qp := flag^.qp;
									 if flag^.tipe = two
											 then begin
															 flag := flag^.next^.next;
															 repeat
																	flag := flag^.next
															 until flag^.let.name = ']'
														end;
									 flag := flag^.next;
									 token := flag^.let
								end
					 else begin
					         qp := nil;
									 scanner(inf, token, flag)
								end;
				if (polynames <> nil) and its_a_polyname(oldtok.name)
					 then error(125, oldtok);
				
				if token.name = ')'
					 then if qp = nil
									 then begin
									         insert(oldtok, m, q);
													 m := nil
												end
									 else begin
													 if m^.numb
														  then m^.ncoef^.size := 0;
													 free_quoly(qp^);
													 qp^ := m;
													 m := nil
											  end
					else if token.name = '['
									then begin 
													if oldtok.name = ''
														 then error(176, oldtok);
													scanner(inf, token, flag);				
													if realflag
														 then ievalcoords(rows, cols, flag, colflag)
														 else evalcoords(inf, rows, cols, flag, ']', ',', colflag);
													scanner(inf, token, flag);  { should be ')' }
												  if qp = nil
														 then lookup(oldtok, rows, cols, q2, qp2, colflag)
														 else begin  { tipe three compiled reference }
																		 np := numptr(qp);
																		 location := np^.value + rows - addresser; 
																		 if colflag
																			  then location := location + (cols - addresser) * np^.next^.value;
																		 qp2 := @ arp[location shr 10]^[location and tenmask]
																  end;
												  if qp2 = nil
														 then sparse_insert(rows, cols, q2, colflag, m)
														 else begin
														         free_quoly(qp2^);
																		 qp2^ := m;
																		 m := nil
																	end
											end;
											
			 if m <> nil
			    then free_quoly(m);
			 if token.name <> ')'
					then error(1, token)
				
		end;
			
  {*****************************************************************************}
	
	procedure subarray(var inf: text; q: arrptr; var start, rows, cols, firstrow, 
	                   firstcol, total_rows: longint; var flag: nameptr);
										 
		{ firstrow and firstcol are coordinates.  the others are numbers. 
		  the subarray is rows X cols, initial spot at address 'start' in arp. 
			total_rows is number of rows in parent matrix. firstrow, firstcol are coords
			of upper-left-most spot. }
	
	   var lastrow, lastcol: longint;
		     colflag: boolean;
		 
		 begin
		 
		    scanner(inf, token, flag);
				if token.name = ','  { rows get default values }
				   then begin
					          firstrow := addresser;
										lastrow := q^.rows + addresser - 1;
								end
				else begin
			        	evalcoords(inf, firstrow, lastrow, flag, ',', '', colflag);
								if not colflag 
								   then if lastrow = addresser
									         then lastrow := firstrow
													 else lastrow := q^.rows + addresser - 1;
			         	if (q^.rows<firstrow) or (firstrow<addresser) or (q^.rows + addresser - 1<lastrow) or 
								   (lastrow<addresser)
								   then error(56, q^.name);
								if firstrow>lastrow
								   then error(57, q^.name)
						 end;
						 
				cols := q^.size div q^.rows;		  {spar} 		 
				
				firstcol := addresser;      
				lastcol := cols + addresser - 1;   { default values }
				if token.name = ','  
				   then begin
				           scanner(inf, token, flag);
								   if token.name = ']'
								      then colflag := true
			        	      else evalcoords(inf, firstcol, lastcol, flag, ']', '', colflag);
								   if not colflag  { means the second col coord was not there. }
								       then if lastcol = addresser
									            then lastcol := firstcol
												   	  else lastcol := cols + addresser - 1;
			         	   if (cols<firstcol) or (firstcol<addresser) or (cols + addresser - 1<lastcol) or 
									    (lastcol<addresser)
								      then error(58, q^.name);
								   if firstcol>lastcol
								      then error(59, q^.name)
						    end;
						 
				scanner(inf, token, flag);
				total_rows := q^.rows;
				rows := lastrow - firstrow + 1;
				cols := lastcol - firstcol + 1;
				if q^.spar = nil              
				   then start := q^.start
					 else start := 0;
				start := start + (firstcol - addresser) * total_rows + firstrow - addresser
				
		 end;
		 
	{*****************************************************************************}	
	
	procedure left_side;{ var inf: text; var q: arrptr; var rows, cols, start, total_rows, 
	                      firstrow, firstcol, target_rows: longint; var oldtok: tokentipe; 
											  var flag: nameptr; systok: boolean) }
											
		{ This is used by both arr_asstat, where it was originally, and built_in_func.  
		  Have to juggle some of the vars differently in the non-subarray case. 
			Must leave start = -1 and target_rows = 0 if not subarray. However, rows, 
			total_rows, and cols are correct in all cases. 
			  Nov 1997: much rearranging below.  Added systok, so [] now ok, as long as 
			it's not an assignment -- caller must check that. }
	
		var n: quoly;
		    m: longint;
				
		begin
		
	    { token = '[' on entry }
			start := -1;  target_rows := 0; { Nov 1997; flags to see if subarray was called }
			scanner(inf, token, flag);
			oldtok := token;     { Nov 1997 }
			if token.name = ''  { Nov 1997 }
			   then if systok 
			           then begin
							           if syst^.stop = -1
														then error(175, token);
							           scanner(inf, token, flag);
							           if token.name = '['
														then error(87, token);
							           if token.name <> ']'
									          then error(24, token);
									       scanner(inf, token, flag);
									       rows := syst^.rows;
									       total_rows := rows;
							           cols := (syst^.stop + 1) div rows;
							           q := syst;
							           exit {(left_side)}
							        end
							   else error(176, token);
								 
      if token.name = ''
			   then begin
				         n := nil;
								 get_arr_arr(inf, n, flag, m);
								 q := arrstash[m];
								 free_quoly(n);
								 if q = nil
									  then error(247, token)
				      end
				 else begin
				         if (token.name[1] < 'a') or (token.name[1] > 'z')
									 then error(42, token);
								 if (polynames <> nil) and its_a_polyname(token.name)
										then error(125, token);
								 if token.address = -1
									  then token.address := hash(token.name, 151);
								 q := arr_store[token.address];
								 while q <> nil do
									  if q^.name.name = token.name
										 	 then break
											 else q := q^.next
							end;

      if q = nil
         then rows := 0
         else rows := q^.rows;
      oldtok := token;
			start := -1;  target_rows := 0; {used as flags later to see if subarray was called }
      scanner(inf, token, flag);
      if token.name = '[' 
			   then if q=nil
				         then error(55, oldtok)
							   else subarray(inf, q, start, target_rows, cols, firstrow, firstcol,
							               total_rows, flag)
				 else begin
				        total_rows := rows;
								if rows <> 0
								   then cols := q^.size div rows
							end;
			if token.name<>']'
         then error(24, token);
      scanner(inf, token, flag)
			
	  end;
		
 {*****************************************************************************}
 
 procedure matrix_power(var arr: workarray; var arr_facts: arr_descr; 
                        var arr_free: boolean; expont: longint; var spar: sparseptr);
												
	  { take matrix arr to the expont power. If not sparse, return answer in arr. 
		  arr_free is true at end, unless perhaps expont = 1.
			   Calls to matrix mult are sneaky because often the two arrays (spar, spar2, 
			or arr, arr2) point to the same storage.  But then the arr_free, arr2_free is
			always correct, so no problem. 
			   Changed to right-to-left, Aug 1995. ~~~~~
			   Copied from fer220, Apr 1996 @@@ }
										 
    var i, k: longint;
		    arr2_free: boolean;
				dumm: quoly;
				arr2: workptr; 
				spar2: sparseptr; 
	     powerOf2 : longint;

		begin
		
			 if expont < 0
			    then begin
					        mat_invert(arr, arr, arr_free, arr_free, arr_facts[2], dumm, true, true, spar);
									arr_free := true;
									expont := -expont
							 end;
					
		   if expont = 1
					then exit {(matrix_power)}
			 else if expont = 0 
					then begin  { return identity matrix. }
					        if spar = nil
					           then identi(arr, arr_facts[2], arr_free)
										 else spar_identi(spar, arr_facts[2], arr_free);
									arr_free := true;
								  exit {(matrix_power)}
							 end;
															 
			 { now expont >= 2 }
			 spar2 := nil;
			 if spar = nil   {@@@}
			    then begin
			            new_worknode(i, expsign);																		 
			            arr2 := workhead[i]
			         end;
			 if spar = nil
				  then for i := 0 to arr_facts[1] - 1 do
								  arr2^[i] := arr[i]
				  else spar2 := spar;
			 arr2_free := false;	
			 
			 {Note that arr2 is UNDEFINED when spar <> nil. @@@}					
					 
			 k := 0;
			 powerOf2 := 1 shl 30;
			 for i := 30 downto 0 do  { find highest-order 1 in expont }
			 begin
					if expont and powerOf2 <> 0
					   then begin
							       k := i;
									   break
							    end;																powerOf2 := powerOf2 shr 1
			end;
										
			 { k must be at least 1. answer will be built up in arr2. }
			 powerOf2 := 1 shl (k-1);
			 for i := k-1 downto 0 do
				  begin  { BUG discovered April 96.  spar2 below !! @@@}
					   matrix_mult(arr2^, arr2^, arr_facts, arr_facts, arr2_free, spar2, spar2);  
						 arr2_free := true;
						 if expont and powerOf2 <> 0
							  then matrix_mult(arr2^, arr, arr_facts, arr_facts, arr2_free, spar2, spar);
						powerOf2 := powerOf2 shr 1
				  end;

			 if spar = nil
					then for i := 0 to arr_facts[1] - 1 do
									begin
										 if arr_free
										    then free_quoly(arr[i]);
										 arr[i] := arr2^[i]
									end
					else begin
									if arr_free
										 then free_sparse(spar, arr_facts[2], true);
									spar := spar2
							 end;
			 if spar = nil
			    then free_work;  {@@@}
			 arr_free := true  
															 
	  end;
												
	{****************************************************************************}
	
	procedure add_to_diag(m: quoly; spar: sparseptr; rows: longint); forward;
	
	{****************************************************************************}
	
	procedure quoly_at_matrix;{ (var inf: text; nq: quoly; var arr: workarray;
                               var arr_facts: arr_descr; var arr_free: boolean; 
										           var rows: longint; var flag: nameptr; var spar: sparseptr); }
													 
		{ Token is '[' upon entry. nq is already determined. Evaluate nq at matrix arr,
		  to be computed here.  This procedure inefficiently recomputes lots of 
			matrix powers if there are big gaps in the poly nq.
			   If spar <> nil then all matrix arithmetic is of sparse matrices.
			This may not be optimal!  I'm ignoring that for now, Nov 1992.
			   Nov 1994:  Previous sentence now changed. Switch of storage format spar2 -> arr2 
			and spar3 -> arr3 can occur. Very delicate.  Depends on the way that mat_invert
			and matrix multiply work. 
			   Nov 1997: nq is now read-only. }
													 
		var arr2_free, arr3_free, oldreal_flag, allreals: boolean;
				arr2, arr3: workptr;
				arr2_facts, arr3_facts: arr_descr;
	      i, j, k, num, nextexp: longint;
				n, q, t: ferm118.poly;
				spar2, spar3: sparseptr;
				qq: quoly;  { a dummy head node quoly used to convert various polys. } 

    {________________________________________________________________________}
	
		procedure pad(p: ferm118.poly);
			 begin
		      newpoly(t);
					t^.exp := 0;
					t^.numb := false;
					t^.next := nil;
					t^.pcoef := p
			 end;
			
		{________________________________________________________________________}
		
		procedure add_scalar(p: ferm118.poly);
		 
		   { add scalar p (i.e. exp = 0) to main diagonal of arr2, spar2. p is read only. 
			   qq is reused each time. }
		
		   var i: longint;
			 
			 begin
					if p^.numb
						 then begin
						         qq^.numb := true;
										 qq^.ncoef := p^.ncoef
									end
						 else begin
										 qq^.numb := false;
										 qq^.denom := nil;
										 qq^.numer := p
									end;									
			    if spar2 = nil
					   then for i := 0 to rows - 1 do
						         better_quoly_add(arr2^[i*(rows+1)], qq, arr2^[i*(rows+1)])
						 else add_to_diag(qq, spar2, rows)
			 end;
		{____________________________________________________________________}
		
		procedure sparse_set_allreals;
		   var sp: sparseptr;
			     cp: colm_ptr;
				   i, k: longint;
			 begin
					sp := spar;  
					for k := 0 to (rows - 1) div sparsesize do
						 begin
								for i := 1 + k*sparsesize to (k+1)*sparsesize do
									 if i > rows 
											then break
									 else begin
													 cp := sp^.indx[i-k*sparsesize];
													 while cp <> nil do
															 begin
																	if cp^.val^.numb
																		 then begin
																						 if cp^.val^.ncoef^.imag <> nil 
																								then begin
																												allreals := false;
																												exit {(sparse_set_allreals)}
																										 end
																					end
																		 else begin
																						 allreals := false;
																						 exit {(sparse_set_allreals)}
																					end;
																	cp := cp^.next
															 end
												end;
								sp := sp^.next
						 end
			 end;
											 
		{____________________________________________________________________}
		
		procedure finish;
		   var i: longint;
		   begin
			    if allreals  
			       then realflag := oldreal_flag;
					if arr_free
					   then if spar = nil  
					           then free_arr(arr, arr_facts)
										 else free_sparse(spar, rows, arr_free);												
				  if spar2 = nil  { note spar2. not same as spar = nil!! }
						 then begin
						         for i := 0 to arr2_facts[1] - 1 do
					              arr[i] := arr2^[i];
										 spar := nil
									end
						 else spar := spar2;
					free_work;
					arr_facts := arr2_facts;
					arr_free := true;
					if t <> nil
				     then begin
				             t^.next := polygarb;
								     polygarb := t
							    end;
					qq^.next := quolygarb;
	        quolygarb := qq;
				  exit {(quoly_at_matrix)}
			 end;
			
		{______________________________________________________________________}
		
		begin
					 
			 if not nq^.numb
			    then if nq^.denom <> nil
				          then begin
					                free_quoly(nq);
									        error(186, bulletsign)
								       end;
											 
			 qq := nil;  { Nov 1997; remove nq from this call }
			 arr_fact(inf, qq, arr, arr_facts, arr_free, rows, flag, spar);
			 free_quoly(qq);  { qq should not have been touched }
			 
			 if (arr_facts[1] <> 0) and (arr_facts[1] <> rows*rows)  {spar}
			    then begin
					        free_quoly(nq);
					        if arr_free
										 then if spar = nil
										         then free_arr(arr, arr_facts)
														 else free_sparse(spar, rows, true);
									error(174, bulletsign)
							 end;
							 			 			 
			 n := nq^.numer;  { a bit tricky since nq may be a number. }
			 if not nq^.numb
			    then num := poly_length(n);
			 
			 if nq^.numb or ((n^.exp = 0) and (num = 1))
			    then begin					        
								  if spar = nil
									   then for i := 1 to rows do
														 for j := 1 to rows do
																begin
																	 k := i + rows * (j - 1) - 1;
																	 if not arr_free
																			then arr[k] := nil;
																	 if i = j
																			then quoly_assign(nq, arr[k])
																			else quoly_set(0, arr[k])
																end
										  else begin
											        spar_identi(spar, rows, arr_free);
															mult_cons_sparse(spar, nq, true, rows)
													 end;
									arr_free := true;
									exit {(quoly_at_matrix)}
               end;
							 			 			 
       t := nil;
			 newquoly(qq);
			 
			 { first step is special case - deal with leading coef, which is not a matrix. }			 
			 if n^.numb  { possible only in laurent }
			    then begin
								  qq^.numb := true;
								  qq^.ncoef := n^.ncoef
							 end 
					else begin
					        q := n^.pcoef;
			            if q^.numb and (q^.next = nil)
										 then begin
														 qq^.numb := true;
														 qq^.ncoef := q^.ncoef
												  end
										 else begin
														 pad(q);   { must pad with dummy node for depth. sets t. }
														 qq^.numb := false;
														 qq^.denom := nil;
														 qq^.numer := t
												  end
							 end;
			 
			 { answer is built up in arr2, spar2 }
			 spar2 := nil;
			 new_worknode(i, bulletsign);	 { necessary even if spar <> nil }																	 
			 arr2 := workhead[i];
			 if spar = nil
			    then for i := 0 to arr_facts[1] - 1 do
									arr2^[i] := nil;
					
			 arr2_free := true;
			 arr2_facts := arr_facts;
			 if num = 1
			    then nextexp := n^.exp
					else nextexp := n^.exp - n^.next^.exp;
					
			 { turn on realflag if you can. decide if matrix is all numbers }
			 allreals := height_is_1(n);
			 if allreals
			    then if spar = nil
									then for i := 0 to arr_facts[1] - 1 do
												  if arr[i]^.numb
														 then begin
																		 if arr[i]^.ncoef^.imag <> nil 
																			  then begin
																							 allreals := false;
																							 break
																						 end
																  end
														 else begin
																		 allreals := false;
																		 break
																  end
											 
									else sparse_set_allreals;
							 			 			 
       if allreals
			    then begin
					        oldreal_flag := realflag;
									realflag:= true
							 end;
							 
			 if (nextexp > 1) or (nextexp < 0)   { nextexp can't be 0 here. }
					then begin				
							    if spar = nil
									   then for i := 0 to arr_facts[1] - 1 do
										         quoly_assign(arr[i], arr2^[i])
										 else copy_sparse(spar, spar2, rows, false);									
								  matrix_power(arr2^, arr2_facts, arr2_free, nextexp, spar2);
									if spar = nil
									   then for i := 0 to arr_facts[1] - 1 do
										         quoly_mult(qq, arr2^[i], arr2^[i])
										 else mult_cons_sparse(spar2, qq, arr2_free, rows)
							 end
				  else if spar = nil
					        then for i := 0 to arr_facts[1] - 1 do  
									        quoly_mult(qq, arr[i], arr2^[i])
									else begin
									        copy_sparse(spar, spar2, rows, false);
													mult_cons_sparse(spar2, qq, true, rows)
											 end;

       if num > 1
			    then n := n^.next
					else finish;  { exit }
					
			 { If get here, no switch of storage format spar2 -> arr2 has occurred. }
			 if n^.numb
				  then add_scalar(n)
			 else if n^.pcoef^.numb and (n^.pcoef^.next = nil)
							 then add_scalar(n^.pcoef)
			 else begin   { must pad with dummy node for depth }
							 if t = nil  { one time only } 
								  then pad(n^.pcoef)  { sets t }
									else t^.pcoef := n^.pcoef; { reuse pad created first time. }
							 add_scalar(t)
					  end;
										
			 { handle other coeffs with loop. }
			 { arr3, spar3 used for powers of matrix, including negative powers.
			   arr3 may in fact never be used. }
			 arr3 := nil;
			 arr3_free := false;  
			 if (num > 2) or (n^.exp > 1) or (n^.exp < 0) { will probably need space for 
			                                              matrix power.  definitely will 
																										if num = 2 and n^.exp > 1, < 0 }
			    then begin
					        new_worknode(i, bulletsign);
								  arr3 := workhead[i];  { note move ~~~~}
								  if spar = nil
									   then for i := 0 to arr_facts[1] - 1 do
										         arr3^[i] := nil;
										 { it is not necessary to nil out the quolies in arr3^ if 
										   spar <> nil, even if storage shift occurs later. }
									arr3_facts := arr_facts
							 end;
					
			 spar3 := nil;
			 for i := 1 to num-2 do  { Horner's method }
				  begin
					   nextexp := n^.exp - n^.next^.exp;
						 { no switch of storage format spar3 -> arr3 can occur in this loop.
						   Recall also that no switch of format spar2 -> arr2 has occurred. } 
						 if nextexp > 1
							  then begin	{ raise arr to power and put in arr3 }
							          if spar = nil
												   then for j := 0 to arr_facts[1] - 1 do
												           quoly_assign(arr[j], arr3^[j])
													 else begin
													         if spar3 <> nil
																	    then free_sparse(spar3, arr_facts[2], true);
																	 copy_sparse(spar, spar3, arr_facts[2], false)
																end;
												arr3_free := true;
								        matrix_power(arr3^, arr3_facts, arr3_free, nextexp, spar3);
									  		matrix_mult(arr2^, arr3^, arr2_facts, arr3_facts, arr2_free, spar2, spar3)
										 end
								else matrix_mult(arr2^, arr, arr2_facts, arr_facts, arr2_free, spar2, spar);
								
						 n := n^.next;
						 if n^.numb
							  then add_scalar(n)
						 else if n^.pcoef^.numb and (n^.pcoef^.next = nil)
							       then add_scalar(n^.pcoef)
						 else begin   { must pad with dummy node for depth }
							       if t = nil  { will be first time } 
											  then pad(n^.pcoef)  { sets t }
									      else t^.pcoef := n^.pcoef; { reuse pad created first time.}	
										 add_scalar(t)
								  end
				  end;
					
       if (n^.exp > 1) or (n^.exp < 0)
					then begin
								  if spar = nil
										 then for i := 0 to arr_facts[1] - 1 do
														 quoly_assign(arr[i], arr3^[i])
										 else begin
														 if spar3 <> nil
																then free_sparse(spar3, arr_facts[2], true);
														 copy_sparse(spar, spar3, arr_facts[2], false)
													end;
									arr3_free := true;
								  matrix_power(arr3^, arr3_facts, arr3_free, n^.exp, spar3);
									{ spar2 might flip format to arr2 here. matrix_mult will do the
									  right thing. }
									matrix_mult(arr2^, arr3^, arr2_facts, arr3_facts, arr2_free, spar2, spar3)
							 end
					else if n^.exp = 1
									then matrix_mult(arr2^, arr, arr2_facts, arr_facts, arr2_free, spar2, spar);
				{ else if n^.exp = 0 do nothing }											 									 
			 
			 if arr3_free { iff arr3 was used } 
			    then if spar3 = nil
					        then free_arr(arr3^, arr3_facts)
									else free_sparse(spar3, rows, true);
			 if arr3 <> nil 
			    then free_work;  
			 finish
		
		end;
		
 {*****************************************************************************}
 
  procedure add_sparses(var spar, spar2: sparseptr; arr_free, arr2_free: boolean; 
	                      row: longint; plus: boolean); forward;
	
 {****************************************************************************}
 
	procedure sparse_evalquoly(var n: quoly; var spar: sparseptr; rows: longint;
	                           var arr_free: boolean; var inf: text; var flag: nameptr); forward;
  
 {****************************************************************************}
 
	procedure sparse_read(var inf: text; var n: quoly; var flag: nameptr; arr_facts:
	                      arr_descr; var arr_free: boolean; var spar: sparseptr); forward;
		
	{***************************************************************************}
	
	procedure complex_sparse(var spar: sparseptr; rows: longint; x: char; var free: boolean);
	
	   var spar2: sparseptr;  {``` delete i}
				 
		 {------------------------------------------------------------------------}
		 
		 procedure basic;
		    var i, k: longint;
				    u: colm_ptrptr;
						sp: sparseptr;
				begin
				   sp := spar;
					 for k := 0 to (rows - 1) div sparsesize do  {```}
							begin
								 for i := 1 + k*sparsesize to (k+1)*sparsesize do
										if i > rows 
											 then break
										else begin
													 u := @ spar^.indx[i];
													 while u^ <> nil do
															if x = ''
																 then begin
																				 quoly_conjugate(u^^.val);
																				 u := @ u^^.next
																			end
																 else begin
																				 if x = ''
																						then quoly_imag_free(u^^.val, true)
																						else quoly_imag_part(u^^.val);
																				 if quoly_iszero(u^^.val)
																						then free_colm(u^)
																						else u := @ u^^.next
																			end
												end;
								 sp := sp^.next
							end
				end;
				
		 {-------------------------------------------------------------------------}
		 
		 begin
		 
		    if free
		       then basic
					 else begin
									 copy_sparse(spar, spar2, rows, false);
									 spar := spar2;
									 basic;
									 free := true
								end
		 
		 end;
	
  {****************************************************************************}

	procedure adjoint(var alpha, arr: workarray; alpha_free: boolean; m: longint; 
	                  var spar: sparseptr); forward;
	
	{****************************************************************************}
	
	procedure extract_diagonal(var arr, arr2: workarray; var arr_facts: arr_descr; 
                             arr_free: boolean; var rows: longint; var spar: sparseptr);
										         
	   { Nov 1997. (arr2, spar) is the input. arr can equal arr2, at least if 
	     arr_free is false. arr^ must exist on input. }
	   
	   var m, i, j, locat, cols: longint;
	       n3: quoly;
	   
	   begin
	   
        cols := arr_facts[1] div rows;
				if rows < cols
				   then m := rows
					 else m := cols;
		    arr_facts[1] := m;
		    arr_facts[2] := 1;
		    if arr_free
				   then if spar = nil
					         then for i := 0 to rows - 1 do
													 for j := 0 to cols - 1 do
															begin
																 locat :=  i + j*rows;
																 if i = j
																		then arr[i] := arr2[locat]
																		else free_quoly(arr2[locat])
															end
									 else begin
									         for i := 0 to m - 1 do
														  begin
																 n3 := spar_retrieve(spar, i+1, i+1);
																 quoly_assign(n3, arr[i])
															end;
													 free_sparse(spar, rows, true)
												end
					 else for i := 0 to m - 1 do
									 if spar = nil
											then arr[i] := arr2[i*(1 + rows)]
											else arr[i] := spar_retrieve(spar, i+1, i+1);
				spar := nil;
			  rows := m
				  
	   end;
	   
 {****************************************************************************}
 
	procedure arr_fact { (var inf: text; var n: quoly; var arr: workarray;
                        var arr_facts: arr_descr; var arr_free: boolean; 
										    var rows: longint; var flag: nameptr; var spar: sparseptr) } ; 
												
    var i, j, k, expont, locat, start, cols, firstrow, firstcol, total_rows, 
		        m: longint;
        q: arrptr;
				r,s : varptr;
				p,t: nameptr;
				arr2, arr3: workptr;
				x: char;
				oldtok : tokentipe;
				double, even, arr2_free: boolean;
				n3: quoly;
				m2: number;
				spar2: sparseptr;
				
	  {____________________________________________________________________}
				
		procedure diagonal_matrix;
		
		   var i, k: longint;
			     neg, itszero: boolean;
					 s: colm_ptr;
					 sp: sparseptr;
		
		   begin
			 
			    if rows = 0
             then error(45, token);
				{	if rows * rows > arr_limit
					   then error(43, token);  }         { <<<< }
					neg := (token.name = '-');
					if neg
					   then scanner(inf, token, flag);
          quoly_readin(inf, n, flag, m);
					if neg
					   then quoly_inplace(n);
					itszero := quoly_iszero(n);
					for k := 0 to (rows - 1) div sparsesize do  {```}
							begin
								 if k = 0
										then begin
														newsparse(spar);
														sp := spar
												 end
										else begin
														newsparse(sp^.next);
														sp := sp^.next
												 end;
								 for i := 1 + k*sparsesize to (k+1)*sparsesize do
										if i > rows 
											 then break
										else if itszero
														then sp^.indx[i-k*sparsesize] := nil
														else begin
																		newcolm(sp^.indx[i-k*sparsesize]);
																		s := sp^.indx[i-k*sparsesize];
																		s^.next := nil;
																		s^.coord := i;
																		s^.val := nil;
																		quoly_assign(n, s^.val)
																 end
							end;
							
          arr_facts[1] := rows * rows;
          arr_facts[2] := rows;
					arr_free := true
					
       end;
			 
    {____________________________________________________________________}

    procedure fillit(q: arrptr);
		
		   var i, k: longint;
		
		   begin
			 
			     scanner(inf, token, flag);
					 if token.name = '['  { subarray }
							then begin
											subarray(inf, q, start, rows, cols, 
															 firstrow, firstcol, total_rows, flag);
											arr_facts[1] := rows*cols;
											arr_facts[2] := rows;
									 end
							else begin
											arr_facts[1] := q^.size;
											arr_facts[2] := q^.rows;
											rows := q^.rows;
											start := q^.start;
											total_rows := rows;
											cols := arr_facts[1] div rows
									 end;
					 j := 0;
					 
					 arr_free := false;   { <- Note! }
					 
					 for i := 0 to cols - 1 do
							for k := 0 to rows - 1 do
								 begin
										locat := start + k + i*total_rows;
										check_and_assign(locat, arr[j]);
										Inc(j)
								 end
																						 
			 end;
			 
    {____________________________________________________________________}

    begin
		
      m2.imag := nil;
			if token.name = '('
        then begin
                scanner(inf, token, flag);
								arr_expre(inf, n, arr, arr_facts, arr_free, rows, flag, spar, true);
                if token.name <> ')'
                   then error(1, token)
                   else scanner(inf, token, flag)
             end
      else if token.name = '-'
            then begin
                    scanner(inf, token, flag);
                    arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
                    if arr_facts[1] = 0
                       then quoly_inplace(n)
                    else if spar = nil
										        then if arr_free
																		then for i := 0 to arr_facts[1] - 1 do 
																						 quoly_inplace(arr[i])
																		else begin
																						for i := 0 to arr_facts[1] - 1 do 
																							 begin
																									n3 := nil;
																									quoly_makeneg(arr[i], n3);
																									arr[i] := n3
																							 end;
																						arr_free := true
																				 end
														else sparse_makeneg(spar, rows, arr_free)
                 end
      else if token.name = '' { transpose matrix }
            then begin
							      oldtok := token;
                    scanner(inf, token, flag);
										new_worknode(i, token);																		 
			              arr2 := workhead[i];
                    arr_fact(inf, n, arr2^, arr_facts, arr_free, rows, flag, spar);
                    if arr_facts[1] = 0
                       then error(72, oldtok);
								    cols := arr_facts[2];	
							      arr_facts[2] := arr_facts[1] div cols;
								    rows := arr_facts[2];
								    if spar = nil
										   then for i := 0 to rows-1 do
															 for j := 0 to cols-1 do
																	begin
																		 locat :=  i + j*rows;
																		 k := j + i*cols;
																		 if arr_free
																				then arr[locat] := arr2^[k]
																				else begin  { have to do this because of :[x]=[x] }
																								arr[locat] := nil;
																								quoly_assign(arr2^[k], arr[locat])
																						 end												 
																	end
											 else if arr_free  {``` delete error}
															then trans_sparse(spar, cols, rows)
															else begin
																			copy_sparse(spar, spar2, cols, false);
																			trans_sparse(spar2, cols, rows);
																			spar := spar2
																	 end;
									  free_work;
										arr_free := true
                 end
      else if token.name = '' { extract diagonal }
            then begin
							      oldtok := token;
                    scanner(inf, token, flag);
										new_worknode(i, token);																		 
			              arr2 := workhead[i];
                    arr_fact(inf, n, arr2^, arr_facts, arr_free, rows, flag, spar);
                    if arr_facts[1] = 0
                       then error(74, oldtok);  { Nov 1997 }
										extract_diagonal(arr, arr2^, arr_facts, arr_free, rows, spar);
										free_work
                 end
								 
      else if token.name = '|'
				 then begin
								 scanner(inf, token, flag);
								 arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
								 if token.name <> '|' 
										then begin
														if arr_free
															 then if spar = nil
																			 then free_arr(arr, arr_facts)
																			 else free_sparse(spar, rows, true);
														error(63, token)
												 end;
								 scanner(inf, token, flag);
								 if arr_facts[1] = 0
										then quoly_abs(n, true)
										else if spar = nil
										        then for i := 0 to arr_facts[1] - 1 do
																		 if arr_free
																				then quoly_abs(arr[i], true)
																				else begin
																								 n3 := nil;
																								 quoly_assign(arr[i], n3);
																								 quoly_abs(n3, true);
																								 arr[i] := n3
																						 end
													  else sparse_great_abs(spar, rows, arr_free, true);
								 arr_free := true
							end
										
			else if token.name = '['     
							then begin
											scanner(inf, token, flag);
											if ((token.name[1] >= '0') and (token.name[1] <= '9')) or (token.name = '-') 
												 then  {try to create diagonal square matrix, rows X rows }
															 diagonal_matrix  

											else if (token.name[1] >= 'a') and (token.name[1] <= 'z')
															then if is_poly_name(token.name, m)
																			then diagonal_matrix
																	 else begin
																					 if token.address = -1
																							then i := hash(token.name, 151)
																							else i := token.address;
						 
																					 q := arr_store[i];
																					 while q <> nil do
																							if q^.name.name = token.name
																								 then break
																								 else q := q^.next;
																					 if q = nil
																							then error(28, token);
																					 if q^.spar = nil
																					    then fillit(q)
																							else begin
																							        scanner(inf, token, flag);
																											if token.name = '['
																											   then error(291, token);
																											spar := q^.spar;
																											arr_free := false; { <- Note! }
																											arr_facts[1] := q^.size;
																											arr_facts[2] := q^.rows;
																											rows := q^.rows
																									 end
																				end

										else if token.name = ''
														then begin
																		get_arr_arr(inf, n, flag, m);
																		if arrstash[m] = nil
																			 then error(247, token);
																		if arrstash[m]^.spar = nil
																		   then fillit(arrstash[m])
																			 else begin
																							scanner(inf, token, flag);
																							if token.name = '['
																								 then error(291, token);
																							spar := arrstash[m]^.spar;
																							arr_free := false; { <- Note! }
																							arr_facts[1] := arrstash[m]^.size;
																							arr_facts[2] := arrstash[m]^.rows;
																							rows := arrstash[m]^.rows
																					  end
																 end
										
										else if (token.name = '(') or (token.name = '[') 
														 { array is being filled by a list. '[' indicates matrix. }
														 then begin
																		 j := 0;
																		 double := (token.name = '[');
																		 if double and want_sparse    { spar }
																		    then begin
																				        arr_facts[2] := rows;  { arr_facts[1] already set }
																								sparse_read(inf, n, flag, arr_facts, arr_free, spar);
																								exit {(arr_fact)}
																						 end;
																		 cols := 0;
																		 repeat
																			 if j > arr_limit - 1
																					then begin
																									 arr_facts[1] := arr_limit;
																									 free_arr(arr, arr_facts);
																									 error(71, comma)
																							 end;
																			 if double
																					then spec_scanner(inf, token, flag, even)
																					else scanner(inf, token, flag);
																			 { even means  (or end of line) was seen. }
																			 if double and even and (cols = 0)
																					then cols := j;
																			 arr[j] := nil;
																			 old_expre(inf, arr[j], flag);
																			 Inc(j);
																			 arr_facts[1] := j;
																			 if (token.name <> ',') and (double or (token.name <> ')')) and
																					(not double or (token.name <> ']'))
																					then begin
																									free_arr(arr, arr_facts);
																									error(70, token)
																							 end;
																		 until ( double and (token.name = ']')) or (not double
																						 and (token.name = ')'));
																		 scanner(inf, token, flag);
																		 if double and (cols = 0)
																				then cols := 1;
																		 if double
																				then if j mod cols <> 0
																								then begin
																												free_arr(arr, arr_facts);
																												error(173, token)
																										 end
																								else rows := j div cols
																				else begin
																								rows := 1;
																								arr_facts[2] := 1
																						 end;
																		 if double
																				then begin  { must transpose }
																								new_worknode(i, token);																		 
			                                          arr2 := workhead[i];
																								arr_facts[2] := rows;
																								for i := 0 to rows-1 do
																									 for j := 0 to cols-1 do
																											begin
																												 locat :=  i + j*rows;
																												 k := j + i*cols;
																												 arr2^[locat] := arr[k]
																											end;
																								for i := 0 to arr_facts[1] - 1 do
																									 arr[i] := arr2^[i];
																							  free_work
																						 end;																							    
																								
																		 arr_free := true
																	end
																	
										else if token.name = '<'   { loop(s) to fill array }
														then begin
																		{ Nov 1997 }
																		set_up_for_loop(inf, flag,r, i, rows, k);
																		if token.name <> '>' then error(78, token);
																		if i < addresser then error(79, r^.let);
																		if rows < addresser then error(80, r^.let);
																		if k < 1 then error(82, r^.let);
																		scanner(inf, token, flag);
																		if token.name = '<'
																			 then begin
																							 { Nov 1997 }
																							 set_up_for_loop(inf, flag,s, j, cols, m);
																							 if token.name <> '>'
																									then error(78, token);
																							 if j < addresser then error(79, s^.let);
																							 if cols < addresser then error(80, s^.let);
																							 if m < 1 then error(82, s^.let);
																							 scanner(inf, token, flag);
																						end
																			 else begin
																							 j := addresser; cols := addresser;
																							 m := 1; s := nil
																						end;
																						
																		obtain_expression(inf, flag, p, '[');
																		start := j;
																		firstrow := rows + 1 - addresser; { actual number of rows }
																								{ 'firstrow' not pnemonic here }
																		arr_facts[1] := firstrow *(cols + 1 - addresser);
																		arr_facts[2] := firstrow;
																		for firstcol := 0 to arr_facts[1]-1 do
																			 arr[firstcol] := nil;   
																		while i <= rows do
																			begin
																				 while j <= cols do
																						begin
																							 locat := i-addresser + (j-addresser)*firstrow;
																							 t := p;
																							 token := p^.let;
																							 currentchar := p^.next;													                     
																							 old_expre(inf, arr[locat], t);
																							 j := j + m;
																							 if s<>nil then adjust(s, j);
																						end;																									 
																				 i := i + k;
																				 j := start;
																				 if s<>nil then adjust(s, j);
																				 adjust(r, i);
																			end;
																			
																		rows := firstrow;
																		arr_free := true;
																		freename(p)  { p is not changed }
																																					
																 end
																	
										else if token.name = ''  { array is being filled by random }
														 then begin
																		 if rows = 0
																				then error(142, token);
																		 scanner(inf, token, flag);
																		 double := (token.name = '');
																		 for j := 0 to arr_facts[1] - 1 do
																				begin
																					 arr[j] := nil;
																					 randomize(double, arr[j])
																				end;
																		 arr_facts[2] := arr_facts[1] div rows;
																		 if double
																				then scanner(inf, token, flag);
																		 arr_free := true
																	 end
																		 
										else if token.name = ''
														then if syst^.stop = -1
																		then error(175, token)
														else begin
																		scanner(inf, token, flag);
																		if token.name = '['
																			 then error(83, token);
																		arr_facts[1] := syst^.stop + 1;
																		rows := syst^.rows;
																		arr_facts[2] := rows;
																		arr_free := true;
																		{ The duplication of space here is essential. }
																		copy_syst(arr, rows, spar)  { Nov 1997 }
																 end
																 
										else if want_sparse and (token.name = ']') {``` empty array}
										        then sparse_init(spar, rows)
												 
										else error(40, token);
	
								 if token.name <> ']'
											then begin
														 if arr_free
														    then if spar = nil
																		    then free_arr(arr, arr_facts)
																		    else free_sparse(spar, rows, true);
														 error(24, token)
													 end;
								 scanner(inf, token, flag);
																							 
							end { if token.name = '[' }
							
      else if token.name = '$'
				 then begin
								 scanner(inf, token, flag);
								 arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
								 if arr_facts[1] = 0
										then quoly_great_int(n)
										else if spar = nil
										        then for i:= 0 to arr_facts[1] - 1 do 
																		if arr_free
																			 then quoly_great_int(arr[i])
																			 else begin
																							 n3 := nil;
																							 quoly_assign(arr[i], n3);
																							 quoly_great_int(n3);
																							 arr[i] := n3
																						end
													  else sparse_great_abs(spar, rows, arr_free, false);
								 arr_free := true																				 
							end
							
			else if token.name = 'Rint'
				 then begin
								 scanner(inf, token, flag);
								 arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
								 if arr_facts[1] = 0
										then quoly_great_int(n)
										else if spar = nil
										        then for i:= 0 to arr_facts[1] - 1 do 
																		if arr_free
																			 then quoly_great_int(arr[i])
																			 else begin
																							 n3 := nil;
																							 quoly_assign(arr[i], n3);
																							 quoly_great_int(n3);
																							 arr[i] := n3
																						end
													  else sparse_great_abs(spar, rows, arr_free, false);
								 arr_free := true																				 
							end
							
			else if token.name = 'Adjoint' 
			      then begin
				            oldtok := token;
                    scanner(inf, token, flag);
										new_worknode(i, oldtok);																		 
			              arr2 := workhead[i];
                    arr_fact(inf, n, arr2^, arr_facts, arr2_free, rows, flag, spar);
                    if arr_facts[1] = 0
                       then error(72, oldtok);
										if sqr(rows) <> arr_facts[1] 
										   then error(285, token);
								    if spar <> nil
										   then error(289, oldtok);
										adjoint(arr2^, arr, arr2_free, rows, spar);
									  free_work;
										arr_free := true
				         end
							
			else if token.name = 'Altmult'  
			      then begin
				            oldtok := token;
                    scanner(inf, token, flag);
										if token.name <> '('
										   then error(177, token);
										scanner(inf, token, flag);
										new_worknode(i, oldtok);																		 
			              arr2 := workhead[i];
                    arr_expre(inf, n, arr2^, arr_facts, even, rows, flag, spar, true);
                    if arr_facts[1] = 0
                       then error(72, token);
										firstcol := arr_facts[1] div rows;
										if spar <> nil
										   then error(289, oldtok);
										if token.name <> ','
										   then error(202, token);
										scanner(inf, token, flag);
										new_worknode(i, oldtok);																		 
			              arr3 := workhead[i];
										firstrow := firstcol;  { in case following call finds a diagonal }
										arr_expre(inf, n, arr3^, arr_facts, double, firstrow, flag, spar, true);
										{ 'firstrow' is misnomer. it's really the second matrix's row. }
                    if arr_facts[1] = 0
                       then error(72, token);
										if spar <> nil
										   then error(289, token);
										if token.name <> ')'
										   then error(1, token);
										cols := arr_facts[1] div firstrow;
										if firstcol <> firstrow
										   then error(39, oldtok);
										if rows*cols > arr_limit
			                 then error(43, token);
										fast_mat_mult(arr2^, arr3^, arr, rows, firstcol, cols);
										scanner(inf, token, flag);
										arr_facts[1] := rows*firstcol;
										if even
										   then free_arr(arr2^, arr_facts);
									  arr_facts[1] := firstrow*cols;
										if double
										   then free_arr(arr3^, arr_facts);
										free_work;
										free_work;
										arr_facts[1] := rows*cols;
										arr_facts[2] := rows;
										arr_free := true
				         end
							
			else if token.name = 'Altpower'  
			      then begin
				            oldtok := token;
                    scanner(inf, token, flag);
										if token.name <> '('
										   then error(177, token);
										scanner(inf, token, flag);
                    arr_expre(inf, n, arr, arr_facts, arr_free, rows, flag, spar, true);
                    if arr_facts[1] = 0
                       then error(72, token);
										cols := arr_facts[1] div rows;
										if spar <> nil
										   then error(289, oldtok);
										if rows <> cols
										   then error(172, oldtok);
										if token.name <> ','
										   then error(202, token);
										m2.size := 0;    m2.imag := nil;
								    get_exponent(inf, flag, m2);
								    expont := check_and_convert(m2);
										if token.name <> ')'
										   then error(1, token);
										alt_mat_power(arr, arr_facts, arr_free, expont);
										scanner(inf, token, flag)
				         end
								 
			else if (token.name = '') or (token.name = '') or (token.name = '')
            then begin
                    x := token.name[1];
										scanner(inf, token, flag);
                    arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
                    if complex
										   then if arr_facts[1] = 0
                               then case x of
															         '': quoly_conjugate(n);
																			 '': quoly_imag_free(n, true);
																			 '': quoly_imag_part(n)
																		end
														else if spar = nil
														        then if arr_free
																						then for i := 0 to arr_facts[1] - 1 do 
																										case x of
																											 '': quoly_conjugate(arr[i]);
																											 '': quoly_imag_free(arr[i], true);
																											 '': quoly_imag_part(arr[i])
																										end
																						else begin
																										for i := 0 to arr_facts[1] - 1 do 
																											 begin
																													n3 := nil;
																													quoly_assign(arr[i], n3);
																													case x of
																														 '': quoly_conjugate(n3);
																														 '': quoly_imag_free(n3, true);
																														 '': quoly_imag_part(n3)
																													end;
																													arr[i] := n3
																											 end;
																										arr_free := true
																								 end
																		else complex_sparse(spar, rows, x, arr_free)
									     else if x = ''
											         then writeln(userOutput, ' Warning:  encountered and ignored.')
                 end
								 												 
			else if token.name = ''''
				 then begin
								 j := 0;
								 repeat
										if j > arr_limit - 1
											 then begin
															 arr_facts[1] := arr_limit;
															 free_arr(arr, arr_facts);
															 error(71, token)
														end;
										dumbscanner(inf, token, flag, double);									    
										if token.name <> ''''
											 then begin
															 arr[j] := nil;
															 quoly_set(ord(token.name[1]),  arr[j]);
															 Inc(j)
														end									      
								 until token.name = '''';
								 scanner(inf, token, flag);
								 if j = 0 then error(110, token);
								 arr_facts[1] := j;
								 arr_facts[2] := 1;
								 arr_free := true;
								 rows := 1
							end
			else begin   { Just call fact. Might get signal from fact to eval matrix }
							matrix_eval := matrix_eval + 1;
							m := matrix_eval;
							old_fact(inf, n, flag);
							if matrix_eval <> m  { fact changed it - want to eval n at matrix }
								 then quoly_at_matrix(inf, n, arr, arr_facts, arr_free, rows, flag, spar)
								 else begin
												 matrix_eval := matrix_eval - 1;
												 arr_facts[1] := 0
											end
					 end;
							 
		 if token.name = '^'
				then begin
								if arr_facts[1] = 0
									 then arr_facts[2] := 0;
								if arr_facts[1] <> arr_facts[2] * arr_facts[2]
									 then begin
													 if spar = nil
															then if arr_free 
																			then free_arr(arr, arr_facts)
																			else
															else free_sparse(spar, arr_facts[2], arr_free);
													 error(172, expsign)
												end;
								m2.size := 0;  m2.imag := nil;  
								get_exponent(inf, flag, m2); { no need to free m2 later }
								if arr_facts[1] = 0
									 then raise_to_power(n, m2)
									 else begin
													 expont := check_and_convert(m2);
													 matrix_power(arr, arr_facts, arr_free, expont, spar)
												end
						 end
			 else if token.name = ''
					then if arr_facts[1] > 0
									then begin
													scanner(inf, token, flag);
													free_quoly(n);
													if spar <> nil
														 then begin
																		 sparse_evalquoly(n, spar, arr_facts[2], arr_free, inf, flag);
																		 exit {(arr_fact)}
																	end;
													for j := 0 to arr_facts[1] - 1 do
														 if arr_free
																then get_evalquoly(inf, arr[j], n, locat, flag, false)
																else begin
																				n3 := nil;
																				quoly_assign(arr[j], n3);
																				get_evalquoly(inf, n3, n, locat, flag, false);
																				arr[j] := n3
																		 end;
													arr_free := true;
													if n^.next <> nil  { total_eval was called by get_evalquoly }
														 then while n <> nil do
																		 begin
																				n3 := n^.next;
																				free_quoly(n);
																				n := n3
																		 end;
													quoly_set(0, n)
											 end
									else begin
													n3 := nil; { flag to get_evalquoly }
													get_evalquoly(inf, n, n3, locat, flag, true);
													free_quoly(n3)
											 end
									
    end;
		
	{*************************************************************************}
	
	procedure half_arr_fact(var inf: text; var n: quoly; var arr: workarray;
                          var arr_facts: arr_descr; var arr_free: boolean; 
										      var rows: longint; var flag: nameptr; var spar: sparseptr);
	
	   { Nov 1997 }
	   
	   var n3: quoly;
	       m2: number;
	       expont, j: longint;
	   
	   begin
	   
	    if token.name = '^'
				then begin
								if arr_facts[1] = 0
									 then arr_facts[2] := 0;
								if arr_facts[1] <> sqr(arr_facts[2])
									 then begin
													 if spar = nil
															then if arr_free 
																			then free_arr(arr, arr_facts)
																			else
															else free_sparse(spar, arr_facts[2], arr_free);
													 error(172, expsign)
												end;
								m2.size := 0; 
								m2.imag := nil; 
								get_exponent(inf, flag, m2);
								if arr_facts[1] = 0
									 then raise_to_power(n, m2)
									 else begin
													 expont := check_and_convert(m2); 
													 matrix_power(arr, arr_facts, arr_free, expont, spar)
												end;
								imag_free(m2)
						 end
		  else if token.name = ''
					then if arr_facts[1] > 0
									then begin
													scanner(inf, token, flag);
													free_quoly(n);
													if spar <> nil
														 then begin
																		 sparse_evalquoly(n, spar, arr_facts[2], arr_free, inf, flag);
																		 exit {(half_arr_fact)}
																	end;
													for j := 0 to arr_facts[1] - 1 do
														 if arr_free
																then get_evalquoly(inf, arr[j], n, expont, flag, false)
																else begin
																				n3 := nil;
																				quoly_assign(arr[j], n3);
																				get_evalquoly(inf, n3, n, expont, flag, false);
																				arr[j] := n3
																		 end;
													arr_free := true;
													if n^.next <> nil  { total_eval was called by get_evalquoly }
														 then while n <> nil do
																		 begin
																				n3 := n^.next;
																				free_quoly(n);
																				n := n3
																		 end;
													quoly_set(0, n)
											 end
									else begin
									        scanner(inf, token, flag);  
									        if token.name = '['
											       then begin  
																	   spar := nil;     
																	   quoly_at_matrix(inf, n, arr, arr_facts, arr_free,
																									   rows, flag, spar);
																	   quoly_set(0, n)
																  end												 
														 else begin
																     n3 := nil; { flag to get_evalquoly }
																		 get_evalquoly(inf, n, n3, expont, flag, true);
																		 free_quoly(n3)
																  end
									     end
									     
	   end;
	   
	{*************************************************************************}
	
	procedure fold_poly; {(var p, num: ferm118.poly; expon: longint)}
	
	   { p is a top level poly, in var t, say. Coefficients may be polys.  
		   Mod out by t^expon = num, num a poly but a number. Don't change num.  
			 p is changed and p's storage is used. expon is > 0. }
	
	   var q, s, t, u, num2: ferm118.poly;
		     n, e, errcode: longint;
				 
		 {------------------------------------------------------------------}
		 
		 procedure loop_body(num: ferm118.poly);
		    begin
					 poly_assign(num, u);							
					 compute_power(u, n, nilpol);  { u is a number here }
					 t := q^.next;
					 q^.next := nil;
					 q^.exp := e;							
					 if (e = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil)
						  then begin
										  q^.next := polygarb;
										  polygarb := q;
										  q := q^.pcoef
									 end;
					 poly_mult(q, u, q, nilpol);  { u is a number here }
					 best_poly_add(s, q, s);
					 q := t
				end;
				
		 {-----------------------------------------------------------------}
			
		 procedure finish;
				begin
					 free_poly(u);
					 p := s;
					 exit {(fold_poly)}
				end;
				 
		{-----------------------------------------------------------------}
		 
		 begin
		 
		    q := p;
				s := nil;
				u := nil;				
				poly_set(0, s);
				while q^.exp >= expon do
				   begin
					    n := q^.exp div expon;
							e := q^.exp mod expon;
							loop_body(num); { advances q, uses e and n }
							if q = nil
							   then begin
                  finish;
                  exit
                 end
					 end;				
					 
			  if q^.exp >= 0  
				   then begin   { find rest of nonnegative terms and add in. }
					         num2 := q;
									 while q^.exp >= 0 do  
										  begin
												 t := q;
												 q := q^.next;
												 if q = nil
													  then break
										  end;										 
									 if q <> nil
										  then t^.next := nil;
									 best_poly_add(s, num2, s);
									 if q = nil  { no negative exponents }
							        then begin
                        finish;
                        exit
                      end
								end;
									 									 					 
				num2 := nil;
				poly_assign(num, num2);
				if poly_iszero(num2)
				   then errcode := 22
					 else quot(number_1, num2^.ncoef^, num2^.ncoef^);
									 
			  if errcode > 0
					 then begin
									 writeln(userOutput, ' *** Can''t apply poly-mod-out of form t^n = c to a term with');
									 writeln(userOutput, '     a negative exponent, when c is not invertible.');
									 writeln(userOutput, '       Modding out aborted.  Some variable may have been');
									 writeln(userOutput, '     partially converted.');
									 free_poly(u);
					         p := s;
									 error(errcode, quotsign)
							  end;
				
				{ now do negative exponents. }
				while q <> nil do
				   begin
					    n := q^.exp div expon;
							e := q^.exp mod expon;
							if e < 0
							   then begin
								         e := e + expon;
												 n := abs(n - 1)
											end
								 else n := abs(n);												 
							loop_body(num2)
			     end;
					 
				free_poly(num2);
				finish
												 					    
		 end;

	{*************************************************************************}
	
	procedure mod_out_poly(var p, num: ferm118.poly; depth, expon: longint);
	
	   { Apply mod out idea to the poly p, modding out the poly var given by depth.
		   Pass expon and num along to fold_poly, the trivial case. This routine is 
			 slightly inefficient by calling poly_add - could just play with trailing
			 pointers to overcome technical problem of vanishing of q^.pcoef. }

     var q,s,t: ferm118.poly;
		 
		 begin
		 
		    if depth = 1
				   then begin
					         fold_poly(p, num, expon);
									 exit {(mod_out_poly)}
								end;
								
				q := p;
				s := nil;
				poly_set(0, s);
				
				while q <> nil do
				   if q^.numb
					    then begin
							        t := q;
									    q := q^.next;
									    t^.next := nil;
							        best_poly_add(s, t, s)
									 end
					 else begin
								   mod_out_poly(q^.pcoef, num, depth - 1, expon);
									 t := q;
									 q := q^.next;
									 t^.next := nil;									 
									 if poly_iszero(t^.pcoef)
									    then free_poly(t)
											else begin
											        if t^.pcoef^.numb and (t^.pcoef^.next = nil) and (t^.exp = 0)  { tricky! }
									               then begin
																         t^.next := polygarb;
																				 polygarb := t;
																				 t := t^.pcoef
																			end;
											        best_poly_add(s, t, s)
													 end
								end;
											
			  p := s
									 
		 end;

	{*************************************************************************}
	
	procedure mod_out_quoly(var q: quoly; var num: ferm118.poly; depth, expon: longint);
	
	   begin
		 
		    if q^.numb
				   then exit {(mod_out_quoly)};
					 
				mod_out_poly(q^.numer, num, depth, expon);
				if poly_iszero(q^.numer)
				   then quoly_set(0, q)
				else if q^.denom <> nil
				   then begin
					         mod_out_poly(q^.denom, num, depth, expon);
									 if poly_iszero(q^.denom)
									    then begin
											        quoly_set(0, q);
															writeln(userOutput, ' Warning.  In converting to poly-mod-out, a denominator became 0.');
															writeln(userOutput, '   That quoly has been set to 0.')
													 end
									    else check_quoly(q, false)  
								end
					         		 
		 end;
	
	{*************************************************************************}
	
	procedure set_mod_out(var inf: text; var flag: nameptr; imperative: boolean);
	
	   var num: quoly;
		     r: ferm118.poly;
				 q: polypt;
				 n, i: integer;
				 expon, j: longint;
				 p: varptr;
				 old_tt, cancelling: boolean;
				 old_left: shortstring;
				 ap: arrptr;
				 
		 {______________________________________________________________________}
		 
		 procedure get_data(var inf: text; var flag: nameptr);
		    { compute n = depth, expon, and num. Read from either input or given inf, flag. }
		    var i: integer;
				    p: ferm118.poly;
		    begin
					 scanner(inf, token, flag);
					 cancelling := (token.name = '-');
					 if cancelling
					    then scanner(inf, token, flag);
					 num := nil;
					 old_term(inf, num, flag);  { not expre ! }
					 
					 { num must be an expression that has evaluated to a monomial with coef 1. }
					 if num^.numb
							then error(195, token);
					 if num^.denom <> nil
							then error(196, token);
					 p := num^.numer;
					 n := 0;
					 while p^.exp = 0 do
							begin
								 n := n + 1;
								 p := p^.pcoef
							end;
					 n := n + 1;
					 if p^.next <> nil
							then error(195, token);
					 expon := p^.exp;
					 if expon < 1
					    then error(195, token);
					 p := p^.pcoef;									 
					 if not poly_eq_1(p)
							then error(195, token);									 
					 
					 if cancelling
					    then if expon <> 1
							        then error(200, token)
											else 
					    else if token.name <> '='
							        then error(4, token);
							
					 scanner(inf, token, flag);
					 if cancelling
					    then exit {(get_data)};
							
					 old_expre(inf, num, flag);
					 
					 if not num^.numb
					    then begin
							        if num^.denom <> nil
							           then error(196, token);
											if n <> poly_depth(num^.numer)
											   then error(197, token);
											p := num^.numer;
											for i := 2 to n do
											   p := p^.pcoef;
											if not height_is_1(p)
											   then error(197, token);
											if p^.exp >= expon
											   then error(198, token);
											while p <> nil do
											   begin
												    if p^.exp < 0
														   then error(168, token);
														p := p^.next
												 end
									 end
									 
				end;
				
		 {____________________________________________________________________}
		 
	    procedure sparse_update(ap: arrptr);		
				var i, j: longint;
						u: colm_ptrptr;
						sp: sparseptr;
				begin
					 sp := ap^.spar;
					 for i := 0 to (ap^.rows - 1) div sparsesize do {```}
						 begin
								for j := 1 + i*sparsesize to (i+1)*sparsesize do
									 if j > ap^.rows
											then break
											else begin
															u := @ sp^.indx[j-i*sparsesize];
															while u^ <> nil do
																 begin
																		mod_out_quoly(u^^.val, r, n, expon);
																		if quoly_iszero(u^^.val)
																			 then free_colm(u^)
																			 else u := @ u^^.next
																 end
													 end;
								sp := sp^.next
						 end
				end;

     {____________________________________________________________________}

     begin
		 
		    if imperative
				   then get_data(inf, flag)
					 else begin
									 writeln(userOutput, 'Changing polynomial mod out.');
									 writeln(userOutput, ' Enter polynomial equation:'); 
									 old_left := leftover;
									 do_prompts;
									 old_tt := tt_flag;
									 tt_flag := true;
									 readln(userInput);  { these readlns added HERE Jan 1998 }
									 get_data(userInput, zilch);
									 tt_flag := old_tt;
									 leftover := old_left
								end;
						 
				{ See that this var is suitable for modding. }
				q := polynames;
			  for i := 2 to n do
					 q := q^.next;
			  if q^.p <> nil
					 then if imperative
					         then free_poly(q^.p)  { will just replace old with new }
									 else if not cancelling
									         then error(199, token);
					 
				if cancelling
				   then begin
					         free_poly(q^.p);
									 writeln(userOutput, ' No longer modding out polynomial variable ', q^.let.name:1, '.');
									 reset_pseudo_poly;									 
									 exit {(set_mod_out)}
								end;
				
				writeln(userOutput, ' Now modding out polynomial variable ', q^.let.name:1, ', using ');
				write(userOutput, '     ', q^.let.name:1, '^', expon:1, ' = ');
				dummy := 0;
				quoly_display(userOutput, true, false, true, num, dummy, semicolon, polynames, 
				              false, true, false);	
				writeln(userOutput);
				
				pseudo_polynames := polynames;
		    								
				{ Convert format }
				if num^.numb
				   then begin
					         quoly_to_poly(num, r);
									 free_quoly(num)
								end
					 else begin
					         r := num^.numer;
									 writeln(userOutput, ' *** Warning. Not a number.');
									 num^.numer := nil;
									 num^.next := quolygarb;
									 quolygarb := num
								end;

        { Change all the storage. }
				for i := 0 to 150 do
				   begin
					    p := sca_store[i];
              while p <> nil do
                 begin
					          mod_out_quoly(p^.val, r, n, expon);
                    p := p^.next
                 end
					 end;

				for j := 0 to endarr do
           if (arp[j shr 10]^[j and tenmask] <> nil) 
              then mod_out_quoly(arp[j shr 10]^[j and tenmask], r, n, expon);
							
				for i := 0 to 150 do
            begin
						   ap := arr_store[i];
							 while ap <> nil do
                  begin
										 if ap^.spar <> nil
										    then sparse_update(ap);
										 ap := ap^.next
									end
						end;
					
				if syst^.spar = nil
				   then for j := 0 to syst^.stop do
				           mod_out_quoly(stash^[j], r, n, expon);
					 
				{ Finally, actually effect the change. }
				q^.expon := expon;
				q^.p := r
		 
		 end;

 {***************************************************************************}
 
 procedure numb_divide_thru(var n: quoly; var dup: workarray; invert: boolean; 
		                        i, m: longint; var ops: colptr);
											 
		{ if invert, n is never even looked at. }

    var j, s: longint;
				ival: longreal;

		 procedure newcolnode;
		    var cl: colptr;
				begin
				   newcol(cl);
					 cl^.i := i;
					 cl^.j := i;
					 quoly_set_ext(ival, cl^.f);
					 cl^.next := ops;
					 ops := cl
				end;
		 
    begin
		
        i := i - 1;  { now reduced }
				s := i + m * i;
        ival := dup[s]^.ncoef^.float;
				if invert
           then newcolnode
					 else n^.ncoef^.float := ival * n^.ncoef^.float;
				ival := 1/ival;
				dup[s]^.ncoef^.float := 1;					
				for j := i+2 to m do
					 begin
							s := s + m;
							dup[s]^.ncoef^.float := dup[s]^.ncoef^.float * ival
					 end
					 
    end;
	
 {***************************************************************************}
 
 procedure divide_thru(var n: quoly; var dup: workarray; invert: boolean; 
                       i, m: longint; var ops: colptr);

    { If invert, n is never even looked at. i is unreduced. ~~~~ all new}

    var j, s: longint;
        val: quoly;
				flipped: boolean;

     {_______________________________________________________________}
		
		 function monomial(n: ferm118.poly): boolean;			 
				{ n can't be nil }				
				begin				
					 if n^.next = nil
						  then if n^.numb
										  then monomial := true
									    else monomial := monomial(n^.pcoef)
						  else monomial := false						
				end;
 
		 {_________________________________________________________________}
		 
		 procedure newcolnode;
		    var cl: colptr;
				begin
				   newcol(cl);
					 cl^.i := i;
					 cl^.j := i;
					 quoly_assign(val, cl^.f);
					 cl^.next := ops;
					 ops := cl
				end;
		 
     {__________________________________________________________________}
		 
		 begin

        i := i - 1;
				s := i + m * i;
        val := nil;
        quoly_assign(dup[s], val);
				if invert
				   then newcolnode
				   else quoly_mult(n, val, n);
        flipped := val^.numb or (laurent and (val^.denom = nil) and monomial(val^.numer));
				if flipped
           then quoly_reciprocal(val);
				quoly_set(1, dup[s]);
				for j := i+2 to m do
           begin
							s := s + m;
						  if flipped
								 then quoly_mult(dup[s], val, dup[s])
								 else quoly_quot(dup[s], val, dup[s])
           end; 
        free_quoly(val)
				
    end;
	
  {***********************************************************************}

  procedure zero_out(var dup: workarray; i, m: longint; allreal: boolean; var ops:
	                   colptr);

     var r, j, s, t: longint;
         val, temp: quoly;
				 ival, iprod: longreal;

     procedure newcolnode(p: quoly);
		    var cl: colptr;
				begin
				   newcol(cl);
					 cl^.i := i;
					 cl^.j := r;
					 quoly_assign(p, cl^.f);
					 cl^.next := ops;
					 ops := cl
				end;
		 
		 begin
        
        i := i - 1;   { i is now a reduced coord }
        if allreal
				   then for r := i + 1 to m - 1 do
									 begin
											s := r + m*i;
											ival := dup[s]^.ncoef^.float;
											newcolnode(dup[s]);
											dup[s]^.ncoef^.float := 0;
											t := s - r + i;
											for j := i+1 to m-1 do
												 begin
														s := s + m;
														t := t + m;
														iprod := ival * dup[t]^.ncoef^.float;
													  dup[s]^.ncoef^.float := dup[s]^.ncoef^.float - iprod
												 end
									 end
					 
					 else for r := i + 1 to m - 1 do
									 begin
											s := r + m*i;
											val := dup[s]; { val is an alias }
											newcolnode(val);
											t := s - r + i;
											for j := i+1 to m-1 do
												 begin
														s := s + m;
														t := t + m;
														temp := nil;
														quoly_mult(val, dup[t], temp);													 
														best_quoly_sub(dup[s], temp)
												 end;
											quoly_set(0, dup[r + m*i]);  { Note: Don't move up! }
                   end
				
     end;

  {***********************************************************************}

  procedure simple_zero_out(var dup: workarray; i, m: longint; allreal: boolean);

     var r, j, s, t: longint;
         val, temp: quoly;
				 ival, iprod, isum: longreal;

     begin
        
        if allreal
				   then for r := i to m - 1 do
									 begin
											s := r + m*(i-1);
											ival := dup[s]^.ncoef^.float;
											t := i + m*(i-1) - 1;
											for j := i to m - 1 do
												 begin
														s := s + m;
														t := t + m;
														iprod := ival * dup[t]^.ncoef^.float;
														isum := dup[s]^.ncoef^.float - iprod;		 
														dup[s]^.ncoef^.float := isum
												 end
									 end					 
					 
					 else for r := i to m - 1 do
									 begin
											s := r + m*(i-1);
											val := dup[s];
											t := i + m*(i-1) - 1;
											for j := i to m - 1 do
												 begin
														s := s + m;
														t := t + m;
														temp := nil;
														quoly_mult(val, dup[t], temp);
														best_quoly_sub(dup[s], temp)
												 end
									 end
				
     end;

  {*************************************************************************}
	
	procedure small_determ(var n: quoly; var matrx: small_workarray; s: longint);
	
	   { matrx is s by s. s >= 2. compute determinant n by minors. }
	
	   var copy: small_workarray;
		     i, r, k: longint;
				 p: quoly;
	
	   begin
 
			  p := nil;
				if s = 2
				   then begin
					         quoly_mult(matrx[0], matrx[3], n);
									 quoly_mult(matrx[1], matrx[2], p);
									 best_quoly_sub(n, p)
								end
				else begin
								r := s + 1;
				        k := s - 1;
								{ initialize copy to last s-1 rows and cols of matrx.}
				        for i := 0 to s*s - 2*s do
					         copy[i] := matrx[i mod k + s*(i div k) + r]; 
												
				        quoly_set(0, n);
								for i := 0 to s-1 do
								   begin
									    p := nil;
									    small_determ(p, copy, s-1);
											quoly_mult(p, matrx[i*s], p);
											if odd(i)
											   then quoly_inplace(p);
											best_quoly_add(n, p);
											if i < s-1  { ith column of matrx (except first row) goes into
											              ith column of copy }
											   then for k := 0 to s - 2 do
					                       copy[k + i*(s-1)] := matrx[k + i*s + 1] 
									 end
						 end
				
	   end;
	
  {*******************************************************************

  COMMENT   
	procedure good_row(var dup: workarray; i, m: longint; var newi, j: longint);

       returns unnnormalized forms of col = j and row = newi 
			var k: longint;

      begin
        j := i;
        k := m * (i - 1) - 1;
        while i <= m do
          if ferm118.iszero(dup[i+k]^.ncoef^)
					    then i := i + 1
              else break;					
        if i > m
          then newi := 0
          else newi := i
      end;
			
  ************************************************************************}

  procedure simple_swap_rows(var dup: workarray;  i, j, m: longint);
											
	  { m = rows; i and j reduced coordinates. Assume i <> j. }

     var k, s: longint;
         temp: quoly;
     begin
        for k := 0 to m-1 do
          begin
             s := m * k;
             temp := dup[i+s];
			       dup[i+s] := dup[j+s];
			       dup[j+s] := temp
          end
     end;
			
 {************************************************************************}

  procedure dual_swap_cols(var n: quoly; var dup: workarray; invert: boolean; 
	                         i, j, m: longint);
											
	   { m = rows, i and j reduced coordinates. }

      var k, s, t: longint;
          temp: quoly;

      begin
	       s := j*m;
		     t := i*m;
         for k := 0 to m-1 do
            if invert or (k >= i)
			         then begin
											 temp := dup[t+k];
											 dup[t+k] := dup[s+k];
											 dup[s+k] := temp;
										end;  
         if not invert 
            then quoly_inplace(n)
      end;
			
	{*************************************************************************}
	
	procedure recheck(var p: quoly);
	
	   { p is not a number }
	
	   begin
		    
				total_poly_modout(p^.numer);
			  if p^.denom <> nil
				   then begin
					         total_poly_modout(p^.denom);
				           if poly_iszero(p^.denom)
					            then begin
											        writeln(userOutput, ' On converting a quoly to poly-mod-out, a denominator became 0.');
															writeln(userOutput, ' The quoly was set to 0.');
															quoly_set(0, p);
															exit {(recheck)}
													 end;									 
				           if poly_iszero(p^.numer)
				              then begin
											        quoly_set(0, p);
															exit {(recheck)}
													 end;
									 check_quoly(p, false)  
								end;
				 if poly_iszero(p^.numer)
				    then quoly_set(0, p)
						else if p^.numer^.numb and (p^.numer^.next = nil) and (p^.denom = nil)
					          then polynum_to_quoly(p)
						
		 end;	
	
	{******************************************************************************}

  procedure invert_sparse(var spar: sparseptr; var arr: workarray; ar_free, 
	                        invert: boolean; rows: longint; var n: quoly); forward;
																										
  {******************************************************************************}

  procedure mat_invert { (var ar, outar: workarray;  ar_free, oar_free: boolean; m: longint; 
	                        var n: quoly; invert, equal: boolean; var spar: sparseptr) };

	  { Invert or determinat of mXm ar. 
		  Answer goes in outar, which is freed or not freed before assignment at end
		  depending on oar_free.  If called to find determinant, n is 1 upon entry. }

    var smallcopy: small_workarray;
				mydupptr, dup: workptr;
        rowops, colswap, q: colptr;
				arf: arr_descr;
        i, j, k, newi, r, s, num_cols, mycut: longint;
        sum, temp: quoly;
				cols_to_search: (one, half, all);
				allnumbs, allreal: boolean;
				iprod, isum: longreal;
				old_pseudo_poly: polypt;
				
  	{----------------------------------------------------------------}
		
		procedure set_search_params;
		   var i: longint;			     
	     begin			 
			    { set defaults }
			    allnumbs := true;
					allreal := true;
					
					if polynames <> nil
					   then for i := 0 to m*m - 1 do
										 if not ar[i]^.numb 
												then begin
																allnumbs := false;
																break
														 end;					
					
					if allnumbs
					   then begin
						         if complex and not realflag
						            then for i := 0 to m*m - 1 do
															  if ar[i]^.ncoef^.imag <> nil 
																	 then begin
																					allreal := false;
																					break
																			  end
													
									end
						 else allreal := false;
					
					if allreal
					   then cols_to_search := one						 
						 else cols_to_search := all
						 
			 end;
			
	  {____________________________________________________________________}
	 
	  procedure restore_rowop(q: colptr);
			var i, s, t: longint;
					temp: quoly;
					ival: longreal;
					
			begin
				 s := m * q^.i;
				 t := m * q^.j;
				 if s = t  { a divide thru }
						then if allreal
										then begin
													 ival := 1/q^.f^.ncoef^.float;
													 for i := 0 to m-1 do 
															with outar[s+i]^.ncoef^ do
															   float := ival * float
												 end
										else for i := 0 to m-1 do  
														quoly_quot(outar[s+i], q^.f, outar[s+i])
				 else if q^.f = nil  { a swap (of rows originally) }
						then for i := 0 to m-1 do  
										 begin
												temp := outar[s+i];
												outar[s+i] := outar[t+i];
												outar[t+i] := temp
										 end
				 else { a row manipulation, originally }
				      if allreal  
								 then begin
												 ival := q^.f^.ncoef^.float;
												 for i := 0 to m-1 do  
														with outar[s+i]^.ncoef^ do
															 float := float - outar[t+i]^.ncoef^.float * ival
											end
								 else for i := 0 to m-1 do  
												 begin
														temp := nil;
														quoly_mult(q^.f, outar[t+i], temp);													 
														best_quoly_sub(outar[s+i], temp)
												 end;
				 free_quoly(q^.f)
			 end;			 
	 
	  {__________________________________________________________________}


    begin
		
			if spar <> nil
			   then begin
				         invert_sparse(spar, outar, ar_free, invert, m, n); {~~~~`}
								 exit {(mat_invert)}
							end;
							
			set_search_params;  { allnumbs, allreal, and cols_to_search }
			old_pseudo_poly := pseudo_polynames;
			pseudo_polynames := nil;    { turn off poly-mod-out }

			if not invert 
			   then if detcutoff < 0   { set mycut by defaults; else use user's value. }
				         then  if allnumbs
													then mycut := 2
											 else if m <= 2
													then mycut := 2
											 else if m <= 5
													then mycut := m - 1
											 else if m = 6
													then mycut := 4
											 else mycut := 0												 
                     
								 else mycut := detcutoff;  
											
			if invert
				 then begin
								 mydupptr := @ outar;  
								 duparr^.name.name := 'outar';
								 if oar_free
										then if equal
														then { nothing }
														else for i := 0 to sqr(m) - 1 do
																		quoly_assign(ar[i], outar[i])
										else for i := 0 to sqr(m) - 1 do
														begin
															 sum := nil;
															 quoly_assign(ar[i], sum);
															 outar[i] := sum
														end
														
									{ outar is now freeable }
							end
				 
			   else if ar_free and equal  {~~~~ note equal}
								 then begin
												 mydupptr := @ ar;
												 duparr^.name.name := 'outar'
											end
				 else { copy ar into dup }
							begin
								 new_worknode(i, quotsign);
								 dup := workhead[i];
								 for i := 0 to sqr(m) - 1 do
										begin
											 dup^[i] := nil;
											 quoly_assign(ar[i], dup^[i])
										end;
								 duparr^.name.name := 'dup';
								 mydupptr := dup
							end;	
					
			dupptr := mydupptr;  { for diagnostic/info purposes and maybe freeing }
			duparr^.stop := sqr(m) - 1;
			duparr^.rows := m; 
			arf[1] := sqr(m);
			{ Next two vars point to stacks of row manips and col swaps. }
			colswap := nil;
			rowops := nil;

      { convert mydupptr^ to upper triangular.  If invert, keep a record of row
				manipulations and all swaps. }
			for i := 1 to m do
				 begin
							
						case cols_to_search of
							 one:  num_cols := 1;
							 half: num_cols := (m-i+2) div 2; { currently unused }
							 all:  num_cols := m-i+1
						end;
						find_good_spot(mydupptr^, i, m, num_cols, newi, j);	
																		
						if newi = 0 { error situation, or at least 0 determinant }
							then begin
											if mydupptr = dup
												 then begin
																	free_arr(dup^, arf);
																	free_work  
															end;                    
											dupptr := nil;
											if invert
												 then begin
																 arf[1] := sqr(m);
																 if ar_free
																		then free_arr(ar, arf);
																 arf[1] := sqr(m);  
																 if not equal
																		then free_arr(outar, arf);
																 pseudo_polynames := old_pseudo_poly;
																 error(44, quotsign)
															end
												 else quoly_set(0, n);
											pseudo_polynames := old_pseudo_poly;
											exit {(mat_invert)}                            
									 end;
									 
						if i <> newi
							 then begin  
											 swap_rows(n, mydupptr^, not invert, false, i-1, newi-1, m);
											 if invert  { save data for later correcting }
													then begin
																 newcol(q);  
																 q^.i := i - 1;
																 q^.j := newi - 1;
																 q^.next := rowops;
																 rowops := q
															 end
										end;
										
						if i <> j
							 then begin
											 dual_swap_cols(n, mydupptr^, invert, i-1, j-1, m);
											 if invert  { save data for later swapping of rows }
													then begin
																 newcol(q);  
																 q^.i := i - 1;
																 q^.j := j - 1;
																 q^.next := colswap;
																 colswap := q
															 end
										end;

						if (m - i + 1 > mycut) { i is small } or invert
							 then begin
											 if (i = m) and not invert
													then begin  { don't do last divide - it's silly }
																	quoly_mult(n, mydupptr^[sqr(m)-1], n);
																	quoly_set(1, mydupptr^[sqr(m)-1])
															 end										 
													else if allreal
																	then numb_divide_thru(n, mydupptr^, invert, i, m, rowops)
																	else divide_thru(n, mydupptr^, invert, i,m, rowops);
											 if invert
													then zero_out(mydupptr^, i,m, allreal, rowops)
													else simple_zero_out(mydupptr^, i,m, allreal)
										end
							 else begin
											 s := m - i + 1; { rest of matrix is s by s. s>=1. }
											 if s = 1
													then begin { must also have m = 1 }
																	quoly_assign(mydupptr^[0], n);
																	break
															 end;												        
											 r := (i - 1)*(m + 1);
											 for k := 0 to sqr(s) - 1 do
													smallcopy[k] := mydupptr^[k mod s + m*(k div s) + r];
											 temp := nil;
											 small_determ(temp, smallcopy, s);  { finish with minors }	
											 quoly_mult(n, temp, n);
											 free_quoly(temp);
											 break
										end
										
				 end;
								
			if not invert
				 then begin { only want determinant }
								 if mydupptr = dup
										then begin
														arf[1] := sqr(m);
														free_arr(dup^, arf);
														free_work
												 end;                    
								 dupptr := nil;  
								 pseudo_polynames := old_pseudo_poly;
								 if pseudo_polynames <> nil  { n is probably wrong }
								    then if not n^.numb
															 then recheck(n);
								 exit {(mat_invert)}
							end;
							
			{ invert upper triangular mydupptr^ }            
			if allreal
			   then for i := 0 to m - 2 do
								 for j := 1 to m - i - 1 do
										begin
												r := - j - i + m * (m - i) - 1;
												isum := 0;	
												for k := 1 to j do
													 begin
															s := r + m * (k - j);
															iprod := mydupptr^[s]^.ncoef^.float * mydupptr^[r+k]^.ncoef^.float;
															isum := isum - iprod
													 end;
												quoly_set_ext(isum, mydupptr^[r]);
										end
				 
				 else for i := 0 to m - 2 do
								for j := 1 to m - i - 1 do
									 begin
											r := - j - i + m * (m - i) - 1;
											sum := nil;
											quoly_set(0, sum);
											for k := 1 to j do
												 begin
														s := r + m * (k - j);
														temp := nil;
														quoly_mult(mydupptr^[s], mydupptr^[r+k], temp);
														best_quoly_sub(sum, temp)
												 end;
											free_quoly(mydupptr^[r]);
											mydupptr^[r] := sum
									 end;

			{ Compute mydupptr^ times rowops's data; then swap rows according to 
				colswap's data.  Reacll that mydupptr := @ outar. }
			if rowops <> nil
				 then begin
								 q := rowops;
								 while true do
										begin
											 restore_rowop(q);
											 if q^.next = nil
													then break
													else q := q^.next
										end;
								 q^.next := colgarb;
								 colgarb := rowops
							end;
										
			if colswap <> nil 
				 then begin
								 q := colswap;
								 while true do
										begin
											 simple_swap_rows(outar, q^.i, q^.j, m);
											 if q^.next = nil
													then break
													else q := q^.next
										end;
								 q^.next := colgarb;
								 colgarb := colswap
							end;
			
			arf[1] := sqr(m);
			dupptr := nil;
			pseudo_polynames := old_pseudo_poly;
			if pseudo_polynames <> nil  { outar is probably wrong }
				 then for i := 0 to m*m - 1 do
				         if not outar[i]^.numb
								    then recheck(outar[i])
		
    end;

  {***************************************************************************}
	
	procedure normalize; { (var n: quoly; q: arrptr; want: boolarray; var alpha, 
	                        beta, alphinv, betinv: workarray); }
	
		 { q is not sparse }
		 
		 var rows, cols, min, i, j, k, locat, spot, start, other: longint;
		     factor, prod: quoly;
				 iszer: boolean;
				 qp: quolyptr;
		 
		 begin
		 
		    rows := q^.rows;
				cols := q^.size div rows;
				if rows < cols
				   then min := rows
					 else min := cols;
				if want[1]
				   then identi(alpha, rows, false);
			  if want[2]
					 then identi(beta, cols, false);
			  if want[3]
					 then identi(alphinv, rows, false);
			  if want[4]
					 then identi(betinv, cols, false);
					 
				factor := nil;				
				for i := 0 to min-1 do
				   begin
					    findbest(q^.start, q^.stop, rows, i, j, k);
							if j = -1 
							   then begin
								         min := i;
												 break;
											end;
							if i <> k
							   then switchrow_col(Switchcol_, i, k, q^.start+i, rows, rows - i, cols - i);
		          if i <> j
							   then switchrow_col(Switchrow_, i, j, q^.start+i*rows, rows, rows - i, cols - i);
							
							if (i <> j) and want[1]
								 then swap_rows(factor, alpha, false, true, i, j, rows);
							if (i <> k) and want[2]
								 then swap_cols(beta, i, k, cols);
							if (i <> j) and want[3]
				         then swap_cols(alphinv, i, j, rows);
			        if (i <> k) and want[4]
			           then swap_rows(factor, betinv, false, true, i, k, cols);								
							
							{ row reduce }
							other := i + 1; { marks row number for alpha, beta, etc. }
							start := q^.start + i*rows + i;  { address of diagonal spot }
							for j := start + 1 to start + rows - i - 1 do  { rest of this column }
							   begin
								    qp := @ arp[j shr 10]^[j and tenmask];
										if not quoly_iszero(qp^)
								      then begin
															quoly_quot(qp^, 
																				arp[start shr 10]^[start and tenmask], 
																				factor);
															quoly_set(0, qp^);
															locat := start + rows;
															spot := j + rows;
															while locat <= q^.stop do
																 begin
																		prod := nil;
																		quoly_mult(factor, arp[locat shr 10]^[locat and tenmask], prod);
																		best_quoly_sub(arp[spot shr 10]^[spot and tenmask],
																									 prod);
																		locat := locat + rows;
																		spot := spot + rows;
																 end;
															if want[1]
																 then row_reduce(alpha, factor, rows, other, i);
															if want[3]
															   then begin
																         quoly_inplace(factor);
																				 col_reduce(alphinv, factor, rows, i, other)
																			end
												   end;
										  other := other + 1
									end;
												 
						  { col reduce }
							k := q^.start + i*rows + i + rows;
							other := i + 1;  { marks col number for alpha, beta, etc. }
							while k <= q^.stop do
							   begin
								    qp := @ arp[k shr 10]^[k and tenmask];
										iszer := quoly_iszero(qp^);
										if (want[2] or want[4]) and not iszer
										   then begin
											         quoly_quot(qp^, arp[start shr 10]^
															            [start and tenmask], factor);
															 if want[2]
															    then col_reduce(beta, factor, cols, other, i);
															 if want[4]
																  then begin
																				  quoly_inplace(factor);
																			    row_reduce(betinv, factor, cols, i, other)
																		   end;
														end;
										other := other + 1;
								    if not iszer
										   then quoly_set(0, qp^);
										k := k + rows
								 end
								     
					 end;
					 
				free_quoly(factor);
				quoly_set(min, n)
							   
		 end;
		 
  {***************************************************************************}
	
	procedure red_row_ech; { var n: quoly; q: arrptr; want: boolarray; var alpha, 
	                         alphinv: workarray }
	                         
	   { reduced row echelon.  beta and betainv make no sense, so want[3] and
	     want[4] make no sense.  At end, alpha*original = reduced.  Oct 2000
	     Warning: svery sensitive to roundoff errors when rank < maximal! }
	
		 var rows, cols, i, j, locat, spot, start, other, rank: longint;
		     prod: quoly;
				 qp, pp: quolyptr;
		 
		 begin
		 
		    rows := q^.rows;
				cols := q^.size div rows;
				if want[1]
				   then identi(alpha, rows, false);
			  if want[2]
					 then identi(alphinv, rows, false);
					 
				rank := 0;	{ also denotes the row we are working on }		
				for i := 0 to cols-1 do
				   begin
				      { Try every column. i marks the column here. }
				      if rank = rows  { done. certainly possible when more cols than rows }
				         then break;
					    colfindbest(q^.start, rows, rank, i, j);
							if j = -1 
							   then continue;  { abandon column i; use same row next time. }
							if rank <> j
							   then switchrow_col(Switchrow_, rank, j, q^.start+i*rows, rows, 
							                      rows {irrelevant}, cols - i);
							
							if (rank <> j) and want[1]  
								 then swap_rows(qp^, alpha, false, true, rank, j, rows);
							if (rank <> j) and want[2]
				         then swap_cols(alphinv, rank, j, rows);
			        
							{ row reduce. first divide out this row by the pivot. }
							start := q^.start + i*rows + rank;  { address of pivot }
							locat := start + rows;
							while locat <= q^.stop do
								 begin
										qp := @ arp[locat shr 10]^[locat and tenmask];
										quoly_quot(qp^, arp[start shr 10]^[start and tenmask], 
															 qp^);
										locat := locat + rows
								 end;
							{ do corresponding action to alpha and alphainv. }
							qp := @ arp[start shr 10]^[start and tenmask];
							if want[1]
								 then divide_row(alpha, qp^, rows, rank);
							if want[2]
							   then mult_col(alphinv, qp^, rows, rank);
							quoly_set(1, qp^);  { pivot is now 1. }
							
							{ row reduce. start at row 0 and go to row rank-1 }
							other := 0; { marks row-to-be-changed number for alpha, alphainv. }
							for j := q^.start + i*rows to start - 1 do  
							   begin
								    qp := @ arp[j shr 10]^[j and tenmask];
								  {  if qp^^.numb
											 then if close_to_0(qp^^.ncoef^)
														   then quoly_set(0, qp^); gave up on this }
										if not quoly_iszero(qp^)
								      then begin
															locat := start + rows;
															spot := j + rows;
															while locat <= q^.stop do
																 begin
																		prod := nil;
																		pp := @ arp[spot shr 10]^[spot and tenmask];
																		quoly_mult(qp^, arp[locat shr 10]^[locat and tenmask], prod);
																		best_quoly_sub(pp^, prod);
																{		if pp^^.numb
																		   then if close_to_0(pp^^.ncoef^)
																		           then quoly_set(0, pp^); }
																		locat := locat + rows;
																		spot := spot + rows
																 end;
															if want[1]
																 then row_reduce(alpha, qp^, rows, other, rank);
															if want[2]
															   then begin
																         quoly_inplace(qp^);
																				 col_reduce(alphinv, qp^, rows, rank, other)
																			end;
														  quoly_set(0, qp^);
												   end;
										other := other + 1
								 end;
									
							{ now go from rank + 1 down to bottom }
							other := rank + 1; { marks row-to-be-changed number for alpha, alphainv. }
							for j := start + 1 to start + rows - rank - 1 do  { rest of this column }
							   begin
								    qp := @ arp[j shr 10]^[j and tenmask];
									{	if qp^^.numb
											 then if close_to_0(qp^^.ncoef^)
														   then quoly_set(0, qp^); }
										if not quoly_iszero(qp^)
								      then begin
															locat := start + rows;
															spot := j + rows;
															while locat <= q^.stop do
																 begin
																		prod := nil;
																		pp := @ arp[spot shr 10]^[spot and tenmask];
																		quoly_mult(qp^, arp[locat shr 10]^[locat and tenmask], prod);
																		best_quoly_sub(pp^, prod);
																	{	if pp^^.numb
																		   then if close_to_0(pp^^.ncoef^)
																		           then quoly_set(0, pp^); }
																		locat := locat + rows;
																		spot := spot + rows
																 end;
															if want[1]
																 then row_reduce(alpha, qp^, rows, other, rank);
															if want[2]
															   then begin
																         quoly_inplace(qp^);
																				 col_reduce(alphinv, qp^, rows, rank, other)
																			end;
															quoly_set(0, qp^)
												   end;
										 other := other + 1
									end;
									
							rank := rank + 1
							
					 end;
												 					 
				quoly_set(rank, n)
							   
		 end;
		 
  {***************************************************************************}
	
   procedure concaten(var n: quoly; var arr2: workarray; var arr_facts: arr_descr; 
	                    arr2_free, arr_free: boolean; var arr: workarray; first: boolean; 
											var rows: longint);
											
		  var i: longint;
		
			begin
						   
				 if arr_facts[1] + 1 > arr_limit
				    then begin
										if arr2_free then free_arr(arr2, arr_facts);
										error(111, concatsign)
								 end;
				 arr_facts[1] := arr_facts[1] + 1;
				 if arr_facts[2] > 1
				    then arr_facts[2] := arr_facts[1];  { convert to column vector }
				 rows := arr_facts[2];
				 	
				 if first  { put n in front }
				    then begin
						        for i := arr_facts[1] - 1 downto 1 do
											 arr[i] := arr2[i-1];
										if not arr_free
										   then arr[0] := nil;
										quoly_assign(n, arr[0])
								 end
				    else begin  { put n in back }
						        i := arr_facts[1] - 1;
										arr[i] := nil;
                    quoly_assign(n, arr[i]);
								 end
				 
			end;
			
   {****************************************************************}
	
   procedure concatenate(var arr, arr2: workarray; var arr_facts, arr2_facts: 
	                       arr_descr; arr_free, arr2_free: boolean; var col, rows: 
												 longint; var oktofree: boolean);
													
			{ wasteful overuse of assign -- should just assign pointers }
		
		  var col2, i, increm: longint;
			    prod: workptr;
					goof: boolean;
					n: quoly;
			
			begin
			
			   if arr_facts[1] + arr2_facts[1] > arr_limit
				    then begin
						        if arr_free then free_arr(arr, arr_facts);
										if arr2_free then free_arr(arr2, arr2_facts);
										error(111, concatsign)
								 end;
																		 
				 col2 := arr2_facts[1] div arr2_facts[2];
				 
				 if arr_facts[1] = 1
				    then begin
						         if not arr2_free
										    then for i := 0 to arr2_facts[1] - 1 do
																 begin
																    n := nil;
																		quoly_assign(arr2[i], n);  
																		arr2[i] := n
																 end;
						         n := arr[0];  { looks weird, I know }
						         concaten(n, arr2, arr2_facts, true, arr_free, arr, true, rows);
										 arr_facts := arr2_facts;
										 oktofree := false;
										 exit {(concatenate)}
								 end
				 else if arr2_facts[1] = 1
				    then begin
						         if not arr_free
										    then for i := 0 to arr_facts[1] - 1 do
																 begin
																    n := nil;
																		quoly_assign(arr[i], n);  
																		arr[i] := n
																 end;
										 concaten(arr2[0], arr, arr_facts, true, true, arr, false, rows);
										 exit {(concatenate)}
								 end;
										 
				 increm := -arr2_facts[2];
				 goof := false;
				 new_worknode(i, token);																		 
			   prod := workhead[i];
	
				 if col = col2
				    then begin
						        for i := 0 to arr_facts[1] - 1 do
										   begin
											    if i mod arr_facts[2] = 0
													   then increm := increm + arr2_facts[2];
											    prod^[i + increm] := nil;
												  quoly_assign(arr[i], prod^[i + increm]);
											 end;
										increm := 0;
										for i := 0 to arr2_facts[1] - 1 do
										   begin
											    if i mod arr2_facts[2] = 0
													   then increm := increm + arr_facts[2];
											    prod^[i + increm] := nil;
												  quoly_assign(arr2[i], prod^[i + increm]);
											 end;
										rows := arr_facts[2] + arr2_facts[2];
								 end
				 else if arr_facts[2] = arr2_facts[2]  { rows are equal }
				    then begin
						        for i := 0 to arr_facts[1] - 1 do
										   begin
											    prod^[i] := nil;
												  quoly_assign(arr[i], prod^[i]);
											 end;
										for i := arr_facts[1] to arr_facts[1] + arr2_facts[1] - 1 do
										   begin
											    prod^[i] := nil;
												  quoly_assign(arr2[i - arr_facts[1]], prod^[i]);
											 end;
										rows := arr_facts[2];
										col2 := col + col2
								 end
				 else goof := true;
				 
				 if arr_free 
				    then free_arr(arr, arr_facts);				 
				 if goof and arr2_free
				    then begin
						        free_arr(arr2, arr2_facts);
						        error(112, concatsign)
								 end;
				 
				 arr_facts[1] := rows * col2;
				 arr_facts[2] := rows;
				 for i := 0 to arr_facts[1] - 1 do
            arr[i] := prod^[i];
				 free_work
														 						
			end;
			
	{************************************************************************}

  procedure arr_term(var inf: text; var n: quoly; var arr: workarray;
                     var arr_facts: arr_descr; var arr_free: boolean; 
										 var rows: longint; var flag: nameptr; var spar: sparseptr;
										 callfact: boolean);
										 
  { Evaluate array term.  Possible space losing problem.  If error occurs during
	  second call to arr_fact, the storage of arr will be lost. (maybe fixed, Nov 92,
		with sparse_error and one_error).
		   arr_facts is output parameter. Only exception is arr_facts[1] is needed by 
		arr_fact if it finds [1] or []. 
		    Nov 1997:  callfact added. }

    var n2, n3: quoly;
        arr2: workptr;
				spar2: sparseptr;
        arr2_facts: arr_descr;
        key: char;
        oldtoken: tokentipe;
        i, col, copy: longint;
				arr2_free, oktofree, times, implicit: boolean;
   	
    {_________________________________________________________________________}
		
		procedure sparse_error(x: longint);
		   begin
			    if spar <> nil
						 then free_sparse(spar, arr_facts[2], arr_free)
						 else if arr_free 
						         then free_arr(arr, arr_facts);
				  if spar2 <> nil
						 then free_sparse(spar2, arr2_facts[2], arr2_free)
						 else if arr2_free 
						         then free_arr(arr2^, arr2_facts);
				  error(x, oldtoken)
			 end;
			 
		{_________________________________________________________________________}
		
		procedure one_error(var sp: sparseptr; var ar: workarray; free: boolean; 
		                    facts: arr_descr; x: longint);
		   begin
			    if sp <> nil
						 then free_sparse(sp, facts[2], free)
						 else if free 
						         then free_arr(ar, facts);
				  error(x, oldtoken)
			 end;
			 
		{_________________________________________________________________________}

    begin
		
      n2 := nil;
      if callfact  { Nov 1997 }
         then arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
      arr2_facts[1] := 0;
					 
      key := token.name[1];
      copy := rows;
      arr2_facts[1] := arr_facts[1];  { only needed below by []. }
			while (key = '*') or (key = '/') or (key = '|') or (key = '\') or (key = '') or (key = '') 
			      or (key = '') or ((key >= 'a') and (key <= 'z')) or ((key >= 'A') and (key <= 'Z')) 
						do
         begin
						new_worknode(i, token);
						arr2 := workhead[i];
						oldtoken := token;
						implicit := (key = '') or (key = '') or ((key >= 'a') and (key <= 'z')) or 
						            ((key >= 'A') and (key <= 'Z'));
						times := implicit or (key = '*');
						if not implicit
						   then scanner(inf, token, flag);
						spar2 := nil;
						arr_fact(inf, n2, arr2^, arr2_facts, arr2_free, copy, flag, spar2);
						if (arr2_facts[1] = 0) and (arr_facts[1] = 0) { both scalars }
							then begin
											if times
												 then quoly_mult(n, n2, n)
											else if oldtoken.name = '/'
												 then quoly_quot(n, n2, n)
											else if oldtoken.name = ''
												 then begin
																 free_quoly(n2);
																 free_quoly(n);
																 error(113, oldtoken)
															end
											else quoly_mod_or_div(n, n2, n, oldtoken.name[1])
									 end
							else if arr_facts[1] = 0  { first item is a scalar }
								then
									begin
										rows := copy; { this is the correct value to pass back (usually) }
										if times
											 then if spar2 = nil
															 then for i := 0 to arr2_facts[1] - 1 do
																			 begin
																					arr[i] := nil;
																					quoly_mult(arr2^[i], n, arr[i])
																			 end
															 else begin
															         mult_cons_sparse(spar2, n, arr2_free, rows);
																			 spar := spar2
																		end
										else if oldtoken.name = '/'
											then if arr2_facts[1] = sqr(arr2_facts[2])
												then { matrix inversion }
														if first_available <= worksize
															 then begin
																			 mat_invert(arr2^, arr, arr2_free, false, arr2_facts[2], n, true, false, spar2);
																			 if quoly_eq_1(n)
																			    then spar := spar2
																					else if spar2 = nil
																									then for i := 0 to arr2_facts[1] - 1 do
																													quoly_mult(arr[i], n, arr[i])
																									else begin
																									        mult_cons_sparse(spar2, n, arr2_free, rows);
																													spar := spar2
																											 end
																		end
															 else one_error(spar2, arr2^, arr2_free, arr2_facts, 89)
												else { term by term division }
														 if spar2 = nil
																then for i := 0 to arr2_facts[1] - 1 do
																				begin
																					 arr[i] := nil;
																					 quoly_quot(n, arr2^[i], arr[i])
																				end
															  else one_error(spar2, arr2^, arr2_free, arr2_facts, 289)
																        
										else if oldtoken.name = ''
											then if spar2 = nil
											        then if arr2_free
																			then concaten(n, arr2^, arr2_facts, arr2_free, false, arr, true, rows) 
																			else begin
																							for i := 0 to arr2_facts[1] - 1 do
																								 begin
																										arr[i] := nil;
																										quoly_assign(arr2^[i], arr[i])
																								 end;
																							concaten(n, arr, arr2_facts, true, false, arr, true, rows)
															             end
															else one_error(spar2, arr2^, arr2_free, arr2_facts, 289)				 
															
										else { its mod or div }
												if spar2 = nil
												    then for i := 0 to arr2_facts[1] - 1 do
																		begin
																			 arr[i] := nil;
																			 quoly_mod_or_div(n, arr2^[i], arr[i], oldtoken.name[1])
																		end
													  else one_error(spar2, arr2^, arr2_free, arr2_facts, 289);
										
										arr_facts := arr2_facts;
										if arr2_free and (oldtoken.name <> '') and (spar2 = nil) 
											 then free_arr(arr2^, arr2_facts)
	
									end  { first item is a scalar }
									
							 else if arr2_facts[1] = 0  { second is scalar }
									then if arr_free
													then if times
																	then if spar = nil
																	        then for i := 0 to arr_facts[1] - 1 do
																					        quoly_mult(arr[i], n2, arr[i])
																					else mult_cons_sparse(spar, n2, true, rows)
															 else if oldtoken.name = '/'
																			 then if spar = nil
																							 then for i := 0 to arr_facts[1]  - 1 do
																									     quoly_quot(arr[i], n2, arr[i])
																							 else begin
																							         quoly_reciprocal(n2);
																											 mult_cons_sparse(spar, n2, true, rows)
																										end
															 else if oldtoken.name = ''
																			 then if spar = nil
																			         then concaten(n2, arr, arr_facts, true, true, arr, false, rows)
																							 else one_error(spar, arr, arr_free, arr_facts, 289)
															 else if spar = nil
															         then for i := 0 to arr_facts[1]  - 1 do
																			         quoly_mod_or_div(arr[i], n2, arr[i], oldtoken.name[1])
																			 else sparse_mod_or_div(spar, n2, rows, true, oldtoken.name[1])
													else if oldtoken.name = ''
																	then if spar = nil
			        										        then begin
																									{ must duplicate stuff in arr }
																									for i := 0 to arr_facts[1] - 1 do
																										 begin
																												n3 := nil;
																												quoly_assign(arr[i], n3);
																												arr[i] := n3
																										 end;
																									concaten(n2, arr, arr_facts, true, false, arr, false, rows)
																							 end
																				  else one_error(spar, arr, arr_free, arr_facts, 289)
															 else if spar = nil
															         then for i := 0 to arr_facts[1] - 1 do
																							 begin
																									n3 := nil;
																									if times
																										 then quoly_mult(arr[i], n2, n3)
																									else if oldtoken.name = '/'
																										 then quoly_quot(arr[i], n2, n3)
																									else quoly_mod_or_div(arr[i], n2, n3, oldtoken.name[1]);
																									arr[i] := n3
																							 end
																			 else if times
																			         then mult_cons_sparse(spar, n2, false, rows)
																							 else if oldtoken.name = '/'
																											 then begin
																															 quoly_reciprocal(n2);
																															 mult_cons_sparse(spar, n2, false, rows)
																														end
																							 else if oldtoken.name = ''
																			                 then one_error(spar, arr, arr_free, arr_facts, 289)
															                         else sparse_mod_or_div(spar, n2, rows, false, oldtoken.name[1])
																													 
								else  { both arrays }
										begin
											oktofree := true;
											col := arr_facts[1] div arr_facts[2];
											if oldtoken.name = ''
												 then if (spar = nil) and (spar2 = nil)
												         then concatenate(arr, arr2^, arr_facts, arr2_facts, 
																					        arr_free, arr2_free, col, rows, oktofree)
																 else sparse_error(289)
											else if times and (col = arr2_facts[2])
												 then matrix_mult(arr, arr2^, arr_facts, arr2_facts, arr_free, spar, spar2)
											else if (col = arr2_facts[2]) and (col * col = arr2_facts[1])
																 and (oldtoken.name = '/')
													then begin
																	quoly_set(1, n);
																	if first_available <= worksize
																		 then begin
																						 mat_invert(arr2^, arr2^, arr2_free, arr2_free, col, n, true, true, spar2);
																						 arr2_free := true
																					end
																		 else error(89, quotsign);
																	matrix_mult(arr, arr2^, arr_facts, arr2_facts, arr_free, spar, spar2)
															 end
											else if (arr_facts[1] <> arr2_facts[1]) or (arr_facts[2] <> arr2_facts[2]) 
													then sparse_error(39)
											else if (spar = nil) and (spar2 = nil)
												      then for i := 0 to arr_facts[1] - 1 do
																			begin
																				 n3 := nil;
																				 if times
																						then quoly_mult(arr[i], arr2^[i], n3)
																				 else if oldtoken.name = '/'
																								 then quoly_quot(arr[i], arr2^[i], n3)
																				 else quoly_mod_or_div(arr[i], arr2^[i], n3, oldtoken.name[1]);
																				 if arr_free
																						then free_quoly(arr[i]);
																				 arr[i] := n3
																			end
													     else sparse_error(289);
																														
											if oktofree and arr2_free
												 then if spar2 = nil
												         then free_arr(arr2^, arr2_facts)
																 else free_sparse(spar2, arr2_facts[2], true)
										end;
										
						free_work;
						key := token.name[1];
						arr_free := true
						
				 end;
				
			free_quoly(n2)
			
    end;

 {******************************************************************************}
 
  procedure add_one_sparse(var arr: workarray; arr_facts: arr_descr; 
	                         spar_free: boolean; spar: sparseptr; plus: boolean);
	
	   { arr is always freeable. }
		 
		 var i, j, row, k, stop: longint;
		     t, s: colm_ptr;
				 sp: sparseptr;
		 
		 begin
		 
				row := arr_facts[2];  
				sp := spar;  {```}
				stop := (row - 1) div sparsesize;
				for k := 0 to stop do
					 begin
							for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > row 
								    then break
								 else if sp^.indx[i-k*sparsesize] <> nil
												then begin
																t := sp^.indx[i-k*sparsesize];
																s := nil;
																while t <> nil do
																	 begin
																			j := i - 1 + (t^.coord - 1)*row;
																			if plus
																				 then better_quoly_add(arr[j], t^.val, arr[j])
																				 else better_quoly_sub(arr[j], t^.val, arr[j]);
																			if spar_free
																				 then free_quoly(t^.val);
																			s := t;
																			t := t^.next
																	 end;
																if spar_free and (s <> nil)
																	 then begin
																					 s^.next := col_garb;
																					 col_garb := sp^.indx[i-k*sparsesize]
																				end
														 end;
							if k < stop
							   then sp := sp^.next
					 end;
				
				if spar_free
				   then begin
					         sp^.next := spargarb;  {```}
				           spargarb := spar
								end
		 
		 end;
  
  {*************************************************************************}
	
  procedure arr_expre; { (var inf: text;  var n: quoly;  var arr: workarray;
											    var arr_facts: arr_descr;  var arr_free: boolean; 
											    var rows: longint; var flag: nameptr; var spar: sparseptr;
											    callterm: boolean) }
											
  { evaluate array expression.  Possible space losing problem.  If error occurs 
	  during second call to arr_term, the storage of arr will be lost. 
		   Concerning spar and spar2: if you create it, you nil it.
			 arr_facts is output parameter. Only exception is arr_facts[1] is needed by 
		arr_fact if it finds [1] or []. 
		
		  Nov 1997: callterm says if we need to get all of the first term here. }

    var n2, n3: quoly;
        arr2: workptr;
        arr2_facts: arr_descr;
				arr2_free, plus: boolean; 
        oldtoken: tokentipe;
				spar2: sparseptr;
        i: longint;

    function nomatch: boolean;
		   var first: boolean;
			 begin
			    first := (arr_facts[1] <> arr2_facts[1]);
					if (spar <> nil) or (spar2 <> nil)
					   then nomatch := first or (arr_facts[2] <> arr2_facts[2])
						 else nomatch := first
			 end;		
		
		begin
							 
      cancelflag := true;

			if not callterm  { Nov 1997. part of (arr, spar) already set. }
         then case token.name[1] of
				         '^', '': half_arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
				         else { nothing }
				      end;
							
			arr_term(inf, n, arr, arr_facts, arr_free, rows, flag, spar, callterm);
      arr2_facts[1] := 0;
			n2 := nil;
			arr2 := nil;
      arr2_facts[1] := arr_facts[1];  { call to arr_term below needs this if 
			                                  second argument is []. }
      while (token.name = '+') or (token.name = '-') do
         begin
						oldtoken := token;
						plus := (oldtoken.name = '+');
						scanner(inf, token, flag);
						if arr2 = nil
							 then begin
											 new_worknode(i, token);																		 
											 arr2 := workhead[i]
										end;
						spar2 := nil;
						arr_term(inf, n2, arr2^, arr2_facts, arr2_free, rows, flag, spar2, true);
						if (arr2_facts[1] = 0) and (arr_facts[1] = 0)  { both scalars }
							then begin
											if plus
												 then best_quoly_add(n, n2)
												 else best_quoly_sub(n, n2);
											n2 := nil
									 end
							else if arr_facts[1] = 0  { first is scalar }
								then if spar2 = nil
												then begin
																if plus
																	then for i := 0 to arr2_facts[1] - 1 do
																					begin
																						 arr[i] := nil;
																						 if arr2_free
																								then better_quoly_add(arr2^[i], n, arr[i])
																								else quoly_add(arr2^[i], n, arr[i])
																					end
																	else for i := 0 to arr2_facts[1] - 1 do
																					begin
																						 arr[i] := nil;
																						 quoly_sub(n, arr2^[i], arr[i]);
																						 if arr2_free then free_quoly(arr2^[i])
																					end;												
																arr_facts := arr2_facts;
																free_quoly(n2);
																arr2_facts[1] := 0
														 end
												else begin
																if arr2_facts[1] > arr_limit
																   then error(292, token);
																for i := 0 to arr2_facts[1] - 1 do
																	 begin
																			arr[i] := nil;
																			quoly_assign(n, arr[i])
																	 end;
																arr_facts := arr2_facts;
																free_quoly(n2);
																arr2_facts[1] := 0;
																add_one_sparse(arr, arr_facts, arr2_free, spar2, plus)
														 end
								else if arr2_facts[1] = 0  { second is scalar }
									then if spar = nil
													then begin
																	if arr_free
																		 then if plus
																						 then for i := 0 to arr_facts[1] - 1 do
																										 better_quoly_add(arr[i], n2, arr[i])
																						 else for i := 0 to arr_facts[1] - 1 do
																										 better_quoly_sub(arr[i], n2, arr[i])
																		 else for i := 0 to arr_facts[1] - 1 do
																						 begin
																								n3 := nil;																
																								if plus
																									 then quoly_add(arr[i], n2, n3)
																									 else quoly_sub(arr[i], n2, n3);
																								arr[i] := n3
																						 end;
																	free_quoly(n2)
															 end
													else begin
																	if arr_facts[1] > arr_limit
																     then error(292, token);
																  if not plus
																		 then quoly_inplace(n2);
																	for i := 0 to arr_facts[1] - 1 do
																		 begin
																				arr[i] := nil;
																				quoly_assign(n2, arr[i])
																		 end;
																	free_quoly(n2);
																	add_one_sparse(arr, arr_facts, arr_free, spar, true);
																	spar := nil
															 end
											 
								else begin  { both arrays }
								
											 if nomatch
													then begin
																	if arr_free 
																		 then if spar = nil
																						 then free_arr(arr, arr_facts)
																						 else free_sparse(spar, arr_facts[2], true);
																	if arr2_free 
																		 then if spar2 = nil
																						 then free_arr(arr2^, arr2_facts)
																						 else free_sparse(spar2, arr2_facts[2], true);
																	free_quoly(n2);
																	error(39, oldtoken)
															 end;
															
											 if (spar <> nil) and (spar2 <> nil)
													then add_sparses(spar, spar2, arr_free, arr2_free, arr_facts[2], 
																					 plus)
											 else if spar <> nil
													then begin  { harder than it first seems!! }
																	if plus 
																		 then begin
																						 if arr2_free
																						    then for i := 0 to arr_facts[1] - 1 do
																								        arr[i] := arr2^[i]
																								else for i := 0 to arr_facts[1] - 1 do
																								        begin
																												   arr[i] := nil;
																													 quoly_assign(arr2^[i], arr[i])
																												end;
																						 add_one_sparse(arr, arr_facts, 
																														arr_free, spar, true)
																					end
																		 else if arr2_free
																						 then begin
																										 for i := 0 to arr_facts[1] - 1 do
																												quoly_inplace(arr2^[i]);
																										 add_one_sparse(arr2^, arr_facts, 
																																		arr_free, spar, true);
																										 for i := 0 to arr_facts[1] - 1 do
																												arr[i] := arr2^[i]
																									end
																						 else begin
																										 for i := 0 to arr_facts[1] - 1 do
																												begin
																													 arr[i] := nil;
																													 quoly_makeneg(arr2^[i], arr[i])
																												end;
																										 add_one_sparse(arr, arr_facts, 
																																		arr_free, spar, true)
																									end;
																	spar := nil
															 end
											 else if spar2 <> nil  { also subtle! }
													then if arr_free
													        then add_one_sparse(arr, arr_facts, arr2_free, 
																	                    spar2, plus)
																	else begin
																	        n2 := nil;
																					for i := 0 to arr_facts[1] - 1 do
																						 begin
																							  quoly_assign(arr[i], n2);
																								arr[i] := n2;
																								n2 := nil
																						 end;
																	        add_one_sparse(arr, arr_facts,  
																					               arr2_free, spar2, plus)
																	     end
											 else if arr_free and arr2_free
													then if plus
																	then for i := 0 to arr_facts[1] - 1 do
																					best_quoly_add(arr[i], arr2^[i])
																	else for i := 0 to arr_facts[1] - 1 do
																					best_quoly_sub(arr[i], arr2^[i])
											 else if arr_free
													then if plus
																	then for i := 0 to arr_facts[1] - 1 do
																					better_quoly_add(arr[i], arr2^[i], arr[i])
																	else for i := 0 to arr_facts[1] - 1 do
																					better_quoly_sub(arr[i], arr2^[i], arr[i])
											 else for i := 0 to arr_facts[1] - 1 do
															 begin
																	n3 := nil;																
																	if plus
																		 then quoly_add(arr[i], arr2^[i], n3)
																		 else quoly_sub(arr[i], arr2^[i], n3);
																	arr[i] := n3;
																	if arr2_free then free_quoly(arr2^[i])
															 end;												      
																	
											 arr2_facts[1] := 0;
											 free_quoly(n2)
										end;
									
					  arr_free := true
									
         end;
				
			cancelflag := false;
			if arr2 <> nil
			   then free_work
				
    end;

  {************************************************************************}	

  procedure arretrieve; { var inf: text; x: tokentipe; var flag: nameptr
	                        var qp: quolyptr }
	                        
	  { Nov 1997: no longer return n, only qp. qp nil means sparse array with
	    no entry; i.e. interpret as 0.  }

    var r, c: longint;
        q: arrptr;         { arrptr for array named x }
			  colflag: boolean;  { is a second coordinate present? }

    begin
      scanner(inf, token, flag);
      if realflag
			   then ievalcoords(r, c, flag, colflag)
				 else evalcoords(inf, r, c, flag, ']', ',', colflag);
			scanner(inf, token, flag);
      lookup(x, r, c, q, qp, colflag);   {spar}
			if qp <> nil
			   then if qp^ = nil
							   then begin        
											   writeln(userOutput, 'Warning. Uninitialized array element in [', x.name, '].');
											   writeln(userOutput, '  Will use 0.');
											   quoly_set(0, qp^)
										  end
    end;

  {**************************************************************************}

  procedure new_arretrieve; { var inf: text; x: tokentipe; var flag: nameptr
	                            var qp: quolyptr; var t: colm_ptrptr; var colpos: longint }
	                        
	  { Nov 1997: all new special version of arretrieve to accomodate new grammar.  
	    See new_array_quoly_ptr. }

    var r, c: longint;
        q: arrptr;         { arrptr for array named x }
			  colflag: boolean;  { is a second coordinate present? }

    begin
      scanner(inf, token, flag);
      if realflag
			   then ievalcoords(r, c, flag, colflag)
				 else evalcoords(inf, r, c, flag, ']', ',', colflag);
			scanner(inf, token, flag);
      array_seek(x, q);
      new_array_quoly_ptr(q, r, c, colflag, qp, x, t);  { sets t, c and qp }
      colpos := c;  { Dec 1997 }
      if qp <> nil  { qp = nil means sparse array, entry not there; i.e. it's 0 }
			   then if qp^ = nil
							   then quoly_set(0, qp^)
    end;

  {***************************************************************************}

  procedure arrdisplay; { (var outf: text;  outf_is_tty, pretty: boolean;
													 x: tokentipe; q: arrptr; location, rows, cols, 
													 firstrow, firstcol, total_rows, desired: longint; 
													 charprint, from_store, extras: boolean; stash: workptr) }
													 
		{ Since adding handle_quote in August 1991, outf_is_tty no longer guarantees
		  that outf is in fact tty. It's a style setting mechanism. }

    var p, i, j, k, mylength: longint;
		    opening: integer;
		    last: tokentipe;
				n: quoly;

    begin

      if q = nil { then look it up using x. }
         then begin
                 location := fastestlookup(x, q);
								 if location = -1
										then error(28, token);
								 if q^.spar <> nil
								    then location := 0;  
                 cols := q^.size div q^.rows;
                 rows := q^.rows;
							   total_rows := rows
						  end 
         else x := q^.name;
		
		  if pretty and outf_is_tty and (q^.spar <> nil) and (rows = q^.rows)  
				 and (cols = q^.size div q^.rows)  { not subarray }
				 then begin
								 sparse_display(outf, q, true);
								 exit {(arrdisplay)} {``` check this code is not below anywhere}
							end;
																						
			if pretty
				 then for j := 0 to cols - 1 do
								for i := 0 to rows - 1 do
									begin
										mylength := 0;
										p := location + i + total_rows * j;
										if q^.spar <> nil
											 then n := spar_retrieve(q^.spar, i+1+location mod total_rows, 
																							 j+1+location div total_rows)
											 else if from_store
															 then n := arp[p shr 10]^[p and tenmask]
															 else n := stash^[p];
										if outf_is_tty and extras
											 then begin
															if cols > 1  { Nov 1997 }
																	then write(outf, ' ', x.name, '[', i+firstrow: 2, ',', j+firstcol: 2, '] := ')
																	else write(outf, ' ', x.name, '[', i+firstrow: 2, '] := ');
															mylength := mylength + 14 + length(x.name);
															if cols > 1
																 then mylength := mylength + 3
														end
											 else if (j=0) and (i=0) and extras
													then write(outf, ' [', x.name, '] := [( ')
											 else if extras
													then write(outf, '          ');
										if (j=cols-1) and (i=rows-1)
											 then last.name := ' '
											 else last.name := ',';
										if n <> nil
											then begin
															if charprint
																 then if n^.numb
																				 then write(outf, chr(convert_to_int(n^.ncoef^)))
																				 else error(121, quotesign)
															else begin
																			if not (n^.numb or outf_is_tty)
																				 then write(outf, '&_n ');
																			quoly_display(outf, outf_is_tty, false, true, n, mylength, last, 
																										polynames, false, false, false)
																	 end;
															if outf_is_tty then writeln(outf)
													 end
											else if outf_is_tty
															then writeln(outf, 'not defined.')
															else writeln(outf, '0', last.name);
										if (i=rows-1) and (rows>1)
											 then begin
															 if (j < cols-1) 
																	then writeln(outf)
																	else if outf_is_tty
																					then writeln(outf)
																					else writeln(outf, '          )];');
															 if outf_is_tty 
																	then check_cmd_keys
														end
											 else if not outf_is_tty
													 then if (rows=1) and (j=cols-1)
																 then writeln(outf, '          )];');
																	 
									end
							
				 else begin
								if outf_is_tty and from_store 
								 then if extras
								         then begin  {!}
																 write(outf, ' [', x.name, '] := ');  { Nov 1997 }
																 opening := 10 + length(x.name)  {@@@}
															end
												 else opening := 0 {!}
								 else opening := 3;
							if outf_is_tty 
								 then if extras
												 then write(outf, '[[ ')
												 else if not uglyprint  {!!}
												         then write(outf, ' ': opening);
							for i := 0 to rows - 1 do
								 for j := 0 to cols - 1 do
										begin
											mylength := 0;
											p := location + i + total_rows * j;
											if q^.spar <> nil
												 then n := spar_retrieve(q^.spar, i+1 + location mod total_rows, 
																								 j+1 + location div total_rows)
												 else if from_store
																 then n := arp[p shr 10]^[p and tenmask]
																 else n := stash^[p];
											if not outf_is_tty and (n <> nil)
												 then if cols > 1
																 then write(outf, ' ', x.name, '[', i+firstrow: 2, ',', j+firstcol: 2, '] := ')
																 else write(outf, ' ', x.name, '[', i+firstrow: 2, '] := ');  { Nov 1997 }
											if n <> nil
												then begin
																if charprint  {!}
																	 then if n^.numb
																					 then begin
																					         mylength := 1;
																									 write(outf, chr(convert_to_int(n^.ncoef^)))
																								end
																					 else error(121, quotesign)
																else begin
																				if extras
																				   then begin
																					         write(outf, ' ');
																				           mylength := 1  {!}
																								end
																					 else mylength := 0; {!}
																				if extras and not (n^.numb or outf_is_tty)
																					 then write(outf, '&_n ');
																				quoly_display(outf, outf_is_tty, false, true, n, mylength, comma, 
																										  polynames, false, false, false)
																		 end;
																if not charprint and ( (i < rows-1) or (j < cols-1) ) {!}
																	 then if not uglyprint or (j < cols-1)  {~~~~}
																	         then begin
																									 write(outf, ',');
																									 Inc(mylength)  {!}
																								end;
																if (j < cols-1) or ( (cols = 1) and (i < rows-1) )
																	 then for k := 1 to desired-mylength do 
																	          write(outf, ' ')
														 end
												else begin
																if (j=cols-1) and (i=rows-1)
																	 then write(outf, ' * ')
																	 else write(outf, ' *,');
																if (j<cols-1) or ( (cols=1) and (i<rows-1) )
																	 then for k := 1 to desired-3 do  {!}
																					 write(outf, ' ')
														 end;
											if (j=cols-1) and (cols>1) and outf_is_tty
												 then begin
																 if i < rows - 1
																		then begin
																						if extras
																							 then if uglyprint
																							         then writeln(outf, '], [')  {~~~~}
																											 else writeln(outf, ' ', continuation)
																							 else writeln(outf);
																						write(outf, ' ': opening)
																				 end
																		else if extras
																						then if rows = 1   {spar}
																						        then if charprint
																										        then writeln(outf, ' ]]')
																{spar>>>>}									else writeln(outf, '  ]]')
																										else writeln(outf, '   ]]');
																 check_cmd_keys
															end
												 else if (cols=1) and (i=rows-1) and outf_is_tty and extras
																 then if charprint
													{spar>}			   then writeln(outf, ' ]]')
																				 else writeln(outf, '  ]]')
										end
					end;
					
			if outf_is_tty and extras
			   then flush(userOutput)
			
    end;

 {***************************************************************************}
 
 procedure set_coef(var n: ferm118.poly; var inf: text; var flag: nameptr; level: integer);
 
    { Within n search for the term described by the exponents to be read.
		  Then read the new coefficient for that term, and change n by inserting
			the new coef.  Don't change n until sure that no errors have occurred. 
			n could be nil on input, never on output. This procedure calls itself
			recursively. }
  
   	var p, t, n2, n3: ferm118.poly;
	      itszero, itsthere: boolean;
				expont: longint;
				q: quoly;
				im: imptr;
				i, depth: integer;
 
    {_______________________________________________________________________}
		
		procedure set_it(itszero: boolean; p, t, n2, n3: ferm118.poly; expont: longint);
		   { Set the expont coef of p to n2 or n3.  In second call of set_it, n2 = n3. }
			 begin
			     if itszero { the new coef n2 is 0 }
							then begin  { remove p^ }
											if t = nil
												 then n := p^.next
												 else t^.next := p^.next;
											if n2 <> nil
												 then free_poly(n2);
											p^.next := nil;
											free_poly(p);
											if n = nil
												 then poly_set(0, n)
									 end
					 else if p^.numb
									 then if n2^.numb and (n2^.next = nil)
													 then begin  { want n2 }
																	 im := n2^.ncoef;
																	 n2^.ncoef := p^.ncoef;
																	 p^.ncoef := im;
																	 free_poly(n2)
																end
													 else begin
																	 free_imag(p^.ncoef);
																	 p^.numb := false;
																	 p^.pcoef := n2
																end
					 else if (expont = 0) and (n3^.numb) and (n3^.next = nil)
									 then begin
													 if t = nil
															then n := n3
															else t^.next := n3;
													 n3^.next := p^.next;
													 p^.next := polygarb;
													 polygarb := p
												end
					 else if n2 <> nil   { only from second call of set_it }
			             then begin
									         free_poly(p^.pcoef);
													 p^.pcoef := n2
											  end
			 end;
			 
		{________________________________________________________________________}
		
		begin
	
			 if token.name = ','
			    then begin
					        { read the exponent }
									level := level + 1;
									scanner(inf, token, flag);
									q := nil;
									old_expre(inf, q, flag);
									if q^.numb
										 then expont := quoly_convert_to_int(q)
										 else begin
														 free_quoly(q);
														 error(155, token)
													end;
									if expont = neg_two_to_31
									   then error(156, token);
									if not laurent and (expont < 0)
									   then error(298, token);
									free_quoly(q);
				          if n = nil
									   then begin
										         set_coef(n, inf, flag, level);
										         if (expont = 0) and n^.numb and (n^.next = nil)
														    then { nothing }
																else if not poly_iszero(n)
																        then begin
																								newpoly(n3);
																								n3^.exp := expont;
																								n3^.numb := false;
																								n3^.pcoef := n;
																								n3^.next := nil;
																								n := n3
																						 end
										      end
										 else begin
										         { Search for expont in n. If found, p points to it;
														   else it's between t and p. }
													   p := n;
														 t := nil;				    
														 while p <> nil do
																if p^.exp > expont
																	 then begin
																					 t := p;
																					 p := p^.next
																				end
																	 else break;
													   { t still nil means p = n }
														 
														 n2 := nil;
														 itsthere := (p <> nil) and (p^.exp = expont);
														 if p = nil
														    then set_coef(n2, inf, flag, level)
																else if p^.exp = expont
																        then if p^.numb
																				        then set_coef(n2, inf, flag, level)
																								else set_coef(p^.pcoef, inf, flag, level)
																				else set_coef(n2, inf, flag, level);
														 if n2 = nil
														    then itszero := poly_iszero(p^.pcoef)
																else itszero := poly_iszero(n2);
														 if itsthere
														    then set_it(itszero, p, t, n2, p^.pcoef, expont)
																else if itszero
																        then free_poly(n2)
																				else begin
																				        if (expont = 0) and n2^.numb and (n2^.next = nil)
																				           then { nothing }
																									 else begin   { pad it }
																									         newpoly(n3);
																													 n3^.exp := expont;
																													 n3^.numb := false;
																													 n3^.pcoef := n2;
																													 n2 := n3
																												end;
																								n2^.next := p;
																								if t = nil
																								   then n := n2
																									 else t^.next := n2
																						 end
													end
			         end
			 
			    else begin
					        { Read the new coefficient.  Convert to poly form in p. 
									  If not a number, check for appropriateness. }
								  if token.name <> ')'
										 then error(1, token);
									scanner(inf, token, flag);
									if token.name <> ':'
										 then error(148, token);  { Dec 1997 }
									scanner(inf, token, flag);
									if token.name <> '='
										 then error(4, token);
									scanner(inf, token, flag);
								  q := nil;
								  old_expre(inf, q, flag);
								  if q^.numb
										 then quoly_consume(q, p)
										 else begin  
														 if q^.denom <> nil
															  then begin
																			  free_quoly(q);
																			  error(158, token)
																		 end;
														 p := q^.numer;
														 { check for and remove dummy exp = 0 nodes. }
														 if level = 0 
														    then if n = nil
																        then depth := 0
																				else depth := 1
																else depth := level;
														 for i := 1 to depth do
															  begin
																	 if (p^.exp <> 0) or (p^.next <> nil)
																		  then begin
																							free_quoly(q);
																							error(158, token)
																					 end;
																	 t := p;
																	 p := p^.pcoef
																end;
														 if depth = 0
														    then begin
																        q^.next := quolygarb;
																				quolygarb := q
																     end
																else begin
																        t^.pcoef := nil;
														            free_quoly(q)
																		 end
													end;
									
									if level = 0  { There was no recursion; leading coef desired. }
									   then if n = nil  
										         then n := p
														 else set_it(poly_iszero(p), n, nil, p, p, n^.exp)
										 else begin
										         if n <> nil
														    then free_poly(n);
										         n := p
										      end
							 end															

	  end;
	
 {************************************************************************}
	 
 procedure quoly_set_coef(var n: quoly; var inf: text; var flag: nameptr);
 
    { complications because of handling numbers as both poly and quoly. 
	    n is nilled out or is a number or there is no n^.denom. }
 	  
	  var n2: ferm118.poly;
		    q: imptr;
 
    begin
	   
			 if n = nil
					then begin
					        n2 := nil;
									set_coef(n2, inf, flag, 0);
									if n2^.numb and (n2^.next = nil)
									   then poly_consume(n2, n)
										 else begin
										         newquoly(n);
														 n^.numb := false;
														 n^.denom := nil;
														 n^.numer := n2
													end							 
							 end									
					else if n^.numb
									then begin
													quoly_to_poly(n, n2);  { n is unchanged }
									        set_coef(n2, inf, flag, 0);
													if n2^.numb and (n2^.next = nil)
														 then begin
														         q := n2^.ncoef;
																		 n2^.ncoef := n^.ncoef;
																		 n^.ncoef := q;
																		 free_poly(n2)
																	end 
														 else begin
																		 free_imag(n^.ncoef);
																		 n^.numb := false;
																		 n^.denom := nil;
																		 n^.numer := n2
																	end
											 end
					 else begin
					         set_coef(n^.numer, inf, flag, 0);
									 if n^.numer^.numb and (n^.numer^.next = nil)
									    then polynum_to_quoly(n)
								end
					 
	   end;
	
  {************************************************************************}

  procedure change_coef; {(var inf: text; var n: quoly; var flag: nameptr);}
		
	   { Locate the quolynomial to be changed. Complicated by use of Numer and Denom. }
		 
		 var oldtok: tokentipe;
				 q: varptr;                    { spar. whole thing }
				 p: ferm118.poly;
				 {wwh qy,} dq: quoly;
				 qa: arrptr;
				 qp, oldqp: quolyptr;
				 r, c: longint;
				 colflag, itscalar, num_den, numer, sparse: boolean;
		 
		 begin
		 
		    scanner(inf, token, flag);
				if token.name <> '('
					 then error(154, token);
				scanner(inf, oldtok, flag);
				if (oldtok.name = 'Numer') or (oldtok.name = 'Denom')
				   then begin
					         num_den := true;
									 numer := (oldtok.name = 'Numer');
									 scanner(inf, token, flag);
									 if token.name <> '('
										  then error(177, token);
									 scanner(inf, oldtok, flag)
								end
					 else num_den := false;
									 
				if (oldtok.name[1] > 'z') or (oldtok.name[1] < 'a')
				   then error(157, oldtok);
				scanner(inf, token, flag);
//wwh				qy := nil;
				sparse := false;  { Nov 1997 }
				if token.name = '['
				   then begin
					         scanner(inf, token, flag);
									 evalcoords(inf, r, c, flag, ']', ',', colflag);
									 scanner(inf, token, flag);
									 lookup(oldtok, r, c, qa, qp, colflag);
									 sparse := (qa^.spar <> nil);   { Nov 1997 }
									 if qp = nil
									    then sparse_set(r, c, qa, qp, colflag);  {need r, c, colflag later } 
									 itscalar := false
								end
					 else begin
									 itscalar := true;
									 { Lookup oldtok in symbol table. }
									 if oldtok.address = -1
										  then r := hash(oldtok.name, 151)
										  else r := oldtok.address;
									 
									 q := sca_store[r];
									 while q <> nil do
										  if q^.let.name = oldtok.name
												 then break
												 else q := q^.next;
									
									 if q = nil
										  then error(19, token) { changed Nov 1997 }
											else qp := @ q^.val
							  end;
								
				if num_den
				   then begin
					         if token.name <> ')'
									    then error(1, token);
									 scanner(inf, token, flag);
									 if qp^ = nil
											then error(287, oldtok);
									 if qp^^.numb
									    then error(286, oldtok);
									 newquoly(dq);
									 dq^.numb := false;
									 dq^.denom:= nil;
									 if numer
									    then dq^.numer := qp^^.numer
											else dq^.numer := qp^^.denom;
									 oldqp := qp;
									 qp := @ dq
								end;
				
				if qp^ <> nil
           then if (not qp^^.numb) and (qp^^.denom <> nil)
					         then error(185, oldtok)
					         else begin
									         quoly_set_coef(qp^, inf, flag);
													 if num_den
													    then begin
															        if dq^.numb
															           then quoly_consume(dq, p)
																			   else begin
																				         p := dq^.numer;
																								 dq^.next := quolygarb;
																								 quolygarb := dq
																							end;
																			qp := oldqp;
																			if numer
																			   then qp^^.numer := p
																				 else begin
																				         qp^^.denom := p;
																			           if poly_iszero(p)
																								    then begin
																										        writeln(userOutput, ' Warning. A quoly denominator has become 0 due to :.');
																														if itscalar
																														   then write(userOutput, '   A variable named ', oldtok.name)
																															 else write(userOutput, '   An array named ', oldtok.name);
																														writeln(userOutput, ' was involved, and set to 0.');
																														quoly_set(0, qp^)
																												 end
																						 end;
																			if qp^^.denom <> nil
																			   then check_quoly(qp^, laurent and not numer);
																		  if qp^^.numer^.numb and (qp^^.numer^.next = nil) and (qp^^.denom = nil)
																				 then polynum_to_quoly(qp^)
																	 end
											  end
           else begin
									 quoly_set_coef(qp^, inf, flag);
									 if itscalar
									    then begin
											        q := sca_store[r];
														  if var_garb = nil
																 then new(sca_store[r])
																 else begin
																				 sca_store[r] := var_garb;
																				 var_garb := var_garb^.next
																		  end;
														  sca_store[r]^.next := q;
														  q := sca_store[r];
														  q^.let := oldtok;
														  q^.val := qp^
													 end
                end;
								
				if flag = nil
				   then quoly_assign(qp^, n)
					 else quoly_set(0, n);
					 
				if sparse
				   then if quoly_iszero(qp^)
				           then sparse_delete(r, c, qa, colflag)  { Nov 1997 }

		 end;
		 
  {**************************************************************************}

  procedure spec_lookup(x: tokentipe; spot: longint; var q: arrptr; var qp: quolyptr);

    { Set qp to point to the right quoly.  Use spot to linearly access.  If array is 
		  sparse and the spot is zero, set qp to nil. Used for compiled references. }
			
		var r, c, i: longint;
		    t: colm_ptr;
				sp: sparseptr;

    begin
      
			if spot < addresser
         then error(27, x);
			array_seek(x, q);
      if q^.spar = nil
				 then begin
								 spot := q^.start - addresser + spot;
								 if (spot < q^.start) or (spot > q^.stop)
										then error(27, x);
								 qp := @ arp[spot shr 10]^[spot and tenmask];
							end
				 else begin
								 { convert to row, col indexing }
								 c := 1 + (spot - addresser) div q^.rows;
								 r := 1 + (spot - addresser) mod q^.rows;
								 if spot > q^.size - 1 + addresser 
								    then error(27, token);
								 sp := q^.spar;  {```}
				         for i := 1 to (r - 1) div sparsesize do
								    sp := sp^.next;
				         t := sp^.indx[1 + (r - 1) mod sparsesize];
								 while t <> nil do
										if t^.coord = c   {``` inefficient }
											 then break
											 else t := t^.next;
								 if t = nil
										then sparse_set(r+addresser-1, c+addresser-1, q, qp, false)
										{ the above will now be an error, caught in compile. Dec 1997 }
										else qp := @ t^.val
							end
    end;

 {******************************************************************************}
 
  procedure create_array; {(var inf: text; var n: quoly; var flag: nameptr)}
  
    { Nov 1997 }
    
    var oldtoken: tokentipe;
        colflag: boolean;
        rows, cols: longint;
    
    begin
     
       repeat  { Sep 2000 }
	        scanner(inf, token, flag);
	        if (token.name[1] < 'a') or (token.name[1] > 'z')
	           then error(40, token);
	        if its_a_polyname(token.name)  { Apr 1998 }
	           then error(125, token);  
	        oldtoken := token;
	        scanner(inf, token, flag);
	        if token.name <> '['
	           then error(178, token);
	        scanner(inf, token, flag);   				
	        if realflag
					   then ievalcoords(rows, cols, flag, colflag)
						 else evalcoords(inf, rows, cols, flag, ']', ',', colflag);
					scanner(inf, token, flag);
	        if not colflag { a linear array  }
	           then cols := 1;  { may have been addresser = 0 }
	        if token.name = 'Sparse'
					   then begin
						         scanner(inf, token, flag);
										 sparse_create(oldtoken, rows, cols)
									end
						 else insertarr(oldtoken, rows, cols)
			 until token.name[1] <> ',' ;
				
       quoly_set(0, n)
							 
    end;
      
	{**********************************************************************
	
	procedure statement(var inf: text; var n: quoly; var flag: nameptr);

    Now Obsolete,  Nov 1997

  **********************************************************************}

  procedure funcdef; {(var inf: text; var flag: nameptr)}

    var q: funcptr;
        once_more: boolean;
				i: integer;
				realtok: tokentipe;

    {___________________________________________________________________}

    procedure make_par_list(var q: paramptr);
      { Formal parameters are linked up.  A semicolon separator means the following 
			  parameters are really local vars, but this procedure treats them exactly 
				like parameters.  Wastes some space. }

       var last: paramptr;
			     res, obj: boolean;

       procedure compare(p: paramptr);
			    begin
					   while p <> last do
						    begin
								   if p^.let.name = last^.let.name
									    then error(277, last^.let);
									 p := p^.next
								end
					end;
					
			 begin
					new(q);  {@@@}
					last := q;
					repeat
						scanner(inf, token, flag);
						res := (token.name[1] = '^');
						obj := (token.name[1] = '');
						if res or obj
						   then scanner(inf, token, flag);
						if (token.name[1] >= 'a') and (token.name[1] <= 'z')
							 then begin
											 if obj
											    then token.name := concat('', token.name);
											 token.address := hash(token.name, 151);
											 new(last^.next);
											 last := last^.next;
											 last^.let := token;
											 last^.result := res;
											 last^.isobject := obj;
											 last^.arry := false;  { used by compiler }
                       compare(q^.next)										
									  end
							 else error(5, token);
						scanner(inf, token, flag);
						if (token.name <> ',') and (token.name <> ';') and (token.name <> ')')
							 then error(6, token)
					until token.name = ')';
					last^.next := nil;
					q := q^.next;
					scanner(inf, token, flag);
					if token.name <> '='
						 then error(7, token)
       end;

    {______________________________________________________________________}


    begin { of funcdef }
                                   {``` remove test for error}
      current_func := token;
      Inc(func_def_count);
      once_more := true;
			last_good_one := nil;
			last_attached := nil;
			last_comm := nil;
      new(q);
      q^.comp := nil;        
      q^.name := token;
			
      scanner(inf, token, flag);
      if token.name = '('
         then make_par_list(q^.pars)
         else if token.name = '='
                 then q^.pars := nil
                 else error(12, token);
								 
      scanner(inf, token, flag);
      right_side(q^.rht, '.', inf, flag, once_more, realtok);
			if eof(inf) and (token.name <> '.')
				 then error(103, token);
				 
			i := hash(q^.name.name, 71);
			q^.name.address := i;
      q^.next := func_store[i];
      func_store[i] := q;
			watch_for_func := true;
			
			{ once_more and realtok are set by attach, basically because a decimal constant 
			  was found in the funcdef }
      if once_more
         then scanner(inf, token, flag)
         else token := realtok;
      func_def_count := func_def_count - 1;

    end;

	 {************************************************************************}
	 
	 procedure dumpobj; {(var outf: text; ob: objptr)```}
	    
	   	var i: integer;
			
			procedure dump_one_obj(ob: objptr);
			   var gp: polygon_ptr;
				 begin
					  if ob^.threeD
						   then writeln(outf, ' threeD,')
							 else writeln(outf, ' twoD,'); 
						dump_points_lines(outf, ob);
					  writeln(outf);
					  write(outf, ' Polygons');
					  gp := ob^.gons;
						if gp <> nil
						   then writeln(outf, ' {');
					  while gp <> nil do  {@@@ obvious bug, April 28, 1996 }
							 begin
								  if command_int 
										 then check_cmd_keys;
								  dumpolyg(outf, gp);
								  gp := gp^.gg;
									if gp <> nil
									   then writeln(outf, ',')
							 end;
					  if ob^.gons <> nil
						   then write(outf, '  }');
						writeln(outf, ',');
					  writeln(outf);
						with ob^ do
						   begin
							    writeln(outf, sintheta:12:8, z_cosine:12:8);
								  writeln(outf, xscale:8:3, ' ', yscale:8:3, ' ', zscale:8:3);
									writeln(outf, bias[1]:12:8, ' ', bias[2]:12:8, ' ', bias[3]:12:8);
								  if threeD
						         then writeln(outf, xmin:12:8, ' ', xmax:12:8, ' ', ymin:12:8, ' ', 
									                ymax:12:8, ' ', zmin:12:8, ' ', zmax:12:8)
							 end;
						writeln(outf);
					  writeln(outf, chr(9), chr(9), '};')
				 end;
			
			begin
			   
				 if output_file_name = ''
				    then error(320, token);
						
				 if ob^.quads <> nil
				    then error(326, token);
				 
				 if ob^.obarray 
				    then writeln(outf, ' Objarray(', ob^.name:1,'[', ob^.final-ob^.init+1:1, ']);');
						
				 if ob^.obarray 
				    then for i := 0 to ob^.final - ob^.init do
						        begin
										   write(outf, ' ', ob^.name:1, '[', i+1:1, '] := { ');  { Feb 1998 }
										   dump_one_obj(obstash^[i+ob^.init]);
											 writeln(outf);
											 if obstash^[i+ob^.init]^.shaded
						              then writeln(outf, ' Shade(', ob^.name:1, '[', i+1:1, ']);');
										   if obstash^[i+ob^.init]^.solid
						              then writeln(outf, ' Solid(', ob^.name:1, '[', i+1:1, ']);');
											 if command_int 
										      then check_cmd_keys
										end
						else begin
						        write(outf, ' ', ob^.name:1, ' := { ');   { Feb 1998 }
										dump_one_obj(ob);
										writeln(outf);
										if ob^.shaded
						           then writeln(outf, ' Shade(', ob^.name:1, ');');
										if ob^.solid
						           then writeln(outf, ' Solid(', ob^.name:1, ');')
								 end;
				 writeln(outf)
			
			end;							
									
	{************************************************************************}
	
	procedure read_object(var inf: text; var n: quoly; var flag: nameptr); {```} 
	
	   var oldtok: tokentipe;
		     threeD: boolean;
				 dim, j, i: integer;
				 rnk: longint;
				 comma: char;
				 ob: objptr;
				 gp: graphptr;  {@@@}
				 lnp: lineptrptr;
				 gnp: gonptrptr;
				 cpp, head: coordptrptr;
		 
		 {___________________________________________________________________}
		 
		 procedure set_comma;
		    begin
				   repeat
						  read(inf, comma);
						  if eoln(inf)    { Jan 1998 }
                 then readln(inf)
					 until eof(inf) or not (comma in throwaways);
					 if eof(inf)
						  then error(324, token)
				end;
		 
		 {____________________________________________________________________}
		 
		 procedure test_comma_scan;
		    begin
				   token.name := comma;
					 if comma <> '}'
							then error(153, token);
					 scanner(inf, token, flag)
				end;
				
		 {____________________________________________________________________}
		 
		 begin
		 
		    if flag <> nil
				   then error(323, token);
				if input_file_name = ''
				   then error(323, token);
					 
				scanner(inf, token, flag);
				oldtok := token;
				if (polynames <> nil) and its_a_polyname(oldtok.name)
				   then error(125, oldtok);
        scanner(inf, token, flag);
				if token.name <> ':'          { Dec 1997 }
				   then error(148, token);
				scanner(inf, token, flag);
				if token.name <> '='
				   then error(4, token);
				scanner(inf, token, flag);
				if token.name <> '<'
				   then error(144, token);
				scanner(inf, token, flag);
				if (token.name <> 'threeD') and (token.name <> 'twoD')
				   then error(321, token);
				threeD := (token.name = 'threeD');
				scanner(inf, token, flag);
				if token.name <> ','
				   then error(202, token);
				if threeD
				   then dim := 3
					 else dim := 2;
				
				scanner(inf, token, flag);
				if token.name <> 'Points'
				   then error(322, token);
				newobj(ob);
				ob^.name := oldtok.name;
				ob^.first := nil;
				ob^.last := nil;
        ob^.threeD := threeD;
				scanner(inf, token, flag);
				if token.name = '<'
				   then begin
									 newgraph(ob^.first);
									 gp := ob^.first;
									 j := 1;
									 i := 0;  { counts number of points seen }
									 repeat
										  Inc(i);
											if i > graphsize
											   then begin
												         newgraph(gp^.next);
																 gp := gp^.next;
																 if command_int 
			                              then check_cmd_keys;  { Jan 1998 }
																 i := 1;
											           j := 1
												      end;
											read(inf, gp^.locoord[j], gp^.locoord[j+1]);
										  if threeD
										     then readln(inf, gp^.locoord[j+2])
												 else readln(inf);
											j := j + 3;
											read(inf, gp^.abscoord[2*i-1], gp^.abscoord[2*i]);
										  set_comma;
										  if comma = '['
										     then begin
										             with gp^ do  { Feb 1998 }
															 	    read(inf, colors[3*i-2], colors[3*i-1], colors[3*i]);
										             set_comma;
										             if comma <> ']'
										                then begin
										                        token.name := comma;
										                        error(213, token)
										                     end;
										             set_comma
										          end;
									 until comma <> ',';
									 ob^.last := gp;
									 gp^.next := nil;
									 ob^.final := i;
									 test_comma_scan
							  end;
								
				if token.name <> ','
				   then error(202, token);
					 
				scanner(inf, token, flag);
				ob^.line := nil;
	      ob^.lasline := nil;
        if token.name <> 'Lines'
				   then error(322, token);
				scanner(inf, token, flag);
				if token.name = '<'
				   then begin
									 lnp := @ ob^.line;
									 repeat
										  newline(lnp^);
									    read(inf, lnp^^.locoord[1], lnp^^.locoord[2]);
											if threeD
												 then readln(inf, lnp^^.locoord[3])
												 else readln(inf);
											read(inf, lnp^^.locoord[4], lnp^^.locoord[5]);
											if threeD
												 then readln(inf, lnp^^.locoord[6])
												 else readln(inf);
											readln(inf, lnp^^.abscoord[1], lnp^^.abscoord[2]);
											read(inf, lnp^^.abscoord[3], lnp^^.abscoord[4]);
											if command_int 
			                   then check_cmd_keys;  { Jan 1998 }
											set_comma;
											if comma = ','
											   then begin
										             with lnp^^ do  { Feb 1998 }
															 	    read(inf, rred, ggreen, bblue);
										             set_comma;
										             if comma <> ']'
										                then begin
										                        token.name := comma;
										                        error(213, token)
										                     end;
										             set_comma
										          end;
										  if comma  = ','
											   then lnp := @ lnp^^.next
										     else break
									 until false;
									 ob^.lasline := lnp^;
									 ob^.lasline^.next := nil;
									 test_comma_scan
							  end;
				if token.name <> ','
				   then error(202, token);
					 
				ob^.gons := nil;
	      ob^.lastgon := nil;
				ob^.headvert := nil;
				ob^.endvert := nil;
        scanner(inf, token, flag);
				if token.name <> 'Polygons'
				   then error(322, token);
				scanner(inf, token, flag);
				if token.name = '<'
				   then begin
									 if not threeD
									    then error(325, token);
									 gnp := @ ob^.gons;
									 head := @ ob^.headvert;
									 repeat
							        newgon(gnp^);
											with gnp^^ do
											   readln(inf, radius, xcen, ycen, zcen, x, y, z);
											set_comma;
											if comma = '['
											   then begin
										             with gnp^^ do  { Feb 1998 }
															 	    read(inf, rred, ggreen, bblue);
										             set_comma;
										             if comma <> ']'
										                then begin
										                        token.name := comma;
										                        error(213, token)
										                     end;
										             set_comma  { should be *, but we don't care }
										          end;
									    readln(inf, gnp^^.rank);
											rnk := gnp^^.rank;
									    cpp := @ gnp^^.cp;
									    if command_int 
			                   then check_cmd_keys;  { Jan 1998 }
											for i := 1 to rnk do
											   begin
												    newpoint(cpp^);
														if i = 1
														   then head^ := cpp^;
														with cpp^^ do
														   begin
															    readln(inf, x, y, z);
																	read(inf, a, b)
															 end;
												    if i = rnk
														   then head := @ cpp^^.cp
															 else cpp := @ cpp^^.cp;
											   end;
						          set_comma;
											if comma = ','
											   then gnp := @ gnp^^.gg
										     else break
									 until false;
									 ob^.lastgon := gnp^;
									 ob^.lastgon^.gg := nil;
									 ob^.endvert := cpp^;
									 head^ := nil;
									 test_comma_scan
							  end;
				if token.name <> ','
				   then error(202, token);
					 
				with ob^ do
					 begin
							readln(inf, sintheta, z_cosine);
							readln(inf, xscale, yscale, zscale);
							readln(inf, bias[1], bias[2], bias[3]);
							if threeD
							   then read(inf, xmin, xmax, ymin, ymax, zmin, zmax)
					 end;
					 
				scanner(inf, token, flag);
				if token.name <> '}'
				   then error(153, token);
				scanner(inf, token, flag);
	
				ob^.obarray := false;
				ob^.shaded := false;
				ob^.solid := false;
				ob^.quads := nil;
				i := hash2(ob^.name, 151);
			  ob^.next := objlist[i];
			  objlist[i] := ob;
			  quoly_set(0, n)  {@@@ Apparent bug!}
		 
		 end;

  {****************************************************************************}
	
   procedure listpars(var outf: text; p: paramptr; var ind: longint);

      var q: paramptr;

      begin
         while p <> nil do
						begin
							q := p^.next;
							if p^.result
							   then begin
								         write(outf, '^');
												 ind := ind + 1
											end;
							write(outf, p^.let.name);
							ind := ind + length(p^.let.name);
							if q <> nil
								then begin
												write(outf, ',');
												ind := ind + 1
										 end;
							p := q
						end;
      end;
			
  {****************************************************************}

   procedure listfuncs(var outf, inf: text; outf_is_tty: boolean; 
	                     x: tokentipe; var flag: nameptr);
											
      var indent: longint;
		      p: funcptr;
				  i: integer;
					
			begin { of listfuncs }
			
				if x.name = '*'
					 then for i := 0 to 70 do
									 begin
											p := func_store[i];
											while p <> nil do
												 begin
														writeln(outf);
														write(outf, ' Function ', p^.name.name);  { Nov 1997 }
														indent := 4 + length(p^.name.name);  { Nov 1997 }
														if p^.pars <> nil
															 then begin
																			 write(outf, '(');
																			 indent := indent + 1
																		end;
														listpars(outf, p^.pars, indent);
														if p^.pars <> nil
															 then begin
																			 write(outf, ')');
																			 indent := indent + 1
																		end;
														if outf_is_tty
															 then writeln(outf, ' =  ', continuation)
															 else writeln(outf, ' =  ');
														write(outf, '    ');
														indent := 4;
														listform(outf, outf_is_tty, p^.rht, indent);
														write(outf, '.');
														if not outf_is_tty
															then write(outf, ';');
														writeln(outf);
														p := p^.next
												 end
										end
								
						else if (x.name = ';') or (x.name = '')
							 then for i := 0 to 70 do
									 begin
											p := func_store[i];
											while p <> nil do
												 begin
														writeln(outf);
														write(outf,  p^.name.name);
														indent := 1 + length(p^.name.name);
														if p^.pars <> nil
															 then begin
																			write(outf, '(');
																			indent := indent + 1
																		end;
														listpars(outf, p^.pars, indent);
														if p^.pars <> nil
															 then begin
																			 write(outf, ')');
																			 indent := indent + 1
																		end;
														writeln(outf);
														p := p^.next
												 end
									 end
											 
						else if (x.name = ',') or (x.name = '<')
								then begin
											scanner(inf, x, flag);
											if x.name = chr(21)
												   then begin
													         if sys_func = nil
																	    then error(243, x);
																	 writeln(outf);  {@@@}
																	 indent := 3;
																	 listform(outf, outf_is_tty, sys_func, indent);
																	 writeln(outf);
													         exit {(listfuncs)}
													      end;
											if x.address = -1
												 then i := hash(x.name, 71)
												 else i := x.address;
											p := func_store[i];
											while p <> nil do
													begin
														if p^.name.name = x.name
															then break;
														p := p^.next;
													end;
											if p = nil
												 then writeln(userOutput, x.name, ' has not been defined.')
												 else begin
																 writeln(outf);  {@@@}
																 write(outf, ' Function ', p^.name.name);  { Nov 1997 }
																 indent := 4 + length(p^.name.name);  { Nov 1997 }
																 if p^.pars <> nil
																			then begin
																							write(outf, '(');
																							indent := indent + 1
																					 end;
																 listpars(outf, p^.pars, indent);
																 if p^.pars <> nil
																		then begin
																						write(outf, ')');
																						indent := indent + 1
																				end;
																 if outf_is_tty
																		then writeln(outf, ' =  ', continuation)
																		else writeln(outf, ' =  ');
																 write(outf, '    ');
																 indent := 4;
																 listform(outf, outf_is_tty, p^.rht, indent);
																 writeln(outf, '.')
															end
													 
										end
						else begin
										writeln(userOutput, x.name, ' is not a legal function name.');
										while token.name <> ';' do
											 scanner(inf, token, flag)
								 end;
								
					 token.name := '@'; token.address := -1
			end;

  {****************************************************************}

  function evalcond(var inf: text; var p: nameptr): boolean;

      var n1, n2: quoly;
          sign: tokentipe;
					num1, num2: longreal;

      begin
        evalcond := false;
        n1 := nil;
        if realflag
				   then old_iexpre(num1, p)
					 else old_expre(inf, n1, p);

        sign := token;
        if not (sign.name[1] in cond_set) 
           then if (sign.name = '>') or (sign.name = '')
					         then begin
									         if realflag
													    then evalcond := (num1 = 1.0)
															else begin
															        if n1^.numb
																			   then evalcond := (n1^.ncoef^.float = 1.0) and (n1^.ncoef^.imag = nil)
																			   else evalcond := false;
																			free_quoly(n1)
																	 end;
												   exit {(evalcond)}
												end
									 else error(13, sign);

        n2 := nil;
				scanner(inf, token, p);
        if realflag
				   then old_iexpre(num2, p)
					 else old_expre(inf, n2, p);
				if not realflag
				   then if not (sign.name[1] in poly_cond_set) and not(n1^.numb and n2^.numb)
				           then error(123, sign);
        if realflag
				   then case sign.name[1] of
										'=': evalcond := (num1 = num2);
										'': evalcond := (num1 <> num2);
										'>': evalcond := (num1 > num2);
										'<': evalcond := (num1 < num2);
										'': evalcond := (num1 >= num2);
										'': evalcond := (num1 <= num2)
								end
					 else begin
					         case sign.name[1] of
											'=': evalcond := quoly_equal(n1, n2);
											'': evalcond := not quoly_equal(n1, n2);
											'>': evalcond := (n1^.ncoef^.float > n2^.ncoef^.float);
											'<': evalcond := (n2^.ncoef^.float > n1^.ncoef^.float);
											'': evalcond := (n1^.ncoef^.float >= n2^.ncoef^.float);
											'': evalcond := (n1^.ncoef^.float <= n2^.ncoef^.float)
									end;
									free_quoly(n1);
									free_quoly(n2)
							 end
				
      end;

	{************************************************************************}

  function bool_expre(var inf: text; var p: nameptr): boolean; forward;
	
	{************************************************************************}
		
  function bool_fact(var inf: text; var p: nameptr): boolean;
	  
    begin
	
      if token.name = '<'
        then begin
               scanner(inf, token, p);
							 bool_fact := bool_expre(inf, p);
               if token.name <> '>'
                 then error(153, token)
                 else scanner(inf, token, p)
             end
      else if token.name = ''
			  then begin
				       scanner(inf, token, p);
							 bool_fact := not bool_fact(inf, p)
						 end
			else bool_fact := evalcond(inf, p)
				
	  end;

  {**********************************************************************}

  function bool_term(var inf: text; var p: nameptr): boolean;

    var value: boolean;

    begin
		
      value := bool_fact(inf, p);
      while (token.name = '^') do
        begin
          scanner(inf, token, p);
          value := value and bool_fact(inf, p);
        end;
				
			bool_term := value
			
   end;

  {***********************************************************************}

  function bool_expre; { (var inf: text; var p: nameptr): boolean; }

    var value: boolean;

    begin
		
      value := bool_term(inf, p);
      while (token.name = '')  do
        begin
          scanner(inf, token, p);
          value := value or bool_term(inf, p);
        end;
				
			bool_expre := value;
			if (token.name <> '>') and (token.name<>'')
			   then error(104, token)
			
   end;

	{***********************************************************************}
	
  procedure remove_args{ f: funcptr; cant_call_error: boolean };

    var q, t: varptr;
        p: paramptr;
				i: integer;
				
		{--------------------------------------------------------------}

    procedure remove_array(x: tokentipe);

      var p, t: arrptr;
			    i: integer;

      begin
         if x.address = -1
			      then i := hash(x.name, 151)
					  else i := x.address;
				 
			   p := arr_store[i];
					
         while p^.name.name <> x.name do
            begin
							 t := p;
							 p := p^.next;
							 if (p = nil)
									then if cant_call_error
													then begin
																	out_err_mess(30);
																	exit {(remove_array)}
															 end
													else error(30, x)
            end;
        if p^.time > 0
				   then begin
					         writeln(userOutput, '*** Warning. On function termination, found an array with the same name as an ');
									 writeln(userOutput, '       array parameter, namely: ', p^.name.name);
									 if cant_call_error
											then begin
															out_err_mess(30);
															exit {(remove_array)}
													 end
											else error(30, p^.name)
								end;
								
				{ Take care of sparse/normal with father. Careful!! Sneaky!! }
				p^.father^.spar := p^.spar;
					         					 
				if p = arr_store[i]
           then arr_store[i] := arr_store[i]^.next
           else t^.next := p^.next;
					
				p^.next := arr_garb;
        arr_garb := p
		 end;
			
	  {---------------------------------------------------------------}

    begin
		
      p := f^.pars;
      while p <> nil do
         begin
				    i := p^.let.address;
						q := sca_store[i];
						while q^.let.name <> p^.let.name do
							 begin
									t := q;
									q := q^.next;
							 end;
						if q = sca_store[i]
							 then sca_store[i] := sca_store[i]^.next
							 else t^.next := q^.next;	 
						if q^.val^.numb
							 then if q^.val^.ncoef^.size = -1742
											 then begin
															 remove_array(p^.let);
															 q^.val^.ncoef^.size := 0
													  end;
						q^.next := var_garb;
						var_garb := q;  
						
						if p^.result
						   then begin
							         free_quoly(q^.qp^);
											 q^.qp^ := q^.val
										end
							 else free_quoly(q^.val);						
	          p := p^.next
							
         end
    end;

	{****************************************************************************}
	
	 procedure add_to_diag; {(m: quoly; spar: sparseptr; rows: longint)}
			
			var i, k: longint;
					u: colm_ptrptr;
					more: boolean;
					sp: sparseptr;
			
			procedure attach(s: colm_ptr);
				 begin
						newcolm(u^);
						u^^.next := s;
						u^^.coord := i;
						u^^.val := nil;
						quoly_assign(m, u^^.val)
				 end;
			
			begin
			
					if quoly_iszero(m)
					   then exit {(add_to_diag)};
						 
					sp := spar;
					for k := 0 to (rows - 1) div sparsesize do  {```}
							begin
								 for i := 1 + k*sparsesize to (k+1)*sparsesize do
										if i > rows 
											 then break
										else begin
														more := true;
														u := @ sp^.indx[i-k*sparsesize];
														while u^ <> nil do
															 if u^^.coord < i
																	then u := @ u^^.next
																	else if u^^.coord > i
																					then begin
																									attach(u^);
																									more := false;
																									break
																							 end
																					else begin
																									better_quoly_add(u^^.val, m, u^^.val);
																									if quoly_iszero(u^^.val)
																										 then free_colm(u^);
																									more := false;
																									break
																							 end;
													 if more 
															then attach(nil)
												end;
							   sp := sp^.next
							end
						
			end;
				
  {**************************************************************************}

  procedure spec_retrieve(var x: tokentipe;  var n: quoly; var qp: quolyptr);

     var q: varptr;
		     i: integer;

     begin

				if x.address = -1
					 then i := hash(x.name, 151)
					 else i := x.address;
					 
				q := sca_store[i];
				while q <> nil do
					 if q^.let.name = x.name
							then break
							else q := q^.next;
			
				if q = nil
					 then begin
								   error(19, x);
								   quoly_set(0, n);
								   exit {(spec_retrieve)}
							  end
					 else begin
									 qp := @ q^.val;
									 quoly_assign(q^.val, n);
							  end;
									
				if n^.numb  { check for array - scalar param error }
					 then if q^.val^.ncoef^.size = -1742 
									 then begin
													quoly_set(0, n);
													writeln(userOutput, ' Warning. ', x.name, ' is an array parameter.');
													writeln(userOutput, '  Value 0 used for ', x.name, '.')
												end
					
     end;

	{*************************************************************************}

	procedure arrayarg {(x: tokentipe; var n: quoly; var newar: arrptr; var inf: text; 
										 var flag: nameptr; var its_array_arg: boolean)};

		 var p, q: arrptr;

		 begin
				if arr_garb = nil
					 then New(p) //p := arrptr(newptr(sizeof(arrnode)))
					 else begin
									 p := arr_garb;
									 arr_garb := arr_garb^.next
								end;
				p^.name := x;
				scanner(inf, token, flag);
				if token.name = ''
					 then error(176, token);
				p^.start := fasterlookup(token, q, inf, flag);
				if p^.start = -1
					 then error(28, token);
				p^.stop := q^.stop;
				p^.rows := q^.rows;
				p^.size := q^.size;  {spar}
				p^.spar := q^.spar;  { This opens up a can of worms. Sparse array passing 
															 is no longer by reference, but sort-of by value-result. }
				p^.father := q;      { for sake of sparse and sparse/normal conflicts }
				p^.time := - abs(q^.time);
				p^.next := newar;
				newar := p;
				scanner(inf, token, flag);
				if token.name <> ']'
					 then error(24, token);
				scanner(inf, token, flag);
				quoly_set(0, n);
				its_array_arg := true
		 end;

	{***********************************************************************}

	procedure get_qp_n {(var qp: quolyptr; var inf: text; var flag: nameptr; 
										   var n: quoly; mytok: tokentipe)};

		 var oldtok: tokentipe;
		     aux: colm_ptrptr;  { Nov 1997 }
         colpos: longint; { Nov 1997 }

		 begin
				if token.name = ')'
					 then error(206, mytok)
					 else begin
									 scanner(inf, token, flag);
									 if (token.name[1] >= 'a') and (token.name[1] <= 'z')
											then if its_a_polyname(token.name)
															then error(207, token)
															else begin
																			oldtok := token;
																			scanner(inf, token, flag);
																			if token.name = '['
																						 then begin
																						         new_arretrieve(inf, oldtok, flag, qp, 
																						                        aux, colpos);
															{ Nov 1997 }           if aux <> nil
																						            then error(329, token)
																						      end
																						 else spec_retrieve(oldtok, n, qp)
																	 end
											else error(207, token)
								end
		 end;

	{*************************************************************************}

  procedure setargs; { (p: paramptr; var flag: nameptr; var mytoken: tokentipe;
	                      var n, val: quoly; var inf: text; var v, r, vcop: varptr; 
												var newarr: arrptr) }
		
	 { This procedure allows for local variables: once ')' is seen in
		 the argument list, all remaining formal parameters are set to 0 -
		 i.e., they become local variables .  Same thing if there is no	argument list. 
		    v is nil upon entry. val <> nil iff funcplotting. }

		var q, temp: varptr;
				s: arrptr;
				qp: quolyptr;
				obp: objptrptr;
				np: numptr;
				its_array_arg, thisone: boolean;
								
		begin 

			mytoken.name := ' ';
			thisone := false;
			if p <> nil
				then begin
								s := nil;
								temp := nil;
								scanner(inf, token, flag);
								if token.name <> '(' { programmer has passed no arguments. Thats ok-
																 all params are local vars.}
									 then begin
													 mytoken := token; { someone will want it }
													 token.name := ')';
													 token.address := -1;
													 if val <> nil  { funcplotting }
													    then begin
															        if plotting and (mytoken.name <> ')')
																			   then error(222, mytoken);
																			if cplotting and (mytoken.name <> ')') and (mytoken.name <> ',')
																			   then error(222, mytoken);
																			thisone := true
																	 end
											  end;
										
								{ Create linked list of arguments, pointed to by temp.  
									WHEN ALL FINISHED attach these to the store array. }
								while p <> nil do
									 begin
											if its_a_polyname(p^.let.name)
												 then error(125, p^.let);
											its_array_arg := false;   { could be changed by arrayarg }
											if p^.result
												 then get_qp_n(qp, inf, flag, n, p^.let)
											else if p^.isobject
											   then obj_param(obp, inf, flag, n)
											else if token.name <> ')'
															 then begin
																			 scanner(inf, token, flag);
																			 if token.name = '['
																					then arrayarg(p^.let, n, s, inf, flag, its_array_arg)
																			 else if token.name = '' 
																							 then if val = nil
																											 then error(216, token)
																											 else begin
																															 free_quoly(n);
																															 n := val;
																															 val := nil;
																															 thisone := true;
																															 scanner(inf, token, flag);
																														end
																			 else old_expre(inf, n, flag)
																		end
															 else if thisone
																			 then begin
																							 free_quoly(n);
																							 n := val;
																							 val := nil
																						end
																			 else quoly_set(0, n);
											if var_garb = nil
												 then New(q) //q := varptr(newptr(sizevarnode))
												 else begin
																 q := var_garb;
																 var_garb := var_garb^.next
															end;											
											q^.let := p^.let;
											if thisone
											   then begin
												         thisone := false;
																 v := q
															end;
											if p^.result
												 then q^.qp := qp
												 else if p^.isobject
												         then q^.obj := obp;
											if its_array_arg
												 then n^.ncoef^.size := -1742  { universal flag }
												 else if n^.numb
																 then n^.ncoef^.size := 0;
											q^.val := n;
											
											{ assign p^.qp for eventual compilation. Need to be careful
												  about array args. }
											if its_array_arg          
												 then p^.sparse := (s^.spar <> nil);
											if its_array_arg
												 then if p^.arry { was array arg last time too }
																 then begin
																				 np := numptr(p^.qp);
																				 np^.value := s^.start - addresser;
																				 np^.next^.value := s^.rows
																			end
																 else begin
																				 newnode(np);
																				 np^.value := s^.start - addresser;
																				 newnode(np^.next);
																				 np^.next^.value := s^.rows;
																				 p^.arry := true;
																				 p^.qp := quolyptr(np)
																			end
												 else if p^.arry
																 then begin
																				 np := numptr(p^.qp);
																				 np^.next^.next := numhead;
																				 numhead := np;
																				 p^.arry := false;
																				 p^.qp := @ q^.val
																			end
																 else p^.qp := @ q^.val; 
											q^.next := temp;
											temp := q;
											p := p^.next;
											n := nil;
											if (token.name <> ',') and (token.name <> ')') and (p <> nil)
												 then error(14, token);
									 end;
									
								if token.name <> ')'
									 then error(15, token);
									 
								{ attach to symbol table. }
								if v <> nil
								   then duplicate(q, s, r, newarr, v, vcop);  { pass back for funcplot }
								attach_symbols(q, s)
						 end;

			if mytoken.name = ' '
				 then scanner(inf, mytoken, flag)
				
		end;

	{**********************************************************************}

	function func_retrieve; { (name: tokentipe): funcptr }

		var q: funcptr;

		begin
			func_retrieve := nil;
			if name.address = -1
				 then name.address := hash(name.name, 71);
			q := func_store[name.address];
			while q <> nil do
				begin
					if q^.name.name = name.name
						 then break;
					q := q^.next;
				end;
		
			if q = nil
				then error(16, name)
				else func_retrieve := q
		end;

  {*************************************************************************}

  procedure get_from_array(var inf: text; var flag: nameptr; var newname: bigstring);
	
	   var i, start: longint;
		     j: integer;
		     other: tokentipe;    
				 p: arrptr;
				 q: quoly;
				 
		 begin
		 
			 newname := '';
			 left_side(inf, p, i, i, start, i, i, i, i, other, flag, false);
			 if p = nil
					then error(28, token);
			 if start <> -1
					then error(304, token);
			 if p^.spar <> nil
					then error(305, token);
			 j := 1;
			 for i := p^.start to p^.stop do
					begin
						 q := arp[i shr 10]^[i and tenmask];
						 if q <> nil
								then if q^.numb
												then begin
																start := round(q^.ncoef^.float);
																newname := concat(newname, chr(start));
																j := j + 1
														 end
												else error(306, token);
						 if j >= 256
								then break
					end;
			 if j = 1
					then writeln(userOutput, '*** Warning. array [', p^.name.name, '] is empty.')
					
		end;
																																												
 {***************************************************************************}
 
 procedure poly_diff; {(var n: ferm118.poly; degree: longint)}
 
   {   Differentiate n 'degree' times w.r.t. the highest level poly var.  degree > 0.
	   Works for laurent polys.  n does not have to be authenic.  n may become a number.  
		 Check other versions. }
 
   var t, p, q, r: ferm118.poly;
		   first, zero: boolean;
 
   {_______________________________________________________________________}
	 
	 procedure set_q;   
	    var i: longint;
			begin
	        q^.ncoef^.float := p^.exp;
					for i := 1 to degree - 1 do
						 with q^.ncoef^ do
								float := (p^.exp - i)*float
	    end;
	 
	 {________________________________________________________________________}
	  
	 begin
	
	   q := nil;
		 first := true;
		 poly_set(0, q); { used for exponents to multiply coefficients }
		 p := n;
	   while p <> nil do
	      begin		       
					 if (p^.exp >= 0) and (p^.exp < degree)
					    then zero := true
					 else begin
									 set_q;	         
									 p^.exp := p^.exp - degree;
									 poly_mult(q, p^.pcoef, p^.pcoef, nilpol);  { q is number }
									 zero := poly_iszero(p^.pcoef)
							  end;
					 if zero
					    then if first
							        then begin
											        n := n^.next;
															p^.next := nil;
															free_poly(p);
															p := n
													 end
											else begin
							                t^.next := p^.next;
											        p^.next := nil;
											        free_poly(p);
											        p := t^.next
									         end
					 else begin
					         if (p^.exp = 0) and p^.pcoef^.numb and (p^.pcoef^.next = nil) { tricky! }
									    then begin
											        r := p^.pcoef;
											        if first
															   then n := r
																 else t^.next := r;
															r^.next := p^.next;
															p^.pcoef := nil;
															p^.next := polygarb;
	                            polygarb := p;
															p := r
													 end;
									 if first
							        then begin
											        t := n;
															first := false
													 end
											else t := p;
									 p := p^.next
								end
		    end;
				
		 free_poly(q);
										 
		 if n = nil
		    then poly_set(0, n)
				
	 end;
	
	{***************************************************************************}
	
	procedure general_poly_diff; {(var p: ferm118.poly; degree: longint; height: integer)}
	
	   var pt: polyptrr;  
		     q: ferm118.poly;
		 
		 procedure discard;
		    begin
				   pt^ := q^.next;
					 q^.next := nil;
					 free_poly(q)
				end;		 
		 
		 begin
		 
		    if height = 1
				   then poly_diff(p, degree)
					 else begin
					         pt := @ p;
									 while pt^ <> nil do
									    begin
											   q := pt^;
												 if q^.numb
											      then discard
												    else begin
																	  general_poly_diff(q^.pcoef, degree, height-1);
																	  if node_iszero(q^.pcoef)
																			 then discard
																			 else if (q^.exp = 0) and q^.pcoef^.numb and (q^.pcoef^.next = nil)
																							 then begin
																											 q^.pcoef^.next := q^.next;
																											 pt^ := q^.pcoef;
																											 q^.next := polygarb;
																											 polygarb:= q;
																											 pt := @ pt^^.next
																									  end
																							 else pt := @ pt^^.next
																 end
											end;
									 if p = nil
									    then poly_set(0, p)
					      end
		 
		 end;
	
	{***************************************************************************}
	
	procedure differentiate; {(var n: quoly; height: integer; degree: longint)}
	
	   { Differentiate n 'degree' times with respect to var 'height'. degree > 0. }
		 
		 var i: longint;  
		 
		 begin
		 
		    if n^.numb 
				   then quoly_set(0, n)
			  else if n^.denom = nil
								then begin
									      general_poly_diff(n^.numer, degree, height);
									      if n^.numer^.numb and (n^.numer^.next = nil)
													 then polynum_to_quoly(n)
								     end
				else if n^.denom^.numb and (n^.denom^.next = nil)
				        then begin  { must be in rational mode }
								        general_poly_diff(n^.numer, degree, height);
								        check_quoly(n, false)  
								     end
				else for i := 1 to degree do
				        quoly_differen_once(n, height)
		 
		 end;
	
  {*************************************************************************}

  procedure load(var inf: text; var n: quoly; var flag: nameptr; newtok: bigstring;
	               var quitit: longint);  {@@@ quitit}

    var oldfunc_store: func_st_type;
		    i: integer;
				old_tt, old_int: boolean;
				oldtok, other: tokentipe;
				oldleft: shortstring;
				myzilch: nameptr;  {@@@ use instead of system global zilch }
				
		{_________________________________________________________}

    procedure reverse;

      var p, q: funcptr;

      begin
        q := func_store[i];
        func_store[i] := oldfunc_store[i];
        while q^.next <> oldfunc_store[i] do
          begin
            p := q^.next;
            q^.next := func_store[i];
            func_store[i] := q;
            q := p
          end;
        q^.next := func_store[i];
        func_store[i] := q
      end;
			
		{________________________________________________________}

    begin { of load }
		
      oldfunc_store := func_store;
			old_int := realflag;
			realflag := false;
			quitit := 0;
			myzilch := nil;  {@@@ all myzilch here}
			
			if (input_file_name = '') or (token.name = 'R')  
			   then begin
				         if newtok <> ' '
								    then { nothing }
								 else begin
													scanner(inf, oldtok, flag);  { must do this now }
													quitit := 1;  {@@@ boolean doesn't work!! April 1996}
													writeln(userOutput, 'Enter name of input file: ');
												{	do_prompts;}
								          readln(userInput, leftover);  {@@@ doprompts kept crashing!?!}
													scanner(userInput, other, myzilch);
													if other.name[1] = '@'
														 then begin
																		 writeln(userOutput, '*** Read cancelled');
																		 token.name := ';';
																		 leftover := '';
																		 exit {(load)};
																	end
														 else if other.name[1] = ''''
														         then begin
																		         newtok := '';
																						 i := 0;
													                   repeat 
																								 dumbscanner(userInput, other, myzilch, old_tt); {old_tt is dummy here} 
																								 if token.name = ''
																									  then error(131, token);
																								 i := i + length(other.name);
																								 if i <= 255
																										then if other.name <> '''' 
																														then newtok := concat(newtok, other.name)
																														else
																										else begin
																										        writeln(userOutput, '*** Warning. Name is too long.');
																														break
																												 end
																						 until other.name = ''''
																		      end
														   else if other.name[1] = '['
																			 then get_from_array(userInput, myzilch, newtok)  {@@@<<<<}
															 else begin
														           newtok := other.name;
																		   writeln(userOutput)
																	  end;
												 leftover := ''
											end;
								 if newtok = ''
								    then error(33, token);   
								 if newtok = output_file_name
								    then error(149, token);
								 if newtok = ''   
								    then begin
										        close(inpuf);
														if input_file_name = ''
														   then if flag = nil
															         then writeln(userOutput, ' *** Warning. No input file had been open.')
																			 else { nothing }
															 else begin
																			 if flag = nil
															            then writeln(userOutput, ' Now closing ', input_file_name, '.');
																			 input_file_name := ''
																		end;
														exit {(load)}
												 end;
								 input_file_name := newtok;
								 if token.name = 'R'
								    then close(inpuf);
								 reset(inpuf, input_file_name);
							{	 PLSetvbuf(inpuf, nil, _IOFBF, buffsize);  Dec 1996; turn off March 1997 }
								 done_load := false;  { global var "done_load" }
							end;

      if not done_load
         then reset(inpuf);
      done_load := false;
      old_tt := tt_flag;
			tt_flag := false;
			oldleft := leftover;
			leftover := '';
			watch_for_func := false;
			if eof(inpuf)
			   then writeln(userOutput, '*** Warning.  End of file ', input_file_name, ' encountered.');
	
      while (not eof(inpuf)) and not done_load do
         begin
            scanner(inpuf, token, myzilch);
            if eof(inpuf)
						   then begin
											 leftover := '';
											 break
										end;
						free_quoly(n);  { a failsafe; leave it }
						case token.name[1] of  {<<<<}
						   '!', ';': parse(inpuf, n, myzilch);
						   '', '[', '': arr_parse(token.name[1], inpuf, n, myzilch);
							 'A': if (token.name = 'Adjoint') or (token.name = 'Altmult')
											 or (token.name = 'Altpower')
											 then arr_parse('A', inpuf, n, myzilch)
											 else old_expre(inpuf, n, myzilch);
						   else parse(inpuf, n, myzilch) { Nov 1997 }
					  end;
					  if (token.name <> ';') and (token.name <> '') and (token.name <> '@')
			         then error(129, token);
            readln(inpuf);
            { if noisy
						   then flush(userOutput);   BUG of Dec 1996 }
						{ if parse sees &x, done_load becomes true }
         end;
      if n = nil
			   then quoly_set(0, n);
			if done_load
			      then leftover := '';
			if watch_for_func
			   then for i := 0 to 70 do
								 if func_store[i] <> oldfunc_store[i]
										then reverse { i } ;
      tt_flag := old_tt;
			realflag := old_int;
			if quitit = 1
			   then token := oldtok
				 else if flag = nil
				         then leftover := oldleft

    end;

  {**********************************************************************}

  procedure arrdescribe(var outf: text; p: arrptr);

    var cols: longint;

    begin
       write(outf, 'Array ', p^.name.name, '[', p^.rows:1);  { Nov 1997 }
       cols := p^.size div p^.rows;  {spar}
       if cols > 1
          then write(outf, ',', cols: 2, ']')
          else write(outf, ']');
			 if p^.spar = nil
			    then writeln(outf, ';')
					else writeln(outf, ' Sparse;')
    end;

  {**************************************************************************}

  procedure save(var inf: text; var flag: nameptr; newname: bigstring);

    var p: arrptr;
        count, i: longint;
				j: integer;
				first: boolean;

    {________________________________________________________________________}
		
		procedure arrdis(var outf: text; x: tokentipe; location, rows, cols, 
										 total_rows, desired: longint);
		   var p, i, j, k, mylength: longint;
					 opening: integer;
					 n: quoly;
		   begin
				  write(outf, '[', x.name, '] := [[ ');  { Nov 1997 }
				  opening := 9 + length(x.name);
					for i := 0 to rows - 1 do
						 for j := 0 to cols - 1 do
								begin
									mylength := 0;
									p := location + i + total_rows * j;
									n := arp[p shr 10]^[p and tenmask];
									if n <> nil
										then begin
														write(outf, ' ');
														mylength := 1;  {@@@}
														quoly_display(outf, true, false, true, n, mylength, comma, 
																				  polynames, false, false, false);
														if (i < rows-1) or (j < cols-1) 
															 then write(outf, ', ');
														if (j<cols-1) or ( (cols=1) and (i<rows-1) )
															 then for k:=1 to desired-mylength do write(outf, ' ');
												 end
										else begin
														if (j=cols-1) and (i=rows-1)
															 then write(outf, ' 0 ')
															 else write(outf, ' 0,');
														if (j<cols-1) or ( (cols=1) and (i<rows-1) )
															 then for k := 1 to desired-1 do
																			 write(outf, ' ')
												 end;
									if (j=cols-1) and (cols>1)
										 then begin
														 if i < rows - 1
																then begin
																				writeln(outf);
																				write(outf, ' ': opening)
																		 end
																else writeln(outf, '   ]];')
													end
										 else if (cols=1) and (i=rows-1)
												     then writeln(outf, '  ]];')
								end
				end;
				
		{_______________________________________________________________________}
		
		function all_small: boolean;
		   var i: longint;
			     n: quoly;
			 begin
			    all_small := false;
					for i := p^.start to p^.stop do
					   begin
						    n := arp[i shr 10]^[i and tenmask];
								if n <> nil
								   then if not n^.numb
						               then exit {(all_small)}
				     end;
					all_small := true
			 end;
		
		{_______________________________________________________________________}
		
    begin
				  
			if (output_file_name = '') or (token.name = 'S')
			   then begin
				         if newname <> ' '
								    then { nothing }
									  else begin
														writeln(userOutput, 'Enter name of output file: ');
														{  do_prompts; @@@ changed to below }
														readln(userInput, leftover);
														scanner(userInput, token, zilch);
														if token.name[1] = '@'
															 then begin
																			 writeln(userOutput, '*** Save cancelled');
																			 exit {(save)};
																		end
															 else if token.name[1] = ''''
																			 then begin
																							 newname := '';
																							 i := 0;
																							 repeat
																									 dumbscanner(userInput, token, zilch, first); { first is dummy here. }
																									 if token.name = ''
																									    then error(131, token);
																									 i := i + length(token.name);
																									 if i <= 255
																											then if token.name <> ''''
																															then newname := concat(newname, token.name)
																															else
																											else begin
																															writeln(userOutput, '*** Warning. Name is too long.');
																															break
																													 end
																							 until token.name = ''''
																						end
															 else if token.name[1] = '['
																			 then get_from_array(inf, flag, newname)
														   else begin
																			 newname := token.name;
																			 writeln(userOutput)
																		end;
														leftover := ''
												 end;
								 if newname = ''
								    then error(33, token);
								 if newname = input_file_name
								    then error(149, token);
								 if output_file_name <> ''
								    then begin
										        flush(outpuf);
														close(outpuf)
												 end;
								 if newname = ''
								    then begin
										        if output_file_name = ''
														   then if flag = nil
															         then writeln(userOutput, ' *** Warning. No output file had been open.')
																			 else { nothing }
															 else begin
																			 if flag = nil
															            then writeln(userOutput, ' Now closing ', output_file_name:1, '.');
																			 output_file_name := ''
																		end;
														exit {(save)}
												 end;
								 output_file_name := newname;
								 AssignFile(outpuf, output_file_name);
                 try
                   Append(outpuf);
                 except on EInOutError do Rewrite(outpuf);
                 end;
//wwh								 Seek(outpuf, FileSize(outpuf));
								 exit {(save)}
							end;

			if complex
			   then writeln(outpuf, '&(c = 1);');  {@@@ bug of April 28, 1996}
			if errorpush 
			   then writeln(outpuf, '&(e = 1);');
			if not noisy
			   then writeln(outpuf, '&(N = 0);');
			if m_interrupt <> 1
			   then writeln(outpuf, '&(m = ', m_interrupt:1, ');');
			if addresser = 0
			   then writeln(outpuf, '&(a = 0);')
				 else writeln(outpuf, '&(a = 1);');
			if detcutoff >= 0
			   then writeln(outpuf, '&(D = ', detcutoff:1, ');');
			if prompt <> '>'
			   then if prompt[1] = chr(13)
				         then writeln(outpuf, '&(P = ''', ' ', ''');')
								 else writeln(outpuf, '&(P = ''', prompt, ''');');
			if namelength <> 10
			   then writeln(outpuf, '&(n = ', namelength:1, ');');
			if uglyprint
			   then writeln(outpuf, '&(U = 1);');
			if timerflag
			   then writeln(outpuf, '&(t = 1);');
			if polynames <> nil
			   then polylist(outpuf, true);
			if laurent
			   then writeln(outpuf, '&( = 1);');
      writeln(outpuf);
			
			writeln(outpuf);
      writeln(outpuf, ';;** functions:');
			listfuncs(outpuf, inf, false, multsign, flag);
      writeln(outpuf);
      writeln(outpuf, ';;** scalars:');
			
      dump(outpuf, false, false);
		
		  first := true;
      for j := 0 to 150 do
			   begin
				    { Calculate number of arrays.}
            p := arr_store[j];
            count := 0;
            while p <> nil do
               begin
                  count := count + 1;
                  p := p^.next
               end;

            { Dump arrays in temporal order; i.e.  backwards. }
            if (count > 0) and first
               then begin
                      writeln(outpuf);
                      writeln(outpuf, ';;**  arrays:');
											first := false
                    end;
			
            while count > 0 do
               begin
									writeln(outpuf);
									p := arr_store[j];
									for i := 1 to count - 1 do p := p^.next;
									arrdescribe(outpuf, p);
									i := p^.size div p^.rows;
									if p^.spar = nil
									   then if all_small
														 then arrdis(outpuf, p^.name, p^.start, p^.rows, i, p^.rows, 5)
														 else arrdisplay(outpuf, false, true, blank, p, p^.start, p^.rows, 
																						 i, 1, 1, p^.rows, 4, false, true, true, nil)
										 else sparse_display(outpuf, p, false);
									count := count - 1
              end
				 end;
				 
			writeln(outpuf, '&x;')

    end;

	{*******************************************************************}

	procedure compile(var n: quoly; p: condexptr; var flag: nameptr);
	
	   var f: funcptr;
		 		 
		 {____________________________________________________________________}
		 
		 procedure read_and_link(f: funcptr; p: condexptr);
		 
		    var q: formptr;
				    r: paramptr;
						qa: arrptr;
						np: numptr;
				    nmeptr: array[1..100] of nameptr;
						names: array[1..100] of nametype;
						copy: nametype;
						dup, externals, tail: nameptr;
						numpars, i, j, k: integer;
						pos: longint;
				
				{------------------------------------------------------------------}		 
			  
				function its_in_the_list(x: nametype; var s: integer): boolean;
				
				   var i: integer;
					 begin					    
							its_in_the_list := false;
							for i := 1 to numpars do
							   if x = names[i]
								    then begin
										        s := i;
														its_in_the_list := true;
														exit {(its_in_the_list)}
												 end
								 else if x < names[i]
								         then begin
												         s := i;
																 exit {(its_in_the_list)}
															end;
							s := numpars + 1
					 end;
				
				{------------------------------------------------------------------}
				
				procedure do_tok_list(q: nameptr);
				
				   { Search an expression, looking up all likely tokens in the symbol tables
					   created earlier.  Mark suitable tokens as compiled, and of what 'tipe'. }
				
				   var lastq, saveq: nameptr;
							 arryname: nametype;
							 leng: integer;
							 found, constant: boolean;
							 
					 {.................................................................}
					 
					 function found_digit(q: nameptr): boolean;
					    begin
							   found_digit := (q^.let.name[1] >= '0') and (q^.let.name[1] <= '9')
							end;
							
					 {.................................................................}
					 
					 function search_and_set(this: nametype; typ: classtype): boolean;
					    var i: integer;
					    begin
							   if its_in_the_list(this, i)
									  then begin
													 lastq^.qp := nmeptr[i]^.qp;
													 nmeptr[i]^.nother := lastq;
													 nmeptr[i] := lastq;
													 lastq^.compiled := true;
													 lastq^.tipe := typ;
													 search_and_set := true
												end
									  else search_and_set := false
							end;
							
					 begin
					 
							while q <> nil do
							   begin
										lastq := q;
										q := q^.next;
										if q = nil
										   then break;
										if (q^.let.name = '[') and (lastq^.let.name[1] >= 'a')
										   and (lastq^.let.name[1] <= 'z')
											 then begin
															 q := q^.next;
															 if q = nil
															    then break;
															 leng := length(lastq^.let.name);
															 if leng + 1 <= 10
															    then arryname := concat(lastq^.let.name, '[')
																	else continue;
															 leng := leng + 1 + length(q^.let.name);
															 if leng <= 10
															    then arryname := concat(arryname, q^.let.name)
																	else continue;
															 saveq := q;
															 constant := found_digit(q);
															 q := q^.next;
															 if q = nil
															    then break;
															 if constant
															    then while found_digit(q) do
																				  begin
																						leng := leng + 1;
																						if leng <= 10
																							 then arryname := concat(arryname, q^.let.name)
																							 else break;
																						q := q^.next;
																						if q = nil
																						   then exit {(do_tok_list)}
																				  end;
															 if q^.let.name = ']'
															    then begin
																	        leng := leng + 1;
																					if leng <= 10
																					   then arryname := concat(arryname, ']')
																						 else begin
																						         q := saveq;
																										 continue
																									end;
																					found := search_and_set(arryname, two);
																					if found
																					   then q := q^.next
																						 else begin
																						         q := saveq;
																										 arryname := lastq^.let.name;
																										 arryname[1] := chr(ord(arryname[1])-32);  { capitalize }
																										 found := search_and_set(arryname, three)
																									end
																			 end
																  else begin
																	        q := saveq;
																					arryname := lastq^.let.name;
																				  arryname[1] := chr(ord(arryname[1])-32);  { capitalize }
																				  found := search_and_set(arryname, three)
																			 end
													 end
											 else found := search_and_set(lastq^.let.name, one);
								 end
								 
					 end;
				
				{------------------------------------------------------------------}
		 
			  procedure do_form(q: formptr); forward;
								
				{------------------------------------------------------------------}
		 
			  procedure do_right(d: condexptr);
					 begin
						  if d^.cond = nil
							   then do_tok_list(d^.expr)
								 else begin
								         do_tok_list(d^.cond);
												 do_form(d^.form1);
												 if d^.form2 <> nil
													  then do_form(d^.form2)
										  end
					 end;								
				
				{------------------------------------------------------------------}
		 
			  procedure do_form; { (q: formptr) }			 
					 begin						
						  while q <> nil do
								 begin
									  do_right(q^.cptr);
									  q := q^.next
								 end
					 end;														
				
				{----------------------------------------------------------------}
					 
			  procedure insert_and_update(thisone: nametype; var i: integer; var name1, name2:
				                            tokentipe);
					 var k: integer;
					 begin
						 if its_in_the_list(thisone, i)  { sets i even if not in list }
								then error(259, name1);
						 if numpars = 100
								then error(256, name2);
						 numpars := numpars + 1;
						 for k := numpars downto i+1 do
								begin
									 names[k] := names[k-1];
									 nmeptr[k] := nmeptr[k-1]
								end;
						 names[i] := thisone;
						 if tail = nil
								then begin
												newname(externals);
												tail := externals
										 end
								else begin
												newname(tail^.next);
												tail := tail^.next
										 end
					 end;
							
				{------------------------------------------------------------------}
		 
			  procedure get_one_name;
				
				   { Scan the list of names after 'Compile'. Extract the next one, place in
					   symbol tables. }
				
				   var thisone: nametype;
					     i: integer;
							 q: varptr;
							 qp: quolyptr;
							 oldflag: nameptr;
							 x: char;
					 
					 {................................................................}
					 
					 procedure get_q(p: nameptr);
					    begin
								 q := sca_store[i];
								 while q <> nil do
										if q^.let.name = p^.let.name
											 then break
											 else q := q^.next;
								 if q = nil
										then error(19, p^.let)
							end;
												 					 					 
					 {................................................................}
					 
					 begin { get_one_name }
					 
					    thisone := flag^.let.name;
							i := flag^.let.address;
							if (thisone[1] >= 'a') and (thisone[1] <= 'z')
							   then begin
													oldflag := flag;
													flag := flag^.next;
													currentchar := flag^.next;
													if flag^.let.name = '['  { a reference like var[dim]; 'tipe' two }
													   then begin
														         flag := flag^.next;    {spar; whole block }
																		 currentchar := flag^.next;
																		 thisone := concat(thisone, '[');
																		 i := flag^.let.address;
														         x := flag^.let.name[1];
																		 pos := 0;
																		 if (x >= '0') and (x <= '9')
																		    then while (x >= '0') and (x <= '9') do
																				        begin
																									 pos := 10*pos + ord(x) - 48;
																									 thisone := concat(thisone, flag^.let.name);
																									 flag := flag^.next;
																									 currentchar := flag^.next;
																									 x := flag^.let.name[1]
																								end
																				else begin
																				        get_q(flag);
																							  if not q^.val^.numb
																									 then error(300, flag^.let);
																								thisone := concat(thisone, flag^.let.name);
																								flag := flag^.next;
																								currentchar := flag^.next;
																							  pos := round(q^.val^.ncoef^.float)
																						 end;
																		 spec_lookup(oldflag^.let, pos, qa, qp);
																		 if qa^.spar <> nil
																        then error(289, token);  { Dec 1997 }
																     if qp^ = nil
																			  then error(29, oldflag^.let);
																		 if flag^.let.name <> ']'
													              then error(73, flag^.let);
																		 thisone := concat(thisone, ']');
																		 flag := flag^.next;
																		 currentchar := flag^.next
														      end
														 else begin
														         qp := nil;
																		 get_q(oldflag)
																	end;
													insert_and_update(thisone, i, flag^.let, oldflag^.let);
								          if qp = nil
													   then tail^.qp := @ q^.val
														 else tail^.qp := qp;
													nmeptr[i] := tail
								      end
								 else if (thisone[1] = '[')  { a reference like [y]; 'tipe' three }
								         then begin
												         flag := flag^.next;
																 currentchar := flag^.next;
																 oldflag := flag;
																 thisone := flag^.let.name;
																 pos := fastestlookup(flag^.let, qa);
																 if pos = -1
																    then error(28, flag^.let);
																 if qa^.spar <> nil
																    then error(289, token);
												         flag := flag^.next;
																 currentchar := flag^.next;
																 if flag^.let.name <> ']'
																		then error(24, flag^.let);
																 flag := flag^.next;
																 currentchar := flag^.next;
																 thisone[1] := chr(ord(thisone[1]) - 32); { Capitalize }
																 insert_and_update(thisone, i, flag^.let, oldflag^.let);
																 newnode(np);
																 np^.value := qa^.start;   { changed Oct 1993 }
																 newnode(np^.next);
																 np^.next^.value := qa^.rows;
										             tail^.qp := quolyptr(np);
																 nmeptr[i] := tail
												      end
								 else error(258, flag^.let)
					 
					 end;
				
				{---------------------------------------------------------------------}
				
				begin { of read_and_link }
								   
					 { Begin to collect symbol table of names to be compiled. 
					   Start with the parameters/local vars. Already attached by setargs. }
					 flag := flag^.next;
					 currentchar := flag^.next;
					 if flag^.let.name = '*'
					    then begin  { ignore the parameters; move up flag. }
							        flag := flag^.next;
					            currentchar := flag^.next;
											f^.do_params := false;
							        r := nil
									 end
					    else begin
							        r := f^.pars;
											f^.do_params := true
									 end;
									 
					 numpars := 0;
					 tail := nil;
					 while r <> nil do
					    begin
							   if r^.arry  { array param, set by setargs. Treat
								               as external; i.e., as a 'tipe' three. } 
								    then begin
										        copy := r^.let.name;
														if r^.sparse 
														   then error(293, r^.let);
														copy[1] := chr(ord(copy[1]) - 32); { Capitalize }
														if numpars = 100
															 then error(256, r^.let);
													  numpars := numpars + 1;
													  names[numpars] := copy;
													  nmeptr[numpars] := nameptr(r)
												 end
								 else begin  { standard parameter.  Dump unsorted into names. }
												 numpars := numpars + 1;
												 if numpars > 100
														then error(256, r^.let);
												 names[numpars] := r^.let.name;
												 nmeptr[numpars] := nameptr(r)
											end;
								 r := r^.next
							end;
							
					 { Insertion sort names, moving nmeptr accordingly }
					 for i := 2 to numpars do
					    for j := 1 to i-1 do
								 if names[i] < names[j]
										then begin
														copy := names[i];
														dup := nmeptr[i];
														for k := i downto j+1 do
															 begin
																	names[k] := names[k-1];
																	nmeptr[k] := nmeptr[k-1]
															 end;
														names[j] := copy;
														nmeptr[j] := dup;
														break
												 end;
												 
					 { Look for rest of compile statement. Add more names if present. }
					 if flag^.let.name = '('
					    then begin
							        repeat
											   flag := flag^.next;
												 currentchar := flag^.next;
												 get_one_name;
											until flag^.let.name <> ',';
											if flag^.let.name <> ')'
											   then error(257, flag^.let)
									 end;
									 
					 { Move past the compile statement. }
					 q := f^.rht;
					 while q^.cptr <> p do
					    begin
							   q := q^.next;
								 if q = nil
								    then error(255, token)
							end;
					 q := q^.next;
					 
					 { Resolve references, and link up. Need to leave linked lists for reassign 
					   to find later.  The nodes pointed to by the external list wouldn't have 
						 to be linked up, but it's harmless. }
					 f^.comp := q;
					 do_form(q);
					 
					 { Finish off the lists. }
					 for i := 1 to numpars do
					    nmeptr[i]^.nother := nil;
					 if tail <> nil
					    then begin
							        tail^.next := name_garb;
											name_garb := externals
									 end
				
				end;
				
		 {____________________________________________________________________}
		 
		 procedure reassign(f: funcptr);
		 
		    var r: paramptr;
				    q: nameptr;
				
				begin
				
				   r := f^.pars;
					 while r <> nil do
					    begin
							   if r^.arry and r^.sparse 
										then error(293, r^.let);
								 q := r^.nother;
								 while q <> nil do
								    begin
										   q^.qp := r^.qp;
										   q := q^.nother
										end; 
							   r := r^.next
							end
				
				end;
				
		 {_____________________________________________________________________}
				
		 begin { of compile }
	
	      if statcount = 0
				   then error(260, token);
				f := lastf^.f;
				if f^.comp = nil   { hasn't been compiled yet }
				   then read_and_link(f, p)
					 else if f^.do_params
					         then reassign(f);
					 
				eval_form(userInput, f^.comp, n);
				if n = nil
					 then quoly_set(0, n);
				exit_flag := true
	
	   end;
	
	{**************************************************************************}

	procedure getval(var inf: text; p: condexptr; var n: quoly);
	
		{ startexpr must be correct (the last thing executed) upon entry.  
			prev_expr is immediately set to this.
			Upon conclusion, startexpr is the last thing successfully executed.
			At any time, if an error occurs, both are correct. }

		var q,t: nameptr; { local copies }
				r: varptr;
				im: imptr;
				i, stop, increm, negflag: longint;
				val: longreal;

		begin 
			q := p^.expr;
			t := p^.cond;
			prev_expr := startexpr;
			startexpr := t;
			if t = nil
				then begin
								startexpr := q;
								token := q^.let;
								currentchar := q^.next;
								case token.name[1] of
						{':',} '!': parse(inf, n, q);  { can't put '&' in this list! }
									 'R': if token.name = 'Real'
													 then begin
													         realflag := true;  { n is never touched }
																	 scanner(inf, token, q)
																end
													 else old_expre(inf, n, q);
									 'C': if token.name = 'Compile'	
													 then compile(n, p, q)
													 else if realflag
																	 then begin
																					 old_iexpre(val, q);
																					 quoly_set_ext(val, n)
																			  end
																	 else old_expre(inf, n, q);
									 '', '[', '': arr_parse(token.name[1], inf, n, q);
									 'A': if (token.name = 'Adjoint') or (token.name = 'Altmult')
												   or (token.name = 'Altpower')
												   then arr_parse('A', inf, n, q)
													 else if realflag
																	 then begin
																					 old_iexpre(val, q);
																					 quoly_set_ext(val, n)
																			  end
																	 else old_expre(inf, n, q);
									 else if realflag
									              then begin
																        iexpre(val, q);
																				quoly_set_ext(val, n)
																		 end
																else parse(inf, n, q)
								end;
								if (token.name <> '') and (token.name<>';') and (token.name<>'@')
									then error(31, token);
						 end
				else if p^.aloop
							then if t^.let.name = ':'  { a for-loop }
											then begin
															{  Nov 1997 token := t^.let;  } 
															currentchar := t^.next;
															set_up_for_loop(inf, t, r, i, stop, increm);
															if token.name <> '' 
			                           then error(189, token);
															if increm < 0
																 then begin
																				 i := -i;  stop := -stop;  increm := -increm;
																				 negflag := -1
																			end
																 else negflag := 1;
															im := r^.val^.ncoef;
															while i <= stop do
																 begin
																		eval_form(inf, p^.form1, n);
																		if exit_flag  { global set by some expression }
																			 then exit {(getval)};
																		if leave_flag { global set by some expression }
																			 then begin
																							 leave_flag := false;
																							 break
																						end;
																		if cycle_flag
																			 then cycle_flag := false;
																		i := i + increm;
																		if abs(i) >= block
																			 then error(47, r^.let);
																		im^.float := negflag*i
																 end;
															if p^.form2 <> nil 
																 then eval_form(inf, p^.form2, n)
													 end
							 else begin	 
											token := t^.let;          
											currentchar := t^.next;
											while bool_expre(inf, t) do 
												 begin
														eval_form(inf, p^.form1, n);													
														if exit_flag  { global set by some expression }
															 then exit {(getval)};
														if leave_flag { global set by some expression }
															 then begin
																			 leave_flag := false;
																			 break
																		end;
														if cycle_flag
															 then cycle_flag := false;
														t := p^.cond;
														prev_expr := startexpr;
														startexpr := t;
														token := t^.let;                  
														currentchar := t^.next
												 end;
											if p^.form2 <> nil 
											   then eval_form(inf, p^.form2, n)
										end
					else { it's an if statement }
							begin
							   token := t^.let;
								 currentchar := t^.next;
								 if bool_expre(inf, t)
									  then eval_form(inf, p^.form1, n)
									  else if p^.form2 <> nil 
													  then eval_form(inf, p^.form2, n)
							end

		end;

  {*************************************************************************}

	procedure eval_form { var inf: text; q: formptr; var n: quoly };
    { may end with n nil }
		begin
			while q <> nil do
				 begin
						free_quoly(n);
						getval(inf, q^.cptr, n);					
						if exit_flag or leave_flag or cycle_flag
							 then exit {(eval_form)};
						q := q^.next
				 end
		end;

  {*************************************************************************}

  procedure evaluate; { (var inf: text; name: tokentipe; var n: quoly; 
                         var flag: nameptr); }

     var p: funcptr;
         mytoken: tokentipe;
				 old_startexpr, old_prev_expr: nameptr;
				 dum: quoly;
				 dummer: varptr;
				 useless: arrptr;
				 old_real_flag: boolean;

     begin 

				p := func_retrieve(name);
				dum := nil;
				dummer := nil;
				setargs(p^.pars, flag, mytoken, n, dum, inf, dummer, dummer, dummer, useless);
				
				{ Update status count and pointers.}
				lastf := lastf^.next;
				lastf^.f := p;
				statcount := statcount + 1;
				old_startexpr := startexpr;
				old_prev_expr := prev_expr;
				old_real_flag := realflag;
				realflag := false;
	
				{ Now actually evaluate. }
				quoly_set(0, n);
				prev_expr := nil;
				startexpr := nil;
				eval_form(inf, p^.rht, n);
				if n = nil
					 then quoly_set(0, n);
				exit_flag := false;
	
				if token.name <> ''
					 then error(31, token);
					 
				remove_args(p, false);
				token := mytoken;
				
				{ Now reset the status information.}
				statcount := statcount - 1;
				lastf := lastf^.prev;
				prev_expr := old_prev_expr;
				startexpr := old_startexpr;
				realflag := old_real_flag;
				syst_dump := false

     end;

  {*************************************************************************}
	
  procedure single_rubout(var inf: text;  var flag: nameptr);
	
    var q, t: varptr;
        p, s: funcptr;
        oldtok, secondtok: tokentipe;
				r, u2: arrptr;
				i: integer;
				
		{_____________________________________________________________}
				
		procedure removearray(fast: boolean); 
		  { Remove array called oldtok. Leave r pointing to node removed.
				This is a very delicate procedure.}
		
		   var locat, length, i: longint;
           u, bad: arrptr;
					 j: integer;
					 array_param: boolean;
		
		   begin
			    
					locat := fastestlookup(oldtok, r);  {spar}
					if fast and (r = nil)
						 then exit {(removearray)};  
					if locat = -1
						 then error(28, token);
					array_param := (r^.time < 0);
					if array_param
						 then if (levelcount = 1) and (flag = nil)
										 then writeln(userOutput, ' Warning.  About to delete an array parameter.')
										 else begin
														 if u2 <> nil
																then u2^.name.name := oldtok.name;												         
														 error(138, oldtok);
														 writeln(userOutput, ' Cancel aborted.');
														 exit {(single_rubout)}
													end;
													
					length := r^.stop - r^.start + 1; { yes! don't use r^.size! <<<< }
					
					{ First, fix up the list in arr_store containing oldtok. Remove the
						node containing oldtok. }
					if oldtok.address = -1
						 then j := hash(oldtok.name, 151)
						 else j := oldtok.address;
						 
					r := arr_store[j];
					u := nil;
					while r^.name.name <> oldtok.name do
						 begin
								u := r;
								r := r^.next
						 end;
					if u = nil
						 then arr_store[j] := arr_store[j]^.next
						 else u^.next := r^.next;
					r^.next := arr_garb;
					arr_garb := r;  { r still points to the node. }
					if array_param
						 then exit {(removearray)};  { don't touch the storage }
					
					{ now free the storage }
					if r^.spar <> nil  {``` added Nov 1994. was absent.}
					   then free_sparse(r^.spar, r^.rows, true);
						 
					if length = 0                       {spar}
						 then exit {(removearray)}; 
					for i := locat to locat + length - 1 do
						 free_quoly(arp[i shr 10]^[i and tenmask]);

					for i := locat to endarr - length do
						arp[i shr 10]^[i and tenmask] := 
								arp[(i+length) shr 10]^[(i+length) and tenmask];

					for i := endarr - length + 1 to endarr do
						 arp[i shr 10]^[i and tenmask] := nil;
 
					endarr := endarr - length;
					
					{ don't change numblocks -- it's the number of so far allocated blocks,
					 empty or not. }
												
					{ Now patch up all the other nodes in arr_store, using the time field
						stored in locat. }
					bad := nil;
					locat := r^.time;  { r^.time must be positive here }
					for i := 0 to 150 do
						 begin
								u := arr_store[i];
								while u <> nil do
									begin
										if abs(u^.time) > locat
											then begin
															u^.start := u^.start - length;
															u^.stop := u^.stop - length
													 end
										else if u^.time = - locat  { just cancelled an array with alias u^.name }
													 then if (levelcount = 1) and (flag = nil)
																	 then begin
																					 writeln(userOutput, ' Warning. Encountered array parameter named ',
																									 u^.name.name, ',');
																					 writeln(userOutput, ' which is an alias of ', oldtok.name, '.  Delete it immediately.');
																				end
																	 else bad := u; { call error later }
										u := u^.next
									end
						 end;
					if bad <> nil
						 then begin
										 if u2 <> nil
												then u2^.name.name := oldtok.name;
										 error(139, bad^.name);
										 writeln(userOutput, ' Cancel aborted.')
									end
							
			 end;
			 
			{________________________________________________________________}
			
			procedure find_pointer;
			
			   begin
						if token.address = -1
							 then i := hash(token.name, 71)
							 else i := token.address;
						p := func_store[i];
						if p = nil
							 then error(20, token);
						while token.name <> p^.name.name do
							 begin
									s := p;
									p := p^.next;
									if p = nil
										then error(20, token)
							 end
				 end;
				
			{________________________________________________________________}	

    begin { of single_rubout }
      
      u2 := nil;
			if (token.name[1] >= 'a') and (token.name[1] <= 'z')
        then
          begin
            if token.address = -1
						   then i := hash(token.name, 151)
							 else i := token.address;
						q := sca_store[i];
            if q = nil
              then begin error(19, token); exit {(single_rubout)} end;
            while token.name <> q^.let.name do
              begin
                t := q;
                q := q^.next;
                if q = nil
                  then begin error(19, token); exit {(single_rubout)} end
              end;
            if q = sca_store[i]
              then sca_store[i] := sca_store[i]^.next
              else t^.next := q^.next;
						q^.next := var_garb;
            var_garb := q;
							
            free_quoly(q^.val)
						
          end
        else if token.name = '['
          then
            begin
              scanner(inf, oldtok, flag);
							if oldtok.name = ''
							   then error(176, oldtok);
              scanner(inf, token, flag);
							if oldtok.name = '*'
							   then begin
								         secondtok := token;
												 scanner(inf, token, flag)
											end;
              if token.name <> ']'
                then error(24, token);
							if oldtok.name = '*'
							  then if secondtok.name = '*'
								        then for i := 0 to 150 do
												        while arr_store[i] <> nil do
												           begin
													            oldtok := arr_store[i]^.name;
														          removearray(false)
												           end
										 else if (secondtok.name[1] < 'a') or (secondtok.name[1] > 'z')
										    then error(28, secondtok)
										 else begin
										         oldtok := secondtok;
														 removearray(true);
														 if r = nil
														    then error(28, oldtok)
														 else repeat
														        removearray(true);
														      until r = nil
												  end
								else removearray(false)
            end
          else if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
            then begin
									  find_pointer {p};
		                if p = func_store[i]
		                   then func_store[i] := func_store[i]^.next
		                   else s^.next := p^.next;
		              end

          else if token.name = '<'  { purge array or function }
					   then begin
						         scanner(inf, token, flag); 
										 if (token.name[1] >= 'A') and (token.name[1] <= 'Z')
										    then begin
												        scanner(inf, oldtok, flag);
										            if oldtok.name <> '>'
										               then error(128, token);
												        find_pointer {p};
																s := p;
																p := p^.next;
																while p <> nil do
																   begin
																	    if token.name = p^.name.name																			
																			   then s^.next := p^.next
																			   else s := p;
																		  p := p^.next
																	 end
														 end
										 else if token.name = '['
										    then begin
												        scanner(inf, oldtok, flag);
												        i := fastestlookup(oldtok, r);
																if i = -1 
																   then error(28, oldtok);
																scanner(inf, token, flag);
																if token.name <> ']'
                                   then error(24, token);
																scanner(inf, token, flag);
										            if token.name <> '>'
										               then error(128, token);
																r^.name.name := ' hell'; { impossible name }
																u2 := r;
																repeat
														       removearray(true);
														    until r = nil;
																u2^.name.name := oldtok.name  { put it back }																
														 end
										 else error(208, token)
										 
								  end
																					
					else error(21, token);

    end;

  {****************************************************************}

	procedure rubout(var inf: text;  var flag: nameptr);
	
		begin

			  if cancelflag
				   then begin
					         error(170, token);
									 exit {(rubout)}
								end;
				scanner(inf, token, flag);
			  if token.name <> '('
				   then single_rubout(inf, flag)
				else repeat
								scanner(inf, token, flag);
								single_rubout(inf, flag);
								scanner(inf, token, flag);
							  if (token.name <> ',') and (token.name <> ')')
									 then error(95, token)
						 until token.name = ')'
																
		end;
								
  {***********************************************************************}
		
	procedure change_complex;
	
		{-------------------------------------------------------------------}
		
		procedure change_quol(var q: quoly);
		
		   begin
			    quoly_imag_free(q, false)
			 end;
			 
		{--------------------------------------------------------------------}
	
	  procedure change_vars;

      var p: varptr;
			    i: integer;

      begin
        for i := 0 to 150 do
				   begin
					    p := sca_store[i];
              while p <> nil do
                 begin
					          change_quol(p^.val);
                    p := p^.next
                 end
					 end
      end;

    {--------------------------------------------------------------------}

    procedure change_arrays;

      var i: longint;

      begin
        for i := 0 to endarr do
           if (arp[i shr 10]^[i and tenmask] <> nil) 
              then change_quol(arp[i shr 10]^[i and tenmask]);
						
				if syst^.spar = nil
				   then for i := 0 to syst^.stop do
				           change_quol(stash^[i])
      end;

		{----------------------------------------------------------------------}
			    
    procedure sparse_change(ap: arrptr);		
		   var i, j: longint;
					 u: colm_ptrptr;
					 sp: sparseptr;
			 begin
					sp := ap^.spar;
					for i := 0 to (ap^.rows - 1) div sparsesize do {```}
						 begin
								for j := 1 + i*sparsesize to (i+1)*sparsesize do
									 if j > ap^.rows
											then break
											else begin
															u := @ sp^.indx[j-i*sparsesize];
															while u^ <> nil do
																 begin
																		change_quol(u^^.val);
												            if (u^^.val = nil) or quoly_iszero(u^^.val)
													             then free_colm(u^)
													             else u := @ u^^.next
																 end
													 end;
								sp := sp^.next
						 end
			 end;
							 
   {----------------------------------------------------------------------}
		
		procedure change_sparses;  {```}
		
      { Unlike some other changes, it doesn't matter if a quoly is changed twice.}
			
			var i: integer;
			    ap: arrptr;

      begin
         for i := 0 to 150 do
            begin
						   ap := arr_store[i];
							 while ap <> nil do
                  begin
										 if ap^.spar <> nil
										    then sparse_change(ap);
										 ap := ap^.next
									end
						end;
				 if syst^.spar <> nil
				    then sparse_change(syst)
      end;

    {-------------------------------------------------------------------}

    procedure change_polydata;
		
      var q: polypt;

      begin
        
				  q := polynames;
					while q <> nil do
					   begin
						    if q^.p <> nil
								   then poly_imag_free(q^.p);
								q := q^.next
						 end					 
					
      end;

		 {------------------------------------------------------------}		 
		
		 begin
		 
		    complex := not complex;
				if complex 
				   then writeln(userOutput, ' Now in complex arithmetic.')
					 else writeln(userOutput, ' Now in real arithmetic.');  {```}
			  if not complex
				   then begin					        
					        change_vars;
				          change_arrays;
									change_sparses;
									change_polydata
							  end
				
		 end;

  {***********************************************************************}
			
	procedure change_laurent;
	
	  { laurent has been changed to new value. }
	
		{-----------------------------------------------------------}
		
		procedure change_quol(var q: quoly);
		
		   var exps, tail: ferm118.poly;
		
		   begin
			    
					if laurent
					   then if not q^.numb and (q^.denom <> nil)
						         then normal_form(q)
										 else { nothing }
						 else if not q^.numb
						         then begin
										         clear_bads(q^.numer, exps, tail, 0);
														 if exps <> nil
															  then begin
																       if q^.denom = nil
																			    then poly_set(1, q^.denom);
																			 eliminate_bads(q^.denom, exps, -1);
																			 tail^.next := polygarb;
																			 polygarb := exps
																		end
										      end
														 
			 end;
			 
		{----------------------------------------------------------------}
	
	  procedure change_vars;

      var p: varptr;
			    i: integer;

      begin
        for i := 0 to 150 do
				   begin
					    p := sca_store[i];
              while p <> nil do
                 begin
					          change_quol(p^.val);
                    p := p^.next
                 end
					 end
      end;

    {------------------------------------------------------------}

    procedure change_arrays;

      var i: longint;

      begin
        for i := 0 to endarr do
           if (arp[i shr 10]^[i and tenmask] <> nil) 
              then change_quol(arp[i shr 10]^[i and tenmask]);
						
				if syst^.spar = nil
				   then for i := 0 to syst^.stop do
				           change_quol(stash^[i])
      end;

		{----------------------------------------------------------------------}
			    
    procedure sparse_change(ap: arrptr);		
		   var i, j: longint;
					 u: colm_ptr;
					 sp: sparseptr;
			 begin
					sp := ap^.spar;
					for i := 0 to (ap^.rows - 1) div sparsesize do {```}
						 begin
								for j := 1 + i*sparsesize to (i+1)*sparsesize do
									 if j > ap^.rows
											then break
											else begin
															u := sp^.indx[j-i*sparsesize];
															while u <> nil do
																 begin
																		change_quol(u^.val);
																		u := u^.next
																 end
													 end;
								sp := sp^.next
						 end
			 end;
							 
   {----------------------------------------------------------------------}
		
		procedure change_sparses;
		
      var i: integer;
			    ap: arrptr;

      begin
         for i := 0 to 150 do
            begin
						   ap := arr_store[i];
							 while ap <> nil do
                  begin
										 if ap^.spar <> nil
										    then sparse_change(ap);
										 ap := ap^.next
									end
						end;
				 if syst^.spar <> nil
				    then sparse_change(syst)
      end;

		 {------------------------------------------------------------------}		 
		
		 begin
		 
			  change_vars;
				change_arrays;
			  change_sparses
				
		 end;

  {****************************************************************************}
	
	procedure attach_poly(var inf: text; var flag: nameptr; not_imper: boolean);
	
	  var q: polypt;
		    cancel: boolean;
				depth: longint;
				one: quoly;
				i, j: integer;
		
    {_________________________________________________________________}
			 
		procedure update_num(var p: ferm118.poly);

       var q: ferm118.poly;		
		
		   begin			 
			    if not p^.numb or (p^.next <> nil)
					   then begin
						         q := p;
										 newpoly(p);
										 p^.numb := false;
										 p^.exp := 0;
										 p^.pcoef := q;
										 p^.next := nil										 
									end
			 end;
		
    {_________________________________________________________________}
			 
		procedure update_quoly(var p: quoly);
		
		   begin			 
			    if not p^.numb
					   then begin
						         update_num(p^.numer);
										 if p^.denom <> nil
										    then update_num(p^.denom)
									end
			 end;
			 
		{_________________________________________________________________}
		
		procedure update_vars;
		
      var p: varptr;
			    i: integer;

      begin
        for i:= 0 to 150 do
				   begin
					    p := sca_store[i];
              while p <> nil do
                 begin
					          update_quoly(p^.val);
                    p := p^.next
                 end
					 end
      end;
		  
		{_________________________________________________________________}
			 
		procedure update_arrays;	    

      var  i: longint;

      begin
        for i := 0 to endarr do
           if (arp[i shr 10]^[i and tenmask] <> nil) 
              then update_quoly(arp[i shr 10]^[i and tenmask]);
						
				if syst^.spar = nil
				   then for i := 0 to syst^.stop do
				           update_quoly(stash^[i])
      end;

		{_________________________________________________________________}
		
		procedure downdate_vars;
		
      var p: varptr;
			    i: integer;

      begin
        for i:= 0 to 150 do
				   begin
					    p := sca_store[i];
              while p <> nil do
                 begin
					          get_evalquoly(inf, p^.val, one, depth, flag, false);
										remove_poly_var(p^.val, depth);
                    p := p^.next
                 end
					 end
      end;
			 
		{_________________________________________________________________}
		
		procedure downdate_arrays;
		
      var i: longint;
			    qp: quolyptr;

      begin
        for i := 0 to endarr do
           begin
					    qp := @ arp[i shr 10]^[i and tenmask];
							if qp^ <> nil 
								 then begin
												 get_evalquoly(inf, qp^, one, depth, flag, false);
												 remove_poly_var(qp^, depth)
										  end
					 end;
								 
				if syst^.spar = nil
				   then for i := 0 to syst^.stop do
									 begin
											get_evalquoly(inf, stash^[i], one, depth, flag, false);
											remove_poly_var(stash^[i], depth)
									 end
      end;
			 
		{_______________________________________________________________________}
			    
    procedure sparse_update(ap: arrptr);		
		   var i, j: longint;
					 u: colm_ptr;
					 sp: sparseptr;
			 begin
					sp := ap^.spar;
					for i := 0 to (ap^.rows - 1) div sparsesize do {```}
						 begin
								for j := 1 + i*sparsesize to (i+1)*sparsesize do
									 if j > ap^.rows
											then break
											else begin
															u := sp^.indx[j-i*sparsesize];
															while u <> nil do
																 begin
																		update_quoly(u^.val);
																		u := u^.next
																 end
													 end;
								sp := sp^.next
						 end
			 end;
			 
    {_______________________________________________________________________}
			    
    procedure sparse_down(ap: arrptr);		
		   var i, j: longint;
					 u: colm_ptrptr;
					 sp: sparseptr;
			 begin
					sp := ap^.spar;
					for i := 0 to (ap^.rows - 1) div sparsesize do {```}
						 begin
								for j := 1 + i*sparsesize to (i+1)*sparsesize do
									 if j > ap^.rows
											then break
											else begin
															u := @ sp^.indx[j-i*sparsesize];
															while u^ <> nil do
																 begin
																		get_evalquoly(inf, u^^.val, one, depth, flag, false);
												            remove_poly_var(u^^.val, depth);
												            if (u^^.val = nil) or quoly_iszero(u^^.val)
													             then free_colm(u^)
													             else u := @ u^^.next
																 end
													 end;
								sp := sp^.next
						 end
			 end;
			 
   {________________________________________________________________________}
		
		procedure redo_sparses;
		  { Take care not to do a given sparse matrix twice }
      var i: integer;
			    ap: arrptr;
      begin
         for i := 0 to 150 do
            begin
						   ap := arr_store[i];
							 while ap <> nil do
                  begin
										 if ap^.spar <> nil
										    then ap^.spar^.notdone := true;
										 ap := ap^.next
									end
						end;
				 for i := 0 to 150 do
            begin
						   ap := arr_store[i];
							 while ap <> nil do
                  begin
										 if ap^.spar <> nil
										    then if ap^.spar^.notdone
												        then begin
																        if cancel
																					 then sparse_down(ap)
																					 else sparse_update(ap);
																				ap^.spar^.notdone := false
																		 end;
										 ap := ap^.next
									end
						end;
				 if syst^.spar <> nil
				    then if cancel
										then sparse_down(syst)
										else sparse_update(syst)
      end;

		{_________________________________________________________________}
	
	  begin
		
		   write(userOutput, ' Change of polynomial variable');
			 cancel := false;
			 if not_imper 
					then begin
					        writeln(userOutput, '.'); 
							    writeln(userOutput, ' Enter variable name:'); 
									do_prompts;
									readln(userInput);  { these added September 1996 }
									scanner(userInput, token, zilch);
									if token.name = '-'
									   then begin
										         cancel := true;
														 scanner(inf, token, flag)
													end;
									if (token.name[1] < 'a') or (token.name[1] > 'z')
									    then error(124, token)
							 end
           else begin
					         scanner(inf, token, flag);
									 if token.name = '-'
									   then begin
										         cancel := true;
														 scanner(inf, token, flag)
													end;
									 if (token.name[1] < 'a') or (token.name[1] > 'z')
									    then error(124, token);
									 write(userOutput, ': ');
									 if cancel then write(userOutput, 'cancel ');
									 writeln(userOutput, token.name, '.'); flush(userOutput);
								end;
									
			if cancel
			   then if not is_poly_name(token.name, depth)
				         then begin
								         error(169, token);
												 exit {(attach_poly)}
											end
								 else 
				 else if is_poly_name(token.name, depth)
			           then begin
				                 error(126, token);
								         exit {(attach_poly)}
							        end;
			if cancel
			   then begin
				         one := nil;
								 quoly_set(1, one);
								 one^.next := nil;  { flag for calls to get_evalquoly }
				         downdate_vars;
								 downdate_arrays;
								 redo_sparses;
								 delete_poly_name(depth);
								 
								 { delete from sorted array polyvar }
								 i := 1;
								 while polyvar[i] <> token.name do
								    i := i + 1;
								 for j := i to number_polys - 1 do
								    polyvar[j] := polyvar[j+1];
										
								 number_polys := number_polys - 1;
								 free_quoly(one);
								 reset_pseudo_poly;
								 writeln(userOutput, token.name, ' now cancelled.')
				      end
			   else begin
				         if number_polys = 100
								    then error(254, token);
				         new(q);
			           q^.next := polynames;
			           polynames := q;
								 q^.let := token;
								 q^.p := nil;
								 
								 { insert into sorted array polyvar }
								 i := 1;
								 while i <= number_polys do
								    begin
										   if token.name < polyvar[i]
										      then break;
										   i := i + 1
										end;
								 for j := number_polys downto i do
								    polyvar[j+1] := polyvar[j];
								 polyvar[i] := token.name;
								 number_polys := number_polys + 1;
								 
								 if pseudo_polynames <> nil
								    then pseudo_polynames := polynames;
			           if q^.next <> nil  { This is at least the second variable. Need to }
			              then begin      { update all polys that already exist. }
				                    update_vars;
								            update_arrays;
														redo_sparses
							           end;
												 
								 if need_to_set_char_poly
								    then begin
										        need_to_set_char_poly := false;
													{	for i := first_step + 1 to in_house_charpol - 1 do
															 for j := 1 to i + 1 do
																	get_char_poly(i, j, pol^[i,j])
																	
														base := nil;
														base_quoly(base, 1);
														p := nil;
														oldm1 := command_int;
														command_int := false;
														
														{ Set diag elements in pol. 
														diag := nil;
														quoly_set(1, diag);
														quoly_set(1, pol[0,1]);
														for j := 2 to limit_char_arrays do
														   begin
															    quoly_sub(base, denom[j-1], p);
																	quoly_mult(diag, p, diag);
																	quoly_quot(diag, prods[j], pol[j-1,j])
															 end;
														
														{ Do rest of entries in pol. 
														for i := 1 to limit_char_arrays do
														   for j := i to limit_char_arrays - 1 do
															    begin
																		 quoly_sub(base, denom[j+1], p);
																		 quoly_mult(p, pol[j-1,i], pol[j,i]);
																		 quoly_sub(denom[i], denom[j+1], p);
																		 quoly_quot(pol[j,i], p, pol[j,i])
																	end;
														
														command_int := oldm1;
														free_quoly(p);
														free_quoly(diag);
														free_quoly(base)  }
												 end

							end
			 			   
		end;
		
 {***************************************************************************}		   

	procedure sparse_adjoin(spar: sparseptr; r, c: longint; var n: quoly); 
	
	  { n is used up and nilled out. no checking here for index out of bounds. }
	
	   var t: colm_ptrptr;
		     i: longint;
				 sp: sparseptr;

	   procedure attach;
		    var s: colm_ptr;
				begin
				   s := t^;
					 newcolm(t^);
					 t^^.next := s;
					 t^^.coord := c;
					 t^^.val := n;
				end;
		 
		 begin
	  
	      if quoly_iszero(n)
				   then begin
					         free_quoly(n);
									 exit {(sparse_adjoin)}
								end;
				r := r - addresser + 1;
				c := c - addresser + 1;
				sp := spar;  {```}
			  for i := 1 to (r - 1) div sparsesize do
					 sp := sp^.next;
			  t := @ sp^.indx[1 + (r - 1) mod sparsesize];
			  while t^ <> nil do
					 if t^^.coord < c
						  then t := @ t^^.next
						  else break;
				if t^ = nil
				   then attach
					 else if c = t^^.coord
					         then begin
									         best_quoly_add(t^^.val, n);
													 if quoly_iszero(t^^.val)
													    then free_colm(t^)
												end
									 else attach;
				n := nil
						 
		 end;
 
 {****************************************************************************}
 
	procedure sparse_read; {(var inf: text; var n: quoly; var flag: nameptr; arr_facts:
	                         arr_descr; var arr_free: boolean; var spar: sparseptr)}
		
     var rows, cols, r, c, j: longint;
		     sp: sparseptr;
				 		 
		 begin
		 
		    rows := arr_facts[2];  { already known to be valid size }
				cols := arr_facts[1] div rows;
				
				newsparse(spar);
				sp := spar;  {```}
				for c := 2 to 1 + (rows - 1) div sparsesize do
				   begin
					    for j := 1 to sparsesize do
				         sp^.indx[j] := nil;
							newsparse(sp^.next);
							sp := sp^.next
					 end;
				for j := 1 to 1 + (rows - 1) mod sparsesize do
				   sp^.indx[j] := nil;	 { leave sp here }
				
				repeat
				   scanner(inf, token, flag);
					 old_expre(inf, n, flag);
					 if token.name <> ','
					    then error(202, token);
					 if not n^.numb
						  then begin
										  free_quoly(n);
											sp^.next := spargarb;  {```}
			                spargarb:= spar;
										  error(310, token)
									 end;
					 r := convert_to_int(n^.ncoef^);
					 if (r < addresser) or (r > rows)
					    then error(27, token);
					 while token.name = ',' do
					    begin
							   scanner(inf, token, flag);
								 if token.name <> '['
										then error(301, token);
								 scanner(inf, token, flag);
								 old_expre(inf, n, flag);
								 if token.name <> ','
										then error(202, token);
								 if not n^.numb
										then begin
														free_quoly(n);
														sp^.next := spargarb;  {```}
														spargarb:= spar;
														error(310, token)
												 end;
					       c := convert_to_int(n^.ncoef^);
								 if (c < addresser) or (c > cols)
					          then error(27, token);
					       scanner(inf, token, flag);
								 old_expre(inf, n, flag);
								 if token.name <> ']'
										then error(297, token);
					       scanner(inf, token, flag);
					       sparse_adjoin(spar, r, c, n)
							end;
					 if token.name <> ']'
							then error(297, token);
				   scanner(inf, token, flag)
				until token.name <> '[';
				
				if token.name <> ']'
				   then error(297, token);
				scanner(inf, token, flag);
				arr_free := true;
				quoly_set(0, n)
		 
		 end;

 {*****************************************************************************}
 
  procedure add_sparses;{(var spar, spar2: sparseptr; arr_free, arr2_free: boolean; 
	                      row: longint; plus: boolean)}
	
	   { add and put answer back in spar. spar2 is not changed, though its storage may 
		   be freed.  Trickier than first appears!  Don't forget the minus signs! }
		 
		 var i, k: longint;
		     sum, sp, sp2, sp3: sparseptr;
				 u: colm_ptrptr;
				 s, t: colm_ptr;
				 n: quoly;
		 
		 {-----------------------------------------------------------------------}
		 
		 procedure attach;
		    begin
				   newcolm(u^);
					 u^^.coord := s^.coord;
					 u^^.val := n;
					 u := @ u^^.next
				end;
				
		 {------------------------------------------------------------------------}
		 
		 procedure append(var s: colm_ptr; positive: boolean);
		    begin
				   newcolm(u^);
					 u^^.coord := s^.coord;
					 u^^.val := nil;
					 if positive
					    then quoly_assign(s^.val, u^^.val)
							else quoly_makeneg(s^.val, u^^.val);
					 s := s^.next;
					 u := @ u^^.next
				end;
				
		 {-----------------------------------------------------------------------}
		 
		 procedure restof(s: colm_ptr; positive: boolean);
		    begin
				   while s <> nil do
					    append(s, positive)
				end;
				
		 {-----------------------------------------------------------------------}
		 
		 procedure add_onto(spar, spar2: sparseptr; switch: boolean);
		    var i, k: longint;
				    uflag, tflag: boolean;
				begin
					 uflag := switch and not plus;  { need to negate the u^ stuff }
					 tflag := plus or switch;       { take t^ stuff as is }
					 sp := spar;
					 sp2 := spar2;
					 for k := 0 to (row - 1) div sparsesize do  {```}
							begin
								 for i := 1 + k*sparsesize to (k+1)*sparsesize do
										if i > row 
											 then break
										else begin
														t := sp2^.indx[i-k*sparsesize];
														u := @ sp^.indx[i-k*sparsesize];
														while (u^ <> nil) and (t <> nil) do
															 begin
																	if u^^.coord < t^.coord
																		 then begin
																						 if uflag
																								then quoly_inplace(u^^.val);
																						 u := @ u^^.next
																					end
																	else if t^.coord < u^^.coord
																		 then begin
																						 s := u^;
																						 append(t, tflag);
																						 u^ := s
																					end
																	else begin
																					if plus
																						 then better_quoly_add(u^^.val, t^.val, u^^.val)
																						 else if switch
																										 then quoly_sub(t^.val, u^^.val, u^^.val)
																										 else better_quoly_sub(u^^.val, t^.val, u^^.val);
																					if quoly_iszero(u^^.val)
																						 then free_colm(u^)
																						 else u := @ u^^.next;
																					t := t^.next
																			 end
															 end;
														if t <> nil
															 then begin
																			 restof(t, tflag);  { changes u }
																			 u^ := nil
																		end
															 else if uflag and (u^ <> nil)
																			 then repeat
																							 quoly_inplace(u^^.val);
																							 u := @ u^^.next
																						until u^ = nil
													end;
													
								 sp := sp^.next;
								 sp2 := sp2^.next
							end
							
				 end;
				 
		 {-----------------------------------------------------------------------}
		 
		 begin
		 
		    if arr_free and arr2_free
				   then begin
					         sp := spar;
									 sp2 := spar2;
									 for k := 0 to (row - 1) div sparsesize do  {```}
											begin
												 for i := 1 + k*sparsesize to (k+1)*sparsesize do
														if i > row 
															 then break
														else begin
																		t := sp2^.indx[i-k*sparsesize];
																		u := @ sp^.indx[i-k*sparsesize];
																		while (u^ <> nil) and (t <> nil) do
																			 begin
																					if u^^.coord < t^.coord
																						 then u := @ u^^.next
																					else if t^.coord < u^^.coord
																						 then begin
																										 if not plus
																												then quoly_inplace(t^.val); 
																										 s := u^;
																										 u^ := t;
																										 t := t^.next;
																										 u^^.next := s;
																										 u := @ u^^.next
																									end
																					else begin
																									if plus
																										 then better_quoly_add(u^^.val, t^.val, u^^.val)
																										 else better_quoly_sub(u^^.val, t^.val, u^^.val);
																									if quoly_iszero(u^^.val)
																										 then free_colm(u^)
																										 else u := @ u^^.next;
																									free_colm(t)
																							 end
																			 end;
																		if t <> nil
																			 then begin
																							 u^ := t;
																							 if not plus
																									then repeat
																													quoly_inplace(t^.val);
																													t := t^.next
																											 until t = nil
																						end
																	end;
																	
												 sum := sp2^.next;
												 sp2^.next := spargarb;
									       spargarb := sp2;
												 sp2 := sum;
												 sp := sp^.next
											end				
									 
								end
				else if arr_free
				   then add_onto(spar, spar2, false)
				else if arr2_free
				   then begin
					         add_onto(spar2, spar, true);
									 spar := spar2
								end
				else begin
				        sp := spar;
								sp2 := spar2;
								for k := 0 to (row - 1) div sparsesize do  {```}
										begin
											 if k = 0
													then begin
																	newsparse(sum);
																	sp3 := sum
															 end
													else begin
																	newsparse(sp3^.next);
																	sp3 := sp3^.next
															 end;
									     for i := 1 + k*sparsesize to (k+1)*sparsesize do
													if i > row 
														 then break
													else begin
																	s := sp^.indx[i-k*sparsesize];
																	t := sp2^.indx[i-k*sparsesize];
																	u := @ sp3^.indx[i-k*sparsesize];
																	while (s <> nil) and (t <> nil) do
																		 begin
																				if s^.coord < t^.coord
																					 then append(s, true)
																				else if t^.coord < s^.coord
																					 then append(t, plus)
																				else begin
																								n := nil;
																								if plus
																									 then quoly_add(s^.val, t^.val, n)
																									 else quoly_sub(s^.val, t^.val, n);
																								if quoly_iszero(n)
																									 then free_quoly(n)
																									 else attach;
																								s := s^.next;
																								t := t^.next
																						 end
																		 end;
																	if s <> nil
																		 then restof(s, true)
																		 else if t <> nil
																						 then restof(t, plus);
																	u^ := nil
															 end;
															 
											 sp := sp^.next;
											 sp2 := sp2^.next
										end;
											
						    spar := sum
						 end
						 
		 end; 
 
	{*****************************************************************************}		
			
	procedure sparse_trace(var n: quoly; spar: sparseptr; rows: longint);
	
		 var i, k: longint;
				 u: colm_ptr;
				 sp: sparseptr;
				 
		 begin
			  quoly_set(0, n);
				sp := spar;
			  for k := 0 to (rows - 1) div sparsesize do  {```}
					 begin
						  for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > rows 
									  then break
								 else begin
												u := sp^.indx[i-k*sparsesize];
												while u <> nil do
													 if u^.coord > i
															then break
															else if u^.coord = i
																			then begin
																							better_quoly_add(n, u^.val, n);
																							break
																					 end
																			else u := u^.next
										 end;
					    sp := sp^.next
					 end
		 end;
		 
	{****************************************************************************}
	
	procedure total_poly_modout; { (var p: ferm118.poly) }
	
	   var q: polypt;
		     depth: longint;
	
	   begin
		 
		    q := polynames;
				depth := 1;
				while q <> nil do
				   begin
					    if q^.p <> nil 
							   then mod_out_poly(p, q^.p, depth, q^.expon);
							depth := depth + 1;
							q := q^.next
					 end							   								
				
		 end;
		 
  {***************************************************************************}
	
	procedure compute_char_poly; {(n, i: longint; var q: quoly)}
	
	   { LaGrange interpolation. q is initialized upon entry. n = number of data points.}
		 
		 var base, numer: quoly;
		     oldm1: boolean;
				 denom: longreal;
		 
		 procedure do_the_loop(start, stop: integer);
		    var j: integer;
				begin
				   for j := start to stop do
							begin
								 denom := denom * (cc[i] - cc[j]);
								 quoly_set_ext(cc[j], numer);
								 quoly_sub(base, numer, numer);
								 quoly_mult(q, numer, q)
							end
				end;
		 
		 begin
		 
		    oldm1 := command_int;
				command_int := false;
				base := nil;
				numer := nil;
				base_quoly(base, 1);
				base_quoly(q, 1);
					 
			  if i = 1
				   then begin
					         denom := cc[1] - cc[2];
									 quoly_set_ext(cc[2], numer);
									 better_quoly_sub(q, numer, q);
									 do_the_loop(3, n)
					      end
					 else begin
					         denom := cc[i] - cc[1];
									 quoly_set_ext(cc[1], numer);
									 better_quoly_sub(q, numer, q);
									 do_the_loop(2, i-1);
									 do_the_loop(i+1, n)
								end;
												
				quoly_set_ext(denom, base);
			  quoly_quot(q, base, q);
			  free_quoly(base);
				free_quoly(numer);
				command_int := oldm1
		 		 
		 end;
	
  {****************************************************************************}		   

 procedure arrinsert(x: tokentipe; qp: quolyptr; r, c: longint; q: arrptr; var n: quoly;
                      colflag: boolean);   { added colflag, Dec 1997 }

    var cols: longint;           {spar}
        oldtt: boolean;

    begin

      cols := q^.size div q^.rows;   {@@@ all new for sioux}
			if levelcount > 1
         then write(userOutput, levelcount: 1);
      if (promptsize > 0) or (prompt[1] = chr(13))
         then write(userOutput, prompt);
      if (cols > 1) and colflag
         then write(userOutput, x.name, '[', r: 2, ',', c: 2, '] := ')  { Nov 1997 }
         else write(userOutput, x.name, '[', r: 2, '] := ');   { Nov 1997 }
		  oldtt := tt_flag;  {@@@}
		  tt_flag := true;
		  leftover := '';
			readln(userInput);
			scanner(userInput, token, zilch);	
			if token.name = '@'
			   then exit {(arrinsert)};
		  old_expre(userInput, n, zilch);
      quoly_assign(n, qp^);
      tt_flag := oldtt
 			
    end;

  {**************************************************************************}

  procedure whole_arrinsert(var inf: text; x: tokentipe; var flag: nameptr; var n: quoly;
	                          var stash: tokentipe; var saveleft: shortstring);

    var q: arrptr;
		    qp: quolyptr;
        rows, cols, i, j, locat, firstrow, firstcol, total_rows, spot: longint;

    begin
		
		  if x.name = ''
			   then error(176, x);
			locat := fasterlookup(x, q, inf, flag);   {spar; whole procedure }
			if locat = -1
				 then error(28, token);
			if q^.spar <> nil
			   then error(289, token);
      scanner(inf, token, flag);
			if token.name = '['
			   then subarray(inf, q, i, rows, cols, firstrow, firstcol, total_rows, flag)
			   else begin
				         if (token.name <> ']') 
                    then error(24, token);
				         cols := q^.size div q^.rows;
								 rows := q^.rows;
								 total_rows := rows;
								 firstrow := addresser;  firstcol := addresser
							end;
      if (token.name <> ']') and (token.name <> '') and (token.name <> ';')
         then error(107, token);
      if token.name = ']' 
			   then scanner(inf, token, flag);
			stash := token;
			saveleft := leftover;
			locat := locat - addresser - total_rows * addresser;
      for i := firstrow to rows + firstrow - 1 do
         for j := firstcol to cols + firstcol - 1 do
            begin
						   spot := locat + i + total_rows * j;
							 qp := @ arp[spot shr 10]^[spot and tenmask];
							 arrinsert(x, qp, i, j, q, n, true);
							 if token.name = '@'
							    then exit {(whole_arrinsert)}
						end
			
    end;

	{****************************************************************************}

  procedure fill_syst_array(var arr: workarray; arr_facts: arr_descr; arr_free: boolean; 
											      spar: sparseptr; r: longint);
  
     { Nov 1997. if spar <> nil, arr is never mentioned.  }
     
     var i: longint;
     
     begin
        
        if syst^.spar <> nil
					 then free_sparse(syst^.spar, syst^.rows, true)
					 else for i := 0 to syst^.stop do
									 free_quoly(stash^[i]);	
		    syst^.rows := r;													 
			  if spar <> nil
					 then if arr_free
									 then syst^.spar := spar
									 else copy_sparse(spar, syst^.spar, r, false)
					 else if arr_free
									 then for i := 0 to arr_facts[1] - 1 do
													 stash^[i] := arr[i]
									 else for i := 0 to arr_facts[1] - 1 do
													 quoly_assign(arr[i], stash^[i]);
			  syst^.stop := arr_facts[1] - 1;
			  syst^.size := arr_facts[1];
			  syst_dump := true
     
     end;
     
  {****************************************************************************}   
     
  procedure fillit(rows, cols: longint; q: arrptr; var arr: workarray);  { Nov 1997 }
     { does not create new storage; rather, pointers in arr point to
       existing storage. }
     var i, j, k: longint;
     begin
				 j := 0;
				 for i := 0 to cols - 1 do
						for k := 0 to rows - 1 do
							 begin
									check_and_assign(q^.start + k + i * rows, arr[j]);   
									Inc(j)
							 end
     end;

  {************************************************************************}

  procedure arr_asstat(var inf: text; var n: quoly; var arr: workarray; 
	                     var arr_facts: arr_descr; var arr_free: boolean; 
											 var flag: nameptr; var spar: sparseptr);
											 
		{ The source is determinded by a call to arr_expre, which fills the parameter
		  arr (unless the source is a scalar).   If arr_free, this stuff is then transfered directly 
			to the permanaent storage area.  If not, duplicate the storage via poly_assign.
			Therefore, do not free arr in either case.  arr_free is not reset at the end
			because nobody cares. 
			
			  Nov 1997: changed for new grammar; will revert to arr_expre if it in fact is
			not an assignment statement.  }

	  var rows, cols, start, total_rows, firstrow, firstcol, target_rows: longint;
        q: arrptr;
        oldtok: tokentipe;
        i, j, k, locat: longint;
				diagonal: boolean;

		
		{-------------------------------------------------------------------------}
		
		function nomatch: boolean;
		   { allow linear target and source (a big pain) except for sparses. }
		   var linear1, linear2: boolean;
		   begin			    
					if arr_facts[1] <> cols*target_rows { = 0 if q is nil }
					   then nomatch := true
						 else if target_rows = arr_facts[2]
										 then nomatch := false
						         else begin
										         linear1 := (arr_facts[1] = arr_facts[2]) or (arr_facts[2] = 1);
										         linear2 := (cols = 1) or (target_rows = 1);
														 if linear1 and linear2
														    then rows := target_rows;
										         nomatch := not (linear1 and linear2)
									        end			 
			 end;
			 
		{---------------------------------------------------------------------}
		
		procedure finishdiag;
		
		  var newone: boolean;
			    i: longint;

      {_______________________________________________________}
			
			procedure fillnewone;
			
			   var i,k: longint;
				     qp: quolyptr;
			
			   begin				    
						 j := 0;
				     for i := 0 to rows - 1 do
							  for k := 0 to rows - 1 do
                   begin
									    locat := start + k + i*rows;
											qp := @ arp[locat shr 10]^[locat and tenmask];
                      if i <> k
											   then quoly_set(0, qp^)
										  else begin
											        if arr_free
											           then qp^ := arr[j]
															   else quoly_assign(arr[j], qp^ );
                              j := j + 1
                           end
									 end									 
					end;
					
      {______________________________________________________________}
		
		  begin  {of finishdiag }
			 
			 if q <> nil
          then if q^.spar <> nil
					     then error(289, diag_sign);  { Sept 1996; here Dec 1997 }
			 if q <> nil
        then
          if arr_facts[1] = 0  { it's a scalar; put into each spot in target array }
            then
              for i := 0 to rows - 1 do
                  begin
									    locat := start + i + i*total_rows;
                      quoly_assign(n, arp[locat shr 10]^[locat and tenmask])
                  end
            else  { source is not a scalar }
              begin
                if (rows <> q^.rows)  { create new array of name oldtok; }
								   and (target_rows = 0)     { couldn't have been subarray. }
                   then begin
													 insertarr(oldtok, rows, rows);
													 if oldtok.address = -1
															then i := hash(oldtok.name, 151)
															else i := oldtok.address;
													 q := arr_store[i];
													 start := q^.start;
													 newone := true
												end
									 else newone := false;
								if start = -1  { still!  This is the usual case. }
								   then start := q^.start;
                if newone
								   then fillnewone
								else for i := 0 to rows - 1 do  { fill old one }
                    begin
										   locat := start + i + i*total_rows;
											 if arr_free
											    then begin
													        free_quoly(arp[locat shr 10]^[locat and tenmask]);
                                  arp[locat shr 10]^[locat and tenmask]
																	    := arr[i]
															 end
													else quoly_assign(arr[i], arp[locat shr 10]^[locat and tenmask] );
                    end
              end
        else { q is nil } if arr_facts[1] = 0 { scalar has been computed; create 1 by 1 }
          then begin
									insertarr(oldtok, 1, 1);
									if oldtok.address = -1
										 then i := hash(oldtok.name, 151)
										 else i := oldtok.address;
									q := arr_store[i];
									i := q^.start;
									quoly_assign(n, arp[i shr 10]^[i and tenmask])
							 end
        else { q is nil, array has been computed; cannot be subarray. 
					       make new oldtok }
            begin
              insertarr(oldtok, rows, rows);
							if oldtok.address = -1
								 then i := hash(oldtok.name, 151)
								 else i := oldtok.address;
              q := arr_store[i];
							start := q^.start;
							fillnewone
            end
						
			 end;
			 
		{----------------------------------------------------------------}

    begin
		
		{ rows and cols are numbers, not coordinates }
		
		  if token.name = ''
			   then begin
				         scanner(inf, token, flag);
								 if token.name <> '[' then error(92, token);
								 diagonal := true
							end
				 else diagonal := false;
				 
      left_side(inf, q, rows, cols, start, total_rows, firstrow, firstcol, target_rows,
			          oldtok, flag, true);  { Nov 1997 }
      
			if start = -1
			   then if q <> nil
				         then arr_facts[1] := q^.size { sparse_read and random need this. }
								 else
				 else begin
				         arr_facts[1] := cols*target_rows;
								 rows := target_rows  { For calls to arr_expre. Later, only [1] and []
								                        need this. }
							end;
							
      if token.name <> ':'  { Nov 1997.  This isn't an assignment. }
         then begin
                 if q = nil
                    then error(28, token);
                 if q = syst
                    then arr_free := true  { Nov 1997 }
                    else arr_free := false;   { <- Note! }
                 spar := q^.spar;
                 arr_facts[2] := rows;
                 if arr_free   { Nov 1997 }
                    then copy_syst(arr, rows, spar)
                    else if spar = nil
                            then fillit(rows, cols, q, arr);
                 if diagonal
                    then extract_diagonal(arr, arr, arr_facts, false, rows, spar);
                            { will reset rows & arr_facts and set spar = nil }
                 { finish by calling arr_expre with last argument false }
                 arr_expre(inf, n, arr, arr_facts, arr_free, rows, flag, spar, false);
                 fill_syst_array(arr, arr_facts, arr_free, spar, rows);
                 quoly_set(0, n);  
                 exit {(arr_asstat)}
              end
         else if q = syst
                 then error(176, token);  { Nov 1997 }
								 
			scanner(inf, token, flag);
			if token.name <> '='
        then error(4, token);
      scanner(inf, token, flag);
			
			if q <> nil
			   then if q^.spar <> nil
				         then want_sparse := true;
      arr_expre(inf, n, arr, arr_facts, arr_free, rows, flag, spar, true);
			want_sparse := false;
	 
			if diagonal and (spar <> nil)
			   then error(289, diag_sign);
			if (spar <> nil) and (start <> -1)
			   then error(291, token);
			if diagonal then rows := arr_facts[1];
			
			{ If subarray, then target and source dimensions must match, unless source is just a
			  scalar. }
				
			if not diagonal
			   then if (start <> -1) and (arr_facts[1] <> 0) 
			            and nomatch
			           then error(60, oldtok)
								 else 
				 else if (start <> -1) and (arr_facts[1] <> 0) 
			            and ( target_rows <> arr_facts[1] )
								 then error(93, oldtok);
								
			{ Figure out where the source stuff goes in the target.  This depends on three things:
			  subarray or not; q = nil or not; source is scalar or not. }
			if start = -1 { not subarray }
			   then if arr_facts[1] <> 0  { it is not a scalar }
			           then cols := arr_facts[1] div rows { rows is correct; probably can't compute start yet }
			           else if q = nil 
												 then 
																	{ will later create 1 by 1 to hold scalar; nothing to do now }
																
												 else begin   { scalar being assigned to existing array }
																 rows := q^.rows;  { use q's data ```}
																 start := q^.start;  { might be 0 if q sparse }
																 total_rows := rows;
																 cols := q^.size div rows
														  end;
			if start = -1   { not a subarray; if haven't set total_rows yet, set it here. }
			   then total_rows := rows;
				 
      j := 0;  { index for arr, below}

      if diagonal
			   then finishdiag
			else if q <> nil
        then
          if arr_facts[1] = 0  { it's a scalar; put into each spot in target array }
            then if q^.spar = nil
						        then for i := 0 to cols - 1 do
														for k := 0 to rows - 1 do
															 begin
																	locat := start + k + i*total_rows;
																	quoly_assign(n, arp[locat shr 10]^[locat and tenmask])
															 end
									  else sparse_set_scalar(q, cols, n)  {```}
            else  { not a scalar }
              begin
                if spar <> nil  { can't be subarray }
								   then begin
									         if (arr_facts[1] <> q^.size) or (rows <> q^.rows) 
								              then begin
													            sparse_create(oldtok, rows, cols);  { no main storage assigned }
																		  if oldtok.address = -1
																				 then oldtok.address := hash(oldtok.name, 151);
																		  q := arr_store[oldtok.address]
												           end
															else if q^.spar = nil  { zapp the main storage }
																		  then for k := q^.start to q^.stop do
																						  free_quoly(arp[k shr 10]^[k and tenmask])
																		  else free_sparse(q^.spar, rows, true);
												   if arr_free
													    then q^.spar := spar
															else copy_sparse(spar, q^.spar, rows, false);
													 quoly_set(0, n);
													 exit {(arr_asstat)}
												end;
												
								if (arr_facts[1] <> q^.size)  { create new array of name oldtok; }
								    and (target_rows = 0)     { couldn't have been subarray. }
                   then begin
													 insertarr(oldtok, rows, cols);
													 if oldtok.address = -1
														  then oldtok.address := hash(oldtok.name, 151);
													 q := arr_store[oldtok.address];
													 start := q^.start;
												end;
								if start = -1  { still!  This is the usual case. }
								   then start := q^.start;
								if q^.spar <> nil
								   then error(295, oldtok);
                for i := 0 to cols - 1 do
								   for k := 0 to rows - 1 do
											begin
												 locat := start + k + i*total_rows;
												 if arr_free
														then begin
																		free_quoly(arp[locat shr 10]^[locat and tenmask]);
																		arp[locat shr 10]^[locat and tenmask] :=  arr[j]
																 end
														else quoly_assign(arr[j], arp[locat shr 10]^[locat and tenmask] );
												 j := j + 1
											end
              end
        else { q is nil } if arr_facts[1] = 0 { scalar has been computed; create 1 by 1 }
            then begin
										insertarr(oldtok, 1, 1);
										if oldtok.address = -1
											 then oldtok.address := hash(oldtok.name, 151);
										q := arr_store[oldtok.address];
										i := q^.start;
										quoly_assign(n, arp[i shr 10]^[i and tenmask])
								 end
        else { q is nil, array has been computed; cannot be subarray. make new oldtok }
            begin
              if spar = nil
							   then insertarr(oldtok, rows, cols)
								 else sparse_create(oldtok, rows, cols);
							if oldtok.address = -1
				         then oldtok.address := hash(oldtok.name, 151);
              q := arr_store[oldtok.address];
							
							if spar = nil
							   then for i := q^.start to q^.stop do
												 begin
													  if arr_free
															 then arp[i shr 10]^[i and tenmask] := arr[j]
															 else quoly_assign(arr[j], arp[i shr 10]^[i and tenmask] );
													  j := j + 1
												 end
								 else if arr_free
												 then q^.spar := spar
												 else copy_sparse(spar, q^.spar, rows, false)
            end;

      quoly_set(0, n)
			
    end;

  {*************************************************************************}

  procedure listvars;

    var q: arrptr;
		    i: integer;

    begin
      dump(userOutput, true, true);
      writeln(userOutput);
      writeln(userOutput, 'arrays:');
      writeln(userOutput);
      for i := 0 to 150 do
			   begin
				    q := arr_store[i];
            while q <> nil do
               begin
                  arrdescribe(userOutput, q);  {@@@}
                  q := q^.next;
               end
				 end
    end;

	{******************************************************************************}

  procedure invert_sparse; {(var spar: sparseptr; var arr: workarray; ar_free,
	                           invert: boolean; rows: longint; var n: quoly)}
														  
		 { Leverrier-Fadeev algorithm. See manual. arr is touched only if the inverse
		   turns out to be not sparse. arr must exist, but it must not have any valid
			 quolies in it (all nil or irrelevant). If not invert (only determinant)
			 return answer in n, which is irrelevant upon entry. 
			     If invert, spar becomes the inverse, unless the inverse is not sparse
			 (which is discovered during the loop below), and then the inverse is in arr
			 and spar is nil.
			     The original storage spar^ is freed at end if ar_free.
					 If not invert, spar is definitely nil at end.  If invert, spar might be
			 nil and arr have the answer, or spar might have the answer.
			     IN ALL CASES spar will be changed!  Beware!  No matter what ar_free is, don't 
			 pass it something like q^.spar! }
		 
		 var i, j, k, cutoff, spot: longint;
		     spar2, copy, sp: sparseptr;
				 m, p: quoly;
				 arrf: arr_descr;
				 arr3, arpt: workptr;
				 possible: boolean;
				 t: colm_ptr;
		 		 		 
		 begin
		 
				m := nil;
				sparse_trace(m, spar, rows);
				if rows = 1
				   then if invert
					         then begin
					                 if quoly_iszero(m)
									            then error(44, token);
									         quoly_reciprocal(m);	
					                 if ar_free
													    then begin
															        quoly_assign(m, spar^.indx[1]^.val);
																			free_quoly(m)
																	 end
															else begin
															        newsparse(spar2);
																			newcolm(spar2^.indx[1]);
																			t := spar2^.indx[1];
																			t^.val := m;
																			t^.next := nil;
																			t^.coord := 1;
																			spar := spar2
																	 end;
													 exit {(invert_sparse)}
					              end
									 else begin
									         if ar_free
				                      then free_sparse(spar, rows, true)
															else spar := nil; {~~~~``}
													 free_quoly(n);
													 n := m;
													 exit {(invert_sparse)}
					              end;
												
				quoly_inplace(m);
				copy_sparse(spar, spar2, rows, false);
				copy := spar;
				arrf[2] := rows;
				arrf[1] := sqr(rows);
				possible := (arrf[1] <= arr_limit); {```}
				
				p := nil;
				cutoff := rows; { heuristic for changing format to ordinary array, if possible
				                  and desirable. }
				for i := 2 to rows do
				   begin
					    add_to_diag(m, spar2, rows);
							spar := copy;
							{ set spar = spar * spar2 }
							mult_sparses(spar, spar2, arrf, rows, rows, false);
							if i < rows
							   then begin
								         free_sparse(spar2, rows, true);
							           spar2 := spar
											end;
							sparse_trace(m, spar, rows);
							quoly_set(i, p);
							quoly_quot(m, p, m);
							if i = rows
							   then break;
							quoly_inplace(m);
							
							if possible {```}
							   then begin
								         { find number of nonzero entries in spar2 }
												spot := 0;
												sp := spar2;
												for k := 0 to (rows - 1) div sparsesize do  {```}
													 begin
															for j := 1 + k*sparsesize to (k+1)*sparsesize do
																 if j > rows 
																		then break
																 else begin
																				 t := sp^.indx[j-k*sparsesize];
																				 while t <> nil do
																						begin
																							 spot := spot + 1;
																							 t := t^.next
																						end
																			end;
															sp := sp^.next
													 end;
												if spot > arrf[1] div 2
													 then begin
																	 cutoff := i;
																	 break
																end
											end
					 end;
					 
				if cutoff < rows  { spar2 is no longer sparse; change format. }
				   then begin
					         new_worknode(i, token);																		 
			             arr3 := workhead[i];
					         { fill arr with data from spar2. }
									 sp := spar2;
									 for k := 0 to (rows - 1) div sparsesize do  {```}
										  begin
												 for i := 1 + k*sparsesize to (k+1)*sparsesize do
													 if i > rows 
															then break
													 else begin
																	 t := sp^.indx[i-k*sparsesize];
																	 for j := 1 to rows do
																			begin
																				 spot := i - 1 + (j - 1)*rows;
																				 arr[spot]:= nil;  {~~~~`` kill oar_free}
																				 if t = nil
																						then quoly_set(0, arr[spot])
																						else if j = t^.coord
																										then begin
																														arr[spot] := t^.val;
																														t^.val := nil;
																														t := t^.next
																												 end
																										else quoly_set(0, arr[spot])
																			end
																end;
												 sp := sp^.next
											end;
									 
									 { finish the computation }
									 arpt := @ arr;
									 for i := cutoff + 1 to rows do
									    begin
											   { add m to diagonal }
												 for j := 1 to rows do
											      begin
														   spot := (j - 1)*(rows + 1);
														   better_quoly_add(arr[spot], m, arr[spot])
														end;
											   { arr3 := original * arr }
												 mult_sparse_norm(copy, arpt, arr3, false, rows, rows, rows, arrf);
											   
												 { compute new m, -(trace of arr3^)/i }
												 quoly_set(0, m);
												 for j := 1 to rows do
											      begin
														   spot := (j - 1)*(rows + 1);
														   better_quoly_add(m, arr3^[spot], m)
														end;
											   quoly_set(i, p);
												 quoly_quot(m, p, m);
												 
												 { move answer to arr }
												 if i < rows
												    then begin
														        quoly_inplace(m);
												            for j := 0 to arrf[1] - 1 do
																			 begin
																				  free_quoly(arr[j]);
																				  arr[j] := arr3^[j]
																			 end
																 end
											end;
											
									 if not invert
									    then free_arr(arr, arrf);
									 arrf[1] := rows*rows;
									 free_arr(arr3^, arrf);
									 free_work
					      
								end;
				
		    free_quoly(p);
				
				if cutoff < rows          { spar = spar2 }
					 then spar2 := nil;     { assign spar correctly below }
				if invert
				   then begin
					         if quoly_iszero(m)
									    then error(44, token);
									 quoly_reciprocal(m);	
									 if cutoff < rows
									    then for j := 0 to sqr(rows) - 1 do
															quoly_mult(arr[j], m, arr[j])
											else mult_cons_sparse(spar2, m, true, rows);
									 free_quoly(m)
					      end
					 else begin
					         if cutoff = rows
									    then free_sparse(spar2, rows, true);
									 free_quoly(n);
									 n := m;
									 if rows mod 2 = 0
									    then quoly_inplace(n)
								end;
								
				if ar_free
				   then free_sparse(copy, rows, true);
				free_sparse(spar, rows, true);
				spar := spar2
		 
		 end;
											 
  {****************************************************************************}
	
  procedure adjoint;{(var alpha, arr: workarray; alpha_free: boolean; m: longint;
	                    var spar: sparseptr) }
											
	   { arr is assumed uninitialized on entry, so obviously alpha <> arr. spar is nil. 
		   We have two basic methods -- inversion followed by multiplication by the det,
			 and the classic definition method. The inversion method may be forced to call 
			 the classic if det turns out to be 0. }
		 
		 var det: quoly;
		     allnumbs, allpolys: boolean;
		 
		 {_________________________________________________________________________}
		 
		 procedure set_params;
		    var i: longint;
	      begin			 
			    allnumbs := true;
					allpolys := true; 				
					for i := 0 to sqr(m) - 1 do
						 if not alpha[i]^.numb 
								then begin
												allnumbs := false;
												if alpha[i]^.denom <> nil
												   then begin
													         allpolys := false;   
																	 break
																end													 													 													 
										 end
			  end;
			
		 {__________________________________________________________________________}
		 
		 procedure classic_method;
		    var i, j, s, k, t: longint;
				    beta: workptr;
				begin
					 new_worknode(i, token);																		 
					 beta := workhead[i];
					 for i := 0 to sqr(m) - 1 do
							begin
								 beta^[i] := nil;
								 quoly_assign(alpha[i], beta^[i])
							end;
					 { Classic adjoint construction. }
					 for i := 0 to m-1 do
							begin
								 s := i - 1;
								 { Replace previous row, all but last spot; we'll get it later. }
								 if i > 0
										then for j := 0 to m-2 do
														begin
															 quoly_assign(alpha[s], beta^[s]);
															 s := s + m
														end;
								 { Zero out this row. }
								 s := i + m;
								 for j := 1 to m-1 do
										begin
											 quoly_set(0, beta^[s]);
											 s := s + m
										end;
								 { Put 1 in spot (i,j), then zero out, then compute det. }
								 s := i;
								 for j := 0 to m-1 do
										begin
											 t := j*m;
											 { Restore previous column. Tricky if j = 0. }
											 if (i > 0) or (j > 0)
													then if j > 0
																	then begin
																					quoly_set(0, beta^[s-m]);
																					for k := t - m to t - m + i - 1 do
																						 quoly_assign(alpha[k], beta^[k]);
																					for k := t - m + i + 1 to t - 1 do
																						 quoly_assign(alpha[k], beta^[k])
																			 end
																	else begin
																					for k := sqr(m)-m to sqr(m)-m+i-1 do
																						 quoly_assign(alpha[k], beta^[k]);
																					for k := sqr(m)-m+i+1 to sqr(m)-1 do
																						 quoly_assign(alpha[k], beta^[k])	 
																			 end;
											 { Put 1 in this spot }
											 quoly_set(1, beta^[s]);
											 { Zero out rest of j column. }
											 for k := t to t + i - 1 do
													quoly_set(0, beta^[k]);
											 for k := t + i + 1 to t + m - 1 do
													quoly_set(0, beta^[k]);
											 { Put the right det into arr. }
											 det := nil;
											 quoly_set(1, det);
											 mat_invert(beta^, beta^, false, false, m, det, false, true, spar);
											 arr[j + i*m] := det;
											 s := s + m
										end
							end;
					 for i := 0 to sqr(m) - 1 do
							free_quoly(beta^[i]);
					 free_work
				end;		 
		 
		 {___________________________________________________________________________}
		 
		 procedure inversion_method;
		    var i: longint;
				    dumm, dett: quoly;
				begin
				   if alpha_free
							then for i := 0 to sqr(m) - 1 do
							        begin
								         arr[i] := alpha[i];
												 alpha[i] := nil
								      end
							else for i := 0 to sqr(m) - 1 do
							        begin
												 arr[i] := nil;
												 quoly_assign(alpha[i], arr[i])
											end;
					 dett := nil;
					 quoly_set(1, dett);
					 { find determinant. We hope it's not 0, but... }
					 mat_invert(arr, arr, false, false, m, dett, false, true, spar);
					 if quoly_iszero(dett)
					    then begin
							        if alpha_free
												 then for i := 0 to sqr(m) - 1 do
																 begin
																	  alpha[i] := arr[i];
																	  arr[i] := nil  { failsafe }
																 end
												 else for i := 0 to sqr(m) - 1 do
																 free_quoly(arr[i]);
											classic_method
							     end
							else begin
							        mat_invert(arr, arr, true, true, m, dumm, true, true, spar);
					            for i := 0 to sqr(m) - 1 do
					               quoly_mult(arr[i], dett, arr[i])
									 end;
					 free_quoly(dett)
				end;
				
		 {_________________________________________________________________________}
		 
		 begin
		 
		    set_params;
				if allnumbs
				   then inversion_method
				   else if allpolys
									 then classic_method
									 else inversion_method
				
		 end;
										
  {*****************************************************************************}

	procedure sparse_chpoly; {(spar: sparseptr; rows: longint; var n: quoly)}
	
	   { Leverrier-Fadeev algorithm. See manual. }
		 
		 var i, j, k, cutoff, spot: longint;
		     spar2, copy, sp: sparseptr;
				 m, p: quoly;
				 arrf: arr_descr;
				 arr2, arr3: workptr;
				 t: colm_ptr;
				 possible: boolean;
		 		 		 
		 begin
		 
		    if rows = 1
				   then quoly_set(1, n)
					 else begin
					         base_quoly(n, 1);
				           quoly_compute_power(n, rows - 1)
								end;
				m := nil;
				sparse_trace(m, spar, rows);
				quoly_inplace(m);
				quoly_mult(n, m, n);
				copy_sparse(spar, spar2, rows, false);
				copy := spar;
				arrf[2] := rows;
				arrf[1] := sqr(rows);
				possible := (arrf[1] <= arr_limit); {```}
				
				p := nil;
				cutoff := rows + 1;
				for i := 2 to rows do
				   begin
					    add_to_diag(m, spar2, rows);
							spar := copy;
							mult_sparses(spar, spar2, arrf, rows, rows, false);
							free_sparse(spar2, rows, true);
							spar2 := spar;
							sparse_trace(m, spar, rows);
							if rows > 29
								 then begin
												 write(userOutput, i-1:0, ' ');
												 if (i mod 27 = 1) or (i = rows)
														then writeln(userOutput);
												 flush(userOutput)
											end;
							quoly_set(i, p);
							quoly_quot(m, p, m);
							quoly_inplace(m);
							if rows = i
								 then quoly_set(1, p)
								 else begin
												 base_quoly(p, 1);
												 quoly_compute_power(p, rows - i)
											end;
							quoly_mult(p, m, p); 
							better_quoly_add(n, p, n);
							
							if possible {```}
							   then begin
								         { find number of nonzero entries in spar2 }
												spot := 0;
												sp := spar2;
												for k := 0 to (rows - 1) div sparsesize do  {```}
													 begin
															for j := 1 + k*sparsesize to (k+1)*sparsesize do
																 if j > rows 
																		then break
																 else begin
																				 t := sp^.indx[j-k*sparsesize];
																				 while t <> nil do
																						begin
																							 spot := spot + 1;
																							 t := t^.next
																						end
																			end;
															sp := sp^.next
													 end;
												if spot > arrf[1] div 2
													 then begin
																	 cutoff := i;
																	 break
																end
											end
											
						 end;
					 
				if cutoff < rows  { spar2 is no longer sparse; change format. }
				   then begin
					         new_worknode(i, token);																		 
			             arr2 := workhead[i];
									 new_worknode(i, token);																		 
			             arr3 := workhead[i];
					         
									 { fill arr2 with data from spar2. }
									 sp := spar2;
									 for k := 0 to (rows - 1) div sparsesize do  {```}
										  begin
												 for i := 1 + k*sparsesize to (k+1)*sparsesize do
													  if i > rows 
															 then break
													  else begin
																	 t := sp^.indx[i-k*sparsesize];
																	 for j := 1 to rows do
																			begin
																				 spot := i - 1 + (j - 1)*rows;
																				 if t = nil
																						then begin
																										arr2^[spot]:= nil;
																										quoly_set(0, arr2^[spot])
																								 end
																						else if j = t^.coord
																										then begin
																														arr2^[spot] := t^.val;
																														t^.val := nil;
																														t := t^.next
																												 end
																										else begin
																														arr2^[spot]:= nil;
																														quoly_set(0, arr2^[spot])
																												 end
																			end
																 end;
												 sp := sp^.next
											end;
									 
									 { finish the computation }
									 for i := cutoff + 1 to rows do
									    begin
											   { add m to diagonal }
												 for j := 1 to rows do
											      begin
														   spot := (j - 1)*(rows+1);
														   better_quoly_add(arr2^[spot], m, arr2^[spot])
														end;
											   { arr3 := original * arr2 }
												 mult_sparse_norm(copy, arr2, arr3, false, rows, rows, rows, arrf);
											   { move answer to arr3 }
												 for j := 0 to arrf[1] - 1 do
												    begin
														   free_quoly(arr2^[j]);
															 arr2^[j] := arr3^[j]
														end;
												 if rows > 29
													  then begin
																	  write(userOutput, i-1:0, ' ');
																	  if (i mod 27 = 1) or (i = rows)
																			 then writeln(userOutput);
																	  flush(userOutput)
																 end;
												 { compute new m, -(trace of arr2)/i }
												 quoly_set(0, m);
												 for j := 1 to rows do
											      begin
														   spot := (j - 1)*(rows+1);
														   better_quoly_add(m, arr2^[spot], m)
														end;
											   quoly_set(i, p);
												 quoly_quot(m, p, m);
												 quoly_inplace(m);
												 { add into sum }
												 if rows = i
													  then quoly_set(1, p)
													  else begin
																	  base_quoly(p, 1);
																	  quoly_compute_power(p, rows - i)
																 end;
												 quoly_mult(p, m, p); 
												 better_quoly_add(n, p, n)
											end;
											
									 free_arr(arr2^, arrf);
									 free_work;
									 free_work
					      
								end;
				
				base_quoly(p, 1);
				quoly_compute_power(p, rows);
				best_quoly_add(n, p);
				if rows mod 2 = 1
				   then quoly_inplace(n);
		    free_quoly(m);
				free_sparse(spar2, rows, true)
		 
		 end;
	
  {*****************************************************************************}

	procedure sparse_evalquoly; {(var n: quoly; var spar: sparseptr; rows: longint; 
	                             var arr_free: boolean; var inf: text; var flag: nameptr)}
														 
	   { n is nil upon entry }
		 
		 var i, dumm, k: longint;
		     u: colm_ptrptr;
				 n2: quoly;
				 spar2, sp: sparseptr;
				 
		 begin
		 
		    if arr_free
				   then spar2 := spar
					 else copy_sparse(spar, spar2, rows, false);
					 
				arr_free := true;
				
				sp := spar2;  {```}
				for k := 0 to (rows - 1) div sparsesize do
					 begin
							for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > rows 
								    then break
								 else begin
												u := @ sp^.indx[i-k*sparsesize];
												while u^ <> nil do   
													 begin
															{ n is computed first time this is executed }
															get_evalquoly(inf, u^^.val, n, dumm, flag, false);
															if quoly_iszero(u^^.val)
																 then free_colm(u^)
																 else u := @ u^^.next
													 end
										  end;
							sp := sp^.next
					 end;
										
				spar := spar2;
				
				if n = nil  { still?  array is 0, i.e., empty }
					 then begin
									 { MUST call get_evalquoly at least once }
									 n2 := nil; 
									 quoly_set(0, n2);
									 get_evalquoly(inf, n2, n, dumm, flag, false);
									 free_quoly(n2)
								end;
								
				if n^.next <> nil  { total_eval was called by get_evalquoly }
					 then while n <> nil do
									 begin
											n2 := n^.next;
											free_quoly(n);
											n := n2
									 end;
				quoly_set(0, n)
		 
		 end;
														 
  {****************************************************************************}	
	
	procedure sparse_sum(var n: quoly; spar: sparseptr; rows: longint);
	
	   var i, k: longint;
		     u: colm_ptr;
				 sp: sparseptr;
		 begin
		    quoly_set(0, n);
		    sp := spar;  {```}
				for k := 0 to (rows - 1) div sparsesize do
					 begin
							for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > rows 
								    then break
								 else begin
												u := sp^.indx[i-k*sparsesize];
												while u <> nil do
													 begin
															better_quoly_add(n, u^.val, n);
															u := u^.next;
													 end
										  end;
							sp := sp^.next
					 end
		 end;
		 
	{****************************************************************************}
	
	procedure sparse_max_min(spar: sparseptr; rows, cols: longint; max, pos_only: boolean; var n: quoly);
	   
		 { Implement ^ and _ for sparse matrices.  It's much trickier than it
		   first appears. The problem is missing elements representing 0. 
			    If tie for best, returns first seen in row major order. }
		 
		 var u: colm_ptr;
		     i, r, c, col_count, k: longint;  { r,c are row and col of best yet seen }
				 best: quoly;
				 examine_missing: boolean;
				 sp: sparseptr;
				 
	   {_______________________________________________________________________}
		 
		 procedure mark_best(t: quoly; col: longint);
		    begin
					 r := i;
					 c := col;
					 best := t
				end;																						
		 {________________________________________________________________________}
		 
		 procedure consider(test: quoly; col: longint);
		 
		   function its_positive: boolean;
					begin
						 its_positive := (test^.ncoef^.float > 0)
					end;
		 
       begin
				
				  if test^.numb
						 then if max
										 then if r = 0  { haven't found anything yet }
														 then mark_best(test, col)
														 else if test^.ncoef^.float > best^.ncoef^.float
																		 then mark_best(test, col)
																		 else
										 else if r = 0 { haven't found anything yet }
														 then if pos_only 
																		 then if its_positive
																						 then mark_best(test, col)
																						 else
																		 else mark_best(test, col)
														 else if pos_only
																		 then if its_positive and (best^.ncoef^.float > test^.ncoef^.float)
																						 then mark_best(test, col)
																						 else
																		 else if best^.ncoef^.float > test^.ncoef^.float
																						 then mark_best(test, col)
																						 else			 
																		 
						 else error(119, expsign)				
				
				end;
		 		 		 
		 {_______________________________________________________________________}
		 
		 begin
		 
		    r := 0; 
				examine_missing := max or not pos_only;
				
				sp := spar;  {```}
				for k := 0 to (rows - 1) div sparsesize do
					 begin
							for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > rows 
								    then break
								 else begin
												u := sp^.indx[i-k*sparsesize];
												if examine_missing and (u = nil)
													 then begin
																	 consider(quol_num_0, 1);
																	 examine_missing := false
																end;
												col_count := 0;
												while u <> nil do
													 begin
															col_count := col_count + 1;
															if examine_missing and (u^.coord > col_count)
																 then begin
																				 consider(quol_num_0, col_count);
																				 examine_missing := false
																			end;
															consider(u^.val, u^.coord);
															u := u^.next							  
													 end;
												if examine_missing and (col_count < cols)
													 then begin
																	 consider(quol_num_0, col_count + 1);
																	 examine_missing := false
																end
										  end;
						  sp := sp^.next
					 end;
		    
				if r = 0  { still! }
				   then quoly_set(addresser-1, n)  { had to be min and pos_only; failure code }
					 else quoly_set(rows*(c-1) + r - 1 + addresser, n)
				
		 end;
		
	{*****************************************************************************}

	procedure arr_parse; { (x: char; var inf: text; var n: quoly; var flag: nameptr);}
	
	  var arr: workptr;
		    arr_facts: arr_descr;
				i, r, spot: longint;
				oldtok : tokentipe;
				arr_free, pos_only: boolean;
				detsign: tokentipe;
				spar: sparseptr;
				
		begin

        oldtok.name := x;
				new_worknode(r, oldtok);
			  arr := workhead[r];
				detsign.name := '';

        arr_facts[1] := 0;
				oldtok.name := ' '; 
				pos_only := false;
				spar := nil;
					 
				case x of 
				   '[', '' :  arr_asstat(inf, n, arr^, arr_facts, arr_free, flag, spar);
                  { This works because of restrictions on array statement syntax. }
									
					 '', 'A' :     {~~~~~the A } { Nov 1997 } 
								 begin
										 arr_expre(inf, n, arr^, arr_facts, arr_free, r, flag, 
										           spar, true);
										 fill_syst_array(arr^, arr_facts, arr_free, spar, r);
										 quoly_set(0, n)
								 end;
										
					 'T' : begin  { trace }
					          scanner(inf, token, flag);
										r := 0;
									  arr_fact(inf, n, arr^, arr_facts, arr_free, r, flag, spar);
										if (arr_facts[1] = sqr(arr_facts[2])) and (arr_facts[1] >= 1)
										   then if spar = nil
											         then begin
																			 quoly_assign(arr^[0], n);
																			 r := arr_facts[2] + 1;
																			 for i := 1 to r - 2 do
																					better_quoly_add(n, arr^[i*r], n)															    
																		end
															 else sparse_trace(n, spar, arr_facts[2])
											 else error(194, token);
										if spar = nil
										   then if arr_free 
									             then free_arr(arr^, arr_facts)
															 else
											 else free_sparse(spar, arr_facts[2], arr_free)
								 end;

           'S': begin  { Sumup }
					         scanner(inf, token, flag);
									 r := 0;
									 arr_fact(inf, n, arr^, arr_facts, arr_free, r, flag, spar);
                   if arr_facts[1] = 0
                      then error(46, token);
									 if spar = nil
									    then sum_arr(arr^, arr_facts[1], n)
											else sparse_sum(n, spar, arr_facts[2]);
									 if spar = nil
										   then if arr_free 
									             then free_arr(arr^, arr_facts)
															 else
											 else free_sparse(spar, arr_facts[2], arr_free)
					      end;
								
						'', 'L' : begin  {  L added Apr 1998 for Det_ }
					        {  by itself is determinant. #([b]= a) counts how many elements of
									  matrix [b] equal a -- similarly for > or <.  _ finds the index 
										in a matrix of the smallest value; ^ does same for largest value.
										_+ restricts to postive entries. }
										
                   if x = 'L'
                      then token.name := '_'  { Apr 1998 }
                      else scanner(inf, token, flag);
									 case token.name[1] of
									    '_', '^': begin
											            oldtok := token;
														      scanner(inf, token, flag);
														      if (token.name = '+') and (oldtok.name = '_')
														         then begin
																            pos_only := true;
																    			  scanner(inf, token, flag)
																		      end
													     end;
											'#': begin
											        oldtok := token;
															scanner(inf, token, flag);
															if token.name <> '(' 
															   then error(64, token);
															scanner(inf, token, flag)
													 end;
									 end; { case token.name[1] of }
									 
                   r := 0;
									 arr_fact(inf, n, arr^, arr_facts, arr_free, r, flag, spar);
                   if arr_facts[1] = 0
                      then error(46, detsign);
									 case oldtok.name[1] of
                      ' ': begin
											        quoly_set(1, n);  {~~~~````}
										          if arr_facts[1] = sqr(arr_facts[2])
                                 then if spar = nil
																         then if first_available <= worksize
													                       then mat_invert(arr^, arr^, arr_free, arr_free, 
																								          arr_facts[2], n, false, true, spar)
														                     else warning(90, '') 
																				 else begin
																				         mat_invert(arr^, arr^, arr_free, arr_free, arr_facts[2], 
																				                    n, false, true, spar);
																								 if spar = nil  { see invert_sparse }
																								    then begin
																										        free_work;
																														exit {(arr_parse)}
																										     end
																							end
                                 else error(285, token);
													 end;
										  '_': if spar = nil
											        then begin
																			spot := -1;
																			if pos_only
																				 then for i := 0 to arr_facts[1] - 1 do
																									 if arr^[i]^.numb
																												 then if arr^[i]^.ncoef^.float > 0
																																 then begin
																																				 spot := i;
																																				 break
																																			end
																																 else
																												 else error(119, logsign)
																							
																				 else spot := 0;
																			
																			if pos_only 
																				 then begin 
																								 if spot>=0
																										then for i := spot+1 to arr_facts[1] - 1 do
																													 if arr^[i]^.numb
																															then begin if arr^[i]^.ncoef^.float > 0
																																						then if arr^[spot]^.ncoef^.float > arr^[i]^.ncoef^.float
																																										then spot := i
																																	 end
																															else error(119, logsign)
																							end
																											
																			 else for i := spot+1 to arr_facts[1] - 1 do
																									if arr^[i]^.numb
																										 then if arr^[spot]^.ncoef^.float > arr^[i]^.ncoef^.float
																														 then spot := i
																														 else
																										 else error(119, logsign);
																			quoly_set(spot+addresser,  n)
													         end
																	 
															else sparse_max_min(spar, arr_facts[2], arr_facts[1] div arr_facts[2],
															                    false, pos_only, n);
											'^': if spar = nil
											        then begin
																			spot := 0;
																			for i := 1 to arr_facts[1] - 1 do
																				 if arr^[i]^.numb
																						then if arr^[i]^.ncoef^.float > arr^[spot]^.ncoef^.float
																										then spot := i
																										else
																						else error(119, expsign);
																			quoly_set(spot+addresser, n)
																	 end
															else sparse_max_min(spar, arr_facts[2], arr_facts[1] div arr_facts[2],
															                    true, false, n);
											'#': begin
											        oldtok := token;
															if spar <> nil
															   then error(289, token);
															if (oldtok.name<>'=') and (oldtok.name<>'>') and (oldtok.name<>'<')
															    then error(65, oldtok);
															scanner(inf, token, flag);
															old_expre(inf, n, flag);
															if token.name<>')' then error(66, token);
															scanner(inf, token, flag);
															spot := 0;
															for i:=0 to arr_facts[1] - 1 do
															    case oldtok.name[1] of
																	   '=': if quoly_equal(arr^[i], n) 
																		         then spot := spot + 1;
																		 '>': if n^.numb and arr^[i]^.numb
																		         then if arr^[i]^.ncoef^.float > n^.ncoef^.float
																		                 then spot := spot + 1
																										 else
																						 else error(120, oldtok);
																		 '<': if n^.numb and arr^[i]^.numb
																		         then if n^.ncoef^.float > arr^[i]^.ncoef^.float
																		                 then spot := spot + 1
																										 else
																						 else error(120, oldtok)
																	end;
																	
															quoly_set(spot,  n)

													 end
															
										end;  { case oldtok.name[1] of }
																 
                   if spar = nil
										  then if arr_free 
									            then free_arr(arr^, arr_facts)
															else
											else free_sparse(spar, arr_facts[2], arr_free)
											 
								 end  { '' : begin }
								 
        end; { case x of }
				
			free_work
				
		end;
		
	{***************************************************************************}
		
	procedure flip_sparse; {(var spar, spar2: sparseptr; row, col: longint)}
	
	   { spar2 is nil or irrelevant. The quolies of spar will be pointed to by spar2, so
		   don't free them later! }
			 
		 var i, k: longint;
				 sp: sparseptr;
		 
		 procedure transfer(i, k: longint);  {```}
		    var s, t: colm_ptr;
				    u: colm_ptrptr;
						j: longint;
						sp2: sparseptr;
				begin
				   t := sp^.indx[i];
					 while t <> nil do
						 begin
								sp2 := spar2;
							  for j := 1 to (t^.coord - 1) div sparsesize do
									 sp2 := sp2^.next;
							  u := @ sp2^.indx[1 + (t^.coord - 1) mod sparsesize];
								s := u^;
								newcolm(u^);
								u^^.next := s;
								u^^.coord := i + k*sparsesize;
								u^^.val := t^.val;
								t := t^.next
						 end				
				end;		 
		 
		 begin
		 
		    sparse_init(spar2, col);
				
				{ Take the data from spar, from the last row toward the first. }  {```}
				sp := spar;
				k := (row - 1) div sparsesize;
				for i := 1 to k do
				   sp := sp^.next;
				{ Take data from last block }
				for i := 1 + (row - 1) mod sparsesize downto 1 do
				   transfer(i, k);
				
				{ Now take it from each block in order. }
				for k := (row - 1) div sparsesize - 1 downto 0 do
				   begin
					    sp := spar;
					    for i := 1 to k do
				         sp := sp^.next;
					    for i := sparsesize downto 1 do
				         transfer(i, k)
					 end
		 
		 end;	
	
	{***************************************************************************}
	
	procedure trans_sparse; {(var spar: sparseptr; row, col: longint)}
	
	   { transpose spar in place. }
			 
		 var i, k: longint;
				 spar2, sp: sparseptr;
		 
		 procedure transfer(i, k: longint);  {```}
		    var s, t: colm_ptr;
				    u: colm_ptrptr;
						j: longint;
						sp2: sparseptr;
				begin
				   t := sp^.indx[i];
					 while t <> nil do
						 begin
								sp2 := spar2;
							  for j := 1 to (t^.coord - 1) div sparsesize do
									 sp2 := sp2^.next;
							  u := @ sp2^.indx[1 + (t^.coord - 1) mod sparsesize];
								s := u^;
								u^ := t;
								t^.coord := i + k*sparsesize;
								t := t^.next;
								u^^.next := s
						 end				
				end;		 
		 
		 begin
		 
		    sparse_init(spar2, col);
				
				{ Take the data from spar, from the last row toward the first. }  {```}
				sp := spar;
				k := (row - 1) div sparsesize;
				for i := 1 to k do
				   sp := sp^.next;
				{ Take data from last block }
				for i := 1 + (row - 1) mod sparsesize downto 1 do
				   transfer(i, k);
				
				sp^.next := spargarb;
				
				{ Now take it from each block in order. }
				for k := (row - 1) div sparsesize - 1 downto 0 do
				   begin
					    sp := spar;
					    for i := 1 to k do
				         sp := sp^.next;
					    for i := sparsesize downto 1 do
				         transfer(i, k)
					 end;
					 				
				spargarb := spar;
				spar := spar2
		 
		 end;	
	
	{**************************************************************************}
	
	procedure namechange; {(var inf: text; var n: quoly; var flag: nameptr)}
	
	  var j: longint;
		    r,u: arrptr;
				oldtok: tokentipe;
				
		procedure call_error(bad: longint; tok: tokentipe);
		   begin
			    error(bad, tok);
					exit {(namechange)}
			 end;
		
		begin
		
		   scanner(inf, token, flag);
			 if token.name <> '['
			    then call_error(100, token);
			 scanner(inf, oldtok, flag);
			 scanner(inf, token, flag);
			 if flag <> nil
			    then while (token.name[1] >= 'a') and (token.name[1] <= 'z') do
					        begin
									   oldtok.name := concat(oldtok.name, token.name);
										 scanner(inf, token, flag);
									end;
			 if token.name <> ']'
			    then call_error(101, token);
			 scanner(inf, token, flag);
			 if token.name <> ':'
					then error(148, token);  { Dec 1997 }
			 scanner(inf, token, flag);
			 if token.name <> '='    { deletions here, Nov 1997 }
			    then call_error(4, token); 
			 scanner(inf, token, flag);
			 if token.name <> ''''
			    then call_error(102, token);
			 scanner(inf, token, flag);
			 if token.name <> '['
			    then call_error(100, token);
			 scanner(inf, token, flag);
			 if (token.name[1] < 'a') or (token.name[1] > 'z')
			    then call_error(40, token);
					
			 { find oldtok }
			 j := hash(oldtok.name, 151);
       r := arr_store[j];
       u := nil;
       while r <> nil do
          begin
					    if r^.name.name = oldtok.name
							   then break;
              u := r;
              r := r^.next;
          end;
			 if r = nil
			    then call_error(28, oldtok);
			 if r^.time < 0  { array parameter }
			    then call_error(140, oldtok);
					
			 oldtok := token;  { the new name }
			 scanner(inf, token, flag);
			 if token.name <> ']'
			    then call_error(101, token);
			 scanner(inf, token, flag);
			 if token.name <> ''''
			    then call_error(102, token);
					
			 { install in new position }
			 if u = nil
          then arr_store[j] := arr_store[j]^.next
          else u^.next := r^.next;
			 j := hash(oldtok.name, 151);
			 oldtok.address := j;
			 r^.next := arr_store[j];
			 r^.name := oldtok;
			 arr_store[j] := r;
			 quoly_set(0, n);
			 
		   scanner(inf, token, flag)	   
		
		end;
		
	{**************************************************************************}						
			
  procedure handle_andsign(var inf: text; var flag: nameptr; var outflag: boolean);
		 
		 { implements dumb save }
		 
		 begin
		 
		    scanner(inf, token, flag);           {spar<}
				if token.name <> 'o'
				   then error(307, token);
				if output_file_name = ''
				   then error(309, token);
				scanner(inf, token, flag);
		    outflag := false
		 		 
		 end;
												 
	{*************************************************************************}						
			
  procedure handle_quote(var inf: text; var n: quoly; var flag: nameptr; 
	                       var tp: text);  {spar}
	                   
	   { changed tp to text, Dec 1997. previous textptr wouldn't compile! }
													
		 var c, lengt: longint;
		     dumm: boolean;
				 out_name: bigstring;
	
	   begin
		 
				 c := 0;
				 out_name := '';  
				 repeat 
						 dumbscanner(inf, token, flag, dumm);
						 c := c + length(token.name);
						 if c <= 255
						    then if token.name <> '''' 
								        then out_name := concat(out_name, token.name)
				 until token.name = '''';
				 
				 c := c - 1;
				 scanner(inf, token, flag);
				 write(tp, out_name);
				 if token.name = ':'
					  then begin
									 scanner(inf, token, flag);
									 old_expre(inf, n, flag);
									 lengt := quoly_convert_to_int(n);
									 if lengt > c then write(tp, ' ': lengt-c)
								 end
								 
		 end;
								 		
	{**************************************************************************}	
	
	procedure one_write_out(var inf: text; var n: quoly; var flag: nameptr; 
	                        ok, outflag, do_extras: boolean; var outfile: text);
													
		{ ok = false means out file must be output. outflag = is output tty?
		  Dec 1997, changed outfile to text from textptr.  }
	
	   var firstrow, firstcol, location, total_rows, 
			       r, c, lengt, old_disp_size, m: longint;
			   q: arrptr;
				 oldtoken: tokentipe;
				 char_flag, its_not_syst: boolean;
				 n1: quoly;         
	
     procedure handle_colon(var n: quoly; var lengt: longint);
		    begin
					 old_expre(inf, n, flag);
					 lengt := quoly_convert_to_int(n)
				end;
		 
		 procedure handle_char;  
		    begin
					 char_flag := true;
					 lengt := 0;
					 scanner(inf, token, flag);
					 if token.name = ':'
							then begin
											scanner(inf, token, flag);
											handle_colon(n, lengt)
									 end
				end;
		 
		 begin
			
				lengt := 4;
				char_flag := false;  {!}
				old_disp_size := disp_size;  {spar}
				if token.name = '['
					 then begin
									firstrow := addresser;  firstcol := addresser;
									q := nil;  { so don't have to set r, c, etc. in main case }
									scanner(inf, oldtoken, flag);
									if oldtoken.name = ''
										 then begin
														 get_arr_arr(inf, n, flag, m);
														 q := arrstash[m];
														 if q = nil
																then error(247, token);
														 r := q^.rows;
														 total_rows := r;
														 c := q^.size div q^.rows;
														 location := q^.start
													end;
									scanner(inf, token, flag);
									if token.name = '['  { find subarray }
											then begin
															if oldtoken.name <> ''
																 then location := fastestlookup(oldtoken, q);  {spar}
															if location = -1
												         then error(28, token);
															{ location is set by following, independent of above }
															subarray(inf, q, location, r, c, firstrow, firstcol,
																			 total_rows, flag)
													 end;
									its_not_syst := (oldtoken.name <> '');
									if not its_not_syst 
										 then begin
														 if syst^.stop = -1
																then error(175, oldtoken);
														 q := syst;
														 location := 0;
														 r := syst^.rows;
														 c := (syst^.stop + 1) div r;
														 total_rows := r;
														 firstcol := addresser;
														 firstrow := addresser
													end;
									if token.name = ']'
										 then begin
														 scanner(inf, token, flag);
														 if token.name = ':'  
																then begin
																				scanner(inf, token, flag);
																				if token.name = 'char'
																					 then handle_char
																					 else handle_colon(n, lengt)
																		 end;
														 arrdisplay(outfile, true, true, oldtoken, q, location, 
																				r, c, firstrow, firstcol, total_rows, lengt,
																	  	  char_flag, its_not_syst, outflag and do_extras, stash)
													end
									else if (token.name = ';') or (token.name = '') or 
													( ok and ((token.name = ',') or (token.name = ')')) )
											then arrdisplay(outfile, true, false, oldtoken, q, location, 
																			r, c, addresser, addresser, total_rows, lengt, 
																			char_flag, its_not_syst, outflag and do_extras, stash)
									else if token.name = ':'
													then begin
																	scanner(inf, token, flag);
																	if token.name = 'char'
																	   then handle_char  
																		 else handle_colon(n, lengt);
																	arrdisplay(outfile, true, false, oldtoken, q, location, 
																			  r, c, addresser, addresser, total_rows, lengt,
																				char_flag, its_not_syst, outflag and do_extras, stash)
															 end
									else error(24, token)
								end
					else if token.name = ''''
						      then handle_quote(inf, n, flag, outfile)
					else if (token.name = ';') or (token.name = '')
								  then if not ok
												  then writeln(userOutput)
												  else error(106, semicolon)
					else if ok
						 then begin
										 old_expre(inf, n, flag);
										 if token.name = ':'
												then begin
																scanner(inf, token, flag);
																n1 := nil;
																if token.name = 'char'
																	 then handle_char  
																	 else handle_colon(n1, lengt);
																free_quoly(n1)
														 end
												else lengt := -1;
										 c := 0;
										 quoly_display(outfile, outflag, false, false, n, c, semicolon, polynames, 
																	 false, true, char_flag);
										 if lengt > c then write(outfile, ' ': lengt-c-1)
									end
					else begin
									old_fact(inf, n, flag);
									c := 0;
									quoly_display(outfile, outflag, false, false, n, c, semicolon, polynames, 
															  false, true, false)   
							 end;
					disp_size := old_disp_size 
							
      end;

  {*************************************************************************}
	
	procedure write_out(var inf: text; var n: quoly; var flag: nameptr);
	
	   { had to get rid of textptr, Dec 1997.  wouldn't compile! Now use
	     explicit output/outpuf. }
	   
	   var lineflag, outflag: boolean;
		
		 begin
		 
			  scanner(inf, token, flag);
				lineflag := (token.name = '!');
				if lineflag 
				   then scanner(inf, token, flag);
				outflag := true;  { default }
				if token.name <> '('
				   then one_write_out(inf, n, flag, false, outflag, true, userOutput)
				else begin
				        scanner(inf, token, flag);   {spar}
								{ first field is special if it has &o in it -- "dumb save" }
				        if token.name = ''''
									 then handle_quote(inf, n, flag, userOutput)
								   else if token.name = '&'
								           then handle_andsign(inf, flag, outflag)  { will change outflag }
								           else one_write_out(inf, n, flag, true, outflag, false, userOutput);
							  while token.name <> ')' do
							     begin
							        if token.name <> ','
									       then error(105, token);
											scanner(inf, token, flag);
											if outflag
											   then one_write_out(inf, n, flag, true, outflag, false, userOutput)
											   else one_write_out(inf, n, flag, true, outflag, false, outpuf);
						       end;
							  scanner(inf, token, flag)
						 end;
						 
				quoly_set(0, n);
				if lineflag
				   then if outflag
				           then writeln(userOutput)
				           else writeln(outpuf);
				if lineflag and outflag
				   then flush(userOutput)
		 
		 end;
		 
	{**************************************************************************}
	
	procedure global_dump;
	   
		 var message: boolean;
		     p: objptr;
				 i: integer;
	
	   begin
		 
		    writeln(userOutput);
				write(userOutput, ' Arithmetic mode: ');
				writeln(userOutput, 'fast float.');
				write(userOutput, ' Pushing after errors is ');
				if errorpush
				   then writeln(userOutput, 'on.')
					 else writeln(userOutput, 'off.');
				write(userOutput, ' Displaying results is ');
				if noisy
				   then writeln(userOutput, 'on.')
					 else writeln(userOutput, 'off.');
				if realflag
				   then writeln(userOutput, 'Real mode on.');
				if detcutoff >= 0
				   then writeln(userOutput, ' Detcutoff is ', detcutoff:1, '.');
				write(userOutput, ' Array initial index is ');
				if addresser = 1
				   then writeln(userOutput, '1.')
					 else writeln(userOutput, '0.');
				write(userOutput, ' Command interrupt is ');
				case m_interrupt of
				   0: writeln(userOutput, 'off.');
					 1: writeln(userOutput, 'on.')
				end;
				if prompt <> '>'
					 then if prompt[1] = chr(13)
									 then writeln(userOutput, ' Prompt is: <cr>')
									 else writeln(userOutput, ' Prompt is: ', prompt);
				if namelength <> 10
				   then writeln(userOutput, ' Maximum name length is ', namelength:1, '.');
				if timerflag
				   then writeln(userOutput, ' Timing is enabled.');
				if uglyprint
				   then writeln(userOutput, ' Ugly printing is on.');
				if input_file_name <> ''
				   then writeln(userOutput, ' Reading from file ', input_file_name, '.');
				if output_file_name <> ''
				   then writeln(userOutput, ' Saving to file ', output_file_name, '.');
				if rand_denom_n.float = 1
				   then { nothing }
					 else	begin
					         writeln(userOutput, ' Denominator for random is:');
									 dummy := 0;
				           complex_display(userOutput, true, true, rand_denom_n, 
								                   dummy, false);
				           writeln(userOutput)
								end;
				if polynames <> nil
				   then begin
					         writeln(userOutput, ' These polynomial variables have been created:');
									 polylist(userOutput, false)
								end
					 else writeln(userOutput, ' No polynomial variables exist.');
				if laurent
				   then writeln(userOutput, ' Laurent polynomials allowed.');
				message := true;
				for i := 0 to 150 do
				   begin
					    p := objlist[i];
						  if message and (p <> nil)
				         then begin
								         writeln(userOutput, ' These objects have been created:');
												 message := false
											end;
						  while p <> nil do
								 begin
									  write(userOutput, '   ', p^.name);
									  if p^.obarray
											 then write(userOutput, ', object array[', (p^.final-p^.init+1):1, ']');
									  if p^.quads <> nil
											 then write(userOutput, ', hidden line object');
										if p^.shaded
											 then write(userOutput, ', shaded object');
										if p^.solid
											 then write(userOutput, ', solid object');
									  writeln(userOutput);
									  p := p^.next
								 end
					 end;
				writeln(userOutput)
				
		end;
		
	{************************************************************************}
				
	procedure set_switch(var inf: text; var n: quoly; var flag: nameptr;
	                     var colflag: boolean);
											 
		{ colflag is used to pass back info about calling scanner one more time. 
		  Basically used by change_prec, it's vaue here is irrelevant because of
			the statements in parse. }
	  
		var oldtok: tokentipe;
		    value {wwh , value2}: longint;
				switch, infin: boolean;
//wwh				n2: quoly;
				
		{______________________________________________________________________}
		
		procedure finish_string;
		   var newname: bigstring;
			     i: integer;
					 dumm: boolean;
		   begin
			    if token.name = ''''
					   then begin
						          i := 0;
											newname := '';
											repeat 
												 dumbscanner(inf, token, flag, dumm);
												 if token.name = ''
													  then error(131, token);
												 i := i + length(token.name);
												 if i <= 255
														then if token.name <> '''' 
																		then newname := concat(newname, token.name)
																		else
														else error(209, token)
											until token.name = ''''
								  end
						 else begin
						         newname := token.name;
										 i := length(newname) + 1
									end;										 
				 
					i := i - 1;
					scanner(inf, token, flag);
			    if token.name <> ')'
					   then error(135, token);
					token := oldtok;
					if (token.name <> 'M') and (newname = ' ')
					   then error(131, token);
					case token.name[1] of
					   'S': save(inf, flag, newname);
             'R': load(inf, n, flag, newname, value);  {@@@ value unused here}
						 'M': begin
		                 prompt := newname;
										 if i > 10
										    then writeln(userOutput, '*** Warning.  prompt name truncated to 10 characters.'); 
										 if prompt = ' '
											   then begin
												         prompt[1] := chr(13);
																 promptsize := 0;
																 writeln(userOutput, ' Prompt now: <cr>')
															end
											   else begin
												         promptsize := length(prompt);
																 if promptsize = 0
																    then begin   {@@@}
																            prompt[1] := chr(13);
																            writeln(userOutput, ' Prompt now: <cr>')
																         end
										                else writeln(userOutput, ' Prompt now:', prompt)
															end
									end;
						 else error(141, oldtok)
					end;
				  exit {(set_switch)}
			 end;
			 
		{______________________________________________________________________}
			 	
		begin
		  
			 scanner(inf, oldtok, flag);
			 scanner(inf, token, flag);
			 if token.name <> '='
			    then error(4, token);
			 if oldtok.name = 'P'
			    then begin
					         set_mod_out(inf, flag, true);
									 if token.name <> ')'
			                then error(1, token);
									 exit {(set_switch)}
							 end
					else if oldtok.name = 'J'
					     then begin
							         attach_poly(inf, flag, false);
											 scanner(inf, token, flag);
											 if token.name <> ')'
			                    then error(1, token);
									     exit {(set_switch)}
										end;
			 scanner(inf, token, flag);
			 infin := (token.name = '');
			 if (token.name = '''') or (oldtok.name = 'S') or (oldtok.name = 'R') or (oldtok.name = 'M')
			    then finish_string;

			 value := 0;
//wwh			 value2 := 0;
//wwh			 n2 := nil;
			 if infin 
			    then error(303, token)
			    else old_expre(inf, n, flag);
					
			 if not infin and (oldtok.name <> '')
			    then begin
					        if not n^.numb
								     then error(147, oldtok);
									value := quoly_convert_to_int(n)
							 end;
			 if (value < 0) and (oldtok.name[1] <> 'D')
			    then error(137, token);
			 if token.name = ',' 
			    then error(134, token);
			 if token.name <> ')'
			    then error(135, token);			 
			 switch := (value = 1);
			 if (value <> 0) and (value <> 1) 
			    and (oldtok.name <> 'n') and (oldtok.name <> 'D')
			    then error(133, token);
			  
			 case oldtok.name[1] of
			   'a': if addresser <> value
				         then begin
							           addresser := value;
								         if flag = nil  
												    then writeln(userOutput, ' Array initial index now ', addresser:1)
							        end
								 else writeln(userOutput, ' Already had that array initial index.');
				 'e': if errorpush = switch
				         then writeln(userOutput, ' Already had that value; no change.')
							   else begin
								         errorpush := switch;
								         if errorpush 
									          then writeln(userOutput, ' Will push new level after errors.')
										        else writeln(userOutput, ' Pushing after errors is deactivated')												
							        end;
				 'E': if extra_line = switch
				         then writeln(userOutput, ' Already had that value; no change.')
							   else begin
								         extra_line := switch;
								         if extra_line 
									          then writeln(userOutput, ' Will do extra line after display.')
												    else writeln(userOutput, ' No extra line after display.')												
							        end;
				 'U': if uglyprint = switch
				         then writeln(userOutput, ' Already had that value; no change.')
							   else begin
								         uglyprint := switch;
												 if uglyprint
												    then continuation := '\'
														else continuation := '';
								         if uglyprint 
									          then writeln(userOutput, ' Will do ugly printing.')
										        else writeln(userOutput, ' Will resume lovely Fermat style.')												
							        end;
				 'N': if noisy = switch
				         then writeln(userOutput, ' Already had that value; no change.')
							   else begin
								         noisy := switch;
								         if noisy 
									          then writeln(userOutput, ' Will display results.')
										        else writeln(userOutput, ' Displaying results is deactivated')												
							        end;
				 '|': if pos_mod = switch
				         then if flag = nil
								         then writeln(userOutput, ' Already had that value; no change.')
												 else 
							   else begin
												 pos_mod := switch;
												 if flag = nil
													  then if pos_mod
																	  then writeln(userOutput, ' Modulus must return non-negatives.')
																	  else writeln(userOutput, ' Modulus can return negatives.')
										  end;
				 'D': begin
				         if value = 1
								    then value := 0
										else if value > 10
										        then value := 10;
								 detcutoff := value;
				         if detcutoff < 0
				            then writeln(userOutput, ' Will set detcutoff using defaults.')
					          else writeln(userOutput, ' Detcutoff now ', detcutoff:1, '.')
							end;
				 'c': if switch <> complex
								 then change_complex
								 else if complex 
				                 then writeln(userOutput, ' Already was in complex mode.')
					               else writeln(userOutput, ' As before, still not in complex mode.');
				 't': if timerflag <> switch
								 then begin
								         timerflag := switch;
								         if timerflag
										        then writeln(userOutput, ' Timing enabled.')
										        else writeln(userOutput, ' Timing disabled.')
											end
								 else writeln(userOutput, ' Already had that value; no change in timing.');
				 '': if laurent <> switch
								 then begin
								         laurent := switch;
												 change_laurent;
								         if laurent
										        then writeln(userOutput, ' Negative exponents enabled.')
										        else writeln(userOutput, ' Negative exponents disabled.')
											end
								 else writeln(userOutput, ' Already had that value; no change in Laurent polynomial status.');
				 'm': if m_interrupt <> value
								 then begin
								         m_interrupt := value;
												 if flag = nil then write(userOutput, ' Command interrupt now ');
								         case value of
												   0: begin
													       command_int := false;
																 if flag = nil then writeln(userOutput, 'off.')
															end;
													 1: begin
													       command_int := true;
																 if flag = nil then writeln(userOutput, 'on.')
															end;
												   else error(146, oldtok)
												 end
											end
								 else writeln(userOutput, ' Already had that value; no change in command interrupt.'); 
				 'n': if namelength <> value
				         then begin
							           namelength := value;
								         writeln(userOutput, ' Maximum name length now ', namelength:1, '.')
							        end
								 else writeln(userOutput, ' Already had that maximum name length.');
				 '': begin
				         if not n^.numb
								    then error(143, oldtok);
				         rand_denom_n.float := n^.ncoef^.float;
								 writeln(userOutput, ' Denominator for random is now: ');
								 dummy := 0;
                 quoly_display(userOutput, true, true, true, n, dummy, semicolon, 
								               polynames, false, true, false)
							end;
								 
								 
				 else error(136, oldtok)
			
			end;
			colflag := false  { not really necessary }
			
		end;
						  
 {****************************************************************************}
				
  procedure set_name_length(var n: quoly);
	
	 begin
		  
		 repeat 
		    writeln(userOutput, 'Enter maximum name length. ');
				do_prompts;
        read(userInput, namelength);
		    writeln(userOutput);
		    if (namelength < 1) or (namelength > 10)
			    then writeln(userOutput, '*** Improper name length')					
		 until (namelength > 0) and (namelength < 11);
			 
		 quoly_set(namelength,  n)
			 
   end;
		
	{************************************************************************}
	
  procedure change_detcutoff(var num: quoly);
	
	   begin
		 
		    writeln(userOutput, ' Enter detcutoff:'); 
				do_prompts;
				readln(userInput);  { these readlns added HERE Jan 1998 }
				scanner(userInput, token, zilch);
			  old_expre(userInput, num, zilch);
			  if not num^.numb
					then error(253, token);
				detcutoff := quoly_convert_to_int(num);
				if detcutoff = 1
				   then detcutoff := 0
					 else if detcutoff > 10
				           then detcutoff := 10;
				if detcutoff < 0
				   then writeln(userOutput, ' Will set detcutoff using defaults.')
					 else writeln(userOutput, ' Detcutoff now ', detcutoff:1, '.')
		 
		 end;
		 
	{**********************************************************************}
	
	procedure arr_arr_state(var inf: text; var n: quoly; var flag: nameptr);

    { Nov 1997. May or may not be an assignment statement; might be just part 
	    of an expression. }
			
		var oldtok: tokentipe;
				r, c, c1: longint;
				colflag, simple, arr_free: boolean;
				q: arrptr;
				qp: quolyptr;
				spar: sparseptr;  { Nov 1997 }
				arr_facts: arr_descr;  { Nov 1997 }
				arr2: workptr;   { Nov 1997 }

    begin 
		
      get_arr_arr(inf, n, flag, c1);
		  scanner(inf, token, flag);	 
			if token.name = '['
			   then begin
				         if arrstash[c1] = nil
								    then error(247, token);
								 simple := true;   { an entry, [..][..] } { Nov 1997 }
								 scanner(inf, token, flag);
			           evalcoords(inf, r, c, flag, ']', ',', colflag);
								 scanner(inf, token, flag);
								 get_quoly_ptr(arrstash[c1], r, c, colflag, qp, arr_arrsign, false)   {spar}
							end
				 else simple := false;  { just the pointer [..] }
				 
			if token.name = ':' { must be assignment; note that [x]*[y]: makes no sense, while
			                      without arrays, x := y*z: does make sense.  Nov 1997 }
			   then begin
			           scanner(inf, token, flag);
			           if token.name <> '='
			               then error(4, token)
			         end
			   else if simple
								 then begin
			                   if qp = nil   { sparse array, entry (r,c) not there }
			                      then quoly_set(0, n)
			                      else if qp^ = nil  { Jan 1998 }
																    then begin
																				   writeln(userOutput, 'Warning. Uninitialized array element in .');
																				   writeln(userOutput, '  Will assign 0.');
																				   quoly_set(0, qp^);
																				   quoly_set(0, n)
																			   end
										                else quoly_assign(qp^, n);  
			                   half_expre(inf, n, flag);
			                   exit {(arr_arr_state)}
			                end
								 else begin
												  q := arrstash[c1];
								          if q = nil
									           then error(247, token);
													arr_facts[1] := q^.size;
													arr_facts[2] := q^.rows;	
												  r := q^.rows;
												  spar := q^.spar;
												  arr_free := false;
												  if spar = nil
                             then begin
                                     new_worknode(c, token);		
                                     arr2 := workhead[c];
                                     fillit(r, q^.size div r, q, arr2^);
                                  end;
			                    arr_expre(inf, n, arr2^, arr_facts, arr_free, r, flag, spar, false);
			                    fill_syst_array(arr2^, arr_facts, arr_free, spar, r);
			                    free_work;
			                    quoly_set(0, n);
			                    exit {(arr_arr_state)}
											end;
											
			scanner(inf, token, flag);
			if simple
			   then begin
				         old_expre(inf, n, flag);
								 if qp = nil   { sparse array, entry (r,c) not there }
								    then sparse_insert(r, c, arrstash[c1], colflag, n)
								    else if arrstash[c1]^.spar = nil
								            then quoly_assign(n, qp^)
								            else if quoly_iszero(n)
	                                  then sparse_delete(r, c, arrstash[c1], colflag)  {@@@}
	                                  else quoly_assign(n, qp^)
							end
				 else begin
				         if token.name <> '['
									  then error(244, token);
								 scanner(inf, oldtok, flag);
								 scanner(inf, token, flag);
								 if token.name <> ']'
									  then error(245, token);
								 scanner(inf, token, flag);
								 r := fastestlookup(oldtok, q);  {spar}
								 if q = nil
								    then error(28, oldtok);
								 arrstash[c1] := q
				      end

    end;

  {**************************************************************************}
	
  procedure calc_disp;

    begin
		  writeln(userOutput, 'Enter display size. ');
			do_prompts;
			read(userInput, disp_size);
			writeln(userOutput);
			if disp_size < 0 then disp_size := 0;
			if disp_size >= 30 
			   then writeln(userOutput, 'Warning.  Very large disp_size.');
      writeln(userOutput, 'new display size: ', disp_size:2);
      token.name := '@';  token.address := -1
    end;

	{************************************************************************}

	function parse;  { (var inf: text;  var n: quoly;  var flag: nameptr) : integer; }

    var oldtoken, stash: tokentipe;
        r, c, colpos: longint;
        q: arrptr;
				s: varptr;
				aux: colm_ptrptr;   { Nov 1997 }
				qp: quolyptr;
			  colflag, savett: boolean;  { double use; change_prec tells if it called scanner }
        var heapstatus : THeapStatus;

    begin

      parse := 0;
      case token.name[1] of

        '[', '', '': arr_parse(token.name[1], inf, n, flag);   { Nov 1997 }

				'': arr_arr_state(inf, n, flag);

				'': read_object(inf, n, flag);  { Jan 1998 }

        '&':
          begin
            scanner(inf, token, flag);
						if length(token.name) > 1
							 then error(114, token);
						oldtoken := token;
            case token.name[1] of
              'f', 'F': begin
							             scanner(inf, token, flag);
				                   listfuncs(userOutput, inf, true, token, flag)
												end;
              'v': listvars;
              's', 'S': save(inf, flag, blankone);
              'r', 'R': begin
							             load(inf, n, flag, blankone, r);
													 if r = 1
													    then begin
															        quoly_set(0, n);
																			exit {(parse)}
																	 end
												end;
							't': begin
							         timerflag := not timerflag;
											 if timerflag
											    then writeln(userOutput, ' Timing enabled.')
													else writeln(userOutput, ' Timing disabled.')
									 end;
//wwh							'T': quoly_set(Tickcount, n);
							'': begin
							        laurent := not laurent;
											change_laurent;
								      if laurent
										     then writeln(userOutput, ' Negative exponents enabled.')
										     else writeln(userOutput, ' Negative exponents disabled.')
								   end;
							'd': calc_disp;
							'm': begin
							        writeln(userOutput, ' Enter command interrupt level:');
											do_prompts;
											readln(userInput);  { these readlns added HERE Jan 1998 }
								      scanner(userInput, token, zilch);
											old_expre(userInput, n, zilch);
											if not n^.numb
								         then error(146, oldtoken);
							        m_interrupt := quoly_convert_to_int(n);
										  write(userOutput, ' Command interrupt now ');
								      case m_interrupt of
												 0: begin
													     command_int := false;
															 writeln(userOutput, 'off.')
													  end;
												 1: begin
													     command_int := true;
															 writeln(userOutput, 'on.')
														end;
												 else error(146, oldtoken)
											end
									 end;
							'a': begin
							         addresser := 1 - addresser;
											 if flag = nil
											    then writeln(userOutput, ' Array initial index now ', addresser:1, '.');
											 quoly_set(addresser, n)
									 end;
							'c': if complex
							        then writeln(userOutput, '** Sorry, must use imperative form to leave complex mode.')
											else change_complex;
							'>': if flag <> nil
							        then leave_flag := true
											else writeln(userOutput, ' Warning. &> ignored.');
							'}': if flag <> nil
							        then exit_flag := true
											else writeln(userOutput, ' Warning. &} ignored.');
							']': if flag <> nil
							        then cycle_flag := true
											else writeln(userOutput, ' Warning. &] ignored.');
							'e': begin
							        errorpush := not errorpush;
											if errorpush
											   then writeln(userOutput, ' Will push new level after errors.')
												 else writeln(userOutput, ' Pushing after errors is deactivated.')
									 end;
							'U': begin
											 uglyprint := not uglyprint;
											 if uglyprint
													then continuation := '\'
													else continuation := '';
											 if uglyprint
													then writeln(userOutput, ' Will do ugly printing.')
													else writeln(userOutput, ' Will resume lovely Fermat style.')
									 end;
							'E': begin
							        extra_line := not extra_line;
											if extra_line
											   then writeln(userOutput, ' Will do extra line after display.')
												 else writeln(userOutput, ' No extra line after display.')
									 end;
							'N': begin
							        noisy := not noisy;
											if noisy
											   then writeln(userOutput, ' Will display results.')
												 else writeln(userOutput, ' Displaying results is deactivated.')
									 end;
							'C': begin  { Jan 1998 }
							        wantcolor := not wantcolor;
											if wantcolor
											   then writeln(userOutput, ' Will display colors.')
												 else writeln(userOutput, ' Will display grays only.')
									 end;
							'H': begin  { Jan 1998 }
							        wantsolid := not wantsolid;
											if wantsolid
											   then writeln(userOutput, ' Will shade with solid colors.')
												 else writeln(userOutput, ' Will shade with patterns.')
									 end;
							'D': change_detcutoff(n);
//wwh							'h': quoly_set(2*memavail, n);
							'h' : begin
{$IFDEF MSWINDOWS}
                    heapstatus := GetHeapStatus;
                    quoly_set(2*heapstatus.TotalAddrSpace, n)
{$ELSE}
                    quoly_set(2*1048576, n) //2^20
{$ENDIF}
                  end;
							'n': set_name_length(n);
              'x': if not tt_flag
                      then done_load := true;
							'J': attach_poly(inf, flag, true);
              'g': global_dump;
							'G': garbage('g');
							'': if dupptr <> nil
							        then arrdisplay(userOutput, true, false, duparr^.name, duparr, 0, duparr^.rows,
							                       (duparr^.stop + 1) div duparr^.rows, addresser,
															        addresser, duparr^.rows, 4, false, false, true, dupptr);
							'o': error(308, token);
							'P': set_mod_out(inf, flag, false);
							'p': begin
							        writeln(userOutput, ' Enter lower boundary for color shading:'); { Jan 1998 }
											do_prompts;
								      readln(userInput);  { these readlns added HERE Jan 1998 }
								      scanner(userInput, token, zilch);
											old_expre(userInput, n, zilch);
											if not n^.numb
								         then error(253, oldtoken);
							        paint_c_1 := (1 - quoly_convert_to_ext(n))/2;
							        paint_c_2 := 1 - paint_c_1;
										  writeln(userOutput, ' Lower boundary for color shading is now ', 2*paint_c_2 - 1:8:5)
							     end;
							'': error(67, token);
							'M': begin
							        writeln(userOutput, ' Enter prompt:');
											do_prompts;
											readln(userInput);  { these readlns added HERE Jan 1998 }
											read(userInput, prompt);
											if prompt = ' '
											   then begin
												         prompt[1] := chr(13);
																 promptsize := 0;
																 writeln(userOutput, ' Prompt now: <cr>')
															end
											   else begin
												         promptsize := length(prompt);
																 if promptsize = 0
																    then begin   {@@@}
																            prompt[1] := chr(13);
																            writeln(userOutput, ' Prompt now: <cr>')
																         end
										                else writeln(userOutput, ' Prompt now:', prompt)
															end
									 end;
              '': time_to_quit := true; { reduce command level; pop }
							'': error(-1, blank);       { push new command level }
							'|': begin
							        pos_mod := not pos_mod;
											if flag = nil
											   then if pos_mod
																 then writeln(userOutput, ' Modulus must return non-negatives.')
																 else writeln(userOutput, ' Modulus can return negatives.')
									 end;
							'q': begin  { end of session }
							        writeln(userOutput); writeln(userOutput, ' bye'); flush(userOutput);
							        real_quit := true;
                      parse := -1;
							        exit {(pseudo_main)};
							     end;
							'': error(0, blank);  { panic stop }
							'(': set_switch(inf, n, flag, colflag);
							'': begin
							        writeln(userOutput, ' Enter new denominator for random:');
											do_prompts;
											readln(userInput);  { these readlns added HERE Jan 1998 }
								      scanner(userInput, token, flag);
											old_expre(userInput, n, zilch);
											if not n^.numb
								         then error(143, oldtoken);
				              rand_denom_n.float := n^.ncoef^.float;
								      writeln(userOutput, ' Denominator for random is now: ');
								      dummy := 0;
                      quoly_display(userOutput, true, true, true, n, dummy, semicolon,
								                   polynames, false, true, false)
									 end;

              else error(17, token)
            end;
            case oldtoken.name[1] of
               'h', 'n', 'p':  { nothing } ;   { Jan 1998 }
               '(', 'T', 'm':  { nothing };
               'a', '':  { nothing } ;
               else quoly_set(0, n)
            end;
						scanner(inf, token, flag)
          end;

        '@': begin
                rubout(inf, flag);
                quoly_set(0, n);
                scanner(inf, token, flag)
             end;
        '!': write_out(inf, n, flag);
				';': begin  { a comment }
				        token.name := '@';
								token.address := -1
						 end;
        '?':
          begin { input from screen }
            scanner(inf, oldtoken, flag);
            scanner(inf, token, flag);
						savett := tt_flag;  { save it }
						quoly_set(0, n);

            if oldtoken.name = '['
               then whole_arrinsert(inf, token, flag, n, stash, saveleft)
               else if token.name = '['
											 then begin
															scanner(inf, token, flag);
															evalcoords(inf, r, c, flag, ']', ',', colflag);
															scanner(inf, token, flag);
															stash := token;
															saveleft := leftover;
															lookup(oldtoken, r, c, q, qp, colflag); {spar}
															if q^.spar <> nil
															   then error(289, token);  { Dec 1997 }
															arrinsert(oldtoken, qp, r, c, q, n, colflag)
													  end
              else begin
											if (oldtoken.name[1] > 'z') or (oldtoken.name[1] < 'a')
												 then error(3, oldtoken);
											stash := token;
											saveleft := leftover;
											if levelcount > 1
				                 then write(userOutput, levelcount: 1);
			                if (promptsize > 0) or (prompt[1] = chr(13))
				                 then write(userOutput, prompt);
											write(userOutput, oldtoken.name, ' := ');  { Nov 1997 }
											leftover := '';
											tt_flag := true;
											readln(userInput);
											{ new for sioux }
											scanner(userInput, token, zilch);
											if token.name <> '@'
												 then begin
																 old_expre(userInput, n, zilch);
																 insert(oldtoken, n, s); { don't want s }
																 n := nil;
																 quoly_assign(s^.val, n)
															end
                   end;
            token := stash;
						leftover := saveleft;
						tt_flag := savett;
            if flag <> zilch
               then quoly_set(0, n)

          end;

			  'A': if (token.name = 'Adjoint') or (token.name = 'Altmult')
								or (token.name = 'Altpower')
							  then arr_parse('A', inf, n, flag)
				        else old_expre(inf, n, flag);


        else begin
                     expre(inf, qp, n, aux, colpos, flag);  { Nov 1997 }
                     if n = nil
                        then if qp = nil
                                then quoly_set(0, n)
                                else quoly_assign(qp^, n)
				          end

      end

    end;

  {***************************************************************************}

	procedure load_startup;

	   var old_tt, oldreal: boolean;
			   oldleft: shortstring;
				 n: quoly;
				 colons: bigstring;
//wwh         i : longint;

		 begin

				load_startup_now := false;

				old_tt := tt_flag;
				tt_flag := false;
				oldleft := leftover;
				oldreal := realflag;
				realflag := false;
				leftover := '';
				n := nil;
			  colons := ':';
				AssignFile(ferstartup, 'ferstartup');
				reset(ferstartup);

				{ moved this: mytime[1] := TickCount; }
				while not eof(ferstartup) do
					 begin
							scanner(ferstartup, token, zilch);
							if eof(ferstartup)
								 then begin
												 leftover := '';
												 break
											end;
							case token.name[1] of  
								 '!', ';': parse(ferstartup, n, zilch);
								 '', '[', '': arr_parse(token.name[1], ferstartup, n, zilch);
								 'A': if (token.name = 'Adjoint') or (token.name = 'Altmult')
												 or (token.name = 'Altpower')
												 then arr_parse('A', ferstartup, n, zilch)
												 else old_expre(ferstartup, n, zilch);
								 else parse(ferstartup, n, zilch) { Nov 1997 }
						  end;
							zilch := nil; {@@@ zilch may have been changed by error, via myzilch }
							free_quoly(n);  { a failsafe; leave it }
							if token.name <> ';' 
							   then if (token.name <> '') and (token.name <> '@')  {@@@}
								         then error(129, token);
							{	if noisy
							   then flush(userOutput);  BUG of Dec 1996 }
 							readln(ferstartup)
					 end;

				close(ferstartup);
				free_quoly(n);
				tt_flag := old_tt;
				realflag := oldreal;
				leftover := oldleft;

				mytime[1] := Time - mytime[1] - time_off[1];
				time_off[1] := 0;
				if timerflag
					 then begin
									 writeln(userOutput, ' Elapsed time: ', mytime[1]/60: 11:3);
									 if extra_line
										  then writeln(userOutput);
								end;

				{@@@ all this }
			  finish := nil;
			  leftover := '';
			  if prompt[1] <> chr(13)
					 then flush(userOutput);
			  if promptsize > 0  
			     then write(userOutput, prompt) 
									 
		 end;
								 
	 {*==========================================================================*}

   begin  { of pseudo_main }
  
		{ prevnum is never nil. sysnum might be at any time. sysnum should always be
		  passed by var to any procedure that uses it. ~~~~~}

    if load_startup_now
       then load_startup;  { once only }
       
    while not Eof(UserInput) do
			 begin

					 scanner(userInput, token, zilch);
					 mytime[1] := Time;
					 case token.name[1] of  {<<<<}
						  '!', ';': parse(userInput, sysnum, zilch);
						  '', '[', '': arr_parse(token.name[1], userInput, sysnum, zilch);
							'A': if (token.name = 'Adjoint') or (token.name = 'Altmult')
											or (token.name = 'Altpower')
										  then arr_parse('A', userInput, sysnum, zilch)
											else old_expre(userInput, sysnum, zilch);
						  else if parse(userInput, sysnum, zilch) <> 0 then exit { Nov 1997 }
					 end;
					 mytime[1] := Time - mytime[1] - time_off[1];
					 time_off[1] := 0;

					 if sysnum = nil
					    then quoly_set(0, sysnum); { must be done here, before prevnum below }
					 if (token.name <> ';') and (token.name <> '@')
					    then if (token.name <> '') and (token.name <> ':') {@@@}
							        then error(129, token);
					 finish := nil;
					 if token.name <> ':'
					    then begin
							        if syst_dump and noisy and (token.name <> '@')  {~~~~spar}{@@@}
												 then arrdisplay(userOutput, true, false, syst^.name, syst, 0, syst^.rows,
																				 (syst^.stop + 1) div syst^.rows, addresser, 
																				 addresser, syst^.rows, 4, false, false, true, stash);
										  if extra_line
												 then writeln(userOutput); 
										  if noisy then flush(userOutput); 
										  dummy := 0;
										  if (token.name <> '@') and noisy  {@@@}
												 then quoly_display(userOutput, true, true, true, sysnum, dummy, semicolon, 
																					  polynames, false, true, false);								
										  if (polynames = nil) and noisy and extra_line  {@@@}
												 then writeln(userOutput)
									 end
							else if extra_line 
									    then writeln(userOutput);						 
					 syst_dump := false;
					 if timerflag
							then begin 
											writeln(userOutput, ' Elapsed time: ', mytime[1]/60: 11:3);
											if extra_line
											   then writeln(userOutput)
									 end;
					 free_quoly(prevnum);
					 prevnum := sysnum;  { prevnum must never be nil or in wrong format ~~~~~}
					 sysnum := nil;
					 
					 if savescreen  { May 1997 }
					    then begin
					            RestoreScreenFromCopy;
					            savescreen := false
					         end;
					 
					 if time_to_quit 
							then begin
											time_to_quit := false;
											writeln(userOutput, ' You must use "&q" to quit the highest level.')
									 end;
					 if prompt[1] <> chr(13)
					    then flush(userOutput);
					 if promptsize > 0
					    then write(userOutput, prompt);
//wwh					 Showcursor(TRUE);
					 readln(userInput)
							
			end;
      real_quit := true 

   end;
   
 {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  procedure mem_error;
   	  
	  begin
	     writeln(userOutput);
       writeln(userOutput, '*** Warning.  You are out of heap space.  Abort this session.');
       writeln(userOutput, '***           Try to save, then quit.');  {@@@}
       writeln(userOutput);
       flush(userOutput);
       leftover := '';
       finish := nil;
			 if promptsize > 0  
			    then write(userOutput, prompt);
			 readln(userInput);
			 pseudo_main;
			 halt  { Nov 1997 }
					    
	  end;

 {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
 {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

 procedure InitializeFermat(inEvent : TEvent);
 var i : Integer;
     screenBounds : TRect;

 begin { of InitializeFermat }

    inputEvent := inEvent;

    mytime[1] := Time;  {  Nov 1996 }

    heapsize := 4194304;
    heapdelta := 2097152;
    buffsize := 8192;  { Dec 1996; turned off March 1997 }
    siouxcols := 80;
    siouxrows := 42;
    screentop := 40;
    screenleft := 20;
    screenright := 50;
    screenbottom := 120;    
    noisy := false;
    saveonclose := true;
    siouxcont := '';   { Sept 1996 }
    continset := [ '', '', '\' ];  { Sept 1996 }
    reset(siouxdata, 'siouxdata');
    
		if not eof(siouxdata)
			 then begin
			         readln(siouxdata, sizeval);  { sizeval not mnemonic }
			         if (sizeval > 250000) and (sizeval < two_to_31)
			            then heapsize := sizeval
			            else if sizeval <> 0
			                    then noisy := true;       { noisy not mnemonic }
			         readln(siouxdata, sizeval);
			         if (sizeval >= 0) and (sizeval < two_to_31)  { Oct 1997 }
			            then heapdelta := sizeval
			            else if sizeval <> 0
			                    then noisy := true;
			         readln(siouxdata, sizeval);
			         if (sizeval > 1000) and (sizeval < mediummask)  { Dec 1996 }
			            then buffsize := sizeval
			            else if sizeval <> 0
			                    then noisy := true;
			         readln(siouxdata, sizeval);
			         if (sizeval > 5) and (sizeval < 400) 
			            then siouxcols := sizeval
			            else if sizeval <> 0
			                    then noisy := true;
			         readln(siouxdata, sizeval);
			         if (sizeval > 3) and (sizeval < 300)
			            then siouxrows := sizeval
			            else if sizeval <> 0
			                    then noisy := true;
			         readln(siouxdata, sizeval);
			         if (sizeval >= 0) and (sizeval <= 1)  { Dec 1996 }
			            then saveonclose := (sizeval = 1)
			            else noisy := true;
			         readln(siouxdata, siouxcont);
			         if not (siouxcont in continset)  { Sept 1996 }
			            then begin
			                    siouxcont := '';
			                    noisy := true
			                 end;
			         read(siouxdata, sizeval);
               GetScreenBounds(screenBounds);
			         if (sizeval > 0) and (sizeval < screenBounds.bottom)  { May 1997 }
			            then begin
			                    screentop := sizeval;
			                    read(siouxdata, screenleft, screenright, screenbottom)
			                 end
			      end;
    close(siouxdata);
(*wwh
   PLHeapInit(heapsize, heapdelta, nil, true, false);      GetHeapStatus      GetMem
		PLSetHeapCheck(false);
		PLSetMErrProc(@mem_error);

		SIOUXSettings.standalone := false;
		SIOUXSettings.fontid := 22;  { courier }
		SIOUXSettings.fontsize := 12;
		SIOUXSettings.toppixel := 40;
		SIOUXSettings.leftpixel := 20;
		SIOUXSettings.columns := siouxcols;
		SIOUXSettings.rows := siouxrows;
		SIOUXSettings.showstatusline := false;
		SIOUXSettings.autocloseonquit := true;
	  SIOUXSettings.asktosaveonclose := saveonclose;
 *)
	  continuation := siouxcont;   { Sept 1996 }

		writeln(userOutput);
		writeln(userOutput, 'Fermat, fast float version 2.1. @1992, 1995, 1998, 2000 by Robert H. Lewis');
		writeln(userOutput, '                                  all rights reserved');
		writeln(userOutput);
		writeln(userOutput, 'This software contains no warranty whatsoever, expressed or implied.');
		writeln(userOutput);
		writeln(userOutput, 'This software is shareware, $30 suggested.  U.S. currency only. ');
		writeln(userOutput);
		if noisy
		   then writeln(userOutput, ' *** siouxdata contains some invalid values. Will use defaults for those.');
		        
		writeln(userOutput, ' initializing...');
		flush(userOutput);
		
    InitGraf; {wwh( @ qd.thePort)};
    
		Initialize;

		levelcount := 1;
		time_to_quit := false;
		real_quit := false;        { May 1997 }
		startexpr := nil;
		prev_expr := nil;
		currentchar := nil;
		zilch := nil;
		matrix_eval := 0; { This is a stack of booleans implemented with an integer. }
		errorpush := false;
		noisy := true;
		nilpol := nil;
		pseudo_polynames := nil;		
		laurent := false;
		limit_char_arrays := 18; 
		uglyprint := false;
		continuation := '';
		
		input_file_name := '';
		output_file_name := '';
		blank.name := ' ';
		semicolon.name := ';';
		zero.name := '0';
		multsign.name := '*';
		quotsign.name := '/';
		minussign.name := '-';
		plussign.name := '+';
		comma.name := ',';
		esign.name := 'e';
		concatsign.name := '';
		empty.name := '';   
		logsign.name := '_';
		sqrtsign.name := '';
		expsign.name := '^';
		arctansign.name := '';
		factsign.name := '!';
		quotesign.name := '''';
		bulletsign.name := '';
		arr_arrsign.name := '';
		sys_func_tok.name := chr(21);
		diag_sign.name := '';
		sys_func := nil;
		doing_sys_func := false;
		
		timerflag := false;
		dispcutoff := 64;

		endarr := -1;
		first_available := 1;
		addresser := 1;
		detcutoff := -1;
    massnum := 8;
    tripval := 3;
		disp_size := 16;  {May 1997}
		want_sparse := false;
		
		prompt := '>';
		promptsize := 1;
		colgarb := nil;
		blankone := ' ';
		
		xscale := 1;
		yscale := 1;
		zscale := 1;
		xorigin := 0;
		yorigin := 0;
		plotting := false;
		cplotting := false;
		surplotting := false;
		savescreen := false;  { May 1997 }
		initial := nil;
		final := nil;
		increm := nil;
		plotnum := nil;
		cplotnum := nil;
		threedim := false;
		marking := false;
		penpatt := 4;  { black }
		lastspot := 0;

(*wwh moved to GraphicsRoutines:
		Initfonts;
		TextSize(9);
		TextFont(22);
		TextMode(0);
//wwh		Initwindows;

    rawptr := NewPtr(SIZEOF(GrafPort));
		newport := GrafPtr(rawptr);
		OpenPort(newport);

		with my_rect do
		   begin
			    top := qd.ScreenBits.bounds.top + screentop;
				  left := qd.ScreenBits.bounds.left + screenleft;
				  right := qd.ScreenBits.bounds.right - screenright;
					bottom := qd.ScreenBits.bounds.bottom - screenbottom
		   end;

		copyrect := my_rect;

//wwh		windw := @ wrecord;
//wwh		mywindow := NewCWindow(windw, my_rect, 'Fermat Graph', true, 8, POINTER(-1),
//wwh		                      true, 0);

		with my_rect do
		   begin
			    top := qd.ScreenBits.bounds.top;
				  left := qd.ScreenBits.bounds.left;
				  right := qd.ScreenBits.bounds.right;
					bottom := qd.ScreenBits.bounds.bottom
		   end;

		SetPort(mywindow);
		mywindow^.txSize := 9;

		with piccopy do
		   begin
		      i := my_rect.bottom;  { beware overflow using integer fields of rects! }
		      i := i * my_rect.right div 8;
		      baseAddr := newptr(i);
		      rowBytes := my_rect.right div 8;
		      bounds := my_rect
		   end;

		{ initialize to all white }
	ClearGraphics;

		OSerror := SysEnvirons(1, theWorld);   { Jan 1998 }
		if not theWorld.hasColorQD
		   then begin
		          writeln(userOutput, '*** Warning!  No color available on this system!');
							writeln(userOutput, '*** Use &C to turn off coloring.')
	          end;
		GetIndPattern(patts[3, 1], 0, 20);
		GetIndPattern(patts[3, 2], 0, 22);
		GetIndPattern(patts[3, 3], 0, 23);
		GetIndPattern(patts[3, 5], 0, 4);
		GetIndPattern(patts[3, 6], 0, 3);
		GetIndPattern(patts[3, 7], 0, 2);
		GetIndPattern(patts[3, 8], 0, 1);
		StuffHex(@ patts[3, 4], 'AA11AA558855AA44');

		patts[2, 1] := patts[3, 1];
		patts[2, 2] := patts[3, 2];
		patts[2, 3] := patts[3, 2];
		patts[2, 4] := patts[3, 3];
		patts[2, 5] := patts[3, 3];
		patts[2, 6] := patts[3, 5];
		patts[2, 7] := patts[3, 5];
		patts[2, 8] := patts[3, 7];

		patts[1, 1] := patts[3, 1];
		patts[1, 2] := patts[3, 1];
		patts[1, 3] := patts[3, 2];
		patts[1, 4] := patts[3, 2];
		patts[1, 5] := patts[3, 3];
		patts[1, 6] := patts[3, 3];
		patts[1, 7] := patts[3, 3];
		patts[1, 8] := patts[3, 5];

		for i := 1 to 8 do
			 patts[0, i] := patts[3, 1];

		thepatt := patts[3];
*)
		costheta := sqrt(2)/2;
	  sintheta := 1/sqrt(6);
		z_cosine := sqrt(2)/sqrt(3);
		printchar := false;
		for i := 1 to 7 do
		   shadefactor[i] := cos(i*3.14159/8);
		shadefactor[8] := -1.01;
		thelight[1] := -0.5/sqrt(26.25);
		thelight[2] := 1/sqrt(26.25);
		thelight[3] := 5/sqrt(26.25);

		base_3_list[0] := 0;   base_3_list[1] := 4;
		base_3_list[2] := 1;   base_3_list[3] := 3;
		base_3_list[4] := 8;   base_3_list[5] := 5;
		base_3_list[6] := 2;

		need_to_set_char_poly := true;
		leftover := '';
		finish := nil;

		plottingerror := false;

	{9988: @@@}

		need_message := true;

    load_startup_now := true; {@@@ true only once. }

		{ No error can occur before calling pseudo_main. @@@}

	end;

procedure RunFermat;
begin
		while true do
			 begin

					if not load_startup_now
					   then begin
					           need_message := true;
					           leftover := '';
										 finish := nil;
										 if promptsize > 0
										    then write(userOutput, prompt);
										 readln(userInput)
									end;

          if savescreen  { May 1997 }
					   then begin
					           RestoreScreenFromCopy;
					           savescreen := false
					        end;
					try
  					pseudo_main;
          except
            on Exception do ;
          end;

          if real_quit
             then break;

          if plottingerror
             then begin
                    { This block of code is executed when an error occurs in plotting. }
							      plottingerror := false;
							      if need_message
										   then begin
											         writeln(userOutput);
										           writeln(userOutput, ' Warning. At least one error occurred during Funcplot.');
															 flush(userOutput);
															 need_message := false  { changed Oct 1993 }
														end;
						        duplicate(hplot, arrplot, hpcopy, arrpcopy, vcop, vcop2);
										simple_quoly_add(vplot^.val, increm, vcop2^.val);
						        vplot := vcop2;

										{ erase environment stack & reinitialize. }
										manage(false, false, 1);
										tt_flag := true;
						        func_def_count := 0;
										first_available := 1;

										{ continue plotting. }
										attach_symbols(hpcopy, arrpcopy);
										lastf := lastf^.next;
										lastf^.f := pplot;
										statcount := statcount + 1;

										simple_plotfunc;  {@@@  no good!!  }
										simple_epilog(pplot);
										cancel_dups(hplot, arrplot);
										quoly_set(0, sysnum)

                  end

			end;
      if output_file_name <> '' then
        close(outpuf)
end;

end.
